package org.jeecg.modules.demo.sync;

import cn.hutool.core.date.DateTime;
import com.alibaba.druid.support.json.JSONParser;
import com.baomidou.mybatisplus.extension.toolkit.SqlHelper;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.quartz.Job;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.Map;

@Slf4j
public abstract class BaseSync implements Job {


    /**
     * 若参数变量名修改 QuartzJobController中也需对应修改
     */
    private String parameter;

    public void setParameter(String parameter) {
        this.parameter = parameter;
    }

    private Map<String,Object> paramMap;

    public Map<String,Object> getParamMap(){
        return paramMap;
    }

    public

    long startTime = 0;

    public long start(){
        log.info("-------------------------------------------开始辣----------------------------------------------------");
        startTime = System.currentTimeMillis();
        initParam();
        return startTime;
    }

    public void end(){
        log.info("-------------------------------------------结束辣----------------------------------------------------");
        long end = System.currentTimeMillis();
        log.info(String.valueOf(end));
        log.info("耗时：【"+(end - startTime)/1000 + "】秒【"+(end - startTime) + "】毫秒");
    }

    public void initParam() {
        if(this.parameter != null && StringUtils.isNotBlank(this.parameter)){
            JSONParser parser = new JSONParser(this.parameter);
            paramMap = parser.parseMap();
        }
    }

    public abstract void run(Map<String, Object> param) throws Exception;

    public abstract void run();



}
