package org.jeecg.modules.demo.sync;

import cn.hutool.core.bean.BeanUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.compress.utils.Lists;
import org.jeecg.common.util.text.StringUtils;
import org.jeecg.modules.demo.xxhbjwxtjxrw.entity.JwxtJxrw;
import org.jeecg.modules.demo.xxhbjwxtjxrw.entity.Xxhbjwxtjxrw;
import org.jeecg.modules.demo.xxhbjwxtjxrw.service.IXxhbjwxtjxrwService;
import org.jeecg.modules.demo.xxhbjwxtjxrw.service.JwxtJxrwService;
import org.jeecg.modules.demo.xxhbjwxtscwjxx.entity.JwxtScwjxx;
import org.jeecg.modules.demo.xxhbjwxtscwjxx.entity.Xxhbjwxtscwjxx;
import org.jeecg.modules.demo.xxhbjwxtscwjxx.service.IXxhbjwxtscwjxxService;
import org.jeecg.modules.demo.xxhbjwxtscwjxx.service.JwxtscwjxxService;
import org.jeecg.modules.demo.xxhbjwxtxsmd.service.IXxhbjwxtxsmdService;
import org.jeecg.modules.demo.xxhbjwxtxsmd.service.JwxtXsmdService;
import org.quartz.JobExecutionContext;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.List;
import java.util.Map;

@Slf4j
public class SyncJwxtNew extends BaseSync {

    @Autowired
    private JwxtJxrwService expJxrwService;

    @Autowired
    private IXxhbjwxtjxrwService impJxrwService;


    @Autowired
    private JwxtscwjxxService expScwjxxService;

    @Autowired
    private IXxhbjwxtscwjxxService impScwjxxService;

    @Autowired
    private JwxtXsmdService expXsmdService;

    @Autowired
    private IXxhbjwxtxsmdService impXsmdService;

    /**
     * 若参数变量名修改 QuartzJobController中也需对应修改
     */

    @Override
    public void execute(JobExecutionContext jobExecutionContext)  {
        start();
        run(getParamMap());
        end();
    }


    /**
     * 有参定时任务实现
     * @param param
     */
    public void run(Map<String, Object> param){

        String xnxqdm = (String) param.get("xnxqdm");
        String startTime = (String) param.get("startTime");
        String endTime = (String) param.get("endTime");
        if(StringUtils.isEmpty(xnxqdm)){
            xnxqdm = "202401";
        }
        if(StringUtils.isEmpty(startTime)){
            startTime = "2024-08-01 00:00:00";
        }
        if(StringUtils.isEmpty(endTime)){
            endTime = "2025-02-01 00:00:00";
        }
        //查询数据
        QueryWrapper<JwxtJxrw> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("xnxqdm",xnxqdm);
        List<JwxtJxrw> inDataList = expJxrwService.list(queryWrapper);
        List<Xxhbjwxtjxrw> outDataList = Lists.newArrayList();

        System.out.println("---------------------------------------------------------------------------");
        System.out.println("--------------查询第1个"+inDataList.size()+"--------------------");
        System.out.println("---------------------------------------------------------------------------");

        //查询数据
        List<JwxtScwjxx> in1DataList = expScwjxxService.list();
        List<Xxhbjwxtscwjxx> out1DataList = Lists.newArrayList();

        System.out.println("---------------------------------------------------------------------------");
        System.out.println("--------------查询第2个"+in1DataList.size()+"--------------------");
        System.out.println("---------------------------------------------------------------------------");

        //清洗数据
        inDataList.forEach(x -> outDataList.add(BeanUtil.toBean(x, Xxhbjwxtjxrw.class)));
        in1DataList.forEach(x -> out1DataList.add(BeanUtil.toBean(x, Xxhbjwxtscwjxx.class)));

        //删除数据
        QueryWrapper dqw = new QueryWrapper();
        queryWrapper.eq("xnxqdm",xnxqdm);
        impJxrwService.remove(dqw);
        QueryWrapper dqw1 = new QueryWrapper();
        dqw1.ge("cjsj",startTime);
        dqw1.le("cjsj",endTime);
        impScwjxxService.remove(dqw1);
        //保存到胃
        try {
            System.out.println("---------------------------------------------------------------------------");
            System.out.println("--------------插入第一个"+outDataList.size()+"--------------------");
            System.out.println("---------------------------------------------------------------------------");
            impJxrwService.syncList(outDataList);

            System.out.println("---------------------------------------------------------------------------");
            System.out.println("--------------插入第二个"+out1DataList.size()+"--------------------");
            System.out.println("---------------------------------------------------------------------------");
            impScwjxxService.syncList(out1DataList);

        }catch (Exception e){
            e.printStackTrace();
        }

    }

    /**
     * 无参定时任务实现
     */
    public void run(){
        run(null);
    }

}
