package org.jeecg.modules.demo.sync;

import cn.hutool.core.bean.BeanUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.compress.utils.Lists;
import org.jeecg.modules.demo.xxhbjwxtjxrw.entity.JwxtJxrw;
import org.jeecg.modules.demo.xxhbjwxtjxrw.entity.Xxhbjwxtjxrw;
import org.jeecg.modules.demo.xxhbjwxtjxrw.service.IXxhbjwxtjxrwService;
import org.jeecg.modules.demo.xxhbjwxtjxrw.service.JwxtJxrwService;
import org.jeecg.modules.demo.xxhbjwxtscwjxx.entity.JwxtScwjxx;
import org.jeecg.modules.demo.xxhbjwxtscwjxx.entity.Xxhbjwxtscwjxx;
import org.jeecg.modules.demo.xxhbjwxtscwjxx.service.IXxhbjwxtscwjxxService;
import org.jeecg.modules.demo.xxhbjwxtscwjxx.service.JwxtscwjxxService;
import org.jeecg.modules.demo.xxhbjwxtxsmd.entity.JwxtXsmd;
import org.jeecg.modules.demo.xxhbjwxtxsmd.entity.Xxhbjwxtxsmd;
import org.jeecg.modules.demo.xxhbjwxtxsmd.service.IXxhbjwxtxsmdService;
import org.jeecg.modules.demo.xxhbjwxtxsmd.service.JwxtXsmdService;
import org.quartz.JobExecutionContext;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.List;
import java.util.Map;

@Slf4j
public class SyncJwxtXsmd extends BaseSync {

    @Autowired
    private JwxtJxrwService expJxrwService;

    @Autowired
    private IXxhbjwxtjxrwService impJxrwService;


    @Autowired
    private JwxtscwjxxService expScwjxxService;

    @Autowired
    private IXxhbjwxtscwjxxService impScwjxxService;

    @Autowired
    private JwxtXsmdService expXsmdService;

    @Autowired
    private IXxhbjwxtxsmdService impXsmdService;

    /**
     * 若参数变量名修改 QuartzJobController中也需对应修改
     */

    @Override
    public void execute(JobExecutionContext jobExecutionContext)  {
        start();
        run(getParamMap());
        end();
    }


    /**
     * 有参定时任务实现
     * @param param
     */
    public void run(Map<String, Object> param){
//        LIMIT 10 OFFSET 10
        int pageSize = 100000;
        QueryWrapper dqw2 = new QueryWrapper();
        impXsmdService.remove(dqw2);
        for(int i=0;i<30;i++){
            //查询数据
            QueryWrapper sqw = new QueryWrapper();
            sqw.eq("xsztmc","在校生");
            sqw.last("LIMIT "+pageSize+" OFFSET "+(i*pageSize));
            int startNum = i*pageSize;
            int endNum = (i+1)*pageSize;
            System.out.println("---------------------------------------------------------------------------");
            System.out.println("--------------第"+i+"次查询--"+startNum+"---"+endNum+"---------------");
            System.out.println("---------------------------------------------------------------------------");
            List<JwxtXsmd> in2DataList = expXsmdService.listFy(startNum,endNum);
            if(in2DataList.size()==0){//没有数据量就停止循环
                break;
            }
            List<Xxhbjwxtxsmd> out2DataList = Lists.newArrayList();
            //清洗数据
            in2DataList.forEach(x -> out2DataList.add(BeanUtil.toBean(x, Xxhbjwxtxsmd.class)));
            //保存到胃
            try {
                System.out.println("---------------------------------------------------------------------------");
                System.out.println("--------------第"+i+"次查询，目前到"+(i*pageSize)+"这个数据--------------------");
                System.out.println("---------------------------------------------------------------------------");
                impXsmdService.syncList(out2DataList);
            }catch (Exception e){
                e.printStackTrace();
            }
        }



    }

    /**
     * 无参定时任务实现
     */
    public void run(){
        run(null);
    }

}
