package org.jeecg.modules.demo.xxhbjwxtscwjxx.controller;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.demo.xxhbjwxtscwjxx.entity.Xxhbjwxtscwjxx;
import org.jeecg.modules.demo.xxhbjwxtscwjxx.service.IXxhbjwxtscwjxxService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

 /**
 * @Description: 教务系统上传文件信息
 * @Author: jeecg-boot
 * @Date:   2024-09-02
 * @Version: V1.0
 */
@Api(tags="教务系统上传文件信息")
@RestController
@RequestMapping("/xxhbjwxtscwjxx/xxhbjwxtscwjxx")
@Slf4j
public class XxhbjwxtscwjxxController extends JeecgController<Xxhbjwxtscwjxx, IXxhbjwxtscwjxxService> {
	@Autowired
	private IXxhbjwxtscwjxxService xxhbjwxtscwjxxService;
	
	/**
	 * 分页列表查询
	 *
	 * @param xxhbjwxtscwjxx
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "教务系统上传文件信息-分页列表查询")
	@ApiOperation(value="教务系统上传文件信息-分页列表查询", notes="教务系统上传文件信息-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<Xxhbjwxtscwjxx>> queryPageList(Xxhbjwxtscwjxx xxhbjwxtscwjxx,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<Xxhbjwxtscwjxx> queryWrapper = QueryGenerator.initQueryWrapper(xxhbjwxtscwjxx, req.getParameterMap());
		Page<Xxhbjwxtscwjxx> page = new Page<Xxhbjwxtscwjxx>(pageNo, pageSize);
		IPage<Xxhbjwxtscwjxx> pageList = xxhbjwxtscwjxxService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param xxhbjwxtscwjxx
	 * @return
	 */
	@AutoLog(value = "教务系统上传文件信息-添加")
	@ApiOperation(value="教务系统上传文件信息-添加", notes="教务系统上传文件信息-添加")
	@RequiresPermissions("xxhbjwxtscwjxx:xxhbjwxtscwjxx:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody Xxhbjwxtscwjxx xxhbjwxtscwjxx) {
		xxhbjwxtscwjxxService.save(xxhbjwxtscwjxx);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param xxhbjwxtscwjxx
	 * @return
	 */
	@AutoLog(value = "教务系统上传文件信息-编辑")
	@ApiOperation(value="教务系统上传文件信息-编辑", notes="教务系统上传文件信息-编辑")
	@RequiresPermissions("xxhbjwxtscwjxx:xxhbjwxtscwjxx:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody Xxhbjwxtscwjxx xxhbjwxtscwjxx) {
		xxhbjwxtscwjxxService.updateById(xxhbjwxtscwjxx);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "教务系统上传文件信息-通过id删除")
	@ApiOperation(value="教务系统上传文件信息-通过id删除", notes="教务系统上传文件信息-通过id删除")
	@RequiresPermissions("xxhbjwxtscwjxx:xxhbjwxtscwjxx:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		xxhbjwxtscwjxxService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "教务系统上传文件信息-批量删除")
	@ApiOperation(value="教务系统上传文件信息-批量删除", notes="教务系统上传文件信息-批量删除")
	@RequiresPermissions("xxhbjwxtscwjxx:xxhbjwxtscwjxx:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.xxhbjwxtscwjxxService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "教务系统上传文件信息-通过id查询")
	@ApiOperation(value="教务系统上传文件信息-通过id查询", notes="教务系统上传文件信息-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<Xxhbjwxtscwjxx> queryById(@RequestParam(name="id",required=true) String id) {
		Xxhbjwxtscwjxx xxhbjwxtscwjxx = xxhbjwxtscwjxxService.getById(id);
		if(xxhbjwxtscwjxx==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(xxhbjwxtscwjxx);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param xxhbjwxtscwjxx
    */
    @RequiresPermissions("xxhbjwxtscwjxx:xxhbjwxtscwjxx:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, Xxhbjwxtscwjxx xxhbjwxtscwjxx) {
        return super.exportXls(request, xxhbjwxtscwjxx, Xxhbjwxtscwjxx.class, "教务系统上传文件信息");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("xxhbjwxtscwjxx:xxhbjwxtscwjxx:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, Xxhbjwxtscwjxx.class);
    }

}
