package org.jeecg.modules.demo.xxhbjwxtxsmd.controller;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.demo.xxhbjwxtxsmd.entity.Xxhbjwxtxsmd;
import org.jeecg.modules.demo.xxhbjwxtxsmd.service.IXxhbjwxtxsmdService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

 /**
 * @Description: 教务系统学生名单
 * @Author: jeecg-boot
 * @Date:   2024-09-02
 * @Version: V1.0
 */
@Api(tags="教务系统学生名单")
@RestController
@RequestMapping("/xxhbjwxtxsmd/xxhbjwxtxsmd")
@Slf4j
public class XxhbjwxtxsmdController extends JeecgController<Xxhbjwxtxsmd, IXxhbjwxtxsmdService> {
	@Autowired
	private IXxhbjwxtxsmdService xxhbjwxtxsmdService;
	
	/**
	 * 分页列表查询
	 *
	 * @param xxhbjwxtxsmd
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "教务系统学生名单-分页列表查询")
	@ApiOperation(value="教务系统学生名单-分页列表查询", notes="教务系统学生名单-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<Xxhbjwxtxsmd>> queryPageList(Xxhbjwxtxsmd xxhbjwxtxsmd,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<Xxhbjwxtxsmd> queryWrapper = QueryGenerator.initQueryWrapper(xxhbjwxtxsmd, req.getParameterMap());
		Page<Xxhbjwxtxsmd> page = new Page<Xxhbjwxtxsmd>(pageNo, pageSize);
		IPage<Xxhbjwxtxsmd> pageList = xxhbjwxtxsmdService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param xxhbjwxtxsmd
	 * @return
	 */
	@AutoLog(value = "教务系统学生名单-添加")
	@ApiOperation(value="教务系统学生名单-添加", notes="教务系统学生名单-添加")
	@RequiresPermissions("xxhbjwxtxsmd:xxhbjwxtxsmd:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody Xxhbjwxtxsmd xxhbjwxtxsmd) {
		xxhbjwxtxsmdService.save(xxhbjwxtxsmd);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param xxhbjwxtxsmd
	 * @return
	 */
	@AutoLog(value = "教务系统学生名单-编辑")
	@ApiOperation(value="教务系统学生名单-编辑", notes="教务系统学生名单-编辑")
	@RequiresPermissions("xxhbjwxtxsmd:xxhbjwxtxsmd:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody Xxhbjwxtxsmd xxhbjwxtxsmd) {
		xxhbjwxtxsmdService.updateById(xxhbjwxtxsmd);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "教务系统学生名单-通过id删除")
	@ApiOperation(value="教务系统学生名单-通过id删除", notes="教务系统学生名单-通过id删除")
	@RequiresPermissions("xxhbjwxtxsmd:xxhbjwxtxsmd:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		xxhbjwxtxsmdService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "教务系统学生名单-批量删除")
	@ApiOperation(value="教务系统学生名单-批量删除", notes="教务系统学生名单-批量删除")
	@RequiresPermissions("xxhbjwxtxsmd:xxhbjwxtxsmd:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.xxhbjwxtxsmdService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "教务系统学生名单-通过id查询")
	@ApiOperation(value="教务系统学生名单-通过id查询", notes="教务系统学生名单-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<Xxhbjwxtxsmd> queryById(@RequestParam(name="id",required=true) String id) {
		Xxhbjwxtxsmd xxhbjwxtxsmd = xxhbjwxtxsmdService.getById(id);
		if(xxhbjwxtxsmd==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(xxhbjwxtxsmd);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param xxhbjwxtxsmd
    */
    @RequiresPermissions("xxhbjwxtxsmd:xxhbjwxtxsmd:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, Xxhbjwxtxsmd xxhbjwxtxsmd) {
        return super.exportXls(request, xxhbjwxtxsmd, Xxhbjwxtxsmd.class, "教务系统学生名单");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("xxhbjwxtxsmd:xxhbjwxtxsmd:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, Xxhbjwxtxsmd.class);
    }

}
