package org.jeecg.modules.httpinterface.controller;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.jeecg.common.system.base.controller.JeecgController;
import org.jeecg.modules.kc.grab.exports.entity.TBks;
import org.jeecg.modules.kc.grab.exports.service.ITBksService;
import org.jeecg.modules.tools.office.pdf.PDFUtil;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * @Description: 对外部访问接口
 * @Author: jeecg-boot
 * @Date:   2023-04-10
 * @Version: V1.0
 */
@Slf4j
@Api(tags="对外部访问接口")
@RestController
@RequestMapping("/temp")
public class testController extends JeecgController<TBks, ITBksService> {

    @AutoLog(value = "对外部访问接口-通过IDS访问奥威亚接口")
    @ApiOperation(value="T_BKS-抓取-通过id查询", notes="T_BKS-抓取-通过id查询")
    @GetMapping(value = "/testPDF")
    public Result<?> runAvyApiByIds(String ids,String type){
        PDFUtil.office2PDF("D:\\opt\\upFiles\\temp\\A学校教师教学体验调研报告2023年1_1720062188727.doc","D:\\opt\\upFiles\\temp\\111b.pdf");
        return Result.OK();
    }

}
