package org.jeecg.modules.kc.KcBdgxbcopy.controller;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.kc.KcBdgxbcopy.entity.KcBdgxbcopy;
import org.jeecg.modules.kc.KcBdgxbcopy.service.IKcBdgxbcopyService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

 /**
 * @Description: 公众号推送openid
 * @Author: jeecg-boot
 * @Date:   2023-05-17
 * @Version: V1.0
 */
@Api(tags="公众号推送openid")
@RestController
@RequestMapping("/KcBdgxbcopy/kcBdgxbcopy")
@Slf4j
public class KcBdgxbcopyController extends JeecgController<KcBdgxbcopy, IKcBdgxbcopyService> {
	@Autowired
	private IKcBdgxbcopyService kcBdgxbcopyService;
	
	/**
	 * 分页列表查询
	 *
	 * @param kcBdgxbcopy
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "公众号推送openid-分页列表查询")
	@ApiOperation(value="公众号推送openid-分页列表查询", notes="公众号推送openid-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<KcBdgxbcopy>> queryPageList(KcBdgxbcopy kcBdgxbcopy,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<KcBdgxbcopy> queryWrapper = QueryGenerator.initQueryWrapper(kcBdgxbcopy, req.getParameterMap());
		Page<KcBdgxbcopy> page = new Page<KcBdgxbcopy>(pageNo, pageSize);
		IPage<KcBdgxbcopy> pageList = kcBdgxbcopyService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param kcBdgxbcopy
	 * @return
	 */
	@AutoLog(value = "公众号推送openid-添加")
	@ApiOperation(value="公众号推送openid-添加", notes="公众号推送openid-添加")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody KcBdgxbcopy kcBdgxbcopy) {
		kcBdgxbcopyService.save(kcBdgxbcopy);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param kcBdgxbcopy
	 * @return
	 */
	@AutoLog(value = "公众号推送openid-编辑")
	@ApiOperation(value="公众号推送openid-编辑", notes="公众号推送openid-编辑")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody KcBdgxbcopy kcBdgxbcopy) {
		kcBdgxbcopyService.updateById(kcBdgxbcopy);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "公众号推送openid-通过id删除")
	@ApiOperation(value="公众号推送openid-通过id删除", notes="公众号推送openid-通过id删除")
	@RequiresPermissions("KcBdgxbcopy:kc_bdgxbcopy:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		kcBdgxbcopyService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "公众号推送openid-批量删除")
	@ApiOperation(value="公众号推送openid-批量删除", notes="公众号推送openid-批量删除")
	@RequiresPermissions("KcBdgxbcopy:kc_bdgxbcopy:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.kcBdgxbcopyService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "公众号推送openid-通过id查询")
	@ApiOperation(value="公众号推送openid-通过id查询", notes="公众号推送openid-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<KcBdgxbcopy> queryById(@RequestParam(name="id",required=true) String id) {
		KcBdgxbcopy kcBdgxbcopy = kcBdgxbcopyService.getById(id);
		if(kcBdgxbcopy==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(kcBdgxbcopy);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param kcBdgxbcopy
    */
    @RequiresPermissions("KcBdgxbcopy:kc_bdgxbcopy:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, KcBdgxbcopy kcBdgxbcopy) {
        return super.exportXls(request, kcBdgxbcopy, KcBdgxbcopy.class, "公众号推送openid");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("KcBdgxbcopy:kc_bdgxbcopy:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, KcBdgxbcopy.class);
    }


	 @ApiOperation(value="根据姓名获取openid", notes="根据姓名获取openid")
	 @GetMapping(value = "/getOpenIdByName")
	 public Result<KcBdgxbcopy> getOpenIdByName(@RequestParam(name="name",required=true) String name) {
		 KcBdgxbcopy kcBdgxbcopy = kcBdgxbcopyService.getOpenIdByName(name);
//		 KcBdgxbcopy kcBdgxbcopy = new KcBdgxbcopy();
//		 kcBdgxbcopy.setOpenid("oak6lwKGlGQQwt83nuynZnP4HUR4");
		 if(kcBdgxbcopy==null) {
			 return Result.error("未找到对应数据");
		 }
		 return Result.OK(kcBdgxbcopy);
	 }

}
