package org.jeecg.modules.kc.blTeacherMain.entity;

import java.io.Serializable;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.TableLogic;
import lombok.Data;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;
import org.jeecgframework.poi.excel.annotation.Excel;
import java.util.Date;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.UnsupportedEncodingException;

/**
 * @Description: 问卷信息
 * @Author: jeecg-boot
 * @Date:   2024-06-07
 * @Version: V1.0
 */
@ApiModel(value="bl_teacher_tjfx对象", description="问卷信息")
@Data
@TableName("bl_teacher_tjfx")
public class BlTeacherTjfx implements Serializable {
    private static final long serialVersionUID = 1L;

	/**id*/
	@TableId(type = IdType.ASSIGN_ID)
    @ApiModelProperty(value = "id")
    private String id;
	/**createBy*/
    @ApiModelProperty(value = "createBy")
    private String createBy;
	/**createTime*/
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd")
    @DateTimeFormat(pattern="yyyy-MM-dd")
    @ApiModelProperty(value = "createTime")
    private Date createTime;
	/**updateBy*/
    @ApiModelProperty(value = "updateBy")
    private String updateBy;
	/**updateTime*/
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd")
    @DateTimeFormat(pattern="yyyy-MM-dd")
    @ApiModelProperty(value = "updateTime")
    private Date updateTime;
	/**mainId*/
    @ApiModelProperty(value = "mainId")
    private String mainId;
	/**年份*/
	@Excel(name = "年份", width = 15)
    @ApiModelProperty(value = "年份")
    private String year;
	/**性别*/
	@Excel(name = "性别", width = 15)
    @ApiModelProperty(value = "性别")
    private String sex;
	/**学历*/
	@Excel(name = "学历", width = 15)
    @ApiModelProperty(value = "学历")
    private String educationLevel;
	/**职称*/
	@Excel(name = "职称", width = 15)
    @ApiModelProperty(value = "职称")
    private String position;
	/**学院*/
	@Excel(name = "学院", width = 15)
    @ApiModelProperty(value = "学院")
    private String department;
	/**岗位类型*/
	@Excel(name = "岗位类型", width = 15)
    @ApiModelProperty(value = "岗位类型")
    private String positiontype;
	/**请评价您周围同事在以下方面的表现（依法依规，履行教师职责）1*/
	@Excel(name = "请评价您周围同事在以下方面的表现（依法依规，履行教师职责）1", width = 15)
    @ApiModelProperty(value = "请评价您周围同事在以下方面的表现（依法依规，履行教师职责）1")
    private String sdsfYfyg;
	/**请评价您周围同事在以下方面的表现（依法依规，履行教师职责）2*/
	@Excel(name = "请评价您周围同事在以下方面的表现（依法依规，履行教师职责）2", width = 15)
    @ApiModelProperty(value = "请评价您周围同事在以下方面的表现（依法依规，履行教师职责）2")
    private String sdsfYfyg2;
	/**请评价您周围同事在以下方面的表现（关心爱护学生）1*/
	@Excel(name = "请评价您周围同事在以下方面的表现（关心爱护学生）1", width = 15)
    @ApiModelProperty(value = "请评价您周围同事在以下方面的表现（关心爱护学生）1")
    private String sdsfGxah;
	/**请评价您周围同事在以下方面的表现（关心爱护学生）2*/
	@Excel(name = "请评价您周围同事在以下方面的表现（关心爱护学生）2", width = 15)
    @ApiModelProperty(value = "请评价您周围同事在以下方面的表现（关心爱护学生）2")
    private String sdsfGxah2;
	/**请评价您周围同事在以下方面的表现（精神面貌及品德修养良好）1*/
	@Excel(name = "请评价您周围同事在以下方面的表现（精神面貌及品德修养良好）1", width = 15)
    @ApiModelProperty(value = "请评价您周围同事在以下方面的表现（精神面貌及品德修养良好）1")
    private String sdsfJsmm;
	/**请评价您周围同事在以下方面的表现（精神面貌及品德修养良好）2*/
	@Excel(name = "请评价您周围同事在以下方面的表现（精神面貌及品德修养良好）2", width = 15)
    @ApiModelProperty(value = "请评价您周围同事在以下方面的表现（精神面貌及品德修养良好）2")
    private String sdsfJsmm2;
	/**请评价您周围同事的以下行为（热爱工作，能以最大的热情投身教育行业，积极主动学习）1*/
	@Excel(name = "请评价您周围同事的以下行为（热爱工作，能以最大的热情投身教育行业，积极主动学习）1", width = 15)
    @ApiModelProperty(value = "请评价您周围同事的以下行为（热爱工作，能以最大的热情投身教育行业，积极主动学习）1")
    private String behaviorPassion;
	/**请评价您周围同事的以下行为（热爱工作，能以最大的热情投身教育行业，积极主动学习）2*/
	@Excel(name = "请评价您周围同事的以下行为（热爱工作，能以最大的热情投身教育行业，积极主动学习）2", width = 15)
    @ApiModelProperty(value = "请评价您周围同事的以下行为（热爱工作，能以最大的热情投身教育行业，积极主动学习）2")
    private String behaviorPassion2;
	/**请评价您周围同事的以下行为（关爱学生，积极帮助学生解决生活或学习上的困难）1*/
	@Excel(name = "请评价您周围同事的以下行为（关爱学生，积极帮助学生解决生活或学习上的困难）1", width = 15)
    @ApiModelProperty(value = "请评价您周围同事的以下行为（关爱学生，积极帮助学生解决生活或学习上的困难）1")
    private String behaviorSolve;
	/**请评价您周围同事的以下行为（关爱学生，积极帮助学生解决生活或学习上的困难）2*/
	@Excel(name = "请评价您周围同事的以下行为（关爱学生，积极帮助学生解决生活或学习上的困难）2", width = 15)
    @ApiModelProperty(value = "请评价您周围同事的以下行为（关爱学生，积极帮助学生解决生活或学习上的困难）2")
    private String behaviorSolve2;
	/**请评价您周围同事的以下行为（关注学生的心理健康状况）1*/
	@Excel(name = "请评价您周围同事的以下行为（关注学生的心理健康状况）1", width = 15)
    @ApiModelProperty(value = "请评价您周围同事的以下行为（关注学生的心理健康状况）1")
    private String behaviorMental;
	/**请评价您周围同事的以下行为（关注学生的心理健康状况）2*/
	@Excel(name = "请评价您周围同事的以下行为（关注学生的心理健康状况）2", width = 15)
    @ApiModelProperty(value = "请评价您周围同事的以下行为（关注学生的心理健康状况）2")
    private String behaviorMental2;
	/**请评价您周围同事的以下行为（教学有序，有清晰合理的教学目标并能清楚地向学生解释）1*/
	@Excel(name = "请评价您周围同事的以下行为（教学有序，有清晰合理的教学目标并能清楚地向学生解释）1", width = 15)
    @ApiModelProperty(value = "请评价您周围同事的以下行为（教学有序，有清晰合理的教学目标并能清楚地向学生解释）1")
    private String behaviorAim;
	/**请评价您周围同事的以下行为（教学有序，有清晰合理的教学目标并能清楚地向学生解释）2*/
	@Excel(name = "请评价您周围同事的以下行为（教学有序，有清晰合理的教学目标并能清楚地向学生解释）2", width = 15)
    @ApiModelProperty(value = "请评价您周围同事的以下行为（教学有序，有清晰合理的教学目标并能清楚地向学生解释）2")
    private String behaviorAim2;
	/**请评价您周围同事的以下行为（育人有方，激发学生的学习兴趣，注重培养学生的创新精神和创新思维）1*/
	@Excel(name = "请评价您周围同事的以下行为（育人有方，激发学生的学习兴趣，注重培养学生的创新精神和创新思维）1", width = 15)
    @ApiModelProperty(value = "请评价您周围同事的以下行为（育人有方，激发学生的学习兴趣，注重培养学生的创新精神和创新思维）1")
    private String behaviorCreate;
	/**请评价您周围同事的以下行为（育人有方，激发学生的学习兴趣，注重培养学生的创新精神和创新思维）2*/
	@Excel(name = "请评价您周围同事的以下行为（育人有方，激发学生的学习兴趣，注重培养学生的创新精神和创新思维）2", width = 15)
    @ApiModelProperty(value = "请评价您周围同事的以下行为（育人有方，激发学生的学习兴趣，注重培养学生的创新精神和创新思维）2")
    private String behaviorCreate2;
	/**请评价您周围同事的以下行为（以身作则，信守承诺）1*/
	@Excel(name = "请评价您周围同事的以下行为（以身作则，信守承诺）1", width = 15)
    @ApiModelProperty(value = "请评价您周围同事的以下行为（以身作则，信守承诺）1")
    private String behaviorCommit;
	/**请评价您周围同事的以下行为（以身作则，信守承诺）2*/
	@Excel(name = "请评价您周围同事的以下行为（以身作则，信守承诺）2", width = 15)
    @ApiModelProperty(value = "请评价您周围同事的以下行为（以身作则，信守承诺）2")
    private String behaviorCommit2;
	/**您将中国特色社会主义核心价值观、做人做事的基本道理、爱国主义与理想信念、国情与社会时政热点等融入课堂教学的方式是（以讲授为主融入课程内容）1*/
	@Excel(name = "您将中国特色社会主义核心价值观、做人做事的基本道理、爱国主义与理想信念、国情与社会时政热点等融入课堂教学的方式是（以讲授为主融入课程内容）1", width = 15)
    @ApiModelProperty(value = "您将中国特色社会主义核心价值观、做人做事的基本道理、爱国主义与理想信念、国情与社会时政热点等融入课堂教学的方式是（以讲授为主融入课程内容）1")
    private String rrfsCourse;
	/**您将中国特色社会主义核心价值观、做人做事的基本道理、爱国主义与理想信念、国情与社会时政热点等融入课堂教学的方式是（在学生参与讨论、展示等课堂互动环节中融入）2*/
	@Excel(name = "您将中国特色社会主义核心价值观、做人做事的基本道理、爱国主义与理想信念、国情与社会时政热点等融入课堂教学的方式是（在学生参与讨论、展示等课堂互动环节中融入）2", width = 15)
    @ApiModelProperty(value = "您将中国特色社会主义核心价值观、做人做事的基本道理、爱国主义与理想信念、国情与社会时政热点等融入课堂教学的方式是（在学生参与讨论、展示等课堂互动环节中融入）2")
    private String rrfsDiscuss;
	/**您将中国特色社会主义核心价值观、做人做事的基本道理、爱国主义与理想信念、国情与社会时政热点等融入课堂教学的方式是（融入课堂作业、论文中）1*/
	@Excel(name = "您将中国特色社会主义核心价值观、做人做事的基本道理、爱国主义与理想信念、国情与社会时政热点等融入课堂教学的方式是（融入课堂作业、论文中）1", width = 15)
    @ApiModelProperty(value = "您将中国特色社会主义核心价值观、做人做事的基本道理、爱国主义与理想信念、国情与社会时政热点等融入课堂教学的方式是（融入课堂作业、论文中）1")
    private String rrfsWork;
	/**您将中国特色社会主义核心价值观、做人做事的基本道理、爱国主义与理想信念、国情与社会时政热点等融入课堂教学的方式是（融入实验、实训中）2*/
	@Excel(name = "您将中国特色社会主义核心价值观、做人做事的基本道理、爱国主义与理想信念、国情与社会时政热点等融入课堂教学的方式是（融入实验、实训中）2", width = 15)
    @ApiModelProperty(value = "您将中国特色社会主义核心价值观、做人做事的基本道理、爱国主义与理想信念、国情与社会时政热点等融入课堂教学的方式是（融入实验、实训中）2")
    private String rrfsIntern;
	/**您将中国特色社会主义核心价值观、做人做事的基本道理、爱国主义与理想信念、国情与社会时政热点等融入课堂教学的方式是（其他）1*/
	@Excel(name = "您将中国特色社会主义核心价值观、做人做事的基本道理、爱国主义与理想信念、国情与社会时政热点等融入课堂教学的方式是（其他）1", width = 15)
    @ApiModelProperty(value = "您将中国特色社会主义核心价值观、做人做事的基本道理、爱国主义与理想信念、国情与社会时政热点等融入课堂教学的方式是（其他）1")
    private String rrfsQt;
	/**您将中国特色社会主义核心价值观、做人做事的基本道理、爱国主义与理想信念、国情与社会时政热点等融入课堂教学的方式是（并未涉及题目所述内容）2*/
	@Excel(name = "您将中国特色社会主义核心价值观、做人做事的基本道理、爱国主义与理想信念、国情与社会时政热点等融入课堂教学的方式是（并未涉及题目所述内容）2", width = 15)
    @ApiModelProperty(value = "您将中国特色社会主义核心价值观、做人做事的基本道理、爱国主义与理想信念、国情与社会时政热点等融入课堂教学的方式是（并未涉及题目所述内容）2")
    private String rrfsNo;
	/**请根据您自身的实际情况评价在以下方面的相符程度（目标明确，熟悉教材，了解学生，教学认知能力强）1*/
	@Excel(name = "请根据您自身的实际情况评价在以下方面的相符程度（目标明确，熟悉教材，了解学生，教学认知能力强）1", width = 15)
    @ApiModelProperty(value = "请根据您自身的实际情况评价在以下方面的相符程度（目标明确，熟悉教材，了解学生，教学认知能力强）1")
    private String skillKnow;
	/**请根据您自身的实际情况评价在以下方面的相符程度（目标明确，熟悉教材，了解学生，教学认知能力强）2*/
	@Excel(name = "请根据您自身的实际情况评价在以下方面的相符程度（目标明确，熟悉教材，了解学生，教学认知能力强）2", width = 15)
    @ApiModelProperty(value = "请根据您自身的实际情况评价在以下方面的相符程度（目标明确，熟悉教材，了解学生，教学认知能力强）2")
    private String skillKnow2;
	/**请根据您自身的实际情况评价在以下方面的相符程度（教学组织合理，教学方法得当，教学设计能力强）1*/
	@Excel(name = "请根据您自身的实际情况评价在以下方面的相符程度（教学组织合理，教学方法得当，教学设计能力强）1", width = 15)
    @ApiModelProperty(value = "请根据您自身的实际情况评价在以下方面的相符程度（教学组织合理，教学方法得当，教学设计能力强）1")
    private String skillDesign;
	/**请根据您自身的实际情况评价在以下方面的相符程度（教学组织合理，教学方法得当，教学设计能力强）2*/
	@Excel(name = "请根据您自身的实际情况评价在以下方面的相符程度（教学组织合理，教学方法得当，教学设计能力强）2", width = 15)
    @ApiModelProperty(value = "请根据您自身的实际情况评价在以下方面的相符程度（教学组织合理，教学方法得当，教学设计能力强）2")
    private String skillDesign2;
	/**请根据您自身的实际情况评价在以下方面的相符程度（灵活变通教学思路，机智应对突发状况，教学调控能力强）1*/
	@Excel(name = "请根据您自身的实际情况评价在以下方面的相符程度（灵活变通教学思路，机智应对突发状况，教学调控能力强）1", width = 15)
    @ApiModelProperty(value = "请根据您自身的实际情况评价在以下方面的相符程度（灵活变通教学思路，机智应对突发状况，教学调控能力强）1")
    private String skillCtrl;
	/**请根据您自身的实际情况评价在以下方面的相符程度（灵活变通教学思路，机智应对突发状况，教学调控能力强）2*/
	@Excel(name = "请根据您自身的实际情况评价在以下方面的相符程度（灵活变通教学思路，机智应对突发状况，教学调控能力强）2", width = 15)
    @ApiModelProperty(value = "请根据您自身的实际情况评价在以下方面的相符程度（灵活变通教学思路，机智应对突发状况，教学调控能力强）2")
    private String skillCtrl2;
	/**请根据您自身的实际情况评价在以下方面的相符程度（坚持产出导向，定量定性相结合，综合知识、能力与素质，注重过程性评价，教学评价能力强）1*/
	@Excel(name = "请根据您自身的实际情况评价在以下方面的相符程度（坚持产出导向，定量定性相结合，综合知识、能力与素质，注重过程性评价，教学评价能力强）1", width = 15)
    @ApiModelProperty(value = "请根据您自身的实际情况评价在以下方面的相符程度（坚持产出导向，定量定性相结合，综合知识、能力与素质，注重过程性评价，教学评价能力强）1")
    private String skillAssess;
	/**请根据您自身的实际情况评价在以下方面的相符程度（坚持产出导向，定量定性相结合，综合知识、能力与素质，注重过程性评价，教学评价能力强）2*/
	@Excel(name = "请根据您自身的实际情况评价在以下方面的相符程度（坚持产出导向，定量定性相结合，综合知识、能力与素质，注重过程性评价，教学评价能力强）2", width = 15)
    @ApiModelProperty(value = "请根据您自身的实际情况评价在以下方面的相符程度（坚持产出导向，定量定性相结合，综合知识、能力与素质，注重过程性评价，教学评价能力强）2")
    private String skillAssess2;
	/**请根据您自身的实际情况评价在以下方面的相符程度（积极将现代信息技术与教育教学深度融合，运用教学媒介能力强）1*/
	@Excel(name = "请根据您自身的实际情况评价在以下方面的相符程度（积极将现代信息技术与教育教学深度融合，运用教学媒介能力强）1", width = 15)
    @ApiModelProperty(value = "请根据您自身的实际情况评价在以下方面的相符程度（积极将现代信息技术与教育教学深度融合，运用教学媒介能力强）1")
    private String skillTech;
	/**请根据您自身的实际情况评价在以下方面的相符程度（积极将现代信息技术与教育教学深度融合，运用教学媒介能力强）2*/
	@Excel(name = "请根据您自身的实际情况评价在以下方面的相符程度（积极将现代信息技术与教育教学深度融合，运用教学媒介能力强）2", width = 15)
    @ApiModelProperty(value = "请根据您自身的实际情况评价在以下方面的相符程度（积极将现代信息技术与教育教学深度融合，运用教学媒介能力强）2")
    private String skillTech2;
	/**您是否同意以下描述（我清楚自己的岗位职责和要求）1*/
	@Excel(name = "您是否同意以下描述（我清楚自己的岗位职责和要求）1", width = 15)
    @ApiModelProperty(value = "您是否同意以下描述（我清楚自己的岗位职责和要求）1")
    private String dedicationStandard;
	/**您是否同意以下描述（我清楚自己的岗位职责和要求）2*/
	@Excel(name = "您是否同意以下描述（我清楚自己的岗位职责和要求）2", width = 15)
    @ApiModelProperty(value = "您是否同意以下描述（我清楚自己的岗位职责和要求）2")
    private String dedicationStandard2;
	/**您是否同意以下描述（我周围的教授同事们都为本科生上课）1*/
	@Excel(name = "您是否同意以下描述（我周围的教授同事们都为本科生上课）1", width = 15)
    @ApiModelProperty(value = "您是否同意以下描述（我周围的教授同事们都为本科生上课）1")
    private String dedicationHigh;
	/**您是否同意以下描述（我周围的教授同事们都为本科生上课）2*/
	@Excel(name = "您是否同意以下描述（我周围的教授同事们都为本科生上课）2", width = 15)
    @ApiModelProperty(value = "您是否同意以下描述（我周围的教授同事们都为本科生上课）2")
    private String dedicationHigh2;
	/**您是否同意以下描述（我和同事们都很乐意开展教学研究和改革）1*/
	@Excel(name = "您是否同意以下描述（我和同事们都很乐意开展教学研究和改革）1", width = 15)
    @ApiModelProperty(value = "您是否同意以下描述（我和同事们都很乐意开展教学研究和改革）1")
    private String dedicationDevelop;
	/**您是否同意以下描述（我和同事们都很乐意开展教学研究和改革）2*/
	@Excel(name = "您是否同意以下描述（我和同事们都很乐意开展教学研究和改革）2", width = 15)
    @ApiModelProperty(value = "您是否同意以下描述（我和同事们都很乐意开展教学研究和改革）2")
    private String dedicationDevelop2;
	/**dedicationResearch*/
	@Excel(name = "dedicationResearch", width = 15)
    @ApiModelProperty(value = "dedicationResearch")
    private String dedicationResearch;
	/**dedicationResearch2*/
	@Excel(name = "dedicationResearch2", width = 15)
    @ApiModelProperty(value = "dedicationResearch2")
    private String dedicationResearch2;
	/**dedicationApply*/
	@Excel(name = "dedicationApply", width = 15)
    @ApiModelProperty(value = "dedicationApply")
    private String dedicationApply;
	/**dedicationApply2*/
	@Excel(name = "dedicationApply2", width = 15)
    @ApiModelProperty(value = "dedicationApply2")
    private String dedicationApply2;
	/**dedicationDistribution*/
	@Excel(name = "dedicationDistribution", width = 15)
    @ApiModelProperty(value = "dedicationDistribution")
    private String dedicationDistribution;
	/**dedicationDistribution2*/
	@Excel(name = "dedicationDistribution2", width = 15)
    @ApiModelProperty(value = "dedicationDistribution2")
    private String dedicationDistribution2;
	/**spendTeach*/
	@Excel(name = "spendTeach", width = 15)
    @ApiModelProperty(value = "spendTeach")
    private String spendTeach;
	/**spendPrepare*/
	@Excel(name = "spendPrepare", width = 15)
    @ApiModelProperty(value = "spendPrepare")
    private String spendPrepare;
	/**spendResearch*/
	@Excel(name = "spendResearch", width = 15)
    @ApiModelProperty(value = "spendResearch")
    private String spendResearch;
	/**spendCoach*/
	@Excel(name = "spendCoach", width = 15)
    @ApiModelProperty(value = "spendCoach")
    private String spendCoach;
	/**spendMeeting*/
	@Excel(name = "spendMeeting", width = 15)
    @ApiModelProperty(value = "spendMeeting")
    private String spendMeeting;
	/**spendParttime*/
	@Excel(name = "spendParttime", width = 15)
    @ApiModelProperty(value = "spendParttime")
    private String spendParttime;
	/**jskcGgts*/
	@Excel(name = "jskcGgts", width = 15)
    @ApiModelProperty(value = "jskcGgts")
    private String jskcGgts;
	/**jskcDnj*/
	@Excel(name = "jskcDnj", width = 15)
    @ApiModelProperty(value = "jskcDnj")
    private String jskcDnj;
	/**jskcGnj*/
	@Excel(name = "jskcGnj", width = 15)
    @ApiModelProperty(value = "jskcGnj")
    private String jskcGnj;
	/**jskcZyxxk*/
	@Excel(name = "jskcZyxxk", width = 15)
    @ApiModelProperty(value = "jskcZyxxk")
    private String jskcZyxxk;
	/**jskcYjs*/
	@Excel(name = "jskcYjs", width = 15)
    @ApiModelProperty(value = "jskcYjs")
    private String jskcYjs;
	/**jskcNo*/
	@Excel(name = "jskcNo", width = 15)
    @ApiModelProperty(value = "jskcNo")
    private String jskcNo;
	/**zykSkill*/
	@Excel(name = "zykSkill", width = 15)
    @ApiModelProperty(value = "zykSkill")
    private String zykSkill;
	/**zykSkill2*/
	@Excel(name = "zykSkill2", width = 15)
    @ApiModelProperty(value = "zykSkill2")
    private String zykSkill2;
	/**zykProblem*/
	@Excel(name = "zykProblem", width = 15)
    @ApiModelProperty(value = "zykProblem")
    private String zykProblem;
	/**zykProblem2*/
	@Excel(name = "zykProblem2", width = 15)
    @ApiModelProperty(value = "zykProblem2")
    private String zykProblem2;
	/**zykCross*/
	@Excel(name = "zykCross", width = 15)
    @ApiModelProperty(value = "zykCross")
    private String zykCross;
	/**zykCross2*/
	@Excel(name = "zykCross2", width = 15)
    @ApiModelProperty(value = "zykCross2")
    private String zykCross2;
	/**zykIntern*/
	@Excel(name = "zykIntern", width = 15)
    @ApiModelProperty(value = "zykIntern")
    private String zykIntern;
	/**zykIntern2*/
	@Excel(name = "zykIntern2", width = 15)
    @ApiModelProperty(value = "zykIntern2")
    private String zykIntern2;
	/**zykEffort*/
	@Excel(name = "zykEffort", width = 15)
    @ApiModelProperty(value = "zykEffort")
    private String zykEffort;
	/**zykEffort2*/
	@Excel(name = "zykEffort2", width = 15)
    @ApiModelProperty(value = "zykEffort2")
    private String zykEffort2;
	/**zykNew*/
	@Excel(name = "zykNew", width = 15)
    @ApiModelProperty(value = "zykNew")
    private String zykNew;
	/**zykNew2*/
	@Excel(name = "zykNew2", width = 15)
    @ApiModelProperty(value = "zykNew2")
    private String zykNew2;
	/**checkKc*/
	@Excel(name = "checkKc", width = 15)
    @ApiModelProperty(value = "checkKc")
    private String checkKc;
	/**linianPyfa*/
	@Excel(name = "linianPyfa", width = 15)
    @ApiModelProperty(value = "linianPyfa")
    private String linianPyfa;
	/**linianPymb*/
	@Excel(name = "linianPymb", width = 15)
    @ApiModelProperty(value = "linianPymb")
    private String linianPymb;
	/**linianByyq*/
	@Excel(name = "linianByyq", width = 15)
    @ApiModelProperty(value = "linianByyq")
    private String linianByyq;
	/**linianXszx*/
	@Excel(name = "linianXszx", width = 15)
    @ApiModelProperty(value = "linianXszx")
    private String linianXszx;
	/**linianNo*/
	@Excel(name = "linianNo", width = 15)
    @ApiModelProperty(value = "linianNo")
    private String linianNo;
	/**linianZjgj*/
	@Excel(name = "linianZjgj", width = 15)
    @ApiModelProperty(value = "linianZjgj")
    private String linianZjgj;
	/**exchangeTlsg*/
	@Excel(name = "exchangeTlsg", width = 15)
    @ApiModelProperty(value = "exchangeTlsg")
    private String exchangeTlsg;
	/**exchangeZdkc*/
	@Excel(name = "exchangeZdkc", width = 15)
    @ApiModelProperty(value = "exchangeZdkc")
    private String exchangeZdkc;
	/**exchangeZdlw*/
	@Excel(name = "exchangeZdlw", width = 15)
    @ApiModelProperty(value = "exchangeZdlw")
    private String exchangeZdlw;
	/**exchangeZdxm*/
	@Excel(name = "exchangeZdxm", width = 15)
    @ApiModelProperty(value = "exchangeZdxm")
    private String exchangeZdxm;
	/**exchangeZygh*/
	@Excel(name = "exchangeZygh", width = 15)
    @ApiModelProperty(value = "exchangeZygh")
    private String exchangeZygh;
	/**exchangeXljk*/
	@Excel(name = "exchangeXljk", width = 15)
    @ApiModelProperty(value = "exchangeXljk")
    private String exchangeXljk;
	/**exchangeNo*/
	@Excel(name = "exchangeNo", width = 15)
    @ApiModelProperty(value = "exchangeNo")
    private String exchangeNo;
	/**preClassPreview*/
	@Excel(name = "preClassPreview", width = 15)
    @ApiModelProperty(value = "preClassPreview")
    private String preClassPreview;
	/**preClassPreview2*/
	@Excel(name = "preClassPreview2", width = 15)
    @ApiModelProperty(value = "preClassPreview2")
    private String preClassPreview2;
	/**inClassQuestions*/
	@Excel(name = "inClassQuestions", width = 15)
    @ApiModelProperty(value = "inClassQuestions")
    private String inClassQuestions;
	/**inClassQuestions2*/
	@Excel(name = "inClassQuestions2", width = 15)
    @ApiModelProperty(value = "inClassQuestions2")
    private String inClassQuestions2;
	/**afterClassSummary*/
	@Excel(name = "afterClassSummary", width = 15)
    @ApiModelProperty(value = "afterClassSummary")
    private String afterClassSummary;
	/**afterClassSummary2*/
	@Excel(name = "afterClassSummary2", width = 15)
    @ApiModelProperty(value = "afterClassSummary2")
    private String afterClassSummary2;
	/**afterClassRead*/
	@Excel(name = "afterClassRead", width = 15)
    @ApiModelProperty(value = "afterClassRead")
    private String afterClassRead;
	/**afterClassRead2*/
	@Excel(name = "afterClassRead2", width = 15)
    @ApiModelProperty(value = "afterClassRead2")
    private String afterClassRead2;
	/**trainSystem*/
	@Excel(name = "trainSystem", width = 15)
    @ApiModelProperty(value = "trainSystem")
    private String trainSystem;
	/**trainSystem2*/
	@Excel(name = "trainSystem2", width = 15)
    @ApiModelProperty(value = "trainSystem2")
    private String trainSystem2;
	/**trainTeach*/
	@Excel(name = "trainTeach", width = 15)
    @ApiModelProperty(value = "trainTeach")
    private String trainTeach;
	/**trainTeach2*/
	@Excel(name = "trainTeach2", width = 15)
    @ApiModelProperty(value = "trainTeach2")
    private String trainTeach2;
	/**trainDevelop*/
	@Excel(name = "trainDevelop", width = 15)
    @ApiModelProperty(value = "trainDevelop")
    private String trainDevelop;
	/**trainDevelop2*/
	@Excel(name = "trainDevelop2", width = 15)
    @ApiModelProperty(value = "trainDevelop2")
    private String trainDevelop2;
	/**trainGlobal*/
	@Excel(name = "trainGlobal", width = 15)
    @ApiModelProperty(value = "trainGlobal")
    private String trainGlobal;
	/**trainGlobal2*/
	@Excel(name = "trainGlobal2", width = 15)
    @ApiModelProperty(value = "trainGlobal2")
    private String trainGlobal2;
	/**teachingIndex*/
	@Excel(name = "teachingIndex", width = 15)
    @ApiModelProperty(value = "teachingIndex")
    private String teachingIndex;
	/**teachingIndex2*/
	@Excel(name = "teachingIndex2", width = 15)
    @ApiModelProperty(value = "teachingIndex2")
    private String teachingIndex2;
	/**teachingEffect*/
	@Excel(name = "teachingEffect", width = 15)
    @ApiModelProperty(value = "teachingEffect")
    private String teachingEffect;
	/**teachingEffect2*/
	@Excel(name = "teachingEffect2", width = 15)
    @ApiModelProperty(value = "teachingEffect2")
    private String teachingEffect2;
	/**teachingSupervise*/
	@Excel(name = "teachingSupervise", width = 15)
    @ApiModelProperty(value = "teachingSupervise")
    private String teachingSupervise;
	/**teachingSupervise2*/
	@Excel(name = "teachingSupervise2", width = 15)
    @ApiModelProperty(value = "teachingSupervise2")
    private String teachingSupervise2;
	/**teachingAwards*/
	@Excel(name = "teachingAwards", width = 15)
    @ApiModelProperty(value = "teachingAwards")
    private String teachingAwards;
	/**teachingAwards2*/
	@Excel(name = "teachingAwards2", width = 15)
    @ApiModelProperty(value = "teachingAwards2")
    private String teachingAwards2;
	/**teachingStudent*/
	@Excel(name = "teachingStudent", width = 15)
    @ApiModelProperty(value = "teachingStudent")
    private String teachingStudent;
	/**teachingStudent2*/
	@Excel(name = "teachingStudent2", width = 15)
    @ApiModelProperty(value = "teachingStudent2")
    private String teachingStudent2;
	/**teachingResult*/
	@Excel(name = "teachingResult", width = 15)
    @ApiModelProperty(value = "teachingResult")
    private String teachingResult;
	/**teachingResult2*/
	@Excel(name = "teachingResult2", width = 15)
    @ApiModelProperty(value = "teachingResult2")
    private String teachingResult2;
	/**checkJp*/
	@Excel(name = "checkJp", width = 15)
    @ApiModelProperty(value = "checkJp")
    private String checkJp;
	/**satiRoom*/
	@Excel(name = "satiRoom", width = 15)
    @ApiModelProperty(value = "satiRoom")
    private String satiRoom;
	/**satiRoom2*/
	@Excel(name = "satiRoom2", width = 15)
    @ApiModelProperty(value = "satiRoom2")
    private String satiRoom2;
	/**satiResourse*/
	@Excel(name = "satiResourse", width = 15)
    @ApiModelProperty(value = "satiResourse")
    private String satiResourse;
	/**satiResourse2*/
	@Excel(name = "satiResourse2", width = 15)
    @ApiModelProperty(value = "satiResourse2")
    private String satiResourse2;
	/**satiLibrary*/
	@Excel(name = "satiLibrary", width = 15)
    @ApiModelProperty(value = "satiLibrary")
    private String satiLibrary;
	/**satiLibrary2*/
	@Excel(name = "satiLibrary2", width = 15)
    @ApiModelProperty(value = "satiLibrary2")
    private String satiLibrary2;
	/**satiNet*/
	@Excel(name = "satiNet", width = 15)
    @ApiModelProperty(value = "satiNet")
    private String satiNet;
	/**satiNet2*/
	@Excel(name = "satiNet2", width = 15)
    @ApiModelProperty(value = "satiNet2")
    private String satiNet2;
	/**satiSport*/
	@Excel(name = "satiSport", width = 15)
    @ApiModelProperty(value = "satiSport")
    private String satiSport;
	/**satiSport2*/
	@Excel(name = "satiSport2", width = 15)
    @ApiModelProperty(value = "satiSport2")
    private String satiSport2;
	/**collsati*/
	@Excel(name = "collsati", width = 15)
    @ApiModelProperty(value = "collsati")
    private String collsati;
	/**collsati2*/
	@Excel(name = "collsati2", width = 15)
    @ApiModelProperty(value = "collsati2")
    private String collsati2;
}
