package org.jeecg.modules.kc.blTeacherMain.vo;

import java.util.List;
import org.jeecg.modules.kc.blTeacherMain.entity.BlTeacherMain;
import org.jeecg.modules.kc.blTeacherMain.entity.BlTeacherTjfx;
import lombok.Data;
import org.jeecgframework.poi.excel.annotation.Excel;
import org.jeecgframework.poi.excel.annotation.ExcelEntity;
import org.jeecgframework.poi.excel.annotation.ExcelCollection;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;
import java.util.Date;
import org.jeecg.common.aspect.annotation.Dict;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

/**
 * @Description: 教师调查问卷
 * @Author: jeecg-boot
 * @Date:   2024-06-07
 * @Version: V1.0
 */
@Data
@ApiModel(value="bl_teacher_mainPage对象", description="教师调查问卷")
public class BlTeacherMainPage {

	/**id*/
	@ApiModelProperty(value = "id")
    private String id;
	/**createBy*/
	@ApiModelProperty(value = "createBy")
    private String createBy;
	/**createTime*/
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd")
    @DateTimeFormat(pattern="yyyy-MM-dd")
	@ApiModelProperty(value = "createTime")
    private Date createTime;
	/**updateBy*/
	@ApiModelProperty(value = "updateBy")
    private String updateBy;
	/**updateTime*/
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd")
    @DateTimeFormat(pattern="yyyy-MM-dd")
	@ApiModelProperty(value = "updateTime")
    private Date updateTime;
	/**名称*/
	@Excel(name = "名称", width = 15)
	@ApiModelProperty(value = "名称")
    private String title;

	@ExcelCollection(name="问卷信息")
	@ApiModelProperty(value = "问卷信息")
	private List<BlTeacherTjfx> blTeacherTjfxList;

}
