package org.jeecg.modules.kc.blZycc.service.impl;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import org.apache.commons.lang3.StringUtils;
import org.jeecg.common.util.PmsUtil;
import org.jeecg.modules.kc.blZycc.entity.BlZycc;
import org.jeecg.modules.kc.blZycc.mapper.BlZyccMapper;
import org.jeecg.modules.kc.blZycc.service.IBlZyccService;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;

import javax.activation.MimetypesFileTypeMap;
import java.io.*;
import java.net.HttpURLConnection;
import java.net.URL;
import java.nio.charset.StandardCharsets;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * @Description: bl_zycc
 * @Author: jeecg-boot
 * @Date:   2024-04-13
 * @Version: V1.0
 */
@Service
public class BlZyccServiceImpl extends ServiceImpl<BlZyccMapper, BlZycc> implements IBlZyccService {


    private static String uploadpath;//SpringContextUtils.getApplicationContext().getEnvironment().getProperty("jeecg.path.upload")

    @Value("${jeecg.path.upload}")
    public void setUploadPath(String uploadPath) {
        this.uploadpath = uploadPath;
    }

    private static String weipuId;

    @Value("${weipu.userId}")
    public void setWeipuId(String weipuId) {
        this.weipuId = weipuId;
    }


    private static String weipuKey;
    @Value("${weipu.userKey}")
    public void setWeipuKey(String weipuKey) {
        this.weipuKey = weipuKey;
    }

    private static String cateid = "20241111111111";//范围库唯一标识
    private static String catename = "测试库";//范围库名称

    //维普外网上传
    @Override
    public BlZycc zyccUpload(BlZycc blZycc) {
        String url = "https://vims.fanyu.com/toole/jianceorgan/papersubmit.aspx";
        //文件路径，文件存在，不存在的话需要先下载下来
        String fileName = uploadpath+"/"+blZycc.getFilePath();
        Map<String, String> textMap = new HashMap<String, String>();
        //可以设置多个input的name，value
        String sign = getSign();
        textMap.put("userid", weipuId);
        textMap.put("sign", sign);
        String titlePar =fileName.substring(fileName.lastIndexOf("/")+1,fileName.length());
        String title = titlePar.split("_")[0];
        textMap.put("title", title);
        textMap.put("author", "测试作者A");
        //设置file的name，路径
        Map<String, String> fileMap = new HashMap<String, String>();
        fileMap.put("file", fileName);
        String contentType = "";//image/png
        String ret = formUpload(url, textMap, fileMap,contentType);
        System.out.println("1-------->"+ret);
        JSONObject object= JSONObject.parseObject(ret);
        if("true".equals(object.getString("success"))){
            String listpaper = object.getString("listpaper");
            JSONArray jsonArray = (JSONArray) JSONArray.parse(listpaper);
            JSONObject object2= jsonArray.getJSONObject(0);
            String paperid = object2.getString("paperid");
            System.out.println("2-------->"+paperid);
            blZycc.setPaperid(paperid);
            baseMapper.insert(blZycc);

            //提交后直接开始检测
            String message = wwKsjc(blZycc);
            System.out.println("21-------->"+message);
            blZycc.setMessage(message);
        }else{
            System.out.println("3-------->");
        }
        return blZycc;
    }

    @Override
    public String wwKsjc(BlZycc blZycc) {
        String url = "https://vims.fanyu.com/toole/jianceorgan/paperbegincheck.aspx";
        //文件路径，文件存在，不存在的话需要先下载下来
        String paperid = blZycc.getPaperid();
        Map<String, String> textMap = new HashMap<String, String>();
        //可以设置多个input的name，value
        String sign = getSign();
        textMap.put("userid", weipuId);
        textMap.put("sign", sign);
        textMap.put("paperids", paperid);//资源id
        String contentType = "";//image/png
        Map<String, String> fileMap = new HashMap<String, String>();
        String ret = formUpload(url, textMap, fileMap,contentType);
        System.out.println("1--xfwbdKsjc------>"+ret);
        JSONObject object= JSONObject.parseObject(ret);
        String message = object.getString("message");
        if("true".equals(object.getString("success"))){//返回值只有{"success":true,"message":"提交比对成功，资源开始比对..."}
            System.out.println("message----->"+message);
        }else{
            System.out.println("3--xfwbdKsjc------>");
        }
        return message;
    }

    @Override
    public Map<String,String> wwCxjcjg(BlZycc blZycc) {
        String url = "https://vims.fanyu.com/toole/jianceorgan/paperlist.aspx";
        //文件路径，文件存在，不存在的话需要先下载下来
        String paperid = blZycc.getPaperid();
        Map<String, String> textMap = new HashMap<String, String>();
        //可以设置多个input的name，value
        String sign = getSign();
        textMap.put("userid", weipuId);
        textMap.put("sign", sign);
        textMap.put("paperids", paperid);//资源id,可多个，用逗号分割
        String contentType = "";//image/png
        Map<String, String> fileMap = new HashMap<String, String>();
        String ret = formUpload(url, textMap, fileMap,contentType);
        System.out.println("1-------->"+ret);
        JSONObject object= JSONObject.parseObject(ret);
        if("true".equals(object.getString("success"))){
            //{"success":true,"message":"查询成功", "datalist":[{"dataid":568,"message":"","paperguid":"5c384d6bd69y9ba9","papertitle":"","filestateid":2,"paperword":1958,"percentage":0,"duplicatepercentage":0,"quotepercentage":0,"paichupercentage":0,"selfyypercentage":0,"ownpercentage":100,"authorpercentage":0,"checkdate":"2024-04-13 13:51:51","paperviewurl":"https://vims.fanyu.com/toole/smallcheck/getonlineurl?guid=5c384d6bd69y9ba9","paperdownurl":"https://vims.fanyu.com/toole/smallcheck/getdownloadurl?guid=5c384d6bd69y9ba9"}]}
            //filestateid 检测状态{0未检测,1检测中,2检测完成, 3检测失败}
            String listpaper = object.getString("listpaper");
            JSONArray jsonArray = (JSONArray) JSONArray.parse(listpaper);
            JSONObject object2= jsonArray.getJSONObject(0);
            String filestateid = object2.getString("filestateid");
            if(StringUtils.equals(filestateid,"0")){
                System.out.println(paperid+":未检测");
            }else if(StringUtils.equals(filestateid,"1")){
                System.out.println(paperid+":检测中");
            }else if(StringUtils.equals(filestateid,"2")){
                System.out.println(paperid+":检测完成");
            }else if(StringUtils.equals(filestateid,"3")){
                System.out.println(paperid+":检测失败；"+object2.getString("message"));
            }else{
                System.out.println(paperid+":当前状态："+filestateid+"；"+object2.getString("message"));
            }
            System.out.println("listpaper----->"+listpaper);//结果结合
            System.out.println("object2----->"+object2);//实际单挑数据结果
            Map<String,String> map = new HashMap<String,String>();
            map.put("duplicatepercentage",object2.getString("duplicatepercentage"));//复写率
            map.put("paperdownurl",object2.getString("paperdownurl"));//报告下载地址
            map.put("paperword",object2.getString("paperword"));//论文字数
            map.put("paichupercentage",object2.getString("paichupercentage"));//他引率
            map.put("paperviewurl",object2.getString("paperviewurl"));//报告在线查看地址
            map.put("papertitle",object2.getString("papertitle"));//论文标题
            map.put("ownpercentage",object2.getString("ownpercentage"));//自写率
            map.put("percentage",object2.getString("percentage"));//相似率
            map.put("paperguid",object2.getString("paperguid"));//报告编号
            map.put("quotepercentage",object2.getString("quotepercentage"));//引用率
            map.put("selfyypercentage",object2.getString("selfyypercentage"));//自引率
            map.put("authorpercentage",object2.getString("authorpercentage"));//专业术语率
            map.put("checkdate",object2.getString("checkdate"));//检测时间
            map.put("papermsg",object2.getString("papermsg"));//其他信息
            map.put("filestateid",object2.getString("filestateid"));//检测状态0:未检测；1:检测中；2:检测完成；3:检测失败；
            map.put("message",object.getString("message"));

            return map;
        }else{
            System.out.println("3-------->");
            Map<String,String> map = new HashMap<String,String>();
            map.put("success","false");
            map.put("message",object.getString("message"));
            return map;
        }
    }


    //小范围比对上传文档
    @Override
    public BlZycc xfwbdUpload(BlZycc blZycc) {
        String url = "https://vims.fanyu.com/toole/smallcheck/submitData";
        //文件路径，文件存在，不存在的话需要先下载下来
        String fileName = uploadpath+"/"+blZycc.getFilePath();
        Map<String, String> textMap = new HashMap<String, String>();
        String titlePar =fileName.substring(fileName.lastIndexOf("/")+1,fileName.length());
        String title = titlePar.split("_")[0];
        //可以设置多个input的name，value
        String sign = getSign();
        textMap.put("userid", weipuId);
        textMap.put("sign", sign);
        textMap.put("title", title);//标题
        textMap.put("author", "test01");//作者
        textMap.put("cateid", cateid);//范围库唯一标识
        textMap.put("catename", catename);//范围库名称
        //设置file的name，路径
        Map<String, String> fileMap = new HashMap<String, String>();
        fileMap.put("file", fileName);
        String contentType = "";//image/png
        String ret = formUpload(url, textMap, fileMap,contentType);
        System.out.println("1-------->"+ret);
        JSONObject object= JSONObject.parseObject(ret);
        if("true".equals(object.getString("success"))){
            String listpaper = object.getString("datainfo");
            JSONObject object2= JSON.parseObject(listpaper);
            String paperid = object2.getString("dataid");//资源id 后续提交比对/删除文档会试用
            System.out.println("2-------->"+paperid);
            blZycc.setPaperid(paperid);
            blZycc.setXnpaperid(paperid);
            blZycc.setCateid(cateid);
            blZycc.setCatename(catename);
            baseMapper.insert(blZycc);

            //提交后直接开始检测
            String message = xfwbdKsjc(blZycc);
            System.out.println("21-------->"+message);
            blZycc.setMessage(message);
        }else{
            System.out.println("3-------->");
        }
        return blZycc;
    }

    //小范围比对开始检测
    @Override
    public String xfwbdKsjc(BlZycc blZycc) {
        String url = "https://vims.fanyu.com/toole/smallcheck/beginCheck";
        //文件路径，文件存在，不存在的话需要先下载下来
        String paperid = blZycc.getPaperid();
        Map<String, String> textMap = new HashMap<String, String>();
        //可以设置多个input的name，value
        String sign = getSign();
        textMap.put("userid", weipuId);
        textMap.put("sign", sign);
        textMap.put("cateid", cateid);//比对库的id
        textMap.put("dataids", paperid);//资源id
        String contentType = "";//image/png
        Map<String, String> fileMap = new HashMap<String, String>();
        String ret = formUpload(url, textMap, fileMap,contentType);
        System.out.println("1--xfwbdKsjc------>"+ret);
        JSONObject object= JSONObject.parseObject(ret);
//        if("true".equals(object.getString("success"))){//返回值只有{"success":true,"message":"提交比对成功，资源开始比对..."}
//
//        }else{
//            System.out.println("3--xfwbdKsjc------>");
//        }
        String message = object.getString("message");
        return message;
    }

    //小范围比对查询检测结果
    @Override
    public Map<String,String> xfwbdCxjcjg(BlZycc blZycc) {
        String url = "https://vims.fanyu.com/toole/smallcheck/searchCheckStatus";
        //文件路径，文件存在，不存在的话需要先下载下来
        String paperid = blZycc.getPaperid();
        Map<String, String> textMap = new HashMap<String, String>();
        //可以设置多个input的name，value
        String sign = getSign();
        textMap.put("userid", weipuId);
        textMap.put("sign", sign);
        textMap.put("cateid", cateid);//比对库的id
        textMap.put("dataids", paperid);//资源id
        String contentType = "";//image/png
        Map<String, String> fileMap = new HashMap<String, String>();
        String ret = formUpload(url, textMap, fileMap,contentType);
        System.out.println("1-------->"+ret);
        JSONObject object= JSONObject.parseObject(ret);
        if("true".equals(object.getString("success"))){
            //{"success":true,"message":"查询成功", "datalist":[{"dataid":568,"message":"","paperguid":"5c384d6bd69y9ba9","papertitle":"","filestateid":2,"paperword":1958,"percentage":0,"duplicatepercentage":0,"quotepercentage":0,"paichupercentage":0,"selfyypercentage":0,"ownpercentage":100,"authorpercentage":0,"checkdate":"2024-04-13 13:51:51","paperviewurl":"https://vims.fanyu.com/toole/smallcheck/getonlineurl?guid=5c384d6bd69y9ba9","paperdownurl":"https://vims.fanyu.com/toole/smallcheck/getdownloadurl?guid=5c384d6bd69y9ba9"}]}
            //filestateid 检测状态{0未检测,1检测中,2检测完成, 3检测失败}
            String listpaper = object.getString("datalist");
            JSONArray jsonArray = (JSONArray) JSONArray.parse(listpaper);
            JSONObject object2= jsonArray.getJSONObject(0);
            String filestateid = object2.getString("filestateid");
            if(StringUtils.equals(filestateid,"0")){
                System.out.println(paperid+":未检测");
            }else if(StringUtils.equals(filestateid,"1")){
                System.out.println(paperid+":检测中");
            }else if(StringUtils.equals(filestateid,"2")){
                System.out.println(paperid+":检测完成");
            }else if(StringUtils.equals(filestateid,"3")){
                System.out.println(paperid+":检测失败；"+object2.getString("message"));
            }else{
                System.out.println(paperid+":当前状态："+filestateid+"；"+object2.getString("message"));
            }
            System.out.println("listpaper----->"+listpaper);//结果结合
            System.out.println("object2----->"+object2);//实际单挑数据结果
            Map<String,String> map = new HashMap<String,String>();
            map.put("duplicatepercentage",object2.getString("duplicatepercentage"));//复写率
            map.put("paperdownurl",object2.getString("paperdownurl"));//报告下载地址
            map.put("paperword",object2.getString("paperword"));//论文字数
            map.put("paichupercentage",object2.getString("paichupercentage"));//他引率
            map.put("paperviewurl",object2.getString("paperviewurl"));//报告在线查看地址
            map.put("papertitle",object2.getString("papertitle"));//论文标题
            map.put("ownpercentage",object2.getString("ownpercentage"));//自写率
            map.put("percentage",object2.getString("percentage"));//相似率
            map.put("paperguid",object2.getString("paperguid"));//报告编号
            map.put("quotepercentage",object2.getString("quotepercentage"));//引用率
            map.put("selfyypercentage",object2.getString("selfyypercentage"));//自引率
            map.put("authorpercentage",object2.getString("authorpercentage"));//专业术语率
            map.put("checkdate",object2.getString("checkdate"));//检测时间
            map.put("papermsg",object2.getString("papermsg"));//其他信息
            map.put("filestateid",object2.getString("filestateid"));//检测状态0:未检测；1:检测中；2:检测完成；3:检测失败；
            map.put("message",object.getString("message"));

            return map;
        }else{
            System.out.println("3-------->");
            Map<String,String> map = new HashMap<String,String>();
            map.put("success","false");
            map.put("message",object.getString("message"));
            return map;
        }
    }



    //aigc上传
    @Override
    public BlZycc aigcUpload(BlZycc blZycc) {

        String url = "https://vims.fanyu.com/tool/AIGCCheck/paperSubmit";
        //文件路径，文件存在，不存在的话需要先下载下来
        String fileName = uploadpath+"/"+blZycc.getFilePath();
        Map<String, String> textMap = new HashMap<String, String>();
        //可以设置多个input的name，value
        String sign = getSign();
        textMap.put("userid", weipuId);
        textMap.put("sign", sign);
        String titlePar =fileName.substring(fileName.lastIndexOf("/")+1,fileName.length());
        String title = titlePar.split("_")[0];
        textMap.put("title", title);
        textMap.put("number", "202405112244");
        textMap.put("author", "测试作者B");
        //设置file的name，路径
        Map<String, String> fileMap = new HashMap<String, String>();
        fileMap.put("file", fileName);
        String contentType = "";//image/png
        String ret = formUpload(url, textMap, fileMap,contentType);
        System.out.println("1-------->"+ret);
        JSONObject object= JSONObject.parseObject(ret);
        if("true".equals(object.getString("success"))){


            String listpaper = object.getString("listPaper");
            JSONArray jsonArray = (JSONArray) JSONArray.parse(listpaper);
            JSONObject object2= jsonArray.getJSONObject(0);
            String paperid = object2.getString("paperid");
            System.out.println("2-------->"+paperid);
            blZycc.setPaperid(paperid);
            blZycc.setAigcpaperid(paperid);
            baseMapper.insert(blZycc);

            //提交后直接开始检测
            String message = aigcKsjc(blZycc);
            System.out.println("21-------->"+message);
            blZycc.setMessage(message);
        }else{
            System.out.println("3-------->");
        }
        return blZycc;
    }

    //aigc开始检测
    @Override
    public String aigcKsjc(BlZycc blZycc) {

        String url = "https://vims.fanyu.com/tool/AIGCCheck/paperBeginCheck\n";
        //文件路径，文件存在，不存在的话需要先下载下来
        String paperid = blZycc.getPaperid();
        Map<String, String> textMap = new HashMap<String, String>();
        //可以设置多个input的name，value
        String sign = getSign();
        textMap.put("userid", weipuId);
        textMap.put("sign", sign);
        textMap.put("paperids", paperid);//资源id
        String contentType = "";//image/png
        Map<String, String> fileMap = new HashMap<String, String>();
        String ret = formUpload(url, textMap, fileMap,contentType);
        System.out.println("1--xfwbdKsjc------>"+ret);
        JSONObject object= JSONObject.parseObject(ret);
//        if("true".equals(object.getString("success"))){//返回值只有{"success":true,"message":"提交比对成功，资源开始比对..."}
//            String message = object.getString("message");
//            System.out.println("message----->"+message);
//        }else{
//            System.out.println("3--xfwbdKsjc------>");
//        }
        String message = object.getString("message");
        return message;
    }

    @Override
    public Map<String,String> aigcCxjcjg(BlZycc blZycc) {
        String url = "https://vims.fanyu.com/tool/AIGCCheck/searchPaper";
        //文件路径，文件存在，不存在的话需要先下载下来
        String paperid = blZycc.getPaperid();
        Map<String, String> textMap = new HashMap<String, String>();
        //可以设置多个input的name，value
        String sign = getSign();
        textMap.put("userid", weipuId);
        textMap.put("sign", sign);
        textMap.put("paperids", paperid);//资源id,可多个，用逗号分割
        String contentType = "";//image/png
        Map<String, String> fileMap = new HashMap<String, String>();
        String ret = formUpload(url, textMap, fileMap,contentType);
        System.out.println("1-------->"+ret);
        JSONObject object= JSONObject.parseObject(ret);
        if("true".equals(object.getString("success"))){
            //{"success":true,"message":"查询成功", "datalist":[{"dataid":568,"message":"","paperguid":"5c384d6bd69y9ba9","papertitle":"","filestateid":2,"paperword":1958,"percentage":0,"duplicatepercentage":0,"quotepercentage":0,"paichupercentage":0,"selfyypercentage":0,"ownpercentage":100,"authorpercentage":0,"checkdate":"2024-04-13 13:51:51","paperviewurl":"https://vims.fanyu.com/toole/smallcheck/getonlineurl?guid=5c384d6bd69y9ba9","paperdownurl":"https://vims.fanyu.com/toole/smallcheck/getdownloadurl?guid=5c384d6bd69y9ba9"}]}
            //filestateid 检测状态{0未检测,1检测中,2检测完成, 3检测失败}
            String listpaper = object.getString("listpaper");
            JSONArray jsonArray = (JSONArray) JSONArray.parse(listpaper);
            JSONObject object2= jsonArray.getJSONObject(0);
            String filestateid = object2.getString("filestateid");
            if(StringUtils.equals(filestateid,"0")){
                System.out.println(paperid+":未检测");
            }else if(StringUtils.equals(filestateid,"1")){
                System.out.println(paperid+":检测中");
            }else if(StringUtils.equals(filestateid,"2")){
                System.out.println(paperid+":检测完成");
            }else if(StringUtils.equals(filestateid,"3")){
                System.out.println(paperid+":检测失败；"+object2.getString("message"));
            }else{
                System.out.println(paperid+":当前状态："+filestateid+"；"+object2.getString("message"));
            }
            System.out.println("listpaper----->"+listpaper);//结果结合
            System.out.println("object2----->"+object2);//实际单挑数据结果
            Map<String,String> map = new HashMap<String,String>();


            map.put("paperguid",object2.getString("paperguid"));//报告编号
            map.put("papertitle",object2.getString("papertitle"));//论文标题
            map.put("filestateid",object2.getString("filestateid"));//检测状态0:未检测；1:检测中；2:检测完成；3:检测失败；
            map.put("checkdate",object2.getString("checkdate"));//检测时间
            map.put("paperword",object2.getString("paperword"));//论文字数
            map.put("aiRate",object2.getString("aiRate"));//疑似ai全文占比
            map.put("humanRate",object2.getString("humanRate"));//人工占比
            map.put("paperviewurl",object2.getString("paperviewurl"));//报告在线查看地址
            map.put("paperdownurl",object2.getString("paperdownurl"));//报告下载地址
            map.put("papermsg",object2.getString("papermsg"));//其他信息

//            map.put("duplicatepercentage",object2.getString("duplicatepercentage"));//复写率
//            map.put("paichupercentage",object2.getString("paichupercentage"));//他引率
//            map.put("ownpercentage",object2.getString("ownpercentage"));//自写率
//            map.put("percentage",object2.getString("percentage"));//相似率
//            map.put("quotepercentage",object2.getString("quotepercentage"));//引用率
//            map.put("selfyypercentage",object2.getString("selfyypercentage"));//自引率
//            map.put("authorpercentage",object2.getString("authorpercentage"));//专业术语率
            map.put("message",object.getString("message"));

            return map;
        }else{
            System.out.println("3-------->");
            Map<String,String> map = new HashMap<String,String>();
            map.put("success","false");
            map.put("message",object.getString("message"));
            return map;
        }
    }


    //生成sign
    public static String getSign() {
        String userid = weipuId;
        String key = weipuKey;
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH");
        String time = sdf.format( new Date());
        String md5Text = userid + key + time;
        String sign = org.springframework.util.DigestUtils.md5DigestAsHex((md5Text).getBytes()).toLowerCase();
        return sign;
    }

    /**
     * 上传图片
     * @param urlStr
     * @param textMap
     * @param fileMap
     * @param contentType 没有传入文件类型默认采用application/octet-stream
     * contentType非空采用filename匹配默认的图片类型
     * @return 返回response数据
     */
    @SuppressWarnings("rawtypes")
    public static String formUpload(String urlStr, Map<String, String> textMap,
                                    Map<String, String> fileMap,String contentType) {
        String res = "";
        HttpURLConnection conn = null;
        // boundary就是request头和上传文件内容的分隔符
        String BOUNDARY = "---------------------------123821742118716";
        try {
            URL url = new URL(urlStr);
            conn = (HttpURLConnection) url.openConnection();
            conn.setConnectTimeout(5000);
            conn.setReadTimeout(30000);
            conn.setDoOutput(true);
            conn.setDoInput(true);
            conn.setUseCaches(false);
            conn.setRequestMethod("POST");
            conn.setRequestProperty("Connection", "Keep-Alive");
            conn.setRequestProperty("Content-Type","multipart/form-data; boundary=" + BOUNDARY);
            OutputStream out = new DataOutputStream(conn.getOutputStream());
            // text
            if (textMap != null) {
                StringBuffer strBuf = new StringBuffer();
                Iterator iter = textMap.entrySet().iterator();
                while (iter.hasNext()) {
                    Map.Entry entry = (Map.Entry) iter.next();
                    String inputName = (String) entry.getKey();
                    String inputValue = (String) entry.getValue();
                    if (inputValue == null) {

                        continue;
                    }
                    strBuf.append("\r\n").append("--").append(BOUNDARY).append("\r\n");
                    strBuf.append("Content-Disposition: form-data; name=\"" + inputName + "\"\r\n\r\n");
                    strBuf.append(inputValue);
                }
                out.write(strBuf.toString().getBytes(StandardCharsets.UTF_8));
            }
            // file
            if (fileMap != null) {
                Iterator iter = fileMap.entrySet().iterator();
                while (iter.hasNext()) {
                    Map.Entry entry = (Map.Entry) iter.next();
                    String inputName = (String) entry.getKey();
                    String inputValue = (String) entry.getValue();
                    if (inputValue == null) {
                        continue;
                    }
                    File file = new File(inputValue);
                    String filename = file.getName();

                    //没有传入文件类型，同时根据文件获取不到类型，默认采用application/octet-stream
                    contentType = new MimetypesFileTypeMap().getContentType(file);
                    //contentType非空采用filename匹配默认的图片类型
                    if(!"".equals(contentType)){
                        if (filename.endsWith(".png")) {
                            contentType = "image/png";
                        }else if (filename.endsWith(".jpg") || filename.endsWith(".jpeg") || filename.endsWith(".jpe")) {
                            contentType = "image/jpeg";
                        }else if (filename.endsWith(".gif")) {
                            contentType = "image/gif";
                        }else if (filename.endsWith(".ico")) {
                            contentType = "image/image/x-icon";
                        }
                    }
                    if (contentType == null || "".equals(contentType)) {
                        contentType = "application/octet-stream";
                    }
                    StringBuffer strBuf = new StringBuffer();
                    strBuf.append("\r\n").append("--").append(BOUNDARY).append("\r\n");
                    strBuf.append("Content-Disposition: form-data; name=\"" + inputName + "\"; filename=\"" + filename + "\"\r\n");
                    strBuf.append("Content-Type:" + contentType + "\r\n\r\n");
                    out.write(strBuf.toString().getBytes());
                    DataInputStream in = new DataInputStream(new FileInputStream(file));
                    int bytes = 0;
                    byte[] bufferOut = new byte[1024];
                    while ((bytes = in.read(bufferOut)) != -1) {
                        out.write(bufferOut, 0, bytes);
                    }
                    in.close();
                }
            }
            byte[] endData = ("\r\n--" + BOUNDARY + "--\r\n").getBytes();
            out.write(endData);
            out.flush();
            out.close();
            // 读取返回数据
            StringBuffer strBuf = new StringBuffer();
            BufferedReader reader = new BufferedReader(new InputStreamReader(conn.getInputStream()));
            String line = null;
            while ((line = reader.readLine()) != null) {
                strBuf.append(line).append("\n");
            }
            res = strBuf.toString();
            reader.close();
            reader = null;
        } catch (Exception e) {
            System.out.println("发送POST请求出错。" + urlStr);
            e.printStackTrace();
        } finally {
            if (conn != null) {
                conn.disconnect();
                conn = null;
            }
        }
        return res;
    }
}
