package org.jeecg.modules.kc.config.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.google.common.collect.Maps;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.compress.utils.Lists;
import org.apache.commons.lang3.StringUtils;
import org.apache.shiro.SecurityUtils;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.jeecg.common.system.base.controller.JeecgController;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.system.vo.LoginUser;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.kc.config.entity.KcExportConfigTpkwcqkjzglx;
import org.jeecg.modules.kc.config.entity.KcExportConfigTpkwcqkjzglxXytktj;
import org.jeecg.modules.kc.config.export.Export;
import org.jeecg.modules.kc.config.service.IKcExportConfigTpkwcqkjzglxService;
import org.jeecg.modules.kc.grab.SynchronizationService.tools.ChangeTingKeTongJi;
import org.jeecg.modules.kc.grab.imports.entity.Xxhbuser;
import org.jeecg.modules.kc.grab.imports.service.IXxhbuserService;
import org.jeecg.modules.kc.kcSysConfig.entity.KcSysConfig;
import org.jeecg.modules.kc.kcSysConfig.service.IKcSysConfigService;
import org.jeecg.modules.kc.kcXqxnHistory.entity.KcXqxnHistory;
import org.jeecg.modules.kc.qa.entity.KcEvaluation;
import org.jeecg.modules.kc.qa.service.IKcEvaluationService;
import org.jeecg.modules.kc.tksf.kctkcstj.entity.KcTkcstj;
import org.jeecg.modules.kc.tksf.kctkcstj.service.IKcTkcstjService;
import org.jeecg.modules.tools.word.ExportWord;
import org.jeecg.modules.tools.word.WordOperator;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.*;
import java.util.stream.Collectors;

/**
 * @Description: kc_export_config_tpkwcqkjzglx
 * @Author: jeecg-boot
 * @Date:   2023-07-21
 * @Version: V1.0
 */
@Api(tags="kc_export_config_tpkwcqkjzglx")
@RestController
@RequestMapping("/config/kcExportConfigTpkwcqkjzglx")
@Slf4j
public class KcExportConfigTpkwcqkjzglxController extends JeecgController<KcExportConfigTpkwcqkjzglx, IKcExportConfigTpkwcqkjzglxService> {
	@Autowired
	private IKcExportConfigTpkwcqkjzglxService kcExportConfigTpkwcqkjzglxService;

	@Autowired
	private IXxhbuserService xxhbuserService;

	@Autowired
	private IKcTkcstjService kcTkcstjService;

	@Autowired
	private ChangeTingKeTongJi changeTingKeTongJi;

	@Autowired
	private IKcEvaluationService evaluationService;

	@Autowired
	private IKcSysConfigService kcSysConfigService;
	@Value("${jeecg.path.upload}")
	private String upLoadPath;

	@Autowired
	private IKcEvaluationService kcEvaluationService;

	/**
	 * 分页列表查询
	 *
	 * @param kcExportConfigTpkwcqkjzglx
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "kc_export_config_tpkwcqkjzglx-分页列表查询")
	@ApiOperation(value="kc_export_config_tpkwcqkjzglx-分页列表查询", notes="kc_export_config_tpkwcqkjzglx-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<KcExportConfigTpkwcqkjzglx>> queryPageList(KcExportConfigTpkwcqkjzglx kcExportConfigTpkwcqkjzglx,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<KcExportConfigTpkwcqkjzglx> queryWrapper = QueryGenerator.initQueryWrapper(kcExportConfigTpkwcqkjzglx, req.getParameterMap());
//		queryWrapper.eq(StringUtils.isNotBlank(kcExportConfigTpkwcqkjzglx.getDwmc()),"b.dwmc",kcExportConfigTpkwcqkjzglx.getDwmc());
		if(kcExportConfigTpkwcqkjzglx.isFindByDwmc()){
			QueryWrapper<Xxhbuser> uqw = new QueryWrapper<>();
			//LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
			uqw.eq("gh",kcExportConfigTpkwcqkjzglx.getFindGh());
			uqw.last("limit 1");
			Xxhbuser xxhbUser = xxhbuserService.getOne(uqw);
			if(xxhbUser == null) {
				return Result.OK(new Page<>());
			}
			queryWrapper.eq("dwmc ",xxhbUser.getDwmc());
		}
//		queryWrapper.eq("zt","在职");
//		queryWrapper.apply("dwmc in (select kkdw from kc_kkdw21_view)");
		Page<KcExportConfigTpkwcqkjzglx> page = new Page<>(pageNo, pageSize);
		IPage<KcExportConfigTpkwcqkjzglx> pageList = kcExportConfigTpkwcqkjzglxService.page(page, queryWrapper);

		Set<String> xqxnSet = pageList.getRecords().stream().filter(x -> StringUtils.isNotBlank(x.getXqxn())).map(KcExportConfigTpkwcqkjzglx::getXqxn).collect(Collectors.toSet());
		//根据当前学期学年，硬合并出来一个数据
		QueryWrapper<KcTkcstj> tjQw = new QueryWrapper<>();
//		KcXqxnHistory kcXqxnHistory = changeTingKeTongJi.getXqConfig(kcExportConfigTpkwcqkjzglx.getXqxn());
//		if(kcXqxnHistory == null){
//			return Result.OK(new Page<>());
//		}
//		tjQw.eq("xnxq",kcXqxnHistory.getTitle());
//		tjQw.eq("xnxq",kcExportConfigTpkwcqkjzglx.getXqxn());
		if(xqxnSet.isEmpty()){
			tjQw.eq("xnxq",-1);
		}else{
			tjQw.in("xnxq",xqxnSet);
		}
//		tjQw.like("jsxm",kcExportConfigTpkwcqkjzglx.getXm());
		List<KcTkcstj> tjList = kcTkcstjService.list(tjQw);
		Map<String,KcTkcstj> tjMap = Maps.newHashMap();
		tjList.forEach(x -> {
			tjMap.put(x.getXnxq() + "-" + x.getJgh(),x);
		});
//
//		pageList.getRecords().forEach(x -> {
//			x.setTkxttj("0");
//			x.setYskcs("0");
//			if(tjMap.containsKey(x.getXqxn() + "-" + x.getGh())){
//				KcTkcstj tkcstj = tjMap.get(x.getXqxn() + "-" + x.getGh());
//				x.setTkxttj(StringUtils.defaultString(tkcstj.getTkxttj(),"0"));
//				x.setYskcs(StringUtils.defaultString(tkcstj.getYskcs(),"0"));
//				//x.setXqxn(kcXqxnHistory.getTitle());
//			}
//		});

		QueryWrapper<KcEvaluation> evaluationQw = new QueryWrapper<>();
		evaluationQw.isNotNull("e.minkcid");
//		evaluationQw.apply("kt.skrq >= STR_TO_DATE('" + "' , '%Y-%m-%d' )");
//		evaluationQw.apply("kt.skrq <= STR_TO_DATE('" + "' , '%Y-%m-%d' )");

		if(xqxnSet.isEmpty()){
			evaluationQw.eq("kt.xnxq",-1);
		}else{
			evaluationQw.in("kt.xnxq",xqxnSet);
		}
		evaluationQw.eq("upuser",kcExportConfigTpkwcqkjzglx.getXm());

		evaluationQw.groupBy("concat(xnxq,'-',upuserid)");
		evaluationQw.orderByDesc("kt.skrq");

		List<KcEvaluation> tjEvaList = evaluationService.findTj(evaluationQw);
		Map<String,KcEvaluation> tjEvaMap = Maps.newHashMap();
		tjEvaList.forEach(x -> {
			tjEvaMap.put(x.getXnxq() + "-" + x.getUpuserid(),x);
		});

		pageList.getRecords().forEach(x -> {
			x.setTkxttj("0");
			x.setYskcs("0");
			if(tjMap.containsKey(x.getXqxn() + "-" + x.getGh())){
				KcTkcstj tkcstj = tjMap.get(x.getXqxn() + "-" + x.getGh());
//				x.setTkxttj(StringUtils.defaultString(tkcstj.getTkxttj(),"0"));
				x.setYskcs(StringUtils.defaultString(tkcstj.getYskcs(),"0"));
				//x.setXqxn(kcXqxnHistory.getTitle());
			}
			if(tjEvaMap.containsKey(x.getXqxn() + "-" + x.getGh())){
				KcEvaluation tkcstj = tjEvaMap.get(x.getXqxn() + "-" + x.getGh());
//				x.setTkxttj(StringUtils.defaultString(tkcstj.getTkxttj(),"0"));
				x.setTkxttj(StringUtils.defaultString(String.valueOf(tkcstj.getPkNum()),"0"));
				//x.setXqxn(kcXqxnHistory.getTitle());
			}
		});



		return Result.OK(pageList);
	}



	@ApiOperation(value="kc_export_config_tpkwcqkjzglx-分页列表查询", notes="kc_export_config_tpkwcqkjzglx-分页列表查询")
	@GetMapping(value = "/list2")
	public Result<IPage<KcExportConfigTpkwcqkjzglx>> queryPageList2(KcExportConfigTpkwcqkjzglx kcExportConfigTpkwcqkjzglx,
																   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
																   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
																   HttpServletRequest req) {
		QueryWrapper<KcExportConfigTpkwcqkjzglx> queryWrapper = QueryGenerator.initQueryWrapper(kcExportConfigTpkwcqkjzglx, req.getParameterMap());
		if(kcExportConfigTpkwcqkjzglx.isFindByDwmc()){
			QueryWrapper<Xxhbuser> uqw = new QueryWrapper<>();
			uqw.eq("gh",kcExportConfigTpkwcqkjzglx.getFindGh());
			uqw.last("limit 1");
			Xxhbuser xxhbUser = xxhbuserService.getOne(uqw);
			if(xxhbUser == null) {
				return Result.OK(new Page<>());
			}
			queryWrapper.eq("dwmc ",xxhbUser.getDwmc());
		}
		queryWrapper.apply("(zt = '在职' )");
//		queryWrapper.eq("zt","在职");
//		queryWrapper.apply("(zt = '在职' or ( ytkcs-0 >0))");
//		queryWrapper.apply("dwmc in (select kkdw from kc_kkdw21_view)");
		Page<KcExportConfigTpkwcqkjzglx> page = new Page<>(pageNo, pageSize);
		IPage<KcExportConfigTpkwcqkjzglx> pageList = kcExportConfigTpkwcqkjzglxService.page(page, queryWrapper);

		Set<String> xqxnSet = pageList.getRecords().stream().filter(x -> StringUtils.isNotBlank(x.getXqxn())).map(KcExportConfigTpkwcqkjzglx::getXqxn).collect(Collectors.toSet());
		//根据当前学期学年，硬合并出来一个数据
		QueryWrapper<KcTkcstj> tjQw = new QueryWrapper<>();
		if(xqxnSet.isEmpty()){
			tjQw.eq("xnxq",-1);
		}else{
			tjQw.in("xnxq",xqxnSet);
		}
		List<KcTkcstj> tjList = kcTkcstjService.list(tjQw);
		Map<String,KcTkcstj> tjMap = Maps.newHashMap();
		tjList.forEach(x -> {
			tjMap.put(x.getXnxq() + "-" + x.getJgh(),x);
		});

		QueryWrapper<KcEvaluation> evaluationQw = new QueryWrapper<>();
		evaluationQw.isNotNull("e.minkcid");

		if(xqxnSet.isEmpty()){
			evaluationQw.eq("kt.xnxq",-1);
		}else{
			evaluationQw.in("kt.xnxq",xqxnSet);
		}
		if(StringUtils.isNotBlank(kcExportConfigTpkwcqkjzglx.getXm())){
			String userName = kcExportConfigTpkwcqkjzglx.getXm().substring(1,kcExportConfigTpkwcqkjzglx.getXm().length()-1);
			evaluationQw.like("upuser",userName);
		}
		evaluationQw.groupBy("concat(xnxq,'-',upuserid)");
		evaluationQw.orderByDesc("kt.skrq");

		List<KcEvaluation> tjEvaList = evaluationService.findTj(evaluationQw);
		Map<String,KcEvaluation> tjEvaMap = Maps.newHashMap();
		tjEvaList.forEach(x -> {
			tjEvaMap.put(x.getXnxq() + "-" + x.getUpuserid(),x);
		});

		pageList.getRecords().forEach(x -> {
			x.setTkxttj("0");
			x.setYskcs("0");
			if(tjMap.containsKey(x.getXqxn() + "-" + x.getGh())){
				KcTkcstj tkcstj = tjMap.get(x.getXqxn() + "-" + x.getGh());
				x.setYskcs(StringUtils.defaultString(tkcstj.getYskcs(),"0"));
			}
			if(tjEvaMap.containsKey(x.getXqxn() + "-" + x.getGh())){
				KcEvaluation tkcstj = tjEvaMap.get(x.getXqxn() + "-" + x.getGh());
				x.setTkxttj(StringUtils.defaultString(String.valueOf(tkcstj.getPkNum()),"0"));
			}
		});



		return Result.OK(pageList);
	}



	@ApiOperation(value="kc_export_config_tpkwcqkjzglx-分页列表查询", notes="kc_export_config_tpkwcqkjzglx-分页列表查询")
	@GetMapping(value = "/list3")
	public Result<IPage<KcExportConfigTpkwcqkjzglx>> list3(KcExportConfigTpkwcqkjzglx kcExportConfigTpkwcqkjzglx,
																	@RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
																	@RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
																	HttpServletRequest req) {
		QueryWrapper<KcExportConfigTpkwcqkjzglx> queryWrapper = QueryGenerator.initQueryWrapper(kcExportConfigTpkwcqkjzglx, req.getParameterMap());
		queryWrapper.apply("(zt = '在职' )");
		Page<KcExportConfigTpkwcqkjzglx> page = new Page<>(pageNo, pageSize);
		IPage<KcExportConfigTpkwcqkjzglx> pageList = kcExportConfigTpkwcqkjzglxService.list3(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param kcExportConfigTpkwcqkjzglx
	 * @return
	 */
	@AutoLog(value = "kc_export_config_tpkwcqkjzglx-添加")
	@ApiOperation(value="kc_export_config_tpkwcqkjzglx-添加", notes="kc_export_config_tpkwcqkjzglx-添加")
//	@RequiresPermissions("config:kc_export_config_tpkwcqkjzglx:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody KcExportConfigTpkwcqkjzglx kcExportConfigTpkwcqkjzglx) {
		//新增学期学年
		//按学期筛选
		KcXqxnHistory common = changeTingKeTongJi.getXqConfig();
		String xqxn;
		if(common != null) {
			//Map<String, KcTkcstj> tongJiMap = Maps.newHashMap();
			//清洗数据核心
//			Date startSjDate = common.getStartTime();
//			Date endSjDate = common.getEndTime();
//            String startSj = DateUtil.format(startSjDate,DatePattern.NORM_DATETIME_FORMAT);
//            String endSj = DateUtil.format(endSjDate,DatePattern.NORM_DATETIME_FORMAT);
			xqxn = common.getTitle();
		} else {
			xqxn = null;
		}
		kcExportConfigTpkwcqkjzglx.setXqxn(xqxn);
		kcExportConfigTpkwcqkjzglxService.save(kcExportConfigTpkwcqkjzglx);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param kcExportConfigTpkwcqkjzglx
	 * @return
	 */
	@AutoLog(value = "kc_export_config_tpkwcqkjzglx-编辑")
	@ApiOperation(value="kc_export_config_tpkwcqkjzglx-编辑", notes="kc_export_config_tpkwcqkjzglx-编辑")
//	@RequiresPermissions("config:kc_export_config_tpkwcqkjzglx:edit")
	@RequestMapping(value = "/editAll", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> editAll(@RequestBody KcExportConfigTpkwcqkjzglx kcExportConfigTpkwcqkjzglx) {
		kcExportConfigTpkwcqkjzglxService.editAll(kcExportConfigTpkwcqkjzglx);
		return Result.OK("编辑成功!");
	}

	/**
	 *  编辑
	 *
	 * @param kcExportConfigTpkwcqkjzglx
	 * @return
	 */
	@AutoLog(value = "kc_export_config_tpkwcqkjzglx-编辑")
	@ApiOperation(value="kc_export_config_tpkwcqkjzglx-编辑", notes="kc_export_config_tpkwcqkjzglx-编辑")
//	@RequiresPermissions("config:kc_export_config_tpkwcqkjzglx:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody KcExportConfigTpkwcqkjzglx kcExportConfigTpkwcqkjzglx) {
		kcExportConfigTpkwcqkjzglxService.updateById(kcExportConfigTpkwcqkjzglx);
		return Result.OK("编辑成功!");
	}

	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "kc_export_config_tpkwcqkjzglx-通过id删除")
	@ApiOperation(value="kc_export_config_tpkwcqkjzglx-通过id删除", notes="kc_export_config_tpkwcqkjzglx-通过id删除")
//	@RequiresPermissions("config:kc_export_config_tpkwcqkjzglx:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		kcExportConfigTpkwcqkjzglxService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "kc_export_config_tpkwcqkjzglx-批量删除")
	@ApiOperation(value="kc_export_config_tpkwcqkjzglx-批量删除", notes="kc_export_config_tpkwcqkjzglx-批量删除")
//	@RequiresPermissions("config:kc_export_config_tpkwcqkjzglx:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.kcExportConfigTpkwcqkjzglxService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "kc_export_config_tpkwcqkjzglx-通过id查询")
	@ApiOperation(value="kc_export_config_tpkwcqkjzglx-通过id查询", notes="kc_export_config_tpkwcqkjzglx-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<KcExportConfigTpkwcqkjzglx> queryById(@RequestParam(name="id",required=true) String id) {
		KcExportConfigTpkwcqkjzglx kcExportConfigTpkwcqkjzglx = kcExportConfigTpkwcqkjzglxService.getById(id);
		if(kcExportConfigTpkwcqkjzglx==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(kcExportConfigTpkwcqkjzglx);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param kcExportConfigTpkwcqkjzglx
    */
//    @RequiresPermissions("config:kc_export_config_tpkwcqkjzglx:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, KcExportConfigTpkwcqkjzglx kcExportConfigTpkwcqkjzglx) {
        return exportXls(request, kcExportConfigTpkwcqkjzglx, KcExportConfigTpkwcqkjzglx.class, "人员信息");
    }

	@RequestMapping(value = "/exportXls3")
	public ModelAndView exportXls3(HttpServletRequest request, KcExportConfigTpkwcqkjzglx kcExportConfigTpkwcqkjzglx) {
		return exportXls3(request, kcExportConfigTpkwcqkjzglx, KcExportConfigTpkwcqkjzglx.class, "人员信息");
	}
	public ModelAndView exportXls(HttpServletRequest request, KcExportConfigTpkwcqkjzglx object, Class<KcExportConfigTpkwcqkjzglx> clazz, String title) {
		// Step.1 组装查询条件
		QueryWrapper<KcExportConfigTpkwcqkjzglx> queryWrapper = QueryGenerator.initQueryWrapper(object, request.getParameterMap());
		LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
		if(object.isFindByDwmc()){
			QueryWrapper<Xxhbuser> uqw = new QueryWrapper<>();
			//LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
			uqw.eq("gh",object.getFindGh());
			uqw.last("limit 1");
			Xxhbuser xxhbUser = xxhbuserService.getOne(uqw);
			if(xxhbUser == null) {
				queryWrapper.eq("dwmc ",-1);
			}
			queryWrapper.eq("dwmc ",xxhbUser.getDwmc());
		}
		// 过滤选中数据
		String selections = request.getParameter("selections");
		if (oConvertUtils.isNotEmpty(selections)) {
			List<String> selectionList = Arrays.asList(selections.split(","));
			queryWrapper.in("id",selectionList);
		}
//		queryWrapper.eq("zt","在职");
		queryWrapper.apply("(zt = '在职')");
		queryWrapper.apply("dwmc in (select kkdw from kc_kkdw21_view)");
		// Step.2 获取导出数据
		List<KcExportConfigTpkwcqkjzglx> exportList = service.list(queryWrapper);

		Set<String> xqxnSet = exportList.stream().filter(x -> StringUtils.isNotBlank(x.getXqxn())).map(KcExportConfigTpkwcqkjzglx::getXqxn).collect(Collectors.toSet());
		//根据当前学期学年，硬合并出来一个数据
		QueryWrapper<KcTkcstj> tjQw = new QueryWrapper<>();
		if(xqxnSet.isEmpty()){
			tjQw.eq("xnxq",-1);
		}else{
			tjQw.in("xnxq",xqxnSet);
		}
		List<KcTkcstj> tjList = kcTkcstjService.list(tjQw);
		Map<String,KcTkcstj> tjMap = Maps.newHashMap();
		tjList.forEach(x -> {
			tjMap.put(x.getXnxq() + "-" + x.getJgh(),x);
		});

		//根据当前学期学年，硬合并出来一个数据
		exportList.forEach(x -> {
			x.setTkxttj("0");
			x.setYskcs("0");
			if(tjMap.containsKey(x.getXqxn() + "-" + x.getGh())){
				KcTkcstj tkcstj = tjMap.get(x.getXqxn() + "-" + x.getGh());
				x.setTkxttj(StringUtils.defaultString(tkcstj.getTkxttj(),"0"));
				x.setYskcs(StringUtils.defaultString(tkcstj.getYskcs(),"0"));
				//x.setXqxn(kcXqxnHistory.getTitle());
			}
		});
		// Step.3 AutoPoi 导出Excel
		ModelAndView mv = new ModelAndView(new JeecgEntityExcelView());
		//此处设置的filename无效 ,前端会重更新设置一下
		mv.addObject(NormalExcelConstants.FILE_NAME, title);
		mv.addObject(NormalExcelConstants.CLASS, clazz);
		//update-begin--Author:liusq  Date:20210126 for：图片导出报错，ImageBasePath未设置--------------------
		ExportParams exportParams=new ExportParams(title + "报表", "导出人:" + sysUser.getRealname(), title);
		exportParams.setImageBasePath(upLoadPath);
		//update-end--Author:liusq  Date:20210126 for：图片导出报错，ImageBasePath未设置----------------------
		mv.addObject(NormalExcelConstants.PARAMS,exportParams);
		mv.addObject(NormalExcelConstants.DATA_LIST, exportList);
		return mv;
	}
	public ModelAndView exportXls3(HttpServletRequest request, KcExportConfigTpkwcqkjzglx object, Class<KcExportConfigTpkwcqkjzglx> clazz, String title) {
		// Step.1 组装查询条件
		QueryWrapper<KcExportConfigTpkwcqkjzglx> queryWrapper = QueryGenerator.initQueryWrapper(object, request.getParameterMap());
		LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
		if(object.isFindByDwmc()){
			QueryWrapper<Xxhbuser> uqw = new QueryWrapper<>();
			//LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
			uqw.eq("gh",object.getFindGh());
			uqw.last("limit 1");
			Xxhbuser xxhbUser = xxhbuserService.getOne(uqw);
			if(xxhbUser == null) {
				queryWrapper.eq("dwmc ",-1);
			}
			queryWrapper.eq("dwmc ",xxhbUser.getDwmc());
		}
		queryWrapper.apply("(zt = '在职' )");
		// 过滤选中数据
		String selections = request.getParameter("selections");
		if (oConvertUtils.isNotEmpty(selections)) {
			List<String> selectionList = Arrays.asList(selections.split(","));
			queryWrapper.in("id",selectionList);
		}
//		queryWrapper.eq("zt","在职");
//		queryWrapper.apply("(zt = '在职' or ( ytkcs-0 >0))");
//		queryWrapper.apply("dwmc in (select kkdw from kc_kkdw21_view)");
		// Step.2 获取导出数据
		queryWrapper.groupBy("gh,xm");
		List<KcExportConfigTpkwcqkjzglx> exportList = service.groupTklxList(queryWrapper);

		Set<String> xqxnSet = exportList.stream().filter(x -> StringUtils.isNotBlank(x.getXqxn())).map(KcExportConfigTpkwcqkjzglx::getXqxn).collect(Collectors.toSet());
		//根据当前学期学年，硬合并出来一个数据
		QueryWrapper<KcTkcstj> tjQw = new QueryWrapper<>();
		if(xqxnSet.isEmpty()){
			tjQw.eq("xnxq",-1);
		}else{
			tjQw.in("xnxq",xqxnSet);
		}
		List<KcTkcstj> tjList = kcTkcstjService.list(tjQw);
		Map<String,KcTkcstj> tjMap = Maps.newHashMap();
		tjList.forEach(x -> {
			tjMap.put(x.getXnxq() + "-" + x.getJgh(),x);
		});

		//------------评课统计---2024-02-29新增的-------------------
		QueryWrapper<KcEvaluation> kcEvaluationQueryWrapper = new QueryWrapper<>();
		kcEvaluationQueryWrapper.eq("xqxn",object.getXqxn());
		kcEvaluationQueryWrapper.eq(StringUtils.isNotBlank(object.getDwmc()),"dwmc",object.getDwmc());
		kcEvaluationQueryWrapper.apply("(zt = '在职' )");
		kcEvaluationQueryWrapper.groupBy("a.gh,a.tklx");

//		where xqxn = #{xqxn} and (zt = '在职' or ( ytkcs-0 >0))
//				<if test="code != null">
//				and tklx in (${code})
//        </if>
//        <if test="dwmc != null and dwmc != ''">
//				and dwmc = #{dwmc}
//        </if>
//		GROUP BY a.tklx,a.gh,a.xm,a.dwmc,a.ytkcs,a.rjzy

		List<KcEvaluation> pktjList = kcEvaluationService.findTkcsTj(kcEvaluationQueryWrapper);
		Map<String,KcEvaluation> pktjMap = Maps.newHashMap();
		pktjList.forEach(x -> {
			pktjMap.put(x.getXnxq() + "-" + x.getUpuserid(),x);
		});
		//------------评课统计---2024-02-29新增的-------------------

		//根据当前学期学年，硬合并出来一个数据
		exportList.forEach(x -> {
			x.setTkxttj("0");
			x.setYskcs("0");
			if(tjMap.containsKey(x.getXqxn() + "-" + x.getGh())){
				KcTkcstj tkcstj = tjMap.get(x.getXqxn() + "-" + x.getGh());
//				x.setTkxttj(StringUtils.defaultString(tkcstj.getTkxttj(),"0"));
				x.setYskcs(StringUtils.defaultString(tkcstj.getYskcs(),"0"));
				//x.setXqxn(kcXqxnHistory.getTitle());
			}
			//------------评课统计---2024-02-29新增的-------------------
			if(pktjMap.containsKey(x.getXqxn() + "-" + x.getGh())){
				KcEvaluation pkcstj = pktjMap.get(x.getXqxn() + "-" + x.getGh());
				x.setTkxttj(StringUtils.defaultString(pkcstj.getPkNum()+"","0"));
			}
			//------------评课统计---2024-02-29新增的-------------------
		});

		// Step.3 AutoPoi 导出Excel
		ModelAndView mv = new ModelAndView(new JeecgEntityExcelView());
		//此处设置的filename无效 ,前端会重更新设置一下
		mv.addObject(NormalExcelConstants.FILE_NAME, title);
		mv.addObject(NormalExcelConstants.CLASS, clazz);
		//update-begin--Author:liusq  Date:20210126 for：图片导出报错，ImageBasePath未设置--------------------
		ExportParams exportParams=new ExportParams(title + "报表", "导出人:" + sysUser.getRealname(), title);
		exportParams.setImageBasePath(upLoadPath);
		//update-end--Author:liusq  Date:20210126 for：图片导出报错，ImageBasePath未设置----------------------
		mv.addObject(NormalExcelConstants.PARAMS,exportParams);
		mv.addObject(NormalExcelConstants.DATA_LIST, exportList);
		return mv;
	}

	/**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("config:kc_export_config_tpkwcqkjzglx:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, KcExportConfigTpkwcqkjzglx.class);
    }

	 /**
	  * 导出word
	  *
	  * @param xqxnParam
	  * @param request
	  * @param response
	  */
//	 @RequiresPermissions("config:kc_export_config_tpkwcqkjzglx:exportXls")
	 @RequestMapping(value = "/exportWord")
	 public void exportWord(KcExportConfigTpkwcqkjzglx kcExportConfigTpkwcqkjzglx, String xqxnParam, HttpServletRequest request, HttpServletResponse response) throws Exception {
		Export export = new Export();
		WordOperator wo = export.export(kcExportConfigTpkwcqkjzglx, kcExportConfigTpkwcqkjzglx.getXqxn());
		ExportWord.download_word(request, response, "file.doc", wo);
	 }

	 /**
	  * 导出word
	  *
	  * @param xqxnParam
	  * @param request
	  * @param response
	  */
//	 @RequiresPermissions("config:kc_export_config_tpkwcqkjzglx:exportXls")
	 @RequestMapping(value = "/exportPdf")
	 public void exportPdf(KcExportConfigTpkwcqkjzglx kcExportConfigTpkwcqkjzglx, String xqxnParam, HttpServletRequest request, HttpServletResponse response) throws Exception {
		 Export export = new Export();
		 WordOperator wo = export.export(kcExportConfigTpkwcqkjzglx, kcExportConfigTpkwcqkjzglx.getXqxn());
		 ExportWord.download_pdf(request, response, "file", wo);
	 }



	@ApiOperation(value="获取听课要求次数", notes="获取听课要求次数")
	@GetMapping(value = "/queryTkyqPageList")
	public Result<IPage<KcExportConfigTpkwcqkjzglx>> queryTkyqPageList(KcExportConfigTpkwcqkjzglx kcExportConfigTpkwcqkjzglx,
																   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
																   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
																   HttpServletRequest req) {
		QueryWrapper<KcExportConfigTpkwcqkjzglx> queryWrapper = QueryGenerator.initQueryWrapper(kcExportConfigTpkwcqkjzglx, req.getParameterMap());

		KcSysConfig kcSysConfig = kcSysConfigService.getById("1");
		queryWrapper.eq("a.xqxn",kcSysConfig.getFlag1());
		queryWrapper.apply("a.tklx is not null");
		queryWrapper.groupBy("a.tklx,b.item_text,a.xqxn");
		Page<KcExportConfigTpkwcqkjzglx> page = new Page<>(pageNo, pageSize);
		IPage<KcExportConfigTpkwcqkjzglx> pageList = kcExportConfigTpkwcqkjzglxService.queryTkyqPageList(page, queryWrapper);

		return Result.OK(pageList);
	}

	@GetMapping(value = "/queryByGh")
	public Result<KcExportConfigTpkwcqkjzglx> queryByGh(@RequestParam(name="gh",required=true) String gh) {
		KcExportConfigTpkwcqkjzglx kcExportConfigTpkwcqkjzglx = kcExportConfigTpkwcqkjzglxService.getByGh(gh);
		if(kcExportConfigTpkwcqkjzglx==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(kcExportConfigTpkwcqkjzglx);
	}

	@GetMapping(value = "/queryBytklx")
	public Result<KcExportConfigTpkwcqkjzglx> queryBytklx(@RequestParam(name="tklx",required=true) String tklx) {
		KcExportConfigTpkwcqkjzglx kcExportConfigTpkwcqkjzglx = kcExportConfigTpkwcqkjzglxService.queryBytklx(tklx);
		if(kcExportConfigTpkwcqkjzglx==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(kcExportConfigTpkwcqkjzglx);
	}




	@ApiOperation(value="听课人员统计图表", notes="听课人员统计图表")
	@GetMapping(value = "/getTjlist")
	public Result<List<Map<String, Object>>> getTjlist(KcExportConfigTpkwcqkjzglx kcExportConfigTpkwcqkjzglx,HttpServletRequest req) {
		List<Map<String, Object>> pageList = kcExportConfigTpkwcqkjzglxService.getTjlist(kcExportConfigTpkwcqkjzglx);
		return Result.OK(pageList);
	}


	@ApiOperation(value="kc_export_config_tpkwcqkjzglx-分页列表查询", notes="kc_export_config_tpkwcqkjzglx-分页列表查询")
	@GetMapping(value = "/getListByCode")
	public Result<IPage<KcExportConfigTpkwcqkjzglx>> getListByCode(KcExportConfigTpkwcqkjzglx kcExportConfigTpkwcqkjzglx,
																   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
																   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
																   HttpServletRequest req) {
		Page<KcExportConfigTpkwcqkjzglx> page = new Page<>(pageNo, pageSize);
		IPage<KcExportConfigTpkwcqkjzglx> pageList = kcExportConfigTpkwcqkjzglxService.getListByCode(page, kcExportConfigTpkwcqkjzglx);
		return Result.OK(pageList);
	}

	@ApiOperation(value="听课人员统计图表", notes="听课人员统计图表")
	@GetMapping(value = "/getBarlist")
	public Result<?> getBarlist(KcExportConfigTpkwcqkjzglx kcExportConfigTpkwcqkjzglx,HttpServletRequest req) {
		List<KcExportConfigTpkwcqkjzglx> pageList = kcExportConfigTpkwcqkjzglxService.getBarlist(kcExportConfigTpkwcqkjzglx);
		return Result.OK(pageList);
	}


	@ApiOperation(value="获取其他专任教书数据", notes="获取其他专任教书数据")
	@GetMapping(value = "/getListQtzrjs")
	public Result<IPage<KcExportConfigTpkwcqkjzglx>> getListQtzrjs(KcExportConfigTpkwcqkjzglx kcExportConfigTpkwcqkjzglx,
																   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
																   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
																   HttpServletRequest req) {
		Page<KcExportConfigTpkwcqkjzglx> page = new Page<>(pageNo, pageSize);
		IPage<KcExportConfigTpkwcqkjzglx> pageList = kcExportConfigTpkwcqkjzglxService.getListQtzrjs(page, kcExportConfigTpkwcqkjzglx);
		return Result.OK(pageList);
	}
	@ApiOperation(value="获取其他专任教书数据", notes="获取其他专任教书数据")
	@GetMapping(value = "/getListQtzrjsChar")
	public  Result<?> getListQtzrjsChar(KcExportConfigTpkwcqkjzglx kcExportConfigTpkwcqkjzglx, HttpServletRequest req) {
		List<KcExportConfigTpkwcqkjzglx> pageList = kcExportConfigTpkwcqkjzglxService.getListQtzrjsChar(kcExportConfigTpkwcqkjzglx);
		return Result.OK(pageList);
	}


	@RequestMapping(value = "/exportXls2")
	public ModelAndView exportXls2(HttpServletRequest request, KcExportConfigTpkwcqkjzglxXytktj kcExportConfigTpkwcqkjzglx) {
		return exportXls2(request, kcExportConfigTpkwcqkjzglx, KcExportConfigTpkwcqkjzglxXytktj.class, "人员信息");
	}

	public ModelAndView exportXls2(HttpServletRequest request, KcExportConfigTpkwcqkjzglxXytktj object, Class<KcExportConfigTpkwcqkjzglxXytktj> clazz, String title) {
		// Step.1 组装查询条件
		QueryWrapper<KcExportConfigTpkwcqkjzglxXytktj> queryWrapper = QueryGenerator.initQueryWrapper(object, request.getParameterMap());
		LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
		List<KcExportConfigTpkwcqkjzglxXytktj> exportList = service.getListByCodeXytktj(queryWrapper,object);

		// Step.3 AutoPoi 导出Excel
		ModelAndView mv = new ModelAndView(new JeecgEntityExcelView());
		//此处设置的filename无效 ,前端会重更新设置一下
		mv.addObject(NormalExcelConstants.FILE_NAME, title);
		mv.addObject(NormalExcelConstants.CLASS, clazz);
		//update-begin--Author:liusq  Date:20210126 for：图片导出报错，ImageBasePath未设置--------------------
		ExportParams exportParams=new ExportParams(title + "报表", "导出人:" + sysUser.getRealname(), title);
		exportParams.setImageBasePath(upLoadPath);
		//update-end--Author:liusq  Date:20210126 for：图片导出报错，ImageBasePath未设置----------------------
		mv.addObject(NormalExcelConstants.PARAMS,exportParams);
		mv.addObject(NormalExcelConstants.DATA_LIST, exportList);
		return mv;
	}



	@AutoLog(value = "根据gh获取教职工信息")
	@ApiOperation(value="根据gh获取教职工信息", notes="根据gh获取教职工信息")
	@RequestMapping(value = "/getTeacherInfo", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<KcExportConfigTpkwcqkjzglx> getTeacherInfo(@RequestBody KcExportConfigTpkwcqkjzglx kcExportConfigTpkwcqkjzglx) {
		QueryWrapper<KcExportConfigTpkwcqkjzglx> queryWrapper = new QueryWrapper<KcExportConfigTpkwcqkjzglx>();
		queryWrapper.eq("gh", kcExportConfigTpkwcqkjzglx.getGh());
		queryWrapper.last("limit 1");
		kcExportConfigTpkwcqkjzglx = kcExportConfigTpkwcqkjzglxService.getOne(queryWrapper);
		return Result.OK(kcExportConfigTpkwcqkjzglx);
	}

}
