package org.jeecg.modules.kc.config.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.jeecg.common.aspect.annotation.Dict;
import org.jeecgframework.poi.excel.annotation.Excel;
import org.springframework.format.annotation.DateTimeFormat;

import java.io.Serializable;
import java.util.Date;

/**
 * @Description: kc_export_config_tpkwcqkjzglx
 * @Author: jeecg-boot
 * @Date:   2023-07-21
 * @Version: V1.0
 */
@Data
@Accessors(chain = true)
@EqualsAndHashCode(callSuper = false)
@ApiModel(value="人员信息", description="人员信息")
public class KcExportConfigTpkwcqkjzglxXytktj implements Serializable {
    private static final long serialVersionUID = 1L;

	/**id*/
	@TableId(type = IdType.ASSIGN_ID)
    @ApiModelProperty(value = "id")
    private String id;
	/**创建人*/
    @ApiModelProperty(value = "创建人")
    private String createBy;
	/**创建日期*/
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd")
    @DateTimeFormat(pattern="yyyy-MM-dd")
    @ApiModelProperty(value = "创建日期")
    private Date createTime;
	/**更新人*/
    @ApiModelProperty(value = "更新人")
    private String updateBy;
	/**更新日期*/
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd")
    @DateTimeFormat(pattern="yyyy-MM-dd")
    @ApiModelProperty(value = "更新日期")
    private Date updateTime;
	/**所属部门*/
    @ApiModelProperty(value = "所属部门")
    private String sysOrgCode;


	/**学期学年*/
	@ApiModelProperty(value = "学年学期")
	private String xqxn;

    /**学院*/
    @Excel(name = "学院名称", width = 15)
    @ApiModelProperty(value = "学院")
    private String dwmc;
	/**工号*/
    @ApiModelProperty(value = "工号")
    private String gh;
	/**姓名*/
	@Excel(name = "教师姓名", width = 15)
	@ApiModelProperty(value = "姓名")
	private String xm;
	/**听课类型（字典：tpkwcqkjzglx）*/
	@Dict(dicCode = "tpkwcqkjzglx")
    @ApiModelProperty(value = "听课类型（字典：tpkwcqkjzglx）")
    private String tklx;

    /**身份*/
    @ApiModelProperty(value = "身份")
    private String sf;

    /**任教专业*/
    @ApiModelProperty(value = "任教专业")
    private String rjzy;
    /**状态*/
    @ApiModelProperty(value = "状态")
    private String zt;
    /**每学期应听课次数*/
//    @Excel(name = "每学期应听课次数", width = 20)
    @Excel(name = "本学期应听课次数", width = 30)
    @ApiModelProperty(value = "每学期应听课次数")
    private String ytkcs;

    @TableField(exist = false)
    private String zwmc;

    /**本学期应听课次数*/
    @TableField(exist = false)
    private String yskcs;
    /**本学期已听课次数*/
    @TableField(exist = false)
    private String tkxttj;

	/**
	 * 按当前用户的部门查询评课
	 */
	@TableField(exist = false)
	private boolean findByDwmc;

	@TableField(exist = false)
	private String findGh;


    @TableField(exist = false)
    private String znum;
    @TableField(exist = false)
    @Excel(name = "本学期实际听课次数", width = 30)
    private String sjtkcs;
    @TableField(exist = false)
    private String code;
    @TableField(exist = false)
    private String type;


}
