package org.jeecg.modules.kc.config.export;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.beust.jcommander.internal.Sets;
import com.google.common.collect.Lists;
import com.google.common.collect.Maps;
import lombok.Data;
import org.apache.commons.lang3.StringUtils;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.system.vo.DictModel;
import org.jeecg.common.util.SpringContextHolder;
import org.jeecg.modules.kc.config.entity.KcExportConfigTpkwcqkjzglx;
import org.jeecg.modules.kc.config.service.IKcExportConfigTpkwcqkjzglxService;
import org.jeecg.modules.kc.grab.SynchronizationService.tools.ChangeTingKeTongJi;
import org.jeecg.modules.kc.grab.imports.entity.Xxhbuser;
import org.jeecg.modules.kc.grab.imports.service.IXxhbuserService;
import org.jeecg.modules.kc.kcXqxnHistory.entity.KcXqxnHistory;
import org.jeecg.modules.kc.kcZwtksfInfo.entity.KcZwtksfInfo;
import org.jeecg.modules.kc.kcZwtksfInfo.service.IKcZwtksfInfoService;
import org.jeecg.modules.kc.tksf.kctkcstj.entity.KcTkcstj;
import org.jeecg.modules.kc.tksf.kctkcstj.service.IKcTkcstjService;
import org.jeecg.modules.system.service.ISysDictService;
import org.jeecg.modules.tools.DictUtils;
import org.jeecg.modules.tools.word.BaseExport;
import org.jeecg.modules.tools.word.ExportWord;
import org.jeecg.modules.tools.word.WordOperator;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.stream.Collectors;


/**
* 功能说明：导出封装
* 创建者：byx
* 创建时间：2021-6-30
* <pre>
* 修改时间:       修改者:            
* 修改内容：
* </pre>
*/
public class Export extends BaseExport {
	
	private Logger logger = LoggerFactory.getLogger(this.getClass());
	
	//由于前面调用使用的是new，所以只能手动注入bean
	//字典
	private ISysDictService sysDictService = SpringContextHolder.getBean(ISysDictService.class);

	private IKcExportConfigTpkwcqkjzglxService kcExportConfigTpkwcqkjzglxService = SpringContextHolder.getBean(IKcExportConfigTpkwcqkjzglxService.class);

	private IXxhbuserService xxhbuserService = SpringContextHolder.getBean(IXxhbuserService.class);

	private IKcTkcstjService kcTkcstjService = SpringContextHolder.getBean(IKcTkcstjService.class);

	private ChangeTingKeTongJi changeTingKeTongJi = SpringContextHolder.getBean(ChangeTingKeTongJi.class);

	private IKcZwtksfInfoService kcZwtksfInfoService = SpringContextHolder.getBean(IKcZwtksfInfoService.class);

	private DictUtils dictUtil = SpringContextHolder.getBean(DictUtils.class);

	@Data
	public class GroupConfig{
		private String key;//唯组合到这个键里
		private String name;//显示的名称
		private String dictKey;// 10,20,30字典的值
	}

	private Map<String,List<GroupConfig>> groupConfigMap = Maps.newLinkedHashMap();

	private GroupConfig genConfig(String key, String name, String dictKey){
		GroupConfig config = new GroupConfig();
		config.setKey(key);
		config.setName(name);
		config.setDictKey(dictKey);
		return config;
	}

	private void putGroupConfigMap(String key, GroupConfig config){
		if(groupConfigMap.containsKey(key)){
			List<GroupConfig> list = groupConfigMap.get(key);
			list.add(config);
		}else{
			List<GroupConfig> list = Lists.newArrayList();
			list.add(config);
			groupConfigMap.put(key,list);
		}
	}

	private void initGroupConfigMap(){
		groupConfigMap = Maps.newLinkedHashMap();
		//从数据库查询
		List<KcZwtksfInfo> list = kcZwtksfInfoService.list();

		list.forEach(x -> {
			String[] tksfs = StringUtils.split(x.getTksf(),",");
			//tksfs
			for (String tksf : tksfs) {
				GroupConfig config;
				config = genConfig(x.getZw(), dictUtil.translateDictValue("pdfzw", x.getZw()), tksf);
				putGroupConfigMap(config.getKey(), config);
			}
		});

//		config = genConfig("oneList","学院（部）教务委员会委员","340");						putGroupConfigMap(config.getKey(),config);
//		config = genConfig("twoList","行政负责人、教学副院（部）长及系（专业）负责人","220");		putGroupConfigMap(config.getKey(),config);
//		config = genConfig("threeList","其他党政领导及辅导员","110");						putGroupConfigMap(config.getKey(),config);
//		config = genConfig("threeList","其他党政领导及辅导员","210");						putGroupConfigMap(config.getKey(),config);
//		config = genConfig("threeList","其他党政领导及辅导员","270");						putGroupConfigMap(config.getKey(),config);
//		config = genConfig("threeList","其他党政领导及辅导员","280");						putGroupConfigMap(config.getKey(),config);
//		config = genConfig("fourList","其他专任教师","10");									putGroupConfigMap(config.getKey(),config);
	}
//	/**
//	 *
//	 * 功能说明    : 将导出的文档片段按照list返回
//	 * 创建者      : byx
//	 * 修改日期    : 2018年9月26日
//	 * @param
//	 * @return 文档片段的list对象
//	 * @throws Exceptionz
//	 */
//	public List<WordOperator> exportAll(QnCustomerHetong customerHetong, SysUser user, Date now) throws Exception{
//		List<WordOperator> list = Lists.newArrayList();
//		list.add(export1(customerHetong,user,now));
//		list.add(export2(customerHetong));
//		list.add(export3(customerHetong));
//		return list;
//	}

	@Override
	public List<DictModel> getDictList(String dictCode){
		return sysDictService.queryDictItemsByCode(dictCode);
	}

	/**
	 * 
	 * 功能说明    : 拼接word导出
	 * 创建者      : byx
	 * 修改日期    : 2021-6-30
	 * @param xqxnParam
	 * @return
	 * @throws Exception
	 */
	public WordOperator export(KcExportConfigTpkwcqkjzglx kcExportConfigTpkwcqkjzglx, String xqxnParam) throws Exception{
		String templateName = "exp1\\tpkqk.docx";

		initGroupConfigMap();

		WordOperator wo = ExportWord.getWordOperator(templateName);
		//********************************@A.单个内容替换***************************************************/
		//********************************取数据***********************************************************/
		Map<String, Object> result = Maps.newHashMap();
		//取配置表中的用户
		QueryWrapper<KcExportConfigTpkwcqkjzglx> queryWrapper = QueryGenerator.initQueryWrapper(kcExportConfigTpkwcqkjzglx,null);
//		queryWrapper.eq(StringUtils.isNotBlank(kcExportConfigTpkwcqkjzglx.getDwmc()),"b.dwmc",kcExportConfigTpkwcqkjzglx.getDwmc());
		if(kcExportConfigTpkwcqkjzglx.isFindByDwmc()){
			QueryWrapper<Xxhbuser> uqw = new QueryWrapper<>();
			//LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
			uqw.eq("gh",kcExportConfigTpkwcqkjzglx.getFindGh());
			uqw.last("limit 1");
			Xxhbuser xxhbUser = xxhbuserService.getOne(uqw);
			if(xxhbUser == null) {
				queryWrapper.eq("dwmc ",-1);
			}else{
				queryWrapper.eq("dwmc ",xxhbUser.getDwmc());
			}
		}
//		Set<GroupConfig> conSet = Sets.newHashSet();
//		if(!groupConfigMap.isEmpty()){
//			groupConfigMap.forEach((k,v) -> conSet.addAll(v));
//		}
//		if(!conSet.isEmpty()){
//			queryWrapper.in("", conSet);
//		}

		QueryWrapper<KcExportConfigTpkwcqkjzglx> kcExportConfigTpkwcqkjzglxQueryWrapper = new QueryWrapper<KcExportConfigTpkwcqkjzglx>();
		kcExportConfigTpkwcqkjzglxQueryWrapper.eq("gh",kcExportConfigTpkwcqkjzglx.getFindGh());
		kcExportConfigTpkwcqkjzglxQueryWrapper.eq("xqxn",kcExportConfigTpkwcqkjzglx.getXqxn());
		KcExportConfigTpkwcqkjzglx KcExportConfigTpkwcqkjzglxPar = kcExportConfigTpkwcqkjzglxService.getOne(kcExportConfigTpkwcqkjzglxQueryWrapper);

		List<KcExportConfigTpkwcqkjzglx> KcExportConfigTpkwcqkjzglxList = kcExportConfigTpkwcqkjzglxService.list(queryWrapper);
		Map<String, List<KcExportConfigTpkwcqkjzglx>> ghMap = KcExportConfigTpkwcqkjzglxList.stream().filter(x -> StringUtils.isNotBlank(x.getGh())).collect(Collectors.groupingBy(KcExportConfigTpkwcqkjzglx::getGh));
		Map<String, List<KcExportConfigTpkwcqkjzglx>> typeMap = KcExportConfigTpkwcqkjzglxList.stream().filter(x -> StringUtils.isNotBlank(x.getTklx())).collect(Collectors.groupingBy(KcExportConfigTpkwcqkjzglx::getTklx));


		KcXqxnHistory common = changeTingKeTongJi.getXqConfig(xqxnParam);
		//默认取最大的学期
		if(StringUtils.isBlank(xqxnParam)){
			xqxnParam = common.getTitle();
		}
//		Date startSjDate = common.getStartTime();
//		Date endSjDate = common.getEndTime();
//		String startSj = DateUtil.format(startSjDate, DatePattern.NORM_DATETIME_FORMAT);
//		String endSj = DateUtil.format(endSjDate,DatePattern.NORM_DATETIME_FORMAT);
//		String xqxn = common.getTitle();
//			if(StringUtils.equals(xqxn,kcEvaluation.getXnxq())){


		QueryWrapper<KcTkcstj> tjQueryWrapper = new QueryWrapper<>();
		if(ghMap.keySet().isEmpty()){
			tjQueryWrapper.eq("jgh",-1);
		}else{
			tjQueryWrapper.in("jgh",ghMap.keySet());
		}
//		queryWrapper.apply("up_date >= STR_TO_DATE('"+ startSj +"', '%Y-%m-%d') ");
//		queryWrapper.apply("up_date <= STR_TO_DATE('"+ endSj +"', '%Y-%m-%d') ");
		tjQueryWrapper.eq("xnxq",xqxnParam);
		List<KcTkcstj> tktjList = kcTkcstjService.list(tjQueryWrapper);

		Map<String,KcTkcstj> tktjMap = tktjList.stream().collect(Collectors.toMap(KcTkcstj::getJgh,a -> a, (a,b) -> a));

//		QueryWrapper<Xxhbuser> uqw = new QueryWrapper();
//		uqw.in("gh",typeMap.keySet());
//		List<Xxhbuser> xxhbuserList = xxhbuserService.list(uqw);

		Map<String,List<KcExportConfigTpkwcqkjzglx>> allListMap = Maps.newLinkedHashMap();

		groupConfigMap.forEach((k,v) ->
			v.forEach(x -> {
				if(typeMap.containsKey(x.getDictKey())){
//					allListMap.put(k,typeMap.get(x.getDictKey()));
					if(allListMap.containsKey(k)){
						List<KcExportConfigTpkwcqkjzglx> list = allListMap.get(k);
						list.addAll(typeMap.get(x.getDictKey()));
					}else{
						List<KcExportConfigTpkwcqkjzglx> list = Lists.newArrayList();
						list.addAll(typeMap.get(x.getDictKey()));
						allListMap.put(k,list);
					}
				}else{
					if(!allListMap.containsKey(k)){
						allListMap.put(k,Lists.newArrayList());
					}
				}
			})
		);


//		List<KcExportConfigTpkwcqkjzglx> oneList = typeMap.get("1");
//		if(oneList == null || oneList.isEmpty()) oneList = Lists.newArrayList();

//		List<KcExportConfigTpkwcqkjzglx> twoList = Lists.newArrayList();
//		List<KcExportConfigTpkwcqkjzglx> twoList1 = typeMap.get("2");
//		List<KcExportConfigTpkwcqkjzglx> twoList2 = typeMap.get("3");
//		List<KcExportConfigTpkwcqkjzglx> twoList3 = typeMap.get("4");
//
//		if(twoList1 != null && !twoList1.isEmpty()) {
//			twoList.addAll(twoList1);
//		}
//		if(twoList2 != null && !twoList2.isEmpty()) {
//			twoList.addAll(twoList2);
//		}
//		if(twoList3 != null && !twoList3.isEmpty()) {
//			twoList.addAll(twoList3);
//		}
//
//		List<KcExportConfigTpkwcqkjzglx> threeList = Lists.newArrayList();
//		List<KcExportConfigTpkwcqkjzglx> threeList1 = typeMap.get("5");
//		List<KcExportConfigTpkwcqkjzglx> threeList2 = typeMap.get("6");
//
//		if(threeList1 != null && !threeList1.isEmpty()) {
//			threeList.addAll(threeList1);
//		}
//		if(threeList2 != null && !threeList2.isEmpty()) {
//			threeList.addAll(threeList2);
//		}
		//********************************取数据END*********************************************************/
		//********************************通用*************************************************************/
		result.put("xym",KcExportConfigTpkwcqkjzglxPar.getDwmc());//学院名称
		result.put("xqxn",xqxnParam);//学期学年
		//填进去数量
		allListMap.forEach((k,v) -> result.put(k + "Size", StringUtils.defaultString(String.valueOf(v.size()),"0")));
//		result.put("oneListSize",   StringUtils.defaultString(String.valueOf(oneList.size()),"0"));
//		result.put("twoListSize",   StringUtils.defaultString(String.valueOf(twoList.size()),"0"));
//		result.put("threeListSize",   StringUtils.defaultString(String.valueOf(threeList.size()),"0"));
//		result.put("fourListSize",   StringUtils.defaultString(String.valueOf(threeList.size()),"0"));

		//********************************表头END**********************************************************/
		wo.replaceTextPlus(result);
		//********************************@A.单个内容替换END**************************************************/
		final int[] index = { 4 };
		List<List<String>> mainList = Lists.newArrayList();


		allListMap.forEach((k,v) -> {
			v.forEach(x -> {
				if(tktjMap.containsKey(x.getGh())) {
					List<String> tmpList = new ArrayList<>();
					mainList.add(tmpList);
					KcTkcstj tkcstj = tktjMap.get(x.getGh());
//					tmpList.add(null);
//					int ytkcs = Integer.parseInt(StringUtils.defaultString(x.getYtkcs(),"0"));
					int ytkcs = 0;
					if(ghMap.containsKey(x.getGh())){
						List<GroupConfig> confList = groupConfigMap.get(k);
						if(!confList.isEmpty()){
							List<KcExportConfigTpkwcqkjzglx> list = ghMap.get(x.getGh());
							List<KcExportConfigTpkwcqkjzglx> flist = Lists.newArrayList();
							for (GroupConfig config: confList){
								for(KcExportConfigTpkwcqkjzglx l: list){
									if(StringUtils.equals(l.getTklx(),config.getDictKey())){
										flist.add(l);
									}
								}
							}
							if(!flist.isEmpty()){
								for(KcExportConfigTpkwcqkjzglx e : flist){
									int c = Integer.parseInt(StringUtils.defaultString(e.getYtkcs(),"0"));
									if(c > ytkcs) {
										ytkcs = c;
									}
								}
							}
						}
					}
					tmpList.add(x.getXm());
					tmpList.add(formatDictTxt(x.getTklx(),"tpkwcqkjzglx"));
					tmpList.add(String.valueOf(ytkcs));//取最大值

					tmpList.add(tkcstj.getTkxttj());
				}else{
					//听课统计里面没有的，在这里补0
					List<String> tmpList = new ArrayList<>();
					mainList.add(tmpList);
//					tmpList.add(null);
//					int ytkcs = Integer.parseInt(StringUtils.defaultString(x.getYtkcs(),"0"));
					int ytkcs = 0;
					if(ghMap.containsKey(x.getGh())){
						List<GroupConfig> confList = groupConfigMap.get(k);
						if(!confList.isEmpty()){
							List<KcExportConfigTpkwcqkjzglx> list = ghMap.get(x.getGh());
							List<KcExportConfigTpkwcqkjzglx> flist = Lists.newArrayList();
							for (GroupConfig config: confList){
								for(KcExportConfigTpkwcqkjzglx l: list){
									if(StringUtils.equals(l.getTklx(),config.getDictKey())){
										flist.add(l);
									}
								}
							}
							if(!flist.isEmpty()){
								for(KcExportConfigTpkwcqkjzglx e : flist){
									int c = Integer.parseInt(StringUtils.defaultString(e.getYtkcs(),"0"));
									if(c > ytkcs) {
										ytkcs = c;
									}
								}
							}
						}
					}
					tmpList.add(x.getXm());
					tmpList.add(formatDictTxt(x.getTklx(),"tpkwcqkjzglx"));
					tmpList.add(String.valueOf(ytkcs));//取最大值

					tmpList.add("0");
				}
			});
			WordOperator.fillNullCall(mainList,v,2,3);
			//从固定位置开始添加（1为第二个表格，第二个1为固定位置）
			wo.insert2Table(0, index[0], true, mainList);
			index[0] += mainList.size() + 2;
			mainList.clear();
		});






//		mainList.clear();
//		twoList.forEach(x -> {
//			if(tktjMap.containsKey(x.getGh())) {
//				List<String> tmpList = new ArrayList<>();
//				mainList.add(tmpList);
//				KcTkcstj tkcstj = tktjMap.get(x.getGh());
//				tmpList.add(null);
//				tmpList.add(StringUtils.defaultString(tkcstj.getJsxm(),x.getXm()));
//				tmpList.add(tkcstj.getTkxttj());
//			}
//		});
//		//从固定位置开始添加（1为第二个表格，第二个1为固定位置）
//		WordOperator.fillNullCall(mainList,twoList,2,3);
//		wo.insert2Table(0, index[0], true, mainList);
//
//		index[0] += mainList.size() + 2;
//		mainList.clear();
//		threeList.forEach(x -> {
//			if(tktjMap.containsKey(x.getGh())) {
//				List<String> tmpList = new ArrayList<>();
//				mainList.add(tmpList);
//				KcTkcstj tkcstj = tktjMap.get(x.getGh());
//				tmpList.add(null);
//				tmpList.add(StringUtils.defaultString(tkcstj.getJsxm(),x.getXm()));
//				tmpList.add(tkcstj.getTkxttj());
//			}
//		});
//		//从固定位置开始添加（1为第二个表格，第二个1为固定位置）
//		WordOperator.fillNullCall(mainList,threeList,2,3);
//		wo.insert2Table(0, index[0], true, mainList);
		return wo;
	}
}
