package org.jeecg.modules.kc.config.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.SecurityUtils;
import org.jeecg.common.system.vo.LoginUser;
import org.jeecg.modules.kc.config.entity.KcExportConfigTpkwcqkjzglx;
import org.jeecg.modules.kc.config.entity.KcExportConfigTpkwcqkjzglxXytktj;
import org.jeecg.modules.kc.config.mapper.KcExportConfigTpkwcqkjzglxMapper;
import org.jeecg.modules.kc.config.service.IKcExportConfigTpkwcqkjzglxService;
import org.jeecg.modules.kc.grab.SynchronizationService.tools.ChangeTingKeTongJi;
import org.jeecg.modules.kc.grab.imports.entity.Xxhbuser;
import org.jeecg.modules.kc.grab.imports.service.IXxhbuserService;
import org.jeecg.modules.kc.kcSysConfig.entity.KcSysConfig;
import org.jeecg.modules.kc.kcSysConfig.service.IKcSysConfigService;
import org.jeecg.modules.kc.kcXqxnHistory.entity.KcXqxnHistory;
import org.jeecg.modules.kc.kcXqxnHistory.service.IKcXqxnHistoryService;
import org.jeecg.modules.kc.tksf.kctksfyq.entity.KcTksfyq;
import org.jeecg.modules.kc.tksf.kctksfyq.service.IKcTksfyqService;
import org.jeecg.modules.system.service.impl.SysBaseApiImpl;
import org.jeecg.modules.tools.DictUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;

/**
 * @Description: kc_export_config_tpkwcqkjzglx
 * @Author: jeecg-boot
 * @Date:   2023-07-21
 * @Version: V1.0
 */
@Service
public class KcExportConfigTpkwcqkjzglxServiceImpl extends ServiceImpl<KcExportConfigTpkwcqkjzglxMapper, KcExportConfigTpkwcqkjzglx> implements IKcExportConfigTpkwcqkjzglxService {

    @Autowired
    private IKcTksfyqService kcTksfyqService;

    @Autowired
    private ChangeTingKeTongJi changeTingKeTongJi;
    @Autowired
    private SysBaseApiImpl sysBaseApi;
    @Autowired
    private IXxhbuserService xxhbuserService;
    @Autowired
    private IKcSysConfigService kcSysConfigService;

    @Autowired
    private DictUtils dictUtils;

    @Autowired
    private IKcXqxnHistoryService kcXqxnHistoryService;

    @Override
    public void editAll(KcExportConfigTpkwcqkjzglx kcExportConfigTpkwcqkjzglx) {
        //按学期筛选
        KcXqxnHistory common = changeTingKeTongJi.getXqConfig();
        String xqxn;
        if(common != null) {
            //Map<String, KcTkcstj> tongJiMap = Maps.newHashMap();
            //清洗数据核心
            Date startSjDate = common.getStartTime();
            Date endSjDate = common.getEndTime();
//            String startSj = DateUtil.format(startSjDate,DatePattern.NORM_DATETIME_FORMAT);
//            String endSj = DateUtil.format(endSjDate,DatePattern.NORM_DATETIME_FORMAT);
            xqxn = common.getTitle();
        } else {
            xqxn = null;
        }


        //结构名称
        if(StringUtils.isNotBlank(kcExportConfigTpkwcqkjzglx.getTklx())){
            List<String> zwmcs = Arrays.asList(kcExportConfigTpkwcqkjzglx.getTklx().split(","));
//            QueryWrapper<KcExportConfigTpkwcqkjzglx> qw = new QueryWrapper<>();
//            qw.in("tklx",zwmcs);
//            remove(qw);
            zwmcs.forEach(x -> {
                kcExportConfigTpkwcqkjzglx.setTklx(x);
                kcExportConfigTpkwcqkjzglx.setId(null);
                UpdateWrapper uw = new UpdateWrapper();
                uw.set("ytkcs",kcExportConfigTpkwcqkjzglx.getYtkcs());
                uw.eq("tklx",x);
                //uw.eq("xqxn",xqxn); //TODO 不对劲，得当前选择数据的年份为条件
                update(uw);
            });
        }
        //结构名称
        if(StringUtils.isNotBlank(kcExportConfigTpkwcqkjzglx.getTklx())){
            List<String> zwmcs = Arrays.asList(kcExportConfigTpkwcqkjzglx.getTklx().split(","));
            QueryWrapper<KcTksfyq> qw = new QueryWrapper<>();
            qw.in("zwmc",zwmcs);
            kcTksfyqService.remove(qw);
            zwmcs.forEach(x -> {
                KcTksfyq kcTksfyq = new KcTksfyq();
                kcTksfyq.setZwmc(x);
                kcTksfyq.setId(null);
                kcTksfyqService.save(kcTksfyq);
            });

        }

    }

    @Override
    public IPage<KcExportConfigTpkwcqkjzglx> queryTkyqPageList(Page<KcExportConfigTpkwcqkjzglx> page, QueryWrapper<KcExportConfigTpkwcqkjzglx> queryWrapper) {
        return baseMapper.queryTkyqPageList(page,queryWrapper);
    }

    @Override
    public KcExportConfigTpkwcqkjzglx getByGh(String gh) {
        return baseMapper.getByGh(gh);
    }

    @Override
    public KcExportConfigTpkwcqkjzglx queryBytklx(String tklx) {
        return baseMapper.queryBytklx(tklx);
    }

    @Override
    public List<Map<String, Object>> getTjlist(KcExportConfigTpkwcqkjzglx kcExportConfigTpkwcqkjzglx) {
        List<Map<String, Object>> resMapList = new ArrayList<>();
        LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
        //-------------获取当前登陆人是否是管理员角色，如果不是都按照教务秘书处理---------------------------
        List<String> roleList = sysBaseApi.getRolesByUsername(sysUser.getUsername());
        String adminRole = "1";//0 admin  1教务秘书
        for(String role :roleList){
            if(StringUtils.equals("admin",role)){
                adminRole = "0";
                break;
            }
        }
        //-------------获取当前登陆人是否是管理员角色，如果不是都按照教务秘书处理---------------------------

        //-------------如果是教务秘书获取是哪个学校的---------------------------
        String schoolname = "";
        List<String> tklxList = new ArrayList<>();
        tklxList.add("30");
        tklxList.add("20");
        tklxList.add("330");
        tklxList.add("60");
        tklxList.add("50,150,180,210,230,350");//副院长、党委副书记、副部长、学院党委副书记、副书记、常务副书记
        tklxList.add("110");
        tklxList.add("10");
        tklxList.add("40");
//        学校教务委员会	70
//        学校督学	100
//        校领导	160
//        学院教务委员会	30
//        系主任（专业负责人）	20
//        教学副院长	330
//        行政负责人 	60
//        其他党政领导   210 270 280
//        辅导员	110
//        其他专任教师 10
        if(StringUtils.equals("1",adminRole)){//获取当前人所在的学院
            QueryWrapper<Xxhbuser> xxhbuserQueryWrapper = new QueryWrapper<>();
            xxhbuserQueryWrapper.eq("gh",sysUser.getUsername());
            xxhbuserQueryWrapper.last("limit 1");
            Xxhbuser xxhbuser = xxhbuserService.getOne(xxhbuserQueryWrapper);
            if(xxhbuser==null){//如果没有查到，则返回空，什么也不显示
                return null;
            }else{
                schoolname = xxhbuser.getDwmc();
            }
        }else{//管理员还需要查这几个
            tklxList.add("70");
            tklxList.add("100");
            tklxList.add("160");
        }
        //-------------如果是教务秘书获取是哪个学校的---------------------------

        //------------------获取统计数据------------------------------------
        for(String tklx:tklxList){
//            KcSysConfig kcSysConfig = kcSysConfigService.getById("1");
            Map<String, Object> resMap = new HashMap<>();
            String title = dictUtils.translateDictValue("tpkwcqkjzglx",tklx);
            resMap.put("title", title);
            if(StringUtils.equals("50,150,180,210,230,350",tklx)){
                resMap.put("title", "学院（部）其他党政领导");
            }
            if(StringUtils.equals("70",tklx)||StringUtils.equals("100",tklx)||StringUtils.equals("160",tklx)){
                resMap.put("type","0");//0代表管理员 1代表教务秘书
            }else{
                resMap.put("type","1");//0代表管理员 1代表教务秘书
            }
            resMap.put("code", tklx);
            KcExportConfigTpkwcqkjzglx kcExportConfigTpkwcqkjzglx1 = new KcExportConfigTpkwcqkjzglx();
            kcExportConfigTpkwcqkjzglx1.setDwmc(schoolname);
            kcExportConfigTpkwcqkjzglx1.setTklx(tklx);
            kcExportConfigTpkwcqkjzglx1.setXqxn(kcExportConfigTpkwcqkjzglx.getXqxn());
            List<KcExportConfigTpkwcqkjzglx> infolist = baseMapper.getTjinfoList(kcExportConfigTpkwcqkjzglx1);
            int ywcrs = 0;//已完成人数
            int wwcrs = 0;//未完成人数
            int ypkcs = 0;//应评课次数
            int sjpkcs = 0;//实际评课次数
            for(int i=0;i<infolist.size();i++){
                KcExportConfigTpkwcqkjzglx KcExportConfigTpkwcqkjzglx2 = infolist.get(i);
                if(KcExportConfigTpkwcqkjzglx2!=null){
                    int a1= Integer.parseInt(KcExportConfigTpkwcqkjzglx2.getYtkcs());
                    int a2= Integer.parseInt(KcExportConfigTpkwcqkjzglx2.getSjtkcs());
                    if(a1<=a2){
                        ywcrs++;
                    }else{
                        wwcrs++;
                    }
                    ypkcs = ypkcs+Integer.parseInt(KcExportConfigTpkwcqkjzglx2.getYtkcs());
                    sjpkcs = sjpkcs+Integer.parseInt(KcExportConfigTpkwcqkjzglx2.getSjtkcs());
                }

            }
            resMap.put("zrs",ywcrs+wwcrs);//总人数
            resMap.put("ywcrs",ywcrs);//已完成人数
            resMap.put("wwcrs",wwcrs);//未完成人数
            resMap.put("ypkcs",ypkcs);//应评课次数
            resMap.put("sjpkcs",sjpkcs);//实际评课次数
            resMapList.add(resMap);
        }


        //------------------获取统计数据------------------------------------

        return resMapList;
    }

    @Override
    public void updateJzgzzzt(KcExportConfigTpkwcqkjzglx kcExportConfigTpkwcqkjzglx) {
        baseMapper.updateJzgzzzt(kcExportConfigTpkwcqkjzglx);
    }

    @Override
    public IPage<KcExportConfigTpkwcqkjzglx> getListByCode(Page<KcExportConfigTpkwcqkjzglx> page, KcExportConfigTpkwcqkjzglx kcExportConfigTpkwcqkjzglx) {
        LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
        //-------------获取当前登陆人是否是管理员角色，如果不是都按照教务秘书处理---------------------------
        List<String> roleList = sysBaseApi.getRolesByUsername(sysUser.getUsername());
        String adminRole = "1";//0 admin  1教务秘书
        for(String role :roleList){
            if(StringUtils.equals("admin",role)){
                adminRole = "0";
                break;
            }
        }
        if(StringUtils.equals("1",adminRole)){
            QueryWrapper<Xxhbuser> uqw = new QueryWrapper<>();
            uqw.eq("gh",sysUser.getUsername());
            uqw.last("limit 1");
            Xxhbuser xxhbUser = xxhbuserService.getOne(uqw);
            kcExportConfigTpkwcqkjzglx.setDwmc(xxhbUser.getDwmc());
        }
        if(StringUtils.isEmpty(kcExportConfigTpkwcqkjzglx.getXqxn())){
            KcSysConfig kcSysConfig = kcSysConfigService.getById("1");
            kcExportConfigTpkwcqkjzglx.setXqxn(kcSysConfig.getFlag1());
        }


        IPage<KcExportConfigTpkwcqkjzglx> infolist = baseMapper.getListByCode(page,kcExportConfigTpkwcqkjzglx);
        return infolist;
    }

    @Override
    public List<KcExportConfigTpkwcqkjzglx> getBarlist(KcExportConfigTpkwcqkjzglx kcExportConfigTpkwcqkjzglx) {
        LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
        //-------------获取当前登陆人是否是管理员角色，如果不是都按照教务秘书处理---------------------------
        List<String> roleList = sysBaseApi.getRolesByUsername(sysUser.getUsername());
        String adminRole = "1";//0 admin  1教务秘书
        for(String role :roleList){
            if(StringUtils.equals("admin",role)){
                adminRole = "0";
                break;
            }
        }
        if(StringUtils.equals("1",adminRole)){
            QueryWrapper<Xxhbuser> uqw = new QueryWrapper<>();
            uqw.eq("gh",sysUser.getUsername());
            uqw.last("limit 1");
            Xxhbuser xxhbUser = xxhbuserService.getOne(uqw);
            kcExportConfigTpkwcqkjzglx.setDwmc(xxhbUser.getDwmc());
        }
        KcSysConfig kcSysConfig = kcSysConfigService.getById("1");
        kcExportConfigTpkwcqkjzglx.setXqxn(kcSysConfig.getFlag1());

        List<KcExportConfigTpkwcqkjzglx> infolist = baseMapper.getBarlist(kcExportConfigTpkwcqkjzglx);
        return infolist;
    }

    @Override
    public IPage<KcExportConfigTpkwcqkjzglx> getListQtzrjs(Page<KcExportConfigTpkwcqkjzglx> page, KcExportConfigTpkwcqkjzglx kcExportConfigTpkwcqkjzglx) {
        KcSysConfig kcSysConfig = kcSysConfigService.getById("1");
        kcExportConfigTpkwcqkjzglx.setXqxn(kcSysConfig.getFlag1());
        return baseMapper.getListQtzrjs(page,kcExportConfigTpkwcqkjzglx);
    }

    @Override
    public List<KcExportConfigTpkwcqkjzglx> getListQtzrjsChar(KcExportConfigTpkwcqkjzglx kcExportConfigTpkwcqkjzglx) {
        LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
        //-------------获取当前登陆人是否是管理员角色，如果不是都按照教务秘书处理---------------------------
        List<String> roleList = sysBaseApi.getRolesByUsername(sysUser.getUsername());
        String adminRole = "1";//0 admin  1教务秘书
        for(String role :roleList){
            if(StringUtils.equals("admin",role)){
                adminRole = "0";
                break;
            }
        }
        if(StringUtils.equals("1",adminRole)){
            QueryWrapper<Xxhbuser> uqw = new QueryWrapper<>();
            uqw.eq("gh",sysUser.getUsername());
            uqw.last("limit 1");
            Xxhbuser xxhbUser = xxhbuserService.getOne(uqw);
            kcExportConfigTpkwcqkjzglx.setDwmc(xxhbUser.getDwmc());
        }
        KcSysConfig kcSysConfig = kcSysConfigService.getById("1");
        kcExportConfigTpkwcqkjzglx.setXqxn(kcSysConfig.getFlag1());

        List<KcExportConfigTpkwcqkjzglx> infolist = baseMapper.getListQtzrjsChar(kcExportConfigTpkwcqkjzglx);
        return infolist;
    }

    @Override
    public List<KcExportConfigTpkwcqkjzglxXytktj> getListByCodeXytktj(QueryWrapper<KcExportConfigTpkwcqkjzglxXytktj> queryWrapper,KcExportConfigTpkwcqkjzglxXytktj kcExportConfigTpkwcqkjzglxXytktj) {
        LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
        //-------------获取当前登陆人是否是管理员角色，如果不是都按照教务秘书处理---------------------------
        List<String> roleList = sysBaseApi.getRolesByUsername(sysUser.getUsername());
        String adminRole = "1";//0 admin  1教务秘书
        for(String role :roleList){
            if(StringUtils.equals("admin",role)){
                adminRole = "0";
                break;
            }
        }
        if(StringUtils.equals("1",adminRole)){
            QueryWrapper<Xxhbuser> uqw = new QueryWrapper<>();
            uqw.eq("gh",sysUser.getUsername());
            uqw.last("limit 1");
            Xxhbuser xxhbUser = xxhbuserService.getOne(uqw);
            kcExportConfigTpkwcqkjzglxXytktj.setDwmc(xxhbUser.getDwmc());
        }
//        KcSysConfig kcSysConfig = kcSysConfigService.getById("1");
//        kcExportConfigTpkwcqkjzglxXytktj.setXqxn(kcSysConfig.getFlag1());

        if(StringUtils.isEmpty(kcExportConfigTpkwcqkjzglxXytktj.getXqxn())){
            KcSysConfig kcSysConfig = kcSysConfigService.getById("1");
            kcExportConfigTpkwcqkjzglxXytktj.setXqxn(kcSysConfig.getFlag1());
        }
        List<KcExportConfigTpkwcqkjzglxXytktj> infolist = baseMapper.getListByCodeXytktj(kcExportConfigTpkwcqkjzglxXytktj);
        return infolist;
    }

    @Override
    public List<KcExportConfigTpkwcqkjzglx> getSfybxqsj() {
        try {
            QueryWrapper<KcXqxnHistory> kcXqxnHistoryQueryWrapper = new QueryWrapper<>();
            kcXqxnHistoryQueryWrapper.orderByDesc("start_time");
            List<KcXqxnHistory> historyList = kcXqxnHistoryService.list(kcXqxnHistoryQueryWrapper);
            String dqxq = historyList.get(0).getTitle();

            KcExportConfigTpkwcqkjzglx KcExportConfigTpkwcqkjzglx = new KcExportConfigTpkwcqkjzglx();
            KcExportConfigTpkwcqkjzglx.setXqxn(dqxq);
            KcExportConfigTpkwcqkjzglx tjsj =baseMapper.getDqxqtjlist(KcExportConfigTpkwcqkjzglx);
            String znum = tjsj.getZnum();
            if(StringUtils.equals("0",znum)){
                String syxq = historyList.get(1).getTitle();//上一学期
                //获取本学期新增数据
                KcExportConfigTpkwcqkjzglx.setType(syxq);
                List<KcExportConfigTpkwcqkjzglx> savelist = baseMapper.getBxqSaveList(KcExportConfigTpkwcqkjzglx);
                return savelist;
            }
        }catch (Exception e) {
            e.printStackTrace();
        }
        return null;
    }

    @Override
    public List<KcExportConfigTpkwcqkjzglx> groupTklxList(QueryWrapper<KcExportConfigTpkwcqkjzglx> queryWrapper) {
        return baseMapper.groupTklxList(queryWrapper);
    }

    @Override
    public IPage<KcExportConfigTpkwcqkjzglx> list3(Page<KcExportConfigTpkwcqkjzglx> page, QueryWrapper<KcExportConfigTpkwcqkjzglx> queryWrapper) {
        return baseMapper.list3(page,queryWrapper);
    }
}
