import {BasicColumn} from '/@/components/Table';
import {FormSchema} from '/@/components/Table';
import { rules} from '/@/utils/helper/validator';
import { render } from '/@/utils/common/renderUtils';
//列表数据
export const columns: BasicColumn[] = [
  {
    title: '工号',
    align: "center",
    dataIndex: 'gh_dictText'
  },
  {
    title: '听课类型（字典：tpkwcqkjzglx	）',
    align: "center",
    dataIndex: 'tklx_dictText'
  },
];

//查询数据
export const searchFormSchema: FormSchema[] = [
  {
    label: "工号",
    field: 'gh',
    component: 'JDictSelectTag',
    componentProps:{
      dictCode: "xxhbuser,xm,gh"
    },
    colProps: {span: 6},
  },
  {
    label: "听课类型（字典：tpkwcqkjzglx	）",
    field: 'tklx',
    component: 'JDictSelectTag',
    componentProps:{
      dictCode: "tpkwcqkjzglx"
    },
    colProps: {span: 6},
  },
];

//表单数据
export const formSchema: FormSchema[] = [
  {
    label: '工号',
    field: 'gh',
    component: 'JDictSelectTag',
    componentProps:{
      dictCode: "xxhbuser,xm,gh"
    },
  },
  {
    label: '听课类型（字典：tpkwcqkjzglx	）',
    field: 'tklx',
    component: 'JDictSelectTag',
    componentProps:{
      dictCode: "tpkwcqkjzglx"
    },
  },
	// TODO 主键隐藏字段，目前写死为ID
  {
    label: '',
    field: 'id',
    component: 'Input',
    show: false,
  },
];
