package org.jeecg.modules.kc.detection.entity;

import java.io.Serializable;
import java.io.UnsupportedEncodingException;
import java.util.Date;
import java.math.BigDecimal;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.TableLogic;
import lombok.Data;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;
import org.jeecgframework.poi.excel.annotation.Excel;
import org.jeecg.common.aspect.annotation.Dict;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * @Description: 教室人数检测-详细表
 * @Author: jeecg-boot
 * @Date:   2024-05-07
 * @Version: V1.0
 */
@Data
@TableName("kc_detection_detailed")
@Accessors(chain = true)
@EqualsAndHashCode(callSuper = false)
@ApiModel(value="kc_detection_detailed对象", description="教室人数检测-详细表")
public class KcDetectionDetailed implements Serializable {
    private static final long serialVersionUID = 1L;

	/**id*/
	@TableId(type = IdType.ASSIGN_ID)
    @ApiModelProperty(value = "id")
    private java.lang.String id;
	/**创建时间*/
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern="yyyy-MM-dd")
    @ApiModelProperty(value = "创建时间")
    private java.util.Date createTime;
	/**更新时间*/
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern="yyyy-MM-dd")
    @ApiModelProperty(value = "更新时间")
    private java.util.Date updateTime;
	/**教室人数检测-主表ID[kc_detection_main.id]*/
	@Excel(name = "教室人数检测-主表ID[kc_detection_main.id]", width = 15)
	@ApiModelProperty(value = "教室人数检测-主表ID[kc_detection_main.id]")
	private java.lang.String pid;
	/**任务编号（课堂）*/
	@Excel(name = "任务编号（课堂）", width = 15)
    @ApiModelProperty(value = "任务编号（课堂）")
    private java.lang.String rwbh;
	/**课程编号*/
	@Excel(name = "课程编号", width = 15)
    @ApiModelProperty(value = "课程编号")
    private java.lang.String kcbh;
	/**课程名称*/
	@Excel(name = "课程名称", width = 15)
    @ApiModelProperty(value = "课程名称")
    private java.lang.String kcmc;
	/**教室编号*/
	@Excel(name = "教室编号", width = 15)
    @ApiModelProperty(value = "教室编号")
    private java.lang.String jsbh;
	/**学年学期内部用*/
	@Excel(name = "学年学期内部用", width = 15)
    @ApiModelProperty(value = "学年学期内部用")
    private java.lang.String xnxq;
	/**检测url*/
	@Excel(name = "检测url", width = 15)
    @ApiModelProperty(value = "检测url")
    private java.lang.String detectionUrl;
	/**截取图片结果URL*/
	@Excel(name = "截取图片结果URL", width = 15)
    @ApiModelProperty(value = "截取图片结果URL")
    private java.lang.String detectionOutImgUrl;
	/**截取图片计算人数返回结果*/
	@Excel(name = "截取图片计算人数返回结果", width = 15)
    @ApiModelProperty(value = "截取图片计算人数返回结果")
    private java.lang.String detectionOutImgRes;
	/**检测次数（当前是第几次）*/
	@Excel(name = "检测次数（当前是第几次）", width = 15)
    @ApiModelProperty(value = "检测次数（当前是第几次）")
    private java.lang.Integer detectionNum;
	/**当次检测人数*/
	@Excel(name = "当次检测人数", width = 15)
    @ApiModelProperty(value = "当次检测人数")
    private java.lang.Integer num;
}
