package org.jeecg.modules.kc.detection.entity;

import java.io.Serializable;
import java.util.Date;
import java.util.List;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.handlers.FastjsonTypeHandler;
import lombok.Data;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.jeecg.modules.kc.ktgl.entity.KcKetangbiao;
import org.springframework.format.annotation.DateTimeFormat;
import org.jeecgframework.poi.excel.annotation.Excel;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * @Description: 教室人数检测-主表
 * @Author: jeecg-boot
 * @Date:   2024-05-07
 * @Version: V1.0
 */
@Data
@TableName(value = "kc_detection_main", autoResultMap = true)
@Accessors(chain = true)
@EqualsAndHashCode(callSuper = false)
@ApiModel(value="kc_detection_main对象", description="教室人数检测-主表")
public class KcDetectionMain implements Serializable {
    private static final long serialVersionUID = 1L;

	/**id*/
	@TableId(type = IdType.ASSIGN_ID)
    @ApiModelProperty(value = "id")
    private String id;
	/**创建时间*/
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd")
    @DateTimeFormat(pattern="yyyy-MM-dd")
    @ApiModelProperty(value = "创建时间")
    private Date createTime;
	/**更新时间*/
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd")
    @DateTimeFormat(pattern="yyyy-MM-dd")
    @ApiModelProperty(value = "更新时间")
    private Date updateTime;


	/**学年学期内部用*/
	@Excel(name = "学年学期", width = 15)
	@ApiModelProperty(value = "学年学期")
	private String xnxq;


	/**任务编号（课堂）*/
    @ApiModelProperty(value = "任务编号（课堂）")
    private String rwbh;
	/**课程编号*/
    @ApiModelProperty(value = "课程编号")
    private String kcbh;
	/**课程名称*/
	@Excel(name = "课程名称", width = 15)
    @ApiModelProperty(value = "课程名称")
    private String kcmc;
	/**教室编号*/
    @ApiModelProperty(value = "教室编号")
    private String jsbh;
	/**检测url*/
    @ApiModelProperty(value = "检测url")
    private String detectionUrl;

	/**检测次数*/
	@Excel(name = "检测次数", width = 15)
    @ApiModelProperty(value = "检测次数")
    private Integer detectionNum;
	/**人数(累加)*/
//	@Excel(name = "人数(累加)", width = 15)
    @ApiModelProperty(value = "人数(累加)")
    private Integer allNum;
	/**平均数*/
//	@Excel(name = "平均数", width = 15)
    @ApiModelProperty(value = "平均数")
    private Integer averageNum;
	/**课堂信息*/
	@TableField(updateStrategy = FieldStrategy.IGNORED, typeHandler = FastjsonTypeHandler.class)
	@ApiModelProperty(value = "课堂信息")
	private KcKetangbiao ketangbiaoInfo;



	@Excel(name = "开课单位", width = 15)
	@TableField(exist = false)
	private String kkdw;
	@Excel(name = "授课教师", width = 15)
	@TableField(exist = false)
	private String skjs;

	@Excel(name = "授课日期", width = 15)
	@TableField(exist = false)
	private String skrq;

	@Excel(name = "授课节次", width = 15)
	@TableField(exist = false)
	private String skjc;

	@Excel(name = "选课人数", width = 15)
	@TableField(exist = false)
	private String xkrs;

	@Excel(name = "出勤率", width = 15)
	@TableField(exist = false)
	private String cql;



	/**详细数据子列表*/
	@TableField(exist = false)
	private List<KcDetectionDetailed> detectionDetailedList;

	/***/
	@TableField(exist = false)
	private Boolean isSelectKcDetailed;

	/**搜索上课日期*/
	@TableField(exist = false)
	private String searchSkrq;

	/**搜索节次*/
	@TableField(exist = false)
	private String searchHh;


	//迟到人数
	@TableField(exist = false)
	private String cdrs;
	//早退人数
	@TableField(exist = false)
	private String ztrs;

}
