package org.jeecg.modules.kc.detection.job;

import lombok.extern.slf4j.Slf4j;
import org.jeecg.modules.kc.detection.service.IKcDetectionDetailedService;
import org.jeecg.modules.kc.grab.SynchronizationService.base.BaseSync;
import org.jeecg.modules.kc.zyInfoStudent.service.IZyInfoStudentService;
import org.quartz.JobExecutionContext;
import org.springframework.beans.factory.annotation.Autowired;

import javax.annotation.Resource;
import java.util.Map;

@Slf4j
public class VideoJobParams extends BaseSync {

    @Resource
    private IKcDetectionDetailedService detectionDetailedService;

    /**
     * 若参数变量名修改 QuartzJobController中也需对应修改
     */

    @Override
    public void execute(JobExecutionContext jobExecutionContext) {
        start();
        run(getParamMap());
        end();
    }


    /**
     * 有参定时任务实现
     * @param param
     */
    public void run(Map<String, Object> param){
        String jsbh = param.get("jsbh").toString();
        detectionDetailedService.videoScreenshotByJsbh(jsbh);//
    }

    /**
     * 无参定时任务实现
     */
    public void run(){
        run(null);
    }

}
