package org.jeecg.modules.kc.grab.SynchronizationService;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.date.DateUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.compress.utils.Lists;
import org.jeecg.common.util.DateUtils;
import org.jeecg.modules.kc.grab.SynchronizationService.base.BaseSync;
import org.jeecg.modules.kc.grab.exports.entity.TFwdtBkjxtkpj;
import org.jeecg.modules.kc.grab.exports.service.ITFwdtBkjxtkpjService;
import org.jeecg.modules.kc.grab.imports.entity.Xxhbbkjxtkpj;
import org.jeecg.modules.kc.grab.imports.entity.Xxhbsynclog;
import org.jeecg.modules.kc.grab.imports.service.IXxhbbkjxtkpjService;
import org.jeecg.modules.kc.kcGongkaike.entity.KcGongkaike;
import org.jeecg.modules.kc.kcGongkaike.service.IKcGongkaikeService;
import org.jeecg.modules.kc.ktgl.service.IKcKetangbiaoService;
import org.jeecg.modules.kc.qa.service.IKcEvaluationService;
import org.jeecg.modules.kc.qa.service.IKcEvaluationsService;
import org.jeecg.modules.quartz.entity.QuartzJob;
import org.jeecg.modules.quartz.service.IQuartzJobService;
import org.quartz.JobExecutionContext;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.Calendar;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * 服务大厅-本科教学服务评价
 */
@Slf4j
public class JcgkkTask extends BaseSync {

    @Autowired
    private IKcGongkaikeService kcGongkaikeService;

    /**
     * 若参数变量名修改 QuartzJobController中也需对应修改
     */

    @Override
    public void execute(JobExecutionContext jobExecutionContext) {
        start();
        run(getParamMap());
        end();
    }


    /**
     * 有参定时任务实现
     * @param param
     */
    public void run(Map<String, Object> param){


        //查询数据
        Date date = new Date();//获取当前时间
        Calendar calendar = Calendar.getInstance();
        calendar.setTime(date);
        calendar.add(Calendar.DAY_OF_MONTH, -1);//当前时间前去一田
        QueryWrapper<KcGongkaike> queryWrapper = new QueryWrapper<>();
        queryWrapper.le("rq", DateUtil.format(date,"yyyy-MM-dd"));
        queryWrapper.lt("jssj", DateUtil.format(date,"HH:mm"));
        queryWrapper.ne("dqzt","已下课");
        List<KcGongkaike> inDataList = kcGongkaikeService.list(queryWrapper);//查询以前的数据，不是下课中的,修改成下课中
        for(KcGongkaike KcGongkaike:inDataList){
            KcGongkaike.setDqzt("已下课");
            KcGongkaike.setDqztpx("3");
            kcGongkaikeService.updateById(KcGongkaike);
        }


        QueryWrapper<KcGongkaike> queryWrapper2 = new QueryWrapper<>();
        queryWrapper2.eq("rq", DateUtil.format(date,"yyyy-MM-dd"));
        queryWrapper2.ge("kssj", DateUtil.format(date,"HH:mm"));
        queryWrapper2.le("jssj", DateUtil.format(date,"HH:mm"));
        queryWrapper2.ne("dqzt","已下课");
        List<KcGongkaike> inDataList2 = kcGongkaikeService.list(queryWrapper2);//查询正在上课的数据

        for(KcGongkaike KcGongkaike:inDataList2){
            KcGongkaike.setDqzt("上课中");
            KcGongkaike.setDqztpx("1");
            kcGongkaikeService.updateById(KcGongkaike);
        }

    }

    /**
     * 无参定时任务实现
     */
    public void run(){
        run(null);
    }

}
