package org.jeecg.modules.kc.grab.SynchronizationService;

import cn.hutool.core.convert.Convert;
import cn.hutool.core.net.url.UrlBuilder;
import cn.hutool.core.util.CharsetUtil;
import cn.hutool.crypto.SecureUtil;
import cn.hutool.http.HttpUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.beust.jcommander.internal.Sets;
import com.google.common.collect.Maps;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.jeecg.common.util.RedisUtil;
import org.jeecg.modules.kc.grab.SynchronizationService.base.BaseSync;
import org.jeecg.modules.kc.jiaoshi.controller.KcZhihuijiaoshiController;
import org.jeecg.modules.kc.jiaoshi.entity.KcZhihuijiaoshi;
import org.jeecg.modules.kc.jiaoshi.entity.KcZhihuijiaoshiMonitorLog;
import org.jeecg.modules.kc.jiaoshi.entity.KcZhihuijiaoshiOperateLog;
import org.jeecg.modules.kc.jiaoshi.entity.KcZhihuijiaoshiStateLog;
import org.jeecg.modules.kc.jiaoshi.service.IKcZhihuijiaoshiMonitorLogService;
import org.jeecg.modules.kc.jiaoshi.service.IKcZhihuijiaoshiOperateLogService;
import org.jeecg.modules.kc.jiaoshi.service.IKcZhihuijiaoshiService;
import org.jeecg.modules.kc.jiaoshi.service.IKcZhihuijiaoshiStateLogService;
import org.quartz.JobExecutionContext;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.*;
import java.util.stream.Collectors;

@Slf4j
@Component
public class RefreshLiveServer extends BaseSync {

    @Autowired
    private IKcZhihuijiaoshiService kcZhihuijiaoshiService;

    @Autowired
    private KcZhihuijiaoshiController kcZhihuijiaoshiController;

    @Autowired
    private IKcZhihuijiaoshiOperateLogService kcZhihuijiaoshiOperateLogService;//真实操作日志

    @Autowired
    private IKcZhihuijiaoshiMonitorLogService kcZhihuijiaoshiMonitorLogService;//操作与状态日志

    @Autowired
    private IKcZhihuijiaoshiStateLogService kcZhihuijiaoshiStateLogService;//直播状态日志

    @Autowired
    private RedisUtil redisUtil;


    /**
     * 若参数变量名修改 QuartzJobController中也需对应修改
     */

    @Override
    public void execute(JobExecutionContext jobExecutionContext)  {
        start();
        run(getParamMap());
        end();
    }

    public void run(Map<String, Object> param){
        //新版，查询当前是否有课
        KcZhihuijiaoshi jiaoshi = new KcZhihuijiaoshi();
        jiaoshi.setXm("教师近景");
        jiaoshi.setChangshang("奥威亚");
        QueryWrapper<KcZhihuijiaoshi> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("xm","教师近景");
        queryWrapper.eq("changshang","奥威亚");
        IPage<KcZhihuijiaoshi> pageList = kcZhihuijiaoshiController.queryPageListN(jiaoshi, 1,-1,queryWrapper);
        Set<String> onList = Sets.newHashSet();
        Set<String> outList = Sets.newHashSet();
        if(pageList != null){
            List<KcZhihuijiaoshi> list = pageList.getRecords();
            //正在上课的数据
            List<KcZhihuijiaoshi> skzList = list.stream().filter(x -> x.getNowIsClass() != null && x.getNowIsClass()).collect(Collectors.toList());
            skzList.forEach(x -> {
                KcZhihuijiaoshiOperateLog operateLog = new KcZhihuijiaoshiOperateLog();
                operateLog.setJxlId(x.getJxlId());//教学楼ID
                operateLog.setJxlName(x.getJxlName());//教学楼名称
                operateLog.setJsbh(x.getJsbh());//教室编号
                operateLog.setJsmc(x.getJsmc());//教室名称
                operateLog.setOperateType("1");//操作类型（打开还是关闭）
                operateLog.setLogType(1);//日志类型
                operateLog.setOperateResultType("0");//调用成功还是失败

                KcZhihuijiaoshiMonitorLog mnitorLog = new KcZhihuijiaoshiMonitorLog();
                mnitorLog.setJxlId(x.getJxlId());//教学楼ID
                mnitorLog.setJxlName(x.getJxlName());//教学楼名称
                mnitorLog.setJsbh(x.getJsbh());//教室编号
                mnitorLog.setJsmc(x.getJsmc());//教室名称
                mnitorLog.setHh(x.getNowIsClassHh());//当前节次
                mnitorLog.setKtId(x.getNowIsClassId());//当前课堂ID
                mnitorLog.setKtName(x.getNowIsClassName());//当前课堂名称
                try {
                    String res = com.xkcoding.http.HttpUtil.get(x.getPullUrl());
                    log.info("返回内容：" + res);//live_setParam_ret=ok
                    //记录日志
                    mnitorLog.setLogType(1);//播放成功
                    onList.add(x.getJsbh());
                } catch (Exception e){
                    outList.add(x.getJsbh());
                    //播放失败
                    //开启
                    log.error(e.getMessage(),e);
                    //打开推送开关
                    //访问。汇总结果
                    //http://${ip}/cgi-bin/plat.cgi?action=9&user=${user}&pwsd=${getMd5Str(pwd)}&command=1
                    String hex = Convert.toHex("live_setParam_enable=1", CharsetUtil.CHARSET_UTF_8);
                    String buildUrl = UrlBuilder.create()
                            .setScheme("http")
                            .setHost(x.getIp())
                            .addPath("/cgi-bin")
                            .addPath("/plat.cgi")
                            .addQuery("action", "9")
                            .addQuery("user", x.getUser())
                            .addQuery("pwsd", SecureUtil.md5(x.getMima()))
                            .addQuery("command", "1")
                            .addQuery("data", hex)
                            .build();
                    log.info("访问奥威亚接口地址"+buildUrl);
                    operateLog.setOperateUrl(buildUrl);//操作URL
                    mnitorLog.setLogType(2);//默认调用成功失败
                    try{
                        String resText = HttpUtil.get(buildUrl);
                        log.info("奥威亚返回接口内容：" + resText);//live_setParam_ret=ok
                        operateLog.setOperateResult(resText);
                        mnitorLog.setLogType(2);//调用成功
                    } catch (Exception e2){
                        log.error(e2.getMessage(),e2);
                        operateLog.setOperateResultType("1");
                        operateLog.setOperateResult(e2.getMessage());
                        mnitorLog.setLogType(3);//调用失败
                    }finally {
                        kcZhihuijiaoshiOperateLogService.save(operateLog);
                    }
                }finally {
                    //保存操作详细日志
                    kcZhihuijiaoshiMonitorLogService.save(mnitorLog);
                }
            });

        }
        UpdateWrapper<KcZhihuijiaoshi> allOutUw = new UpdateWrapper<>();
        allOutUw.set("sfyx", 1);//关闭
        allOutUw.set("update_by","system");
        allOutUw.set("update_time",new Date());
        //allOutUw.notIn("jsbh", Arrays.asList(onList.toArray(), outList.toArray()));
        kcZhihuijiaoshiService.update(allOutUw);

        if(!onList.isEmpty()){
            UpdateWrapper<KcZhihuijiaoshi> onUw = new UpdateWrapper<>();
            onUw.set("sfyx",0);//打开
            onUw.set("update_by","system");
            onUw.set("update_time",new Date());
            onUw.in("jsbh",onList);
            kcZhihuijiaoshiService.update(onUw);
        }

        if(!outList.isEmpty()) {
            UpdateWrapper<KcZhihuijiaoshi> outUw = new UpdateWrapper<>();
            outUw.set("sfyx", 1);//关闭
            outUw.set("update_by","system");
            outUw.set("update_time",new Date());
            outUw.in("jsbh", outList);
            kcZhihuijiaoshiService.update(outUw);
        }
        //同步刷新智慧教室设备刷新时间
        //refreshState(null);
        //refreshState(null);
    }

    /**
     * 刷新日志
     */
    public void refreshState(String jxlName){
        if(StringUtils.isNotBlank(jxlName)){
            redisUtil.set("zhihuijiaos:" + jxlName + ":btnStatus",true,60);
        }else{
            redisUtil.set("zhihuijiaos:all:btnStatus",true,60);
        }
        QueryWrapper<KcZhihuijiaoshi> qw = new QueryWrapper<>();
        //qw.eq("xm","教师近景");
        qw.eq(StringUtils.isNotBlank(jxlName),"jxl_name",jxlName);
        List<KcZhihuijiaoshi> list = kcZhihuijiaoshiService.list(qw);

        //查询旧数据（带标志位的）
        QueryWrapper<KcZhihuijiaoshiStateLog> qrqw = new QueryWrapper<>();
        qrqw.isNotNull("force_state");
        List<KcZhihuijiaoshiStateLog> KcZhihuijiaoshiStateLogList = kcZhihuijiaoshiStateLogService.list(qrqw);
        Map<String, KcZhihuijiaoshiStateLog> KcZhihuijiaoshiStateLogMap = Maps.newHashMap();
        KcZhihuijiaoshiStateLogList.forEach(x -> KcZhihuijiaoshiStateLogMap.put(x.getJsbh(),x));


        //删除旧数据
        QueryWrapper<KcZhihuijiaoshiStateLog> rqw = new QueryWrapper<>();
        rqw.eq(StringUtils.isNotBlank(jxlName),"jxl_name",jxlName);
        kcZhihuijiaoshiStateLogService.remove(rqw);
        Map<String, KcZhihuijiaoshiStateLog> stateLogMap = Maps.newHashMap();

        list.forEach(x -> {
            KcZhihuijiaoshiStateLog stateLog = null;
            if(stateLogMap.containsKey(x.getJsbh())){
                stateLog = stateLogMap.get(x.getJsbh());
            }else{
                KcZhihuijiaoshiStateLog _stateLog = new KcZhihuijiaoshiStateLog();
                _stateLog.setJxlId(x.getJxlId());//教学楼ID
                _stateLog.setJxlName(x.getJxlName());//教学楼名称
                _stateLog.setJsbh(x.getJsbh());//教室编号
                _stateLog.setJsmc(x.getJsmc());//教室名称
                stateLogMap.put(x.getJsbh(),_stateLog);
                stateLog = _stateLog;
            }
            if(KcZhihuijiaoshiStateLogMap.containsKey(x.getJsbh())){
                KcZhihuijiaoshiStateLog log = KcZhihuijiaoshiStateLogMap.get(x.getJsbh());
                stateLog.setForceState(log.getForceState());
            }
            try{
                String res = com.xkcoding.http.HttpUtil.get(x.getPullUrl());
                log.info("返回内容：" + res);
                switch (x.getXm()){
                    case "教师近景": stateLog.setLbzj("green");break;
                    case "教师全景": stateLog.setJsqj("green");break;
                    case "学生全景": stateLog.setXsqj("green");break;
                    case "PPT": stateLog.setPpt("green");break;
                    default:
                }
            } catch (Exception e){
                //失败
                switch (x.getXm()){
                    case "教师近景": stateLog.setLbzj("red");break;
                    case "教师全景": stateLog.setJsqj("red");break;
                    case "学生全景": stateLog.setXsqj("red");break;
                    case "PPT": stateLog.setPpt("red");break;
                    default:
                }
            }

        });
        //重新计算内容
        stateLogMap.forEach((k,v) -> {
            int num = (StringUtils.equals("green",v.getLbzj())?1:0) + (StringUtils.equals("green",v.getJsqj())?1:0) + (StringUtils.equals("green",v.getXsqj())?1:0) + (StringUtils.equals("green",v.getPpt())?1:0);
            v.setGreenNum(num);
            if(num == 4){
                v.setType("green");
            }else if(num == 0){
                v.setType("red");
            }else{
                v.setType("yellow");
            }
            v.setForceState(v.getType());
        });
        kcZhihuijiaoshiStateLogService.saveBatch(stateLogMap.values());
        //更新全部的修改时间(新规则，分批展示时间)
//        UpdateWrapper<KcZhihuijiaoshiStateLog> uqw = new UpdateWrapper<>();
//        uqw.set("create_time",new Date());
//        kcZhihuijiaoshiStateLogService.update(uqw);
        if(StringUtils.isNotBlank(jxlName)){
            redisUtil.del("zhihuijiaos:" + jxlName + ":btnStatus");
        }else{
            redisUtil.del("zhihuijiaos:all:btnStatus");
        }
    }

    /**
     * 无参定时任务实现
     */
    public void run(){
        run(null);
    }

    public void sdjc(String id) {
        QueryWrapper<KcZhihuijiaoshi> qw = new QueryWrapper<>();
        //qw.eq("xm","教师近景");
        qw.eq(StringUtils.isNotBlank(id),"jsbh",id);
        List<KcZhihuijiaoshi> list = kcZhihuijiaoshiService.list(qw);

        //删除旧数据
        QueryWrapper<KcZhihuijiaoshiStateLog> rqw = new QueryWrapper<>();
        rqw.eq(StringUtils.isNotBlank(id),"jsbh",id);
        kcZhihuijiaoshiStateLogService.remove(rqw);
        Map<String, KcZhihuijiaoshiStateLog> stateLogMap = Maps.newHashMap();

        list.forEach(x -> {
            KcZhihuijiaoshiStateLog stateLog = null;
            if(stateLogMap.containsKey(x.getJsbh())){
                stateLog = stateLogMap.get(x.getJsbh());
            }else{
                KcZhihuijiaoshiStateLog _stateLog = new KcZhihuijiaoshiStateLog();
                _stateLog.setJxlId(x.getJxlId());//教学楼ID
                _stateLog.setJxlName(x.getJxlName());//教学楼名称
                _stateLog.setJsbh(x.getJsbh());//教室编号
                _stateLog.setJsmc(x.getJsmc());//教室名称
                stateLogMap.put(x.getJsbh(),_stateLog);
                stateLog = _stateLog;
            }
            try{
                String res = com.xkcoding.http.HttpUtil.get(x.getPullUrl());
                log.info("返回内容：" + res);
                switch (x.getXm()){
                    case "教师近景": stateLog.setLbzj("green");break;
                    case "教师全景": stateLog.setJsqj("green");break;
                    case "学生全景": stateLog.setXsqj("green");break;
                    case "PPT": stateLog.setPpt("green");break;
                    default:
                }
            } catch (Exception e){
                //失败
                switch (x.getXm()){
                    case "教师近景": stateLog.setLbzj("red");break;
                    case "教师全景": stateLog.setJsqj("red");break;
                    case "学生全景": stateLog.setXsqj("red");break;
                    case "PPT": stateLog.setPpt("red");break;
                    default:
                }
            }
        });
        //重新计算内容
        stateLogMap.forEach((k,v) -> {
            int num = (StringUtils.equals("green",v.getLbzj())?1:0) + (StringUtils.equals("green",v.getJsqj())?1:0) + (StringUtils.equals("green",v.getXsqj())?1:0) + (StringUtils.equals("green",v.getPpt())?1:0);
            v.setGreenNum(num);
            if(num == 4){
                v.setType("green");
            }else if(num == 0){
                v.setType("red");
            }else{
                v.setType("yellow");
            }
        });
        kcZhihuijiaoshiStateLogService.saveBatch(stateLogMap.values());
        //更新全部的修改时间(新规则，分批展示时间)
//        UpdateWrapper<KcZhihuijiaoshiStateLog> uqw = new UpdateWrapper<>();
//        uqw.set("create_time",new Date());
//        kcZhihuijiaoshiStateLogService.update(uqw);
//        if(StringUtils.isNotBlank(id)){
//            redisUtil.del("zhihuijiaos:" + jxlName + ":btnStatus");
//        }else{
//            redisUtil.del("zhihuijiaos:all:btnStatus");
//        }
        redisUtil.del("zhihuijiaos:all:btnStatus");
    }
}
