package org.jeecg.modules.kc.grab.SynchronizationService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import lombok.extern.slf4j.Slf4j;
import org.jeecg.common.util.DateUtils;
import org.jeecg.modules.kc.grab.SynchronizationService.base.BaseSync;
import org.jeecg.modules.kc.grab.imports.entity.Xxhbsynclog;
import org.jeecg.modules.kc.kcSysConfig.entity.KcSysConfig;
import org.jeecg.modules.kc.kcSysConfig.service.IKcSysConfigService;
import org.jeecg.modules.kc.ktgl.entity.KcKechengbiao;
import org.jeecg.modules.kc.ktgl.entity.KcKetangbiao;
import org.jeecg.modules.kc.ktgl.service.IKcKechengbiaoService;
import org.jeecg.modules.kc.ktgl.service.IKcKetangbiaoService;
import org.quartz.JobExecutionContext;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;

import java.text.ParseException;
import java.util.*;

/**
 * 更具原始数据表初始化课程表
 */
@Slf4j
public class SyncKcKetangbiao extends BaseSync {


    @Autowired
    private IKcKetangbiaoService kcKetangbiaoService;

    @Autowired
    private IKcSysConfigService kcSysConfigService;

    @Override
    public void execute(JobExecutionContext jobExecutionContext)  {
        start();
        run(getParamMap());
        end();
    }


    /**
     * 有参定时任务实现
     * @param param
     */
    public void run(Map<String, Object> param){

        try {

            //更新历史数据
//            KcKetangbiao kcKetangbiaohis = new KcKetangbiao();
//            kcKetangbiaohis.setTs(DateUtils.formatDate(new Date(),"yyyyMMddHHmmss"));
//            kcKetangbiaoService.saveHis(kcKetangbiaohis);

            KcSysConfig kcSysConfig = kcSysConfigService.getById("1");
            String bxqkssj = kcSysConfig.getBxqkssj();
            String bxqjssj = kcSysConfig.getBxqjssj();
            //保留历史数据但是删除当前学期的数据
            QueryWrapper<KcKetangbiao> queryWrapper = new QueryWrapper<>();
            queryWrapper.ge("skrq",bxqkssj);
            queryWrapper.le("skrq",bxqjssj);
            kcKetangbiaoService.remove(queryWrapper);



            //插入数据
            KcKetangbiao kcKetangbiao = new KcKetangbiao();
            List<KcKetangbiao> list = kcKetangbiaoService.selectSyncList(kcKetangbiao);
            List<KcKetangbiao> arrayList = new ArrayList<>();
            for(int i=0;i<list.size();i++){
                KcKetangbiao kcKetangbiaoOld = list.get(i);
                try {
                    String jkzc[] = kcKetangbiaoOld.getJkzc().split(",");
                    String week = kcKetangbiaoOld.getWeek();
                    for(int j=0;j<jkzc.length;j++){
                        KcKetangbiao kcKetangbiaoAddNew = new KcKetangbiao();
                        int djz = Integer.parseInt(jkzc[j]);
                        BeanUtils.copyProperties(kcKetangbiaoOld,kcKetangbiaoAddNew);
                        kcKetangbiaoAddNew.setId(null);
                        //skrq 生成规则，取本学开始时间（kc_sys_config.bxqkssj）+(jkzc-1)*7+week
                        int addSj = (djz -1 )*7+Integer.parseInt(week)-1;
                        Date date = DateUtils.parseDate(bxqkssj,"yyyy-MM-dd");
                        Calendar c = Calendar.getInstance();
                        c.setTime(date);
                        c.add(Calendar.DAY_OF_MONTH, addSj);
                        String skrq = DateUtils.formatDate(c,"yyyy-MM-dd");
                        kcKetangbiaoAddNew.setSkrq(skrq);
                        kcKetangbiaoAddNew.setDijizhou(djz);
                        arrayList.add(kcKetangbiaoAddNew);
                    }
                }catch (Exception e){
                    e.printStackTrace();
                }
            }
            kcKetangbiaoService.saveBatch(arrayList);

            Xxhbsynclog xxhbsynclog = new Xxhbsynclog();
            xxhbsynclog.setSyncRowNum(String.valueOf(arrayList.size()));
            saveLog(xxhbsynclog, KcKetangbiao.class);
        }catch (Exception e){
            e.printStackTrace();
            Xxhbsynclog xxhbsynclog = new Xxhbsynclog();
            xxhbsynclog.setSyncRowNum(String.valueOf(-1));
            xxhbsynclog.setErrormessage(e.getMessage());
            saveLog(xxhbsynclog, KcKetangbiao.class);
        }
    }

    /**
     * 无参定时任务实现
     */
    public void run(){
        run(null);
    }


    public static void main(String[] args) throws ParseException {
        String week = "4";
        String bxqkssj = "2023-06-12";
        int djz = 2;
        //skrq 生成规则，取本学开始时间（kc_sys_config.bxqkssj）+(jkzc-1)*7+week
        int addSj = (djz -1 )*7+Integer.parseInt(week)-1;
        Date date = DateUtils.parseDate(bxqkssj,"yyyy-MM-dd");
        Calendar c = Calendar.getInstance();
        c.setTime(date);
        c.add(Calendar.DAY_OF_MONTH, addSj);
        String skrq = DateUtils.formatDate(c,"yyyy-MM-dd");
        System.out.println(skrq);
    }
}
