package org.jeecg.modules.kc.grab.SynchronizationService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import lombok.extern.slf4j.Slf4j;
import org.jeecg.common.util.DateUtils;
import org.jeecg.modules.kc.grab.SynchronizationService.base.BaseSync;
import org.jeecg.modules.kc.kcKetangbiaoSkrqLog.entity.KcKetangbiaoSkrqLog;
import org.jeecg.modules.kc.kcKetangbiaoSkrqLog.service.IKcKetangbiaoSkrqLogService;
import org.jeecg.modules.kc.kcSysConfig.entity.KcSysConfig;
import org.jeecg.modules.kc.kcSysConfig.service.IKcSysConfigService;
import org.jeecg.modules.kc.kcXqxnHistory.service.IKcXqxnHistoryService;
import org.jeecg.modules.kc.ktgl.entity.KcKechengbiao;
import org.jeecg.modules.kc.ktgl.entity.KcKetangbiao;
import org.jeecg.modules.kc.ktgl.service.IKcKechengbiaoHisService;
import org.jeecg.modules.kc.ktgl.service.IKcKechengbiaoService;
import org.jeecg.modules.kc.ktgl.service.IKcKetangbiaoHisService;
import org.jeecg.modules.kc.ktgl.service.IKcKetangbiaoService;
import org.quartz.JobExecutionContext;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.*;

/**
 * 更具原始数据表初始化课程表
 */
@Slf4j
public class SyncKcktStatCopy extends BaseSync {

    @Autowired
    private IKcKechengbiaoService kcKechengbiaoService;

    @Autowired
    private IKcSysConfigService kcSysConfigService;

    @Autowired
    private IKcKechengbiaoHisService kcKechengbiaoHisService;

    @Autowired
    private IKcKetangbiaoService kcKetangbiaoService;

    @Autowired
    private IKcKetangbiaoHisService kcKetangbiaoHisService;

    @Autowired
    private IKcXqxnHistoryService kcXqxnHistoryService;

    @Autowired
    private IKcKetangbiaoSkrqLogService kcKetangbiaoSkrqLogService;

    @Override
    public void execute(JobExecutionContext jobExecutionContext)  {
        start();
        run(getParamMap());
        end();
    }


    /**
     * 有参定时任务实现
     * @param param
     */
    public void run(Map<String, Object> param){
        try {

            KcSysConfig kcSysConfig = kcSysConfigService.getById("1");
            Date dateNow = new Date();


            //-----------------修改课程表数据------------------------
            KcKechengbiao kcKechengbiao = new KcKechengbiao();
            kcKechengbiao.setXqxn(kcSysConfig.getFlag1());
//            kcKechengbiao.setSkjs("刘婷");
            List<KcKechengbiao> kckblist = kcKechengbiaoService.getKechengbiaoList(kcKechengbiao);
            for(KcKechengbiao KcKechengbiaoPar:kckblist){
                QueryWrapper<KcKechengbiao> kcKechengbiaoQueryWrapper = new QueryWrapper<>();
                kcKechengbiaoQueryWrapper.eq("kcbh",KcKechengbiaoPar.getKcbh());
                kcKechengbiaoQueryWrapper.eq("kcmc",KcKechengbiaoPar.getKcmc());
                kcKechengbiaoQueryWrapper.eq("jgh",KcKechengbiaoPar.getJgh());
                kcKechengbiaoQueryWrapper.eq("skjs",KcKechengbiaoPar.getSkjs());
                kcKechengbiaoQueryWrapper.eq("rwbh",KcKechengbiaoPar.getRwbh());
                kcKechengbiaoQueryWrapper.eq("kkdwid",KcKechengbiaoPar.getKkdwid());
                kcKechengbiaoQueryWrapper.eq("kcxz",KcKechengbiaoPar.getKcxz());
//                kcKechengbiaoQueryWrapper.eq("skdd",KcKechengbiaoPar.getSkdd());
                kcKechengbiaoQueryWrapper.eq("sksj",KcKechengbiaoPar.getSksj());
                kcKechengbiaoQueryWrapper.eq("jkzc",KcKechengbiaoPar.getJkzc());
                kcKechengbiaoQueryWrapper.eq("xf",KcKechengbiaoPar.getXf());
                kcKechengbiaoQueryWrapper.eq("xnxq",KcKechengbiaoPar.getXnxq());
                kcKechengbiaoQueryWrapper.eq("kcdl",KcKechengbiaoPar.getKcdl());
                List<KcKechengbiao> KcKechengbiaoInsList = kcKechengbiaoService.list(kcKechengbiaoQueryWrapper);
                if(KcKechengbiaoInsList!=null&&KcKechengbiaoInsList.size()>0){
                    for(KcKechengbiao KcKechengbiao : KcKechengbiaoInsList){
                        String id = KcKechengbiao.getId();
                        BeanUtils.copyProperties(KcKechengbiaoPar,KcKechengbiao);
                        KcKechengbiao.setId(id);
                        kcKechengbiaoService.updateById(KcKechengbiao);
                    }
                }else{
                    kcKechengbiaoService.saveOne(KcKechengbiaoPar);
                }
            }
            //-----------------初始化数据------------------------

            //------------------去除课程表重复数据 20231024新增-----------------
            KcKechengbiao KcKechengbiao = new KcKechengbiao();
            KcKechengbiao.setXqxn(kcSysConfig.getFlag1());
            kcKechengbiaoService.removeCfsj(KcKechengbiao);
            //------------------去除课程表重复数据 20231024新增-----------------



            //-----------------所有的数据都变成无效 20240321------------
//            KcKechengbiao kcbAll = new KcKechengbiao();
//            kcbAll.setXnxq(kcSysConfig.getFlag1());
//            kcKechengbiaoService.updateAllFlag(kcbAll);//所有的数据都变成无效
//            kcKechengbiaoService.updateYxByXxhbkckb(kcbAll);//根据条件变成有效数据

            //-----------------所有的数据都变成无效 20240321------------



            //------------------刨除指定表的数据 20240314新增 修改flag标志位----------------
            KcKechengbiao ktbExculde = new KcKechengbiao();
            ktbExculde.setXnxq(kcSysConfig.getFlag1());
            kcKechengbiaoService.updateKechengExculde(ktbExculde);
            //------------------刨除指定表的数据 20240314新增 修改flag标志位----------------




            //-------------------删除本年的课程数据冰倩是当天及以后的----------------------
            QueryWrapper<KcKetangbiao> KcKetangbiaoQueryWrapper = new QueryWrapper<>();
            KcKetangbiaoQueryWrapper.eq("xnxq",kcSysConfig.getFlag1());
            KcKetangbiaoQueryWrapper.ge("skrq",DateUtils.formatDate(dateNow,"yyyy-MM-dd"));
            kcKetangbiaoService.remove(KcKetangbiaoQueryWrapper);
            //-------------------删除本年的课程数据冰倩是当天及以后的----------------------

            String bxqkssj = kcSysConfig.getBxqkssj();
            //插入数据
            KcKetangbiao kcKetangbiao = new KcKetangbiao();
            kcKetangbiao.setXnxq(kcSysConfig.getFlag1());
            kcKetangbiao.setFlag("0");
            List<KcKetangbiao> list = kcKetangbiaoService.selectSyncList(kcKetangbiao);
            List<KcKetangbiao> arrayList = new ArrayList<>();
            for(int i=0;i<list.size();i++){
                KcKetangbiao kcKetangbiaoOld = list.get(i);
                try {
                    String jkzc[] = kcKetangbiaoOld.getJkzc().split(",");
                    String week = kcKetangbiaoOld.getWeek();
                    for(int j=0;j<jkzc.length;j++){
                        KcKetangbiao kcKetangbiaoAddNew = new KcKetangbiao();
                        int djz = Integer.parseInt(jkzc[j]);
                        BeanUtils.copyProperties(kcKetangbiaoOld,kcKetangbiaoAddNew);
                        kcKetangbiaoAddNew.setId(null);
                        //skrq 生成规则，取本学开始时间（kc_sys_config.bxqkssj）+(jkzc-1)*7+week
                        int addSj = (djz -1 )*7+Integer.parseInt(week)-1;
                        Date date = DateUtils.parseDate(bxqkssj,"yyyy-MM-dd");
                        Calendar c = Calendar.getInstance();
                        c.setTime(date);
                        c.add(Calendar.DAY_OF_MONTH, addSj);
                        String skrq = DateUtils.formatDate(c,"yyyy-MM-dd");
                        String dasj = DateUtils.formatDate(dateNow,"yyyy-MM-dd");
                        //判断生成数据的skrq是否大于等于当前日期，如果满足则进行新增，否则不动
                        if(DateUtils.parseDate(skrq,"yyyy-MM-dd").getTime()>=DateUtils.parseDate(dasj,"yyyy-MM-dd").getTime()){
                            kcKetangbiaoAddNew.setSkrq(skrq);
                            kcKetangbiaoAddNew.setDijizhou(djz);
                            kcKetangbiaoAddNew.setXnxq(kcSysConfig.getFlag1());
                            arrayList.add(kcKetangbiaoAddNew);
                        }
                    }
                }catch (Exception e){
                    e.printStackTrace();
                }
            }
            kcKetangbiaoService.saveBatch(arrayList);

            //修改智慧教室关联的课堂表id-- 清洗智慧教室数据
            kcKetangbiaoService.updateJsbh();

            //修改智慧教室关联的课堂表id-- 清洗智慧教室数据
            KcKetangbiao kcKetangbiaoup = new KcKetangbiao();
            kcKetangbiaoup.setSkxs(1);
            kcKetangbiaoup.setXnxq(kcSysConfig.getFlag1());
            kcKetangbiaoService.updateSkxs(kcKetangbiaoup);

            //修改调停课时间
            String dasj = DateUtils.formatDate(dateNow,"yyyy-MM-dd");

            QueryWrapper<KcKetangbiaoSkrqLog> kcKetangbiaoSkrqLogQueryWrapper = new QueryWrapper<>();
            kcKetangbiaoSkrqLogQueryWrapper.ge("jsrq",dasj);
            List<KcKetangbiaoSkrqLog> list1 = kcKetangbiaoSkrqLogService.list(kcKetangbiaoSkrqLogQueryWrapper);
            for(KcKetangbiaoSkrqLog KcKetangbiaoSkrqLog:list1){
                UpdateWrapper<KcKetangbiao> KcKetangbiaoUpdateWrapper = new UpdateWrapper<>();
                KcKetangbiaoUpdateWrapper.set("skrq",KcKetangbiaoSkrqLog.getTzrq());
                KcKetangbiaoUpdateWrapper.eq("skrq",KcKetangbiaoSkrqLog.getSkrq());
                kcKetangbiaoService.update(KcKetangbiaoUpdateWrapper);
            }
        }catch (Exception e){
            e.printStackTrace();
        }
    }

    /**
     * 无参定时任务实现
     */
    public void run(){
        run(null);
    }

}
