package org.jeecg.modules.kc.grab.SynchronizationService;

import cn.hutool.core.date.DateField;
import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.jeecg.modules.kc.grab.SynchronizationService.base.BaseSync;
import org.jeecg.modules.kc.grab.imports.entity.Xxhbsynclog;
import org.jeecg.modules.kc.kcMessagelistcopy.entity.KcMessagelistcopy;
import org.jeecg.modules.kc.kcMessagelistcopy.service.IKcMessagelistcopyService;
import org.quartz.JobExecutionContext;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.Map;

@Slf4j
public class SyncMessageList extends BaseSync {

    @Autowired
    private IKcMessagelistcopyService impService;

    /**
     * 若参数变量名修改 QuartzJobController中也需对应修改
     */

    @Override
    public void execute(JobExecutionContext jobExecutionContext)  {
        start();
        run(getParamMap());
        end();
    }


    /**
     * 有参定时任务实现
     * @param param
     */
    public void run(Map<String, Object> param){
//        int offsetDay = 1;
        //明天
        DateTime now = DateUtil.date();
        if(param != null){
            if(StringUtils.isNotBlank((String)param.get("nowDay"))){
                now = DateUtil.parse((String)param.get("nowDay"), "yyyy-MM-dd");
            }
        }
        //今天下午
        String todayStr = now.toDateStr() + " 16:00";
        DateTime nextDate = DateUtil.offset(now, DateField.DAY_OF_MONTH, 1);
        String nextStr = nextDate.toDateStr();

        int rowNum = impService.insertTx(nextStr,todayStr);

//        impService.insertStudentClass(nextStr);
//        impService.insertTeacherClass(nextStr);
//
//        impService.insertStudentNextDayClass(nextStr,todayStr);
//        impService.insertTeacherNextDayClass(nextStr,todayStr);

        //保存到胃
//        impService.syncList(outDataList);

        Xxhbsynclog xxhbsynclog = new Xxhbsynclog();
        xxhbsynclog.setSyncRowNum(String.valueOf(rowNum));
        saveLog(xxhbsynclog, KcMessagelistcopy.class);
    }

    /**
     * 无参定时任务实现
     */
    public void run(){
        run(null);
    }

}
