package org.jeecg.modules.kc.grab.SynchronizationService;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.date.DatePattern;
import cn.hutool.core.date.DateUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.google.common.collect.Maps;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.compress.utils.Lists;
import org.apache.commons.lang3.StringUtils;
import org.jeecg.modules.kc.grab.SynchronizationService.base.BaseSync;
import org.jeecg.modules.kc.grab.SynchronizationService.tools.ChangeTingKeTongJi;
import org.jeecg.modules.kc.grab.imports.entity.Xxhbbkjxtkpj;
import org.jeecg.modules.kc.grab.imports.entity.Xxhbsynclog;
import org.jeecg.modules.kc.grab.log.entity.KcOldEvaluationansBad;
import org.jeecg.modules.kc.grab.log.entity.KcOldEvaluationansGood;
import org.jeecg.modules.kc.grab.log.entity.XxhbbkjxtkpjBadLog;
import org.jeecg.modules.kc.grab.log.service.IKcOldEvaluationansBadService;
import org.jeecg.modules.kc.grab.log.service.IKcOldEvaluationansGoodService;
import org.jeecg.modules.kc.grab.log.service.IXxhbbkjxtkpjBadLogService;
import org.jeecg.modules.kc.ktgl.entity.KcKetangbiao;
import org.jeecg.modules.kc.ktgl.service.IKcKetangbiaoService;
import org.jeecg.modules.kc.qa.entity.*;
import org.jeecg.modules.kc.qa.service.*;
import org.quartz.JobExecutionContext;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.List;
import java.util.Map;

import static cn.hutool.core.date.DatePattern.*;

/**
 * 同步旧版本调查问卷
 */
@Slf4j
public class SyncOldEvaluation extends BaseSync {

    @Autowired
    private IKcKetangbiaoService kcKetangbiaoService;

    //----------------------------------旧系统------------------------------------------
    @Autowired
    private IKcOldEvaluationansService kcOldEvaluationansService;//旧系统答案（混合）

    @Autowired
    private IKcOldEvaluationqueService kcOldEvaluationqueService;//旧系统问题（纯问题）

    //----------------------------------旧系统END------------------------------------------

    //----------------------------------正在使用------------------------------------------

    @Autowired
    private IKcEvaluationansService kcEvaluationansService;//正在使用答案（纯答案）

    @Autowired
    private IKcEvaluationqueService kcEvaluationqueService;//正在使用问题（纯问题）

    @Autowired
    private IKcEvaluationService kcEvaluationService;//正在使用问题（回答主表）

    @Autowired
    private IKcEvaluationsService kcEvaluationsService;//正在使用问题(回答明细子表)

    //----------------------------------正在使用END------------------------------------------

    //----------------------------------政务大厅------------------------------------------
    //----------------------------------政务大厅END------------------------------------------

    //----------------------------------纸质评价（后台导入）------------------------------------------
    //----------------------------------纸质评价（后台导入）END------------------------------------------

    @Autowired
    private ChangeTingKeTongJi changeTingKeTongJi;

    @Autowired
    private IKcOldEvaluationansBadService kcOldEvaluationansBadService;

    @Autowired
    private IKcOldEvaluationansGoodService kcOldEvaluationansGoodService;


    Map<String,String> queOptionMap = Maps.newHashMap();
    Map<String,String> ansOptionMap = Maps.newHashMap();

    /**
     * 若参数变量名修改 QuartzJobController中也需对应修改
     */

    @Override
    public void execute(JobExecutionContext jobExecutionContext)  {
        start();
        run(getParamMap());
        end();
    }


    /**
     * 有参定时任务实现
     * @param param
     */
    public void run(Map<String, Object> param){

        initOptionMap();
        //旧版本
        washOldData(param);

        Xxhbsynclog xxhbsynclog = new Xxhbsynclog();
        xxhbsynclog.setSyncRowNum("1");
        saveLog(xxhbsynclog, KcOldEvaluationque.class);
    }

    /**
     * 无参定时任务实现
     */
    public void run(){
        run(null);
    }

    public void initOptionMap (){
//        optionMap.put("0","A");
//        optionMap.put("1","B");
//        optionMap.put("2","C");
//        optionMap.put("3","D");
//        optionMap.put("4","E");

        //序号，问题ID
        queOptionMap.put("1","23");//讲课有热情，精神饱满，能调动学生情绪，课堂气氛活跃
        queOptionMap.put("2","24");//教学目标明确，内容丰富，重点突出，语言表达清楚
        queOptionMap.put("3","25");//授课有启发性，能给予学生思考、联想、创新的启迪
        queOptionMap.put("4","26");//能有效利用各种教学媒体，课件或板书使用效果好
        queOptionMap.put("5","27");//仪表得体，按时上下课，严格要求学生
        queOptionMap.put("6","28");//无迟到、早退、旷课现象
        queOptionMap.put("7","29");//课堂教学秩序好，无喧闹、打瞌睡、发短信、玩手机等现象
        queOptionMap.put("8","30");//上课认真听讲、积极思考，主动与老师交流互动
        queOptionMap.put("9","31");//课堂教学总体印象评价
        queOptionMap.put("10","32");//对课堂内容以及其他方面的具体意见或建议

        //问题ID-答案代号，答案ID
        ansOptionMap.put("23-A", "176");
        ansOptionMap.put("23-B", "177");
        ansOptionMap.put("23-C", "178");
        ansOptionMap.put("23-D", "179");
        ansOptionMap.put("23-E", "180");
        ansOptionMap.put("24-A", "181");
        ansOptionMap.put("24-B", "182");
        ansOptionMap.put("24-C", "183");
        ansOptionMap.put("24-D", "184");
        ansOptionMap.put("24-E", "185");
        ansOptionMap.put("25-A", "186");
        ansOptionMap.put("25-B", "187");
        ansOptionMap.put("25-C", "188");
        ansOptionMap.put("25-D", "189");
        ansOptionMap.put("25-E", "190");
        ansOptionMap.put("26-A", "191");
        ansOptionMap.put("26-B", "192");
        ansOptionMap.put("26-C", "193");
        ansOptionMap.put("26-D", "194");
        ansOptionMap.put("26-E", "195");
        ansOptionMap.put("27-A", "196");
        ansOptionMap.put("27-B", "197");
        ansOptionMap.put("27-C", "198");
        ansOptionMap.put("27-D", "199");
        ansOptionMap.put("27-E", "200");
        ansOptionMap.put("28-A", "201");
        ansOptionMap.put("28-B", "202");
        ansOptionMap.put("28-C", "203");
        ansOptionMap.put("28-D", "204");
        ansOptionMap.put("28-E", "205");
        ansOptionMap.put("29-A", "206");
        ansOptionMap.put("29-B", "207");
        ansOptionMap.put("29-C", "208");
        ansOptionMap.put("29-D", "209");
        ansOptionMap.put("29-E", "210");
        ansOptionMap.put("30-A", "211");
        ansOptionMap.put("30-B", "212");
        ansOptionMap.put("30-C", "213");
        ansOptionMap.put("30-D", "214");
        ansOptionMap.put("30-E", "215");
        ansOptionMap.put("31-A", "296");
        ansOptionMap.put("31-B", "297");
        ansOptionMap.put("31-C", "298");
        ansOptionMap.put("31-D", "299");
        ansOptionMap.put("31-E", "300");

    }

    public void washOldData(Map<String, Object> param) {


        int source = 1;

        //删除旧数据
        QueryWrapper<KcEvaluation> kcEvaluation = new QueryWrapper<>();
        kcEvaluation.eq("source",source);
        kcEvaluationService.remove(kcEvaluation);
        QueryWrapper<KcEvaluations> kcEvaluations = new QueryWrapper<>();
        kcEvaluations.eq("source",source);
        kcEvaluationsService.remove(kcEvaluations);

        //删除好的和坏的数据
        QueryWrapper<KcOldEvaluationansBad> bedQw = new QueryWrapper<>();
        kcOldEvaluationansBadService.remove(bedQw);

        QueryWrapper<KcOldEvaluationansGood> goodQw = new QueryWrapper<>();
        kcOldEvaluationansGoodService.remove(goodQw);

        //查询数据
        //筛选符合条件的答案
        QueryWrapper<KcOldEvaluationans> inQw = new QueryWrapper<>();
        inQw.in("ans1","A", "B", "C", "D", "E");
        inQw.in("ans2","A", "B", "C", "D", "E");
        inQw.in("ans3","A", "B", "C", "D", "E");
        inQw.in("ans4","A", "B", "C", "D", "E");
        inQw.in("ans5","A", "B", "C", "D", "E");
        inQw.in("ans6","A", "B", "C", "D", "E");
        inQw.in("ans7","A", "B", "C", "D", "E");
        inQw.in("ans8","A", "B", "C", "D", "E");
        inQw.in("ans9","A", "B", "C", "D", "E");
        List<KcOldEvaluationans> inDataList = kcOldEvaluationansService.list(inQw);
        List<KcEvaluation> saveMainList = Lists.newArrayList();

        List<KcEvaluations> saveChildList = Lists.newArrayList();

        List<KcOldEvaluationansBad> saveBedList = Lists.newArrayList();
        List<KcOldEvaluationansGood> saveGoodList = Lists.newArrayList();

        inDataList.forEach(x -> {
            KcEvaluation main = new KcEvaluation();
            main.setUpDate(DateUtil.parse(x.getPksj(),NORM_DATE_PATTERN));
//            main.setUpTime(DateUtil.parse(x.getPksj(),NORM_TIME_PATTERN));//数据中没有时间，
            main.setUpTimestamp(x.getPksj());

            main.setUpuser(x.getTkjs());
            if(StringUtils.isNotBlank(x.getTkjgh())){
                main.setUpuserid(Integer.parseInt(x.getTkjgh()));
            }

            //main.setMinkcid(x.get);????好像得多条件查询 kcmc kkdw jgh skjs sksj hh skdd tkjgh tkjs

            QueryWrapper<KcKetangbiao> qwKeTang = new QueryWrapper<>();
            qwKeTang.eq("kcmc",x.getKcmc());
//            qwKeTang.eq("kkdw",x.getKkdw());
//            qwKeTang.eq("",x.getJgh());
            qwKeTang.eq("jgh",x.getJgh());
            qwKeTang.eq("skrq",x.getSksj());
//            qwKeTang.eq("hh",x.getHh());
            qwKeTang.eq("skdd",x.getSkdd());
//            qwKeTang.eq("",x.getTkjgh());
//            qwKeTang.eq("",x.getTkjs());
            qwKeTang.last("limit 1");
            KcKetangbiao ketangbiao = kcKetangbiaoService.getOne(qwKeTang);
            if(ketangbiao == null) {
                ketangbiao = new KcKetangbiao();
                log.error("错误的课题");

                //记录错误日志
                KcOldEvaluationansBad bedLog = BeanUtil.toBean(x, KcOldEvaluationansBad.class);
                saveBedList.add(bedLog);
            }else{
                KcOldEvaluationansGood goodLog = BeanUtil.toBean(x, KcOldEvaluationansGood.class);
                saveGoodList.add(goodLog);
            }
            main.setMinkcid(ketangbiao.getId());

            main.setAnswer1(x.getAns1());
            main.setAnswer2(x.getAns2());
            main.setAnswer3(x.getAns3());
            main.setAnswer4(x.getAns4());
            main.setAnswer5(x.getAns5());
            main.setAnswer6(x.getAns6());
            main.setAnswer7(x.getAns7());
            main.setAnswer8(x.getAns8());
            main.setAnswer9(x.getAns9());
            main.setAnswer10(x.getAns10());

            main.setEvaluationver(3);//题版本
            main.setSource(source);//老版本
            saveMainList.add(main);
            //子数据
            //100004	2022-09-06	14:31:00	杨霞	2010900015	2022-09-06 14:31:42	193359	11	75		4568	0
//            String optionId1 = queOptionMap.get(main.getAnswer1());
//            String optionId2 = queOptionMap.get(main.getAnswer2());
//            String optionId3 = queOptionMap.get(main.getAnswer3());
//            String optionId4 = queOptionMap.get(main.getAnswer5());
//            String optionId5 = queOptionMap.get(main.getAnswer6());
//            String optionId6 = queOptionMap.get(main.getAnswer7());
//            String optionId7 = queOptionMap.get(main.getAnswer8());
//            String optionId8 = queOptionMap.get(main.getAnswer9());
//            String optionId9 = queOptionMap.get(main.getAnswer10());

            kcEvaluationService.save(main);
            //添加听课日志
            if(StringUtils.isNotBlank(main.getMinkcid())){
                changeTingKeTongJi.addTingKeData(String.valueOf(main.getUpuserid()),main.getMinkcid(),main.getUpDate());
            }

            for (int i = 1; 10 >= i; i++){
                String optionId = "";
                String ansKey = "";
                switch (i) {
                    case 1: optionId = queOptionMap.get("1"); ansKey = main.getAnswer1(); break;
                    case 2: optionId = queOptionMap.get("2"); ansKey = main.getAnswer2(); break;
                    case 3: optionId = queOptionMap.get("3"); ansKey = main.getAnswer3(); break;
                    case 4: optionId = queOptionMap.get("4"); ansKey = main.getAnswer4(); break;
                    case 5: optionId = queOptionMap.get("5"); ansKey = main.getAnswer5(); break;
                    case 6: optionId = queOptionMap.get("6"); ansKey = main.getAnswer6(); break;
                    case 7: optionId = queOptionMap.get("7"); ansKey = main.getAnswer7(); break;
                    case 8: optionId = queOptionMap.get("8"); ansKey = main.getAnswer8(); break;
                    case 9: optionId = queOptionMap.get("9"); ansKey = main.getAnswer9(); break;
                    case 10: optionId = queOptionMap.get("10"); ansKey = main.getAnswer10(); break;
                }
                KcEvaluations child = new KcEvaluations();
                child.setUpDate(DateUtil.parse(x.getPksj(),NORM_DATE_PATTERN));
//                child.setUpTime(DateUtil.parse(x.getPksj(),NORM_TIME_PATTERN));
                child.setUpTimestamp(x.getPksj());
                child.setUpuser(x.getTkjs());
                child.setUpuserid(x.getTkjgh());
                child.setKetangbiaoid(ketangbiao.getId());//用上面的ID

                child.setQueid(Integer.parseInt(optionId));//问题ID

                if(i == 10){
                    child.setAnsid(0);
                    child.setTextanscontent(ansKey);//多行文本型答案内容
                }else {
                    String ansId = ansOptionMap.get(optionId+"-"+ansKey);
                    if(StringUtils.isNotBlank(ansId)){
                        child.setAnsid(Integer.parseInt(ansId));//答案ID
                    }
                }
                //child.setEvaluationid("3");
                child.setEvaluationid(main.getId());
                child.setSource(source);//老版本
                saveChildList.add(child);

            }


        });

        //kcEvaluationService.saveBatch(saveMainList);
        kcEvaluationsService.saveBatch(saveChildList);

        //查出答案不对劲的数据
        QueryWrapper<KcOldEvaluationans> bedSaveQw = new QueryWrapper<>();

        bedSaveQw.apply("(ans1 not in('A','B','C','D','E') or ans1 is null or ans1 = '')" +
                "or (ans2 not in('A','B','C','D','E') or ans2 is null or ans2 = '')" +
                "or (ans3 not in('A','B','C','D','E') or ans3 is null or ans3 = '')" +
                "or (ans4 not in('A','B','C','D','E') or ans4 is null or ans4 = '')" +
                "or (ans5 not in('A','B','C','D','E') or ans5 is null or ans5 = '')" +
                "or (ans6 not in('A','B','C','D','E') or ans6 is null or ans6 = '')" +
                "or (ans7 not in('A','B','C','D','E') or ans7 is null or ans7 = '')" +
                "or (ans8 not in('A','B','C','D','E') or ans8 is null or ans8 = '')" +
                "or (ans9 not in('A','B','C','D','E') or ans9 is null or ans9 = '')");
//        bedSaveQw
//        .notIn("ans1","A", "B", "C", "D", "E").or()
//        .notIn("ans2","A", "B", "C", "D", "E").or()
//        .notIn("ans3","A", "B", "C", "D", "E").or()
//        .notIn("ans4","A", "B", "C", "D", "E").or()
//        .notIn("ans5","A", "B", "C", "D", "E").or()
//        .notIn("ans6","A", "B", "C", "D", "E").or()
//        .notIn("ans7","A", "B", "C", "D", "E").or()
//        .notIn("ans8","A", "B", "C", "D", "E").or()
//        .notIn("ans9","A", "B", "C", "D", "E");
        List<KcOldEvaluationans> bedList = kcOldEvaluationansService.list(bedSaveQw);

        if(bedList != null){
            bedList.forEach(x -> saveBedList.add(BeanUtil.toBean(x, KcOldEvaluationansBad.class)));
        }
        if(saveBedList != null){
            kcOldEvaluationansBadService.saveBatch(saveBedList);
        }

        if(saveGoodList != null){
            kcOldEvaluationansGoodService.saveBatch(saveGoodList);
        }

        changeTingKeTongJi.changeTingKeTongji();

        //        List<KcEvaluationque> saveList = Lists.newArrayList();
//
//
//        //删除旧数据
//        QueryWrapper<KcEvaluationque> rqw = new QueryWrapper<>();
//        rqw.eq("source",1);
//        kcEvaluationqueService.remove(rqw);
//
//        inDataList.forEach(x -> {
//            KcEvaluationque que = new KcEvaluationque();
//            que.setContent(x.getContent());
//            que.setStatus(x.getStatus());
//            que.setGenre(x.getGenre());
//            que.setOrdernum(x.getOrdernum());
//            que.setQuetype(x.getQuetype());
//            que.setIsrequire(x.getIsrequire());
//            que.setEvaluationver(x.getEvaluationver());
//            que.setSource(1);
//            saveList.add(que);
//        });
//
//        kcEvaluationqueService.saveBatch(saveList);

        //有ID了，清洗数据

    }

}
