package org.jeecg.modules.kc.grab.SynchronizationService;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.compress.utils.Lists;
import org.apache.commons.lang3.StringUtils;
import org.jeecg.common.util.DateUtils;
import org.jeecg.modules.kc.grab.SynchronizationService.base.BaseSync;
import org.jeecg.modules.kc.grab.exports.entity.TFwdtBkjxtkpj;
import org.jeecg.modules.kc.grab.exports.service.ITFwdtBkjxtkpjService;
import org.jeecg.modules.kc.grab.imports.entity.Xxhbbkjxtkpj;
import org.jeecg.modules.kc.grab.imports.entity.Xxhbsynclog;
import org.jeecg.modules.kc.grab.imports.service.IXxhbbkjxtkpjService;
import org.jeecg.modules.kc.ktgl.service.IKcKetangbiaoService;
import org.jeecg.modules.kc.qa.service.IKcEvaluationService;
import org.jeecg.modules.kc.qa.service.IKcEvaluationsService;
import org.jeecg.modules.quartz.entity.QuartzJob;
import org.jeecg.modules.quartz.service.IQuartzJobService;
import org.quartz.JobExecutionContext;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.Calendar;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * 服务大厅-本科教学服务评价
 */
@Slf4j
public class SyncTFwdtBkjxtkpj extends BaseSync {

    @Autowired
    private ITFwdtBkjxtkpjService tfwdtBkjxtkpjService;

    @Autowired
    private IXxhbbkjxtkpjService xxhbbkjxtkpjService;

    @Autowired
    private IKcEvaluationService kcEvaluationService;

    @Autowired
    private IKcEvaluationsService kcEvaluationsService;

    @Autowired
    private IKcKetangbiaoService kcKetangbiaoService;

    @Autowired
    private IQuartzJobService quartzJobService;

    /**
     * 若参数变量名修改 QuartzJobController中也需对应修改
     */

    @Override
    public void execute(JobExecutionContext jobExecutionContext) {
        start();
        run(getParamMap());
        end();
    }


    /**
     * 有参定时任务实现
     * @param param
     */
    public void run(Map<String, Object> param){

        DateTime now = DateUtil.date();

        boolean isAll = false;
        if(param != null){
            if(param.containsKey("isAll")){
                String isAllStr = (String)param.get("isAll");
                if(StringUtils.isNotBlank(isAllStr)){
                    isAll = Boolean.parseBoolean(isAllStr);
                }
            }
            if(param.containsKey("nowDay")){
                String nowDayStr = (String)param.get("nowDay");
                if(StringUtils.isNotBlank(nowDayStr)){
                    now = DateUtil.parse(nowDayStr, "yyyy-MM-dd");
                }
            }

        }

        //查询数据
        Date date = now;//获取当前时间
        Calendar calendar = Calendar.getInstance();
        calendar.setTime(date);
        calendar.add(Calendar.DAY_OF_MONTH, -1);//当前时间前去一天
        QueryWrapper<TFwdtBkjxtkpj> queryWrapper = new QueryWrapper<>();
//        queryWrapper.like("timestamps", DateUtils.formatDate(calendar.getTime(),"yyyy-MM-dd"));//增量数据
        String nowStr = DateUtils.formatDate(calendar.getTime(),"yyyy-MM-dd");
        if(!isAll){
//            queryWrapper.between("timestamps","to_date('"+nowStr+" 00:00:00', 'yyyy-MM-dd HH24:MI:SS')","to_date('"+nowStr+" 00:00:00', 'yyyy-MM-dd HH24:MI:SS')");
            queryWrapper.apply("timestamps between to_date('"+nowStr+" 00:00:00', 'yyyy-MM-dd HH24:MI:SS') and to_date('"+nowStr+" 23:59:59', 'yyyy-MM-dd HH24:MI:SS')");
        }
        List<TFwdtBkjxtkpj> inDataList = tfwdtBkjxtkpjService.list(queryWrapper);
        List<Xxhbbkjxtkpj> outDataList = Lists.newArrayList();

        //清洗数据
        inDataList.forEach(x -> outDataList.add(BeanUtil.toBean(x, Xxhbbkjxtkpj.class)));

        QueryWrapper<Xxhbbkjxtkpj> xxhbbkjxtkpjQw = new QueryWrapper<>();
        //xxhbbkjxtkpjQw.between("timestamps","str_to_date('"+nowStr+"', '%Y-%m-%d')","str_to_date('"+nowStr+"', '%Y-%m-%d')");
        if(!isAll) {
            xxhbbkjxtkpjQw.apply("timestamps between str_to_date('" + nowStr + "', '%Y-%m-%d') and str_to_date('" + nowStr + "', '%Y-%m-%d')");
        }
        xxhbbkjxtkpjService.remove(xxhbbkjxtkpjQw);
        //保存到胃
        xxhbbkjxtkpjService.syncList(outDataList,false);

//        for(Xxhbbkjxtkpj xxhbbkjxtkpj : outDataList){
//            KcEvaluation kcEvaluation = new KcEvaluation();
//            kcEvaluation.setUpDate(xxhbbkjxtkpj.getTimestamps());
//            kcEvaluation.setUpTime(xxhbbkjxtkpj.getTimestamps());
//            kcEvaluation.setUpuser(xxhbbkjxtkpj.getTkrxm());
//            kcEvaluation.setUpuserid(Integer.parseInt(xxhbbkjxtkpj.getTkrgh()));
//            kcEvaluation.setUpTimestamp(DateUtils.formatDate(xxhbbkjxtkpj.getTimestamps(),"yyyy-MM-dd HH:mm:ss"));
//            kcEvaluation.setEvaluationver(5);
//
//            QueryWrapper<KcKetangbiao> ktqueryWrapper = new QueryWrapper<>();
//            ktqueryWrapper.eq("kcbh",xxhbbkjxtkpj.getKcbh());
//            List<KcKetangbiao> listKt = kcKetangbiaoService.list(ktqueryWrapper);
//            KcKetangbiao kcKetangbiao = new KcKetangbiao();
//            if(listKt!=null && listKt.size()>0){
//                kcKetangbiao = listKt.get(0);
//            }else{
//                continue;
//            }
//
//            kcEvaluation.setMinkcid(Integer.parseInt(kcKetangbiao.getId()));
//            kcEvaluationService.save(kcEvaluation);
//
//            List<KcEvaluations> kcEvaluationsList = new ArrayList<>();
//
//            KcEvaluations kcEvaluations = new KcEvaluations();
//            if(StringUtils.isNotBlank(xxhbbkjxtkpj.getJspg1())){
//                kcEvaluations = new KcEvaluations();
//                kcEvaluations.setUpDate(xxhbbkjxtkpj.getTimestamps());
//                kcEvaluations.setUpTime(xxhbbkjxtkpj.getTimestamps());
//                kcEvaluations.setUpuser(xxhbbkjxtkpj.getTkrxm());
//                kcEvaluations.setUpuserid(Integer.parseInt(xxhbbkjxtkpj.getTkrgh()));
//                kcEvaluations.setUpTimestamp(DateUtils.formatDate(xxhbbkjxtkpj.getTimestamps(),"yyyy-MM-dd HH:mm:ss"));
//                kcEvaluations.setKetangbiaoid(kcEvaluation.getMinkcid());
//                kcEvaluations.setEvaluationid(kcEvaluation.getId());
//                kcEvaluations.setId(null);
//                kcEvaluations.setQueid(52);
//                if(StringUtils.equals(xxhbbkjxtkpj.getJspg1(),"A")){
//                    kcEvaluations.setAnsid(301);
//                }else if(StringUtils.equals(xxhbbkjxtkpj.getJspg1(),"B")){
//                    kcEvaluations.setAnsid(302);
//                }else if(StringUtils.equals(xxhbbkjxtkpj.getJspg1(),"C")){
//                    kcEvaluations.setAnsid(303);
//                }else if(StringUtils.equals(xxhbbkjxtkpj.getJspg1(),"D")){
//                    kcEvaluations.setAnsid(304);
//                }else if(StringUtils.equals(xxhbbkjxtkpj.getJspg1(),"E")){
//                    kcEvaluations.setAnsid(305);
//                }
//                kcEvaluations.setTextanscontent("");
//                kcEvaluationsList.add(kcEvaluations);
//            }
//
//            if(StringUtils.isNotBlank(xxhbbkjxtkpj.getJspg2())){
//                kcEvaluations = new KcEvaluations();
//                kcEvaluations.setUpDate(xxhbbkjxtkpj.getTimestamps());
//                kcEvaluations.setUpTime(xxhbbkjxtkpj.getTimestamps());
//                kcEvaluations.setUpuser(xxhbbkjxtkpj.getTkrxm());
//                kcEvaluations.setUpuserid(Integer.parseInt(xxhbbkjxtkpj.getTkrgh()));
//                kcEvaluations.setUpTimestamp(DateUtils.formatDate(xxhbbkjxtkpj.getTimestamps(),"yyyy-MM-dd HH:mm:ss"));
//                kcEvaluations.setKetangbiaoid(kcEvaluation.getMinkcid());
//                kcEvaluations.setEvaluationid(kcEvaluation.getId());
//                kcEvaluations.setId(null);
//                kcEvaluations.setQueid(53);
//                if(StringUtils.equals(xxhbbkjxtkpj.getJspg2(),"A")){
//                    kcEvaluations.setAnsid(306);
//                }else if(StringUtils.equals(xxhbbkjxtkpj.getJspg2(),"B")){
//                    kcEvaluations.setAnsid(307);
//                }else if(StringUtils.equals(xxhbbkjxtkpj.getJspg2(),"C")){
//                    kcEvaluations.setAnsid(308);
//                }else if(StringUtils.equals(xxhbbkjxtkpj.getJspg2(),"D")){
//                    kcEvaluations.setAnsid(309);
//                }else if(StringUtils.equals(xxhbbkjxtkpj.getJspg2(),"E")){
//                    kcEvaluations.setAnsid(310);
//                }
//                kcEvaluations.setTextanscontent("");
//                kcEvaluationsList.add(kcEvaluations);
//            }
//
//            if(StringUtils.isNotBlank(xxhbbkjxtkpj.getJspg3())){
//                kcEvaluations = new KcEvaluations();
//                kcEvaluations.setUpDate(xxhbbkjxtkpj.getTimestamps());
//                kcEvaluations.setUpTime(xxhbbkjxtkpj.getTimestamps());
//                kcEvaluations.setUpuser(xxhbbkjxtkpj.getTkrxm());
//                kcEvaluations.setUpuserid(Integer.parseInt(xxhbbkjxtkpj.getTkrgh()));
//                kcEvaluations.setUpTimestamp(DateUtils.formatDate(xxhbbkjxtkpj.getTimestamps(),"yyyy-MM-dd HH:mm:ss"));
//                kcEvaluations.setKetangbiaoid(kcEvaluation.getMinkcid());
//                kcEvaluations.setEvaluationid(kcEvaluation.getId());
//                kcEvaluations.setId(null);
//                kcEvaluations.setQueid(54);
//                if(StringUtils.equals(xxhbbkjxtkpj.getJspg3(),"A")){
//                    kcEvaluations.setAnsid(311);
//                }else if(StringUtils.equals(xxhbbkjxtkpj.getJspg3(),"B")){
//                    kcEvaluations.setAnsid(312);
//                }else if(StringUtils.equals(xxhbbkjxtkpj.getJspg3(),"C")){
//                    kcEvaluations.setAnsid(313);
//                }else if(StringUtils.equals(xxhbbkjxtkpj.getJspg3(),"D")){
//                    kcEvaluations.setAnsid(314);
//                }else if(StringUtils.equals(xxhbbkjxtkpj.getJspg3(),"E")){
//                    kcEvaluations.setAnsid(315);
//                }
//                kcEvaluations.setTextanscontent("");
//                kcEvaluationsList.add(kcEvaluations);
//            }
//
//            if(StringUtils.isNotBlank(xxhbbkjxtkpj.getJspg4())){
//                kcEvaluations = new KcEvaluations();
//                kcEvaluations.setUpDate(xxhbbkjxtkpj.getTimestamps());
//                kcEvaluations.setUpTime(xxhbbkjxtkpj.getTimestamps());
//                kcEvaluations.setUpuser(xxhbbkjxtkpj.getTkrxm());
//                kcEvaluations.setUpuserid(Integer.parseInt(xxhbbkjxtkpj.getTkrgh()));
//                kcEvaluations.setUpTimestamp(DateUtils.formatDate(xxhbbkjxtkpj.getTimestamps(),"yyyy-MM-dd HH:mm:ss"));
//                kcEvaluations.setKetangbiaoid(kcEvaluation.getMinkcid());
//                kcEvaluations.setEvaluationid(kcEvaluation.getId());
//                kcEvaluations.setId(null);
//                kcEvaluations.setQueid(55);
//                if(StringUtils.equals(xxhbbkjxtkpj.getJspg4(),"A")){
//                    kcEvaluations.setAnsid(316);
//                }else if(StringUtils.equals(xxhbbkjxtkpj.getJspg4(),"B")){
//                    kcEvaluations.setAnsid(317);
//                }else if(StringUtils.equals(xxhbbkjxtkpj.getJspg4(),"C")){
//                    kcEvaluations.setAnsid(318);
//                }else if(StringUtils.equals(xxhbbkjxtkpj.getJspg4(),"D")){
//                    kcEvaluations.setAnsid(319);
//                }else if(StringUtils.equals(xxhbbkjxtkpj.getJspg4(),"E")){
//                    kcEvaluations.setAnsid(320);
//                }
//                kcEvaluations.setTextanscontent("");
//                kcEvaluationsList.add(kcEvaluations);
//            }
//
//            if(StringUtils.isNotBlank(xxhbbkjxtkpj.getJspg5())){
//                kcEvaluations = new KcEvaluations();
//                kcEvaluations.setUpDate(xxhbbkjxtkpj.getTimestamps());
//                kcEvaluations.setUpTime(xxhbbkjxtkpj.getTimestamps());
//                kcEvaluations.setUpuser(xxhbbkjxtkpj.getTkrxm());
//                kcEvaluations.setUpuserid(Integer.parseInt(xxhbbkjxtkpj.getTkrgh()));
//                kcEvaluations.setUpTimestamp(DateUtils.formatDate(xxhbbkjxtkpj.getTimestamps(),"yyyy-MM-dd HH:mm:ss"));
//                kcEvaluations.setKetangbiaoid(kcEvaluation.getMinkcid());
//                kcEvaluations.setEvaluationid(kcEvaluation.getId());
//                kcEvaluations.setId(null);
//                kcEvaluations.setQueid(56);
//                if(StringUtils.equals(xxhbbkjxtkpj.getJspg5(),"A")){
//                    kcEvaluations.setAnsid(321);
//                }else if(StringUtils.equals(xxhbbkjxtkpj.getJspg5(),"B")){
//                    kcEvaluations.setAnsid(322);
//                }else if(StringUtils.equals(xxhbbkjxtkpj.getJspg5(),"C")){
//                    kcEvaluations.setAnsid(323);
//                }else if(StringUtils.equals(xxhbbkjxtkpj.getJspg5(),"D")){
//                    kcEvaluations.setAnsid(324);
//                }else if(StringUtils.equals(xxhbbkjxtkpj.getJspg5(),"E")){
//                    kcEvaluations.setAnsid(325);
//                }
//                kcEvaluations.setTextanscontent("");
//                kcEvaluationsList.add(kcEvaluations);
//            }
//
//            if(StringUtils.isNotBlank(xxhbbkjxtkpj.getXspg1())){
//                kcEvaluations = new KcEvaluations();
//                kcEvaluations.setUpDate(xxhbbkjxtkpj.getTimestamps());
//                kcEvaluations.setUpTime(xxhbbkjxtkpj.getTimestamps());
//                kcEvaluations.setUpuser(xxhbbkjxtkpj.getTkrxm());
//                kcEvaluations.setUpuserid(Integer.parseInt(xxhbbkjxtkpj.getTkrgh()));
//                kcEvaluations.setUpTimestamp(DateUtils.formatDate(xxhbbkjxtkpj.getTimestamps(),"yyyy-MM-dd HH:mm:ss"));
//                kcEvaluations.setKetangbiaoid(kcEvaluation.getMinkcid());
//                kcEvaluations.setEvaluationid(kcEvaluation.getId());
//                kcEvaluations.setId(null);
//                kcEvaluations.setQueid(57);
//                if(StringUtils.equals(xxhbbkjxtkpj.getXspg1(),"A")){
//                    kcEvaluations.setAnsid(326);
//                }else if(StringUtils.equals(xxhbbkjxtkpj.getXspg1(),"B")){
//                    kcEvaluations.setAnsid(327);
//                }else if(StringUtils.equals(xxhbbkjxtkpj.getXspg1(),"C")){
//                    kcEvaluations.setAnsid(328);
//                }else if(StringUtils.equals(xxhbbkjxtkpj.getXspg1(),"D")){
//                    kcEvaluations.setAnsid(329);
//                }else if(StringUtils.equals(xxhbbkjxtkpj.getXspg1(),"E")){
//                    kcEvaluations.setAnsid(330);
//                }
//                kcEvaluations.setTextanscontent("");
//                kcEvaluationsList.add(kcEvaluations);
//            }
//
//            if(StringUtils.isNotBlank(xxhbbkjxtkpj.getXspg2())){
//                kcEvaluations = new KcEvaluations();
//                kcEvaluations.setUpDate(xxhbbkjxtkpj.getTimestamps());
//                kcEvaluations.setUpTime(xxhbbkjxtkpj.getTimestamps());
//                kcEvaluations.setUpuser(xxhbbkjxtkpj.getTkrxm());
//                kcEvaluations.setUpuserid(Integer.parseInt(xxhbbkjxtkpj.getTkrgh()));
//                kcEvaluations.setUpTimestamp(DateUtils.formatDate(xxhbbkjxtkpj.getTimestamps(),"yyyy-MM-dd HH:mm:ss"));
//                kcEvaluations.setKetangbiaoid(kcEvaluation.getMinkcid());
//                kcEvaluations.setEvaluationid(kcEvaluation.getId());
//                kcEvaluations.setId(null);
//                kcEvaluations.setQueid(58);
//                if(StringUtils.equals(xxhbbkjxtkpj.getXspg2(),"A")){
//                    kcEvaluations.setAnsid(331);
//                }else if(StringUtils.equals(xxhbbkjxtkpj.getXspg2(),"B")){
//                    kcEvaluations.setAnsid(332);
//                }else if(StringUtils.equals(xxhbbkjxtkpj.getXspg2(),"C")){
//                    kcEvaluations.setAnsid(333);
//                }else if(StringUtils.equals(xxhbbkjxtkpj.getXspg2(),"D")){
//                    kcEvaluations.setAnsid(334);
//                }else if(StringUtils.equals(xxhbbkjxtkpj.getXspg2(),"E")){
//                    kcEvaluations.setAnsid(335);
//                }
//                kcEvaluations.setTextanscontent("");
//                kcEvaluationsList.add(kcEvaluations);
//            }
//
//            if(StringUtils.isNotBlank(xxhbbkjxtkpj.getXspg3())){
//                kcEvaluations = new KcEvaluations();
//                kcEvaluations.setUpDate(xxhbbkjxtkpj.getTimestamps());
//                kcEvaluations.setUpTime(xxhbbkjxtkpj.getTimestamps());
//                kcEvaluations.setUpuser(xxhbbkjxtkpj.getTkrxm());
//                kcEvaluations.setUpuserid(Integer.parseInt(xxhbbkjxtkpj.getTkrgh()));
//                kcEvaluations.setUpTimestamp(DateUtils.formatDate(xxhbbkjxtkpj.getTimestamps(),"yyyy-MM-dd HH:mm:ss"));
//                kcEvaluations.setKetangbiaoid(kcEvaluation.getMinkcid());
//                kcEvaluations.setEvaluationid(kcEvaluation.getId());
//                kcEvaluations.setId(null);
//                kcEvaluations.setQueid(59);
//                if(StringUtils.equals(xxhbbkjxtkpj.getXspg3(),"A")){
//                    kcEvaluations.setAnsid(336);
//                }else if(StringUtils.equals(xxhbbkjxtkpj.getXspg3(),"B")){
//                    kcEvaluations.setAnsid(337);
//                }else if(StringUtils.equals(xxhbbkjxtkpj.getXspg3(),"C")){
//                    kcEvaluations.setAnsid(338);
//                }else if(StringUtils.equals(xxhbbkjxtkpj.getXspg3(),"D")){
//                    kcEvaluations.setAnsid(339);
//                }else if(StringUtils.equals(xxhbbkjxtkpj.getXspg3(),"E")){
//                    kcEvaluations.setAnsid(340);
//                }
//                kcEvaluations.setTextanscontent("");
//                kcEvaluationsList.add(kcEvaluations);
//            }
//
//
//            if(StringUtils.isNotBlank(xxhbbkjxtkpj.getXspg3())){
//                kcEvaluations = new KcEvaluations();
//                kcEvaluations.setUpDate(xxhbbkjxtkpj.getTimestamps());
//                kcEvaluations.setUpTime(xxhbbkjxtkpj.getTimestamps());
//                kcEvaluations.setUpuser(xxhbbkjxtkpj.getTkrxm());
//                kcEvaluations.setUpuserid(Integer.parseInt(xxhbbkjxtkpj.getTkrgh()));
//                kcEvaluations.setUpTimestamp(DateUtils.formatDate(xxhbbkjxtkpj.getTimestamps(),"yyyy-MM-dd HH:mm:ss"));
//                kcEvaluations.setKetangbiaoid(kcEvaluation.getMinkcid());
//                kcEvaluations.setEvaluationid(kcEvaluation.getId());
//                kcEvaluations.setId(null);
//                kcEvaluations.setQueid(60);
//                if(StringUtils.equals(xxhbbkjxtkpj.getXspg3(),"A")){
//                    kcEvaluations.setAnsid(341);
//                }else if(StringUtils.equals(xxhbbkjxtkpj.getXspg3(),"B")){
//                    kcEvaluations.setAnsid(342);
//                }else if(StringUtils.equals(xxhbbkjxtkpj.getXspg3(),"C")){
//                    kcEvaluations.setAnsid(343);
//                }else if(StringUtils.equals(xxhbbkjxtkpj.getXspg3(),"D")){
//                    kcEvaluations.setAnsid(344);
//                }else if(StringUtils.equals(xxhbbkjxtkpj.getXspg3(),"E")){
//                    kcEvaluations.setAnsid(345);
//                }
//                kcEvaluations.setTextanscontent("");
//                kcEvaluationsList.add(kcEvaluations);
//            }
//
//            if(StringUtils.isNotBlank(xxhbbkjxtkpj.getQtyj())){
//                kcEvaluations = new KcEvaluations();
//                kcEvaluations.setUpDate(xxhbbkjxtkpj.getTimestamps());
//                kcEvaluations.setUpTime(xxhbbkjxtkpj.getTimestamps());
//                kcEvaluations.setUpuser(xxhbbkjxtkpj.getTkrxm());
//                kcEvaluations.setUpuserid(Integer.parseInt(xxhbbkjxtkpj.getTkrgh()));
//                kcEvaluations.setUpTimestamp(DateUtils.formatDate(xxhbbkjxtkpj.getTimestamps(),"yyyy-MM-dd HH:mm:ss"));
//                kcEvaluations.setKetangbiaoid(kcEvaluation.getMinkcid());
//                kcEvaluations.setEvaluationid(kcEvaluation.getId());
//                kcEvaluations.setId(null);
//                kcEvaluations.setQueid(61);
//                kcEvaluations.setAnsid(0);
//                kcEvaluations.setTextanscontent(xxhbbkjxtkpj.getQtyj());
//                kcEvaluationsList.add(kcEvaluations);
//            }
//
//            kcEvaluationsService.saveBatch(kcEvaluationsList);
//
//
//
//        }

        //执行清洗
        QueryWrapper<QuartzJob> jobQw = new QueryWrapper<>();
        jobQw.eq("job_class_name","org.jeecg.modules.kc.grab.SynchronizationService.SyncZwdtEvaluation");
        jobQw.last("limit 1");
        QuartzJob quartzJob = quartzJobService.getOne(jobQw);
        try {
            if(quartzJob != null){
                quartzJobService.execute(quartzJob);
            }
        } catch (Exception e) {
            throw new RuntimeException(e);
        }


        Xxhbbkjxtkpj xxhbshryxx = xxhbbkjxtkpjService.getSumnum();
        int mysqlnum = xxhbshryxx.getMysqlnum();


        Xxhbsynclog xxhbsynclog = new Xxhbsynclog();
//        xxhbsynclog.setTablename("附加定时任务，清洗服务大厅数据");
        xxhbsynclog.setOratabname("T_FWDT_BKJXTKPJ");//oracle表名
        xxhbsynclog.setOratabnum(inDataList.size());//oracle表数量
        xxhbsynclog.setTablenum(mysqlnum);//mysql表数量
        xxhbsynclog.setSyncnum(outDataList.size());//本次同步数据量
        xxhbsynclog.setSynctype("1");//同步类型 0全量  1增量
//        xxhbsynclog.setErrormessage("");
        xxhbsynclog.setSyncRowNum(String.valueOf(outDataList.size()));
        saveLog(xxhbsynclog,Xxhbbkjxtkpj.class);
    }

    /**
     * 无参定时任务实现
     */
    public void run(){
        run(null);
    }

}
