package org.jeecg.modules.kc.grab.SynchronizationService;

import cn.hutool.core.bean.BeanUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.compress.utils.Lists;
import org.apache.commons.lang.StringUtils;
import org.jeecg.modules.kc.grab.SynchronizationService.base.BaseSync;
import org.jeecg.modules.kc.grab.exports.entity.TFwdtShryxx;
import org.jeecg.modules.kc.grab.exports.service.ITFwdtShryxxService;
import org.jeecg.modules.kc.grab.imports.entity.Xxhbbks;
import org.jeecg.modules.kc.grab.imports.entity.Xxhbshryxx;
import org.jeecg.modules.kc.grab.imports.entity.Xxhbsynclog;
import org.jeecg.modules.kc.grab.imports.service.IXxhbshryxxService;
import org.jeecg.modules.kc.tksf.kctksfrzb.entity.KcTksfrzb;
import org.jeecg.modules.kc.tksf.kctksfrzb.service.IKcTksfrzbService;
import org.quartz.JobExecutionContext;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.Arrays;
import java.util.List;
import java.util.Map;

@Slf4j
public class SyncTFwdtShryxx extends BaseSync {

    @Autowired
    private ITFwdtShryxxService expService;

    @Autowired
    private IXxhbshryxxService impService;

    @Autowired
    private IKcTksfrzbService kcTksfrzbService;

    /**
     * 若参数变量名修改 QuartzJobController中也需对应修改
     */

    @Override
    public void execute(JobExecutionContext jobExecutionContext)  {
        start();
        run(getParamMap());
        end();
    }


    /**
     * 有参定时任务实现
     * @param param
     */
    public void run(Map<String, Object> param){
        //查询数据
        List<TFwdtShryxx> inDataList = expService.list();
        List<Xxhbshryxx> outDataList = Lists.newArrayList();

        List<KcTksfrzb> saveList = Lists.newArrayList();

        List<String> whiteList = Arrays.asList("学校教务委员会", "学校督学", "党委书记", "党委副书记", "党委常务副书记", "副处长", "处长", "教务秘书", "本科生辅导员", "校团委书记", "校长", "校领导");
        //清洗数据
        inDataList.forEach(x -> {
            outDataList.add(BeanUtil.toBean(x, Xxhbshryxx.class));
            if(whiteList.contains(x.getZwmc())){
                KcTksfrzb y = new KcTksfrzb();
                y.setGh(StringUtils.trim(x.getGh()));
                y.setXm(StringUtils.trim(x.getXm()));
                y.setZwmc(StringUtils.trim(x.getZwmc()));
                y.setFlag("2");
                saveList.add(y);
            }
        });

        //保存到胃

        //保存到胃
        int syncnum=0;
        String errorMessage = "";
        try {
            impService.syncList(outDataList);
            syncnum = outDataList.size();
        }catch (Exception e){
            e.printStackTrace();
            errorMessage = e.getMessage();
        }






        //删除旧数据

        QueryWrapper<KcTksfrzb> rqw = new QueryWrapper<>();
        rqw.eq("flag",2);
        kcTksfrzbService.remove(rqw);

        kcTksfrzbService.saveBatch(saveList);

        Xxhbshryxx xxhbshryxx = impService.getSumnum();
        int mysqlnum=xxhbshryxx.getMysqlnum();
        Xxhbsynclog xxhbsynclog = new Xxhbsynclog();
        xxhbsynclog.setSyncRowNum(String.valueOf(outDataList.size()));
        xxhbsynclog.setOratabname("T_FWDT_SHRYXX");//oracle表名
        xxhbsynclog.setOratabnum(inDataList.size());//oracle表数量
        xxhbsynclog.setTablenum(mysqlnum);//mysql表数量
        xxhbsynclog.setSyncnum(syncnum);//本次同步数据量
        xxhbsynclog.setSynctype("0");//同步类型 0全量  1增量
        xxhbsynclog.setErrormessage(errorMessage);
        saveLog(xxhbsynclog,Xxhbshryxx.class);

    }

    /**
     * 无参定时任务实现
     */
    public void run(){
        run(null);
    }

}
