package org.jeecg.modules.kc.grab.SynchronizationService;

import cn.hutool.core.bean.BeanUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.compress.utils.Lists;
import org.apache.commons.lang3.StringUtils;
import org.jeecg.modules.kc.grab.SynchronizationService.base.BaseSync;
import org.jeecg.modules.kc.grab.exports.entity.TJwJsjbxx;
import org.jeecg.modules.kc.grab.exports.service.ITJwJsjbxxService;
import org.jeecg.modules.kc.grab.imports.entity.Xxhbjsjbxx;
import org.jeecg.modules.kc.grab.imports.entity.Xxhbsynclog;
import org.jeecg.modules.kc.grab.imports.service.IXxhbjsjbxxService;
import org.jeecg.modules.kc.jiaoshi.entity.KcJiaoxuelouInfo;
import org.jeecg.modules.kc.jiaoshi.service.IKcJiaoxuelouInfoService;
import org.quartz.JobExecutionContext;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.List;
import java.util.Map;

@Slf4j
public class SyncTJwJsjbxxb extends BaseSync {

    @Autowired
    private ITJwJsjbxxService expService;

    @Autowired
    private IXxhbjsjbxxService impService;

    @Autowired
    private IKcJiaoxuelouInfoService kcJiaoxuelouInfoService;

    /**
     * 若参数变量名修改 QuartzJobController中也需对应修改
     */

    @Override
    public void execute(JobExecutionContext jobExecutionContext)  {
        start();
        run(getParamMap());
        end();
    }


    /**
     * 有参定时任务实现
     * @param param
     */
    public void run(Map<String, Object> param){
        //查询数据
        List<TJwJsjbxx> inDataList = expService.list();
        List<Xxhbjsjbxx> outDataList = Lists.newArrayList();

        //清洗数据
        inDataList.forEach(x -> outDataList.add(BeanUtil.toBean(x, Xxhbjsjbxx.class)));


        //保存到胃
        int syncnum=0;
        String errorMessage = "";
        try {
            impService.syncList(outDataList);
            syncnum = outDataList.size();
        }catch (Exception e){
            e.printStackTrace();
            errorMessage = e.getMessage();
        }
        Xxhbjsjbxx Xxhbjsjbxx = impService.getSumnum();
        int mysqlnum=Xxhbjsjbxx.getMysqlnum();
        Xxhbsynclog xxhbsynclog = new Xxhbsynclog();
        xxhbsynclog.setSyncRowNum(String.valueOf(outDataList.size()));
        xxhbsynclog.setOratabname("T_JW_JSJBXX");//oracle表名
        xxhbsynclog.setOratabnum(inDataList.size());//oracle表数量
        xxhbsynclog.setTablenum(mysqlnum);//mysql表数量
        xxhbsynclog.setSyncnum(syncnum);//本次同步数据量
        xxhbsynclog.setSynctype("0");//同步类型 0全量  1增量
        xxhbsynclog.setErrormessage(errorMessage);
        saveLog(xxhbsynclog,Xxhbjsjbxx.class);
        //更新到表里
        List<KcJiaoxuelouInfo> list = kcJiaoxuelouInfoService.list();
        list.forEach(x -> {
            QueryWrapper<Xxhbjsjbxx> qw = new QueryWrapper<>();
            if(StringUtils.equals("净月综合教学楼",x.getJxlhName())){
                qw.apply("jxlh in (select JZWH from xxhbjxljbxx where jzwmc in ('"+x.getJxlhName()+"') and yxh is null)");
            }else{
                qw.apply("jxlh in (select JZWH from xxhbjxljbxx where jzwmc in ('"+x.getJxlhName()+"') and yxh is not null)");
            }
            x.setJsNum(String.valueOf(impService.count(qw)));
        });
        kcJiaoxuelouInfoService.updateBatchById(list);
//        "select count(*) from xxhbjsjbxx where jxlh in (select JZWH from xxhbjxljbxx where jzwmc in ('逸夫教学楼') and yxh is not null);
//        select count(*) from xxhbjsjbxx where jxlh in (select JZWH from xxhbjxljbxx where jzwmc in ('惟真楼') and yxh is not null);
//        select count(*) from xxhbjsjbxx where jxlh in (select JZWH from xxhbjxljbxx where jzwmc in ('净月综合教学楼') and yxh is null);"

    }

    /**
     * 无参定时任务实现
     */
    public void run(){
        run(null);
    }

}
