package org.jeecg.modules.kc.grab.SynchronizationService;

import cn.hutool.core.bean.BeanUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.compress.utils.Lists;
import org.apache.commons.lang3.StringUtils;
import org.jeecg.modules.kc.grab.SynchronizationService.base.BaseSync;
import org.jeecg.modules.kc.grab.exports.entity.TJwKckb;
import org.jeecg.modules.kc.grab.exports.service.ITJwKckbService;
import org.jeecg.modules.kc.grab.imports.entity.Xxhbkckb;
import org.jeecg.modules.kc.grab.imports.entity.Xxhbsynclog;
import org.jeecg.modules.kc.grab.imports.service.IXxhbkckbService;
import org.jeecg.modules.kc.kcJieci.entity.KcJieci;
import org.jeecg.modules.kc.kcJieci.service.IKcJieciService;
import org.jeecg.modules.kc.kcJieciPipei.entity.KcJieciPipei;
import org.jeecg.modules.kc.kcJieciPipei.service.IKcJieciPipeiService;
import org.jeecg.modules.kc.ktgl.entity.KcKechengbiao;
import org.jeecg.modules.kc.xxhbkckbOra.entity.XxhbkckbOra;
import org.jeecg.modules.kc.xxhbkckbOra.service.IXxhbkckbOraService;
import org.quartz.JobExecutionContext;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

@Slf4j
public class SyncTJwKckb extends BaseSync {

    @Autowired
    private ITJwKckbService expService;

    @Autowired
    private IXxhbkckbService impService;
    
    @Autowired
    private IXxhbkckbOraService xxhbkckbOraService;
    
    @Autowired
    private IKcJieciPipeiService kcJieciPipeiService;
    @Autowired
    private IKcJieciService kcJieciService;
    /**
     * 若参数变量名修改 QuartzJobController中也需对应修改
     */

    @Override
    public void execute(JobExecutionContext jobExecutionContext)  {
        start();
        run(getParamMap());
        end();
    }


    /**
     * 有参定时任务实现
     * @param param
     */
    public void run(Map<String, Object> param){
        //查询数据
        List<TJwKckb> inDataList = expService.list();
        List<Xxhbkckb> outDataList = Lists.newArrayList();

        //清洗数据
        inDataList.forEach(x -> outDataList.add(BeanUtil.toBean(x, Xxhbkckb.class)));

//        //保存到胃
//        try {
//            xxhbkckbOraService.syncList(outDataList);
//        }catch (Exception e){
//            e.printStackTrace();
//        }
//
//        //查询异常的节次数据
//        List<XxhbkckbOra> oraList = xxhbkckbOraService.getSksjList();
//        List<KcJieciPipei> kcJieciPipeiList = new ArrayList<>();
//        for(int i=0;i<oraList.size();i++){
//            KcJieciPipei par = new KcJieciPipei();
//            par.setExpCol(oraList.get(i).getSksj());
//            kcJieciPipeiList.add(par);
//        }
//        //不为空则插入数据
//        if(kcJieciPipeiList != null){
//            kcJieciPipeiService.saveBatch(kcJieciPipeiList);
//        }
//
//        //查询全部ora数据
//        List<XxhbkckbOra> list = xxhbkckbOraService.list();
//        List<Xxhbkckb> importDataList = Lists.newArrayList();
//        for(XxhbkckbOra par:list){
//            String sksjArr = par.getSksj();//获取授课事件结合，例如：7010203040506070809101112
//            if(StringUtils.isEmpty(sksjArr)){
//                continue;
//            }
//            String week = sksjArr.substring(0,1);//获取周几上课，例如：7
//            String sksj = sksjArr.substring(1,sksjArr.length());//获取具体的上课节次，例如：010203040506070809101112
//
//            QueryWrapper<KcJieciPipei> kcJieciPipeiQueryWrapper = new QueryWrapper<>();
//            kcJieciPipeiQueryWrapper.eq("exp_col",sksj);
//            kcJieciPipeiQueryWrapper.last("limit 1");
//            KcJieciPipei kcJieciPipei = kcJieciPipeiService.getOne(kcJieciPipeiQueryWrapper);//根据当前节次获取对应的正确节次数据
//            //组装拆分后的数据，封装到xxhbkckb表中
//            if(kcJieciPipei != null && StringUtils.isNotBlank(kcJieciPipei.getNorCol())){
//                String norCol[] = StringUtils.split(kcJieciPipei.getNorCol(),"|");
//                for(String nor : norCol){
//                    Xxhbkckb xxhbkckb = new Xxhbkckb();
//                    BeanUtil.copyProperties(par,xxhbkckb);
//                    xxhbkckb.setId(null);
//                    xxhbkckb.setSksj(week+nor);
//                    importDataList.add(xxhbkckb);
//                }
//            }
//        }
        //保存到胃
        int syncnum=0;
        String errorMessage = "";
        try {
            QueryWrapper dqw = new QueryWrapper();
            impService.remove(dqw);
            impService.syncList(outDataList);
            syncnum = outDataList.size();
        }catch (Exception e){
            e.printStackTrace();
            errorMessage = e.getMessage();
        }

        Xxhbkckb Xxhbkckb = impService.getSumnum();
        int mysqlnum=Xxhbkckb.getMysqlnum();
        Xxhbsynclog xxhbsynclog = new Xxhbsynclog();
        xxhbsynclog.setSyncRowNum(String.valueOf(outDataList.size()));
        xxhbsynclog.setOratabname("T_JW_KCKB");//oracle表名
        xxhbsynclog.setOratabnum(inDataList.size());//oracle表数量
        xxhbsynclog.setTablenum(mysqlnum);//mysql表数量
        xxhbsynclog.setSyncnum(syncnum);//本次同步数据量
        xxhbsynclog.setSynctype("0");//同步类型 0全量  1增量
        xxhbsynclog.setErrormessage(errorMessage);
        saveLog(xxhbsynclog, Xxhbkckb.class);
    }

    /**
     * 无参定时任务实现
     */
    public void run(){
        run(null);
    }

}
