package org.jeecg.modules.kc.grab.SynchronizationService;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.date.DatePattern;
import cn.hutool.core.date.DateUtil;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.compress.utils.Lists;
import org.jeecg.modules.kc.grab.SynchronizationService.base.BaseSync;
import org.jeecg.modules.kc.grab.exports.entity.TJwTkkcb;
import org.jeecg.modules.kc.grab.exports.service.ITJwTkkcbService;
import org.jeecg.modules.kc.grab.imports.entity.Xxhbsynclog;
import org.jeecg.modules.kc.grab.imports.entity.Xxhbtkkcb;
import org.jeecg.modules.kc.grab.imports.service.IXxhbtkkcbService;
import org.quartz.JobExecutionContext;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.List;
import java.util.Map;

@Slf4j
public class SyncTJwTkkcb extends BaseSync {

    @Autowired
    private ITJwTkkcbService expService;

    @Autowired
    private IXxhbtkkcbService impService;

    /**
     * 若参数变量名修改 QuartzJobController中也需对应修改
     */

    @Override
    public void execute(JobExecutionContext jobExecutionContext)  {
        start();
        run(getParamMap());
        end();
    }


    /**
     * 有参定时任务实现
     * @param param
     */
    public void run(Map<String, Object> param){
        //查询数据
        List<TJwTkkcb> inDataList = expService.list();
        List<Xxhbtkkcb> outDataList = Lists.newArrayList();

        //清洗数据
        inDataList.forEach(x -> {
            Xxhbtkkcb outData = BeanUtil.toBean(x, Xxhbtkkcb.class);
            outData.setTimestamps(DateUtil.format(x.getTimestamps(), DatePattern.NORM_DATETIME_PATTERN));
            outDataList.add(outData);
        });

        //保存到胃
        int syncnum=0;
        String errorMessage = "";
        try {
            impService.syncList(outDataList);
            syncnum = outDataList.size();
        }catch (Exception e){
            e.printStackTrace();
            errorMessage = e.getMessage();
        }
        Xxhbtkkcb Xxhbtkkcb = impService.getSumnum();
        int mysqlnum=Xxhbtkkcb.getMysqlnum();
        Xxhbsynclog xxhbsynclog = new Xxhbsynclog();
        xxhbsynclog.setSyncRowNum(String.valueOf(outDataList.size()));
        xxhbsynclog.setOratabname("T_JW_TKKCB");//oracle表名
        xxhbsynclog.setOratabnum(inDataList.size());//oracle表数量
        xxhbsynclog.setTablenum(mysqlnum);//mysql表数量
        xxhbsynclog.setSyncnum(syncnum);//本次同步数据量
        xxhbsynclog.setSynctype("0");//同步类型 0全量  1增量
        xxhbsynclog.setErrormessage(errorMessage);
        saveLog(xxhbsynclog, Xxhbtkkcb.class);
    }

    /**
     * 无参定时任务实现
     */
    public void run(){
        run(null);
    }

}
