package org.jeecg.modules.kc.grab.SynchronizationService;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.date.DatePattern;
import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.compress.utils.Lists;
import org.apache.commons.lang3.StringUtils;
import org.jeecg.modules.kc.grab.SynchronizationService.base.BaseSync;
import org.jeecg.modules.kc.grab.exports.entity.TJwXsxkb;
import org.jeecg.modules.kc.grab.exports.service.ITJwXsxkbService;
import org.jeecg.modules.kc.grab.imports.entity.Xxhbsynclog;
import org.jeecg.modules.kc.grab.imports.entity.Xxhbxsxkb;
import org.jeecg.modules.kc.grab.imports.service.IXxhbxsxkbService;
import org.quartz.JobExecutionContext;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.List;
import java.util.Map;

@Slf4j
public class SyncTJwXsxkb extends BaseSync {

    @Autowired
    private ITJwXsxkbService expService;

    @Autowired
    private IXxhbxsxkbService impService;

    /**
     * 若参数变量名修改 QuartzJobController中也需对应修改
     */

    @Override
    public void execute(JobExecutionContext jobExecutionContext)  {
        start();
        run(getParamMap());
        end();
    }


    /**
     * 有参定时任务实现
     * @param param
     */
    public void run(Map<String, Object> param){
        QueryWrapper eqw = new QueryWrapper();
        QueryWrapper dqw = new QueryWrapper();

        DateTime now = DateTime.now();
        String startDate = "";
        String endDate = "";


        boolean isAll = false;
        boolean isScope = false;
        if(param != null){
            if(param.containsKey("isAll")){//同步全部
                String isAllStr = (String)param.get("isAll");
                if(StringUtils.isNotBlank(isAllStr)){
                    isAll = Boolean.parseBoolean(isAllStr);
                }
            }
            if(param.containsKey("now")){//按照此时间同步
                String keyStr = (String)param.get("now");
                if(StringUtils.isNotBlank(keyStr)){
                    now = DateUtil.parse(keyStr, "yyyy-MM-dd");
                }
            }
            if(param.containsKey("isScope")){//按照范围同步
                String isScopeStr = (String)param.get("isScope");
                if(StringUtils.isNotBlank(isScopeStr)){
                    isScope = Boolean.parseBoolean(isScopeStr);
                    if(isScope){
                        isAll = false;
                        startDate = (String)param.get("startDate");
                        endDate = (String)param.get("endDate");
                    }
                }
            }
        }

        if(!isAll){
            //范围
            if(isScope && StringUtils.isNotBlank(startDate) && StringUtils.isNotBlank(endDate) ){
                //按范围查询
//                eqw.between("timestamps","to_date('"+startDate+" 00:00:00', 'yyyy-MM-dd HH24:MI:SS')","to_date('"+endDate+" 00:00:00', 'yyyy-MM-dd HH24:MI:SS')");
//                dqw.between("timestamps","str_to_date('"+startDate+"', '%Y-%m-%d')","str_to_date('"+endDate+"', '%Y-%m-%d')");
                eqw.apply("timestamps between to_date('"+startDate+" 00:00:00', 'yyyy-MM-dd HH24:MI:SS') and to_date('"+endDate+" 23:59:59', 'yyyy-MM-dd HH24:MI:SS')");
                dqw.apply("timestamps between str_to_date('"+startDate+"', '%Y-%m-%d') and str_to_date('"+endDate+"', '%Y-%m-%d')");
//                eqw.apply("TIMESTAMPS >= to_date('"+startDate+"', 'yyyy-MM-dd')");
//                eqw.apply("TIMESTAMPS < to_date('"+endDate+"','yyyy-MM-dd')");
//                dqw.apply("TIMESTAMPS >= str_to_date('"+startDate+"', 'yyyy-MM-dd')");
//                dqw.apply("TIMESTAMPS < str_to_date('"+endDate+"','yyyy-MM-dd')");
            }else{
                //按天
                String nowStr = now.toDateStr();
//                eqw.between("timestamps","to_date('"+nowStr+" 00:00:00', 'yyyy-MM-dd HH24:MI:SS')","to_date('"+nowStr+" 00:00:00', 'yyyy-MM-dd HH24:MI:SS')");
//                dqw.between("timestamps","str_to_date('"+nowStr+"', '%Y-%m-%d')","str_to_date('"+nowStr+"', '%Y-%m-%d')");
                eqw.apply("timestamps between to_date('"+nowStr+" 00:00:00', 'yyyy-MM-dd HH24:MI:SS') and to_date('"+nowStr+" 23:59:59', 'yyyy-MM-dd HH24:MI:SS')");
                dqw.apply("timestamps between str_to_date('"+nowStr+"', '%Y-%m-%d') and str_to_date('"+nowStr+"', '%Y-%m-%d')");
//                eqw.apply("TIMESTAMPS >= to_date('"+nowStr+"', 'yyyy-MM-dd')");
//                eqw.apply("TIMESTAMPS < to_date('"+nowStr+"','yyyy-MM-dd')");
//                dqw.apply("TIMESTAMPS >= str_to_date('"+nowStr+"', 'yyyy-MM-dd')");
//                dqw.apply("TIMESTAMPS < str_to_date('"+nowStr+"','yyyy-MM-dd')");
            }
        }

//        boolean isDelete = true;
//        if(param != null){
//            if(Boolean.parseBoolean((String)param.get("isToday"))){
//                //如果是今天模式，
//                String nowStr = DateTime.now().toDateStr();
//                eqw.apply("TIMESTAMPS >= to_date('"+nowStr+"', 'yyyy-MM-dd')");
//                eqw.apply("TIMESTAMPS < to_date('"+nowStr+"','yyyy-MM-dd')");
//                dqw.apply("TIMESTAMPS >= str_to_date('"+nowStr+"', 'yyyy-MM-dd')");
//                dqw.apply("TIMESTAMPS < str_to_date('"+nowStr+"','yyyy-MM-dd')");
//                isDelete = false;
//            } else if (Boolean.parseBoolean((String)param.get("isScope"))) {
//                //按照范围查询
//                String startDate = (String)param.get("startDate");
//                String endDate = (String)param.get("endDate");
//                eqw.apply("TIMESTAMPS >= to_date('"+startDate+"', 'yyyy-MM-dd')");
//                eqw.apply("TIMESTAMPS < to_date('"+endDate+"','yyyy-MM-dd')");
//                dqw.apply("TIMESTAMPS >= str_to_date('"+startDate+"', 'yyyy-MM-dd')");
//                dqw.apply("TIMESTAMPS < str_to_date('"+endDate+"','yyyy-MM-dd')");
//                isDelete = false;
//            } else if (Boolean.parseBoolean((String)param.get("isAll"))) {
//                //全部。。。
//            }
//        }
        //查询数据
        List<TJwXsxkb> inDataList = expService.list(eqw);
        List<Xxhbxsxkb> outDataList = Lists.newArrayList();

        //清洗数据
        inDataList.forEach(x -> {
            Xxhbxsxkb outData = BeanUtil.toBean(x, Xxhbxsxkb.class);
            outData.setTimestamps(DateUtil.format(x.getTimestamps(), DatePattern.NORM_DATETIME_PATTERN));
            outDataList.add(outData);

        });

        //保存到胃
        int syncnum=0;
        String errorMessage = "";
        try {
            //删除数据
//            impService.remove(dqw);
            impService.syncList(outDataList,dqw,true);
            syncnum = outDataList.size();
        }catch (Exception e){
            e.printStackTrace();
            errorMessage = e.getMessage();
        }
        Xxhbxsxkb Xxhbxsxkb = impService.getSumnum();
        int mysqlnum=Xxhbxsxkb.getMysqlnum();
        Xxhbsynclog xxhbsynclog = new Xxhbsynclog();
        xxhbsynclog.setSyncRowNum(String.valueOf(outDataList.size()));
        xxhbsynclog.setOratabname("T_JW_XSXKB");//oracle表名
        xxhbsynclog.setOratabnum(inDataList.size());//oracle表数量
        xxhbsynclog.setTablenum(mysqlnum);//mysql表数量
        xxhbsynclog.setSyncnum(syncnum);//本次同步数据量
        xxhbsynclog.setSynctype("1");//同步类型 0全量  1增量
        xxhbsynclog.setErrormessage(errorMessage);
        saveLog(xxhbsynclog,Xxhbxsxkb.class);
    }

    /**
     * 无参定时任务实现
     */
    public void run(){
        run(null);

    }

}
