package org.jeecg.modules.kc.grab.SynchronizationService;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.date.DatePattern;
import cn.hutool.core.date.DateUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.google.common.collect.Maps;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.compress.utils.Lists;
import org.jeecg.modules.kc.config.entity.KcExportConfigTpkwcqkjzglx;
import org.jeecg.modules.kc.config.service.IKcExportConfigTpkwcqkjzglxService;
import org.jeecg.modules.kc.grab.SynchronizationService.base.BaseSync;
import org.jeecg.modules.kc.grab.SynchronizationService.tools.ChangeTingKeTongJi;
import org.jeecg.modules.kc.grab.exports.entity.TJzgXskc;
import org.jeecg.modules.kc.grab.exports.service.ITJzgXskcService;
import org.jeecg.modules.kc.grab.imports.entity.Xxhbsynclog;
import org.jeecg.modules.kc.grab.imports.entity.Xxhbuser;
import org.jeecg.modules.kc.grab.imports.entity.Xxhbxskc;
import org.jeecg.modules.kc.grab.imports.service.IXxhbuserService;
import org.jeecg.modules.kc.grab.imports.service.IXxhbxskcService;
import org.jeecg.modules.kc.kcXqxnHistory.entity.KcXqxnHistory;
import org.quartz.JobExecutionContext;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * 同步用户
 */
@Slf4j
public class SyncTJzgXskc extends BaseSync {

    @Autowired
    private ITJzgXskcService expService;

    @Autowired
    private IXxhbxskcService impService;

    @Autowired
    private IXxhbuserService xxhbuserService;

    @Autowired
    private ChangeTingKeTongJi changeTingKeTongJi;

    @Autowired
    private IKcExportConfigTpkwcqkjzglxService exportConfigTpkwcqkjzglxService;

    /**
     * 若参数变量名修改 QuartzJobController中也需对应修改
     */

    @Override
    public void execute(JobExecutionContext jobExecutionContext)  {
        start();
        run(getParamMap());
        end();
    }


    /**
     * 有参定时任务实现
     * @param param
     */
    public void run(Map<String, Object> param){




        //查询数据
        List<TJzgXskc> inDataList = expService.list();
        List<Xxhbxskc> outDataList = Lists.newArrayList();

        List<Xxhbuser> outUserDataList = Lists.newArrayList();
        Map<String, Xxhbuser> outUserDataMap = Maps.newHashMap();

        //清洗数据
        inDataList.forEach(x -> {
            String timestamps = DateUtil.format(x.getTimestamps(), DatePattern.NORM_DATETIME_PATTERN);
            String gh = x.getGh();
            outDataList.add(BeanUtil.toBean(x, Xxhbxskc.class));
            Xxhbuser outUserData = BeanUtil.toBean(x, Xxhbuser.class);
            outUserData.setTimestamps(timestamps);
            outUserDataList.add(outUserData);
            Xxhbuser xxhbuser = BeanUtil.toBean(x, Xxhbuser.class);
            xxhbuser.setTimestamps(timestamps);
            outUserDataMap.put(xxhbuser.getGh(),xxhbuser);
        });

        //保存到胃
        int syncnum=0;
        String errorMessage = "";
        try {
            impService.syncList(outDataList);
            syncnum = outDataList.size();
        }catch (Exception e){
            e.printStackTrace();
            errorMessage = e.getMessage();
        }
        Xxhbxskc xxhbxskc = impService.getSumnum();
        int mysqlnum=xxhbxskc.getMysqlnum();
        Xxhbsynclog xxhbsynclog = new Xxhbsynclog();
        xxhbsynclog.setSyncRowNum(String.valueOf(outDataList.size()));
        xxhbsynclog.setOratabname("T_JZG_XSKC");//oracle表名
        xxhbsynclog.setOratabnum(inDataList.size());//oracle表数量
        xxhbsynclog.setTablenum(mysqlnum);//mysql表数量
        xxhbsynclog.setSyncnum(syncnum);//本次同步数据量
        xxhbsynclog.setSynctype("0");//同步类型 0全量  1增量
        xxhbsynclog.setErrormessage(errorMessage);
        saveLog(xxhbsynclog,Xxhbxskc.class);

        //同步清洗到xxhbUser表。
        //删除原数据
        QueryWrapper<Xxhbuser> xuQw = new QueryWrapper<>();
        xxhbuserService.remove(xuQw);

        //保存
        if(outUserDataList != null){
            xxhbuserService.saveBatch(outUserDataList);
        }

        //再同步清洗到kc_export_config_tpkwcqkjzglx表
        //筛选
        QueryWrapper<KcExportConfigTpkwcqkjzglx> ectQw = new QueryWrapper<>();
        //按学期筛选
        KcXqxnHistory common = changeTingKeTongJi.getXqConfig();
        String xqxn;
        if(common != null) {
            //Map<String, KcTkcstj> tongJiMap = Maps.newHashMap();
            //清洗数据核心
            Date startSjDate = common.getStartTime();
            Date endSjDate = common.getEndTime();
//            String startSj = DateUtil.format(startSjDate,DatePattern.NORM_DATETIME_FORMAT);
//            String endSj = DateUtil.format(endSjDate,DatePattern.NORM_DATETIME_FORMAT);
            xqxn = common.getTitle();
            ectQw.eq("xqxn",xqxn);
            ectQw.in("zt","在职");
        } else {
            xqxn = null;
        }

        List<KcExportConfigTpkwcqkjzglx> oldExportConfigTpkwcqkjzglxList =  exportConfigTpkwcqkjzglxService.list(ectQw);

        List<KcExportConfigTpkwcqkjzglx> saveList = Lists.newArrayList();
        List<KcExportConfigTpkwcqkjzglx> updateList = Lists.newArrayList();

        Map<String,KcExportConfigTpkwcqkjzglx> saveMap = Maps.newHashMap();

        oldExportConfigTpkwcqkjzglxList.forEach(x -> {
            if(outUserDataMap.containsKey(x.getGh())){
                Xxhbuser data = outUserDataMap.get(x.getGh());
                x.setXm(data.getXm());
                x.setDwmc(data.getDwmc());
                updateList.add(x);
                saveMap.put(x.getGh(),x);
            }
        });

        if(updateList != null){
            try {
                exportConfigTpkwcqkjzglxService.updateBatchById(updateList);
            }catch (Exception e){
                e.printStackTrace();
                errorMessage = e.getMessage();
            }
            Xxhbsynclog updateLog = new Xxhbsynclog();
            updateLog.setSyncRowNum(String.valueOf(outDataList.size()));
            updateLog.setOratabname("T_JZG_XSKC-清洗至kc_export_config_tpkwcqkjzglx，升级数据");//oracle表名
            updateLog.setOratabnum(inDataList.size());//oracle表数量
            updateLog.setTablenum(0);//mysql表数量
            updateLog.setSyncnum(updateList.size());//本次同步数据量
            updateLog.setSynctype("0");//同步类型 0全量  1增量
            updateLog.setErrormessage(errorMessage);
            saveLog(xxhbsynclog,Xxhbxskc.class);

        }

        outUserDataList.forEach(x -> {
            if(!saveMap.containsKey(x.getGh())){
                KcExportConfigTpkwcqkjzglx data = BeanUtil.toBean(x, KcExportConfigTpkwcqkjzglx.class);
                data.setXqxn(xqxn);
                saveList.add(data);
            }
        });

        if(saveList != null){


            List<KcExportConfigTpkwcqkjzglx> listA = exportConfigTpkwcqkjzglxService.getSfybxqsj();
            if(listA != null){
                exportConfigTpkwcqkjzglxService.saveBatch(listA);
                Xxhbsynclog updateLog = new Xxhbsynclog();
                updateLog.setSyncRowNum(String.valueOf(listA.size()));
                updateLog.setOratabname("T_JZG_XSKC-清洗至kc_export_config_tpkwcqkjzglx，新增数据");//oracle表名
                updateLog.setOratabnum(listA.size());//oracle表数量
                updateLog.setTablenum(0);//mysql表数量
                updateLog.setSyncnum(listA.size());//本次同步数据量
                updateLog.setSynctype("0");//同步类型 0全量  1增量
                updateLog.setErrormessage(errorMessage);
                saveLog(xxhbsynclog,Xxhbxskc.class);
            }else{
                try {
                    exportConfigTpkwcqkjzglxService.saveBatch(saveList);
                }catch (Exception e){
                    e.printStackTrace();
                    errorMessage = e.getMessage();
                }
                Xxhbsynclog updateLog = new Xxhbsynclog();
                updateLog.setSyncRowNum(String.valueOf(outDataList.size()));
                updateLog.setOratabname("T_JZG_XSKC-清洗至kc_export_config_tpkwcqkjzglx，新增数据");//oracle表名
                updateLog.setOratabnum(inDataList.size());//oracle表数量
                updateLog.setTablenum(0);//mysql表数量
                updateLog.setSyncnum(saveList.size());//本次同步数据量
                updateLog.setSynctype("0");//同步类型 0全量  1增量
                updateLog.setErrormessage(errorMessage);
                saveLog(xxhbsynclog,Xxhbxskc.class);
            }
        }

    }

    /**
     * 无参定时任务实现
     */
    public void run(){
        run(null);

    }

}
