package org.jeecg.modules.kc.grab.SynchronizationService;

import cn.hutool.core.date.DatePattern;
import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.google.common.collect.Maps;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.compress.utils.Lists;
import org.apache.commons.lang3.StringUtils;
import org.jeecg.modules.kc.grab.SynchronizationService.base.BaseSync;
import org.jeecg.modules.kc.grab.SynchronizationService.tools.ChangeTingKeTongJi;
import org.jeecg.modules.kc.grab.imports.entity.Xxhbbkjxtkpj;
import org.jeecg.modules.kc.grab.imports.entity.Xxhbsynclog;
import org.jeecg.modules.kc.grab.imports.service.IXxhbbkjxtkpjService;
import org.jeecg.modules.kc.kcXqxnHistory.entity.KcXqxnHistory;
import org.jeecg.modules.kc.kcXqxnHistory.service.IKcXqxnHistoryService;
import org.jeecg.modules.kc.ktgl.entity.KcKetangbiao;
import org.jeecg.modules.kc.ktgl.service.IKcKetangbiaoService;
import org.jeecg.modules.kc.qa.entity.KcEvaluation;
import org.jeecg.modules.kc.qa.entity.KcEvaluations;
import org.jeecg.modules.kc.qa.service.IKcEvaluationService;
import org.jeecg.modules.kc.qa.service.IKcEvaluationansService;
import org.jeecg.modules.kc.qa.service.IKcEvaluationqueService;
import org.jeecg.modules.kc.qa.service.IKcEvaluationsService;
import org.quartz.JobExecutionContext;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * 同步旧版本调查问卷
 */
@Slf4j
public class SyncTingKeTongJi extends BaseSync {

    @Autowired
    private ChangeTingKeTongJi changeTingKeTongJi;

    @Autowired
    private IKcXqxnHistoryService kcXqxnHistoryService;

    /**
     * 若参数变量名修改 QuartzJobController中也需对应修改
     */

    @Override
    public void execute(JobExecutionContext jobExecutionContext)  {
        start();
        run(getParamMap());
        end();
    }


    /**
     * 有参定时任务实现
     * @param param
     */
    public void run(Map<String, Object> param){
        String xqxn = "";
        boolean isAll = false;
        if(param != null){
            if(param.containsKey("xqxn")){
                xqxn = (String)param.get("xqxn");
            }
            if(param.containsKey("isAll")){
                String isAllStr = (String)param.get("isAll");
                if(StringUtils.isNotBlank(isAllStr)){
                    isAll = Boolean.parseBoolean(isAllStr);
                }
            }
        }
        if(isAll){
            QueryWrapper<KcXqxnHistory> qw = new QueryWrapper<>();
            qw.orderByDesc("end_time");
            List<KcXqxnHistory> list = kcXqxnHistoryService.list(qw);
            list.forEach(x -> {
                changeTingKeTongJi.changeTingKeTongji(x.getTitle());
            });
        }else{
            changeTingKeTongJi.changeTingKeTongji(xqxn);
        }
    }

    /**
     * 无参定时任务实现
     */
    public void run(){
        run(null);
    }


}
