package org.jeecg.modules.kc.grab.SynchronizationService;

import cn.hutool.core.bean.BeanUtil;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.compress.utils.Lists;
import org.jeecg.modules.kc.grab.SynchronizationService.base.BaseSync;
import org.jeecg.modules.kc.xxhbfxcjmxb0015.entity.Vjxythk0015;
import org.jeecg.modules.kc.xxhbfxcjmxb0015.entity.Xxhbfxcjmxb0015;
import org.jeecg.modules.kc.xxhbfxcjmxb0015.service.IXxhbfxcjmxb0015Service;
import org.jeecg.modules.kc.xxhbfxcjmxb0015.service.Vjxythk0015Service;
import org.quartz.JobExecutionContext;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.List;
import java.util.Map;

@Slf4j
public class SyncVjxythk0015 extends BaseSync {

    @Autowired
    private Vjxythk0015Service expService;

    @Autowired
    private IXxhbfxcjmxb0015Service impService;

    /**
     * 若参数变量名修改 QuartzJobController中也需对应修改
     */

    @Override
    public void execute(JobExecutionContext jobExecutionContext)  {
        start();
        run(getParamMap());
        end();
    }


    /**
     * 有参定时任务实现
     * @param param
     */
    public void run(Map<String, Object> param){
        //查询数据
        List<Vjxythk0015> inDataList = expService.list();
        List<Xxhbfxcjmxb0015> outDataList = Lists.newArrayList();

        //清洗数据
        inDataList.forEach(x -> {
            Xxhbfxcjmxb0015 outData = BeanUtil.toBean(x, Xxhbfxcjmxb0015.class);
            outDataList.add(outData);
        });

        //保存到胃
        try {
            impService.syncList(outDataList);
        }catch (Exception e){
            e.printStackTrace();
        }

    }

    /**
     * 无参定时任务实现
     */
    public void run(){
        run(null);
    }

}
