package org.jeecg.modules.kc.grab.SynchronizationService;

import cn.hutool.core.bean.BeanUtil;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.compress.utils.Lists;
import org.jeecg.modules.kc.grab.SynchronizationService.base.BaseSync;
import org.jeecg.modules.kc.xxhbfxcjb0016.entity.Vjxythk0016;
import org.jeecg.modules.kc.xxhbfxcjb0016.entity.Xxhbfxcjb0016;
import org.jeecg.modules.kc.xxhbfxcjb0016.service.IXxhbfxcjb0016Service;
import org.jeecg.modules.kc.xxhbfxcjb0016.service.Vjxythk0016Service;
import org.quartz.JobExecutionContext;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.List;
import java.util.Map;

@Slf4j
public class SyncVjxythk0016 extends BaseSync {

    @Autowired
    private Vjxythk0016Service expService;

    @Autowired
    private IXxhbfxcjb0016Service impService;

    /**
     * 若参数变量名修改 QuartzJobController中也需对应修改
     */

    @Override
    public void execute(JobExecutionContext jobExecutionContext)  {
        start();
        run(getParamMap());
        end();
    }


    /**
     * 有参定时任务实现
     * @param param
     */
    public void run(Map<String, Object> param){
        //查询数据
        List<Vjxythk0016> inDataList = expService.list();
        List<Xxhbfxcjb0016> outDataList = Lists.newArrayList();

        //清洗数据
        inDataList.forEach(x -> {
            Xxhbfxcjb0016 outData = BeanUtil.toBean(x, Xxhbfxcjb0016.class);
            outDataList.add(outData);
        });

        //保存到胃
        try {
            impService.syncList(outDataList);
        }catch (Exception e){
            e.printStackTrace();
        }

    }

    /**
     * 无参定时任务实现
     */
    public void run(){
        run(null);
    }

}
