package org.jeecg.modules.kc.grab.SynchronizationService;

import cn.hutool.core.bean.BeanUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.compress.utils.Lists;
import org.jeecg.common.util.DateUtils;
import org.jeecg.modules.kc.KcBdgxbcopy.entity.KcBdgxbcopy;
import org.jeecg.modules.kc.KcBdgxbcopy.service.IKcBdgxbcopyService;
import org.jeecg.modules.kc.grab.SynchronizationService.base.BaseSync;
import org.jeecg.modules.kc.grab.exports.entity.TFwdtBkjxtkpj;
import org.jeecg.modules.kc.grab.exports.service.ITFwdtBkjxtkpjService;
import org.jeecg.modules.kc.grab.imports.entity.Xxhbbkjxtkpj;
import org.jeecg.modules.kc.grab.imports.entity.Xxhbsynclog;
import org.jeecg.modules.kc.grab.imports.service.IXxhbbkjxtkpjService;
import org.jeecg.modules.kc.ktgl.service.IKcKetangbiaoService;
import org.jeecg.modules.kc.qa.service.IKcEvaluationService;
import org.jeecg.modules.kc.qa.service.IKcEvaluationsService;
import org.quartz.JobExecutionContext;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.Calendar;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * 微信生成推送信息
 */
@Slf4j
public class SyncWechartDsrw extends BaseSync {

    @Autowired
    private IKcBdgxbcopyService kcBdgxbcopyService;

    /**
     * 若参数变量名修改 QuartzJobController中也需对应修改
     */

    @Override
    public void execute(JobExecutionContext jobExecutionContext) {
        start();
        run(getParamMap());
        end();
    }


    /**
     * 有参定时任务实现
     * @param param
     */
    public void run(Map<String, Object> param){
        KcBdgxbcopy kcBdgxbcopy = new KcBdgxbcopy();
        kcBdgxbcopy.setYwTime(DateUtils.formatDate(new Date(),"yyyy-MM-dd"));
        // 1、写入学生课前提醒
        kcBdgxbcopyService.saveStudentKqtx(kcBdgxbcopy);
        // 2、写入教师课前提醒
        kcBdgxbcopyService.saveTeacherKqtx(kcBdgxbcopy);
        // 3、写入学生明日课程提醒
        kcBdgxbcopyService.saveStudentMrtx(kcBdgxbcopy);
        // 4、写入教师明日课程提醒
        kcBdgxbcopyService.saveTeacherMrtx(kcBdgxbcopy);
    }

    /**
     * 无参定时任务实现
     */
    public void run(){
        run(null);
    }

}
