package org.jeecg.modules.kc.grab.SynchronizationService;

import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.xkcoding.http.HttpUtil;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.jeecg.common.util.DateUtils;
import org.jeecg.modules.kc.KcBdgxbcopy.entity.KcBdgxbcopy;
import org.jeecg.modules.kc.KcBdgxbcopy.service.IKcBdgxbcopyService;
import org.jeecg.modules.kc.grab.SynchronizationService.base.BaseSync;
import org.jeecg.modules.kc.kcMessagelistcopy.entity.KcMessagelistcopy;
import org.jeecg.modules.kc.kcMessagelistcopy.service.IKcMessagelistcopyService;
import org.jeecg.modules.wxgzh.WeChatTemplateMsg;
import org.quartz.JobExecutionContext;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.web.client.RestTemplate;

import java.text.SimpleDateFormat;
import java.util.*;

/**
 * 微信推送信息
 */
@Slf4j
public class SyncWechartTsxx extends BaseSync {
    @Autowired
    private IKcMessagelistcopyService kcMessagelistcopyService;

    // appId
    private static final String appId = "wx59920eb69d611d7f";

    // appIdSecret
    private static final String appIdSecret = "bf0c19af0e956f447ede4dd902ea63b7";
    /**
     * 若参数变量名修改 QuartzJobController中也需对应修改
     */

    @Override
    public void execute(JobExecutionContext jobExecutionContext) {
        start();
        run(getParamMap());
        end();
    }


    /**
     * 有参定时任务实现
     * @param param
     */
    public void run(Map<String, Object> param){

        String urlToken = "https://api.weixin.qq.com/cgi-bin/token?grant_type=client_credential&appid="+ appId +"&secret=" + appIdSecret;
        System.out.println("urlToken：  "+ urlToken);
        String res = HttpUtil.get(urlToken);
        JSONObject jsonObjectToken = JSONObject.parseObject(res);
        System.out.println("jsonObjectToken：{}"+ jsonObjectToken);
        String accessToken = jsonObjectToken.getString("access_token");
        System.out.println("accessToken：{}"+ accessToken);

        if(StringUtils.isNotBlank(accessToken)){
            SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
            Calendar nowTime = Calendar.getInstance();
            nowTime.add(Calendar.MINUTE, 30);//30分钟后的时间

            Calendar nowTime2 = Calendar.getInstance();
            nowTime2.add(Calendar.MINUTE, -30);//30分钟前的时间
            QueryWrapper<KcMessagelistcopy> queryWrapper = new QueryWrapper<>();
            queryWrapper.ge("scheduleddatetime",DateUtils.formatDate(nowTime2,"yyyy-MM-dd HH:mm:ss"));
            queryWrapper.le("scheduleddatetime",DateUtils.formatDate(nowTime,"yyyy-MM-dd HH:mm:ss"));
            queryWrapper.eq("status","0");
            List<KcMessagelistcopy> list =kcMessagelistcopyService.list(queryWrapper);
            for(KcMessagelistcopy KcMessagelistcopy:list){

                // 模板参数
                Map<String, WeChatTemplateMsg> sendMag = new HashMap<String, WeChatTemplateMsg>();
                // openId代表一个唯一微信用户，即微信消息的接收人
                String openId = KcMessagelistcopy.getTouser();
                String url = "https://api.weixin.qq.com/cgi-bin/message/template/send?access_token=" + accessToken;

                /**
                 *  其他模板可以从模板库中自己添加
                 * 模板ID
                 * KtWw0lwQ8FOgJdKgrmya0eoafGkMfMN8ECdZs8oSJys
                 * 开发者调用模板消息接口时需提供模板ID
                 * 标题      上课提醒
                 * 行业      教育 - 院校
                 * 详细内容
                 * {{first.DATA}}
                 * 课程：{{keyword1.DATA}}
                 * 时间：{{keyword2.DATA}}
                 * 地点：{{keyword3.DATA}}
                 * {{remark.DATA}}
                 */
                sendMag.put("first", new WeChatTemplateMsg(KcMessagelistcopy.getFirstdata()));
                sendMag.put("keyword1", new WeChatTemplateMsg(KcMessagelistcopy.getKeyword1()));
                sendMag.put("keyword2", new WeChatTemplateMsg(KcMessagelistcopy.getKeyword2()));
                sendMag.put("keyword3", new WeChatTemplateMsg(KcMessagelistcopy.getKeyword3()));
                sendMag.put("remark", new WeChatTemplateMsg(KcMessagelistcopy.getRemarkdata()));
                RestTemplate restTemplate = new RestTemplate();
                //拼接base参数
                Map<String, Object> sendBody = new HashMap<>();
                sendBody.put("touser", openId);               // openId
                sendBody.put("url", KcMessagelistcopy.getTourl());         // 点击模板信息跳转地址
                sendBody.put("topcolor", "#FF0000");          // 顶色
                sendBody.put("data", sendMag);                   // 模板参数
                sendBody.put("template_id", KcMessagelistcopy.getTemplateId());      // 模板Id
                ResponseEntity<String> forEntity = restTemplate.postForEntity(url, sendBody, String.class);
                log.info("结果是: {}",forEntity.getBody());
                JSONObject jsonObject = JSONObject.parseObject(forEntity.getBody());
                // 0
                String messageCode = jsonObject.getString("errcode");
                // 2431260672639467520
                String msgId = jsonObject.getString("msgid");
                System.out.println("messageCode : " + messageCode + ", msgId: " +msgId);
                if(StringUtils.isNotBlank(msgId)){
                    KcMessagelistcopy.setStatus("1");
                    kcMessagelistcopyService.updateById(KcMessagelistcopy);
                }
            }
        }



    }

    /**
     * 无参定时任务实现
     */
    public void run(){
        run(null);
    }

}
