package org.jeecg.modules.kc.grab.SynchronizationService;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.date.DatePattern;
import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.google.common.collect.Maps;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.compress.utils.Lists;
import org.apache.commons.lang3.StringUtils;
import org.jeecg.modules.kc.grab.SynchronizationService.base.BaseSync;
import org.jeecg.modules.kc.grab.SynchronizationService.tools.ChangeTingKeTongJi;
import org.jeecg.modules.kc.grab.imports.entity.Xxhbbkjxtkpj;
import org.jeecg.modules.kc.grab.log.entity.KcOldEvaluationansBad;
import org.jeecg.modules.kc.grab.log.entity.XxhbbkjxtkpjBadLog;
import org.jeecg.modules.kc.grab.imports.entity.Xxhbsynclog;
import org.jeecg.modules.kc.grab.log.entity.XxhbbkjxtkpjGoodLog;
import org.jeecg.modules.kc.grab.log.service.IXxhbbkjxtkpjBadLogService;
import org.jeecg.modules.kc.grab.imports.service.IXxhbbkjxtkpjService;
import org.jeecg.modules.kc.grab.log.service.IXxhbbkjxtkpjGoodLogService;
import org.jeecg.modules.kc.kcSysConfig.entity.KcSysConfig;
import org.jeecg.modules.kc.kcSysConfig.service.IKcSysConfigService;
import org.jeecg.modules.kc.ktgl.entity.KcKetangbiao;
import org.jeecg.modules.kc.ktgl.service.IKcKetangbiaoService;
import org.jeecg.modules.kc.qa.entity.KcEvaluation;
import org.jeecg.modules.kc.qa.entity.KcEvaluations;
import org.jeecg.modules.kc.qa.entity.KcOldEvaluationans;
import org.jeecg.modules.kc.qa.service.IKcEvaluationService;
import org.jeecg.modules.kc.qa.service.IKcEvaluationansService;
import org.jeecg.modules.kc.qa.service.IKcEvaluationqueService;
import org.jeecg.modules.kc.qa.service.IKcEvaluationsService;
import org.quartz.JobExecutionContext;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * 同步旧版本调查问卷
 */
@Slf4j
public class SyncZwdtEvaluation extends BaseSync {

    @Autowired
    private IKcKetangbiaoService kcKetangbiaoService;

    //----------------------------------旧系统------------------------------------------
    @Autowired
    private IXxhbbkjxtkpjService xxhbbkjxtkpjService;//政务大厅（纯回答）

    //----------------------------------旧系统END------------------------------------------

    //----------------------------------正在使用------------------------------------------

    @Autowired
    private IKcEvaluationansService kcEvaluationansService;//正在使用答案（纯答案）

    @Autowired
    private IKcEvaluationqueService kcEvaluationqueService;//正在使用问题（纯问题）

    @Autowired
    private IKcEvaluationService kcEvaluationService;//正在使用问题（回答主表）

    @Autowired
    private IKcEvaluationsService kcEvaluationsService;//正在使用问题(回答明细子表)
    @Autowired
    private IKcSysConfigService kcSysConfigService;

    //----------------------------------正在使用END------------------------------------------

    //----------------------------------政务大厅------------------------------------------
    //----------------------------------政务大厅END------------------------------------------

    //----------------------------------纸质评价（后台导入）------------------------------------------
    //----------------------------------纸质评价（后台导入）END------------------------------------------

    @Autowired
    private ChangeTingKeTongJi changeTingKeTongJi;

    @Autowired
    private IXxhbbkjxtkpjBadLogService xxhbbkjxtkpjBadLogService;

    @Autowired
    private IXxhbbkjxtkpjGoodLogService xxhbbkjxtkpjGoodLogService;


    Map<String,String> queOptionMap = Maps.newHashMap();
    Map<String,String> ansOptionMap = Maps.newHashMap();

    /**
     * 若参数变量名修改 QuartzJobController中也需对应修改
     */

    @Override
    public void execute(JobExecutionContext jobExecutionContext)  {
        start();
        run(getParamMap());
        end();
    }


    /**
     * 有参定时任务实现
     * @param param
     */
    public void run(Map<String, Object> param){

        initOptionMap();
        //旧版本
        washOldData(param);
    }

    /**
     * 无参定时任务实现
     */
    public void run(){
        run(null);
    }

    public void initOptionMap (){
//        optionMap.put("0","A");
//        optionMap.put("1","B");
//        optionMap.put("2","C");
//        optionMap.put("3","D");
//        optionMap.put("4","E");

        //序号，问题ID
        queOptionMap.put("1","23");//讲课有热情，精神饱满，能调动学生情绪，课堂气氛活跃
        queOptionMap.put("2","24");//教学目标明确，内容丰富，重点突出，语言表达清楚
        queOptionMap.put("3","25");//授课有启发性，能给予学生思考、联想、创新的启迪
        queOptionMap.put("4","26");//能有效利用各种教学媒体，课件或板书使用效果好
        queOptionMap.put("5","27");//仪表得体，按时上下课，严格要求学生
        queOptionMap.put("6","28");//无迟到、早退、旷课现象
        queOptionMap.put("7","29");//课堂教学秩序好，无喧闹、打瞌睡、发短信、玩手机等现象
        queOptionMap.put("8","30");//上课认真听讲、积极思考，主动与老师交流互动
        queOptionMap.put("9","31");//课堂教学总体印象评价
        queOptionMap.put("10","32");//对课堂内容以及其他方面的具体意见或建议
        //queOptionMap.put("32", "");//对课堂内容以及其他方面的具体意见或建议

        //问题ID-答案代号，答案ID
        ansOptionMap.put("23-A", "176");
        ansOptionMap.put("23-B", "177");
        ansOptionMap.put("23-C", "178");
        ansOptionMap.put("23-D", "179");
        ansOptionMap.put("23-E", "180");
        ansOptionMap.put("24-A", "181");
        ansOptionMap.put("24-B", "182");
        ansOptionMap.put("24-C", "183");
        ansOptionMap.put("24-D", "184");
        ansOptionMap.put("24-E", "185");
        ansOptionMap.put("25-A", "186");
        ansOptionMap.put("25-B", "187");
        ansOptionMap.put("25-C", "188");
        ansOptionMap.put("25-D", "189");
        ansOptionMap.put("25-E", "190");
        ansOptionMap.put("26-A", "191");
        ansOptionMap.put("26-B", "192");
        ansOptionMap.put("26-C", "193");
        ansOptionMap.put("26-D", "194");
        ansOptionMap.put("26-E", "195");
        ansOptionMap.put("27-A", "196");
        ansOptionMap.put("27-B", "197");
        ansOptionMap.put("27-C", "198");
        ansOptionMap.put("27-D", "199");
        ansOptionMap.put("27-E", "200");
        ansOptionMap.put("28-A", "201");
        ansOptionMap.put("28-B", "202");
        ansOptionMap.put("28-C", "203");
        ansOptionMap.put("28-D", "204");
        ansOptionMap.put("28-E", "205");
        ansOptionMap.put("29-A", "206");
        ansOptionMap.put("29-B", "207");
        ansOptionMap.put("29-C", "208");
        ansOptionMap.put("29-D", "209");
        ansOptionMap.put("29-E", "210");
        ansOptionMap.put("30-A", "211");
        ansOptionMap.put("30-B", "212");
        ansOptionMap.put("30-C", "213");
        ansOptionMap.put("30-D", "214");
        ansOptionMap.put("30-E", "215");
        ansOptionMap.put("31-A", "296");
        ansOptionMap.put("31-B", "297");
        ansOptionMap.put("31-C", "298");
        ansOptionMap.put("31-D", "299");
        ansOptionMap.put("31-E", "300");

    }

    public void washOldData(Map<String, Object> param) {

        DateTime now = DateUtil.date();

        boolean isAll = false;
        if(param != null){
            if(param.containsKey("isAll")){
                String isAllStr = (String)param.get("isAll");
                if(StringUtils.isNotBlank(isAllStr)){
                    isAll = Boolean.parseBoolean(isAllStr);
                }
            }
            if(param.containsKey("nowDay")){
                String nowDayStr = (String)param.get("nowDay");
                if(StringUtils.isNotBlank(nowDayStr)){
                    now = DateUtil.parse(nowDayStr, "yyyy-MM-dd");
                }
            }

        }
        //时间得减一天
        now = DateUtil.offsetDay(now,-1);

        String nowStr = DateUtil.format(now,DatePattern.NORM_DATE_FORMAT);

        int source = 2;

        //删除旧数据
        QueryWrapper<KcEvaluation> kcEvaluation = new QueryWrapper<>();
        kcEvaluation.eq("source",source);
        kcEvaluation.eq(!isAll,"up_timestamp",nowStr);
        kcEvaluationService.remove(kcEvaluation);
        QueryWrapper<KcEvaluations> kcEvaluations = new QueryWrapper<>();
        kcEvaluations.eq("source",source);
        kcEvaluations.eq(!isAll,"up_timestamp", nowStr);
        kcEvaluationsService.remove(kcEvaluations);


        //删除好的和坏的数据
        QueryWrapper<XxhbbkjxtkpjBadLog> bedQw = new QueryWrapper<>();
        bedQw.eq(!isAll,"timestamps",nowStr);
        xxhbbkjxtkpjBadLogService.remove(bedQw);

        QueryWrapper<XxhbbkjxtkpjGoodLog> goodQw = new QueryWrapper<>();
        goodQw.eq(!isAll,"timestamps",nowStr);
        xxhbbkjxtkpjGoodLogService.remove(goodQw);

        //查询数据
        QueryWrapper<Xxhbbkjxtkpj> inQw = new QueryWrapper<>();
        inQw.eq(!isAll,"timestamps",nowStr);
        //筛选符合条件的答案
        //inQw.like("tksjxq","(");
        inQw.notLike("tksjxq","()");
        inQw.in("jspg1","A", "B", "C", "D", "E");
        inQw.in("jspg2","A", "B", "C", "D", "E");
        inQw.in("jspg3","A", "B", "C", "D", "E");
        inQw.in("jspg4","A", "B", "C", "D", "E");
        inQw.in("jspg5","A", "B", "C", "D", "E");

        inQw.in("xspg1","A", "B", "C", "D", "E");
        inQw.in("xspg2","A", "B", "C", "D", "E");
        inQw.in("xspg3","A", "B", "C", "D", "E");
        inQw.in("ztpj", "A", "B", "C", "D", "E");
//        inQw.last("limit 100");
        List<Xxhbbkjxtkpj> inDataList = xxhbbkjxtkpjService.list(inQw);
        List<KcEvaluation> saveMainList = Lists.newArrayList();

        List<KcEvaluations> saveChildList = Lists.newArrayList();
        List<XxhbbkjxtkpjBadLog> saveXxhbbkjxtkpjBadLogList = Lists.newArrayList();
        List<XxhbbkjxtkpjGoodLog> saveXxhbbkjxtkpjGoodLogList = Lists.newArrayList();

        inDataList.forEach(x -> {
            KcEvaluation main = new KcEvaluation();

            //类似这样的。。2020年春季第17周星期一(2020年06月14日)    2020年春季第8周星期三(2020年04月14日)
            String tksjxq = x.getTksjxq();
            if(StringUtils.isNotBlank(tksjxq)){
                int startIndex = StringUtils.indexOf(tksjxq,"(");
                int endIndex = StringUtils.indexOf(tksjxq,")");
                if(startIndex != -1 && endIndex != -1){
                    String dateStr = StringUtils.substring(tksjxq,startIndex+1,endIndex);
                    Date pksj = DateUtil.parse(dateStr);
                    main.setUpDate(pksj);
                    main.setUpTime(pksj);
                    main.setUpTimestamp(DateUtil.format(pksj, DatePattern.NORM_DATE_FORMAT));
                }
            }
            main.setUpuser(x.getTkrxm());
//            main.setUserid(x.getTkrgh());
            if(StringUtils.isNotBlank(x.getTkrgh())){
                main.setUpuserid(Integer.parseInt(x.getTkrgh()));
            }

            //main.setMinkcid(x.get);????好像得多条件查询 tkkcmc
            QueryWrapper<KcKetangbiao> qwKeTang = new QueryWrapper<>();
            //qwKeTang.eq("kcbh",x.getKbbh());
            qwKeTang.eq("kcmc",x.getTkkcmc());
//            qwKeTang.eq("kkdw",x.getKkdw());
//            qwKeTang.eq("",x.getJgh());
            qwKeTang.eq("skjs",x.getRkjs());
            qwKeTang.eq("skrq",DateUtil.format(main.getUpDate(), DatePattern.NORM_DATE_FORMAT));
//            qwKeTang.eq("sksj",x.getSksj());
            String hh = x.getKcjc();
            switch (hh){
                case "第1节":
                case "第2节":
                    hh = "01、02";
                    break;
                case "第3节":
                case "第4节":
                    hh = "03、04";
                    break;
                case "第5节":
                case "第6节":
                    hh = "05、06";
                    break;
                case "第7节":
                case "第8节":
                    hh = "07、08";
                    break;
                case "第9节":
                case "第10节":
                    hh = "09、10";
                    break;
                case "第11节":
                case "第12节":
                    hh = "11、12";
                    break;
                default:
                    hh = "";
                    break;
            }

            qwKeTang.eq("hh",hh);
//            qwKeTang.eq("skdd",x.getTkjs());
//            qwKeTang.eq("",x.getTkjgh());
//            qwKeTang.eq("",x.getTkjs());
            qwKeTang.last("limit 1");
            KcKetangbiao ketangbiao = kcKetangbiaoService.getOne(qwKeTang);
            if(ketangbiao == null) {
                //再查一遍，去除hh
                QueryWrapper<KcKetangbiao> qwKeTang2 = new QueryWrapper<>();
                qwKeTang2.eq("kcmc",x.getTkkcmc());
                qwKeTang2.eq("skjs",x.getRkjs());
                qwKeTang2.eq("skrq",DateUtil.format(main.getUpDate(), DatePattern.NORM_DATE_FORMAT));
                qwKeTang2.last("limit 1");
                ketangbiao = kcKetangbiaoService.getOne(qwKeTang2);
            }
            //如果还是没有，那就造一条记录，插入进去
            if(ketangbiao == null) {
                KcKetangbiao KcKetangbiao2 = new KcKetangbiao();
                KcKetangbiao2.setKcmc(x.getTkkcmc());
                KcKetangbiao2.setSkjs(x.getRkjs());
                KcKetangbiao2.setSkrq(DateUtil.format(main.getUpDate(), DatePattern.NORM_DATE_FORMAT));
                KcKetangbiao2.setHh(hh);
                KcKetangbiao2.setSkdd(x.getTkjs());
                String skrq = DateUtil.format(main.getUpDate(), DatePattern.NORM_DATE_FORMAT);
                QueryWrapper<KcSysConfig> kcSysConfigQueryWrapper = new QueryWrapper<>();
                kcSysConfigQueryWrapper.apply("bxqkssj >= '" + skrq +"' and bxqjssj <= '" + skrq + "'");
                KcSysConfig KcSysConfig = kcSysConfigService.getOne(kcSysConfigQueryWrapper);
                String flag1 = "";
                if(KcSysConfig!=null){
                    flag1 = KcSysConfig.getFlag1();
                }
                KcKetangbiao2.setXnxq(flag1);
                kcKetangbiaoService.save(KcKetangbiao2);
                ketangbiao = KcKetangbiao2;
            }

            if(ketangbiao == null) {
                //还是为空，，就记录吧，
                ketangbiao = new KcKetangbiao();
                log.error("错误的课题");
                //存新表里面
                XxhbbkjxtkpjBadLog bedLog = BeanUtil.toBean(x, XxhbbkjxtkpjBadLog.class);
                bedLog.setSkrq(DateUtil.format(main.getUpDate(), DatePattern.PURE_DATE_FORMAT));
                bedLog.setHh(hh);
                //bedLog.setTimestamps(DateUtil.format(x.getTimestamps(), DatePattern.NORM_DATETIME_PATTERN));
                //outDataList.add(BeanUtil.toBean(x, XxhbbkjxtkpjBadLog.class));
                saveXxhbbkjxtkpjBadLogList.add(bedLog);
            }else{
                XxhbbkjxtkpjGoodLog goodLog = BeanUtil.toBean(x, XxhbbkjxtkpjGoodLog.class);
                goodLog.setSkrq(DateUtil.format(main.getUpDate(), DatePattern.PURE_DATE_FORMAT));
                goodLog.setHh(hh);
                saveXxhbbkjxtkpjGoodLogList.add(goodLog);
            }
            main.setMinkcid(ketangbiao.getId());

            main.setAnswer1(x.getJspg1());
            main.setAnswer2(x.getJspg2());
            main.setAnswer3(x.getJspg3());
            main.setAnswer4(x.getJspg4());
            main.setAnswer5(x.getJspg5());
            main.setAnswer6(x.getXspg1());
            main.setAnswer7(x.getXspg2());
            main.setAnswer8(x.getXspg3());
            main.setAnswer9(x.getZtpj());
            main.setAnswer10(x.getQtyj());

            main.setEvaluationver(3);//题版本
            main.setSource(source);//老版本
            saveMainList.add(main);
            //子数据
            //100004	2022-09-06	14:31:00	杨霞	2010900015	2022-09-06 14:31:42	193359	11	75		4568	0
//            String optionId1 = queOptionMap.get(main.getAnswer1());
//            String optionId2 = queOptionMap.get(main.getAnswer2());
//            String optionId3 = queOptionMap.get(main.getAnswer3());
//            String optionId4 = queOptionMap.get(main.getAnswer5());
//            String optionId5 = queOptionMap.get(main.getAnswer6());
//            String optionId6 = queOptionMap.get(main.getAnswer7());
//            String optionId7 = queOptionMap.get(main.getAnswer8());
//            String optionId8 = queOptionMap.get(main.getAnswer9());
//            String optionId9 = queOptionMap.get(main.getAnswer10());
//            String optionId10 = queOptionMap.get(main.getAnswer10());


            kcEvaluationService.save(main);

            //添加听课日志
            if(StringUtils.isNotBlank(main.getMinkcid())){
                changeTingKeTongJi.addTingKeData(String.valueOf(main.getUpuserid()),main.getMinkcid(),main.getUpDate());
            }

            for (int i = 1; 10 >= i; i++){
                String optionId = "";
                String ansKey = "";
                switch (i) {
                    case 1: optionId = queOptionMap.get("1"); ansKey = main.getAnswer1(); break;
                    case 2: optionId = queOptionMap.get("2"); ansKey = main.getAnswer2(); break;
                    case 3: optionId = queOptionMap.get("3"); ansKey = main.getAnswer3(); break;
                    case 4: optionId = queOptionMap.get("4"); ansKey = main.getAnswer4(); break;
                    case 5: optionId = queOptionMap.get("5"); ansKey = main.getAnswer5(); break;
                    case 6: optionId = queOptionMap.get("6"); ansKey = main.getAnswer6(); break;
                    case 7: optionId = queOptionMap.get("7"); ansKey = main.getAnswer7(); break;
                    case 8: optionId = queOptionMap.get("8"); ansKey = main.getAnswer8(); break;
                    case 9: optionId = queOptionMap.get("9"); ansKey = main.getAnswer9(); break;
                    case 10: optionId = queOptionMap.get("10"); ansKey = main.getAnswer10(); break;
                }
                KcEvaluations child = new KcEvaluations();
                child.setUpDate(x.getTimestamps());
                child.setUpTime(x.getTimestamps());
                child.setUpTimestamp(DateUtil.format(x.getTimestamps(),DatePattern.NORM_DATETIME_FORMAT));
                child.setUpuser(x.getTkrxm());
                child.setUpuserid(x.getTkrgh());
                child.setKetangbiaoid(ketangbiao.getId());//用上面的ID

                child.setQueid(Integer.parseInt(optionId));//问题ID

                if(i == 10){
                    child.setAnsid(0);
                    child.setTextanscontent(ansKey);//多行文本型答案内容
                }else {
                    String ansId = ansOptionMap.get(optionId+"-"+ansKey);
                    if(StringUtils.isNotBlank(ansId)){
                        child.setAnsid(Integer.parseInt(ansId));//答案ID
                    }
                }

                child.setEvaluationid(main.getId());
                child.setSource(source);//老版本
                saveChildList.add(child);

            }

        });


        //存错误日志

        QueryWrapper<Xxhbbkjxtkpj> bedSaveQw = new QueryWrapper<>();
        bedSaveQw.eq(!isAll,"timestamps",nowStr);

        bedSaveQw.apply("bh not in (select bh from xxhbbkjxtkpj " +
        "where (tksjxq not like '%()%'         " +
        "and jspg1  in('A','B','C','D','E')     " +
        "and jspg2  in('A','B','C','D','E')     " +
        "and jspg3  in('A','B','C','D','E')     " +
        "and jspg4  in('A','B','C','D','E')     " +
        "and jspg5  in('A','B','C','D','E')     " +
        "and xspg1  in('A','B','C','D','E')     " +
        "and xspg2  in('A','B','C','D','E')     " +
        "and xspg3  in('A','B','C','D','E')     " +
        "and ztpj   in('A','B','C','D','E')))   ");
        //筛选符合条件的答案
//        bedSaveQw.and(x ->
//            //x.notLike("tksjxq","(").or()
//            x.like("tksjxq","()").or()
//            .notIn("jspg1","A", "B", "C", "D", "E").or() jspg1 is null or jspg1 = ''
//            .notIn("jspg2","A", "B", "C", "D", "E").or()
//            .notIn("jspg3","A", "B", "C", "D", "E").or()
//            .notIn("jspg4","A", "B", "C", "D", "E").or()
//            .notIn("jspg5","A", "B", "C", "D", "E").or()
//
//            .notIn("xspg1","A", "B", "C", "D", "E").or()
//            .notIn("xspg2","A", "B", "C", "D", "E").or()
//            .notIn("xspg3","A", "B", "C", "D", "E").or()
//            .notIn("ztpj", "A", "B", "C", "D", "E")
//
//        );
        List<Xxhbbkjxtkpj> bedList = xxhbbkjxtkpjService.list(bedSaveQw);

        if(bedList != null){
            bedList.forEach(x -> saveXxhbbkjxtkpjBadLogList.add(BeanUtil.toBean(x, XxhbbkjxtkpjBadLog.class)));
        }
        if(saveXxhbbkjxtkpjBadLogList != null){
            xxhbbkjxtkpjBadLogService.saveBatch(saveXxhbbkjxtkpjBadLogList);
        }

        if(saveXxhbbkjxtkpjGoodLogList != null){
            xxhbbkjxtkpjGoodLogService.saveBatch(saveXxhbbkjxtkpjGoodLogList);
        }

        //kcEvaluationService.saveBatch(saveMainList);
        if(saveChildList != null){
            kcEvaluationsService.saveBatch(saveChildList);
        }
//        List<KcEvaluationque> saveList = Lists.newArrayList();

        changeTingKeTongJi.changeTingKeTongji();
//
//
//        //删除旧数据
//        QueryWrapper<KcEvaluationque> rqw = new QueryWrapper<>();
//        rqw.eq("source",1);
//        kcEvaluationqueService.remove(rqw);
//
//        inDataList.forEach(x -> {
//            KcEvaluationque que = new KcEvaluationque();
//            que.setContent(x.getContent());
//            que.setStatus(x.getStatus());
//            que.setGenre(x.getGenre());
//            que.setOrdernum(x.getOrdernum());
//            que.setQuetype(x.getQuetype());
//            que.setIsrequire(x.getIsrequire());
//            que.setEvaluationver(x.getEvaluationver());
//            que.setSource(1);
//            saveList.add(que);
//        });
//
//        kcEvaluationqueService.saveBatch(saveList);

        //有ID了，清洗数据

        Xxhbsynclog xxhbsynclog = new Xxhbsynclog();
        xxhbsynclog.setTablename("附加定时任务，清洗服务大厅数据");
        xxhbsynclog.setOratabname("T_ZZB_LDXX");//oracle表名
        xxhbsynclog.setOratabnum(inDataList.size());//oracle表数量
//        xxhbsynclog.setTablenum(mysqlnum);//mysql表数量
        xxhbsynclog.setSyncnum(saveMainList.size());//本次同步数据量
        xxhbsynclog.setSynctype(isAll?"0":"1");//同步类型 0全量  1增量
//        xxhbsynclog.setErrormessage("");
        saveLog(xxhbsynclog);


    }

    public static void main(String[] args) {
        //类似这样的。。2020年春季第17周星期一(2020年06月14日)    2020年春季第8周星期三(2020年04月14日)
        String tksjxq = "2020年春季第17周星期一(2020年06月14日)";
        if(StringUtils.isNotBlank(tksjxq)){
            int startIndex = StringUtils.indexOf(tksjxq,"(");
            int endIndex = StringUtils.indexOf(tksjxq,")");
            if(startIndex != -1 && endIndex != -1){
                String dateStr = StringUtils.substring(tksjxq,startIndex+1,endIndex);
                System.out.println(dateStr);
            }
        }

    }

}
