package org.jeecg.modules.kc.grab.SynchronizationService;

import cn.hutool.core.date.DateUtil;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.jeecg.modules.kc.grab.SynchronizationService.base.BaseSync;
import org.jeecg.modules.kc.zyCcjg.service.IZyCcjgService;
import org.jeecg.modules.kc.zyInfo.service.IZyInfoService;
import org.quartz.JobExecutionContext;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.Map;

/**
 * 作业查重接口
 */
@Slf4j
public class SyncZyParamsCcjg extends BaseSync {

    @Autowired
    private IZyCcjgService zyCcjgService;

    @Autowired
    private IZyInfoService zyInfoService;

    /**
     * 若参数变量名修改 QuartzJobController中也需对应修改
     */

    @Override
    public void execute(JobExecutionContext jobExecutionContext)  {
        start();
        run(getParamMap());
        end();
    }


    /**
     * 有参定时任务实现
     * @param param
     */
    public void run(Map<String, Object> param){

        if(param != null){
            String paperId = (String)param.get("paperId");
            zyCcjgService.updateCcjg(paperId);
        }

    }

    /**
     * 无参定时任务实现
     */
    public void run(){
        run(null);
    }

}
