package org.jeecg.modules.kc.grab.SynchronizationService;

import cn.hutool.core.date.DateUtil;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.xkcoding.http.HttpUtil;
import lombok.extern.slf4j.Slf4j;
import org.jeecg.modules.kc.KcBdgxbcopy.entity.KcBdgxbcopy;
import org.jeecg.modules.kc.KcBdgxbcopy.service.IKcBdgxbcopyService;
import org.jeecg.modules.kc.grab.SynchronizationService.base.BaseSync;
import org.jeecg.modules.kc.kcMessagelistcopy.entity.KcMessagelistcopy;
import org.jeecg.modules.kc.kcMessagelistcopy.service.IKcMessagelistcopyService;
import org.jeecg.modules.wxgzh.WeChatTemplateMsg;
import org.quartz.JobExecutionContext;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.web.client.RestTemplate;

import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 服务大厅-本科教学服务评价
 */
@Slf4j
public class WechartSendmessageTask extends BaseSync {

    @Autowired
    private IKcBdgxbcopyService kcBdgxbcopyService;

    @Autowired
    private IKcMessagelistcopyService kcMessagelistcopyService;

    // appId
//    private static final String appId = "wx59920eb69d611d7f";//东师
    private static final String appId = "wxafdbb51ba3aa614d";//测试

    // appIdSecret
//    private static final String appIdSecret = "";//东师
    private static final String appIdSecret = "bdf346ae8b986e9fa5d33b2e4495b27e";//测试
    // 公众号的模板id(也有相应的接口可以查询到)
//    private static final String templateId = "KtWw0lwQ8FOgJdKgrmya0eoafGkMfMN8ECdZs8oSJys";//东师
    private static final String templateId = "cFD7lyjpppIZUB9ipuGjkjZr9ED-BhJZ7bw3ILaFgbg";//测试
    //微信通知点击后跳转的页面
    private static final String domainTo = "https://smartedu.nenu.edu.cn/";
    /**
     * 若参数变量名修改 QuartzJobController中也需对应修改
     */

    @Override
    public void execute(JobExecutionContext jobExecutionContext) {
        start();
        try {
            run(getParamMap());
        } catch (Exception e) {
            e.printStackTrace();
        }
        end();
    }


    /**
     * 有参定时任务实现
     * @param param
     */
    public void run(Map<String, Object> param) throws Exception {
        // 模板参数
        Map<String, WeChatTemplateMsg> sendMag = new HashMap<String, WeChatTemplateMsg>();

        String ywTime = (String)param.get("ywTime");


        QueryWrapper<KcMessagelistcopy> kcMessagelistcopyQueryWrapper = new QueryWrapper<>();
        kcMessagelistcopyQueryWrapper.ne("status","1");
        kcMessagelistcopyQueryWrapper.eq("scheduleddatetime", ywTime);
        List<KcMessagelistcopy> messqglist = kcMessagelistcopyService.list();
        for(KcMessagelistcopy KcMessagelistcopy:messqglist){

        // openId代表一个唯一微信用户，即微信消息的接收人
            String openId = KcMessagelistcopy.getTouser();
            // 微信的基础accessToken
            String accessToken = getAccessToken();
            String url = "https://api.weixin.qq.com/cgi-bin/message/template/send?access_token=" + accessToken;

            /**
             *  其他模板可以从模板库中自己添加
             * 模板ID
             * KtWw0lwQ8FOgJdKgrmya0eoafGkMfMN8ECdZs8oSJys
             * 开发者调用模板消息接口时需提供模板ID
             * 标题      上课提醒
             * 行业      教育 - 院校
             * 详细内容
             * {{first.DATA}}
             * 课程：{{keyword1.DATA}}
             * 时间：{{keyword2.DATA}}
             * 地点：{{keyword3.DATA}}
             * {{remark.DATA}}
             */
            sendMag.put("first", new WeChatTemplateMsg(KcMessagelistcopy.getFirstdata()));
            sendMag.put("keyword1", new WeChatTemplateMsg(KcMessagelistcopy.getKeyword1()));
            sendMag.put("keyword2", new WeChatTemplateMsg(KcMessagelistcopy.getKeyword2()));
            sendMag.put("keyword3", new WeChatTemplateMsg(KcMessagelistcopy.getKeyword3()));
            sendMag.put("remark", new WeChatTemplateMsg(KcMessagelistcopy.getRemarkdata()));
            RestTemplate restTemplate = new RestTemplate();
            //拼接base参数
            Map<String, Object> sendBody = new HashMap<>();
            sendBody.put("touser", openId);               // openId
            sendBody.put("url", KcMessagelistcopy.getTourl());         // 点击模板信息跳转地址
            sendBody.put("topcolor", "#FF0000");          // 顶色
            sendBody.put("data", sendMag);                   // 模板参数
            sendBody.put("template_id", KcMessagelistcopy.getTemplateId());      // 模板Id
            ResponseEntity<String> forEntity = restTemplate.postForEntity(url, sendBody, String.class);
            log.info("结果是: {}",forEntity.getBody());
            JSONObject jsonObject = JSONObject.parseObject(forEntity.getBody());
            // 0
            String messageCode = jsonObject.getString("errcode");
            // 2431260672639467520
            String msgId = jsonObject.getString("msgid");
            System.out.println("messageCode : " + messageCode + ", msgId: " +msgId);
            KcMessagelistcopy.setMsgid(msgId);
            KcMessagelistcopy.setStatus("1");
            KcMessagelistcopy.setSendtime(DateUtil.format(new Date(),"yyyy-MM-dd HH:mm:ss"));
            kcMessagelistcopyService.updateById(KcMessagelistcopy);
        }

    }

    public String getAccessToken() throws Exception{
        String url = "https://api.weixin.qq.com/cgi-bin/token?grant_type=client_credential&appid="+ appId +"&secret=" + appIdSecret;
        String res = HttpUtil.get(url);
        JSONObject jsonObject = JSONObject.parseObject(res);
        String accessToken = jsonObject.getString("access_token");
        log.info("accessToken：{}", accessToken);
        return accessToken;
    }
    /**
     * 无参定时任务实现
     */
    public void run(){
        try {
            run(null);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

}
