package org.jeecg.modules.kc.grab.SynchronizationService.base;

import cn.hutool.core.date.DateTime;
import com.alibaba.druid.support.json.JSONParser;
import com.baomidou.mybatisplus.extension.toolkit.SqlHelper;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.jeecg.modules.kc.grab.imports.entity.Xxhbbks;
import org.jeecg.modules.kc.grab.imports.entity.Xxhbsynclog;
import org.jeecg.modules.kc.grab.imports.service.IXxhbsynclogService;
import org.quartz.Job;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.Arrays;
import java.util.Map;
import java.util.logging.Logger;

@Slf4j
public abstract class BaseSync implements Job {

    @Autowired
    private IXxhbsynclogService xxhbsynclogService;

    /**
     * 若参数变量名修改 QuartzJobController中也需对应修改
     */
    private String parameter;

    public void setParameter(String parameter) {
        this.parameter = parameter;
    }

    private Map<String,Object> paramMap;

    public Map<String,Object> getParamMap(){
        return paramMap;
    }

    public

    long startTime = 0;

    public long start(){
        log.info("-------------------------------------------开始辣----------------------------------------------------");
        startTime = System.currentTimeMillis();
        initParam();
        return startTime;
    }

    public void end(){
        log.info("-------------------------------------------结束辣----------------------------------------------------");
        long end = System.currentTimeMillis();
        log.info(String.valueOf(end));
        log.info("耗时：【"+(end - startTime)/1000 + "】秒【"+(end - startTime) + "】毫秒");
    }

    public void initParam() {
        if(this.parameter != null && StringUtils.isNotBlank(this.parameter)){
            JSONParser parser = new JSONParser(this.parameter);
            paramMap = parser.parseMap();
        }
    }

    public abstract void run(Map<String, Object> param) throws Exception;

    public abstract void run();

    public void saveLog(Xxhbsynclog xxhbsynclog) {
        saveLog(xxhbsynclog,null);
    }

    public void saveLog(Xxhbsynclog xxhbsynclog, Class clazz) {
        try {
            DateTime now = DateTime.now();
            xxhbsynclog.setSyncdate(now.toDateStr());//日期
            xxhbsynclog.setSynctime(now.toTimeStr());//时间
            if(clazz != null){
                xxhbsynclog.setTablename(SqlHelper.table(clazz).getTableName());
            }
            xxhbsynclogService.save(xxhbsynclog);
        }catch (Exception e){
            log.error("同步数据出现未知错误!!!");
            log.error(e.getMessage(),e);
        }
    }



}
