package org.jeecg.modules.kc.grab.SynchronizationService.tools;

import cn.hutool.core.date.DatePattern;
import cn.hutool.core.date.DateUnit;
import cn.hutool.core.date.DateUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.beust.jcommander.internal.Sets;
import com.google.common.collect.Maps;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.compress.utils.Lists;
import org.apache.commons.lang.StringUtils;
import org.jeecg.modules.kc.config.entity.KcExportConfigTpkwcqkjzglx;
import org.jeecg.modules.kc.config.service.IKcExportConfigTpkwcqkjzglxService;
import org.jeecg.modules.kc.grab.imports.entity.Xxhbuser;
import org.jeecg.modules.kc.grab.imports.service.IXxhbuserService;
import org.jeecg.modules.kc.kcCasusers.entity.KcCasusers;
import org.jeecg.modules.kc.kcCasusers.service.IKcCasusersService;
import org.jeecg.modules.kc.kcSysConfig.entity.KcSysConfig;
import org.jeecg.modules.kc.kcSysConfig.service.IKcSysConfigService;
import org.jeecg.modules.kc.kcXqxnHistory.entity.KcXqxnHistory;
import org.jeecg.modules.kc.kcXqxnHistory.service.IKcXqxnHistoryService;
import org.jeecg.modules.kc.qa.entity.KcEvaluation;
import org.jeecg.modules.kc.qa.service.IKcEvaluationService;
import org.jeecg.modules.kc.tksf.kctkcstj.entity.KcTkcstj;
import org.jeecg.modules.kc.tksf.kctkcstj.service.IKcTkcstjService;
import org.jeecg.modules.kc.tksf.kctksfrzb.entity.KcTksfrzb;
import org.jeecg.modules.kc.tksf.kctksfrzb.service.IKcTksfrzbService;
import org.jeecg.modules.kc.tktj.entity.KcTingke;
import org.jeecg.modules.kc.tktj.service.IKcTingkeService;
import org.jeecg.modules.tools.DictUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.stereotype.Component;

import java.util.Date;
import java.util.List;
import java.util.Map;
import java.util.Set;

/**
 * 清洗听课统计
 */
@Slf4j
@Component
public class ChangeTingKeTongJi {

    @Autowired
    private IKcXqxnHistoryService kcXqxnHistoryService;
    @Autowired
    private IKcTkcstjService kcTkcstjService;

    @Autowired
    private IKcTksfrzbService kcTksfrzbService;

    @Autowired
    private IXxhbuserService xxhbuserService;

    @Autowired
    private IKcTingkeService kcTingkeService;

    @Autowired
    private DictUtils dictUtils;

    @Autowired
    @Lazy
    private IKcExportConfigTpkwcqkjzglxService exportConfigTpkwcqkjzglxService;

    public KcXqxnHistory getXqConfig(){
        return getXqConfig(null);
    }

    public KcXqxnHistory getXqConfig(String xqxn){
        QueryWrapper<KcXqxnHistory> qw = new QueryWrapper<>();
        qw.eq(StringUtils.isNotBlank(xqxn),"title",xqxn);
        qw.orderByDesc("end_time");
        qw.last("limit 1");
        return kcXqxnHistoryService.getOne(qw);
    }

    public void changeTingKeTongji(){
        updateTingKeTongJiByUserId(null,null);
    }

    public void changeTingKeTongji(String xqxn){
        updateTingKeTongJiByUserId(xqxn,null);
    }

    public void updateTingKeTongJiByUserId(String userId){
        updateTingKeTongJiByUserId(null,userId);
    }

    public void updateTingKeTongJiByUserId(String xqxnt, String userId){
        KcXqxnHistory common = getXqConfig(xqxnt);
        if(common != null) {
            //Map<String, KcTkcstj> tongJiMap = Maps.newHashMap();
            //清洗数据核心
            Date startSjDate = common.getStartTime();
            Date endSjDate = common.getEndTime();
            String startSj = DateUtil.format(startSjDate,DatePattern.NORM_DATETIME_FORMAT);
            String endSj = DateUtil.format(endSjDate,DatePattern.NORM_DATETIME_FORMAT);
            String xqxn = common.getTitle();

            Set<String> tjSet = Sets.newHashSet();
            //此法会造成数据变多，，改为新方法统计
//            saveMainList.forEach(x -> {
//                //先过滤数据为本学期的。
//                Date pkDate = x.getUpDate();
//                long startDiffer = DateUtil.between(DateUtil.parse(startSj), pkDate, DateUnit.DAY,true);
//                long endDiffer = DateUtil.between(pkDate, DateUtil.parse(endSj), DateUnit.DAY,true);
//
//                if(startDiffer > 0 && endDiffer > 0){
//                    tjSet.add(x.getUserid());
//                    if(tongJiMap.containsKey(x.getUserid())){
//                        KcTkcstj tj = tongJiMap.get(x.getUserid());
//                        String tks = tj.getTkxttj();
//                        tj.setTkxttj(String.valueOf(Integer.parseInt(tks)+1));//听课数量+1
//                    }else{
//                        KcTkcstj tj = new KcTkcstj();
//                        tj.setXnxq(xqxn);//学期学年
//                        tj.setJgh(x.getUserid());
//                        //tj.setJsxm("");//后面补
//                        //tj.setSsxy();
//                        //tj.setTksf();
//                        //tj.setYskcs();
//                        tj.setTkxttj("0");
//                        tongJiMap.put(x.getUserid(),tj);
//                    }
//                }
//            });

            QueryWrapper<KcTingke> evaQw = new QueryWrapper<>();
            evaQw.select("count(userid) as pkNum,userid,tingketime");

            evaQw.apply("(tingketime,kechengbiaoid,userid) in ( select max(tingketime) as tingketime,kechengbiaoid,userid from kc_tingke where true "+
                "and tingketime >= STR_TO_DATE( '"+ startSj +"', '%Y-%m-%d' ) "+
                "AND tingketime <= STR_TO_DATE( '" + endSj +"', '%Y-%m-%d' ) "+
                "and kechengbiaoid is not null "+
                "GROUP BY userid, kechengbiaoid "+
                "ORDER BY tingketime desc "+
                ")"
            );

            evaQw.eq(StringUtils.isNotBlank(userId),"userid",userId);
//            evaQw.apply("tingketime >= STR_TO_DATE('"+ startSj +"', '%Y-%m-%d') ");
//            evaQw.apply("tingketime <= STR_TO_DATE('"+ endSj +"', '%Y-%m-%d') ");
            //evaQw.isNotNull("kechengbiaoid");
            evaQw.groupBy("userid,tingketime");
            evaQw.orderByAsc("tingketime");

            List<KcTingke> countTjList = kcTingkeService.list(evaQw);

            //Map<String, KcEvaluation> countTj = Maps.newHashMap();
            countTjList.forEach(x -> {
                tjSet.add(x.getUserid());
                //countTj.put(x.getUserid(),x);
            });

            if(tjSet.isEmpty()){
                log.error("工号为空，咋办？");
                return;
            }

            //查询所在单位
            QueryWrapper<Xxhbuser> szdwQw = new QueryWrapper<>();
            szdwQw.in("gh",tjSet);
            List<Xxhbuser> szdwList =  xxhbuserService.list(szdwQw);
            Map<String, Xxhbuser> szdwMap = Maps.newHashMap();
            szdwList.forEach(x -> {
                szdwMap.put(x.getGh(),x);
            });

            //查询听课身份
            QueryWrapper<KcExportConfigTpkwcqkjzglx> tksfQw = new QueryWrapper<>();
            tksfQw.in("gh",tjSet);
            List<KcExportConfigTpkwcqkjzglx> tksfList =  exportConfigTpkwcqkjzglxService.list(tksfQw);
            Map<String, KcExportConfigTpkwcqkjzglx> tksfMap = Maps.newHashMap();
            tksfList.forEach(x -> {
                if(tksfMap.containsKey(x.getGh())){
                    //存在了，拼接职务名称，取最大的听课要求
                    KcExportConfigTpkwcqkjzglx currentData = tksfMap.get(x.getGh());
                    String currentZwmc = dictUtils.translateDictValue("tpkwcqkjzglx",currentData.getTklx());
                    String currentTkyq = currentData.getYtkcs();
                    if(StringUtils.isNotBlank(currentTkyq)){
                        int tkyq = Integer.parseInt(currentTkyq);
                        int xtkyq = Integer.parseInt(StringUtils.defaultString(x.getYtkcs(),"0"));
                        x.setZwmc(currentZwmc + "、" + dictUtils.translateDictValue("tpkwcqkjzglx",x.getTklx()));
                        if(tkyq > xtkyq){
                            x.setYtkcs(String.valueOf(tkyq));
                        }else{
                            x.setYtkcs(String.valueOf(xtkyq));
                        }
                    }else{
                        x.setZwmc(currentZwmc + "、" + dictUtils.translateDictValue("tpkwcqkjzglx",x.getTklx()));
                    }
                    tksfMap.put(x.getGh(),x);
                }else {
                    tksfMap.put(x.getGh(),x);
                }
            });

            //删除已有听课数据重新生成
            QueryWrapper<KcTkcstj> tjQw = new QueryWrapper<>();
            tjQw.eq(StringUtils.isNotBlank(userId),"jgh",userId);
            tjQw.eq("xnxq",xqxn);
            tjQw.in("jgh",tjSet);
            kcTkcstjService.remove(tjQw);

            //查询已有听课数据
//            QueryWrapper<KcTkcstj> tjQw = new QueryWrapper<>();
//            tjQw.eq("xnxq",xqxn);
//            tjQw.in("jgh",tjSet);
//            List<KcTkcstj> tjList =  kcTkcstjService.list(tjQw);
//            Map<String, KcTkcstj> tjMap = Maps.newHashMap();
//            tjList.forEach(x -> {
//                tjMap.put(x.getJgh(),x);
//                //刷新身份和听课要求
//                if(tksfMap.containsKey(x.getJgh())){
//                    KcTksfrzb currentData = tksfMap.get(x.getJgh());
//                    x.setTksf(currentData.getZwmc());
//                    x.setYskcs(currentData.getTkyq());
//                }
//            });


//            List<KcTkcstj> updateTjList = Lists.newArrayList();
            List<KcTkcstj> addTjList = Lists.newArrayList();
            countTjList.forEach(x-> {
                KcTkcstj tj = new KcTkcstj();
                //填充所在单位
                String xuserId = x.getUserid();

                tj.setXnxq(xqxn);
                tj.setJgh(xuserId);
                if(szdwMap.containsKey(xuserId)){
                    Xxhbuser currentData = szdwMap.get(xuserId);
                    tj.setSsxy(currentData.getDwmc());
                }
                if(tksfMap.containsKey(xuserId)){
                    KcExportConfigTpkwcqkjzglx currentData = tksfMap.get(xuserId);
                    tj.setJsxm(currentData.getXm());
                    tj.setTksf(StringUtils.defaultString(currentData.getZwmc(),dictUtils.translateDictValue("tpkwcqkjzglx",currentData.getTklx())));
                    tj.setYskcs(currentData.getYtkcs());
                }
                if(StringUtils.isBlank(tj.getJsxm())){//补充教师姓名
                    if(szdwMap.containsKey(xuserId)){
                        Xxhbuser casuser = szdwMap.get(xuserId);
                        if(casuser != null) {
                            tj.setJsxm(casuser.getXm());
                        }
                    }
                }
                tj.setTkxttj(String.valueOf(x.getPkNum()));
                addTjList.add(tj);
            });

//            tongJiMap.forEach((k,v) -> {
//                if(tjMap.containsKey(k)){
//                    //旧数据更新
//                    KcTkcstj tjData = tjMap.get(k);
//                    v.setJsxm(tjData.getJsxm());
//                    v.setSsxy(tjData.getSsxy());
//                    v.setTksf(tjData.getTksf());
//                    v.setYskcs(tjData.getYskcs());
//                    String sjtks = v.getTkxttj();
//                    if(StringUtils.isNotBlank((sjtks))){
//                        int xtks = 0;
//                        if(StringUtils.isNotBlank(tjData.getTkxttj())){
//                            xtks = Integer.parseInt(tjData.getTksf());
//                        }
//                        v.setTkxttj(String.valueOf(Integer.parseInt(sjtks) + xtks));
//                    }
//                    //转成更新List
//                    //updateTjList.add(v);
//                    UpdateWrapper<KcTkcstj> uw = new UpdateWrapper<>();
//                    uw.set("tksf",v.getTksf());
//                    uw.set("yskcs",v.getYskcs());
//                    uw.set("tkxttj",v.getTkxttj());
//                    uw.eq("xnxq",v.getXnxq());
//                    uw.eq("jgh",v.getJgh());
//                    kcTkcstjService.update(uw);
//                }else {
//                    //新数据
//                    //添加身份和听课要求
//                    if(tksfMap.containsKey(k)){
//                        KcTksfrzb currentData = tksfMap.get(k);
//                        v.setTksf(currentData.getZwmc());
//                        v.setYskcs(currentData.getTkyq());
//                        v.setJsxm(currentData.getXm());
//                        //v.setSsxy(currentData.());//?
//                        String sjtks = v.getTkxttj();
//                        if(StringUtils.isNotBlank((sjtks))){
//                            v.setTkxttj(sjtks);
//                        }
//                        addTjList.add(v);
//                    }
//                }
//            });
            kcTkcstjService.saveBatch(addTjList);
        }else {
            log.error("查不到基本配置！【去kc_sys_config表添加ID为1的数据】");
        }
    }

    public void addTingKeData(String userId,String kbId){
        addTingKeData(userId, kbId, new Date());
    }

    public void addTingKeData(String userId,String kbId,Date tkSj){
        //删除旧数据
        QueryWrapper<KcTingke> removeQw = new QueryWrapper<>();
        removeQw.eq("userid",userId);
        removeQw.eq("kechengbiaoid",kbId);
        kcTingkeService.remove(removeQw);
        //查询辅助数据
        //查询所在单位
        QueryWrapper<Xxhbuser> szdwQw = new QueryWrapper<>();
        szdwQw.eq("gh",userId);
        List<Xxhbuser> szdwList =  xxhbuserService.list(szdwQw);
        Map<String, Xxhbuser> szdwMap = Maps.newHashMap();
        szdwList.forEach(x -> {
            szdwMap.put(x.getGh(),x);
        });

        //查询听课身份
        QueryWrapper<KcTksfrzb> tksfQw = new QueryWrapper<>();
        tksfQw.eq("gh",userId);
        List<KcTksfrzb> tksfList =  kcTksfrzbService.list(tksfQw);
        Map<String, KcTksfrzb> tksfMap = Maps.newHashMap();
        tksfList.forEach(x -> {
            if(tksfMap.containsKey(x.getGh())){
                //存在了，拼接职务名称，取最大的听课要求
                KcTksfrzb currentData = tksfMap.get(x.getGh());
                String currentZwmc = currentData.getZwmc();
                String currentTkyq = currentData.getTkyq();
                if(StringUtils.isNotBlank(currentZwmc)){
                    int tkyq = Integer.parseInt(StringUtils.defaultString(currentTkyq,"0"));
                    int xtkyq = Integer.parseInt(StringUtils.defaultString(x.getTkyq(),"0"));
                    x.setZwmc(currentZwmc + "、" + x.getZwmc());
                    if(tkyq > xtkyq){
                        x.setTkyq(String.valueOf(tkyq));
                    }else{
                        x.setTkyq(String.valueOf(xtkyq));
                    }
                }else{
                    x.setZwmc(currentZwmc + "、" + x.getZwmc());
                }
                tksfMap.put(x.getGh(),x);
            }else {
                tksfMap.put(x.getGh(),x);
            }
        });

        //组合数据
        KcTingke kcTingke = new KcTingke();
        kcTingke.setTingketime(DateUtil.format(tkSj, DatePattern.NORM_DATETIME_FORMAT));
        kcTingke.setKechengbiaoid(kbId);
        kcTingke.setUserid(userId);
        if(tksfMap.containsKey(userId)){
            KcTksfrzb currentData = tksfMap.get(userId);
            if(StringUtils.isNotBlank(currentData.getTkyq())){
                kcTingke.setUsertkyq(Integer.parseInt(currentData.getTkyq()));
            }else{
                kcTingke.setUsertkyq(0);
            }

            String tksfs = currentData.getZwmc();
            if(StringUtils.isNotBlank(tksfs)){
                if(StringUtils.indexOf(tksfs,"、") != 1){
                    String[] tksfArray = tksfs.split("、");
                    kcTingke.setUsertksf1(tksfArray[0]);
                    if(tksfArray.length >= 2){
                        kcTingke.setUsertksf2(tksfArray[1]);
                    }
                }else {
                    kcTingke.setUsertksf1(tksfs);
                }
            }
        }
        Xxhbuser xxhbuser = szdwMap.get(userId);
        if(xxhbuser != null){
            kcTingke.setUsername(xxhbuser.getXm());
            kcTingke.setUserdwmc(xxhbuser.getDwmc());
        }
//        if(StringUtils.isBlank(kcTingke.getJsxm())){//补充教师姓名
//            if(szdwMap.containsKey(userId)){
//                Xxhbuser casuser = szdwMap.get(userId);
//                if(casuser != null) {
//                    kcTingke.setJsxm(casuser.getXm());
//                }
//            }
//        }

        kcTingkeService.save(kcTingke);


    }

    public void updateTingKeTongJiAndPingKeByUserId(String userId,String kbId){
        addTingKeData(userId,kbId);
        updateTingKeTongJiByUserId(userId);
    }

    public static void main(String[] args) {
        String startSj = "2023-02-20";
        String endSj = "2023-07-17";
        Date pkDate = DateUtil.parse("2023-02-18");
        long startDiffer = DateUtil.between(DateUtil.parse(startSj), pkDate, DateUnit.DAY,false);
        long endDiffer = DateUtil.between(pkDate, DateUtil.parse(endSj), DateUnit.DAY,false);
        System.out.println(startDiffer);
        System.out.println(endDiffer);
    }

}
