package org.jeecg.modules.kc.grab.exports.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.jeecg.common.system.base.controller.JeecgController;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.modules.kc.grab.exports.entity.TFwdtBkjxtkpj;
import org.jeecg.modules.kc.grab.exports.service.ITFwdtBkjxtkpjService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.Arrays;

/**
* @Description: TFwdtBkjxtkpj
* @Author: jeecg-boot
* @Date:   2023-05-04
* @Version: V1.0
*/
@Api(tags="TFwdtBkjxtkpj")
@RestController
@RequestMapping("/TFwdtBkjxtkpj/TFwdtBkjxtkpj")
@Slf4j
public class TFwdtBkjxtkpjController extends JeecgController<TFwdtBkjxtkpj, ITFwdtBkjxtkpjService> {
   @Autowired
   private ITFwdtBkjxtkpjService TFwdtBkjxtkpjService;
   
   /**
    * 分页列表查询
    *
    * @param TFwdtBkjxtkpj
    * @param pageNo
    * @param pageSize
    * @param req
    * @return
    */
   //@AutoLog(value = "TFwdtBkjxtkpj-分页列表查询")
   @ApiOperation(value="TFwdtBkjxtkpj-分页列表查询", notes="TFwdtBkjxtkpj-分页列表查询")
   @GetMapping(value = "/list")
   public Result<IPage<TFwdtBkjxtkpj>> queryPageList(TFwdtBkjxtkpj TFwdtBkjxtkpj,
                                  @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
                                  @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
                                  HttpServletRequest req) {
       QueryWrapper<TFwdtBkjxtkpj> queryWrapper = QueryGenerator.initQueryWrapper(TFwdtBkjxtkpj, req.getParameterMap());
       Page<TFwdtBkjxtkpj> page = new Page<TFwdtBkjxtkpj>(pageNo, pageSize);
       IPage<TFwdtBkjxtkpj> pageList = TFwdtBkjxtkpjService.page(page, queryWrapper);
       return Result.OK(pageList);
   }
   
   /**
    *   添加
    *
    * @param TFwdtBkjxtkpj
    * @return
    */
   @AutoLog(value = "TFwdtBkjxtkpj-添加")
   @ApiOperation(value="TFwdtBkjxtkpj-添加", notes="TFwdtBkjxtkpj-添加")
   @RequiresPermissions("TFwdtBkjxtkpj:TFwdtBkjxtkpj:add")
   @PostMapping(value = "/add")
   public Result<String> add(@RequestBody TFwdtBkjxtkpj TFwdtBkjxtkpj) {
       TFwdtBkjxtkpjService.save(TFwdtBkjxtkpj);
       return Result.OK("添加成功！");
   }
   
   /**
    *  编辑
    *
    * @param TFwdtBkjxtkpj
    * @return
    */
   @AutoLog(value = "TFwdtBkjxtkpj-编辑")
   @ApiOperation(value="TFwdtBkjxtkpj-编辑", notes="TFwdtBkjxtkpj-编辑")
   @RequiresPermissions("TFwdtBkjxtkpj:TFwdtBkjxtkpj:edit")
   @RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
   public Result<String> edit(@RequestBody TFwdtBkjxtkpj TFwdtBkjxtkpj) {
       TFwdtBkjxtkpjService.updateById(TFwdtBkjxtkpj);
       return Result.OK("编辑成功!");
   }
   
   /**
    *   通过id删除
    *
    * @param id
    * @return
    */
   @AutoLog(value = "TFwdtBkjxtkpj-通过id删除")
   @ApiOperation(value="TFwdtBkjxtkpj-通过id删除", notes="TFwdtBkjxtkpj-通过id删除")
   @RequiresPermissions("TFwdtBkjxtkpj:TFwdtBkjxtkpj:delete")
   @DeleteMapping(value = "/delete")
   public Result<String> delete(@RequestParam(name="id",required=true) String id) {
       TFwdtBkjxtkpjService.removeById(id);
       return Result.OK("删除成功!");
   }
   
   /**
    *  批量删除
    *
    * @param ids
    * @return
    */
   @AutoLog(value = "TFwdtBkjxtkpj-批量删除")
   @ApiOperation(value="TFwdtBkjxtkpj-批量删除", notes="TFwdtBkjxtkpj-批量删除")
   @RequiresPermissions("TFwdtBkjxtkpj:TFwdtBkjxtkpj:deleteBatch")
   @DeleteMapping(value = "/deleteBatch")
   public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
       this.TFwdtBkjxtkpjService.removeByIds(Arrays.asList(ids.split(",")));
       return Result.OK("批量删除成功!");
   }
   
   /**
    * 通过id查询
    *
    * @param id
    * @return
    */
   //@AutoLog(value = "TFwdtBkjxtkpj-通过id查询")
   @ApiOperation(value="TFwdtBkjxtkpj-通过id查询", notes="TFwdtBkjxtkpj-通过id查询")
   @GetMapping(value = "/queryById")
   public Result<TFwdtBkjxtkpj> queryById(@RequestParam(name="id",required=true) String id) {
       TFwdtBkjxtkpj TFwdtBkjxtkpj = TFwdtBkjxtkpjService.getById(id);
       if(TFwdtBkjxtkpj==null) {
           return Result.error("未找到对应数据");
       }
       return Result.OK(TFwdtBkjxtkpj);
   }

   /**
   * 导出excel
   *
   * @param request
   * @param TFwdtBkjxtkpj
   */
   @RequiresPermissions("TFwdtBkjxtkpj:TFwdtBkjxtkpj:exportXls")
   @RequestMapping(value = "/exportXls")
   public ModelAndView exportXls(HttpServletRequest request, TFwdtBkjxtkpj TFwdtBkjxtkpj) {
       return super.exportXls(request, TFwdtBkjxtkpj, TFwdtBkjxtkpj.class, "TFwdtBkjxtkpj");
   }

   /**
     * 通过excel导入数据
   *
   * @param request
   * @param response
   * @return
   */
   @RequiresPermissions("TFwdtBkjxtkpj:TFwdtBkjxtkpj:importExcel")
   @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
   public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
       return super.importExcel(request, response, TFwdtBkjxtkpj.class);
   }

}
