package org.jeecg.modules.kc.grab.exports.controller;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.kc.grab.exports.entity.TJwJsjbxx;
import org.jeecg.modules.kc.grab.exports.service.ITJwJsjbxxService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

 /**
 * @Description: TJwJsjbxx
 * @Author: jeecg-boot
 * @Date:   2023-05-22
 * @Version: V1.0
 */
@Api(tags="TJwJsjbxx")
@RestController
@RequestMapping("/TJwJsjbxx/TJwJsjbxx")
@Slf4j
public class TJwJsjbxxController extends JeecgController<TJwJsjbxx, ITJwJsjbxxService> {
	@Autowired
	private ITJwJsjbxxService TJwJsjbxxService;
	
	/**
	 * 分页列表查询
	 *
	 * @param TJwJsjbxx
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "TJwJsjbxx-分页列表查询")
	@ApiOperation(value="TJwJsjbxx-分页列表查询", notes="TJwJsjbxx-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<TJwJsjbxx>> queryPageList(TJwJsjbxx TJwJsjbxx,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<TJwJsjbxx> queryWrapper = QueryGenerator.initQueryWrapper(TJwJsjbxx, req.getParameterMap());
		Page<TJwJsjbxx> page = new Page<TJwJsjbxx>(pageNo, pageSize);
		IPage<TJwJsjbxx> pageList = TJwJsjbxxService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param TJwJsjbxx
	 * @return
	 */
	@AutoLog(value = "TJwJsjbxx-添加")
	@ApiOperation(value="TJwJsjbxx-添加", notes="TJwJsjbxx-添加")
	@RequiresPermissions("TJwJsjbxx:TJwJsjbxx:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody TJwJsjbxx TJwJsjbxx) {
		TJwJsjbxxService.save(TJwJsjbxx);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param TJwJsjbxx
	 * @return
	 */
	@AutoLog(value = "TJwJsjbxx-编辑")
	@ApiOperation(value="TJwJsjbxx-编辑", notes="TJwJsjbxx-编辑")
	@RequiresPermissions("TJwJsjbxx:TJwJsjbxx:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody TJwJsjbxx TJwJsjbxx) {
		TJwJsjbxxService.updateById(TJwJsjbxx);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "TJwJsjbxx-通过id删除")
	@ApiOperation(value="TJwJsjbxx-通过id删除", notes="TJwJsjbxx-通过id删除")
	@RequiresPermissions("TJwJsjbxx:TJwJsjbxx:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		TJwJsjbxxService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "TJwJsjbxx-批量删除")
	@ApiOperation(value="TJwJsjbxx-批量删除", notes="TJwJsjbxx-批量删除")
	@RequiresPermissions("TJwJsjbxx:TJwJsjbxx:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.TJwJsjbxxService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "TJwJsjbxx-通过id查询")
	@ApiOperation(value="TJwJsjbxx-通过id查询", notes="TJwJsjbxx-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<TJwJsjbxx> queryById(@RequestParam(name="id",required=true) String id) {
		TJwJsjbxx TJwJsjbxx = TJwJsjbxxService.getById(id);
		if(TJwJsjbxx==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(TJwJsjbxx);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param TJwJsjbxx
    */
    @RequiresPermissions("TJwJsjbxx:TJwJsjbxx:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, TJwJsjbxx TJwJsjbxx) {
        return super.exportXls(request, TJwJsjbxx, TJwJsjbxx.class, "TJwJsjbxx");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("TJwJsjbxx:TJwJsjbxx:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, TJwJsjbxx.class);
    }

}
