package org.jeecg.modules.kc.grab.exports.controller;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.kc.grab.exports.entity.TJwJxljbxx;
import org.jeecg.modules.kc.grab.exports.service.ITJwJxljbxxService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

 /**
 * @Description: TJwJxljbxx
 * @Author: jeecg-boot
 * @Date:   2023-05-22
 * @Version: V1.0
 */
@Api(tags="TJwJxljbxx")
@RestController
@RequestMapping("/TJwJxljbxx/TJwJxljbxx")
@Slf4j
public class TJwJxljbxxController extends JeecgController<TJwJxljbxx, ITJwJxljbxxService> {
	@Autowired
	private ITJwJxljbxxService TJwJxljbxxService;
	
	/**
	 * 分页列表查询
	 *
	 * @param TJwJxljbxx
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "TJwJxljbxx-分页列表查询")
	@ApiOperation(value="TJwJxljbxx-分页列表查询", notes="TJwJxljbxx-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<TJwJxljbxx>> queryPageList(TJwJxljbxx TJwJxljbxx,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<TJwJxljbxx> queryWrapper = QueryGenerator.initQueryWrapper(TJwJxljbxx, req.getParameterMap());
		Page<TJwJxljbxx> page = new Page<TJwJxljbxx>(pageNo, pageSize);
		IPage<TJwJxljbxx> pageList = TJwJxljbxxService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param TJwJxljbxx
	 * @return
	 */
	@AutoLog(value = "TJwJxljbxx-添加")
	@ApiOperation(value="TJwJxljbxx-添加", notes="TJwJxljbxx-添加")
	@RequiresPermissions("TJwJxljbxx:TJwJxljbxx:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody TJwJxljbxx TJwJxljbxx) {
		TJwJxljbxxService.save(TJwJxljbxx);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param TJwJxljbxx
	 * @return
	 */
	@AutoLog(value = "TJwJxljbxx-编辑")
	@ApiOperation(value="TJwJxljbxx-编辑", notes="TJwJxljbxx-编辑")
	@RequiresPermissions("TJwJxljbxx:TJwJxljbxx:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody TJwJxljbxx TJwJxljbxx) {
		TJwJxljbxxService.updateById(TJwJxljbxx);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "TJwJxljbxx-通过id删除")
	@ApiOperation(value="TJwJxljbxx-通过id删除", notes="TJwJxljbxx-通过id删除")
	@RequiresPermissions("TJwJxljbxx:TJwJxljbxx:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		TJwJxljbxxService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "TJwJxljbxx-批量删除")
	@ApiOperation(value="TJwJxljbxx-批量删除", notes="TJwJxljbxx-批量删除")
	@RequiresPermissions("TJwJxljbxx:TJwJxljbxx:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.TJwJxljbxxService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "TJwJxljbxx-通过id查询")
	@ApiOperation(value="TJwJxljbxx-通过id查询", notes="TJwJxljbxx-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<TJwJxljbxx> queryById(@RequestParam(name="id",required=true) String id) {
		TJwJxljbxx TJwJxljbxx = TJwJxljbxxService.getById(id);
		if(TJwJxljbxx==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(TJwJxljbxx);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param TJwJxljbxx
    */
    @RequiresPermissions("TJwJxljbxx:TJwJxljbxx:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, TJwJxljbxx TJwJxljbxx) {
        return super.exportXls(request, TJwJxljbxx, TJwJxljbxx.class, "TJwJxljbxx");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("TJwJxljbxx:TJwJxljbxx:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, TJwJxljbxx.class);
    }

}
