package org.jeecg.modules.kc.grab.imports.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.jeecg.common.system.base.controller.JeecgController;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.modules.kc.grab.imports.entity.Xxhbbkjxtkpj;
import org.jeecg.modules.kc.grab.imports.service.IXxhbbkjxtkpjService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.Arrays;

 /**
 * @Description: xxhbbkjxtkpj
 * @Author: jeecg-boot
 * @Date:   2023-05-04
 * @Version: V1.0
 */
@Api(tags="xxhbbkjxtkpj")
@RestController
@RequestMapping("/xxhbbkjxtkpj/xxhbbkjxtkpj")
@Slf4j
public class XxhbbkjxtkpjController extends JeecgController<Xxhbbkjxtkpj, IXxhbbkjxtkpjService> {
	@Autowired
	private IXxhbbkjxtkpjService xxhbbkjxtkpjService;
	
	/**
	 * 分页列表查询
	 *
	 * @param xxhbbkjxtkpj
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "xxhbbkjxtkpj-分页列表查询")
	@ApiOperation(value="xxhbbkjxtkpj-分页列表查询", notes="xxhbbkjxtkpj-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<Xxhbbkjxtkpj>> queryPageList(Xxhbbkjxtkpj xxhbbkjxtkpj,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<Xxhbbkjxtkpj> queryWrapper = QueryGenerator.initQueryWrapper(xxhbbkjxtkpj, req.getParameterMap());
		Page<Xxhbbkjxtkpj> page = new Page<Xxhbbkjxtkpj>(pageNo, pageSize);
		IPage<Xxhbbkjxtkpj> pageList = xxhbbkjxtkpjService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param xxhbbkjxtkpj
	 * @return
	 */
	@AutoLog(value = "xxhbbkjxtkpj-添加")
	@ApiOperation(value="xxhbbkjxtkpj-添加", notes="xxhbbkjxtkpj-添加")
	@RequiresPermissions("xxhbbkjxtkpj:xxhbbkjxtkpj:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody Xxhbbkjxtkpj xxhbbkjxtkpj) {
		xxhbbkjxtkpjService.save(xxhbbkjxtkpj);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param xxhbbkjxtkpj
	 * @return
	 */
	@AutoLog(value = "xxhbbkjxtkpj-编辑")
	@ApiOperation(value="xxhbbkjxtkpj-编辑", notes="xxhbbkjxtkpj-编辑")
	@RequiresPermissions("xxhbbkjxtkpj:xxhbbkjxtkpj:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody Xxhbbkjxtkpj xxhbbkjxtkpj) {
		xxhbbkjxtkpjService.updateById(xxhbbkjxtkpj);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "xxhbbkjxtkpj-通过id删除")
	@ApiOperation(value="xxhbbkjxtkpj-通过id删除", notes="xxhbbkjxtkpj-通过id删除")
	@RequiresPermissions("xxhbbkjxtkpj:xxhbbkjxtkpj:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		xxhbbkjxtkpjService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "xxhbbkjxtkpj-批量删除")
	@ApiOperation(value="xxhbbkjxtkpj-批量删除", notes="xxhbbkjxtkpj-批量删除")
	@RequiresPermissions("xxhbbkjxtkpj:xxhbbkjxtkpj:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.xxhbbkjxtkpjService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "xxhbbkjxtkpj-通过id查询")
	@ApiOperation(value="xxhbbkjxtkpj-通过id查询", notes="xxhbbkjxtkpj-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<Xxhbbkjxtkpj> queryById(@RequestParam(name="id",required=true) String id) {
		Xxhbbkjxtkpj xxhbbkjxtkpj = xxhbbkjxtkpjService.getById(id);
		if(xxhbbkjxtkpj==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(xxhbbkjxtkpj);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param xxhbbkjxtkpj
    */
    @RequiresPermissions("xxhbbkjxtkpj:xxhbbkjxtkpj:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, Xxhbbkjxtkpj xxhbbkjxtkpj) {
        return super.exportXls(request, xxhbbkjxtkpj, Xxhbbkjxtkpj.class, "xxhbbkjxtkpj");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("xxhbbkjxtkpj:xxhbbkjxtkpj:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, Xxhbbkjxtkpj.class);
    }

}
