package org.jeecg.modules.kc.grab.imports.controller;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.kc.grab.imports.entity.Xxhbdw;
import org.jeecg.modules.kc.grab.imports.service.IXxhbdwService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

 /**
 * @Description: 同步数据表(bdw)
 * @Author: jeecg-boot
 * @Date:   2023-04-11
 * @Version: V1.0
 */
@Api(tags="同步数据表(bdw)")
@RestController
@RequestMapping("/grab/imports/xxhbdw")
@Slf4j
public class XxhbdwController extends JeecgController<Xxhbdw, IXxhbdwService> {
	@Autowired
	private IXxhbdwService xxhbdwService;
	
	/**
	 * 分页列表查询
	 *
	 * @param xxhbdw
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "同步数据表(bdw)-分页列表查询")
	@ApiOperation(value="同步数据表(bdw)-分页列表查询", notes="同步数据表(bdw)-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<Xxhbdw>> queryPageList(Xxhbdw xxhbdw,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<Xxhbdw> queryWrapper = QueryGenerator.initQueryWrapper(xxhbdw, req.getParameterMap());
		Page<Xxhbdw> page = new Page<Xxhbdw>(pageNo, pageSize);
		IPage<Xxhbdw> pageList = xxhbdwService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param xxhbdw
	 * @return
	 */
	@AutoLog(value = "同步数据表(bdw)-添加")
	@ApiOperation(value="同步数据表(bdw)-添加", notes="同步数据表(bdw)-添加")
	@RequiresPermissions("grab.imports:xxhbdw:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody Xxhbdw xxhbdw) {
		xxhbdwService.save(xxhbdw);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param xxhbdw
	 * @return
	 */
	@AutoLog(value = "同步数据表(bdw)-编辑")
	@ApiOperation(value="同步数据表(bdw)-编辑", notes="同步数据表(bdw)-编辑")
	@RequiresPermissions("grab.imports:xxhbdw:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody Xxhbdw xxhbdw) {
		xxhbdwService.updateById(xxhbdw);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "同步数据表(bdw)-通过id删除")
	@ApiOperation(value="同步数据表(bdw)-通过id删除", notes="同步数据表(bdw)-通过id删除")
	@RequiresPermissions("grab.imports:xxhbdw:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		xxhbdwService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "同步数据表(bdw)-批量删除")
	@ApiOperation(value="同步数据表(bdw)-批量删除", notes="同步数据表(bdw)-批量删除")
	@RequiresPermissions("grab.imports:xxhbdw:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.xxhbdwService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "同步数据表(bdw)-通过id查询")
	@ApiOperation(value="同步数据表(bdw)-通过id查询", notes="同步数据表(bdw)-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<Xxhbdw> queryById(@RequestParam(name="id",required=true) String id) {
		Xxhbdw xxhbdw = xxhbdwService.getById(id);
		if(xxhbdw==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(xxhbdw);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param xxhbdw
    */
    @RequiresPermissions("grab.imports:xxhbdw:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, Xxhbdw xxhbdw) {
        return super.exportXls(request, xxhbdw, Xxhbdw.class, "同步数据表(bdw)");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("grab.imports:xxhbdw:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, Xxhbdw.class);
    }

}
