package org.jeecg.modules.kc.grab.imports.controller;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.kc.grab.imports.entity.Xxhbjsjbxx;
import org.jeecg.modules.kc.grab.imports.service.IXxhbjsjbxxService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

 /**
 * @Description: xxhbjsjbxx
 * @Author: jeecg-boot
 * @Date:   2023-05-22
 * @Version: V1.0
 */
@Api(tags="xxhbjsjbxx")
@RestController
@RequestMapping("/xxhbjsjbxx/xxhbjsjbxx")
@Slf4j
public class XxhbjsjbxxController extends JeecgController<Xxhbjsjbxx, IXxhbjsjbxxService> {
	@Autowired
	private IXxhbjsjbxxService xxhbjsjbxxService;
	
	/**
	 * 分页列表查询
	 *
	 * @param xxhbjsjbxx
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "xxhbjsjbxx-分页列表查询")
	@ApiOperation(value="xxhbjsjbxx-分页列表查询", notes="xxhbjsjbxx-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<Xxhbjsjbxx>> queryPageList(Xxhbjsjbxx xxhbjsjbxx,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<Xxhbjsjbxx> queryWrapper = QueryGenerator.initQueryWrapper(xxhbjsjbxx, req.getParameterMap());
		Page<Xxhbjsjbxx> page = new Page<Xxhbjsjbxx>(pageNo, pageSize);
		IPage<Xxhbjsjbxx> pageList = xxhbjsjbxxService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param xxhbjsjbxx
	 * @return
	 */
	@AutoLog(value = "xxhbjsjbxx-添加")
	@ApiOperation(value="xxhbjsjbxx-添加", notes="xxhbjsjbxx-添加")
	@RequiresPermissions("xxhbjsjbxx:xxhbjsjbxx:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody Xxhbjsjbxx xxhbjsjbxx) {
		xxhbjsjbxxService.save(xxhbjsjbxx);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param xxhbjsjbxx
	 * @return
	 */
	@AutoLog(value = "xxhbjsjbxx-编辑")
	@ApiOperation(value="xxhbjsjbxx-编辑", notes="xxhbjsjbxx-编辑")
	@RequiresPermissions("xxhbjsjbxx:xxhbjsjbxx:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody Xxhbjsjbxx xxhbjsjbxx) {
		xxhbjsjbxxService.updateById(xxhbjsjbxx);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "xxhbjsjbxx-通过id删除")
	@ApiOperation(value="xxhbjsjbxx-通过id删除", notes="xxhbjsjbxx-通过id删除")
	@RequiresPermissions("xxhbjsjbxx:xxhbjsjbxx:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		xxhbjsjbxxService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "xxhbjsjbxx-批量删除")
	@ApiOperation(value="xxhbjsjbxx-批量删除", notes="xxhbjsjbxx-批量删除")
	@RequiresPermissions("xxhbjsjbxx:xxhbjsjbxx:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.xxhbjsjbxxService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "xxhbjsjbxx-通过id查询")
	@ApiOperation(value="xxhbjsjbxx-通过id查询", notes="xxhbjsjbxx-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<Xxhbjsjbxx> queryById(@RequestParam(name="id",required=true) String id) {
		Xxhbjsjbxx xxhbjsjbxx = xxhbjsjbxxService.getById(id);
		if(xxhbjsjbxx==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(xxhbjsjbxx);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param xxhbjsjbxx
    */
    @RequiresPermissions("xxhbjsjbxx:xxhbjsjbxx:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, Xxhbjsjbxx xxhbjsjbxx) {
        return super.exportXls(request, xxhbjsjbxx, Xxhbjsjbxx.class, "xxhbjsjbxx");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("xxhbjsjbxx:xxhbjsjbxx:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, Xxhbjsjbxx.class);
    }

}
