package org.jeecg.modules.kc.grab.imports.controller;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.kc.grab.imports.entity.Xxhbjxljbxx;
import org.jeecg.modules.kc.grab.imports.service.IXxhbjxljbxxService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

 /**
 * @Description: xxhbjxljbxx
 * @Author: jeecg-boot
 * @Date:   2023-05-22
 * @Version: V1.0
 */
@Api(tags="xxhbjxljbxx")
@RestController
@RequestMapping("/xxhbjxljbxx/xxhbjxljbxx")
@Slf4j
public class XxhbjxljbxxController extends JeecgController<Xxhbjxljbxx, IXxhbjxljbxxService> {
	@Autowired
	private IXxhbjxljbxxService xxhbjxljbxxService;
	
	/**
	 * 分页列表查询
	 *
	 * @param xxhbjxljbxx
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "xxhbjxljbxx-分页列表查询")
	@ApiOperation(value="xxhbjxljbxx-分页列表查询", notes="xxhbjxljbxx-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<Xxhbjxljbxx>> queryPageList(Xxhbjxljbxx xxhbjxljbxx,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<Xxhbjxljbxx> queryWrapper = QueryGenerator.initQueryWrapper(xxhbjxljbxx, req.getParameterMap());
		Page<Xxhbjxljbxx> page = new Page<Xxhbjxljbxx>(pageNo, pageSize);
		IPage<Xxhbjxljbxx> pageList = xxhbjxljbxxService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param xxhbjxljbxx
	 * @return
	 */
	@AutoLog(value = "xxhbjxljbxx-添加")
	@ApiOperation(value="xxhbjxljbxx-添加", notes="xxhbjxljbxx-添加")
	@RequiresPermissions("xxhbjxljbxx:xxhbjxljbxx:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody Xxhbjxljbxx xxhbjxljbxx) {
		xxhbjxljbxxService.save(xxhbjxljbxx);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param xxhbjxljbxx
	 * @return
	 */
	@AutoLog(value = "xxhbjxljbxx-编辑")
	@ApiOperation(value="xxhbjxljbxx-编辑", notes="xxhbjxljbxx-编辑")
	@RequiresPermissions("xxhbjxljbxx:xxhbjxljbxx:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody Xxhbjxljbxx xxhbjxljbxx) {
		xxhbjxljbxxService.updateById(xxhbjxljbxx);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "xxhbjxljbxx-通过id删除")
	@ApiOperation(value="xxhbjxljbxx-通过id删除", notes="xxhbjxljbxx-通过id删除")
	@RequiresPermissions("xxhbjxljbxx:xxhbjxljbxx:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		xxhbjxljbxxService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "xxhbjxljbxx-批量删除")
	@ApiOperation(value="xxhbjxljbxx-批量删除", notes="xxhbjxljbxx-批量删除")
	@RequiresPermissions("xxhbjxljbxx:xxhbjxljbxx:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.xxhbjxljbxxService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "xxhbjxljbxx-通过id查询")
	@ApiOperation(value="xxhbjxljbxx-通过id查询", notes="xxhbjxljbxx-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<Xxhbjxljbxx> queryById(@RequestParam(name="id",required=true) String id) {
		Xxhbjxljbxx xxhbjxljbxx = xxhbjxljbxxService.getById(id);
		if(xxhbjxljbxx==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(xxhbjxljbxx);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param xxhbjxljbxx
    */
    @RequiresPermissions("xxhbjxljbxx:xxhbjxljbxx:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, Xxhbjxljbxx xxhbjxljbxx) {
        return super.exportXls(request, xxhbjxljbxx, Xxhbjxljbxx.class, "xxhbjxljbxx");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("xxhbjxljbxx:xxhbjxljbxx:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, Xxhbjxljbxx.class);
    }

}
