package org.jeecg.modules.kc.grab.imports.controller;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.kc.grab.imports.entity.Xxhbsynclog;
import org.jeecg.modules.kc.grab.imports.service.IXxhbsynclogService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

 /**
 * @Description: 同步数据日志记录
 * @Author: jeecg-boot
 * @Date:   2023-04-11
 * @Version: V1.0
 */
@Api(tags="同步数据日志记录")
@RestController
@RequestMapping("/grab/imports/xxhbsynclog")
@Slf4j
public class XxhbsynclogController extends JeecgController<Xxhbsynclog, IXxhbsynclogService> {
	@Autowired
	private IXxhbsynclogService xxhbsynclogService;
	
	/**
	 * 分页列表查询
	 *
	 * @param xxhbsynclog
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "同步数据日志记录-分页列表查询")
	@ApiOperation(value="同步数据日志记录-分页列表查询", notes="同步数据日志记录-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<Xxhbsynclog>> queryPageList(Xxhbsynclog xxhbsynclog,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<Xxhbsynclog> queryWrapper = QueryGenerator.initQueryWrapper(xxhbsynclog, req.getParameterMap());
		Page<Xxhbsynclog> page = new Page<Xxhbsynclog>(pageNo, pageSize);
		IPage<Xxhbsynclog> pageList = xxhbsynclogService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param xxhbsynclog
	 * @return
	 */
	@AutoLog(value = "同步数据日志记录-添加")
	@ApiOperation(value="同步数据日志记录-添加", notes="同步数据日志记录-添加")
	@RequiresPermissions("grab.imports:xxhbsynclog:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody Xxhbsynclog xxhbsynclog) {
		xxhbsynclogService.save(xxhbsynclog);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param xxhbsynclog
	 * @return
	 */
	@AutoLog(value = "同步数据日志记录-编辑")
	@ApiOperation(value="同步数据日志记录-编辑", notes="同步数据日志记录-编辑")
	@RequiresPermissions("grab.imports:xxhbsynclog:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody Xxhbsynclog xxhbsynclog) {
		xxhbsynclogService.updateById(xxhbsynclog);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "同步数据日志记录-通过id删除")
	@ApiOperation(value="同步数据日志记录-通过id删除", notes="同步数据日志记录-通过id删除")
	@RequiresPermissions("grab.imports:xxhbsynclog:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		xxhbsynclogService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "同步数据日志记录-批量删除")
	@ApiOperation(value="同步数据日志记录-批量删除", notes="同步数据日志记录-批量删除")
	@RequiresPermissions("grab.imports:xxhbsynclog:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.xxhbsynclogService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "同步数据日志记录-通过id查询")
	@ApiOperation(value="同步数据日志记录-通过id查询", notes="同步数据日志记录-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<Xxhbsynclog> queryById(@RequestParam(name="id",required=true) String id) {
		Xxhbsynclog xxhbsynclog = xxhbsynclogService.getById(id);
		if(xxhbsynclog==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(xxhbsynclog);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param xxhbsynclog
    */
    @RequiresPermissions("grab.imports:xxhbsynclog:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, Xxhbsynclog xxhbsynclog) {
        return super.exportXls(request, xxhbsynclog, Xxhbsynclog.class, "同步数据日志记录");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("grab.imports:xxhbsynclog:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, Xxhbsynclog.class);
    }

}
