package org.jeecg.modules.kc.grab.imports.controller;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.lang3.StringUtils;
import org.apache.shiro.SecurityUtils;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.system.vo.LoginUser;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.kc.grab.imports.entity.Xxhbtkxx;
import org.jeecg.modules.kc.grab.imports.service.IXxhbtkxxService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

 /**
 * @Description: 同步数据表(tkxx)
 * @Author: jeecg-boot
 * @Date:   2023-04-11
 * @Version: V1.0
 */
@Api(tags="同步数据表(tkxx)")
@RestController
@RequestMapping("/grab/imports/xxhbtkxx")
@Slf4j
public class XxhbtkxxController extends JeecgController<Xxhbtkxx, IXxhbtkxxService> {
	@Autowired
	private IXxhbtkxxService xxhbtkxxService;

	 @Value("${jeecg.path.upload}")
	 private String upLoadPath;
	/**
	 * 分页列表查询
	 *
	 * @param xxhbtkxx
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "同步数据表(tkxx)-分页列表查询")
	@ApiOperation(value="同步数据表(tkxx)-分页列表查询", notes="同步数据表(tkxx)-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<Xxhbtkxx>> queryPageList(Xxhbtkxx xxhbtkxx,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<Xxhbtkxx> queryWrapper = QueryGenerator.initQueryWrapper("a",xxhbtkxx, req.getParameterMap());
		queryWrapper.eq(StringUtils.isNotBlank(xxhbtkxx.getXqxn()),"b.title",xxhbtkxx.getXqxn());
		Page<Xxhbtkxx> page = new Page<Xxhbtkxx>(pageNo, pageSize);
		IPage<Xxhbtkxx> pageList = xxhbtkxxService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param xxhbtkxx
	 * @return
	 */
	@AutoLog(value = "同步数据表(tkxx)-添加")
	@ApiOperation(value="同步数据表(tkxx)-添加", notes="同步数据表(tkxx)-添加")
	@RequiresPermissions("grab.imports:xxhbtkxx:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody Xxhbtkxx xxhbtkxx) {
		xxhbtkxxService.save(xxhbtkxx);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param xxhbtkxx
	 * @return
	 */
	@AutoLog(value = "同步数据表(tkxx)-编辑")
	@ApiOperation(value="同步数据表(tkxx)-编辑", notes="同步数据表(tkxx)-编辑")
	@RequiresPermissions("grab.imports:xxhbtkxx:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody Xxhbtkxx xxhbtkxx) {
		xxhbtkxxService.updateById(xxhbtkxx);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "同步数据表(tkxx)-通过id删除")
	@ApiOperation(value="同步数据表(tkxx)-通过id删除", notes="同步数据表(tkxx)-通过id删除")
	@RequiresPermissions("grab.imports:xxhbtkxx:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		xxhbtkxxService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "同步数据表(tkxx)-批量删除")
	@ApiOperation(value="同步数据表(tkxx)-批量删除", notes="同步数据表(tkxx)-批量删除")
	@RequiresPermissions("grab.imports:xxhbtkxx:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.xxhbtkxxService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "同步数据表(tkxx)-通过id查询")
	@ApiOperation(value="同步数据表(tkxx)-通过id查询", notes="同步数据表(tkxx)-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<Xxhbtkxx> queryById(@RequestParam(name="id",required=true) String id) {
		Xxhbtkxx xxhbtkxx = xxhbtkxxService.getById(id);
		if(xxhbtkxx==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(xxhbtkxx);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param xxhbtkxx
    */
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, Xxhbtkxx xxhbtkxx) {
        return exportXls(request, xxhbtkxx, Xxhbtkxx.class, "停课信息");
    }

	 protected ModelAndView exportXls(HttpServletRequest request, Xxhbtkxx object, Class<Xxhbtkxx> clazz, String title) {
		 // Step.1 组装查询条件
		 QueryWrapper<Xxhbtkxx> queryWrapper = QueryGenerator.initQueryWrapper(object, request.getParameterMap());
		 LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();

		 // 过滤选中数据
		 String selections = request.getParameter("selections");
		 if (oConvertUtils.isNotEmpty(selections)) {
			 List<String> selectionList = Arrays.asList(selections.split(","));
			 queryWrapper.in("id",selectionList);
		 }
		 queryWrapper.eq(StringUtils.isNotBlank(object.getXqxn()),"b.title",object.getXqxn());
		 // Step.2 获取导出数据
		 List<Xxhbtkxx> exportList = service.list(queryWrapper);

		 // Step.3 AutoPoi 导出Excel
		 ModelAndView mv = new ModelAndView(new JeecgEntityExcelView());
		 //此处设置的filename无效 ,前端会重更新设置一下
		 mv.addObject(NormalExcelConstants.FILE_NAME, title);
		 mv.addObject(NormalExcelConstants.CLASS, clazz);
		 //update-begin--Author:liusq  Date:20210126 for：图片导出报错，ImageBasePath未设置--------------------
		 ExportParams  exportParams=new ExportParams(title + "报表", "导出人:" + sysUser.getRealname(), title);
		 exportParams.setImageBasePath(upLoadPath);
		 //update-end--Author:liusq  Date:20210126 for：图片导出报错，ImageBasePath未设置----------------------
		 mv.addObject(NormalExcelConstants.PARAMS,exportParams);
		 mv.addObject(NormalExcelConstants.DATA_LIST, exportList);
		 return mv;
	 }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("grab.imports:xxhbtkxx:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, Xxhbtkxx.class);
    }


	 @ApiOperation(value="获取今日停课信息", notes="获取今日停课信息")
	 @GetMapping(value = "/getDayTklist")
	 public Result<List<Xxhbtkxx>> getDayTklist(HttpServletRequest req) {
		 List<Xxhbtkxx> pageList = xxhbtkxxService.getDayTklist();
		 return Result.OK(pageList);
	 }

}
