package org.jeecg.modules.kc.grab.imports.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.jeecgframework.poi.excel.annotation.Excel;
import org.springframework.format.annotation.DateTimeFormat;

import java.io.Serializable;

/**
 * @Description: 同步数据表（bks）
 * @Author: jeecg-boot
 * @Date:   2023-04-10
 * @Version: V1.0
 */
@Data
@TableName("xxhbbks")
@Accessors(chain = true)
@EqualsAndHashCode(callSuper = false)
@ApiModel(value="xxhbbks对象", description="同步数据表（bks）")
public class Xxhbbks implements Serializable {
    private static final long serialVersionUID = 1L;

	/**id*/
	@TableId(type = IdType.ASSIGN_ID)
    @ApiModelProperty(value = "id")
    private java.lang.String id;
	/**学号*/
	@Excel(name = "学号", width = 15)
    @ApiModelProperty(value = "学号")
    private java.lang.String xh;
	/**姓名*/
	@Excel(name = "姓名", width = 15)
    @ApiModelProperty(value = "姓名")
    private java.lang.String xm;
	/**xbm*/
	@Excel(name = "xbm", width = 15)
    @ApiModelProperty(value = "xbm")
    private java.lang.String xbm;
	/**yxh*/
	@Excel(name = "yxh", width = 15)
    @ApiModelProperty(value = "yxh")
    private java.lang.String yxh;
	/**单位名称*/
	@Excel(name = "单位名称", width = 15)
    @ApiModelProperty(value = "单位名称")
    private java.lang.String dwmc;
	/**专业号*/
	@Excel(name = "专业号", width = 15)
    @ApiModelProperty(value = "专业号")
    private java.lang.String zyh;
	/**专业名称*/
	@Excel(name = "专业名称", width = 15)
    @ApiModelProperty(value = "专业名称")
    private java.lang.String zymc;
	/**学期名称*/
	@Excel(name = "学期名称", width = 15)
    @ApiModelProperty(value = "学期名称")
    private java.lang.String xqm;
	/**年级*/
	@Excel(name = "年级", width = 15)
    @ApiModelProperty(value = "年级")
    private java.lang.String nj;
	/**xjztdm*/
	@Excel(name = "xjztdm", width = 15)
    @ApiModelProperty(value = "xjztdm")
    private java.lang.String xjztdm;
	/**时间戳*/
//    @Excel(name = "时间戳", width = 15)
//    @ApiModelProperty(value = "时间戳")
//    private java.lang.String timestamps;

    @Excel(name = "timestamps", width = 15, format = "yyyy-MM-dd")
    @JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd")
    @DateTimeFormat(pattern="yyyy-MM-dd")
    @ApiModelProperty(value = "timestamps")
    private java.util.Date timestamps;

    @TableField(exist = false)
    private Integer mysqlnum;

    @TableField(exist = false)
    private String rwbh;

}
