package org.jeecg.modules.kc.grab.imports.entity;

import java.io.Serializable;
import java.io.UnsupportedEncodingException;
import java.util.Date;
import java.math.BigDecimal;

import com.baomidou.mybatisplus.annotation.*;
import lombok.Data;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;
import org.jeecgframework.poi.excel.annotation.Excel;
import org.jeecg.common.aspect.annotation.Dict;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * @Description: 同步数据表(kcapzb)
 * @Author: jeecg-boot
 * @Date:   2023-04-11
 * @Version: V1.0
 */
@Data
@TableName("xxhbkcapzb")
@Accessors(chain = true)
@EqualsAndHashCode(callSuper = false)
@ApiModel(value="xxhbkcapzb对象", description="同步数据表(kcapzb)")
public class Xxhbkcapzb implements Serializable {
    private static final long serialVersionUID = 1L;

	/**id*/
	@TableId(type = IdType.ASSIGN_ID)
    @ApiModelProperty(value = "id")
    private java.lang.String id;
	/**课程编号*/
	@Excel(name = "课程编号", width = 15)
    @ApiModelProperty(value = "课程编号")
    private java.lang.String kcbh;
	/**开设单位号*/
	@Excel(name = "开设单位号", width = 15)
    @ApiModelProperty(value = "开设单位号")
    private java.lang.String ksdw;
	/**课堂名称*/
	@Excel(name = "课堂名称", width = 15)
    @ApiModelProperty(value = "课堂名称")
    private java.lang.String ktmc;
	/**工号*/
	@Excel(name = "工号", width = 15)
    @ApiModelProperty(value = "工号")
    private java.lang.String gh;
	/**课程属性代码*/
	@Excel(name = "课程属性代码", width = 15)
    @ApiModelProperty(value = "课程属性代码")
    private java.lang.String kcsxdm;
	/**课程性质代码*/
	@Excel(name = "课程性质代码", width = 15)
    @ApiModelProperty(value = "课程性质代码")
    private java.lang.String kcxzdm;
	/**考试方式代码*/
	@Excel(name = "考试方式代码", width = 15)
    @ApiModelProperty(value = "考试方式代码")
    private java.lang.String ksfsdm;
	/**考试类别代码*/
	@Excel(name = "考试类别代码", width = 15)
    @ApiModelProperty(value = "考试类别代码")
    private java.lang.String kslbdm;
	/**排课标志*/
	@Excel(name = "排课标志", width = 15)
    @ApiModelProperty(value = "排课标志")
    private java.lang.String pkbz;
	/**选课人数*/
	@Excel(name = "选课人数", width = 15)
    @ApiModelProperty(value = "选课人数")
    private java.lang.String xkrs;
	/**排课人数*/
	@Excel(name = "排课人数", width = 15)
    @ApiModelProperty(value = "排课人数")
    private java.lang.String pkrs;
	/**授课地点*/
	@Excel(name = "授课地点", width = 15)
    @ApiModelProperty(value = "授课地点")
    private java.lang.String skdd;
	/**授课方式代码*/
	@Excel(name = "授课方式代码", width = 15)
    @ApiModelProperty(value = "授课方式代码")
    private java.lang.String skfsdm;
	/**授课时间*/
	@Excel(name = "授课时间", width = 15)
    @ApiModelProperty(value = "授课时间")
    private java.lang.String sksj;
	/**素质课程类型代码*/
	@Excel(name = "素质课程类型代码", width = 15)
    @ApiModelProperty(value = "素质课程类型代码")
    private java.lang.String szkcfldm;
	/**通知单类别代码*/
	@Excel(name = "通知单类别代码", width = 15)
    @ApiModelProperty(value = "通知单类别代码")
    private java.lang.String tzdlbdm;
	/**学分*/
	@Excel(name = "学分", width = 15)
    @ApiModelProperty(value = "学分")
    private java.lang.String xf;
	/**成绩录入标志*/
	@Excel(name = "成绩录入标志", width = 15)
    @ApiModelProperty(value = "成绩录入标志")
    private java.lang.String cjlrbz;
	/**总学时*/
	@Excel(name = "总学时", width = 15)
    @ApiModelProperty(value = "总学时")
    private java.lang.String zxs;
	/**排课类别*/
	@Excel(name = "排课类别", width = 15)
    @ApiModelProperty(value = "排课类别")
    private java.lang.String pklb;
	/**学年学期编号*/
	@Excel(name = "学年学期编号", width = 15)
    @ApiModelProperty(value = "学年学期编号")
    private java.lang.String xnxqbh;
	/**选课性质代码*/
	@Excel(name = "选课性质代码", width = 15)
    @ApiModelProperty(value = "选课性质代码")
    private java.lang.String xkxzdm;
	/**开课周次*/
	@Excel(name = "开课周次", width = 15)
    @ApiModelProperty(value = "开课周次")
    private java.lang.String kkzc;
	/**课序号*/
	@Excel(name = "课序号", width = 15)
    @ApiModelProperty(value = "课序号")
    private java.lang.String kxh;
	/**是否完成排课*/
	@Excel(name = "是否完成排课", width = 15)
    @ApiModelProperty(value = "是否完成排课")
    private java.lang.String sfwcpk;
	/**校区编号*/
	@Excel(name = "校区编号", width = 15)
    @ApiModelProperty(value = "校区编号")
    private java.lang.String xqbh;
	/**选课标志*/
	@Excel(name = "选课标志", width = 15)
    @ApiModelProperty(value = "选课标志")
    private java.lang.String xkbz;

    @TableField(exist = false)
    private Integer mysqlnum;
}
