package org.jeecg.modules.kc.grab.imports.entity;

import java.io.Serializable;
import java.io.UnsupportedEncodingException;
import java.util.Date;
import java.math.BigDecimal;

import com.baomidou.mybatisplus.annotation.*;
import lombok.Data;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;
import org.jeecgframework.poi.excel.annotation.Excel;
import org.jeecg.common.aspect.annotation.Dict;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * @Description: 同步数据表(tkxx)
 * @Author: jeecg-boot
 * @Date:   2023-04-11
 * @Version: V1.0
 */
@Data
@TableName("xxhbtkxx")
@Accessors(chain = true)
@EqualsAndHashCode(callSuper = false)
@ApiModel(value="xxhbtkxx对象", description="同步数据表(tkxx)")
public class Xxhbtkxx implements Serializable {
    private static final long serialVersionUID = 1L;

	/**id*/
	@TableId(type = IdType.ASSIGN_ID)
    @ApiModelProperty(value = "id")
    private java.lang.String id;

    @TableField(exist = false)
    private String xqxn;
	/**姓名*/
	@Excel(name = "姓名", width = 15)
    @ApiModelProperty(value = "姓名")
    private java.lang.String xm;
	/**cjr*/
	@Excel(name = "工号", width = 15)
    @ApiModelProperty(value = "cjr")
    private java.lang.String cjr;
	/**sjh*/
    @ApiModelProperty(value = "sjh")
    private java.lang.String sjh;
	/**tksy*/
	@Excel(name = "调课事由", width = 15)
    @ApiModelProperty(value = "tksy")
    private java.lang.String tksy;
	/**xyjwmsshyj*/
    @ApiModelProperty(value = "xyjwmsshyj")
    private java.lang.String xyjwmsshyj;
	/**yjxq*/
    @ApiModelProperty(value = "yjxq")
    private java.lang.String yjxq;
	/**sqrdw*/
    @ApiModelProperty(value = "sqrdw")
    private java.lang.String sqrdw;
	/**bizbh*/
    @ApiModelProperty(value = "bizbh")
    private java.lang.String bizbh;
	/**jwcsh*/
    @ApiModelProperty(value = "jwcsh")
    private java.lang.String jwcsh;
	/**szxyldshyj*/
    @ApiModelProperty(value = "szxyldshyj")
    private java.lang.String szxyldshyj;
	/**shxq*/
    @ApiModelProperty(value = "shxq")
    private java.lang.String shxq;
	/**lcjgbh*/
    @ApiModelProperty(value = "lcjgbh")
    private java.lang.String lcjgbh;
	/**bkjh*/
	@Excel(name = "补课计划", width = 15)
    @ApiModelProperty(value = "bkjh")
    private java.lang.String bkjh;
	/**时间戳*/
    private java.lang.String timestamps;
	/**课程名称*/
	@Excel(name = "课程名称", width = 15)
    @ApiModelProperty(value = "课程名称")
    private java.lang.String kcmc;
	/**pbh*/
    @ApiModelProperty(value = "pbh")
    private java.lang.String pbh;
	/**节次*/
	@Excel(name = "节次", width = 15)
    @ApiModelProperty(value = "节次")
    private java.lang.String jc;
	/**上课日期*/
	@Excel(name = "上课日期", width = 15)
    @ApiModelProperty(value = "上课日期")
    private java.lang.String skrq;
	/**kcxxbh*/
    @ApiModelProperty(value = "kcxxbh")
    private java.lang.String kcxxbh;
	/**学期*/
    @ApiModelProperty(value = "校区")
    private java.lang.String xq;
	/**jsgh*/
    @ApiModelProperty(value = "jsgh")
    private java.lang.String jsgh;
	/**编号*/
	@Excel(name = "编号", width = 15)
    @ApiModelProperty(value = "编号")
    private java.lang.String bh;
	/**授课教师*/
	@Excel(name = "授课教室", width = 15)
    @ApiModelProperty(value = "授课教室")
    private java.lang.String skjs;
	/**lcbh*/
    @ApiModelProperty(value = "lcbh")
    private java.lang.String lcbh;
	/**1-调整时间，2-调整地点，3-更换教师，4-其他*/
    @Excel(name = "调课类型", width = 15,dicCode = "tiaokeleixing")
    @ApiModelProperty(value = "1-调整时间，2-调整地点，3-更换教师，4-其他")
    @Dict(dicCode = "tiaokeleixing")
    private java.lang.String tklx;
    @TableField(exist = false)
    private Integer mysqlnum;

}
