package org.jeecg.modules.kc.grab.imports.service.impl;

import com.baomidou.mybatisplus.annotation.InterceptorIgnore;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import org.jeecg.modules.kc.grab.imports.entity.Xxhbtkxx;
import org.jeecg.modules.kc.grab.imports.entity.Xxhbxsxkb;
import org.jeecg.modules.kc.grab.imports.mapper.XxhbtkxxMapper;
import org.jeecg.modules.kc.grab.imports.service.IXxhbtkxxService;
import org.springframework.stereotype.Service;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.transaction.annotation.Transactional;

import java.util.Collection;
import java.util.List;

/**
 * @Description: 同步数据表(tkxx)
 * @Author: jeecg-boot
 * @Date:   2023-04-11
 * @Version: V1.0
 */
@Service
public class XxhbtkxxServiceImpl extends ServiceImpl<XxhbtkxxMapper, Xxhbtkxx> implements IXxhbtkxxService {

    @Override
    @Transactional(rollbackFor = {Exception.class})
    public boolean syncList(Collection<Xxhbtkxx> entityList) {
        return syncList(entityList, true);
    }

    @Override
    @Transactional(rollbackFor = {Exception.class})
    @InterceptorIgnore(tenantLine = "true")
    public boolean syncList(Collection<Xxhbtkxx> entityList, boolean isDelete) {
        QueryWrapper dqw = new QueryWrapper();
        if(isDelete){
            baseMapper.delete(dqw);
        }
//      SQL1：UPDATE xxhbtkxx set jc = replace( convert(jc using ascii),'?', '')【第5-6节 -> 5-6】
        UpdateWrapper<Xxhbtkxx> upw1 = new UpdateWrapper<>();
        //upw1.setSql("jc = replace( convert(jc using ascii),'?', '')");
        upw1.set("jc","replace( convert(jc using ascii),'?', '')");
        update(upw1);
//      SQL2：UPDATE xxhbtkxx set jc = replace( jc,'-', '、')【5-6 -> 5、6】
        UpdateWrapper<Xxhbtkxx> upw2 = new UpdateWrapper<>();
        //upw2.setSql("jc = replace( jc,'-', '、')");
        upw2.set("jc","replace( jc,'-', '、')");
        update(upw2);
        //将【5、6 -> 05、06】
        UpdateWrapper<Xxhbtkxx> upw3 = new UpdateWrapper<>();
        upw3.set("jc",
        "CONCAT("+
            "CASE"+
                "WHEN POSITION( '、' IN jc ) = 2 THEN concat( '0', substr( jc, 1, 1 ), '、' )"+
                "WHEN POSITION( '、' IN jc ) = 3 THEN concat( '0', substr( jc, 1, 2 ), '、' )"+
            "END,"+
            "CASE"+
                "WHEN LENGTH( jc ) - POSITION( '、' IN jc ) = 3 THEN CONCAT('0',substr( jc, POSITION( '、' IN jc )+ 1 ))"+
                "WHEN LENGTH( jc ) - POSITION( '、' IN jc ) = 4 THEN CONCAT(substr( jc, POSITION( '、' IN jc )+ 1 ))"+
            "END"+
        ")");
        update(upw3);

        //3、将停课信息(xxhbtkxx)更新至课堂表(ketangbiao)
        updateToKeTang(new QueryWrapper<>());

        return this.saveBatch(entityList, 1000);
    }

    @Override
    @Transactional(rollbackFor = {Exception.class})
    public boolean updateToKeTang(Wrapper<Xxhbtkxx> queryWrapper) {
        return baseMapper.updateToKeTang(queryWrapper);
    }

    @Override
    public Xxhbtkxx getSumnum() {
        return baseMapper.getSumnum();
    }

    @Override
    public List<Xxhbtkxx> getDayTklist() {
        return baseMapper.getDayTklist();
    }
}
