package org.jeecg.modules.kc.grab.log.controller;

import java.util.Arrays;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.lang3.StringUtils;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.modules.kc.grab.log.entity.XxhbbkjxtkpjBadLog;
import org.jeecg.modules.kc.grab.log.service.IXxhbbkjxtkpjBadLogService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

 /**
 * @Description: 服务大厅同步失败记录
 * @Author: jeecg-boot
 * @Date:   2023-07-26
 * @Version: V1.0
 */
@Api(tags="服务大厅同步失败记录")
@RestController
@RequestMapping("/grab/xxhbbkjxtkpjBadLog")
@Slf4j
public class XxhbbkjxtkpjBadLogController extends JeecgController<XxhbbkjxtkpjBadLog, IXxhbbkjxtkpjBadLogService> {
	@Autowired
	private IXxhbbkjxtkpjBadLogService xxhbbkjxtkpjBadLogService;
	
	/**
	 * 分页列表查询
	 *
	 * @param xxhbbkjxtkpjBadLog
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "服务大厅同步失败记录-分页列表查询")
	@ApiOperation(value="服务大厅同步失败记录-分页列表查询", notes="服务大厅同步失败记录-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<XxhbbkjxtkpjBadLog>> queryPageList(XxhbbkjxtkpjBadLog xxhbbkjxtkpjBadLog,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<XxhbbkjxtkpjBadLog> queryWrapper = QueryGenerator.initQueryWrapper("a",xxhbbkjxtkpjBadLog, req.getParameterMap());
		queryWrapper.eq(StringUtils.isNotBlank(xxhbbkjxtkpjBadLog.getXqxn()),"b.title",xxhbbkjxtkpjBadLog.getXqxn());
		Page<XxhbbkjxtkpjBadLog> page = new Page<XxhbbkjxtkpjBadLog>(pageNo, pageSize);
		IPage<XxhbbkjxtkpjBadLog> pageList = xxhbbkjxtkpjBadLogService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param xxhbbkjxtkpjBadLog
	 * @return
	 */
	@AutoLog(value = "服务大厅同步失败记录-添加")
	@ApiOperation(value="服务大厅同步失败记录-添加", notes="服务大厅同步失败记录-添加")
	@RequiresPermissions("grab:xxhbbkjxtkpj_bad_log:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody XxhbbkjxtkpjBadLog xxhbbkjxtkpjBadLog) {
		xxhbbkjxtkpjBadLogService.save(xxhbbkjxtkpjBadLog);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param xxhbbkjxtkpjBadLog
	 * @return
	 */
	@AutoLog(value = "服务大厅同步失败记录-编辑")
	@ApiOperation(value="服务大厅同步失败记录-编辑", notes="服务大厅同步失败记录-编辑")
	@RequiresPermissions("grab:xxhbbkjxtkpj_bad_log:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody XxhbbkjxtkpjBadLog xxhbbkjxtkpjBadLog) {
		xxhbbkjxtkpjBadLogService.updateById(xxhbbkjxtkpjBadLog);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "服务大厅同步失败记录-通过id删除")
	@ApiOperation(value="服务大厅同步失败记录-通过id删除", notes="服务大厅同步失败记录-通过id删除")
	@RequiresPermissions("grab:xxhbbkjxtkpj_bad_log:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		xxhbbkjxtkpjBadLogService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "服务大厅同步失败记录-批量删除")
	@ApiOperation(value="服务大厅同步失败记录-批量删除", notes="服务大厅同步失败记录-批量删除")
	@RequiresPermissions("grab:xxhbbkjxtkpj_bad_log:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.xxhbbkjxtkpjBadLogService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "服务大厅同步失败记录-通过id查询")
	@ApiOperation(value="服务大厅同步失败记录-通过id查询", notes="服务大厅同步失败记录-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<XxhbbkjxtkpjBadLog> queryById(@RequestParam(name="id",required=true) String id) {
		XxhbbkjxtkpjBadLog xxhbbkjxtkpjBadLog = xxhbbkjxtkpjBadLogService.getById(id);
		if(xxhbbkjxtkpjBadLog==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(xxhbbkjxtkpjBadLog);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param xxhbbkjxtkpjBadLog
    */
    @RequiresPermissions("grab:xxhbbkjxtkpj_bad_log:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, XxhbbkjxtkpjBadLog xxhbbkjxtkpjBadLog) {
        return super.exportXls(request, xxhbbkjxtkpjBadLog, XxhbbkjxtkpjBadLog.class, "服务大厅同步失败记录");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("grab:xxhbbkjxtkpj_bad_log:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, XxhbbkjxtkpjBadLog.class);
    }

}
