package org.jeecg.modules.kc.grab.log.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.jeecg.common.system.base.controller.JeecgController;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.modules.kc.grab.log.entity.XxhbbkjxtkpjGoodLog;
import org.jeecg.modules.kc.grab.log.service.IXxhbbkjxtkpjGoodLogService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.Arrays;

 /**
 * @Description: 服务大厅同步成功记录
 * @Author: jeecg-boot
 * @Date:   2023-08-13
 * @Version: V1.0
 */
@Api(tags="服务大厅同步成功记录")
@RestController
@RequestMapping("/grab/xxhbbkjxtkpjGoodLog")
@Slf4j
public class XxhbbkjxtkpjGoodLogController extends JeecgController<XxhbbkjxtkpjGoodLog, IXxhbbkjxtkpjGoodLogService> {
	@Autowired
	private IXxhbbkjxtkpjGoodLogService xxhbbkjxtkpjGoodLogService;
	
	/**
	 * 分页列表查询
	 *
	 * @param xxhbbkjxtkpjGoodLog
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "服务大厅同步成功记录-分页列表查询")
	@ApiOperation(value="服务大厅同步成功记录-分页列表查询", notes="服务大厅同步成功记录-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<XxhbbkjxtkpjGoodLog>> queryPageList(XxhbbkjxtkpjGoodLog xxhbbkjxtkpjGoodLog,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<XxhbbkjxtkpjGoodLog> queryWrapper = QueryGenerator.initQueryWrapper("a",xxhbbkjxtkpjGoodLog, req.getParameterMap());
		queryWrapper.eq(StringUtils.isNotBlank(xxhbbkjxtkpjGoodLog.getXqxn()),"b.title",xxhbbkjxtkpjGoodLog.getXqxn());
		Page<XxhbbkjxtkpjGoodLog> page = new Page<XxhbbkjxtkpjGoodLog>(pageNo, pageSize);
		IPage<XxhbbkjxtkpjGoodLog> pageList = xxhbbkjxtkpjGoodLogService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param xxhbbkjxtkpjGoodLog
	 * @return
	 */
	@AutoLog(value = "服务大厅同步成功记录-添加")
	@ApiOperation(value="服务大厅同步成功记录-添加", notes="服务大厅同步成功记录-添加")
	@RequiresPermissions("grab:xxhbbkjxtkpj_good_log:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody XxhbbkjxtkpjGoodLog xxhbbkjxtkpjGoodLog) {
		xxhbbkjxtkpjGoodLogService.save(xxhbbkjxtkpjGoodLog);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param xxhbbkjxtkpjGoodLog
	 * @return
	 */
	@AutoLog(value = "服务大厅同步成功记录-编辑")
	@ApiOperation(value="服务大厅同步成功记录-编辑", notes="服务大厅同步成功记录-编辑")
	@RequiresPermissions("grab:xxhbbkjxtkpj_good_log:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody XxhbbkjxtkpjGoodLog xxhbbkjxtkpjGoodLog) {
		xxhbbkjxtkpjGoodLogService.updateById(xxhbbkjxtkpjGoodLog);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "服务大厅同步成功记录-通过id删除")
	@ApiOperation(value="服务大厅同步成功记录-通过id删除", notes="服务大厅同步成功记录-通过id删除")
	@RequiresPermissions("grab:xxhbbkjxtkpj_good_log:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		xxhbbkjxtkpjGoodLogService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "服务大厅同步成功记录-批量删除")
	@ApiOperation(value="服务大厅同步成功记录-批量删除", notes="服务大厅同步成功记录-批量删除")
	@RequiresPermissions("grab:xxhbbkjxtkpj_good_log:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.xxhbbkjxtkpjGoodLogService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "服务大厅同步成功记录-通过id查询")
	@ApiOperation(value="服务大厅同步成功记录-通过id查询", notes="服务大厅同步成功记录-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<XxhbbkjxtkpjGoodLog> queryById(@RequestParam(name="id",required=true) String id) {
		XxhbbkjxtkpjGoodLog xxhbbkjxtkpjGoodLog = xxhbbkjxtkpjGoodLogService.getById(id);
		if(xxhbbkjxtkpjGoodLog==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(xxhbbkjxtkpjGoodLog);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param xxhbbkjxtkpjGoodLog
    */
    @RequiresPermissions("grab:xxhbbkjxtkpj_good_log:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, XxhbbkjxtkpjGoodLog xxhbbkjxtkpjGoodLog) {
        return super.exportXls(request, xxhbbkjxtkpjGoodLog, XxhbbkjxtkpjGoodLog.class, "服务大厅同步成功记录");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("grab:xxhbbkjxtkpj_good_log:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, XxhbbkjxtkpjGoodLog.class);
    }

}
