package org.jeecg.modules.kc.grab.log.entity;

import java.io.Serializable;
import java.io.UnsupportedEncodingException;
import java.util.Date;
import java.math.BigDecimal;

import com.baomidou.mybatisplus.annotation.*;
import lombok.Data;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;
import org.jeecgframework.poi.excel.annotation.Excel;
import org.jeecg.common.aspect.annotation.Dict;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * @Description: 服务大厅同步失败记录
 * @Author: jeecg-boot
 * @Date:   2023-07-26
 * @Version: V1.0
 */
@Data
@TableName("xxhbbkjxtkpj_bad_log")
@Accessors(chain = true)
@EqualsAndHashCode(callSuper = false)
@ApiModel(value="xxhbbkjxtkpj_bad_log对象", description="服务大厅同步失败记录")
public class XxhbbkjxtkpjBadLog implements Serializable {
    private static final long serialVersionUID = 1L;

	/**id*/
	@TableId(type = IdType.ASSIGN_ID)
    @ApiModelProperty(value = "id")
    private java.lang.String id;
	/**创建人*/
    @ApiModelProperty(value = "创建人")
    private java.lang.String createBy;
	/**创建日期*/
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd")
    @DateTimeFormat(pattern="yyyy-MM-dd")
    @ApiModelProperty(value = "创建日期")
    private java.util.Date createTime;
	/**更新人*/
    @ApiModelProperty(value = "更新人")
    private java.lang.String updateBy;
	/**更新日期*/
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd")
    @DateTimeFormat(pattern="yyyy-MM-dd")
    @ApiModelProperty(value = "更新日期")
    private java.util.Date updateTime;
	/**所属部门*/
    @ApiModelProperty(value = "所属部门")
    private java.lang.String sysOrgCode;
	/**编号*/
	@Excel(name = "编号", width = 15)
    @ApiModelProperty(value = "编号")
    private java.lang.String bh;
	/**轮次编号*/
	@Excel(name = "轮次编号", width = 15)
    @ApiModelProperty(value = "轮次编号")
    private java.lang.String lcbh;
	/**轮次出镜人*/
	@Excel(name = "轮次出镜人", width = 15)
    @ApiModelProperty(value = "轮次出镜人")
    private java.lang.String lccjr;
	/**听课人工号*/
	@Excel(name = "听课人工号", width = 15)
    @ApiModelProperty(value = "听课人工号")
    private java.lang.String tkrgh;
	/**听课人姓名*/
	@Excel(name = "听课人姓名", width = 15)
    @ApiModelProperty(value = "听课人姓名")
    private java.lang.String tkrxm;
	/**听课人单位名称*/
	@Excel(name = "听课人单位名称", width = 15)
    @ApiModelProperty(value = "听课人单位名称")
    private java.lang.String tkrdwmc;
	/**听课时间学期*/
	@Excel(name = "听课时间学期", width = 15)
    @ApiModelProperty(value = "听课时间学期")
    private java.lang.String tksjxq;
	/**课程节次*/
	@Excel(name = "课程节次", width = 15)
    @ApiModelProperty(value = "课程节次")
    private java.lang.String kcjc;
    /**课程节次*/
    @Excel(name = "课程节次(转换后)", width = 15)
    @ApiModelProperty(value = "课程节次(转换后)")
    private java.lang.String hh;
	/**课程单位*/
	@Excel(name = "课程单位", width = 15)
    @ApiModelProperty(value = "课程单位")
    private java.lang.String kcdm;
	/**听课教师*/
	@Excel(name = "听课教师", width = 15)
    @ApiModelProperty(value = "听课教师")
    private java.lang.String tkjs;
	/**听课课程名称*/
	@Excel(name = "听课课程名称", width = 15)
    @ApiModelProperty(value = "听课课程名称")
    private java.lang.String tkkcmc;
	/**任课教师*/
	@Excel(name = "任课教师", width = 15)
    @ApiModelProperty(value = "任课教师")
    private java.lang.String rkjs;
	/**总体评价*/
	@Excel(name = "总体评价", width = 15)
    @ApiModelProperty(value = "总体评价")
    private java.lang.String ztpj;
	/**教师工号*/
	@Excel(name = "教师工号", width = 15)
    @ApiModelProperty(value = "教师工号")
    private java.lang.String jsgh;
	/**全体意见*/
	@Excel(name = "全体意见", width = 15)
    @ApiModelProperty(value = "全体意见")
    private java.lang.String qtyj;
	/**教师评估1*/
	@Excel(name = "教师评估1", width = 15)
    @ApiModelProperty(value = "教师评估1")
    private java.lang.String jspg1;
	/**教师评估2*/
	@Excel(name = "教师评估2", width = 15)
    @ApiModelProperty(value = "教师评估2")
    private java.lang.String jspg2;
	/**教师评估3*/
	@Excel(name = "教师评估3", width = 15)
    @ApiModelProperty(value = "教师评估3")
    private java.lang.String jspg3;
	/**教师评估4*/
	@Excel(name = "教师评估4", width = 15)
    @ApiModelProperty(value = "教师评估4")
    private java.lang.String jspg4;
	/**教师评估5*/
	@Excel(name = "教师评估5", width = 15)
    @ApiModelProperty(value = "教师评估5")
    private java.lang.String jspg5;
	/**学生评估1*/
	@Excel(name = "学生评估1", width = 15)
    @ApiModelProperty(value = "学生评估1")
    private java.lang.String xspg1;
	/**学生评估2*/
	@Excel(name = "学生评估2", width = 15)
    @ApiModelProperty(value = "学生评估2")
    private java.lang.String xspg2;
	/**学生评估3*/
	@Excel(name = "学生评估3", width = 15)
    @ApiModelProperty(value = "学生评估3")
    private java.lang.String xspg3;
	/**课程编号*/
	@Excel(name = "课程编号", width = 15)
    @ApiModelProperty(value = "课程编号")
    private java.lang.String kcbh;
	/**时间戳*/
	@Excel(name = "时间戳", width = 15, format = "yyyy-MM-dd")
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd")
    @DateTimeFormat(pattern="yyyy-MM-dd")
    @ApiModelProperty(value = "时间戳")
    private java.util.Date timestamps;
	/**课表编号*/
	@Excel(name = "课表编号", width = 15)
    @ApiModelProperty(value = "课表编号")
    private java.lang.String kbbh;

    @TableField(exist = false)
    private String skrq;

    @TableField(exist = false)
    private String xqxn;

}
