package org.jeecg.modules.kc.jiaoshi.controller;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.kc.jiaoshi.entity.KcJiaoshixinxibiao;
import org.jeecg.modules.kc.jiaoshi.service.IKcJiaoshixinxibiaoService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

 /**
 * @Description: 教室信息表
 * @Author: jeecg-boot
 * @Date:   2023-04-19
 * @Version: V1.0
 */
@Api(tags="教室信息表")
@RestController
@RequestMapping("/jiaoshi/kcJiaoshixinxibiao")
@Slf4j
public class KcJiaoshixinxibiaoController extends JeecgController<KcJiaoshixinxibiao, IKcJiaoshixinxibiaoService> {
	@Autowired
	private IKcJiaoshixinxibiaoService kcJiaoshixinxibiaoService;
	
	/**
	 * 分页列表查询
	 *
	 * @param kcJiaoshixinxibiao
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "教室信息表-分页列表查询")
	@ApiOperation(value="教室信息表-分页列表查询", notes="教室信息表-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<KcJiaoshixinxibiao>> queryPageList(KcJiaoshixinxibiao kcJiaoshixinxibiao,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<KcJiaoshixinxibiao> queryWrapper = QueryGenerator.initQueryWrapper(kcJiaoshixinxibiao, req.getParameterMap());
		Page<KcJiaoshixinxibiao> page = new Page<KcJiaoshixinxibiao>(pageNo, pageSize);
		IPage<KcJiaoshixinxibiao> pageList = kcJiaoshixinxibiaoService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param kcJiaoshixinxibiao
	 * @return
	 */
	@AutoLog(value = "教室信息表-添加")
	@ApiOperation(value="教室信息表-添加", notes="教室信息表-添加")
	@RequiresPermissions("jiaoshi:kc_jiaoshixinxibiao:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody KcJiaoshixinxibiao kcJiaoshixinxibiao) {
		kcJiaoshixinxibiaoService.save(kcJiaoshixinxibiao);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param kcJiaoshixinxibiao
	 * @return
	 */
	@AutoLog(value = "教室信息表-编辑")
	@ApiOperation(value="教室信息表-编辑", notes="教室信息表-编辑")
	@RequiresPermissions("jiaoshi:kc_jiaoshixinxibiao:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody KcJiaoshixinxibiao kcJiaoshixinxibiao) {
		kcJiaoshixinxibiaoService.updateById(kcJiaoshixinxibiao);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "教室信息表-通过id删除")
	@ApiOperation(value="教室信息表-通过id删除", notes="教室信息表-通过id删除")
	@RequiresPermissions("jiaoshi:kc_jiaoshixinxibiao:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		kcJiaoshixinxibiaoService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "教室信息表-批量删除")
	@ApiOperation(value="教室信息表-批量删除", notes="教室信息表-批量删除")
	@RequiresPermissions("jiaoshi:kc_jiaoshixinxibiao:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.kcJiaoshixinxibiaoService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "教室信息表-通过id查询")
	@ApiOperation(value="教室信息表-通过id查询", notes="教室信息表-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<KcJiaoshixinxibiao> queryById(@RequestParam(name="id",required=true) String id) {
		KcJiaoshixinxibiao kcJiaoshixinxibiao = kcJiaoshixinxibiaoService.getById(id);
		if(kcJiaoshixinxibiao==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(kcJiaoshixinxibiao);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param kcJiaoshixinxibiao
    */
    @RequiresPermissions("jiaoshi:kc_jiaoshixinxibiao:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, KcJiaoshixinxibiao kcJiaoshixinxibiao) {
        return super.exportXls(request, kcJiaoshixinxibiao, KcJiaoshixinxibiao.class, "教室信息表");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("jiaoshi:kc_jiaoshixinxibiao:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, KcJiaoshixinxibiao.class);
    }

}
