package org.jeecg.modules.kc.jiaoshi.controller;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.xkcoding.http.HttpUtil;
import org.apache.commons.lang3.StringUtils;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.kc.jiaoshi.entity.KcZhihuijiaoshiAccessLog;
import org.jeecg.modules.kc.jiaoshi.service.IKcZhihuijiaoshiAccessLogService;
import java.util.Date;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;
import org.jeecg.common.system.base.controller.JeecgController;
import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

 /**
 * @Description: 智慧教室播放日志
 * @Author: jeecg-boot
 * @Date:   2023-10-17
 * @Version: V1.0
 */
@Slf4j
@Api(tags="智慧教室播放日志")
@RestController
@RequestMapping("/jiaoshi/kcZhihuijiaoshiAccessLog")
public class KcZhihuijiaoshiAccessLogController extends JeecgController<KcZhihuijiaoshiAccessLog, IKcZhihuijiaoshiAccessLogService> {
	@Autowired
	private IKcZhihuijiaoshiAccessLogService kcZhihuijiaoshiAccessLogService;
	
	/**
	 * 分页列表查询
	 *
	 * @param kcZhihuijiaoshiAccessLog
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	@AutoLog(value = "智慧教室播放日志-分页列表查询")
	@ApiOperation(value="智慧教室播放日志-分页列表查询", notes="智慧教室播放日志-分页列表查询")
	@GetMapping(value = "/list")
	public Result<?> queryPageList(KcZhihuijiaoshiAccessLog kcZhihuijiaoshiAccessLog,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<KcZhihuijiaoshiAccessLog> queryWrapper = QueryGenerator.initQueryWrapper(kcZhihuijiaoshiAccessLog, req.getParameterMap());
		Page<KcZhihuijiaoshiAccessLog> page = new Page<KcZhihuijiaoshiAccessLog>(pageNo, pageSize);
		IPage<KcZhihuijiaoshiAccessLog> pageList = kcZhihuijiaoshiAccessLogService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 * 添加
	 *
	 * @param kcZhihuijiaoshiAccessLog
	 * @return
	 */
	@AutoLog(value = "智慧教室播放日志-添加")
	@ApiOperation(value="智慧教室播放日志-添加", notes="智慧教室播放日志-添加")
	@PostMapping(value = "/add")
	public Result<?> add(@RequestBody KcZhihuijiaoshiAccessLog kcZhihuijiaoshiAccessLog) {
		kcZhihuijiaoshiAccessLogService.save(kcZhihuijiaoshiAccessLog);
		return Result.OK("添加成功！");
	}

	/**
	 * 添加
	 *
	 * @param kcZhihuijiaoshiAccessLog
	 * @return
	 */
	@AutoLog(value = "智慧教室播放日志-保存播放日志")
	@ApiOperation(value="智慧教室播放日志-保存播放日志", notes="智慧教室播放日志-保存播放日志")
	@PostMapping(value = "/savePlayLog")
	public Result<?> savePlayLog(@RequestBody KcZhihuijiaoshiAccessLog kcZhihuijiaoshiAccessLog) {
		//查询是不是通的，
		String playUrl = kcZhihuijiaoshiAccessLog.getPlayUrl();
		kcZhihuijiaoshiAccessLog.setLogType(2);//播放失败
		if(StringUtils.isNotBlank(playUrl)){
			try {
				HttpUtil.get(playUrl);
				kcZhihuijiaoshiAccessLog.setLogType(1);//成功
			}catch (Exception e){
				kcZhihuijiaoshiAccessLog.setLogType(2);//播放失败
			}finally {
				kcZhihuijiaoshiAccessLogService.save(kcZhihuijiaoshiAccessLog);
			}
		}else{
			kcZhihuijiaoshiAccessLogService.save(kcZhihuijiaoshiAccessLog);
		}
		return Result.OK("添加成功！");
	}

	/**
	 * 编辑
	 *
	 * @param kcZhihuijiaoshiAccessLog
	 * @return
	 */
	@AutoLog(value = "智慧教室播放日志-编辑")
	@ApiOperation(value="智慧教室播放日志-编辑", notes="智慧教室播放日志-编辑")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<?> edit(@RequestBody KcZhihuijiaoshiAccessLog kcZhihuijiaoshiAccessLog) {
		kcZhihuijiaoshiAccessLogService.updateById(kcZhihuijiaoshiAccessLog);
		return Result.OK("编辑成功!");
	}
	
	/**
	 * 通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "智慧教室播放日志-通过id删除")
	@ApiOperation(value="智慧教室播放日志-通过id删除", notes="智慧教室播放日志-通过id删除")
	@DeleteMapping(value = "/delete")
	public Result<?> delete(@RequestParam(name="id",required=true) String id) {
		kcZhihuijiaoshiAccessLogService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 * 批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "智慧教室播放日志-批量删除")
	@ApiOperation(value="智慧教室播放日志-批量删除", notes="智慧教室播放日志-批量删除")
	@DeleteMapping(value = "/deleteBatch")
	public Result<?> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.kcZhihuijiaoshiAccessLogService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功！");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "智慧教室播放日志-通过id查询")
	@ApiOperation(value="智慧教室播放日志-通过id查询", notes="智慧教室播放日志-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<?> queryById(@RequestParam(name="id",required=true) String id) {
		KcZhihuijiaoshiAccessLog kcZhihuijiaoshiAccessLog = kcZhihuijiaoshiAccessLogService.getById(id);
		return Result.OK(kcZhihuijiaoshiAccessLog);
	}

  /**
   * 导出excel
   *
   * @param request
   * @param kcZhihuijiaoshiAccessLog
   */
  @RequestMapping(value = "/exportXls")
  public ModelAndView exportXls(HttpServletRequest request, KcZhihuijiaoshiAccessLog kcZhihuijiaoshiAccessLog) {
      return super.exportXls(request, kcZhihuijiaoshiAccessLog, KcZhihuijiaoshiAccessLog.class, "智慧教室播放日志");
  }

  /**
   * 通过excel导入数据
   *
   * @param request
   * @param response
   * @return
   */
  @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
  public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
      return super.importExcel(request, response, KcZhihuijiaoshiAccessLog.class);
  }

}
