package org.jeecg.modules.kc.jiaoshi.controller;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.concurrent.atomic.AtomicReference;
import java.util.stream.Collectors;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import cn.hutool.core.date.DateField;
import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.date.TimeInterval;
import com.beust.jcommander.internal.Sets;
import com.google.common.collect.Maps;
import lombok.Data;
import org.apache.commons.lang.StringUtils;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.RedisUtil;
import org.jeecg.modules.kc.grab.SynchronizationService.RefreshLiveServer;
import org.jeecg.modules.kc.grab.imports.entity.Xxhbjsjbxx;
import org.jeecg.modules.kc.grab.imports.service.IXxhbjsjbxxService;
import org.jeecg.modules.kc.jiaoshi.entity.KcJiaoxuelouInfo;
import org.jeecg.modules.kc.jiaoshi.entity.KcZhihuijiaoshi;
import org.jeecg.modules.kc.jiaoshi.entity.KcZhihuijiaoshiStateLog;
import org.jeecg.modules.kc.jiaoshi.service.IKcJiaoxuelouInfoService;
import org.jeecg.modules.kc.jiaoshi.service.IKcZhihuijiaoshiService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecg.modules.kc.jiaoshi.service.IKcZhihuijiaoshiStateLogService;
import org.jeecg.modules.kc.kcJieci.entity.KcJieci;
import org.jeecg.modules.kc.kcJieci.service.IKcJieciService;
import org.jeecg.modules.kc.ktgl.entity.KcKetangbiao;
import org.jeecg.modules.kc.ktgl.service.IKcKetangbiaoService;
import org.jeecg.modules.quartz.entity.QuartzJob;
import org.jeecg.modules.quartz.service.IQuartzJobService;
import org.jeecg.modules.tools.DictUtils;
import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

 /**
 * @Description: 智慧教室
 * @Author: jeecg-boot
 * @Date:   2023-04-19
 * @Version: V1.0
 */
@Api(tags="智慧教室")
@RestController
@RequestMapping("/jiaoshi/kcZhihuijiaoshi")
@Slf4j
public class KcZhihuijiaoshiController extends JeecgController<KcZhihuijiaoshi, IKcZhihuijiaoshiService> {
	@Autowired
	private IKcZhihuijiaoshiService kcZhihuijiaoshiService;

	 @Autowired
	 private IKcJieciService kcJieciService;

	 @Autowired
	 private IKcKetangbiaoService kcKetangbiaoService;

	 @Autowired
	 private IQuartzJobService quartzJobService;

	 @Autowired
	 private IKcJiaoxuelouInfoService kcJiaoxuelouInfoService;

	 @Lazy
	 @Autowired
	 private RefreshLiveServer refreshLiveServer;

	 @Autowired
	 private IKcZhihuijiaoshiStateLogService kcZhihuijiaoshiStateLogService;//直播状态日志

	 @Autowired
	 private IXxhbjsjbxxService xxhbjsjbxxService;


	 @Autowired
	 private DictUtils dictUtils;

	 @Autowired
	 private RedisUtil redisUtil;

	 @Data
	 public class JieciIntTime {
		 private Integer ksTime;
		 private Integer jsTime;
	 }

	 public IPage<KcZhihuijiaoshi> queryPageListN(KcZhihuijiaoshi kcZhihuijiaoshi,
												  @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
												  @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
												  QueryWrapper<KcZhihuijiaoshi> queryWrapper) {
		 TimeInterval timer = DateUtil.timer();
		 Page<KcZhihuijiaoshi> page = new Page<>(pageNo, pageSize);
		 queryWrapper.orderByAsc("sort");
		 queryWrapper.orderByDesc("xm");
		 IPage<KcZhihuijiaoshi> pageList = kcZhihuijiaoshiService.page(page, queryWrapper);

		 log.info("01: {}",timer.intervalRestart());
		 //查询今天的课，
		 //DateTime starTime = DateUtil.parse("2023-12-08 07:29:00");
		 DateTime starTime = DateTime.now();

		 String nowTimeStr = starTime.toString("HHmm");
		 int nowTimeNum = Integer.parseInt(nowTimeStr);

		 DateTime nowPlus30Time = DateUtil.offset(starTime,DateField.MINUTE,30);//提前30分钟
		 String nowPlus30TimeStr = nowPlus30Time.toString("HHmm");
		 int nowPlus30TimeNum = Integer.parseInt(nowPlus30TimeStr);
		 starTime = DateUtil.endOfDay(starTime);//校正为今天末尾
		 String nowStr = starTime.toString("yyyy-MM-dd");

		 //查询全部的教学楼
		 //QueryWrapper<KcKetangbiao> jxlqw = new QueryWrapper<>();
		 List<KcJiaoxuelouInfo> jiaoxuelouInfoList = kcJiaoxuelouInfoService.list();
		 log.info("02: {}",timer.intervalRestart());

		 Map<String, KcJiaoxuelouInfo> jiaoxuelouInfoMap = jiaoxuelouInfoList.stream().collect(Collectors.toMap(KcJiaoxuelouInfo::getId,a -> a, (a,b) -> a));

		 log.info("03: {}",timer.intervalRestart());
		 //下一节次映射表
		 Map<String,String> nextJcMap = Maps.newHashMap();
		 nextJcMap.put("01、02","03、04");
		 nextJcMap.put("03、04","05、06");
		 nextJcMap.put("05、06","07、08");
		 nextJcMap.put("07、08","09、10");
		 nextJcMap.put("09、10","11、12");
		 nextJcMap.put("11、12","01、02");

		 AtomicReference<String> jieci = new AtomicReference<>();

		 //查询节次时间
		 QueryWrapper<KcJieci> jcqw = new QueryWrapper<>();
		 jcqw.like("jieci","、");
		 List<KcJieci> kcJieciList= kcJieciService.list(jcqw);
		 Map<String, JieciIntTime> kcJieciMap = Maps.newHashMap();
		 Set<String> nextKcJieciSet = Sets.newHashSet();
		 kcJieciList.forEach(x -> {
			 JieciIntTime jieciIntTime = new JieciIntTime();
			 jieciIntTime.setKsTime(Integer.parseInt(x.getHhks()));
			 jieciIntTime.setJsTime(Integer.parseInt(x.getHhjs()));

			 if(jieciIntTime.getKsTime() <= nowPlus30TimeNum && nowTimeNum <= jieciIntTime.getJsTime()){
				 //符合当前节
				 kcJieciMap.put(x.getJieci(), jieciIntTime);
				 jieci.set(x.getJieci());
			 }
			 //下一节次

		 });
		 log.info("04: {}",timer.intervalRestart());
		 //补充进下一节次里
		 kcJieciMap.forEach((k,v) -> {
			 if(nextJcMap.containsKey(k)){
				 String nextKey = nextJcMap.get(k);
				 //if(kcJieciMap.containsKey(nextKey)){
				 nextKcJieciSet.add(nextKey);//存下一节课，占个可以就行
				 //}
			 }
		 });
		 log.info("05: {}",timer.intervalRestart());

		 QueryWrapper<KcKetangbiao> ktqw = new QueryWrapper<>();
		 ktqw.eq("skrq",nowStr);
		 ktqw.eq(StringUtils.isNotBlank(jieci.get()),"hh",jieci.get());
//		 ktqw.apply("skrq >= STR_TO_DATE('"+nowStr+"', '%Y-%m-%d')");
//		 ktqw.apply("skrq < DATE_ADD(STR_TO_DATE('"+nowStr+"','%Y-%m-%d'),INTERVAL 1 DAY)");
		 ktqw.isNotNull("jsbh");
		 List<KcKetangbiao> kcKetangbiaoList = kcKetangbiaoService.list(ktqw);

		 log.info("06: {}",timer.intervalRestart());

		 starTime = starTime.offset(DateField.DAY_OF_MONTH,1);//明天
		 String nowStr2 = starTime.toString("yyyy-MM-dd");

		 QueryWrapper<KcKetangbiao> nextDayKtqw = new QueryWrapper<>();
		 nextDayKtqw.eq("hh","01、02");//明天的只查01、02这个节次的
//		 nextDayKtqw.apply("skrq >= STR_TO_DATE('"+nowStr2+"', '%Y-%m-%d')");
//		 nextDayKtqw.apply("skrq < DATE_ADD(STR_TO_DATE('"+nowStr2+"','%Y-%m-%d'),INTERVAL 1 DAY)");
		 nextDayKtqw.eq("skrq",nowStr2);
		 nextDayKtqw.isNotNull("jsbh");
		 List<KcKetangbiao> nextDayKcKetangbiaoList = kcKetangbiaoService.list(nextDayKtqw);

		 log.info("07: {}",timer.intervalRestart());

		 //根据节次信息包装进Map
		 Map<String, KcKetangbiao> kcKetangbiaoNowSet = Maps.newHashMap();
		 Map<String, KcKetangbiao> kcKetangbiaoNextSet = Maps.newHashMap();

		 kcKetangbiaoList.forEach(x -> {
			 //匹配是否在上课范围内
			 if(kcJieciMap.containsKey(x.getHh())){
				 kcKetangbiaoNowSet.put(x.getJsbh(), x);
			 }
			 //下一节不是12节的是今天的下一节（34,56,78）
			 if(nextKcJieciSet.contains(x.getHh()) && !StringUtils.equals(x.getHh(),"01、02")){
				 kcKetangbiaoNextSet.put(x.getJsbh(), x);
			 }
		 });
		 if(kcJieciMap.isEmpty() || kcJieciMap.containsKey("11、12")){//当前没有节次，当前匹配节次为最后一节，使用明天的课程填充进去
			 nextDayKcKetangbiaoList.forEach(x -> {
				 //下一节是01、02的归类为明天的
				 if(StringUtils.equals(x.getHh(),"01、02")){
					 kcKetangbiaoNextSet.put(x.getJsbh(), x);
				 }
			 });
		 }

		 log.info("08: {}",timer.intervalRestart());

		 //查找状态日志塞进去
		 List<KcZhihuijiaoshiStateLog> zhihuijiaoshiStateLogList = kcZhihuijiaoshiStateLogService.list();
		 Map<String, KcZhihuijiaoshiStateLog> zhihuijiaoshiStateLogMap = Maps.newHashMap();
		 zhihuijiaoshiStateLogList.forEach(x -> zhihuijiaoshiStateLogMap.put(x.getJsbh(),x));


		 //计算哪节在时间范围内

		 Map<String, KcZhihuijiaoshi> jxlMap = Maps.newHashMap();

		 //装填到数据里
		 pageList.getRecords().forEach(x -> {
			 //jsbh 教室编号
			 //sksj 上课时间
			 //hh 节次
			 //kcJieciMap.containsKey(x.getHh)
			 jxlMap.put(x.getJxlName(),x);
			 //nowTimeNum
			 if(kcKetangbiaoNowSet.containsKey(x.getJsbh())){
				 KcKetangbiao ketangbiao = kcKetangbiaoNowSet.get(x.getJsbh());
				 x.setNowIsClass(true);
				 x.setNowIsClassId(ketangbiao.getId());
				 x.setNowIsClassHh(ketangbiao.getHh());
				 x.setNowIsClassName(ketangbiao.getKcmc());
			 }
//			 x.setNowIsClass(true);//debug
			 if(kcKetangbiaoNextSet.containsKey(x.getJsbh())){
				 KcKetangbiao ketangbiao = kcKetangbiaoNextSet.get(x.getJsbh());
				 x.setNextIsClass(true);
				 x.setNextIsClassId(ketangbiao.getId());
			 }
			 if(jiaoxuelouInfoMap.containsKey(x.getJxlId())){
				 KcJiaoxuelouInfo info = jiaoxuelouInfoMap.get(x.getJxlId());
				 x.setJsNum(StringUtils.defaultString(info.getJsNum(),"0"));
			 }
			 if(zhihuijiaoshiStateLogMap.containsKey(x.getJsbh())){
				 KcZhihuijiaoshiStateLog data = zhihuijiaoshiStateLogMap.get(x.getJsbh());
				 x.setForceState(data.getForceState());
			 }
		 });
		 log.info("09: {}",timer.intervalRestart());
		 //查询多余的数据
		 if(kcZhihuijiaoshi.getQueryNoZhiHuiJiaoShi() != null && kcZhihuijiaoshi.getQueryNoZhiHuiJiaoShi()){
			 QueryWrapper<Xxhbjsjbxx> qw = new QueryWrapper<>();
			 qw.in(!jxlMap.keySet().isEmpty(),"jxl.JZWMC",jxlMap.keySet());
			 qw.apply("a.jsh not in (select jsbh from kc_zhihuijiaoshi)");
			 List<Xxhbjsjbxx> otherList = xxhbjsjbxxService.queryOtherList(qw);
			 //转换类型
			 for (Xxhbjsjbxx x:otherList){
				 KcZhihuijiaoshi jiaoshi = new KcZhihuijiaoshi();
				 //jiaoshi.setId(x.getBh());// a.bh as id
				 //获取教学楼ID
				 KcZhihuijiaoshi jxl = jxlMap.get(x.getJzwmc());
				 String jxlId = "";
				 if(jxl != null){
					 jxlId = jxl.getJxlId();
				 }
				 jiaoshi.setXq(x.getJsmc());//
				 jiaoshi.setJxlId(jxlId);
				 jiaoshi.setJxlName(x.getJzwmc());
				 jiaoshi.setJsbh(x.getJsh());
				 jiaoshi.setJsmc(x.getJsmc());
				 //jiaoshi.setXm()
				 pageList.getRecords().add(jiaoshi);
			 }
		 }
		 log.info("10: {}",timer.intervalRestart());

		 return pageList;
	 }


	/**
	 * 分页列表查询
	 *
	 * @param kcZhihuijiaoshi
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "智慧教室-分页列表查询")
	@ApiOperation(value="智慧教室-分页列表查询", notes="智慧教室-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<KcZhihuijiaoshi>> queryPageList(KcZhihuijiaoshi kcZhihuijiaoshi,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<KcZhihuijiaoshi> queryWrapper = QueryGenerator.initQueryWrapper(kcZhihuijiaoshi, req.getParameterMap());
		IPage<KcZhihuijiaoshi> pageList = queryPageListN(kcZhihuijiaoshi,pageNo,pageSize,queryWrapper);
		return Result.OK(pageList);
	}

	 public static void main(String[] args) {
		 DateTime starTime = DateTime.now();
		 //starTime = DateUtil.endOfDay(starTime);//校正为今天末尾

		 String nowTimeStr = starTime.toString("HHmm");
		 int nowTimeNum = Integer.parseInt(nowTimeStr);

//			 01、02, 0800, 0930
//		 03、04, 1000, 1130
//		 05、06, 1330, 1500
//		 07、08, 1515, 1645
//		 09、10, 1800, 1930
//		 11、12, 1945, 2115
		 //betweenStartDay >=0 && betweenEndDay <=0
		 System.out.println(nowTimeStr);
		 if(1945 <= nowTimeNum && nowTimeNum <= 2115){
			 System.out.println("有效！");
		 }

		 DateTime nowPlus30Time = DateUtil.offset(starTime,DateField.MINUTE,30);//提前30分钟
		 String nowTimeStr2 = nowPlus30Time.toString("HHmm");
		 int nowTimeNum2 = Integer.parseInt(nowTimeStr2);
		 starTime = DateUtil.endOfDay(starTime);//校正为今天末尾
		 String nowStr = starTime.toString("yyyy-MM-dd");
		 System.out.println(nowTimeNum2);
		 System.out.println(nowStr);
		 //740 810 0800	0930 910 +30 940
		 if(800 <= 940 && 910 <= 930){
			 System.out.println("有效！");
		 }

		 if(730 <= (745) && 815 <= 930){
			 System.out.println("有效！");
		 }


	 }

	/**
	 *   添加
	 *
	 * @param kcZhihuijiaoshi
	 * @return
	 */
	@AutoLog(value = "智慧教室-添加")
	@ApiOperation(value="智慧教室-添加", notes="智慧教室-添加")
//	@RequiresPermissions("jiaoshi:kc_zhihuijiaoshi:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody KcZhihuijiaoshi kcZhihuijiaoshi) {
		//补充教学楼名称和教室名称
		if(StringUtils.isNotBlank(kcZhihuijiaoshi.getJxlId())){
			kcZhihuijiaoshi.setJxlName(dictUtils.translateDictValue("id","jxlh_name","kc_jiaoxuelou_info",kcZhihuijiaoshi.getJxlId()));
		}
		if(StringUtils.isNotBlank(kcZhihuijiaoshi.getJsbh())){
			kcZhihuijiaoshi.setJsmc(dictUtils.translateDictValue("jsh","jsmc","xxhbjsjbxx",kcZhihuijiaoshi.getJsbh()));
		}
		kcZhihuijiaoshiService.save(kcZhihuijiaoshi);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param kcZhihuijiaoshi
	 * @return
	 */
	@AutoLog(value = "智慧教室-编辑")
	@ApiOperation(value="智慧教室-编辑", notes="智慧教室-编辑")
//	@RequiresPermissions("jiaoshi:kc_zhihuijiaoshi:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody KcZhihuijiaoshi kcZhihuijiaoshi) {
		if(StringUtils.isNotBlank(kcZhihuijiaoshi.getJxlId())){
			kcZhihuijiaoshi.setJxlName(dictUtils.translateDictValue("id","jxlh_name","kc_jiaoxuelou_info",kcZhihuijiaoshi.getJxlId()));
		}
		if(StringUtils.isNotBlank(kcZhihuijiaoshi.getJsbh())){
			kcZhihuijiaoshi.setJsmc(dictUtils.translateDictValue("jsh","jsmc","xxhbjsjbxx",kcZhihuijiaoshi.getJsbh()));
		}
		kcZhihuijiaoshiService.updateById(kcZhihuijiaoshi);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "智慧教室-通过id删除")
	@ApiOperation(value="智慧教室-通过id删除", notes="智慧教室-通过id删除")
//	@RequiresPermissions("jiaoshi:kc_zhihuijiaoshi:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		kcZhihuijiaoshiService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "智慧教室-批量删除")
	@ApiOperation(value="智慧教室-批量删除", notes="智慧教室-批量删除")
//	@RequiresPermissions("jiaoshi:kc_zhihuijiaoshi:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.kcZhihuijiaoshiService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "智慧教室-通过id查询")
	@ApiOperation(value="智慧教室-通过id查询", notes="智慧教室-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<KcZhihuijiaoshi> queryById(@RequestParam(name="id",required=true) String id) {
		KcZhihuijiaoshi kcZhihuijiaoshi = kcZhihuijiaoshiService.getById(id);
		if(kcZhihuijiaoshi==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(kcZhihuijiaoshi);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param kcZhihuijiaoshi
    */
    @RequiresPermissions("jiaoshi:kc_zhihuijiaoshi:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, KcZhihuijiaoshi kcZhihuijiaoshi) {
        return super.exportXls(request, kcZhihuijiaoshi, KcZhihuijiaoshi.class, "智慧教室");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("jiaoshi:kc_zhihuijiaoshi:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, KcZhihuijiaoshi.class);
    }


	 @ApiOperation(value="智慧教室-分页列表查询", notes="智慧教室-分页列表查询")
	 @GetMapping(value = "/updateAllLive")
	 public Result<String> updateAllLive(KcZhihuijiaoshi kcZhihuijiaoshi) {
		if(StringUtils.isBlank(kcZhihuijiaoshi.getIds())){
			return Result.error("操作失败!");
		}
	 	this.kcZhihuijiaoshiService.updateAllLive(kcZhihuijiaoshi);
	 	return Result.OK("操作成功!");
	 }


	 @GetMapping(value = "/getAutoShangXianQuartz")
	 public Result<?> getAutoShangXianQuartz(){
		 QueryWrapper<QuartzJob> jobQw = new QueryWrapper<>();
		 jobQw.eq("job_class_name","org.jeecg.modules.kc.grab.SynchronizationService.RefreshLiveServer");
		 jobQw.last("limit 1");
		 QuartzJob quartzJob = quartzJobService.getOne(jobQw);
		 return Result.OK(quartzJob);
	 }

	 /**
	  * 刷新状态日志
	  * @return
	  */
	 @GetMapping(value = "/refreshLogs")
	 public Result<?> refreshLogs(String jxlName){
		 refreshLiveServer.refreshState(jxlName);
		 return Result.OK(kcZhihuijiaoshiStateLogService.list());
	 }

	 /**
	  * 查询redis中某key的状态
	  * @return
	  */
	 @GetMapping(value = "/getRedisKey")
	 public Result<?> getRedisKey(String key){
		 return Result.OK(redisUtil.get(key));
	 }

	 /**
	  * 查询redis中某key的状态
	  * @return
	  */
	 @GetMapping(value = "/resettingRedisKeys")
	 public Result<?> resettingRedisKey(String key){
		 redisUtil.del(StringUtils.split(key,","));
		 return Result.OK();
	 }


	 @AutoLog(value = "智慧教室-修改开放听课状态")
	 @ApiOperation(value="智慧教室-修改开放听课状态", notes="智慧教室-修改开放听课状态")
	 @PostMapping(value = "/updateTkzt")
	 public Result<String> updateTkzt(@RequestBody KcZhihuijiaoshi kcZhihuijiaoshi) {
		 kcZhihuijiaoshiService.updateById(kcZhihuijiaoshi);
		 return Result.OK("操作成功!");
	 }


	 @GetMapping(value = "/sdjc")
	 public Result<?> sdjc(String id){
		 refreshLiveServer.sdjc(id);
		 return Result.OK(kcZhihuijiaoshiStateLogService.list());
	 }

}
