package org.jeecg.modules.kc.jiaoshi.controller;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.LambdaUpdateWrapper;
import org.apache.commons.lang3.StringUtils;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.kc.jiaoshi.entity.KcZhihuijiaoshiStateLog;
import org.jeecg.modules.kc.jiaoshi.service.IKcZhihuijiaoshiStateLogService;
import java.util.Date;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;
import org.jeecg.common.system.base.controller.JeecgController;
import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

 /**
 * @Description: 状态日志
 * @Author: jeecg-boot
 * @Date:   2023-10-29
 * @Version: V1.0
 */
@Slf4j
@Api(tags="状态日志")
@RestController
@RequestMapping("/jiaoshi/kcZhihuijiaoshiStateLog")
public class KcZhihuijiaoshiStateLogController extends JeecgController<KcZhihuijiaoshiStateLog, IKcZhihuijiaoshiStateLogService> {
	@Autowired
	private IKcZhihuijiaoshiStateLogService kcZhihuijiaoshiStateLogService;
	
	/**
	 * 分页列表查询
	 *
	 * @param kcZhihuijiaoshiStateLog
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	@AutoLog(value = "状态日志-分页列表查询")
	@ApiOperation(value="状态日志-分页列表查询", notes="状态日志-分页列表查询")
	@GetMapping(value = "/list")
	public Result<?> queryPageList(KcZhihuijiaoshiStateLog kcZhihuijiaoshiStateLog,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<KcZhihuijiaoshiStateLog> queryWrapper = QueryGenerator.initQueryWrapper(kcZhihuijiaoshiStateLog, req.getParameterMap());
		if(StringUtils.isNotBlank(kcZhihuijiaoshiStateLog.getTypeIsBad())){
			queryWrapper.ne("type","green");
		}
		if(StringUtils.isNotBlank(kcZhihuijiaoshiStateLog.getForceStateIsBad())){
			queryWrapper.and(x -> x.ne("force_state","green").or().isNull("force_state"));
			queryWrapper.apply("( if(force_state is not null,force_state,type) = '" + kcZhihuijiaoshiStateLog.getForceStateIsBad() + "' )");
		}
		Page<KcZhihuijiaoshiStateLog> page = new Page<>(pageNo, pageSize);
		IPage<KcZhihuijiaoshiStateLog> pageList = kcZhihuijiaoshiStateLogService.page(page, queryWrapper);






		return Result.OK(pageList);
	}
	
	/**
	 * 添加
	 *
	 * @param kcZhihuijiaoshiStateLog
	 * @return
	 */
	@AutoLog(value = "状态日志-添加")
	@ApiOperation(value="状态日志-添加", notes="状态日志-添加")
	@PostMapping(value = "/add")
	public Result<?> add(@RequestBody KcZhihuijiaoshiStateLog kcZhihuijiaoshiStateLog) {
		kcZhihuijiaoshiStateLogService.save(kcZhihuijiaoshiStateLog);
		return Result.OK("添加成功！");
	}
	
	/**
	 * 编辑
	 *
	 * @param kcZhihuijiaoshiStateLog
	 * @return
	 */
	@AutoLog(value = "状态日志-编辑")
	@ApiOperation(value="状态日志-编辑", notes="状态日志-编辑")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<?> edit(@RequestBody KcZhihuijiaoshiStateLog kcZhihuijiaoshiStateLog) {
		kcZhihuijiaoshiStateLogService.updateById(kcZhihuijiaoshiStateLog);
		return Result.OK("编辑成功!");
	}

	 /**
	  * 编辑
	  *
	  * @param kcZhihuijiaoshiStateLog
	  * @return
	  */
	 @AutoLog(value = "状态日志-编辑-教室编号")
	 @ApiOperation(value="状态日志-编辑-教室编号", notes="状态日志-编辑-教室编号")
	 @RequestMapping(value = "/updateByJsbh", method = {RequestMethod.PUT,RequestMethod.POST})
	 public Result<?> updateByJsId(@RequestBody KcZhihuijiaoshiStateLog kcZhihuijiaoshiStateLog) {
		 LambdaUpdateWrapper<KcZhihuijiaoshiStateLog> luw = new LambdaUpdateWrapper<>();
		 luw.set(KcZhihuijiaoshiStateLog::getForceState, kcZhihuijiaoshiStateLog.getForceState());
		 luw.eq(KcZhihuijiaoshiStateLog::getJsbh, kcZhihuijiaoshiStateLog.getJsbh());
		 kcZhihuijiaoshiStateLogService.update(luw);
		 return Result.OK("编辑成功!");
	 }

	/**
	 * 通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "状态日志-通过id删除")
	@ApiOperation(value="状态日志-通过id删除", notes="状态日志-通过id删除")
	@DeleteMapping(value = "/delete")
	public Result<?> delete(@RequestParam(name="id",required=true) String id) {
		kcZhihuijiaoshiStateLogService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 * 批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "状态日志-批量删除")
	@ApiOperation(value="状态日志-批量删除", notes="状态日志-批量删除")
	@DeleteMapping(value = "/deleteBatch")
	public Result<?> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.kcZhihuijiaoshiStateLogService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功！");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "状态日志-通过id查询")
	@ApiOperation(value="状态日志-通过id查询", notes="状态日志-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<?> queryById(@RequestParam(name="id",required=true) String id) {
		KcZhihuijiaoshiStateLog kcZhihuijiaoshiStateLog = kcZhihuijiaoshiStateLogService.getById(id);
		return Result.OK(kcZhihuijiaoshiStateLog);
	}

  /**
   * 导出excel
   *
   * @param request
   * @param kcZhihuijiaoshiStateLog
   */
  @RequestMapping(value = "/exportXls")
  public ModelAndView exportXls(HttpServletRequest request, KcZhihuijiaoshiStateLog kcZhihuijiaoshiStateLog) {
      return super.exportXls(request, kcZhihuijiaoshiStateLog, KcZhihuijiaoshiStateLog.class, "状态日志");
  }

  /**
   * 通过excel导入数据
   *
   * @param request
   * @param response
   * @return
   */
  @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
  public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
      return super.importExcel(request, response, KcZhihuijiaoshiStateLog.class);
  }

}
