package org.jeecg.modules.kc.jiaoshi.entity;

import java.io.Serializable;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.TableField;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;
import org.jeecgframework.poi.excel.annotation.Excel;

/**
 * @Description: 教室容量
 * @Author: jeecg-boot
 * @Date:   2024-01-09
 * @Version: V1.0
 */
@Data
@TableName("kc_jiaoshirongliang")
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value="kc_jiaoshirongliang对象", description="教室容量")
public class KcJiaoshirongliang {
    
	/**id*/
	@TableId(type = IdType.ASSIGN_ID)
    @ApiModelProperty(value = "id")
	private Integer id;
	/**创建人登录名称*/
	@Excel(name = "创建人登录名称", width = 15)
    @ApiModelProperty(value = "创建人登录名称")
	private String createBy;
	/**创建日期*/
	@Excel(name = "创建日期", width = 15, format = "yyyy-MM-dd")
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd")
    @DateTimeFormat(pattern="yyyy-MM-dd")
    @ApiModelProperty(value = "创建日期")
	private Date createTime;
	/**更新人登录名称*/
	@Excel(name = "更新人登录名称", width = 15)
    @ApiModelProperty(value = "更新人登录名称")
	private String updateBy;
	/**更新日期*/
	@Excel(name = "更新日期", width = 15, format = "yyyy-MM-dd")
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd")
    @DateTimeFormat(pattern="yyyy-MM-dd")
    @ApiModelProperty(value = "更新日期")
	private Date updateTime;
	/**教室编号*/
	@Excel(name = "教室编号", width = 15)
    @ApiModelProperty(value = "教室编号")
	private String jsbh;
	/**教室名称*/
	@Excel(name = "教室名称", width = 15)
    @ApiModelProperty(value = "教室名称")
	private String jsmc;
	/**所属单位*/
	@Excel(name = "所属单位", width = 15)
    @ApiModelProperty(value = "所属单位")
	private String ssdw;
	/**教室类型*/
	@Excel(name = "教室类型", width = 15)
    @ApiModelProperty(value = "教室类型")
	private String jslx;
	/**楼层*/
	@Excel(name = "楼层", width = 15)
    @ApiModelProperty(value = "楼层")
	private String lc;
	/**教室容量*/
	@Excel(name = "教室容量", width = 15)
    @ApiModelProperty(value = "教室容量")
	private String jsrl;
	/**教室图片*/
	@Excel(name = "教室图片", width = 15)
    @ApiModelProperty(value = "教室图片")
	private String jstp;
	/**建筑物名称*/
	@Excel(name = "建筑物名称", width = 15)
    @ApiModelProperty(value = "建筑物名称")
	private String jzwmc;
	/**校区名称*/
	@Excel(name = "校区名称", width = 15)
    @ApiModelProperty(value = "校区名称")
	private String xqmc;
	/**是否笔试考试*/
	@Excel(name = "是否笔试考试", width = 15)
    @ApiModelProperty(value = "是否笔试考试")
	private String sfbsks;
	/**门牌号*/
	@Excel(name = "门牌号", width = 15)
    @ApiModelProperty(value = "门牌号")
	private String mph;
}
