package org.jeecg.modules.kc.jiaoshi.entity;

import java.io.Serializable;
import java.io.UnsupportedEncodingException;
import java.util.Date;
import java.math.BigDecimal;

import com.baomidou.mybatisplus.annotation.*;
import lombok.Data;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;
import org.jeecgframework.poi.excel.annotation.Excel;
import org.jeecg.common.aspect.annotation.Dict;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * @Description: 智慧教室
 * @Author: jeecg-boot
 * @Date:   2023-04-19
 * @Version: V1.0
 */
@Data
@TableName("kc_zhihuijiaoshi")
@Accessors(chain = true)
@EqualsAndHashCode(callSuper = false)
@ApiModel(value="kc_zhihuijiaoshi对象", description="智慧教室")
public class KcZhihuijiaoshi implements Serializable {
    private static final long serialVersionUID = 1L;

	/**id*/
	@TableId(type = IdType.ASSIGN_ID)
    @ApiModelProperty(value = "id")
    private java.lang.Integer id;

    /**
     * 创建人
     */
    @ApiModelProperty(value = "创建人")
    @Excel(name = "创建人", width = 15)
    private java.lang.String createBy;

    /**
     * 创建时间
     */
    @ApiModelProperty(value = "创建时间")
    @Excel(name = "创建时间", width = 20, format = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private java.util.Date createTime;

    /**
     * 更新人
     */
    @ApiModelProperty(value = "更新人")
    @Excel(name = "更新人", width = 15)
    private java.lang.String updateBy;

    /**
     * 更新时间
     */
    @ApiModelProperty(value = "更新时间")
    @Excel(name = "更新时间", width = 20, format = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private java.util.Date updateTime;

    /**校区*/
	@Excel(name = "校区", width = 15)
    @ApiModelProperty(value = "校区")
    private java.lang.String xq;
    /**教学楼ID*/
    @Excel(name = "教学楼ID", width = 15)
    @ApiModelProperty(value = "教学楼ID")
    private java.lang.String jxlId;
    /**教学楼名称*/
    @Excel(name = "教学楼名称", width = 15)
    @ApiModelProperty(value = "教学楼名称")
    private java.lang.String jxlName;
    /**教室编号*/
    @Excel(name = "教室编号", width = 15)
    @ApiModelProperty(value = "教室编号")
    private java.lang.String jsbh;
    /**教室名称*/
    @Excel(name = "教室名称", width = 15)
    @ApiModelProperty(value = "教室名称")
    private java.lang.String jsmc;
	/**项目*/
	@Excel(name = "项目", width = 15)
    @ApiModelProperty(value = "项目")
    private java.lang.String xm;
	/**新ip*/
	@Excel(name = "新ip", width = 15)
    @ApiModelProperty(value = "新ip")
    private java.lang.String ip;


    /**推流地址（rtmp）*/
    @Excel(name = "推流地址（rtmp）", width = 15)
    @ApiModelProperty(value = "推流地址（rtmp）")
    private String pushUrl;

    /**播放地址（http）*/
    @Excel(name = "播放地址（http）", width = 15)
    @ApiModelProperty(value = "播放地址（http）")
    private String pullUrl;

	/**账号*/
	@Excel(name = "账号", width = 15)
    @ApiModelProperty(value = "账号")
    private java.lang.String user;
	/**密码*/
	@Excel(name = "密码", width = 15)
    @ApiModelProperty(value = "密码")
    private java.lang.String mima;
    /**密码*/
    @Excel(name = "厂商名称", width = 15)
    @ApiModelProperty(value = "厂商名称")
    private java.lang.String changshang;
	/**备注*/
	@Excel(name = "备注", width = 15)
    @ApiModelProperty(value = "备注")
    private java.lang.String bz;

    /**是否有效 0-有效 1-无效*/
    @Excel(name = "是否有效 0-有效 1-无效", width = 15)
    @ApiModelProperty(value = "是否有效 0-有效 1-无效")
    private java.lang.String sfyx;

    private String tjKftkzt;//开放听课后台统计状态

    /**一组*/
    @TableField(exist = false)
    private java.lang.String ids;

    /**当前节是否有课*/
    @TableField(exist = false)
    private java.lang.Boolean nowIsClass;

    /**当前节节次*/
    @TableField(exist = false)
    private java.lang.String nowIsClassHh;

    /**当前节是否有课的课堂ID*/
    @TableField(exist = false)
    private java.lang.String nowIsClassId;

    /**当前节是否有课的课堂名称*/
    @TableField(exist = false)
    private java.lang.String nowIsClassName;

    /**下一节是否有课*/
    @TableField(exist = false)
    private java.lang.Boolean nextIsClass;

    /**当前节是否有课的课堂ID*/
    @TableField(exist = false)
    private java.lang.String nextIsClassId;

    @TableField(exist = false)
    private java.lang.String jsNum;

    /**是否查询非智慧教室内容*/
    @TableField(exist = false)
    private Boolean queryNoZhiHuiJiaoShi;

    /**强制状态（green: 直播正常, yellow: 部分异常,red: 设备异常）*/
    @TableField(exist = false)
    private java.lang.String forceState;


}
