package org.jeecg.modules.kc.jiaoshi.entity;

import java.io.Serializable;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.TableField;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.jeecg.common.aspect.annotation.Dict;
import org.springframework.format.annotation.DateTimeFormat;
import org.jeecgframework.poi.excel.annotation.Excel;

/**
 * @Description: 状态日志
 * @Author: jeecg-boot
 * @Date:   2023-10-29
 * @Version: V1.0
 */
@Data
@TableName("kc_zhihuijiaoshi_monitor_log")
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value="kc_zhihuijiaoshi_monitor_log对象", description="状态日志")
public class KcZhihuijiaoshiMonitorLog {
    
	/**id*/
	@TableId(type = IdType.ASSIGN_ID)
    @ApiModelProperty(value = "id")
	private java.lang.String id;
	/**日志类型(1:播放正常 | 2:播放失败，拉起成功 | 3:播放失败，拉起失败)*/
    @ApiModelProperty(value = "日志类型(1:播放正常 | 2:播放失败，拉起成功 | 3:播放失败，拉起失败)")
	private java.lang.Integer logType;
	/**教学楼编号*/
    @ApiModelProperty(value = "教学楼编号")
	private java.lang.String jxlId;
	/**教室编号*/
    @ApiModelProperty(value = "教室编号")
	private java.lang.String jsbh;
	/**节次*/
	@ApiModelProperty(value = "节次")
	private java.lang.String hh;
	/**课堂ID*/
	@ApiModelProperty(value = "课堂ID")
	private java.lang.String ktId;
	/**课堂名称*/
	@ApiModelProperty(value = "课堂名称")
	private java.lang.String ktName;
	/**创建人*/
    @ApiModelProperty(value = "创建人")
	@Dict(dictTable = "sys_user", dicCode = "username", dicText = "realname")
	private java.lang.String createBy;
	/**更新人*/
    @ApiModelProperty(value = "更新人")
	@Dict(dictTable = "sys_user", dicCode = "username", dicText = "realname")
	private java.lang.String updateBy;
	/**更新时间*/
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "更新时间")
	private java.util.Date updateTime;
	//---------------------------导出--------------------------


	/**创建时间*/
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm:ss")
	@DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
	@ApiModelProperty(value = "统计日期")
	private java.util.Date createTime;


	@Excel(name = "统计日期", width = 15)
	@TableField(exist = false)
	private String startTime;
	@TableField(exist = false)
	private String endTime;
	/**教学楼名称*/
	@Excel(name = "教学楼名称", width = 15)
	@ApiModelProperty(value = "教学楼名称")
	private java.lang.String jxlName;
	/**教室名称*/
	@Excel(name = "教室名称", width = 15)
	@ApiModelProperty(value = "教室名称")
	private java.lang.String jsmc;

	@TableField(exist = false)
	@Excel(name = "状态正常数量", width = 15)
	private String ztzcNum;
	@TableField(exist = false)
	@Excel(name = "开启成功数量", width = 15)
	private String kqcgNum;
	@TableField(exist = false)
	@Excel(name = "开启失败数量", width = 15)
	private String kqsbNum;
	//---------------------------导出--------------------------



}
