package org.jeecg.modules.kc.jiaoshi.entity;

import java.io.Serializable;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.TableField;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.jeecg.common.aspect.annotation.Dict;
import org.springframework.format.annotation.DateTimeFormat;
import org.jeecgframework.poi.excel.annotation.Excel;

/**
 * @Description: 智慧教室操作日志
 * @Author: jeecg-boot
 * @Date:   2023-10-17
 * @Version: V1.0
 */
@Data
@TableName("kc_zhihuijiaoshi_operate_log")
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value="kc_zhihuijiaoshi_operate_log对象", description="智慧教室操作日志")
public class KcZhihuijiaoshiOperateLog {
    
	/**id*/
	@TableId(type = IdType.ASSIGN_ID)
    @ApiModelProperty(value = "id")
	private java.lang.String id;
	/**日志类型（1自动执行日志，2手动操作操作日志）*/
	@Excel(name = "日志类型（1自动执行日志，2手动操作操作日志）", width = 15)
    @ApiModelProperty(value = "日志类型（1自动执行日志，2手动操作操作日志）")
	private java.lang.Integer logType;
	/**教学楼编号*/
	@Excel(name = "教学楼编号", width = 15)
    @ApiModelProperty(value = "教学楼编号")
	private java.lang.String jxlId;
	/**教学楼名称*/
	@Excel(name = "教学楼名称", width = 15)
    @ApiModelProperty(value = "教学楼名称")
	private java.lang.String jxlName;
	/**教室编号*/
	@Excel(name = "教室编号", width = 15)
    @ApiModelProperty(value = "教室编号")
	private java.lang.String jsbh;
	/**教室名称*/
	@Excel(name = "教室名称", width = 15)
    @ApiModelProperty(value = "教室名称")
	private java.lang.String jsmc;
	/**操作类型(1开启，0关闭)*/
	@Excel(name = "操作类型(1开启，0关闭)", width = 15)
    @ApiModelProperty(value = "操作类型(1开启，0关闭)")
	private java.lang.String operateType;
	/**操作URl*/
	@Excel(name = "操作URl", width = 15)
    @ApiModelProperty(value = "操作URl")
	private java.lang.Object operateUrl;
	/**操作结果*/
	@Excel(name = "操作结果", width = 15)
    @ApiModelProperty(value = "操作结果")
	private java.lang.Object operateResult;
	/**操作返回类型(0:调用成功，1:调用失败)*/
	@Excel(name = "操作返回类型(0:调用成功，1:调用失败)", width = 15)
	@ApiModelProperty(value = "操作返回类型(0:调用成功，1:调用失败)")
	private java.lang.String operateResultType;
	/**创建人*/
	@ApiModelProperty(value = "创建人")
	@Excel(name = "创建人", width = 15)
	@Dict(dictTable = "sys_user", dicCode = "username", dicText = "realname")
	private java.lang.String createBy;
	/**创建时间*/
	@Excel(name = "创建时间", width = 15, format = "yyyy-MM-dd HH:mm:ss")
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern="yyyy-MM-dd")
    @ApiModelProperty(value = "创建时间")
	private java.util.Date createTime;
	/**更新人*/
	@Excel(name = "更新人", width = 15)
    @ApiModelProperty(value = "更新人")
	@Dict(dictTable = "sys_user", dicCode = "username", dicText = "realname")
	private java.lang.String updateBy;
	/**更新时间*/
	@Excel(name = "更新时间", width = 15, format = "yyyy-MM-dd HH:mm:ss")
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern="yyyy-MM-dd")
    @ApiModelProperty(value = "更新时间")
	private java.util.Date updateTime;
}
