package org.jeecg.modules.kc.jiaoshi.entity;

import java.io.Serializable;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.TableField;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.jeecg.common.aspect.annotation.Dict;
import org.springframework.format.annotation.DateTimeFormat;
import org.jeecgframework.poi.excel.annotation.Excel;

/**
 * @Description: 状态日志
 * @Author: jeecg-boot
 * @Date:   2023-10-29
 * @Version: V1.0
 */
@Data
@TableName("kc_zhihuijiaoshi_state_log")
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value="kc_zhihuijiaoshi_state_log对象", description="状态日志")
public class KcZhihuijiaoshiStateLog {
    
	/**id*/
	@TableId(type = IdType.ASSIGN_ID)
    @ApiModelProperty(value = "id")
	private java.lang.String id;
	/**教学楼编号*/
	@Excel(name = "教学楼编号", width = 15)
    @ApiModelProperty(value = "教学楼编号")
	private java.lang.String jxlId;
	/**教学楼名称*/
	@Excel(name = "教学楼名称", width = 15)
    @ApiModelProperty(value = "教学楼名称")
	private java.lang.String jxlName;
	/**教室编号*/
	@Excel(name = "教室编号", width = 15)
    @ApiModelProperty(value = "教室编号")
	private java.lang.String jsbh;
	/**教室名称*/
	@Excel(name = "教室名称", width = 15)
    @ApiModelProperty(value = "教室名称")
	private java.lang.String jsmc;
	/**教师近景(录播主机*/
	@Excel(name = "教师近景(录播主机", width = 15)
    @ApiModelProperty(value = "教师近景(录播主机)")
	private java.lang.String lbzj;
	/**教师全景*/
	@Excel(name = "教师全景", width = 15)
    @ApiModelProperty(value = "教师全景")
	private java.lang.String jsqj;
	/**学生全景*/
	@Excel(name = "学生全景", width = 15)
    @ApiModelProperty(value = "学生全景")
	private java.lang.String xsqj;
	/**PPT*/
	@Excel(name = "PPT", width = 15)
    @ApiModelProperty(value = "PPT")
	private java.lang.String ppt;
	/**绿色的数量*/
	@Excel(name = "绿色的数量", width = 15)
    @ApiModelProperty(value = "绿色的数量")
	private java.lang.Integer greenNum;
	/**状态指示灯（green: 直播正常, yellow: 部分异常,red: 设备异常）*/
	@Excel(name = "状态指示灯（green: 直播正常, yellow: 部分异常,red: 设备异常）", width = 15)
    @ApiModelProperty(value = "状态指示灯（green: 直播正常, yellow: 部分异常,red: 设备异常）")
	private java.lang.String type;
	//查找失败的
	@TableField(exist = false)
	private java.lang.String typeIsBad;
	/**创建人*/
	@Excel(name = "创建人", width = 15)
    @ApiModelProperty(value = "创建人")
	@Dict(dictTable = "sys_user", dicCode = "username", dicText = "realname")
	private java.lang.String createBy;
	/**创建时间*/
	@Excel(name = "创建时间", width = 20, format = "yyyy-MM-dd HH:mm:ss")
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "创建时间")
	private java.util.Date createTime;
	/**更新人*/
	@Excel(name = "更新人", width = 15)
    @ApiModelProperty(value = "更新人")
	@Dict(dictTable = "sys_user", dicCode = "username", dicText = "realname")
	private java.lang.String updateBy;
	/**更新时间*/
	@Excel(name = "更新时间", width = 20, format = "yyyy-MM-dd HH:mm:ss")
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "更新时间")
	private java.util.Date updateTime;
	/**强制状态（green: 直播正常, yellow: 部分异常,red: 设备异常）*/
	private java.lang.String forceState;
	//查找失败的
	@TableField(exist = false)
	private java.lang.String forceStateIsBad;

}
