package org.jeecg.modules.kc.jiaoshi.export;

import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.ArrayUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.beust.jcommander.internal.Sets;
import com.google.common.collect.Lists;
import com.google.common.collect.Maps;
import lombok.Data;
import org.apache.commons.lang3.StringUtils;
import org.jeecg.common.util.SpringContextHolder;
import org.jeecg.modules.kc.jiaoshi.entity.KcZhihuijiaoshiMonitorLog;
import org.jeecg.modules.kc.jiaoshi.service.IKcZhihuijiaoshiMonitorLogService;
import org.jeecg.modules.tools.word.BaseExport;
import org.jeecg.modules.tools.word.ExportWord;
import org.jeecg.modules.tools.word.WordOperator;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.math.BigDecimal;
import java.math.RoundingMode;
import java.text.DecimalFormat;
import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.stream.Collectors;


/**
* 功能说明：导出封装
* 创建者：byx
* 创建时间：2021-6-30
* <pre>
* 修改时间:       修改者:            
* 修改内容：
* </pre>
*/
public class Export extends BaseExport {

	public Export(){
		super();
		initHhNameMap();
	}
	
	private Logger logger = LoggerFactory.getLogger(this.getClass());
	
	//由于前面调用使用的是new，所以只能手动注入bean
//	private ISysDictService sysDictService = SpringContextHolder.getBean(ISysDictService.class);
	private IKcZhihuijiaoshiMonitorLogService kcZhihuijiaoshiMonitorLogService = SpringContextHolder.getBean(IKcZhihuijiaoshiMonitorLogService.class);

//	/**
//	 *
//	 * 功能说明    : 将导出的文档片段按照list返回
//	 * 创建者      : byx
//	 * 修改日期    : 2018年9月26日
//	 * @param
//	 * @return 文档片段的list对象
//	 * @throws Exception
//	 */
//	public List<WordOperator> exportAll(QnCustomerHetong customerHetong, SysUser user, Date now) throws Exception{
//		List<WordOperator> list = Lists.newArrayList();
//		list.add(export1(customerHetong,user,now));
//		list.add(export2(customerHetong));
//		list.add(export3(customerHetong));
//		return list;
//	}

//	@Override
//	public List<DictModel> getDictList(String dictCode){
//		return sysDictService.queryDictItemsByCode(dictCode);
//	}
	//不保留小数
	DecimalFormat dfz = new DecimalFormat("0");

	/**
	 * 转换为 ***
	 * @param num 数字
	 * @return 字符型的***数字
	 */
	public String dfzf(String num){
		return dfzf(new BigDecimal(num));
	}

	/**
	 * 转换为 ***
	 * @param num 数字
	 * @return 字符型的***数字
	 */
	public String dfzf(BigDecimal num){
		return dfz.format(num);
	}

	//保留两位小数
	public static DecimalFormat dfzdzz = new DecimalFormat("0.00");

	/**
	 * 转换为 ***.**
	 * @param num 数字
	 * @return 字符型的***.**数字
	 */
	public String dfzdzzf(String num){
		return dfzdzz.format(new BigDecimal(num));
	}

	/**
	 * 转换为 ***.**
	 * @param num 数字
	 * @return 字符型的***.**数字
	 */
	public String dfzdzzf(BigDecimal num){
		return dfzdzz.format(num);
	}

	//数量÷总数×100
	public BigDecimal getPercentage(BigDecimal zc, BigDecimal yc){
		if(zc.compareTo(new BigDecimal(0)) == 0){
			return new BigDecimal("0");
		}
		if(yc.compareTo(new BigDecimal(0)) == 0){
			return new BigDecimal("0");
		}
		BigDecimal all = zc.add(yc);
		return zc.divide(all, 2, RoundingMode.HALF_UP).multiply(new BigDecimal("100"));
	}

	//数量÷总数×100
	public BigDecimal getPercentageByAll(BigDecimal yc, BigDecimal all){
		if(yc.compareTo(new BigDecimal(0)) == 0){
			return new BigDecimal("0");
		}
		if(all.compareTo(new BigDecimal(0)) == 0){
			return new BigDecimal("0");
		}
		return yc.divide(all, 2, RoundingMode.HALF_UP).multiply(new BigDecimal("100"));
	}

	public Integer isNull(Integer num){
		if(num == null) return 0;
		return num;
	}
	@Data
	public class TwoYcListClass {
		private String ycHh;//异常节次
		private String ycKcmc;//异常课程名称
		private String ycDate;//异常时间

		private Integer jccs;//监测次数
		private Integer yccs;//异常次数

		public void addJccs(Integer num){
			if(this.jccs == null) this.jccs = 0;
			if(num == null) return;
			this.jccs += num;
		}
		public void addYccs(Integer num){
			if(this.yccs == null) this.yccs = 0;
			if(num == null) return;
			this.yccs += num;
		}

	}


	@Data
	public class TwoListClass {
		private String jxl;//教学楼
		private String jsmc;//教室名称
		private Integer kfkts = 0;//开放课堂数
		//private Float zcktl;//正常课堂率
		private Integer zckts = 0;//正常课堂数
		private Integer yckts = 0;//异常课堂数
		private String ycqksm;//异常情况说明

		private Map<String,TwoYcListClass> ycMap = Maps.newLinkedHashMap();

//		private List<String> ycHhList = Lists.newArrayList();//异常节次
//		private List<String> ycKcmcList = Lists.newArrayList();//异常课程名称
//
//		private List<Integer> jccsList = Lists.newArrayList();//监测次数
//		private List<Integer> yccsList = Lists.newArrayList();//异常次数
//		private List<Integer> yclList = Lists.newArrayList();//异常率
		public void addKfkts(Integer num){
			if(this.kfkts == null) this.kfkts = 0;
			if(num == null) return;
			this.kfkts += num;
		}
		public void addZckts(Integer num){
			if(this.zckts == null) this.zckts = 0;
			if(num == null) return;
			this.zckts += num;
		}
		public void addYckts(Integer num){
			if(this.yckts == null) this.yckts = 0;
			if(num == null) return;
			this.yckts += num;
		}

		public BigDecimal getZcktl(){
			if(yckts != 0){
				return getPercentage(new BigDecimal(zckts),new BigDecimal(yckts));
			}else {
				return new BigDecimal("100");
			}
		}
	}

	@Data
	public class OneListClass {
		private String jxlName;//教学楼名称
		private String hhName;//节次名称
		private Integer kfnum = 0;//开放数
		private Integer zcnum = 0;//正常
		private Integer ycnum = 0;//异常

		public void addKfnum(Integer num){
			if(this.kfnum == null) this.kfnum = 0;
			if(num == null) return;
			this.kfnum += num;
		}
		public void addZcnum(Integer num){
			if(this.zcnum == null) this.zcnum = 0;
			if(num == null) return;
			this.zcnum += num;
		}
		public void addYcnum(Integer num){
			if(this.ycnum == null) this.ycnum = 0;
			if(num == null) return;
			this.ycnum += num;
		}
	}

	public Map<String, String> hhNameMap = Maps.newHashMap();

	public void initHhNameMap(){
		hhNameMap.put("01、02","第一大节");
		hhNameMap.put("03、04","第二大节");
		hhNameMap.put("05、06","第三大节");
		hhNameMap.put("07、08","第四大节");
		hhNameMap.put("09、10","第五大节");
		hhNameMap.put("11、12","第六大节");
	}

	public String getHhName(String key){
		String value = hhNameMap.get(key);
		return StringUtils.defaultString(value,"");
	}

	/**
	 * 
	 * 功能说明    : 拼接word导出
	 * 创建者      : byx
	 * 修改日期    : 2021-6-30
	 * @param kcZhihuijiaoshiMonitorLog
	 * @return
	 * @throws Exception
	 */
	public WordOperator export(KcZhihuijiaoshiMonitorLog kcZhihuijiaoshiMonitorLog) throws Exception{
		String templateName = "exp1\\zhjs-tjfxbg.docx";

		WordOperator wo = ExportWord.getWordOperator(templateName);
		//********************************@A.单个内容替换***************************************************/
		//********************************取数据***********************************************************/
		Map<String, Object> result = Maps.newHashMap();
		//查询日志
		QueryWrapper<KcZhihuijiaoshiMonitorLog> mainQw = new QueryWrapper<>();
		mainQw.isNotNull("kt_id");
		mainQw.ge(StringUtils.isNotBlank(kcZhihuijiaoshiMonitorLog.getStartTime()),"create_time",kcZhihuijiaoshiMonitorLog.getStartTime() + " 07:02:00");
		mainQw.le(StringUtils.isNotBlank(kcZhihuijiaoshiMonitorLog.getEndTime()),"create_time",kcZhihuijiaoshiMonitorLog.getEndTime() + " 23:59:59");
		if(StringUtils.isNotBlank(kcZhihuijiaoshiMonitorLog.getJxlName())){
			mainQw.in("jxl_name", Arrays.asList(StringUtils.split(kcZhihuijiaoshiMonitorLog.getJxlName(),",")));
		}
		List<KcZhihuijiaoshiMonitorLog> mainLogList =  kcZhihuijiaoshiMonitorLogService.list(mainQw);
		if(mainLogList.isEmpty()){
//			String today = DateUtil.today();
			String now = DateUtil.now();
			result.put("监测时间", kcZhihuijiaoshiMonitorLog.getStartTime() + " - " + kcZhihuijiaoshiMonitorLog.getEndTime());
			result.put("监测教学楼", kcZhihuijiaoshiMonitorLog.getJxlName());
			result.put("打印时间",now);
			result.put("教学楼数", "0");
			result.put("教室数", "0");
			result.put("大节数", "0");
			result.put("运行正常课堂", "0");
			result.put("运行异常课堂", "0");
			result.put("正常率", "0");
			wo.replaceTextPlus(result);
			wo.insert2Table(0, 2, true, Lists.newArrayList());
			wo.insert2Table(1, 1, true, Lists.newArrayList());
		}
		//01 聚合数据，
		Map<String, KcZhihuijiaoshiMonitorLog> mainLogMap = Maps.newHashMap();
//		Map<String, TwoListClass> jsNumMap = Maps.newHashMap();
		for(KcZhihuijiaoshiMonitorLog mainLog:  mainLogList){
			String day = formatDate(mainLog.getCreateTime(), "yyyy-MM-dd");
			String key = day + "-" + mainLog.getHh() + "-" + mainLog.getKtId();
			if(mainLogMap.containsKey(key)){
				//KcZhihuijiaoshiMonitorLog mmainLog = mainLogMap.get(key);
				if(mainLog.getLogType() == null || mainLog.getLogType() != 1){
					//失败的，瞬间污染全局
					mainLogMap.put(key,mainLog);
				}
			}else{
				mainLogMap.put(key,mainLog);
			}
			//先行计算每个教室的课堂数，成功，失败数
			//TwoListClass
//			String key2 = mainLog.getJsmc();
//			if(jsNumMap.containsKey(key2)){
//				TwoListClass o = jsNumMap.get(key2);
//
//			}else{
//
//			}
		}

		//先行计算每个教室的课堂数，成功，失败数
		Map<String, TwoListClass> jsNumMap = Maps.newHashMap();
		for (KcZhihuijiaoshiMonitorLog miniLog: mainLogMap.values()){
			String key = miniLog.getJsmc();
			TwoListClass o = null;
			if(jsNumMap.containsKey(key)){
				o = jsNumMap.get(key);
			}else{
				o = new TwoListClass();
				o.setKfkts(0);//开放数
				o.setZckts(0);//正常
				o.setYckts(0);//异常
				jsNumMap.put(key,o);
			}
			o.addKfkts(1);
			if(miniLog.getLogType() == null || miniLog.getLogType() != 1){
				o.addYckts(1);
			}else{
				o.addZckts(1);
			}
		}


		//折腾数据
		int jxls = 0;
		int jss = 0;
		int djs = 0;
		int zckts = 0;
		int yckts = 0;
		BigDecimal zcl = new BigDecimal(100);

		Set<String> jxlsSet = Sets.newHashSet();
		Set<String> jssSet = Sets.newHashSet();
		Set<String> djsSet = Sets.newHashSet();
//		Set<String> zcktsSet = Sets.newHashSet();
//		Set<String> ycktsSet = Sets.newHashSet();
		//Set<String> zclSet = Sets.newHashSet();

		Map<String,OneListClass> oneListMap = Maps.newHashMap();
		Map<String,TwoListClass> twoListMap = Maps.newHashMap();

		for(KcZhihuijiaoshiMonitorLog monitorLog: mainLogMap.values()){
			//基础数据
			jxlsSet.add(monitorLog.getJxlName());
			jssSet.add(monitorLog.getJsmc());
			djsSet.add(monitorLog.getHh());
			if(monitorLog.getLogType() != null && monitorLog.getLogType() == 1){
				//zcktsSet.add();//日志类型(1:播放正常 | 2:播放失败，拉起成功 | 3:播放失败，拉起失败)
				zckts++;
			}else{
				yckts++;
			}

			//第一个
			if(oneListMap.containsKey(monitorLog.getJxlName() + "-" + monitorLog.getHh())){
				OneListClass o = oneListMap.get(monitorLog.getJxlName() + "-" + monitorLog.getHh());
				o.addKfnum(1);
				if(monitorLog.getLogType() != null && monitorLog.getLogType() == 1){
					o.addZcnum(1);
				}else{
					o.addYcnum(1);
				}
			}else{
				OneListClass o = new OneListClass();
				o.setJxlName(monitorLog.getJxlName());
				o.setHhName(getHhName(monitorLog.getHh()));
				o.setKfnum(1);
				if(monitorLog.getLogType() != null && monitorLog.getLogType() == 1){
					o.setZcnum(1);
				}else{
					o.setYcnum(1);
				}
				oneListMap.put(monitorLog.getJxlName() + "-" + monitorLog.getHh(),o);
			}
		}

		for(KcZhihuijiaoshiMonitorLog monitorLog: mainLogList){

			//教学楼	教室名称	开放课堂数	正常课堂率	正常课堂数	异常课堂数	异常情况说明
			//第二集
			if(twoListMap.containsKey(monitorLog.getJxlName() + monitorLog.getJsmc())){
				//存在，累计数
				TwoListClass o = twoListMap.get(monitorLog.getJxlName() + monitorLog.getJsmc());
				String key = monitorLog.getJxlName() + monitorLog.getJsmc() + monitorLog.getHh() +  monitorLog.getKtId();
				Map<String, TwoYcListClass> twoYcListClassMap = o.getYcMap();
				if(twoYcListClassMap.containsKey(key)){
					TwoYcListClass twoYcListClass = twoYcListClassMap.get(key);
					//累计次数
					twoYcListClass.addJccs(1);
					if(monitorLog.getLogType() == null || monitorLog.getLogType() != 1){
						//累加失败次数
						twoYcListClass.addYccs(1);
					}
				}else {
					TwoYcListClass twoYcListClass = new TwoYcListClass();
					twoYcListClass.setYcHh(getHhName(monitorLog.getHh()));//异常节次
					twoYcListClass.setYcKcmc(monitorLog.getKtName());//异常课程名称
					twoYcListClass.setYcDate(formatDate(monitorLog.getCreateTime(), "yyyy-MM-dd"));
					twoYcListClass.setJccs(1);//累计次数
					if(monitorLog.getLogType() != null && monitorLog.getLogType() == 1){
						twoYcListClass.setYccs(0);//异常次数
					}else{
						twoYcListClass.setYccs(1);//异常次数
					}
//					o.getYclList().add();//异常率
					twoYcListClassMap.put(key,twoYcListClass);
				}
				if(monitorLog.getLogType() != null && monitorLog.getLogType() == 1){
					o.addZckts(1);//正常课堂数
				}else{
					o.addYckts(1);//异常课堂数
					//ycqksm;//异常情况说明
				}
				o.addKfkts(1);
			}else{
				TwoListClass o = new TwoListClass();
				o.setJxl(monitorLog.getJxlName());
				o.setJsmc(monitorLog.getJsmc());
				o.setKfkts(1);
//				o.setZcktl(0);
				o.setZckts(0);
				o.setYckts(0);


				String key = monitorLog.getJxlName() + monitorLog.getJsmc() + monitorLog.getHh() +  monitorLog.getKtId();
				Map<String, TwoYcListClass> twoYcListClassMap = o.getYcMap();
				if(twoYcListClassMap.containsKey(key)){
					TwoYcListClass twoYcListClass = twoYcListClassMap.get(key);
					//累计次数
					twoYcListClass.addJccs(1);
					if(monitorLog.getLogType() == null || monitorLog.getLogType() != 1){
						//累加失败次数
						twoYcListClass.addYccs(1);
					}
				}else {
					TwoYcListClass twoYcListClass = new TwoYcListClass();
					twoYcListClass.setYcHh(getHhName(monitorLog.getHh()));//异常节次
					twoYcListClass.setYcKcmc(monitorLog.getKtName());//异常课程名称
					twoYcListClass.setYcDate(formatDate(monitorLog.getCreateTime(), "yyyy-MM-dd"));
					twoYcListClass.setJccs(1);//累计次数
					if(monitorLog.getLogType() != null && monitorLog.getLogType() == 1){
						twoYcListClass.setYccs(0);//异常次数
					}else{
						twoYcListClass.setYccs(1);//异常次数
					}
					twoYcListClassMap.put(key,twoYcListClass);
				}
				//zcktl;//正常课堂率
				if(monitorLog.getLogType() != null && monitorLog.getLogType() == 1){
					o.setZckts(1);//正常课堂数
				}else{
					o.setYckts(1);//异常课堂数
					//ycqksm;//异常情况说明
				}
				twoListMap.put(monitorLog.getJxlName() + monitorLog.getJsmc(),o);
			}
		}

		jxls = jxlsSet.size();
		jss = jssSet.size();
		djs = djsSet.size();

		if(yckts != 0){
			zcl = getPercentage(new BigDecimal(zckts),new BigDecimal((yckts)));
		}


		//********************************取数据END*********************************************************/
		//********************************通用*************************************************************/
//		String today= DateUtil.today();
		String now = DateUtil.now();
		result.put("监测时间", kcZhihuijiaoshiMonitorLog.getStartTime() + " - " + kcZhihuijiaoshiMonitorLog.getEndTime());
		result.put("监测教学楼", kcZhihuijiaoshiMonitorLog.getJxlName());
		result.put("打印时间",now);
		result.put("教学楼数", String.valueOf(jxls));
		result.put("教室数", String.valueOf(jss));
		//result.put("大节数", String.valueOf(djs));
		result.put("大节数", String.valueOf(zckts + yckts));
		result.put("运行正常课堂", String.valueOf(zckts));
		result.put("运行异常课堂", String.valueOf(yckts));
		result.put("正常率", String.valueOf(zcl.floatValue()));

		//********************************表头END**********************************************************/
		wo.replaceTextPlus(result);
		//********************************@A.单个内容替换END**************************************************/
//		final int[] index = { 2 };
		List<List<String>> mainList = Lists.newArrayList();

		Map<String,Map<String,OneListClass>> oneListMapMap = Maps.newHashMap();

		for (String key: oneListMap.keySet()){
			OneListClass o = oneListMap.get(key);
			if(oneListMapMap.containsKey(o.getJxlName())){
				Map<String,OneListClass> m = oneListMapMap.get(o.getJxlName());
				m.put(o.getHhName(),o);
			}else{
				Map<String,OneListClass> m = Maps.newHashMap();
				m.put(o.getHhName(),o);
				oneListMapMap.put(o.getJxlName(),m);
			}
		}
		List<BigDecimal> sumList = Lists.newArrayList();
		sumList.add(new BigDecimal("0"));
		sumList.add(new BigDecimal("0"));
		sumList.add(new BigDecimal("0"));

		sumList.add(new BigDecimal("0"));
		sumList.add(new BigDecimal("0"));

		sumList.add(new BigDecimal("0"));
		sumList.add(new BigDecimal("0"));

		sumList.add(new BigDecimal("0"));
		sumList.add(new BigDecimal("0"));

		sumList.add(new BigDecimal("0"));
		sumList.add(new BigDecimal("0"));

		sumList.add(new BigDecimal("0"));
		sumList.add(new BigDecimal("0"));

		sumList.add(new BigDecimal("0"));
		sumList.add(new BigDecimal("0"));

		for (String key: oneListMapMap.keySet()){
			Map<String,OneListClass> m = oneListMapMap.get(key);
			OneListClass all = new OneListClass();
			OneListClass one = new OneListClass();
			OneListClass two = new OneListClass();
			OneListClass three = new OneListClass();
			OneListClass four = new OneListClass();
			OneListClass five = new OneListClass();
			OneListClass six = new OneListClass();

			for (String mkey: m.keySet()){
				OneListClass o = m.get(mkey);
				switch (o.getHhName()){
					case "第一大节": {
						all.setJxlName(o.getJxlName());
						all.addKfnum(o.getKfnum());
						all.addZcnum(o.getZcnum());
						all.addYcnum(o.getYcnum());
						one.setKfnum(isNull(o.getKfnum()));
						one.setZcnum(isNull(o.getZcnum()));
						one.setYcnum(isNull(o.getYcnum()));
						break;
					}
					case "第二大节": {
						all.setJxlName(o.getJxlName());
						all.addKfnum(o.getKfnum());
						all.addZcnum(o.getZcnum());
						all.addYcnum(o.getYcnum());
						two.setKfnum(isNull(o.getKfnum()));
						two.setZcnum(isNull(o.getZcnum()));
						two.setYcnum(isNull(o.getYcnum()));
						break;
					}
					case "第三大节": {
						all.setJxlName(o.getJxlName());
						all.addKfnum(o.getKfnum());
						all.addZcnum(o.getZcnum());
						all.addYcnum(o.getYcnum());
						three.setKfnum(isNull(o.getKfnum()));
						three.setZcnum(isNull(o.getZcnum()));
						three.setYcnum(isNull(o.getYcnum()));
						break;
					}
					case "第四大节": {
						all.setJxlName(o.getJxlName());
						all.addKfnum(o.getKfnum());
						all.addZcnum(o.getZcnum());
						all.addYcnum(o.getYcnum());
						four.setKfnum(isNull(o.getKfnum()));
						four.setZcnum(isNull(o.getZcnum()));
						four.setYcnum(isNull(o.getYcnum()));
						break;
					}
					case "第五大节": {
						all.setJxlName(o.getJxlName());
						all.addKfnum(o.getKfnum());
						all.addZcnum(o.getZcnum());
						all.addYcnum(o.getYcnum());
						five.setKfnum(isNull(o.getKfnum()));
						five.setZcnum(isNull(o.getZcnum()));
						five.setYcnum(isNull(o.getYcnum()));
						break;
					}
					case "第六大节": {
						all.setJxlName(o.getJxlName());
						all.addKfnum(o.getKfnum());
						all.addZcnum(o.getZcnum());
						all.addYcnum(o.getYcnum());
						six.setKfnum(isNull(o.getKfnum()));
						six.setZcnum(isNull(o.getZcnum()));
						six.setYcnum(isNull(o.getYcnum()));
						break;
					}
				}
			}
			List<String> list = Lists.newArrayList();
			list.add(all.getJxlName());
			if(all.getYcnum() != 0){
				BigDecimal num = getPercentage(new BigDecimal(all.getZcnum()), new BigDecimal(all.getYcnum()));
				list.add(num.toString());
			}else{
				list.add("100");
			}
			list.add(String.valueOf(all.getKfnum()));
			list.add(String.valueOf(all.getZcnum()));
			list.add(String.valueOf(all.getYcnum()));
			sumList.set(0,sumList.get(0).add(new BigDecimal(all.getKfnum())));
			sumList.set(1,sumList.get(1).add(new BigDecimal(all.getZcnum())));
			sumList.set(2,sumList.get(2).add(new BigDecimal(all.getYcnum())));

			list.add(String.valueOf(one.getZcnum()));
			list.add(String.valueOf(one.getYcnum()));
			sumList.set(3,sumList.get(3).add(new BigDecimal(one.getZcnum())));
			sumList.set(4,sumList.get(4).add(new BigDecimal(one.getYcnum())));

			list.add(String.valueOf(two.getZcnum()));
			list.add(String.valueOf(two.getYcnum()));
			sumList.set(5,sumList.get(5).add(new BigDecimal(two.getZcnum())));
			sumList.set(6,sumList.get(6).add(new BigDecimal(two.getYcnum())));

			list.add(String.valueOf(three.getZcnum()));
			list.add(String.valueOf(three.getYcnum()));
			sumList.set(7,sumList.get(7).add(new BigDecimal(three.getZcnum())));
			sumList.set(8,sumList.get(8).add(new BigDecimal(three.getYcnum())));

			list.add(String.valueOf(four.getZcnum()));
			list.add(String.valueOf(four.getYcnum()));
			sumList.set(9,sumList.get(9).add(new BigDecimal(four.getZcnum())));
			sumList.set(10,sumList.get(10).add(new BigDecimal(four.getYcnum())));

			list.add(String.valueOf(five.getZcnum()));
			list.add(String.valueOf(five.getYcnum()));
			sumList.set(11,sumList.get(11).add(new BigDecimal(five.getZcnum())));
			sumList.set(12,sumList.get(12).add(new BigDecimal(five.getYcnum())));

			list.add(String.valueOf(six.getZcnum()));
			list.add(String.valueOf(six.getYcnum()));
			sumList.set(13,sumList.get(13).add(new BigDecimal(six.getZcnum())));
			sumList.set(14,sumList.get(14).add(new BigDecimal(six.getYcnum())));

			mainList.add(list);
		}
		if(!oneListMapMap.keySet().isEmpty()){
			List<String> sumRowlist = Lists.newArrayList();
			sumRowlist.add("合计");
			sumRowlist.add("0");//正常率
			for (BigDecimal sumNum: sumList){
				sumRowlist.add(dfzf(sumNum));
			}
			//计算百分比
			sumRowlist.set(1,dfzdzzf(getPercentage(sumList.get(1), sumList.get(2))));
			mainList.add(sumRowlist);
		}

		wo.insert2Table(0, 2, true, mainList);
//		index[0] += mainList.size() + 2;
		mainList.clear();

		Map<String, Object> result2 = Maps.newHashMap();
		 Map<String, Integer> jxlMap = Maps.newHashMap();
		for (String key: mainLogMap.keySet()) {
			KcZhihuijiaoshiMonitorLog o = mainLogMap.get(key);
			String skey = o.getJsmc();
			if(jxlMap.containsKey(skey)){
				Integer num = jxlMap.get(skey);
				num = num+1;
				jxlMap.put(skey,num);
			}else{
				jxlMap.put(skey,1);
			}

		}



		int rowIndex = 1;
		for (String key: twoListMap.keySet()){
			TwoListClass o = twoListMap.get(key);
			List<String> list = Lists.newArrayList();
			//教学楼	教室名称	开放课堂数	正常课堂率	正常课堂数	异常课堂数	异常情况说明
			list.add(o.getJxl());
			list.add(o.getJsmc());

			TwoListClass numO = jsNumMap.get(o.getJsmc());
			if(numO == null) numO = new TwoListClass();
			list.add(StringUtils.defaultString(String.valueOf(numO.getKfkts()),"0"));
			list.add(StringUtils.defaultString(String.valueOf(numO.getZcktl().toString()),"0"));
			list.add(StringUtils.defaultString(String.valueOf(numO.getZckts()),"0"));
			list.add(StringUtils.defaultString(String.valueOf(numO.getYckts()),"0"));
			//1.异常节次： 异常课程：  监测次数：  异常次数：  异常率：
//			Integer jccs = 0;
//
//			for (Integer x: o.getJccsList()){
//				if(x == null) x = 0;
//				jccs += x;
//			}
//			Integer yccs = 0;
////			for (Integer x: o.getYccsList()){
////				if(x == null) x = 0;
////				yccs += x;
////			}
//			yccs = o.getYckts();
//			String ycl = getPercentageByAll(new BigDecimal(yccs),new BigDecimal(o.getKfkts())).toString();

//			String sm = "1.异常节次："+ArrayUtil.join(o.getYcHhList().toArray(new String[]{}),",")+" 异常课程："+ArrayUtil.join(o.getYcKcmcList().toArray(new String[]{}),",")+" 监测次数："+jccs+" 异常次数："+yccs+" 异常率："+ycl;
			StringBuilder sm = new StringBuilder();
			Map<String, TwoYcListClass> twoYcListClassMap = o.getYcMap();
			int i = 1;
			List<TwoYcListClass> nextBlockList = twoYcListClassMap.values().stream().filter(x -> x.getYccs() !=0).collect(Collectors.toList());
			for(TwoYcListClass twoYcListClass: nextBlockList){
				sm.append(i);
				sm.append(".异常节次：");
				sm.append(twoYcListClass.getYcHh());
				sm.append("(");
				sm.append(twoYcListClass.getYcDate());
				sm.append(")");
				sm.append(" 异常课程：");
				sm.append(twoYcListClass.getYcKcmc());
				sm.append(" 监测次数：");
				sm.append(twoYcListClass.getJccs());
				sm.append(" 异常次数：");
				sm.append(twoYcListClass.getYccs());
				sm.append(" 异常率：");
				//计算！
				sm.append(getPercentageByAll(new BigDecimal(twoYcListClass.getYccs()),new BigDecimal(twoYcListClass.getJccs())));
				sm.append("\n");
				i++;

			}

			if(nextBlockList.isEmpty()){
				sm.append("\n");
			}

//			String sm = "1.异常节次："+ArrayUtil.join(o.getYcHhList().toArray(new String[]{}),",")+" 异常课程："+ArrayUtil.join(o.getYcKcmcList().toArray(new String[]{}),",")+" 监测次数："+jccs+" 异常次数："+yccs+" 异常率："+ycl;
			//list.add(o.getYcqksm());

			String listKey = "{" + rowIndex + "List}";
			result2.put(rowIndex + "List",sm.toString());
			list.add(listKey);
			mainList.add(list);
			rowIndex++;
		}

//		List<String> list = Lists.newArrayList();
//		list.add("楼1");
//		list.add("11");
//		list.add("22");
//		mainList.add(list);

		//WordOperator.fillNullCall(mainList,mainList);
		//从固定位置开始添加（1为第二个表格，第二个1为固定位置）
//		wo.insert2Table(0, index[0], true, mainList);
		wo.insert2Table(1, 1, true, mainList);
//		index[0] += mainList.size() + 2;
		mainList.clear();



		wo = WordOperator.twoReplaceWord(wo);

		wo.replaceTextPlus(result2);

		//第二列表 最后一行拼接 1.异常节次： 异常课程：  监测次数：  异常次数：  异常率
		return wo;
	}
}
