package org.jeecg.modules.kc.kcErrorreport.entity;

import java.io.Serializable;
import java.io.UnsupportedEncodingException;
import java.util.Date;
import java.math.BigDecimal;

import com.baomidou.mybatisplus.annotation.*;
import lombok.Data;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;
import org.jeecgframework.poi.excel.annotation.Excel;
import org.jeecg.common.aspect.annotation.Dict;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * @Description: kc_errorreport
 * @Author: jeecg-boot
 * @Date:   2023-04-05
 * @Version: V1.0
 */
@Data
@TableName("kc_errorreport")
@Accessors(chain = true)
@EqualsAndHashCode(callSuper = false)
@ApiModel(value="kc_errorreport对象", description="kc_errorreport")
public class KcErrorreport implements Serializable {
    private static final long serialVersionUID = 1L;

	/**id*/
	@TableId(type = IdType.ASSIGN_ID)
    @ApiModelProperty(value = "id")
    private java.lang.String id;
	/**报错人*/
	@Excel(name = "报错人", width = 15)
    @ApiModelProperty(value = "报错人")
    private java.lang.String subper;
	/**错误类型*/
	@Excel(name = "错误类型", width = 15, dicCode = "optionsradios")
	@Dict(dicCode = "optionsradios")
    @ApiModelProperty(value = "错误类型")
    private java.lang.String optionsradios;
	/**会议号*/
	@Excel(name = "会议号", width = 15)
    @ApiModelProperty(value = "会议号")
    private java.lang.String meetingnum;
	/**会议密码*/
	@Excel(name = "会议密码", width = 15)
    @ApiModelProperty(value = "会议密码")
    private java.lang.String meetingpsw;
	/**会议邀请链接*/
	@Excel(name = "会议邀请链接", width = 15)
    @ApiModelProperty(value = "会议邀请链接")
    private java.lang.String meetinglink;
	/**错误信息描述*/
	@Excel(name = "错误信息描述", width = 15)
    @ApiModelProperty(value = "错误信息描述")
    private java.lang.String errortext;
	/**报错时间*/
	@Excel(name = "报错时间", width = 15)
    @ApiModelProperty(value = "报错时间")
    private java.lang.String reportstime;
	/**处理状态*/
	@Excel(name = "处理状态", width = 15)
    @ApiModelProperty(value = "处理状态")
    private java.lang.Integer reportstatus;
	/**课程表ID*/
	@Excel(name = "课程表ID", width = 15)
    @ApiModelProperty(value = "课程表ID")
    private java.lang.Integer kechengbiaoid;
	/**账号ID*/
	@Excel(name = "账号ID", width = 15)
    @ApiModelProperty(value = "账号ID")
    private java.lang.String userid;
	/**账号姓名*/
	@Excel(name = "账号姓名", width = 15)
    @ApiModelProperty(value = "账号姓名")
    private java.lang.String username;
	/**修改类型：0-本堂课修改，1-*/
	@Excel(name = "修改类型：0-本堂课修改，1-", width = 15, dicCode = "edittype")
	@Dict(dicCode = "edittype")
    @ApiModelProperty(value = "修改类型：0-本堂课修改，1-")
    private java.lang.Integer edittype;
	/**是否修改：0-未修改，1-已修改*/
	@Excel(name = "是否修改：0-未修改，1-已修改", width = 15)
    @ApiModelProperty(value = "是否修改：0-未修改，1-已修改")
    private java.lang.Integer ismodified;
	/**课程的上课日期*/
	@Excel(name = "课程的上课日期", width = 15)
    @ApiModelProperty(value = "课程的上课日期")
    private java.lang.String skrq;
	/**是否出镜，0-出镜，1-不出镜*/
	@Excel(name = "是否出镜，0-出镜，1-不出镜", width = 15)
    @ApiModelProperty(value = "是否出镜，0-出镜，1-不出镜")
    @Dict(dicCode = "sfcj")
    private java.lang.Integer sfcj;
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "创建日期")
    private java.util.Date createTime;


    @TableField(exist = false)
    private java.lang.String college;
    @TableField(exist = false)
    private java.lang.String kcmc;
    @TableField(exist = false)
    private java.lang.String kkdw;
    @TableField(exist = false)
    private java.lang.String ktskrq;
    @TableField(exist = false)
    private java.lang.String hh;
    @TableField(exist = false)
    @Dict(dicCode = "sfcj")
    private java.lang.String ktbsfcj;
    @TableField(exist = false)
    private java.lang.String startTime;
    @TableField(exist = false)
    private java.lang.String endTime;
    @TableField(exist = false)
    private java.lang.String szdw;



}
