package org.jeecg.modules.kc.kcEvaluationsHisrecord.entity;

import java.io.Serializable;
import java.io.UnsupportedEncodingException;
import java.util.Date;
import java.math.BigDecimal;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.TableLogic;
import lombok.Data;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;
import org.jeecgframework.poi.excel.annotation.Excel;
import org.jeecg.common.aspect.annotation.Dict;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * @Description: 历史听课数据
 * @Author: jeecg-boot
 * @Date:   2024-04-16
 * @Version: V1.0
 */
@Data
@TableName("kc_evaluations_hisrecord")
@Accessors(chain = true)
@EqualsAndHashCode(callSuper = false)
@ApiModel(value="kc_evaluations_hisrecord对象", description="历史听课数据")
public class KcEvaluationsHisrecord implements Serializable {
    private static final long serialVersionUID = 1L;

    private String id;
	/**学年学期*/
	@Excel(name = "学年学期", width = 15)
    @ApiModelProperty(value = "学年学期")
    private java.lang.String xnxq;
	/**课程编号*/
	@Excel(name = "课程编号", width = 15)
    @ApiModelProperty(value = "课程编号")
	@TableId
    private java.lang.String kcbh;
	/**课程名称*/
	@Excel(name = "课程名称", width = 15)
    @ApiModelProperty(value = "课程名称")
    private java.lang.String kcmc;
	/**开课院系*/
	@Excel(name = "开课院系", width = 15)
    @ApiModelProperty(value = "开课院系")
    private java.lang.String kkdw;
	/**上课教师*/
	@Excel(name = "上课教师", width = 15)
    @ApiModelProperty(value = "上课教师")
    private java.lang.String skjs;
	/**听课教师*/
	@Excel(name = "听课教师", width = 15)
    @ApiModelProperty(value = "听课教师")
    private java.lang.String tkjs;
	/**课堂教学总体印象评价（综合评分）*/
	@Excel(name = "课堂教学总体印象评价（综合评分）", width = 15)
    @ApiModelProperty(value = "课堂教学总体印象评价（综合评分）")
    private java.lang.String col01;
	/**无迟到、早退、旷课现象（学生情况）*/
	@Excel(name = "无迟到、早退、旷课现象（学生情况）", width = 15)
    @ApiModelProperty(value = "无迟到、早退、旷课现象（学生情况）")
    private java.lang.String col02;
	/**课堂教学秩序好、无喧闹、打瞌睡、发短信、玩手机等现象（学生情况）*/
	@Excel(name = "课堂教学秩序好、无喧闹、打瞌睡、发短信、玩手机等现象（学生情况）", width = 15)
    @ApiModelProperty(value = "课堂教学秩序好、无喧闹、打瞌睡、发短信、玩手机等现象（学生情况）")
    private java.lang.String col03;
	/**上课认真听讲、积极思考，主动与老师交流互动（学生情况）*/
	@Excel(name = "上课认真听讲、积极思考，主动与老师交流互动（学生情况）", width = 15)
    @ApiModelProperty(value = "上课认真听讲、积极思考，主动与老师交流互动（学生情况）")
    private java.lang.String col04;
	/**讲课有热情、精神饱满，能够调动学生情绪，课堂气氛活跃（教师情况）*/
	@Excel(name = "讲课有热情、精神饱满，能够调动学生情绪，课堂气氛活跃（教师情况）", width = 15)
    @ApiModelProperty(value = "讲课有热情、精神饱满，能够调动学生情绪，课堂气氛活跃（教师情况）")
    private java.lang.String col05;
	/**教学目标明确，内容丰富，重点突出，语言表达清楚（教师情况）*/
	@Excel(name = "教学目标明确，内容丰富，重点突出，语言表达清楚（教师情况）", width = 15)
    @ApiModelProperty(value = "教学目标明确，内容丰富，重点突出，语言表达清楚（教师情况）")
    private java.lang.String col06;
	/**授课有启发性，能给予学生思考、联想、创新的启迪（教师情况）*/
	@Excel(name = "授课有启发性，能给予学生思考、联想、创新的启迪（教师情况）", width = 15)
    @ApiModelProperty(value = "授课有启发性，能给予学生思考、联想、创新的启迪（教师情况）")
    private java.lang.String col07;
	/**能有效利用各种教学媒体，课件或板书使用效果好（教师情况）*/
	@Excel(name = "能有效利用各种教学媒体，课件或板书使用效果好（教师情况）", width = 15)
    @ApiModelProperty(value = "能有效利用各种教学媒体，课件或板书使用效果好（教师情况）")
    private java.lang.String col08;
	/**仪表得体，按时上下课，严格要求学生（教师情况）*/
	@Excel(name = "仪表得体，按时上下课，严格要求学生（教师情况）", width = 15)
    @ApiModelProperty(value = "仪表得体，按时上下课，严格要求学生（教师情况）")
    private java.lang.String col09;
	/**意见或建议*/
	@Excel(name = "意见或建议", width = 15)
    @ApiModelProperty(value = "意见或建议")
    private java.lang.String col10;
	/**数据来源*/
	@Excel(name = "数据来源", width = 15)
    @ApiModelProperty(value = "数据来源")
    private java.lang.String source;
}
