package org.jeecg.modules.kc.kcEvaluationsStat.controller;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.lang3.StringUtils;
import org.apache.shiro.SecurityUtils;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.system.vo.LoginUser;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.kc.grab.imports.entity.Xxhbuser;
import org.jeecg.modules.kc.grab.imports.service.IXxhbuserService;
import org.jeecg.modules.kc.kcEvaluationsStat.entity.KcEvaluationsStat;
import org.jeecg.modules.kc.kcEvaluationsStat.service.IKcEvaluationsStatService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecg.modules.system.service.impl.SysBaseApiImpl;
import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

 /**
 * @Description: kc_evaluations_stat
 * @Author: jeecg-boot
 * @Date:   2023-08-22
 * @Version: V1.0
 */
@Api(tags="kc_evaluations_stat")
@RestController
@RequestMapping("/kcEvaluationsStat/kcEvaluationsStat")
@Slf4j
public class KcEvaluationsStatController extends JeecgController<KcEvaluationsStat, IKcEvaluationsStatService> {
	@Autowired
	private IKcEvaluationsStatService kcEvaluationsStatService;
	 @Autowired
	 private IXxhbuserService xxhbuserService;

	 @Autowired
	 private SysBaseApiImpl sysBaseApi;

	 @Value("${jeecg.path.upload}")
	 private String upLoadPath;
	/**
	 * 分页列表查询
	 *
	 * @param kcEvaluationsStat
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "kc_evaluations_stat-分页列表查询")
	@ApiOperation(value="kc_evaluations_stat-分页列表查询", notes="kc_evaluations_stat-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<KcEvaluationsStat>> queryPageList(KcEvaluationsStat kcEvaluationsStat,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		if(StringUtils.isNotBlank(kcEvaluationsStat.getCol13())){
			kcEvaluationsStat.setCol13("*"+kcEvaluationsStat.getCol13()+"*");
		}

		LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
		System.out.println("--->"+JSON.toJSONString(sysUser));

		List<String> roleList = sysBaseApi.getRolesByUsername(sysUser.getUsername());
		String adminRole = "1";//0 admin  1教务秘书
		for(String role :roleList){
			if(org.apache.commons.lang.StringUtils.equals("admin",role)){
				adminRole = "0";
				break;
			}
		}

		QueryWrapper<KcEvaluationsStat> queryWrapper = QueryGenerator.initQueryWrapper("a",kcEvaluationsStat, req.getParameterMap());
		if(StringUtils.isNotBlank(kcEvaluationsStat.getSzkc())){
			String szkc = kcEvaluationsStat.getSzkc();
			if(StringUtils.equals("1",szkc)){
				queryWrapper.eq("col59","是");
			}else if(StringUtils.equals("0",szkc)){
				queryWrapper.eq("col59","否");
			}
		}
		if(StringUtils.equals("1",adminRole)){
			QueryWrapper<Xxhbuser> xxhbuserQueryWrapper = new QueryWrapper<>();
			xxhbuserQueryWrapper.eq("gh",sysUser.getUsername());
			xxhbuserQueryWrapper.last("limit 1");
			Xxhbuser xxhbuser = xxhbuserService.getOne(xxhbuserQueryWrapper);
			queryWrapper.eq("col10",xxhbuser.getDwmc());
		}
		queryWrapper.eq(StringUtils.isNotBlank(kcEvaluationsStat.getSkjsdw()),"b.dwmc",kcEvaluationsStat.getSkjsdw());

//		queryWrapper.eq(StringUtils.isNotBlank(kcEvaluationsStat.getSzkc()),"c.szkc",kcEvaluationsStat.getSzkc());
		Page<KcEvaluationsStat> page = new Page<KcEvaluationsStat>(pageNo, pageSize);
		IPage<KcEvaluationsStat> pageList = kcEvaluationsStatService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param kcEvaluationsStat
	 * @return
	 */
	@AutoLog(value = "kc_evaluations_stat-添加")
	@ApiOperation(value="kc_evaluations_stat-添加", notes="kc_evaluations_stat-添加")
	@RequiresPermissions("kcEvaluationsStat:kc_evaluations_stat:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody KcEvaluationsStat kcEvaluationsStat) {
		kcEvaluationsStatService.save(kcEvaluationsStat);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param kcEvaluationsStat
	 * @return
	 */
	@AutoLog(value = "kc_evaluations_stat-编辑")
	@ApiOperation(value="kc_evaluations_stat-编辑", notes="kc_evaluations_stat-编辑")
	@RequiresPermissions("kcEvaluationsStat:kc_evaluations_stat:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody KcEvaluationsStat kcEvaluationsStat) {
		kcEvaluationsStatService.updateById(kcEvaluationsStat);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "kc_evaluations_stat-通过id删除")
	@ApiOperation(value="kc_evaluations_stat-通过id删除", notes="kc_evaluations_stat-通过id删除")
	@RequiresPermissions("kcEvaluationsStat:kc_evaluations_stat:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		kcEvaluationsStatService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "kc_evaluations_stat-批量删除")
	@ApiOperation(value="kc_evaluations_stat-批量删除", notes="kc_evaluations_stat-批量删除")
	@RequiresPermissions("kcEvaluationsStat:kc_evaluations_stat:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.kcEvaluationsStatService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "kc_evaluations_stat-通过id查询")
	@ApiOperation(value="kc_evaluations_stat-通过id查询", notes="kc_evaluations_stat-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<KcEvaluationsStat> queryById(@RequestParam(name="id",required=true) String id) {
		KcEvaluationsStat kcEvaluationsStat = kcEvaluationsStatService.getById(id);
		if(kcEvaluationsStat==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(kcEvaluationsStat);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param kcEvaluationsStat
    */
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, KcEvaluationsStat kcEvaluationsStat) {
		if(StringUtils.isNotBlank(kcEvaluationsStat.getCol13())){
			kcEvaluationsStat.setCol13("*"+kcEvaluationsStat.getCol13()+"*");
		}
        return exportXls(request, kcEvaluationsStat, KcEvaluationsStat.class, "全量评价表");
    }

	 protected ModelAndView exportXls(HttpServletRequest request, KcEvaluationsStat kcEvaluationsStat, Class<KcEvaluationsStat> clazz, String title) {
		 // Step.1 组装查询条件
		 QueryWrapper<KcEvaluationsStat> queryWrapper = QueryGenerator.initQueryWrapper("a",kcEvaluationsStat, request.getParameterMap());
//		 LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
//		 queryWrapper.eq(StringUtils.isNotBlank(object.getSzkc()),"a.col59",object.getSzkc());
//		 queryWrapper.eq(StringUtils.isNotBlank(object.getSzkc()),"b.dwmc",object.getSkjsdw());
//
//		 if(StringUtils.isNotBlank(kcEvaluationsStat.getCol13())){
//			 kcEvaluationsStat.setCol13("*"+kcEvaluationsStat.getCol13()+"*");
//		 }
//
		 LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
		 List<String> roleList = sysBaseApi.getRolesByUsername(sysUser.getUsername());
		 String adminRole = "1";//0 admin  1教务秘书
		 for(String role :roleList){
			 if(org.apache.commons.lang.StringUtils.equals("admin",role)){
				 adminRole = "0";
				 break;
			 }
		 }

//		 QueryWrapper<KcEvaluationsStat> queryWrapper = QueryGenerator.initQueryWrapper("a",kcEvaluationsStat, request.getParameterMap());
		 if(StringUtils.isNotBlank(kcEvaluationsStat.getSzkc())){
			 String szkc = kcEvaluationsStat.getSzkc();
			 if(StringUtils.equals("1",szkc)){
				 queryWrapper.eq("col59","是");
			 }else if(StringUtils.equals("0",szkc)){
				 queryWrapper.eq("col59","否");
			 }
		 }
		 if(StringUtils.equals("1",adminRole)){
			 QueryWrapper<Xxhbuser> xxhbuserQueryWrapper = new QueryWrapper<>();
			 xxhbuserQueryWrapper.eq("gh",sysUser.getUsername());
			 xxhbuserQueryWrapper.last("limit 1");
			 Xxhbuser xxhbuser = xxhbuserService.getOne(xxhbuserQueryWrapper);
			 queryWrapper.eq("col10",xxhbuser.getDwmc());
		 }
		 queryWrapper.eq(StringUtils.isNotBlank(kcEvaluationsStat.getSkjsdw()),"b.dwmc",kcEvaluationsStat.getSkjsdw());

//		queryWrapper.eq(StringUtils.isNotBlank(kcEvaluationsStat.getSzkc()),"c.szkc",kcEvaluationsStat.getSzkc());
//		 Page<KcEvaluationsStat> page = new Page<KcEvaluationsStat>(pageNo, pageSize);
//		 IPage<KcEvaluationsStat> pageList = kcEvaluationsStatService.page(page, queryWrapper);

		 // Step.2 获取导出数据
		 List<KcEvaluationsStat> exportList = kcEvaluationsStatService.list(queryWrapper);

		 // Step.3 AutoPoi 导出Excel
		 ModelAndView mv = new ModelAndView(new JeecgEntityExcelView());
		 //此处设置的filename无效 ,前端会重更新设置一下
		 mv.addObject(NormalExcelConstants.FILE_NAME, title);
		 mv.addObject(NormalExcelConstants.CLASS, clazz);
		 //update-begin--Author:liusq  Date:20210126 for：图片导出报错，ImageBasePath未设置--------------------
		 ExportParams  exportParams=new ExportParams(title + "报表", "导出人:" + sysUser.getRealname(), title);
		 exportParams.setImageBasePath(upLoadPath);
		 //update-end--Author:liusq  Date:20210126 for：图片导出报错，ImageBasePath未设置----------------------
		 mv.addObject(NormalExcelConstants.PARAMS,exportParams);
		 mv.addObject(NormalExcelConstants.DATA_LIST, exportList);
		 return mv;
	 }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("kcEvaluationsStat:kc_evaluations_stat:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, KcEvaluationsStat.class);
    }

}
