package org.jeecg.modules.kc.kcGongkaike.controller;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.lang3.StringUtils;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.kc.kcGongkaike.entity.KcGongkaike;
import org.jeecg.modules.kc.kcGongkaike.service.IKcGongkaikeService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecg.modules.kc.kcSysConfig.entity.KcSysConfig;
import org.jeecg.modules.kc.kcSysConfig.service.IKcSysConfigService;
import org.jeecg.modules.kc.kcXqxnHistory.entity.KcXqxnHistory;
import org.jeecg.modules.kc.kcXqxnHistory.service.IKcXqxnHistoryService;
import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

 /**
 * @Description: kc_gongkaike
 * @Author: jeecg-boot
 * @Date:   2023-04-06
 * @Version: V1.0
 */
@Api(tags="kc_gongkaike")
@RestController
@RequestMapping("/kcGongkaike/kcGongkaike")
@Slf4j
public class KcGongkaikeController extends JeecgController<KcGongkaike, IKcGongkaikeService> {
	@Autowired
	private IKcGongkaikeService kcGongkaikeService;

	 @Autowired
	 private IKcSysConfigService kcSysConfigService;

	 @Autowired
	 private IKcXqxnHistoryService kcXqxnHistoryService;
	/**
	 * 分页列表查询
	 *
	 * @param kcGongkaike
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "kc_gongkaike-分页列表查询")
	@ApiOperation(value="kc_gongkaike-分页列表查询", notes="kc_gongkaike-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<KcGongkaike>> queryPageList(KcGongkaike kcGongkaike,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<KcGongkaike> queryWrapper = QueryGenerator.initQueryWrapper(kcGongkaike, req.getParameterMap());
		Page<KcGongkaike> page = new Page<KcGongkaike>(pageNo, pageSize);
		IPage<KcGongkaike> pageList = kcGongkaikeService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param kcGongkaike
	 * @return
	 */
	@AutoLog(value = "kc_gongkaike-添加")
	@ApiOperation(value="kc_gongkaike-添加", notes="kc_gongkaike-添加")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody KcGongkaike kcGongkaike) {
		kcGongkaikeService.save(kcGongkaike);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param kcGongkaike
	 * @return
	 */
	@AutoLog(value = "kc_gongkaike-编辑")
	@ApiOperation(value="kc_gongkaike-编辑", notes="kc_gongkaike-编辑")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody KcGongkaike kcGongkaike) {
		kcGongkaikeService.updateById(kcGongkaike);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "kc_gongkaike-通过id删除")
	@ApiOperation(value="kc_gongkaike-通过id删除", notes="kc_gongkaike-通过id删除")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		kcGongkaikeService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "kc_gongkaike-批量删除")
	@ApiOperation(value="kc_gongkaike-批量删除", notes="kc_gongkaike-批量删除")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.kcGongkaikeService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "kc_gongkaike-通过id查询")
	@ApiOperation(value="kc_gongkaike-通过id查询", notes="kc_gongkaike-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<KcGongkaike> queryById(@RequestParam(name="id",required=true) String id) {
		KcGongkaike kcGongkaike = kcGongkaikeService.getById(id);
		if(kcGongkaike==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(kcGongkaike);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param kcGongkaike
    */
    @RequiresPermissions("kcGongkaike:kc_gongkaike:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, KcGongkaike kcGongkaike) {
        return super.exportXls(request, kcGongkaike, KcGongkaike.class, "kc_gongkaike");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("kcGongkaike:kc_gongkaike:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, KcGongkaike.class);
    }


	 @GetMapping(value = "/getIndexList")
	 public Result<IPage<KcGongkaike>> getIndexList(KcGongkaike kcGongkaike,
													 @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
													 @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
													 HttpServletRequest req) {
		String xnxq = kcGongkaike.getXnxq();

		 QueryWrapper<KcGongkaike> queryWrapper = QueryGenerator.initQueryWrapper(kcGongkaike, req.getParameterMap());
//		 if(StringUtils.isEmpty(xnxq)){
//		 	KcSysConfig kcSysConfig = kcSysConfigService.getById("1");
//			 queryWrapper.ge("rq",kcSysConfig.getBxqkssj());
//			 queryWrapper.le("rq",kcSysConfig.getBxqjssj());
//		 }else{QueryWrapper<KcXqxnHistory> kcXqxnHistoryQueryWrapper = new QueryWrapper<>();
//			 kcXqxnHistoryQueryWrapper.eq("title",xnxq);
//			 KcXqxnHistory KcXqxnHistory = kcXqxnHistoryService.getOne(kcXqxnHistoryQueryWrapper);queryWrapper.ge("rq",KcXqxnHistory.getStartTime());
//			 queryWrapper.le("rq",KcXqxnHistory.getEndTime());
//		 }
		 Page<KcGongkaike> page = new Page<KcGongkaike>(pageNo, pageSize);
		 IPage<KcGongkaike> pageList = kcGongkaikeService.getIndexList(page, queryWrapper);
		 return Result.OK(pageList);
	 }


	 @AutoLog(value = "批量修改前台是否展示")
	 @ApiOperation(value="批量修改前台是否展示", notes="批量修改前台是否展示")
	 @RequestMapping(value = "/editBatch", method = {RequestMethod.PUT,RequestMethod.POST})
	 public Result<String> editBatch(@RequestBody KcGongkaike kcGongkaike) {
		String ids[] = kcGongkaike.getId().split(",");
		String sfxs = kcGongkaike.getSfxs();
		for(String id:ids){
			KcGongkaike kcGongkaikePar = new KcGongkaike();
			kcGongkaikePar.setId(id);
			kcGongkaikePar.setSfxs(sfxs);
			kcGongkaikeService.updateById(kcGongkaikePar);
		}
		 return Result.OK("编辑成功!");
	 }

}
