package org.jeecg.modules.kc.kcGongkaikelog.controller;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.kc.kcGongkaikelog.entity.KcGongkaikelog;
import org.jeecg.modules.kc.kcGongkaikelog.service.IKcGongkaikelogService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecg.modules.kc.kcSysConfig.entity.KcSysConfig;
import org.jeecg.modules.kc.kcSysConfig.service.IKcSysConfigService;
import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

 /**
 * @Description: kc_gongkaikelog
 * @Author: jeecg-boot
 * @Date:   2023-06-18
 * @Version: V1.0
 */
@Api(tags="kc_gongkaikelog")
@RestController
@RequestMapping("/kcGongkaikelog/kcGongkaikelog")
@Slf4j
public class KcGongkaikelogController extends JeecgController<KcGongkaikelog, IKcGongkaikelogService> {
	@Autowired
	private IKcGongkaikelogService kcGongkaikelogService;
	/**
	 * 分页列表查询
	 *
	 * @param kcGongkaikelog
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "kc_gongkaikelog-分页列表查询")
	@ApiOperation(value="kc_gongkaikelog-分页列表查询", notes="kc_gongkaikelog-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<KcGongkaikelog>> queryPageList(KcGongkaikelog kcGongkaikelog,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<KcGongkaikelog> queryWrapper = QueryGenerator.initQueryWrapper(kcGongkaikelog, req.getParameterMap());
		Page<KcGongkaikelog> page = new Page<KcGongkaikelog>(pageNo, pageSize);
		IPage<KcGongkaikelog> pageList = kcGongkaikelogService.page(page, queryWrapper);
		return Result.OK(pageList);
	}


	 @ApiOperation(value="kc_gongkaikelog-分页列表查询", notes="kc_gongkaikelog-分页列表查询")
	 @GetMapping(value = "/listIndex")
	 public Result<IPage<KcGongkaikelog>> listIndex(KcGongkaikelog kcGongkaikelog,
														@RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
														@RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
														HttpServletRequest req) {

		 QueryWrapper<KcGongkaikelog> queryWrapper = QueryGenerator.initQueryWrapper(kcGongkaikelog, req.getParameterMap());
		 Page<KcGongkaikelog> page = new Page<KcGongkaikelog>(pageNo, pageSize);
		 IPage<KcGongkaikelog> pageList = kcGongkaikelogService.page(page, queryWrapper);
		 return Result.OK(pageList);
	 }
	
	/**
	 *   添加
	 *
	 * @param kcGongkaikelog
	 * @return
	 */
	@AutoLog(value = "kc_gongkaikelog-添加")
	@ApiOperation(value="kc_gongkaikelog-添加", notes="kc_gongkaikelog-添加")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody KcGongkaikelog kcGongkaikelog) {
		kcGongkaikelogService.save(kcGongkaikelog);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param kcGongkaikelog
	 * @return
	 */
	@AutoLog(value = "kc_gongkaikelog-编辑")
	@ApiOperation(value="kc_gongkaikelog-编辑", notes="kc_gongkaikelog-编辑")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody KcGongkaikelog kcGongkaikelog) {
		kcGongkaikelogService.updateById(kcGongkaikelog);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "kc_gongkaikelog-通过id删除")
	@ApiOperation(value="kc_gongkaikelog-通过id删除", notes="kc_gongkaikelog-通过id删除")
	@RequiresPermissions("kcGongkaikelog:kc_gongkaikelog:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		kcGongkaikelogService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "kc_gongkaikelog-批量删除")
	@ApiOperation(value="kc_gongkaikelog-批量删除", notes="kc_gongkaikelog-批量删除")
	@RequiresPermissions("kcGongkaikelog:kc_gongkaikelog:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.kcGongkaikelogService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "kc_gongkaikelog-通过id查询")
	@ApiOperation(value="kc_gongkaikelog-通过id查询", notes="kc_gongkaikelog-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<KcGongkaikelog> queryById(@RequestParam(name="id",required=true) String id) {
		KcGongkaikelog kcGongkaikelog = kcGongkaikelogService.getById(id);
		if(kcGongkaikelog==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(kcGongkaikelog);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param kcGongkaikelog
    */
    @RequiresPermissions("kcGongkaikelog:kc_gongkaikelog:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, KcGongkaikelog kcGongkaikelog) {
        return super.exportXls(request, kcGongkaikelog, KcGongkaikelog.class, "kc_gongkaikelog");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("kcGongkaikelog:kc_gongkaikelog:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, KcGongkaikelog.class);
    }

}
