package org.jeecg.modules.kc.kcJieci.service.impl;

import cn.hutool.core.date.DateUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import org.apache.commons.lang.StringUtils;
import org.jeecg.common.util.DateUtils;
import org.jeecg.modules.kc.kcJieci.entity.KcJieci;
import org.jeecg.modules.kc.kcJieci.mapper.KcJieciMapper;
import org.jeecg.modules.kc.kcJieci.service.IKcJieciService;
import org.springframework.stereotype.Service;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.List;

/**
 * @Description: kc_jieci
 * @Author: jeecg-boot
 * @Date:   2023-04-03
 * @Version: V1.0
 */
@Service
public class KcJieciServiceImpl extends ServiceImpl<KcJieciMapper, KcJieci> implements IKcJieciService {

    @Override
    public List<KcJieci> getIndexJcList(KcJieci kcJieci) {
        QueryWrapper<KcJieci> queryWrapper = new QueryWrapper<>();
        queryWrapper.apply("LENGTH(jieci)>2");
        queryWrapper.orderByAsc("id");
        List<KcJieci> list = baseMapper.selectList(queryWrapper);
        List<KcJieci> resList = new ArrayList<>();
        String dqsj = DateUtils.getDate("HHmm");//获取当前时间的小时和分钟
        String sjkssj = "";//实际开始时间 用于判断正在上课和即将上课的文字切换
        String minDate = list.get(0).getHhks();//最小开始时间
        String maxDate = list.get(5).getHhjs();//最大结束时间
        String dqkssj = DateUtils.getDate("yyyy-MM-dd");//当前开始时间
        String dqjc = "";//当前节次
        String xyjkssj = "";//当前开始时间
        String xyjjc = "";//当前节次
        Calendar calendarMin = Calendar.getInstance();
        calendarMin.setTime(DateUtil.parse(dqkssj+" "+minDate.substring(0,2)+":"+minDate.substring(2,4)+":00","yyyy-MM-dd HH:mm:ss"));
        //从当前日期减去30分钟
        calendarMin.add(Calendar.MINUTE, -30);
        minDate = DateUtil.format(calendarMin.getTime(),"HHmm") ;

        if(Integer.parseInt(dqsj)<Integer.parseInt(minDate)){
            //如果当前时间小于第一节开始时间则当前时间赋值为昨天，节次为最后一节
            dqkssj = DateUtils.getDate("yyyy-MM-dd");
            dqjc = "";
            //下一节赋值为当天第一节
            xyjkssj = DateUtils.getDate("yyyy-MM-dd");
            xyjjc = list.get(0).getJieci();
        }else{
            if(Integer.parseInt(dqsj)>Integer.parseInt(maxDate)){
                SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd");//设置格式
                Calendar calendar = Calendar.getInstance(); //创建Calendar 的实例
                calendar.add(Calendar.DAY_OF_MONTH, +1); //当前时间减去一天，即一天前的时间
                //如果当前时间大于最后一节课则赋值给最后一节课
                dqkssj = DateUtils.getDate("yyyy-MM-dd");
                dqjc = "";
                //下一节课赋值给明天第一节
                xyjkssj = simpleDateFormat.format(calendar.getTime());
                xyjjc = list.get(0).getJieci();
            }else{
                for(int i=0;i<list.size();i++){
                    String kssj = "";
                    String jssj = "";

                    kssj = list.get(i).getHhks();
                    jssj = list.get(i).getHhjs();

                    Calendar calendar2 = Calendar.getInstance();
                    calendar2.setTime(DateUtil.parse(dqkssj+" "+kssj.substring(0,2)+":"+kssj.substring(2,4)+":00","yyyy-MM-dd HH:mm:ss"));
                    //从当前日期减去15分钟
                    calendar2.add(Calendar.MINUTE, -30);
                    kssj = DateUtil.format(calendar2.getTime(),"HHmm") ;
                    sjkssj = list.get(i).getHhks();
//
//                    if(i==list.size()-1){
//                        kssj = list.get(i).getHhks();
//                        jssj = list.get(i).getHhjs();
//                    }else{
//                        kssj = list.get(i).getHhks();
//                        jssj = list.get(i+1).getHhks();
//                    }
                    if(Integer.parseInt(dqsj)>=Integer.parseInt(kssj)&&Integer.parseInt(dqsj)<Integer.parseInt(jssj)){
                        dqjc = list.get(i).getJieci();
                        if(i==list.size()-1){
                            SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd");//设置格式
                            Calendar calendar = Calendar.getInstance(); //创建Calendar 的实例
                            calendar.add(Calendar.DAY_OF_MONTH, +1); //当前时间减去一天，即一天前的时间
                            //如果当前时间大于最后一节课则赋值给最后一节课
                            dqjc = list.get(i).getJieci();
                            //下一节课赋值给明天第一节
                            xyjkssj = simpleDateFormat.format(calendar.getTime());
                            xyjjc = list.get(0).getJieci();
                        }else{
                            xyjkssj = DateUtils.getDate("yyyy-MM-dd");
                            xyjjc = list.get(i+1).getJieci();
                        }
                        break;
                    }
                    if(Integer.parseInt(dqsj)>=1130&&Integer.parseInt(dqsj)<=1300){
                        xyjkssj = DateUtils.getDate("yyyy-MM-dd");
                        xyjjc = "05、06";
                    }
                    if(Integer.parseInt(dqsj)>=1645&&Integer.parseInt(dqsj)<=1730){
                        xyjkssj = DateUtils.getDate("yyyy-MM-dd");
                        xyjjc = "09、10";
                    }
                }
            }
        }
        KcJieci kcJieciRes = new KcJieci();
        kcJieciRes.setKssj(dqkssj);
        kcJieciRes.setJieci(dqjc);
        kcJieciRes.setType("1");
        if(StringUtils.isNotBlank(sjkssj)){
            kcJieciRes.setSjsksj(dqkssj+" "+sjkssj.substring(0,2)+":"+sjkssj.substring(2,4)+":00");
        }
        resList.add(kcJieciRes);
        kcJieciRes = new KcJieci();
        kcJieciRes.setKssj(xyjkssj);
        kcJieciRes.setJieci(xyjjc);
        kcJieciRes.setType("2");
        resList.add(kcJieciRes);
        return resList;
    }

    @Override
    public List<KcJieci> getIndexJcXskcList(KcJieci kcJieci) {
        QueryWrapper<KcJieci> queryWrapper = new QueryWrapper<>();
        queryWrapper.apply("LENGTH(jieci)>2");
        queryWrapper.orderByAsc("id");
        List<KcJieci> list = baseMapper.selectList(queryWrapper);
        List<KcJieci> resList = new ArrayList<>();
        String dqsj = DateUtils.getDate("HHmm");//获取当前时间的小时和分钟
        String minDate = list.get(0).getHhks();//最小开始时间
        String maxDate = list.get(5).getHhjs();//最大结束时间
        String dqkssj = "";//当前开始时间
        String dqjc = "";//当前节次
        String xyjkssj = "";//当前开始时间
        String xyjjc = "";//当前节次
        if(Integer.parseInt(dqsj)<Integer.parseInt(minDate)){
            SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd");//设置格式
            Calendar calendar = Calendar.getInstance(); //创建Calendar 的实例
            calendar.add(Calendar.DAY_OF_MONTH, -1); //当前时间减去一天，即一天前的时间
            //如果当前时间小于第一节开始时间则当前时间赋值为昨天，节次为最后一节
            dqkssj = simpleDateFormat.format(calendar.getTime());
            dqjc = "";
            //下一节赋值为当天第一节
            xyjkssj = DateUtils.getDate("yyyy-MM-dd");
            xyjjc = list.get(0).getJieci();
        }else{
            if(Integer.parseInt(dqsj)>Integer.parseInt(maxDate)){
                SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd");//设置格式
                Calendar calendar = Calendar.getInstance(); //创建Calendar 的实例
                calendar.add(Calendar.DAY_OF_MONTH, +1); //当前时间减去一天，即一天前的时间
                //如果当前时间大于最后一节课则赋值给最后一节课
                dqkssj = DateUtils.getDate("yyyy-MM-dd");
                dqjc = "";
                //下一节课赋值给明天第一节
                xyjkssj = simpleDateFormat.format(calendar.getTime());
                xyjjc = list.get(0).getJieci();
            }else{
                dqkssj = DateUtils.getDate("yyyy-MM-dd");
                for(int i=0;i<list.size();i++){
                    String kssj = "";
                    String jssj = "";
                    kssj = list.get(i).getHhks();
                    jssj = list.get(i).getHhjs();

                    Calendar calendar2 = Calendar.getInstance();
                    calendar2.setTime(DateUtil.parse(dqkssj+" "+kssj.substring(0,2)+":"+kssj.substring(2,4)+":00","yyyy-MM-dd HH:mm:ss"));
                    //从当前日期减去15分钟
                    calendar2.add(Calendar.MINUTE, -15);
                    kssj = DateUtil.format(calendar2.getTime(),"HHmm") ;

//                    if(i==0){
//                        kssj = list.get(i).getHhks();
//                        jssj = list.get(i).getHhjs();
//                    }else{
//                        kssj = list.get(i-1).getHhjs();
//                        jssj = list.get(i).getHhjs();
//                    }
                    if(Integer.parseInt(dqsj)>=Integer.parseInt(kssj)&&Integer.parseInt(dqsj)<Integer.parseInt(jssj)){

                        dqjc = list.get(i).getJieci();
                        if(i==list.size()-1){
                            SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd");//设置格式
                            Calendar calendar = Calendar.getInstance(); //创建Calendar 的实例
                            calendar.add(Calendar.DAY_OF_MONTH, +1); //当前时间减去一天，即一天前的时间
                            //如果当前时间大于最后一节课则赋值给最后一节课
                            dqkssj = DateUtils.getDate("yyyy-MM-dd");
                            dqjc = list.get(i).getJieci();
                            //下一节课赋值给明天第一节
                            xyjkssj = simpleDateFormat.format(calendar.getTime());
                            xyjjc = list.get(0).getJieci();
                        }else{
                            xyjkssj = DateUtils.getDate("yyyy-MM-dd");
                            xyjjc = list.get(i+1).getJieci();
                        }
                        break;
                    }
                }
            }
        }
        KcJieci kcJieciRes = new KcJieci();
        kcJieciRes.setKssj(dqkssj);
        kcJieciRes.setJieci(dqjc);
        kcJieciRes.setType("1");
        resList.add(kcJieciRes);
        kcJieciRes = new KcJieci();
        kcJieciRes.setKssj(xyjkssj);
        kcJieciRes.setJieci(xyjjc);
        kcJieciRes.setType("2");
        resList.add(kcJieciRes);
        return resList;
    }
}
