package org.jeecg.modules.kc.kcKechengExclude.controller;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.kc.kcKechengExclude.entity.KcKechengExclude;
import org.jeecg.modules.kc.kcKechengExclude.service.IKcKechengExcludeService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

 /**
 * @Description: 课程刨除数据
 * @Author: jeecg-boot
 * @Date:   2024-03-21
 * @Version: V1.0
 */
@Api(tags="课程刨除数据")
@RestController
@RequestMapping("/kcKechengExclude/kcKechengExclude")
@Slf4j
public class KcKechengExcludeController extends JeecgController<KcKechengExclude, IKcKechengExcludeService> {
	@Autowired
	private IKcKechengExcludeService kcKechengExcludeService;
	
	/**
	 * 分页列表查询
	 *
	 * @param kcKechengExclude
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "课程刨除数据-分页列表查询")
	@ApiOperation(value="课程刨除数据-分页列表查询", notes="课程刨除数据-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<KcKechengExclude>> queryPageList(KcKechengExclude kcKechengExclude,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<KcKechengExclude> queryWrapper = QueryGenerator.initQueryWrapper(kcKechengExclude, req.getParameterMap());
		Page<KcKechengExclude> page = new Page<KcKechengExclude>(pageNo, pageSize);
		IPage<KcKechengExclude> pageList = kcKechengExcludeService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param kcKechengExclude
	 * @return
	 */
	@AutoLog(value = "课程刨除数据-添加")
	@ApiOperation(value="课程刨除数据-添加", notes="课程刨除数据-添加")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody KcKechengExclude kcKechengExclude) {
		kcKechengExcludeService.save(kcKechengExclude);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param kcKechengExclude
	 * @return
	 */
	@AutoLog(value = "课程刨除数据-编辑")
	@ApiOperation(value="课程刨除数据-编辑", notes="课程刨除数据-编辑")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody KcKechengExclude kcKechengExclude) {
		kcKechengExcludeService.updateById(kcKechengExclude);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "课程刨除数据-通过id删除")
	@ApiOperation(value="课程刨除数据-通过id删除", notes="课程刨除数据-通过id删除")
	@RequiresPermissions("kcKechengExclude:kc_kecheng_exclude:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		kcKechengExcludeService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "课程刨除数据-批量删除")
	@ApiOperation(value="课程刨除数据-批量删除", notes="课程刨除数据-批量删除")
	@RequiresPermissions("kcKechengExclude:kc_kecheng_exclude:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.kcKechengExcludeService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "课程刨除数据-通过id查询")
	@ApiOperation(value="课程刨除数据-通过id查询", notes="课程刨除数据-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<KcKechengExclude> queryById(@RequestParam(name="id",required=true) String id) {
		KcKechengExclude kcKechengExclude = kcKechengExcludeService.getById(id);
		if(kcKechengExclude==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(kcKechengExclude);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param kcKechengExclude
    */
    @RequiresPermissions("kcKechengExclude:kc_kecheng_exclude:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, KcKechengExclude kcKechengExclude) {
        return super.exportXls(request, kcKechengExclude, KcKechengExclude.class, "课程刨除数据");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("kcKechengExclude:kc_kecheng_exclude:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, KcKechengExclude.class);
    }

}
