package org.jeecg.modules.kc.kcKechengtixingdingyue.controller;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.lang3.StringUtils;
import org.apache.shiro.SecurityUtils;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.system.vo.LoginUser;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.kc.kcKechengtixingdingyue.entity.KcKechengtixingdingyue;
import org.jeecg.modules.kc.kcKechengtixingdingyue.service.IKcKechengtixingdingyueService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

 /**
 * @Description: 课程提醒订阅
 * @Author: jeecg-boot
 * @Date:   2023-04-06
 * @Version: V1.0
 */
@Api(tags="课程提醒订阅")
@RestController
@RequestMapping("/kcKechengtixingdingyue/kcKechengtixingdingyue")
@Slf4j
public class KcKechengtixingdingyueController extends JeecgController<KcKechengtixingdingyue, IKcKechengtixingdingyueService> {
	@Autowired
	private IKcKechengtixingdingyueService kcKechengtixingdingyueService;

	 @Value("${jeecg.path.upload}")
	 private String upLoadPath;
	/**
	 * 分页列表查询
	 *
	 * @param kcKechengtixingdingyue
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "课程提醒订阅-分页列表查询")
	@ApiOperation(value="课程提醒订阅-分页列表查询", notes="课程提醒订阅-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<KcKechengtixingdingyue>> queryPageList(KcKechengtixingdingyue kcKechengtixingdingyue,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<KcKechengtixingdingyue> queryWrapper = QueryGenerator.initQueryWrapper(kcKechengtixingdingyue, req.getParameterMap());
		queryWrapper.eq(StringUtils.isNotBlank(kcKechengtixingdingyue.getDwmc()),"b.dwmc",kcKechengtixingdingyue.getDwmc());
		if(StringUtils.isNotBlank(kcKechengtixingdingyue.getRjzy())){
			queryWrapper.like("b.rjzy",kcKechengtixingdingyue.getRjzy());

		}
		queryWrapper.apply("username is not null");
		Page<KcKechengtixingdingyue> page = new Page<KcKechengtixingdingyue>(pageNo, pageSize);
		IPage<KcKechengtixingdingyue> pageList = kcKechengtixingdingyueService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param kcKechengtixingdingyue
	 * @return
	 */
	@AutoLog(value = "课程提醒订阅-添加")
	@ApiOperation(value="课程提醒订阅-添加", notes="课程提醒订阅-添加")
//	@RequiresPermissions("kcKechengtixingdingyue:kc_kechengtixingdingyue:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody KcKechengtixingdingyue kcKechengtixingdingyue) {
		kcKechengtixingdingyueService.save(kcKechengtixingdingyue);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param kcKechengtixingdingyue
	 * @return
	 */
	@AutoLog(value = "课程提醒订阅-编辑")
	@ApiOperation(value="课程提醒订阅-编辑", notes="课程提醒订阅-编辑")
//	@RequiresPermissions("kcKechengtixingdingyue:kc_kechengtixingdingyue:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody KcKechengtixingdingyue kcKechengtixingdingyue) {
		kcKechengtixingdingyueService.updateById(kcKechengtixingdingyue);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "课程提醒订阅-通过id删除")
	@ApiOperation(value="课程提醒订阅-通过id删除", notes="课程提醒订阅-通过id删除")
	@RequiresPermissions("kcKechengtixingdingyue:kc_kechengtixingdingyue:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		kcKechengtixingdingyueService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "课程提醒订阅-批量删除")
	@ApiOperation(value="课程提醒订阅-批量删除", notes="课程提醒订阅-批量删除")
	@RequiresPermissions("kcKechengtixingdingyue:kc_kechengtixingdingyue:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.kcKechengtixingdingyueService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "课程提醒订阅-通过id查询")
	@ApiOperation(value="课程提醒订阅-通过id查询", notes="课程提醒订阅-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<KcKechengtixingdingyue> queryById(@RequestParam(name="id",required=true) String id) {
		KcKechengtixingdingyue kcKechengtixingdingyue = kcKechengtixingdingyueService.getById(id);
		if(kcKechengtixingdingyue==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(kcKechengtixingdingyue);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param kcKechengtixingdingyue
    */
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, KcKechengtixingdingyue kcKechengtixingdingyue) {
        return exportXls(request, kcKechengtixingdingyue, KcKechengtixingdingyue.class, "课程提醒订阅");
    }


	 protected ModelAndView exportXls(HttpServletRequest request, KcKechengtixingdingyue object, Class<KcKechengtixingdingyue> clazz, String title) {
		 // Step.1 组装查询条件
		 QueryWrapper<KcKechengtixingdingyue> queryWrapper = QueryGenerator.initQueryWrapper(object, request.getParameterMap());
		 LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();

		 // 过滤选中数据
		 String selections = request.getParameter("selections");
		 if (oConvertUtils.isNotEmpty(selections)) {
			 List<String> selectionList = Arrays.asList(selections.split(","));
			 queryWrapper.in("id",selectionList);
		 }
		 queryWrapper.eq(StringUtils.isNotBlank(object.getDwmc()),"b.dwmc",object.getDwmc());
		 if(StringUtils.isNotBlank(object.getRjzy())){
			 queryWrapper.like("b.rjzy",object.getRjzy());

		 }
		 // Step.2 获取导出数据
		 queryWrapper.apply("username is not null");
		 List<KcKechengtixingdingyue> exportList = service.list(queryWrapper);
		 for(KcKechengtixingdingyue kcKechengtixingdingyuePar:exportList){
			 if(StringUtils.equals("0",kcKechengtixingdingyuePar.getKqtx())){
				 kcKechengtixingdingyuePar.setKqtx("否");
			 }else{
				 kcKechengtixingdingyuePar.setKqtx("是");
			 }
			 if(StringUtils.equals("0",kcKechengtixingdingyuePar.getMrkctx())){
				 kcKechengtixingdingyuePar.setMrkctx("否");
			 }else{
				 kcKechengtixingdingyuePar.setMrkctx("是");
			 }
		 }

		 // Step.3 AutoPoi 导出Excel
		 ModelAndView mv = new ModelAndView(new JeecgEntityExcelView());
		 //此处设置的filename无效 ,前端会重更新设置一下
		 mv.addObject(NormalExcelConstants.FILE_NAME, title);
		 mv.addObject(NormalExcelConstants.CLASS, clazz);
		 //update-begin--Author:liusq  Date:20210126 for：图片导出报错，ImageBasePath未设置--------------------
		 ExportParams  exportParams=new ExportParams(title + "报表", "导出人:" + sysUser.getRealname(), title);
		 exportParams.setImageBasePath(upLoadPath);
		 //update-end--Author:liusq  Date:20210126 for：图片导出报错，ImageBasePath未设置----------------------
		 mv.addObject(NormalExcelConstants.PARAMS,exportParams);
		 mv.addObject(NormalExcelConstants.DATA_LIST, exportList);
		 return mv;
	 }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("kcKechengtixingdingyue:kc_kechengtixingdingyue:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, KcKechengtixingdingyue.class);
    }

}
