package org.jeecg.modules.kc.kcNotice.entity;

import java.io.Serializable;
import java.io.UnsupportedEncodingException;
import java.util.Date;
import java.math.BigDecimal;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.TableLogic;
import lombok.Data;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;
import org.jeecgframework.poi.excel.annotation.Excel;
import org.jeecg.common.aspect.annotation.Dict;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * @Description: kc_notice
 * @Author: jeecg-boot
 * @Date:   2023-04-02
 * @Version: V1.0
 */
@Data
@TableName("kc_notice")
@Accessors(chain = true)
@EqualsAndHashCode(callSuper = false)
@ApiModel(value="kc_notice对象", description="kc_notice")
public class KcNotice implements Serializable {
    private static final long serialVersionUID = 1L;

	/**id*/
	@TableId(type = IdType.ASSIGN_ID)
    @ApiModelProperty(value = "id")
    private java.lang.Integer id;
	/**标题*/
	@Excel(name = "标题", width = 15)
    @ApiModelProperty(value = "标题")
    private java.lang.String ntitle;
	/**类型 0：外部链接 1：富文本 */
	@Excel(name = "类型 0：外部链接 1：富文本 ", width = 15, dicCode = "ntype")
	@Dict(dicCode = "ntype")
    @ApiModelProperty(value = "类型 0：外部链接 1：富文本 ")
    private java.lang.String ntype;
	/**状态 0：不可用 1：可用*/
	@Excel(name = "状态 0：不可用 1：可用", width = 15, dicCode = "nstatus")
	@Dict(dicCode = "nstatus")
    @ApiModelProperty(value = "状态 0：不可用 1：可用")
    private java.lang.String nstatus;
	/**内容*/
	@Excel(name = "内容", width = 15)
    private transient java.lang.String ncontentString;

    private byte[] ncontent;

    public byte[] getNcontent(){
        if(ncontentString==null){
            return null;
        }
        try {
            return ncontentString.getBytes("UTF-8");
        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        }
        return null;
    }

    public String getNcontentString(){
        if(ncontent==null || ncontent.length==0){
            return "";
        }
        try {
            return new String(ncontent,"UTF-8");
        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        }
        return "";
    }
	/**链接*/
	@Excel(name = "链接", width = 15)
    @ApiModelProperty(value = "链接")
    private java.lang.String nlink;
	/**发布日期*/
	@Excel(name = "发布日期", width = 20, format = "yyyy-MM-dd")
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd")
    @DateTimeFormat(pattern="yyyy-MM-dd")
    @ApiModelProperty(value = "发布日期")
    private java.util.Date ndate;
	/**是否置顶0：否 1：置顶*/
	@Excel(name = "是否置顶0：否 1：置顶", width = 15, dicCode = "ontop")
	@Dict(dicCode = "ontop")
    @ApiModelProperty(value = "是否置顶0：否 1：置顶")
    private java.lang.String ontop;
}
