package org.jeecg.modules.kc.kcSysConfig.controller;

import java.text.ParseException;
import java.util.*;
import java.util.stream.Collectors;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import com.baomidou.mybatisplus.extension.toolkit.SqlHelper;
import org.apache.commons.lang3.StringUtils;
import org.apache.shiro.SecurityUtils;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.system.vo.LoginUser;
import org.jeecg.common.util.DateUtils;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.kc.grab.imports.entity.Xxhbsynclog;
import org.jeecg.modules.kc.kcSysConfig.entity.KcSysConfig;
import org.jeecg.modules.kc.kcSysConfig.service.IKcSysConfigService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecg.modules.kc.kcTingkeBmd.entity.KcTingkeBmd;
import org.jeecg.modules.kc.kcTingkeBmd.service.IKcTingkeBmdService;
import org.jeecg.modules.kc.kcXqxnHistory.entity.KcXqxnHistory;
import org.jeecg.modules.kc.kcXqxnHistory.service.IKcXqxnHistoryService;
import org.jeecg.modules.kc.ktgl.entity.KcKechengbiao;
import org.jeecg.modules.kc.ktgl.entity.KcKechengbiaoHis;
import org.jeecg.modules.kc.ktgl.entity.KcKetangbiao;
import org.jeecg.modules.kc.ktgl.entity.KcKetangbiaoHis;
import org.jeecg.modules.kc.ktgl.service.IKcKechengbiaoHisService;
import org.jeecg.modules.kc.ktgl.service.IKcKechengbiaoService;
import org.jeecg.modules.kc.ktgl.service.IKcKetangbiaoHisService;
import org.jeecg.modules.kc.ktgl.service.IKcKetangbiaoService;
import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

 /**
 * @Description: 课程系统配置
 * @Author: jeecg-boot
 * @Date:   2023-04-10
 * @Version: V1.0
 */
@Api(tags="课程系统配置")
@RestController
@RequestMapping("/kcSysConfig/kcSysConfig")
@Slf4j
public class KcSysConfigController extends JeecgController<KcSysConfig, IKcSysConfigService> {
	@Autowired
	private IKcSysConfigService kcSysConfigService;

	 @Autowired
	 private IKcKechengbiaoService kcKechengbiaoService;
	 @Autowired
	 private IKcKechengbiaoHisService kcKechengbiaoHisService;

	 @Autowired
	 private IKcKetangbiaoService kcKetangbiaoService;
	 @Autowired
	 private IKcKetangbiaoHisService kcKetangbiaoHisService;
	 @Autowired
	 private IKcXqxnHistoryService kcXqxnHistoryService;
	 @Autowired
	 private IKcTingkeBmdService kcTingkeBmdService;
	/**
	 * 分页列表查询
	 *
	 * @param kcSysConfig
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "课程系统配置-分页列表查询")
	@ApiOperation(value="课程系统配置-分页列表查询", notes="课程系统配置-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<KcSysConfig>> queryPageList(KcSysConfig kcSysConfig,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<KcSysConfig> queryWrapper = QueryGenerator.initQueryWrapper(kcSysConfig, req.getParameterMap());
		Page<KcSysConfig> page = new Page<KcSysConfig>(pageNo, pageSize);
		IPage<KcSysConfig> pageList = kcSysConfigService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param kcSysConfig
	 * @return
	 */
	@AutoLog(value = "课程系统配置-添加")
	@ApiOperation(value="课程系统配置-添加", notes="课程系统配置-添加")
	@RequiresPermissions("kcSysConfig:kc_sys_config:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody KcSysConfig kcSysConfig) {
		kcSysConfigService.save(kcSysConfig);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param kcSysConfig
	 * @return
	 */
	@AutoLog(value = "课程系统配置-编辑")
	@ApiOperation(value="课程系统配置-编辑", notes="课程系统配置-编辑")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody KcSysConfig kcSysConfig) {
		if(StringUtils.isNotBlank(kcSysConfig.getFlag1())){
			QueryWrapper<KcXqxnHistory> queryWrapper = new QueryWrapper<>();
			queryWrapper.eq("title",kcSysConfig.getFlag1());
			queryWrapper.last("limit 1");
			KcXqxnHistory kcXqxnHistory = kcXqxnHistoryService.getOne(queryWrapper);
			if(kcXqxnHistory==null){
				KcXqxnHistory kcXqxnHistoryPar = new KcXqxnHistory();
				kcXqxnHistoryPar.setTitle(kcSysConfig.getFlag1());
				kcXqxnHistoryPar.setStartTime(DateUtil.parse(kcSysConfig.getBxqkssj(),"yyyy-MM-dd"));
				kcXqxnHistoryPar.setEndTime(DateUtil.parse(kcSysConfig.getBxqjssj(),"yyyy-MM-dd"));
				kcXqxnHistoryService.save(kcXqxnHistoryPar);
			}else{
				kcXqxnHistoryService.updateById(kcXqxnHistory);
			}
		}
		kcSysConfigService.updateById(kcSysConfig);

		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "课程系统配置-通过id删除")
	@ApiOperation(value="课程系统配置-通过id删除", notes="课程系统配置-通过id删除")
	@RequiresPermissions("kcSysConfig:kc_sys_config:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		kcSysConfigService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "课程系统配置-批量删除")
	@ApiOperation(value="课程系统配置-批量删除", notes="课程系统配置-批量删除")
	@RequiresPermissions("kcSysConfig:kc_sys_config:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.kcSysConfigService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "课程系统配置-通过id查询")
	@ApiOperation(value="课程系统配置-通过id查询", notes="课程系统配置-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<KcSysConfig> queryById(@RequestParam(name="id",required=true) String id) {
		KcSysConfig kcSysConfig = kcSysConfigService.getById(id);
		LoginUser user = (LoginUser) SecurityUtils.getSubject().getPrincipal();
		QueryWrapper<KcTingkeBmd> query = new QueryWrapper<KcTingkeBmd>();
		query.eq("jgh", user.getUsername());
		query.eq("xnxq", kcSysConfig.getFlag1());
		query.last("limit 1");
		KcTingkeBmd kcTingkeBmd = kcTingkeBmdService.getOne(query);
		if(kcTingkeBmd==null) {
			kcSysConfig.setSfbmd("n");
		}else{
			kcSysConfig.setSfbmd("y");
		}
		return Result.OK(kcSysConfig);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param kcSysConfig
    */
    @RequiresPermissions("kcSysConfig:kc_sys_config:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, KcSysConfig kcSysConfig) {
        return super.exportXls(request, kcSysConfig, KcSysConfig.class, "课程系统配置");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("kcSysConfig:kc_sys_config:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, KcSysConfig.class);
    }


	 @GetMapping(value = "/getDjz")
	 public Result<List<KcSysConfig>> getDjz() throws ParseException {
		 KcSysConfig kcSysConfig = kcSysConfigService.getById("1");
		 List<KcSysConfig> list = new ArrayList<>();
		 String startTime = kcSysConfig.getBxqkssj();
		 String endTime = kcSysConfig.getBxqjssj();
		 Date date1 = DateUtils.parseDate(startTime,"yyyy-MM-dd");
		 Date date2 = DateUtils.parseDate(endTime,"yyyy-MM-dd");
		 int i=0;
		 while(date1.getTime()<date2.getTime()){
			 if(i!=0){
				 Calendar calendar = Calendar.getInstance(); //日历时间工具类实例化创建，取得当前时间初值
				 calendar.setTime(date1);  //覆盖掉当前时间
				 calendar.add(Calendar.DATE, 1); //+7
				 date1 = calendar.getTime();
			 }
			 i++;
			 KcSysConfig kcSysConfigPar = new KcSysConfig();
			 kcSysConfigPar.setBxqkssj(DateUtils.formatDate(date1,"yyyy-MM-dd"));
			 kcSysConfigPar.setFlag1("第"+i+"周");
			 Date date3 = date1;
			 Calendar calendar = Calendar.getInstance(); //日历时间工具类实例化创建，取得当前时间初值
//			 String lssj = DateUtils.formatDate(date1,"yyyy-MM-dd")+" 23:59:59";
			 calendar.setTime(DateUtil.parse(DateUtil.format(date3,"yyyy-MM-dd")+" 23:59:59","yyyy-MM-dd HH:mm:ss"));  //覆盖掉当前时间
			 calendar.add(Calendar.DATE, 7); //+7
			 Date date4 = calendar.getTime();
			 date1 = DateUtil.parse(DateUtil.format(calendar.getTime(),"yyyy-MM-dd")+" 00:00:00","yyyy-MM-dd HH:mm:ss");
			 Date date5 = new Date();
			 System.out.println("3:   "+DateUtil.format(date3,"yyyy-MM-dd HH:mm:ss"));
			 System.out.println("5:   "+DateUtil.format(date5,"yyyy-MM-dd HH:mm:ss"));
			 System.out.println("4:   "+DateUtil.format(date4,"yyyy-MM-dd HH:mm:ss"));
			 if(date3.getTime()<=date5.getTime()&&date5.getTime()<=date4.getTime()){
				 kcSysConfigPar.setFlag2("1");
			 }
			 kcSysConfigPar.setBxqjssj(DateUtils.formatDate(date4,"yyyy-MM-dd"));
			 list.add(kcSysConfigPar);
		 }
		 String flag2 = "0";
		 for(int j=0;j<list.size();j++){
			 KcSysConfig kcSysConfigPar = list.get(j);
			 if("1".equals(kcSysConfigPar.getFlag2())){
				 break;
			 }
			 if(list.size()-1==j){
				 kcSysConfigPar.setFlag2("1");
			 }

		 }
		 return Result.OK(list);
	 }


	 @AutoLog(value = "课程系统配置-通过id查询")
	 @GetMapping(value = "/listKcxx")
	 public Result<String> listKcxx(KcSysConfig kcSysConfig,HttpServletRequest req) {
		 try {

			 kcSysConfig = kcSysConfigService.getById("1");

			 QueryWrapper<KcKechengbiao> kcKechengbiaoQueryWrapper = new QueryWrapper<>();
			 kcKechengbiaoQueryWrapper.eq("xqxn",kcSysConfig.getFlag1());
			 kcKechengbiaoQueryWrapper.last("limit 1");
			 List<KcKechengbiao> kcbList = kcKechengbiaoService.list(kcKechengbiaoQueryWrapper);
			 if(kcbList.size()==0){


				 //-----------------删除对应数据--------------------------
				 QueryWrapper<KcKechengbiao> queryWrapper = new QueryWrapper<>();
				 queryWrapper.eq("xqxn",kcSysConfig.getFlag1());
				 kcKechengbiaoService.remove(queryWrapper);
				 System.out.println("-------------11111111111111111111111------------------");
				 //-----------------删除对应数据-----------------------

				 //-----------------初始化数据------------------------
				 KcKechengbiao kcKechengbiao = new KcKechengbiao();
				 kcKechengbiao.setXqxn(kcSysConfig.getFlag1());
				 kcKechengbiaoService.syncKechengbiao(kcKechengbiao);
				 System.out.println("-------------22222222222222222222222------------------");
				 //-----------------初始化数据------------------------




				 //---------------删除对应数据--------------------
				 QueryWrapper<KcKetangbiao> queryWrapper2 = new QueryWrapper<>();
				 queryWrapper2.eq("xnxq",kcSysConfig.getFlag1());
				 kcKetangbiaoService.remove(queryWrapper2);
				 System.out.println("-------------33333333333333333333333333------------------");
				 //---------------删除对应数据--------------------

				 String bxqkssj = kcSysConfig.getBxqkssj();
				 //插入数据
				 KcKetangbiao kcKetangbiao = new KcKetangbiao();
				 kcKetangbiao.setXnxq(kcSysConfig.getFlag1());
				 kcKetangbiao.setFlag("0");
				 List<KcKetangbiao> list = kcKetangbiaoService.selectSyncList(kcKetangbiao);
				 System.out.println("-------------list。size------------------"+list.size());

				 List<KcKetangbiao> arrayList = new ArrayList<>();
				 for(int i=0;i<list.size();i++){
					 KcKetangbiao kcKetangbiaoOld = list.get(i);
					 try {
						 String jkzc[] = kcKetangbiaoOld.getJkzc().split(",");
						 String week = kcKetangbiaoOld.getWeek();
						 for(int j=0;j<jkzc.length;j++){
							 KcKetangbiao kcKetangbiaoAddNew = new KcKetangbiao();
							 int djz = Integer.parseInt(jkzc[j]);
							 BeanUtils.copyProperties(kcKetangbiaoOld,kcKetangbiaoAddNew);
							 kcKetangbiaoAddNew.setId(null);
							 //skrq 生成规则，取本学开始时间（kc_sys_config.bxqkssj）+(jkzc-1)*7+week
							 int addSj = (djz -1 )*7+Integer.parseInt(week)-1;
							 Date date = DateUtils.parseDate(bxqkssj,"yyyy-MM-dd");
							 Calendar c = Calendar.getInstance();
							 c.setTime(date);
							 c.add(Calendar.DAY_OF_MONTH, addSj);
							 String skrq = DateUtils.formatDate(c,"yyyy-MM-dd");
							 kcKetangbiaoAddNew.setSkrq(skrq);
							 kcKetangbiaoAddNew.setDijizhou(djz);
							 kcKetangbiaoAddNew.setXnxq(kcSysConfig.getFlag1());
							 kcKetangbiaoAddNew.setSkxs(1);
							 arrayList.add(kcKetangbiaoAddNew);

						 }
					 }catch (Exception e){
						 e.printStackTrace();
					 }
				 }
				 System.out.println("-------------4444444444444444444444444------------------");
				 kcKetangbiaoService.saveBatch(arrayList);
				 System.out.println("-------------5555555555555555555555555------------------");
			 }

//			 //-----------------向历史数据添加数据--------------------------
//			 List<KcKechengbiao> listKcb = kcKechengbiaoService.list();
//			 List<KcKechengbiaoHis> listHisKcb = new ArrayList<>();
//			 for(int i=0;i<listKcb.size();i++){
//				 KcKechengbiaoHis his = new KcKechengbiaoHis();
//				 KcKechengbiao KcKechengbiaoPar = listKcb.get(i);
//				 BeanUtils.copyProperties(KcKechengbiaoPar,his);
//				 his.setXnxq(kcSysConfig.getFlag1());
//				 his.setSjc(dateNow);
//				 listHisKcb.add(his);
//			 }
//			 kcKechengbiaoHisService.saveBatch(listHisKcb);




//			 //---------------向历史数据里添加记录----------------
//			 List<KcKetangbiaoHis> arrayHisList = new ArrayList<>();
//			 List<KcKetangbiao> KcKetangbiaoParList = kcKetangbiaoService.list();
//			 for(int i=0;i<KcKetangbiaoParList.size();i++){
//				 KcKetangbiao KcKetangbiaoPar = KcKetangbiaoParList.get(i);
//				 KcKetangbiaoHis hisKtb = new KcKetangbiaoHis();
//				 BeanUtils.copyProperties(KcKetangbiaoPar,hisKtb);
//				 hisKtb.setXnxq(kcSysConfig.getFlag1());
//				 hisKtb.setSjc(dateNow);
//				 arrayHisList.add(hisKtb);
//			 }
//			 kcKetangbiaoHisService.saveBatch(arrayHisList);
//			 //---------------向历史数据里添加记录----------------









			 return Result.OK("操作成功");
		 }catch (Exception e){
			 e.printStackTrace();
			 return Result.error("操作失败，请联系管理员"+e.getMessage());
		 }
	 }

}
