package org.jeecg.modules.kc.kcSysConfig.entity;

import java.io.Serializable;
import java.io.UnsupportedEncodingException;
import java.util.Date;
import java.math.BigDecimal;

import com.baomidou.mybatisplus.annotation.*;
import lombok.Data;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;
import org.jeecgframework.poi.excel.annotation.Excel;
import org.jeecg.common.aspect.annotation.Dict;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * @Description: 课程系统配置
 * @Author: jeecg-boot
 * @Date:   2023-04-10
 * @Version: V1.0
 */
@Data
@TableName("kc_sys_config")
@Accessors(chain = true)
@EqualsAndHashCode(callSuper = false)
@ApiModel(value="kc_sys_config对象", description="课程系统配置")
public class KcSysConfig implements Serializable {
    private static final long serialVersionUID = 1L;

	/**主键*/
	@TableId(type = IdType.ASSIGN_ID)
    @ApiModelProperty(value = "主键")
    private java.lang.String id;
	/**创建人*/
    @ApiModelProperty(value = "创建人")
    private java.lang.String createBy;
	/**创建日期*/
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "创建日期")
    private java.util.Date createTime;
	/**更新人*/
    @ApiModelProperty(value = "更新人")
    private java.lang.String updateBy;
	/**更新日期*/
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "更新日期")
    private java.util.Date updateTime;
	/**所属部门*/
    @ApiModelProperty(value = "所属部门")
    private java.lang.String sysOrgCode;
	/**本学期课程开始时间*/
	@Excel(name = "本学期课程开始时间", width = 15)
    @ApiModelProperty(value = "本学期课程开始时间")
    private java.lang.String bxqkssj;
	/**本学期课程结束时间*/
	@Excel(name = "本学期课程结束时间", width = 15)
    @ApiModelProperty(value = "本学期课程结束时间")
    private java.lang.String bxqjssj;
	/**预留字段1*/
	@Excel(name = "预留字段1", width = 15)
    @ApiModelProperty(value = "预留字段1")
    private java.lang.String flag1;
	/**预留字段2*/
	@Excel(name = "预留字段2", width = 15)
    @ApiModelProperty(value = "预留字段2")
    private java.lang.String flag2;
	/**预留字段3*/
	@Excel(name = "预留字段3", width = 15)
    @ApiModelProperty(value = "预留字段3")
    private java.lang.String flag3;
	/**预留字段4*/
	@Excel(name = "预留字段4", width = 15)
    @ApiModelProperty(value = "预留字段4")
    private java.lang.String flag4;
	/**预留字段5*/
	@Excel(name = "预留字段5", width = 15)
    @ApiModelProperty(value = "预留字段5")
    private java.lang.String flag5;
	/**预留字段6*/
	@Excel(name = "预留字段6", width = 15)
	@ApiModelProperty(value = "预留字段6")
    private java.lang.String flag6;
	/**预留字段7*/
	@Excel(name = "预留字段7", width = 15)
	@ApiModelProperty(value = "预留字段7")
    private java.lang.String flag7;
	/**预留字段8*/
	@Excel(name = "预留字段8", width = 15)
	@ApiModelProperty(value = "预留字段8")
    private java.lang.String flag8;
	/**线上课堂-说明文字*/
	@Excel(name = "线上课堂-说明文字", width = 15)
	@ApiModelProperty(value = "线上课堂-说明文字")
    private java.lang.String xsktTitle;
	/**今日课堂-说明文字*/
	@Excel(name = "今日课堂-说明文字", width = 15)
	@ApiModelProperty(value = "今日课堂-说明文字")
    private java.lang.String jrktTitle;
	/**今日课堂-说明文字*/
	@Excel(name = "白名单-说明文字", width = 15)
	@ApiModelProperty(value = "白名单-说明文字")
	private java.lang.String bmdTitle;
	/**智慧教室播放错误提示文字*/
	@Excel(name = "智慧教室播放错误提示文字", width = 15)
	@ApiModelProperty(value = "智慧教室播放错误提示文字")
    private java.lang.String videoPlayErrTitle;
	private java.lang.String flag9;//今日课表听课按钮

	//是否白名单 y是 n否
	@TableField(exist = false)
	private String sfbmd;//是否白名单
}
