package org.jeecg.modules.kc.kcTingkeBmd.controller;

import java.io.UnsupportedEncodingException;
import java.io.IOException;
import java.net.URLDecoder;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.jeecg.common.system.vo.LoginUser;
import org.apache.shiro.SecurityUtils;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.kc.kcTingkeBmd.entity.KcTingkeBmdKcxx;
import org.jeecg.modules.kc.kcTingkeBmd.entity.KcTingkeBmd;
import org.jeecg.modules.kc.kcTingkeBmd.vo.KcTingkeBmdPage;
import org.jeecg.modules.kc.kcTingkeBmd.service.IKcTingkeBmdService;
import org.jeecg.modules.kc.kcTingkeBmd.service.IKcTingkeBmdKcxxService;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;
import com.alibaba.fastjson.JSON;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;


 /**
 * @Description: 听课白名单教师信息
 * @Author: jeecg-boot
 * @Date:   2024-03-07
 * @Version: V1.0
 */
@Api(tags="听课白名单教师信息")
@RestController
@RequestMapping("/kcTingkeBmd/kcTingkeBmd")
@Slf4j
public class KcTingkeBmdController {
	@Autowired
	private IKcTingkeBmdService kcTingkeBmdService;
	@Autowired
	private IKcTingkeBmdKcxxService kcTingkeBmdKcxxService;
	
	/**
	 * 分页列表查询
	 *
	 * @param kcTingkeBmd
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "听课白名单教师信息-分页列表查询")
	@ApiOperation(value="听课白名单教师信息-分页列表查询", notes="听课白名单教师信息-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<KcTingkeBmd>> queryPageList(KcTingkeBmd kcTingkeBmd,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<KcTingkeBmd> queryWrapper = QueryGenerator.initQueryWrapper(kcTingkeBmd, req.getParameterMap());
		Page<KcTingkeBmd> page = new Page<KcTingkeBmd>(pageNo, pageSize);
		IPage<KcTingkeBmd> pageList = kcTingkeBmdService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param kcTingkeBmdPage
	 * @return
	 */
	@AutoLog(value = "听课白名单教师信息-添加")
	@ApiOperation(value="听课白名单教师信息-添加", notes="听课白名单教师信息-添加")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody KcTingkeBmdPage kcTingkeBmdPage) {
		KcTingkeBmd kcTingkeBmd = new KcTingkeBmd();
		BeanUtils.copyProperties(kcTingkeBmdPage, kcTingkeBmd);
		kcTingkeBmdService.saveMain(kcTingkeBmd, kcTingkeBmdPage.getKcTingkeBmdKcxxList());
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param kcTingkeBmdPage
	 * @return
	 */
	@AutoLog(value = "听课白名单教师信息-编辑")
	@ApiOperation(value="听课白名单教师信息-编辑", notes="听课白名单教师信息-编辑")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody KcTingkeBmdPage kcTingkeBmdPage) {
		KcTingkeBmd kcTingkeBmd = new KcTingkeBmd();
		BeanUtils.copyProperties(kcTingkeBmdPage, kcTingkeBmd);
		KcTingkeBmd kcTingkeBmdEntity = kcTingkeBmdService.getById(kcTingkeBmd.getId());
		if(kcTingkeBmdEntity==null) {
			return Result.error("未找到对应数据");
		}
		kcTingkeBmdService.updateMain(kcTingkeBmd, kcTingkeBmdPage.getKcTingkeBmdKcxxList());
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "听课白名单教师信息-通过id删除")
	@ApiOperation(value="听课白名单教师信息-通过id删除", notes="听课白名单教师信息-通过id删除")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		kcTingkeBmdService.delMain(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "听课白名单教师信息-批量删除")
	@ApiOperation(value="听课白名单教师信息-批量删除", notes="听课白名单教师信息-批量删除")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.kcTingkeBmdService.delBatchMain(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功！");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "听课白名单教师信息-通过id查询")
	@ApiOperation(value="听课白名单教师信息-通过id查询", notes="听课白名单教师信息-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<KcTingkeBmd> queryById(@RequestParam(name="id",required=true) String id) {
		KcTingkeBmd kcTingkeBmd = kcTingkeBmdService.getById(id);
		if(kcTingkeBmd==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(kcTingkeBmd);

	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "分配的课程通过主表ID查询")
	@ApiOperation(value="分配的课程主表ID查询", notes="分配的课程-通主表ID查询")
	@GetMapping(value = "/queryKcTingkeBmdKcxxByMainId")
	public Result<List<KcTingkeBmdKcxx>> queryKcTingkeBmdKcxxListByMainId(@RequestParam(name="id",required=true) String id) {
		List<KcTingkeBmdKcxx> kcTingkeBmdKcxxList = kcTingkeBmdKcxxService.selectByMainId(id);
		return Result.OK(kcTingkeBmdKcxxList);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param kcTingkeBmd
    */
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, KcTingkeBmd kcTingkeBmd) {
      // Step.1 组装查询条件查询数据
      QueryWrapper<KcTingkeBmd> queryWrapper = QueryGenerator.initQueryWrapper(kcTingkeBmd, request.getParameterMap());
      LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();

      //配置选中数据查询条件
      String selections = request.getParameter("selections");
      if(oConvertUtils.isNotEmpty(selections)) {
         List<String> selectionList = Arrays.asList(selections.split(","));
         queryWrapper.in("id",selectionList);
      }
      //Step.2 获取导出数据
      List<KcTingkeBmd> kcTingkeBmdList = kcTingkeBmdService.list(queryWrapper);

      // Step.3 组装pageList
      List<KcTingkeBmdPage> pageList = new ArrayList<KcTingkeBmdPage>();
      for (KcTingkeBmd main : kcTingkeBmdList) {
          KcTingkeBmdPage vo = new KcTingkeBmdPage();
          BeanUtils.copyProperties(main, vo);
          List<KcTingkeBmdKcxx> kcTingkeBmdKcxxList = kcTingkeBmdKcxxService.selectByMainId(main.getId());
          vo.setKcTingkeBmdKcxxList(kcTingkeBmdKcxxList);
          pageList.add(vo);
      }

      // Step.4 AutoPoi 导出Excel
      ModelAndView mv = new ModelAndView(new JeecgEntityExcelView());
      mv.addObject(NormalExcelConstants.FILE_NAME, "听课白名单教师信息列表");
      mv.addObject(NormalExcelConstants.CLASS, KcTingkeBmdPage.class);
      mv.addObject(NormalExcelConstants.PARAMS, new ExportParams("听课白名单教师信息数据", "导出人:"+sysUser.getRealname(), "听课白名单教师信息"));
      mv.addObject(NormalExcelConstants.DATA_LIST, pageList);
      return mv;
    }

    /**
    * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("kcTingkeBmd:kc_tingke_bmd:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
      MultipartHttpServletRequest multipartRequest = (MultipartHttpServletRequest) request;
      Map<String, MultipartFile> fileMap = multipartRequest.getFileMap();
      for (Map.Entry<String, MultipartFile> entity : fileMap.entrySet()) {
          // 获取上传文件对象
          MultipartFile file = entity.getValue();
          ImportParams params = new ImportParams();
          params.setTitleRows(2);
          params.setHeadRows(1);
          params.setNeedSave(true);
          try {
              List<KcTingkeBmdPage> list = ExcelImportUtil.importExcel(file.getInputStream(), KcTingkeBmdPage.class, params);
              for (KcTingkeBmdPage page : list) {
                  KcTingkeBmd po = new KcTingkeBmd();
                  BeanUtils.copyProperties(page, po);
                  kcTingkeBmdService.saveMain(po, page.getKcTingkeBmdKcxxList());
              }
              return Result.OK("文件导入成功！数据行数:" + list.size());
          } catch (Exception e) {
              log.error(e.getMessage(),e);
              return Result.error("文件导入失败:"+e.getMessage());
          } finally {
              try {
                  file.getInputStream().close();
              } catch (IOException e) {
                  e.printStackTrace();
              }
          }
      }
      return Result.OK("文件导入失败！");
    }


	 @ApiOperation(value="听课白名单教师信息-通过jgh查询", notes="听课白名单教师信息-通过id查询")
	 @GetMapping(value = "/getBmdInfo")
	 public Result<String> getBmdInfo(@RequestParam(name="jgh",required=true) String jgh) {
		QueryWrapper<KcTingkeBmd> query = new QueryWrapper<KcTingkeBmd>();
		 query.eq("jgh", jgh);
		 query.last("limit 1");
		 KcTingkeBmd kcTingkeBmd = kcTingkeBmdService.getOne(query);
		 if(kcTingkeBmd==null) {
			 return Result.OK("n");
		 }else{
			 return Result.OK("y");
		 }
	 }
}
