package org.jeecg.modules.kc.kcTingkeBmd.service.impl;

import org.jeecg.modules.kc.kcTingkeBmd.entity.KcTingkeBmd;
import org.jeecg.modules.kc.kcTingkeBmd.entity.KcTingkeBmdKcxx;
import org.jeecg.modules.kc.kcTingkeBmd.mapper.KcTingkeBmdKcxxMapper;
import org.jeecg.modules.kc.kcTingkeBmd.mapper.KcTingkeBmdMapper;
import org.jeecg.modules.kc.kcTingkeBmd.service.IKcTingkeBmdService;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;
import java.io.Serializable;
import java.util.List;
import java.util.Collection;

/**
 * @Description: 听课白名单教师信息
 * @Author: jeecg-boot
 * @Date:   2024-03-07
 * @Version: V1.0
 */
@Service
public class KcTingkeBmdServiceImpl extends ServiceImpl<KcTingkeBmdMapper, KcTingkeBmd> implements IKcTingkeBmdService {

	@Autowired
	private KcTingkeBmdMapper kcTingkeBmdMapper;
	@Autowired
	private KcTingkeBmdKcxxMapper kcTingkeBmdKcxxMapper;
	
	@Override
	@Transactional(rollbackFor = Exception.class)
	public void saveMain(KcTingkeBmd kcTingkeBmd, List<KcTingkeBmdKcxx> kcTingkeBmdKcxxList) {
		kcTingkeBmdMapper.insert(kcTingkeBmd);
		if(kcTingkeBmdKcxxList!=null && kcTingkeBmdKcxxList.size()>0) {
			for(KcTingkeBmdKcxx entity:kcTingkeBmdKcxxList) {
				//外键设置
				entity.setId(null);
				entity.setBmdId(kcTingkeBmd.getId());
				kcTingkeBmdKcxxMapper.insert(entity);
			}
		}
	}

	@Override
	@Transactional(rollbackFor = Exception.class)
	public void updateMain(KcTingkeBmd kcTingkeBmd,List<KcTingkeBmdKcxx> kcTingkeBmdKcxxList) {
		kcTingkeBmdMapper.updateById(kcTingkeBmd);
		
		//1.先删除子表数据
		kcTingkeBmdKcxxMapper.deleteByMainId(kcTingkeBmd.getId());
		
		//2.子表数据重新插入
		if(kcTingkeBmdKcxxList!=null && kcTingkeBmdKcxxList.size()>0) {
			for(KcTingkeBmdKcxx entity:kcTingkeBmdKcxxList) {
				//外键设置
				entity.setBmdId(kcTingkeBmd.getId());
				kcTingkeBmdKcxxMapper.insert(entity);
			}
		}
	}

	@Override
	@Transactional(rollbackFor = Exception.class)
	public void delMain(String id) {
		kcTingkeBmdKcxxMapper.deleteByMainId(id);
		kcTingkeBmdMapper.deleteById(id);
	}

	@Override
	@Transactional(rollbackFor = Exception.class)
	public void delBatchMain(Collection<? extends Serializable> idList) {
		for(Serializable id:idList) {
			kcTingkeBmdKcxxMapper.deleteByMainId(id.toString());
			kcTingkeBmdMapper.deleteById(id);
		}
	}
	
}
