package org.jeecg.modules.kc.kcTtksdpz.controller;

import java.util.Arrays;
import java.util.Date;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import org.apache.commons.lang3.StringUtils;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.DateUtils;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.kc.kcTtksdpz.entity.KcTtksdpz;
import org.jeecg.modules.kc.kcTtksdpz.service.IKcTtksdpzService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecg.modules.kc.ktgl.entity.KcKetangbiao;
import org.jeecg.modules.kc.ktgl.service.IKcKetangbiaoService;
import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

 /**
 * @Description: 调停课配置
 * @Author: jeecg-boot
 * @Date:   2024-04-16
 * @Version: V1.0
 */
@Api(tags="调停课配置")
@RestController
@RequestMapping("/kcTtksdpz/kcTtksdpz")
@Slf4j
public class KcTtksdpzController extends JeecgController<KcTtksdpz, IKcTtksdpzService> {
	@Autowired
	private IKcTtksdpzService kcTtksdpzService;


	 @Autowired
	 private IKcKetangbiaoService kcKetangbiaoService;
	
	/**
	 * 分页列表查询
	 *
	 * @param kcTtksdpz
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "调停课配置-分页列表查询")
	@ApiOperation(value="调停课配置-分页列表查询", notes="调停课配置-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<KcTtksdpz>> queryPageList(KcTtksdpz kcTtksdpz,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<KcTtksdpz> queryWrapper = QueryGenerator.initQueryWrapper(kcTtksdpz, req.getParameterMap());
		Page<KcTtksdpz> page = new Page<KcTtksdpz>(pageNo, pageSize);
		IPage<KcTtksdpz> pageList = kcTtksdpzService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param kcTtksdpz
	 * @return
	 */
	@AutoLog(value = "调停课配置-添加")
	@ApiOperation(value="调停课配置-添加", notes="调停课配置-添加")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody KcTtksdpz kcTtksdpz) {
		kcTtksdpzService.save(kcTtksdpz);
		try {
			editTtkxx();
		}catch (Exception e) {
			e.printStackTrace();
		}
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param kcTtksdpz
	 * @return
	 */
	@AutoLog(value = "调停课配置-编辑")
	@ApiOperation(value="调停课配置-编辑", notes="调停课配置-编辑")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody KcTtksdpz kcTtksdpz) {
		kcTtksdpzService.updateById(kcTtksdpz);
		try {
			editTtkxx();
		}catch (Exception e) {
			e.printStackTrace();
		}
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "调停课配置-通过id删除")
	@ApiOperation(value="调停课配置-通过id删除", notes="调停课配置-通过id删除")
	@RequiresPermissions("kcTtksdpz:kc_ttksdpz:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		kcTtksdpzService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "调停课配置-批量删除")
	@ApiOperation(value="调停课配置-批量删除", notes="调停课配置-批量删除")
	@RequiresPermissions("kcTtksdpz:kc_ttksdpz:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.kcTtksdpzService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "调停课配置-通过id查询")
	@ApiOperation(value="调停课配置-通过id查询", notes="调停课配置-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<KcTtksdpz> queryById(@RequestParam(name="id",required=true) String id) {
		KcTtksdpz kcTtksdpz = kcTtksdpzService.getById(id);
		if(kcTtksdpz==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(kcTtksdpz);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param kcTtksdpz
    */
    @RequiresPermissions("kcTtksdpz:kc_ttksdpz:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, KcTtksdpz kcTtksdpz) {
        return super.exportXls(request, kcTtksdpz, KcTtksdpz.class, "调停课配置");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("kcTtksdpz:kc_ttksdpz:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, KcTtksdpz.class);
    }


	 private void editTtkxx() {
		 Date dateNow = new Date();
		 String dqsj = DateUtils.formatDate(dateNow,"yyyy-MM-dd");
		 QueryWrapper<KcTtksdpz> kcTtksdpzQueryWrapper = new QueryWrapper<>();
		 kcTtksdpzQueryWrapper.ge("fjsj",dqsj);
		 List<KcTtksdpz> sdpzList = kcTtksdpzService.list(kcTtksdpzQueryWrapper);
//            停课：代表在放假时间内，不上课
//            调课：放假时间上调课时间内的课程
		 for(KcTtksdpz kcTtksdpz:sdpzList){
			 String tklx = kcTtksdpz.getTklx();
			 if(StringUtils.equals("1",tklx)){//调课
				 String fjsj = DateUtils.formatDate(kcTtksdpz.getFjsj(),"yyyy-MM-dd");//放假时间
				 String tksj = DateUtils.formatDate(kcTtksdpz.getTksj(),"yyyy-MM-dd");//调课时间

				 //更具调课时间修改成放假时间
				 UpdateWrapper<KcKetangbiao> KcKetangbiaoUpdateWrapper = new UpdateWrapper<>();
				 KcKetangbiaoUpdateWrapper.set("skrq",fjsj);
				 KcKetangbiaoUpdateWrapper.set("is_delete","0");
				 KcKetangbiaoUpdateWrapper.eq("skrq",tksj);
				 kcKetangbiaoService.update(KcKetangbiaoUpdateWrapper);

				 kcTtksdpz.setZxsj(dateNow);
				 kcTtksdpz.setZxsql1("update kc_ketangbiao set skrq = '"+fjsj+"' , is_delete = '0' where skrq = '"+tksj+"'");
				 kcTtksdpzService.updateById(kcTtksdpz);
			 }else if(StringUtils.equals("0",tklx)){//停课
				 String fjsj = DateUtils.formatDate(kcTtksdpz.getFjsj(),"yyyy-MM-dd");//放假时间

				 //更具调课时间修改成放假时间
				 UpdateWrapper<KcKetangbiao> KcKetangbiaoUpdateWrapper = new UpdateWrapper<>();
				 KcKetangbiaoUpdateWrapper.set("is_delete","1");
				 KcKetangbiaoUpdateWrapper.eq("skrq",fjsj);
				 kcKetangbiaoService.update(KcKetangbiaoUpdateWrapper);

				 kcTtksdpz.setZxsj(dateNow);
				 kcTtksdpz.setZxsql1("update kc_ketangbiao set is_delete = '0' where skrq = '"+fjsj+"'");
				 kcTtksdpzService.updateById(kcTtksdpz);
			 }
		 }
	 }
}
