package org.jeecg.modules.kc.kcWechatSendLog.controller;

import java.util.*;
import java.util.stream.Collectors;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.alibaba.fastjson.JSONObject;
import com.xkcoding.http.HttpUtil;
import org.apache.commons.lang3.StringUtils;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.DateUtils;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.kc.KcBdgxbcopy.entity.KcBdgxbcopy;
import org.jeecg.modules.kc.grab.imports.entity.Xxhbuser;
import org.jeecg.modules.kc.grab.imports.service.IXxhbuserService;
import org.jeecg.modules.kc.kcWechatSendLog.entity.KcWechatSendLog;
import org.jeecg.modules.kc.kcWechatSendLog.service.IKcWechatSendLogService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecg.modules.kc.ktgl.entity.KcKetangbiao;
import org.jeecg.modules.system.entity.SysUser;
import org.jeecg.modules.wxgzh.WeChatTemplateMsg;
import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.client.RestTemplate;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

 /**
 * @Description: 手动微信推送
 * @Author: jeecg-boot
 * @Date:   2023-12-06
 * @Version: V1.0
 */
@Api(tags="手动微信推送")
@RestController
@RequestMapping("/kcWechatSendLog/kcWechatSendLog")
@Slf4j
public class KcWechatSendLogController extends JeecgController<KcWechatSendLog, IKcWechatSendLogService> {
	@Autowired
	private IKcWechatSendLogService kcWechatSendLogService;
	 @Autowired
	 private IXxhbuserService xxhbuserService;
	
	/**
	 * 分页列表查询
	 *
	 * @param kcWechatSendLog
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "手动微信推送-分页列表查询")
	@ApiOperation(value="手动微信推送-分页列表查询", notes="手动微信推送-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<KcWechatSendLog>> queryPageList(KcWechatSendLog kcWechatSendLog,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<KcWechatSendLog> queryWrapper = QueryGenerator.initQueryWrapper(kcWechatSendLog, req.getParameterMap());
		Page<KcWechatSendLog> page = new Page<KcWechatSendLog>(pageNo, pageSize);
		IPage<KcWechatSendLog> pageList = kcWechatSendLogService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param kcWechatSendLog
	 * @return
	 */
	@AutoLog(value = "手动微信推送-添加")
	@ApiOperation(value="手动微信推送-添加", notes="手动微信推送-添加")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody KcWechatSendLog kcWechatSendLog) {
		String[] openIds = kcWechatSendLog.getOpenid().split(",");
		for(String openId:openIds){

			QueryWrapper<Xxhbuser> xxhbuserQueryWrapper = new QueryWrapper<>();
			xxhbuserQueryWrapper.eq("gh",openId);
			xxhbuserQueryWrapper.last("limit 1");
			Xxhbuser xxhbuser = xxhbuserService.getOne(xxhbuserQueryWrapper);

			KcWechatSendLog kcWechatSendLogNew = new KcWechatSendLog();
			kcWechatSendLogNew.setOpenid(openId);
			kcWechatSendLogNew.setTeacherName(xxhbuser.getXm());
			kcWechatSendLogNew.setYtkcs(kcWechatSendLog.getYtkcs());
			kcWechatSendLogService.save(kcWechatSendLogNew);
			sendWxmessage(kcWechatSendLogNew);
		}
		return Result.OK("添加成功！");
	}


//	 // appId
//	 private static final String appId = "wx59920eb69d611d7f";//东师
//
//	 // appIdSecret
//	 private static final String appIdSecret = "bf0c19af0e956f447ede4dd902ea63b7";//东师

	 // appId
	 private static final String appId = "wx031697a8ca09a5ce";//东师

	 private static final String agentid = "1000065";//
	 // appIdSecret
	 private static final String appIdSecret = "6Qhnge3xfzAQMDX2TcjEyE0vUGP96hP9OTYUsYBze2Y";//东师

	 //微信通知点击后跳转的页面
	 private static final String domainTo = "https://smartedu.nenu.edu.cn";



	 public void sendWxmessage(KcWechatSendLog kcWechatSendLog) {
		 String openId = kcWechatSendLog.getOpenid();//曹老师账号
		 System.out.println("openId:"+openId+"");
		 if(StringUtils.isNotEmpty(openId)){
			 try {
				 String urlToken = "https://qyapi.weixin.qq.com/cgi-bin/gettoken?corpid="+ appId +"&corpsecret=" + appIdSecret;
				 System.out.println("urlToken：  "+ urlToken);
				 String res = HttpUtil.get(urlToken);
				 JSONObject jsonObjectToken = JSONObject.parseObject(res);
				 System.out.println("jsonObjectToken：{}"+ jsonObjectToken);
				 String accessToken = jsonObjectToken.getString("access_token");
				 System.out.println("accessToken：{}"+ accessToken);

				 // 微信的基础accessToken
				 String url = "https://qyapi.weixin.qq.com/cgi-bin/message/send?access_token=" + accessToken;
				 Map<String, Object> sendMag = new HashMap<>();

//				 1、xx老师，你好，您本学期（2023秋）听课要求为：5次，当前实际听课次数：3次，请尽快完成本学期的听课任务。
				 String html = kcWechatSendLog.getYtkcs();
				 html = html + "\n<a href=\""+domainTo+"\">查看</a>";
				 sendMag.put("content", html);//授课老师推送内容
				 RestTemplate restTemplate = new RestTemplate();
				 //拼接base参数
				 Map<String, Object> sendBody = new HashMap<>();
				 sendBody.put("touser", openId);                // openId
				 sendBody.put("msgtype", "text");               // 消息类型，此时固定为：text
				 sendBody.put("agentid", agentid);              // 企业id
				 sendBody.put("text",sendMag); 				//发送内容
				 ResponseEntity<String> forEntity = restTemplate.postForEntity(url, sendBody, String.class);
				 JSONObject jsonObject2 = JSONObject.parseObject(forEntity.getBody());
				 System.out.println("jsonObject2 : " + jsonObject2);
				 String messageCode = jsonObject2.getString("errcode");
				 String msgId = jsonObject2.getString("msgid");
				 System.out.println("messageCode : " + messageCode + ", msgId: " +msgId);
				 kcWechatSendLog.setRemark(jsonObject2.toString());
				 kcWechatSendLogService.updateById(kcWechatSendLog);
			 }catch (Exception e) {
				 e.printStackTrace();
				 kcWechatSendLog.setRemark(e.getMessage());
				 kcWechatSendLogService.updateById(kcWechatSendLog);
			 }
		 }else{
			 kcWechatSendLog.setRemark("未获取到openid");
			 kcWechatSendLogService.updateById(kcWechatSendLog);
		 }
	 }


	 public void sendWxmessage2(KcWechatSendLog kcWechatSendLog) {
		 String openId = kcWechatSendLog.getOpenid();//曹老师账号
		 System.out.println("openId:"+openId+"");
		 if(StringUtils.isNotEmpty(openId)){
			 try {
				 String urlToken = "https://api.weixin.qq.com/cgi-bin/token?grant_type=client_credential&appid="+ appId +"&secret=" + appIdSecret;
				 System.out.println("urlToken：  "+ urlToken);
				 String res = HttpUtil.get(urlToken);
				 JSONObject jsonObjectToken = JSONObject.parseObject(res);
				 System.out.println("jsonObjectToken：{}"+ jsonObjectToken);
				 String accessToken = jsonObjectToken.getString("access_token");
				 System.out.println("accessToken：{}"+ accessToken);

				 // 模板参数
				 Map<String, WeChatTemplateMsg> sendMag = new HashMap<String, WeChatTemplateMsg>();

				 // 微信的基础accessToken
				 String url = "https://api.weixin.qq.com/cgi-bin/message/template/send?access_token=" + accessToken;
//				 String url = "https://api.weixin.qq.com/cgi-bin/message/subscribe/bizsend?access_token=" + accessToken;

//				 1、xx老师，你好，您本学期（2023秋）听课要求为：5次，当前实际听课次数：3次，请尽快完成本学期的听课任务。
//				 如需听评课，请点击：课程信息中心（链接）
				 sendMag.put("first", new WeChatTemplateMsg(kcWechatSendLog.getTeacherName()));//授课老师
				 sendMag.put("keyword1", new WeChatTemplateMsg("["+kcWechatSendLog.getXqxn()+"]"+kcWechatSendLog.getTeacherName()));//授课老师
//				 String message = "应听"+kcWechatSendLog.getYtkcs()+"次；实听"+kcWechatSendLog.getSjtkcs()+"次，请尽快完成";
				 sendMag.put("keyword2", new WeChatTemplateMsg(kcWechatSendLog.getYtkcs()));//授课老师
				 sendMag.put("remark", new WeChatTemplateMsg(kcWechatSendLog.getYtkcs()));//授课老师
//				 sendMag.put("thing9", new WeChatTemplateMsg(message));//上课时间
//				 sendMag.put("number4", new WeChatTemplateMsg(kcWechatSendLog.getYtkcs()));//应听课次数
//				 sendMag.put("number9", new WeChatTemplateMsg(kcWechatSendLog.getSjtkcs()));//实际听课次数
				 RestTemplate restTemplate = new RestTemplate();
				 //拼接base参数
				 Map<String, Object> sendBody = new HashMap<>();
				 sendBody.put("touser", openId);               // openId
				 sendBody.put("url", domainTo);         // 点击模板信息跳转地址
//				 sendBody.put("topcolor", "#FF0000");          // 顶色
				 sendBody.put("data", sendMag);                   // 模板参数
				 sendBody.put("template_id", "PDS1hf6s8P5Ce-SFa9J95XvHhMIGlyhITAGq_CIoNMM");      // 模板Id
				 ResponseEntity<String> forEntity = restTemplate.postForEntity(url, sendBody, String.class);
				 JSONObject jsonObject2 = JSONObject.parseObject(forEntity.getBody());
				 System.out.println("jsonObject2 : " + jsonObject2);
				 String messageCode = jsonObject2.getString("errcode");
				 String msgId = jsonObject2.getString("msgid");
				 System.out.println("messageCode : " + messageCode + ", msgId: " +msgId);
				 kcWechatSendLog.setRemark(jsonObject2.toString());
				 kcWechatSendLogService.updateById(kcWechatSendLog);
			 }catch (Exception e) {
				 e.printStackTrace();
				 kcWechatSendLog.setRemark(e.getMessage());
				 kcWechatSendLogService.updateById(kcWechatSendLog);
			 }
		 }else{
			 kcWechatSendLog.setRemark("未获取到openid");
			 kcWechatSendLogService.updateById(kcWechatSendLog);
		 }
	 }
	
	/**
	 *  编辑
	 *
	 * @param kcWechatSendLog
	 * @return
	 */
	@AutoLog(value = "手动微信推送-编辑")
	@ApiOperation(value="手动微信推送-编辑", notes="手动微信推送-编辑")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody KcWechatSendLog kcWechatSendLog) {
		kcWechatSendLogService.updateById(kcWechatSendLog);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "手动微信推送-通过id删除")
	@ApiOperation(value="手动微信推送-通过id删除", notes="手动微信推送-通过id删除")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		kcWechatSendLogService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "手动微信推送-批量删除")
	@ApiOperation(value="手动微信推送-批量删除", notes="手动微信推送-批量删除")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.kcWechatSendLogService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "手动微信推送-通过id查询")
	@ApiOperation(value="手动微信推送-通过id查询", notes="手动微信推送-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<KcWechatSendLog> queryById(@RequestParam(name="id",required=true) String id) {
		KcWechatSendLog kcWechatSendLog = kcWechatSendLogService.getById(id);
		if(kcWechatSendLog==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(kcWechatSendLog);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param kcWechatSendLog
    */
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, KcWechatSendLog kcWechatSendLog) {
        return super.exportXls(request, kcWechatSendLog, KcWechatSendLog.class, "手动微信推送");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("kcWechatSendLog:kc_wechat_send_log:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, KcWechatSendLog.class);
    }

}
