package org.jeecg.modules.kc.kcXqxnHistory.controller;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.kc.kcXqxnHistory.entity.KcXqxnHistory;
import org.jeecg.modules.kc.kcXqxnHistory.service.IKcXqxnHistoryService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

 /**
 * @Description: kc_xqxn_history
 * @Author: jeecg-boot
 * @Date:   2023-06-13
 * @Version: V1.0
 */
@Api(tags="kc_xqxn_history")
@RestController
@RequestMapping("/kcXqxnHistory/kcXqxnHistory")
@Slf4j
public class KcXqxnHistoryController extends JeecgController<KcXqxnHistory, IKcXqxnHistoryService> {
	@Autowired
	private IKcXqxnHistoryService kcXqxnHistoryService;
	
	/**
	 * 分页列表查询
	 *
	 * @param kcXqxnHistory
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "kc_xqxn_history-分页列表查询")
	@ApiOperation(value="kc_xqxn_history-分页列表查询", notes="kc_xqxn_history-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<KcXqxnHistory>> queryPageList(KcXqxnHistory kcXqxnHistory,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<KcXqxnHistory> queryWrapper = QueryGenerator.initQueryWrapper(kcXqxnHistory, req.getParameterMap());
		queryWrapper.orderByDesc("start_time");
		Page<KcXqxnHistory> page = new Page<KcXqxnHistory>(pageNo, pageSize);
		IPage<KcXqxnHistory> pageList = kcXqxnHistoryService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param kcXqxnHistory
	 * @return
	 */
	@AutoLog(value = "kc_xqxn_history-添加")
	@ApiOperation(value="kc_xqxn_history-添加", notes="kc_xqxn_history-添加")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody KcXqxnHistory kcXqxnHistory) {
		kcXqxnHistoryService.save(kcXqxnHistory);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param kcXqxnHistory
	 * @return
	 */
	@AutoLog(value = "kc_xqxn_history-编辑")
	@ApiOperation(value="kc_xqxn_history-编辑", notes="kc_xqxn_history-编辑")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody KcXqxnHistory kcXqxnHistory) {
		kcXqxnHistoryService.updateById(kcXqxnHistory);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "kc_xqxn_history-通过id删除")
	@ApiOperation(value="kc_xqxn_history-通过id删除", notes="kc_xqxn_history-通过id删除")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		kcXqxnHistoryService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "kc_xqxn_history-批量删除")
	@ApiOperation(value="kc_xqxn_history-批量删除", notes="kc_xqxn_history-批量删除")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.kcXqxnHistoryService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "kc_xqxn_history-通过id查询")
	@ApiOperation(value="kc_xqxn_history-通过id查询", notes="kc_xqxn_history-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<KcXqxnHistory> queryById(@RequestParam(name="id",required=true) String id) {
		KcXqxnHistory kcXqxnHistory = kcXqxnHistoryService.getById(id);
		if(kcXqxnHistory==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(kcXqxnHistory);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param kcXqxnHistory
    */
    @RequiresPermissions("kcXqxnHistory:kc_xqxn_history:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, KcXqxnHistory kcXqxnHistory) {
        return super.exportXls(request, kcXqxnHistory, KcXqxnHistory.class, "kc_xqxn_history");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("kcXqxnHistory:kc_xqxn_history:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, KcXqxnHistory.class);
    }

}
