package org.jeecg.modules.kc.kcXsktjxmydcp.controller;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.kc.kcXsktjxmydcp.entity.KcXsktjxmydcp;
import org.jeecg.modules.kc.kcXsktjxmydcp.service.IKcXsktjxmydcpService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

 /**
 * @Description: 学生课堂教学满意度测评
 * @Author: jeecg-boot
 * @Date:   2024-05-08
 * @Version: V1.0
 */
@Api(tags="学生课堂教学满意度测评")
@RestController
@RequestMapping("/kcXsktjxmydcp/kcXsktjxmydcp")
@Slf4j
public class KcXsktjxmydcpController extends JeecgController<KcXsktjxmydcp, IKcXsktjxmydcpService> {
	@Autowired
	private IKcXsktjxmydcpService kcXsktjxmydcpService;
	
	/**
	 * 分页列表查询
	 *
	 * @param kcXsktjxmydcp
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "学生课堂教学满意度测评-分页列表查询")
	@ApiOperation(value="学生课堂教学满意度测评-分页列表查询", notes="学生课堂教学满意度测评-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<KcXsktjxmydcp>> queryPageList(KcXsktjxmydcp kcXsktjxmydcp,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<KcXsktjxmydcp> queryWrapper = QueryGenerator.initQueryWrapper(kcXsktjxmydcp, req.getParameterMap());
		Page<KcXsktjxmydcp> page = new Page<KcXsktjxmydcp>(pageNo, pageSize);
		IPage<KcXsktjxmydcp> pageList = kcXsktjxmydcpService.page(page, queryWrapper);
		return Result.OK(pageList);
	}

	 @ApiOperation(value="学生课堂教学满意度测评-分页列表查询", notes="学生课堂教学满意度测评-分页列表查询")
	 @GetMapping(value = "/groupByList")
	 public Result<IPage<KcXsktjxmydcp>> groupByList(KcXsktjxmydcp kcXsktjxmydcp,
													   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
													   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
													   HttpServletRequest req) {
		 QueryWrapper<KcXsktjxmydcp> queryWrapper = QueryGenerator.initQueryWrapper(kcXsktjxmydcp, req.getParameterMap());
		 Page<KcXsktjxmydcp> page = new Page<KcXsktjxmydcp>(pageNo, pageSize);
		 IPage<KcXsktjxmydcp> pageList = kcXsktjxmydcpService.groupByList(page, queryWrapper);
		 return Result.OK(pageList);
	 }
	
	/**
	 *   添加
	 *
	 * @param kcXsktjxmydcp
	 * @return
	 */
	@AutoLog(value = "学生课堂教学满意度测评-添加")
	@ApiOperation(value="学生课堂教学满意度测评-添加", notes="学生课堂教学满意度测评-添加")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody KcXsktjxmydcp kcXsktjxmydcp) {
		kcXsktjxmydcpService.save(kcXsktjxmydcp);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param kcXsktjxmydcp
	 * @return
	 */
	@AutoLog(value = "学生课堂教学满意度测评-编辑")
	@ApiOperation(value="学生课堂教学满意度测评-编辑", notes="学生课堂教学满意度测评-编辑")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody KcXsktjxmydcp kcXsktjxmydcp) {
		kcXsktjxmydcpService.updateById(kcXsktjxmydcp);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "学生课堂教学满意度测评-通过id删除")
	@ApiOperation(value="学生课堂教学满意度测评-通过id删除", notes="学生课堂教学满意度测评-通过id删除")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		kcXsktjxmydcpService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "学生课堂教学满意度测评-批量删除")
	@ApiOperation(value="学生课堂教学满意度测评-批量删除", notes="学生课堂教学满意度测评-批量删除")
	@RequiresPermissions("kcXsktjxmydcp:kc_xsktjxmydcp:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.kcXsktjxmydcpService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "学生课堂教学满意度测评-通过id查询")
	@ApiOperation(value="学生课堂教学满意度测评-通过id查询", notes="学生课堂教学满意度测评-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<KcXsktjxmydcp> queryById(@RequestParam(name="id",required=true) String id) {
		KcXsktjxmydcp kcXsktjxmydcp = kcXsktjxmydcpService.getById(id);
		if(kcXsktjxmydcp==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(kcXsktjxmydcp);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param kcXsktjxmydcp
    */
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, KcXsktjxmydcp kcXsktjxmydcp) {
        return super.exportXls(request, kcXsktjxmydcp, KcXsktjxmydcp.class, "学生课堂教学满意度测评");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, KcXsktjxmydcp.class);
    }

}
