package org.jeecg.modules.kc.kcYuyue.controller;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import cn.hutool.core.date.DateUtil;
import org.apache.commons.lang3.StringUtils;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.kc.kcXqxnHistory.entity.KcXqxnHistory;
import org.jeecg.modules.kc.kcXqxnHistory.service.IKcXqxnHistoryService;
import org.jeecg.modules.kc.kcYuyue.entity.KcYuyue;
import org.jeecg.modules.kc.kcYuyue.service.IKcYuyueService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

 /**
 * @Description: kc_yuyue
 * @Author: jeecg-boot
 * @Date:   2023-04-05
 * @Version: V1.0
 */
@Api(tags="kc_yuyue")
@RestController
@RequestMapping("/kcYuyue/kcYuyue")
@Slf4j
public class KcYuyueController extends JeecgController<KcYuyue, IKcYuyueService> {
	@Autowired
	private IKcYuyueService kcYuyueService;

	 @Autowired
	 private IKcXqxnHistoryService kcXqxnHistoryService;
	/**
	 * 分页列表查询
	 *
	 * @param kcYuyue
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "kc_yuyue-分页列表查询")
	@ApiOperation(value="kc_yuyue-分页列表查询", notes="kc_yuyue-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<KcYuyue>> queryPageList(KcYuyue kcYuyue,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<KcYuyue> queryWrapper = QueryGenerator.initQueryWrapper(kcYuyue, req.getParameterMap());
		Page<KcYuyue> page = new Page<KcYuyue>(pageNo, pageSize);
		IPage<KcYuyue> pageList = kcYuyueService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param kcYuyue
	 * @return
	 */
	@AutoLog(value = "kc_yuyue-添加")
	@ApiOperation(value="kc_yuyue-添加", notes="kc_yuyue-添加")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody KcYuyue kcYuyue) {
		kcYuyueService.save(kcYuyue);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param kcYuyue
	 * @return
	 */
	@AutoLog(value = "kc_yuyue-编辑")
	@ApiOperation(value="kc_yuyue-编辑", notes="kc_yuyue-编辑")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody KcYuyue kcYuyue) {
		kcYuyueService.updateById(kcYuyue);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "kc_yuyue-通过id删除")
	@ApiOperation(value="kc_yuyue-通过id删除", notes="kc_yuyue-通过id删除")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		kcYuyueService.removeById(id);
		return Result.OK("删除预约成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "kc_yuyue-批量删除")
	@ApiOperation(value="kc_yuyue-批量删除", notes="kc_yuyue-批量删除")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.kcYuyueService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "kc_yuyue-通过id查询")
	@ApiOperation(value="kc_yuyue-通过id查询", notes="kc_yuyue-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<KcYuyue> queryById(@RequestParam(name="id",required=true) String id) {
		KcYuyue kcYuyue = kcYuyueService.getById(id);
		if(kcYuyue==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(kcYuyue);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param kcYuyue
    */
    @RequiresPermissions("kcYuyue:kc_yuyue:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, KcYuyue kcYuyue) {
        return super.exportXls(request, kcYuyue, KcYuyue.class, "kc_yuyue");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("kcYuyue:kc_yuyue:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, KcYuyue.class);
    }

	 @ApiOperation(value="kc_yuyue-分页列表查询", notes="kc_yuyue-分页列表查询")
	 @GetMapping(value = "/findTingkeZuJiByPage")
	 public Result<IPage<?>> findTingkeZuJiByPage(KcYuyue kcYuyue,@RequestParam(name="pageNo", defaultValue="1") Integer pageNo, @RequestParam(name="pageSize", defaultValue="10") Integer pageSize, HttpServletRequest req) {

		 String xnxq = kcYuyue.getXnxq();
		 if(org.apache.commons.lang3.StringUtils.isNotBlank(xnxq)){
			 QueryWrapper<KcXqxnHistory> kcXqxnHistoryQueryWrapper = new QueryWrapper<>();
			 kcXqxnHistoryQueryWrapper.eq("title",xnxq);
			 kcXqxnHistoryQueryWrapper.last("limit 1");
			 KcXqxnHistory kcXqxnHistory =kcXqxnHistoryService.getOne(kcXqxnHistoryQueryWrapper);
			 kcYuyue.setStartTime(DateUtil.format(kcXqxnHistory.getStartTime(),"yyyy-MM-dd"));
			 kcYuyue.setEndTime(DateUtil.format(kcXqxnHistory.getEndTime(),"yyyy-MM-dd"));
		 }
		QueryWrapper<KcYuyue> queryWrapper = QueryGenerator.initQueryWrapper("a",kcYuyue, req.getParameterMap());
		 if(kcYuyue.getIsOrderByNow() != null && kcYuyue.getIsOrderByNow()){
			 queryWrapper.orderByAsc("ABS(NOW() - str_to_date( CONCAT( kt.skrq, kt.hhks ), '%Y-%m-%d %H%i' ))");
		 }
		 queryWrapper.ge(StringUtils.isNotBlank(kcYuyue.getStartTime()),"kt.skrq",kcYuyue.getStartTime());
		 queryWrapper.le(StringUtils.isNotBlank(kcYuyue.getEndTime()),"kt.skrq",kcYuyue.getEndTime());
		 queryWrapper.eq(StringUtils.isNotBlank(kcYuyue.getKkdw()),"kt.kkdw",kcYuyue.getKkdw());
		 queryWrapper.eq(StringUtils.isNotBlank(kcYuyue.getJieci()),"kt.hh",kcYuyue.getJieci());
		 if(StringUtils.isNotBlank(kcYuyue.getYwmc())){
			 queryWrapper.apply("kt.kcmc like '%"+kcYuyue.getYwmc()+"%' or kt.skjs like '%"+kcYuyue.getYwmc()+"%'");
		 }
		 Page<KcYuyue> page = new Page<KcYuyue>(pageNo, pageSize);
		 IPage<Map<String,Object>> pageList = kcYuyueService.findTingkeZuJiByPage(page, queryWrapper);
		 return Result.OK(pageList);

	}

}
