package org.jeecg.modules.kc.kcZwtksfInfo.controller;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.kc.kcZwtksfInfo.entity.KcZwtksfInfo;
import org.jeecg.modules.kc.kcZwtksfInfo.service.IKcZwtksfInfoService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

 /**
 * @Description: kc_zwtksf_info
 * @Author: jeecg-boot
 * @Date:   2023-11-10
 * @Version: V1.0
 */
@Api(tags="kc_zwtksf_info")
@RestController
@RequestMapping("/kcZwtksfInfo/kcZwtksfInfo")
@Slf4j
public class KcZwtksfInfoController extends JeecgController<KcZwtksfInfo, IKcZwtksfInfoService> {
	@Autowired
	private IKcZwtksfInfoService kcZwtksfInfoService;
	
	/**
	 * 分页列表查询
	 *
	 * @param kcZwtksfInfo
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "kc_zwtksf_info-分页列表查询")
	@ApiOperation(value="kc_zwtksf_info-分页列表查询", notes="kc_zwtksf_info-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<KcZwtksfInfo>> queryPageList(KcZwtksfInfo kcZwtksfInfo,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<KcZwtksfInfo> queryWrapper = QueryGenerator.initQueryWrapper(kcZwtksfInfo, req.getParameterMap());
		Page<KcZwtksfInfo> page = new Page<KcZwtksfInfo>(pageNo, pageSize);
		IPage<KcZwtksfInfo> pageList = kcZwtksfInfoService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param kcZwtksfInfo
	 * @return
	 */
	@AutoLog(value = "kc_zwtksf_info-添加")
	@ApiOperation(value="kc_zwtksf_info-添加", notes="kc_zwtksf_info-添加")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody KcZwtksfInfo kcZwtksfInfo) {
		kcZwtksfInfoService.save(kcZwtksfInfo);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param kcZwtksfInfo
	 * @return
	 */
	@AutoLog(value = "kc_zwtksf_info-编辑")
	@ApiOperation(value="kc_zwtksf_info-编辑", notes="kc_zwtksf_info-编辑")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody KcZwtksfInfo kcZwtksfInfo) {
		kcZwtksfInfoService.updateById(kcZwtksfInfo);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "kc_zwtksf_info-通过id删除")
	@ApiOperation(value="kc_zwtksf_info-通过id删除", notes="kc_zwtksf_info-通过id删除")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		kcZwtksfInfoService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "kc_zwtksf_info-批量删除")
	@ApiOperation(value="kc_zwtksf_info-批量删除", notes="kc_zwtksf_info-批量删除")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.kcZwtksfInfoService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "kc_zwtksf_info-通过id查询")
	@ApiOperation(value="kc_zwtksf_info-通过id查询", notes="kc_zwtksf_info-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<KcZwtksfInfo> queryById(@RequestParam(name="id",required=true) String id) {
		KcZwtksfInfo kcZwtksfInfo = kcZwtksfInfoService.getById(id);
		if(kcZwtksfInfo==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(kcZwtksfInfo);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param kcZwtksfInfo
    */
    @RequiresPermissions("kcZwtksfInfo:kc_zwtksf_info:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, KcZwtksfInfo kcZwtksfInfo) {
        return super.exportXls(request, kcZwtksfInfo, KcZwtksfInfo.class, "kc_zwtksf_info");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("kcZwtksfInfo:kc_zwtksf_info:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, KcZwtksfInfo.class);
    }

}
