package org.jeecg.modules.kc.kcZzSzkc.controller;

import java.util.*;
import java.util.stream.Collectors;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import cn.hutool.core.date.DateUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.SecurityUtils;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.system.vo.LoginUser;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.kc.grab.SynchronizationService.tools.ChangeTingKeTongJi;
import org.jeecg.modules.kc.kcAssessuser.entity.KcAssessuser;
import org.jeecg.modules.kc.kcAssessuser.service.IKcAssessuserService;
import org.jeecg.modules.kc.kcZzSzkc.entity.KcZzSzkc;
import org.jeecg.modules.kc.kcZzSzkc.service.IKcZzSzkcService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecg.modules.kc.ktgl.entity.KcKetangbiao;
import org.jeecg.modules.kc.ktgl.service.IKcKetangbiaoService;
import org.jeecg.modules.kc.qa.entity.KcEvaluation;
import org.jeecg.modules.kc.qa.entity.KcEvaluationans;
import org.jeecg.modules.kc.qa.entity.KcEvaluations;
import org.jeecg.modules.kc.qa.service.IKcEvaluationService;
import org.jeecg.modules.kc.qa.service.IKcEvaluationansService;
import org.jeecg.modules.kc.qa.service.IKcEvaluationsService;
import org.jeecg.modules.kc.tktj.entity.KcTingke;
import org.jeecg.modules.kc.tktj.service.IKcTingkeService;
import org.jeecg.modules.system.service.impl.SysBaseApiImpl;
import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

 /**
 * @Description: 思政课程评价记录
 * @Author: jeecg-boot
 * @Date:   2024-09-25
 * @Version: V1.0
 */
@Api(tags="思政课程评价记录")
@RestController
@RequestMapping("/kcZzSzkc/kcZzSzkc")
@Slf4j
public class KcZzSzkcController extends JeecgController<KcZzSzkc, IKcZzSzkcService> {
	@Autowired
	private IKcZzSzkcService kcZzSzkcService;
	 @Autowired
	 private IKcKetangbiaoService kcKetangbiaoService;
	 @Autowired
	 private IKcEvaluationService kcEvaluationService;
	 @Autowired
	 private IKcEvaluationsService kcEvaluationsService;
	 @Autowired
	 private IKcEvaluationansService kcEvaluationansService;
	 @Autowired
	 private ChangeTingKeTongJi changeTingKeTongJi;
	 @Autowired
	 private IKcAssessuserService kcAssessuserService;
	 @Autowired
	 private IKcTingkeService kcTingkeService;
	 @Autowired
	 private SysBaseApiImpl sysBaseApi;
	
	/**
	 * 分页列表查询
	 *
	 * @param kcZzSzkc
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "思政课程评价记录-分页列表查询")
	@ApiOperation(value="思政课程评价记录-分页列表查询", notes="思政课程评价记录-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<KcZzSzkc>> queryPageList(KcZzSzkc kcZzSzkc,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {

		QueryWrapper<KcZzSzkc> queryWrapper = QueryGenerator.initQueryWrapper("a",kcZzSzkc, req.getParameterMap());
		queryWrapper.eq(StringUtils.isNotBlank(kcZzSzkc.getXqxn()),"b.title",kcZzSzkc.getXqxn());
		//-------------获取当前登陆人是否是管理员角色，如果不是都按照教务秘书处理---------------------------
		LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
		List<String> roleList = sysBaseApi.getRolesByUsername(sysUser.getUsername());
		String adminRole = "1";//0 admin
		for(String role :roleList){
			if(StringUtils.equals("admin",role)){
				adminRole = "0";
				break;
			}
		}
		if(StringUtils.equals("1",adminRole)){
			queryWrapper.eq("a.create_by",sysUser.getUsername());
		}
		//-------------获取当前登陆人是否是管理员角色，如果不是都按照教务秘书处理---------------------------

//		QueryWrapper<KcZzSzkc> queryWrapper = QueryGenerator.initQueryWrapper(kcZzSzkc, req.getParameterMap());
		Page<KcZzSzkc> page = new Page<KcZzSzkc>(pageNo, pageSize);
		IPage<KcZzSzkc> pageList = kcZzSzkcService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param kcZzSzkc
	 * @return
	 */
	@AutoLog(value = "思政课程评价记录-添加")
	@ApiOperation(value="思政课程评价记录-添加", notes="思政课程评价记录-添加")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody KcZzSzkc kcZzSzkc) {


		KcZzSzkc KcZzSzkcPar =kcZzSzkc;
		QueryWrapper<KcZzSzkc> queryWrapper = new QueryWrapper<>();
		queryWrapper.eq("kcmc",KcZzSzkcPar.getKcmc());
		queryWrapper.eq("skjs",KcZzSzkcPar.getSkjs());
		queryWrapper.eq("skdd",KcZzSzkcPar.getSkdd());
		queryWrapper.eq("skrq",KcZzSzkcPar.getSkrq());
		queryWrapper.eq("tkjsbh",KcZzSzkcPar.getTkjsbh());
		queryWrapper.eq("tkjsxm",KcZzSzkcPar.getTkjsxm());
		queryWrapper.like("pksj", DateUtil.format(KcZzSzkcPar.getPksj(),"yyyy-MM-dd"));
		List<KcZzSzkc> listPar = kcZzSzkcService.list(queryWrapper);
		if(listPar!=null&&listPar.size()>0){
			return Result.error("数据重复了，已经有评价数据");
		}else{
			QueryWrapper<KcKetangbiao> kcKetangbiaoQueryWrapper = new QueryWrapper<>();
			kcKetangbiaoQueryWrapper.eq("kcmc",KcZzSzkcPar.getKcmc());
			kcKetangbiaoQueryWrapper.eq("skdd",KcZzSzkcPar.getSkdd());
			kcKetangbiaoQueryWrapper.eq("skrq",DateUtil.format(KcZzSzkcPar.getSkrq(),"yyyy-MM-dd"));
			kcKetangbiaoQueryWrapper.eq("skjs",KcZzSzkcPar.getSkjs());
			List<KcKetangbiao> kcKetangBiaoList = kcKetangbiaoService.list(kcKetangbiaoQueryWrapper);
			if(kcKetangBiaoList!=null && kcKetangBiaoList.size()>0){
				KcKetangbiao KcKetangbiao = kcKetangBiaoList.get(0);
				KcZzSzkcPar.setKcbh(KcKetangbiao.getKcbh());

				KcTingke kcTingke = new KcTingke();
				kcTingke.setTingketime(DateUtil.format(KcZzSzkcPar.getSkrq(),"yyyy-MM-dd"));
				kcTingke.setKechengbiaoid(KcKetangbiao.getId());
				kcTingke.setUserid(KcZzSzkcPar.getTkjsbh());
				kcTingke.setUsername(KcZzSzkcPar.getTkjsxm());
				kcTingkeService.save(kcTingke);

				String ans1 = KcZzSzkcPar.getAns1();//25
				String ans2 = KcZzSzkcPar.getAns2();//26
				String ans3 = KcZzSzkcPar.getAns3();//27
				String ans4 = KcZzSzkcPar.getAns4();//23
				String ans5 = KcZzSzkcPar.getAns5();//24
				String ans6 = KcZzSzkcPar.getAns6();//28
				String ans7 = KcZzSzkcPar.getAns7();//29
				String ans8 = KcZzSzkcPar.getAns8();//
				String ans9 = KcZzSzkcPar.getAns9();//
				String ans10 = KcZzSzkcPar.getAns10();//
				String ans11 = KcZzSzkcPar.getAns11();//
				String ans12 = KcZzSzkcPar.getAns12();//
				String ans13 = KcZzSzkcPar.getAns13();//
				String ans14 = KcZzSzkcPar.getAns14();//
				String ans15 = KcZzSzkcPar.getAns15();//
				String ans16 = KcZzSzkcPar.getAns16();//
				int upuserid = 0;
				if(StringUtils.isNotBlank(KcZzSzkcPar.getTkjsbh())){
					upuserid = Integer.parseInt(KcZzSzkcPar.getTkjsbh());
				}
				String upuser = KcZzSzkcPar.getTkjsxm();
				Date tkrq = KcZzSzkcPar.getPksj();
				int evaluationver = 5;
				String kcid = KcKetangbiao.getId();
				KcEvaluation kcEvaluation = new KcEvaluation();
				kcEvaluation.setUpuserid(upuserid);
				kcEvaluation.setUpuser(upuser);
				kcEvaluation.setEvaluationver(evaluationver);
				kcEvaluation.setUpTimestamp(DateUtil.format(tkrq,"yyyy-MM-dd HH:mm:ss"));
				kcEvaluation.setMinkcid(kcid);
				kcEvaluation.setUpDate(tkrq);
				kcEvaluation.setSource(3);
				kcEvaluationService.save(kcEvaluation);

				KcEvaluations kcEvaluations = new KcEvaluations();
				kcEvaluations.setKetangbiaoid(kcid+"");
				kcEvaluations.setUpuser(upuser);
				kcEvaluations.setUpuserid(upuserid+"");
				kcEvaluations.setEvaluationid(kcEvaluation.getId());
				kcEvaluations.setUpTimestamp(DateUtil.format(tkrq,"yyyy-MM-dd HH:mm:ss"));
				kcEvaluations.setUpDate(tkrq);

				QueryWrapper<KcEvaluationans> kcEvaluationansQueryWrapper1 = new QueryWrapper<>();
				kcEvaluationansQueryWrapper1.eq("queid","61");
				kcEvaluationansQueryWrapper1.eq("ordernum",ans1);
				List<KcEvaluationans> kcEvaluationansList1 = kcEvaluationansService.list(kcEvaluationansQueryWrapper1);
				if(kcEvaluationansList1!=null && kcEvaluationansList1.size()>0){
					kcEvaluations.setId(null);
					kcEvaluations.setQueid(kcEvaluationansList1.get(0).getQueid());
					kcEvaluations.setAnsid(kcEvaluationansList1.get(0).getId());
					kcEvaluationsService.save(kcEvaluations);
				}

				QueryWrapper<KcEvaluationans> kcEvaluationansQueryWrapper2 = new QueryWrapper<>();
				kcEvaluationansQueryWrapper2.eq("queid","62");
				kcEvaluationansQueryWrapper2.eq("ordernum",ans2);
				List<KcEvaluationans> kcEvaluationansList2 = kcEvaluationansService.list(kcEvaluationansQueryWrapper2);
				if(kcEvaluationansList2!=null && kcEvaluationansList2.size()>0){
					kcEvaluations.setId(null);
					kcEvaluations.setQueid(kcEvaluationansList2.get(0).getQueid());
					kcEvaluations.setAnsid(kcEvaluationansList2.get(0).getId());
					kcEvaluationsService.save(kcEvaluations);
				}


				QueryWrapper<KcEvaluationans> kcEvaluationansQueryWrapper3 = new QueryWrapper<>();
				kcEvaluationansQueryWrapper3.eq("queid","63");
				kcEvaluationansQueryWrapper3.eq("ordernum",ans3);
				List<KcEvaluationans> kcEvaluationansList3 = kcEvaluationansService.list(kcEvaluationansQueryWrapper3);
				if(kcEvaluationansList3!=null && kcEvaluationansList3.size()>0){
					kcEvaluations.setId(null);
					kcEvaluations.setQueid(kcEvaluationansList3.get(0).getQueid());
					kcEvaluations.setAnsid(kcEvaluationansList3.get(0).getId());
					kcEvaluationsService.save(kcEvaluations);
				}

				QueryWrapper<KcEvaluationans> kcEvaluationansQueryWrapper4 = new QueryWrapper<>();
				kcEvaluationansQueryWrapper4.eq("queid","64");
				kcEvaluationansQueryWrapper4.eq("ordernum",ans4);
				List<KcEvaluationans> kcEvaluationansList4 = kcEvaluationansService.list(kcEvaluationansQueryWrapper4);
				if(kcEvaluationansList4!=null && kcEvaluationansList4.size()>0){
					kcEvaluations.setId(null);
					kcEvaluations.setQueid(kcEvaluationansList4.get(0).getQueid());
					kcEvaluations.setAnsid(kcEvaluationansList4.get(0).getId());
					kcEvaluationsService.save(kcEvaluations);
				}

				QueryWrapper<KcEvaluationans> kcEvaluationansQueryWrapper5 = new QueryWrapper<>();
				kcEvaluationansQueryWrapper5.eq("queid","65");
				kcEvaluationansQueryWrapper5.eq("ordernum",ans5);
				List<KcEvaluationans> kcEvaluationansList5 = kcEvaluationansService.list(kcEvaluationansQueryWrapper5);
				if(kcEvaluationansList5!=null && kcEvaluationansList5.size()>0){
					kcEvaluations.setId(null);
					kcEvaluations.setQueid(kcEvaluationansList5.get(0).getQueid());
					kcEvaluations.setAnsid(kcEvaluationansList5.get(0).getId());
					kcEvaluationsService.save(kcEvaluations);
				}

				QueryWrapper<KcEvaluationans> kcEvaluationansQueryWrapper6 = new QueryWrapper<>();
				kcEvaluationansQueryWrapper6.eq("queid","66");
				kcEvaluationansQueryWrapper6.eq("ordernum",ans6);
				List<KcEvaluationans> kcEvaluationansList6 = kcEvaluationansService.list(kcEvaluationansQueryWrapper6);
				if(kcEvaluationansList6!=null && kcEvaluationansList6.size()>0){
					kcEvaluations.setId(null);
					kcEvaluations.setQueid(kcEvaluationansList6.get(0).getQueid());
					kcEvaluations.setAnsid(kcEvaluationansList6.get(0).getId());
					kcEvaluationsService.save(kcEvaluations);
				}

				QueryWrapper<KcEvaluationans> kcEvaluationansQueryWrapper7 = new QueryWrapper<>();
				kcEvaluationansQueryWrapper7.eq("queid","67");
				kcEvaluationansQueryWrapper7.eq("ordernum",ans7);
				List<KcEvaluationans> kcEvaluationansList7 = kcEvaluationansService.list(kcEvaluationansQueryWrapper7);
				if(kcEvaluationansList7!=null && kcEvaluationansList7.size()>0){
					kcEvaluations.setId(null);
					kcEvaluations.setQueid(kcEvaluationansList7.get(0).getQueid());
					kcEvaluations.setAnsid(kcEvaluationansList7.get(0).getId());
					kcEvaluationsService.save(kcEvaluations);
				}

				QueryWrapper<KcEvaluationans> kcEvaluationansQueryWrapper8 = new QueryWrapper<>();
				kcEvaluationansQueryWrapper8.eq("queid","68");
				kcEvaluationansQueryWrapper8.eq("ordernum",ans8);
				List<KcEvaluationans> kcEvaluationansList8 = kcEvaluationansService.list(kcEvaluationansQueryWrapper8);
				if(kcEvaluationansList8!=null && kcEvaluationansList8.size()>0){
					kcEvaluations.setId(null);
					kcEvaluations.setQueid(kcEvaluationansList8.get(0).getQueid());
					kcEvaluations.setAnsid(kcEvaluationansList8.get(0).getId());
					kcEvaluationsService.save(kcEvaluations);
				}

				QueryWrapper<KcEvaluationans> kcEvaluationansQueryWrapper9 = new QueryWrapper<>();
				kcEvaluationansQueryWrapper9.eq("queid","69");
				kcEvaluationansQueryWrapper9.eq("ordernum",ans9);
				List<KcEvaluationans> kcEvaluationansList9 = kcEvaluationansService.list(kcEvaluationansQueryWrapper9);
				if(kcEvaluationansList9!=null && kcEvaluationansList9.size()>0){
					kcEvaluations.setId(null);
					kcEvaluations.setQueid(kcEvaluationansList9.get(0).getQueid());
					kcEvaluations.setAnsid(kcEvaluationansList9.get(0).getId());
					kcEvaluationsService.save(kcEvaluations);
				}

				QueryWrapper<KcEvaluationans> kcEvaluationansQueryWrapper10 = new QueryWrapper<>();
				kcEvaluationansQueryWrapper10.eq("queid","70");
				kcEvaluationansQueryWrapper10.eq("ordernum",ans10);
				List<KcEvaluationans> kcEvaluationansList10 = kcEvaluationansService.list(kcEvaluationansQueryWrapper10);
				if(kcEvaluationansList10!=null && kcEvaluationansList10.size()>0){
					kcEvaluations.setId(null);
					kcEvaluations.setQueid(kcEvaluationansList10.get(0).getQueid());
					kcEvaluations.setAnsid(kcEvaluationansList10.get(0).getId());
					kcEvaluationsService.save(kcEvaluations);
				}

				QueryWrapper<KcEvaluationans> kcEvaluationansQueryWrapper11 = new QueryWrapper<>();
				kcEvaluationansQueryWrapper11.eq("queid","71");
				kcEvaluationansQueryWrapper11.eq("ordernum",ans11);
				List<KcEvaluationans> kcEvaluationansList11 = kcEvaluationansService.list(kcEvaluationansQueryWrapper11);
				if(kcEvaluationansList11!=null && kcEvaluationansList11.size()>0){
					kcEvaluations.setId(null);
					kcEvaluations.setQueid(kcEvaluationansList11.get(0).getQueid());
					kcEvaluations.setAnsid(kcEvaluationansList11.get(0).getId());
					kcEvaluationsService.save(kcEvaluations);
				}

				QueryWrapper<KcEvaluationans> kcEvaluationansQueryWrapper12 = new QueryWrapper<>();
				kcEvaluationansQueryWrapper12.eq("queid","72");
				kcEvaluationansQueryWrapper12.eq("ordernum",ans12);
				List<KcEvaluationans> kcEvaluationansList12 = kcEvaluationansService.list(kcEvaluationansQueryWrapper12);
				if(kcEvaluationansList12!=null && kcEvaluationansList12.size()>0){
					kcEvaluations.setId(null);
					kcEvaluations.setQueid(kcEvaluationansList12.get(0).getQueid());
					kcEvaluations.setAnsid(kcEvaluationansList12.get(0).getId());
					kcEvaluationsService.save(kcEvaluations);
				}

				QueryWrapper<KcEvaluationans> kcEvaluationansQueryWrapper13 = new QueryWrapper<>();
				kcEvaluationansQueryWrapper13.eq("queid","73");
				kcEvaluationansQueryWrapper13.eq("ordernum",ans13);
				List<KcEvaluationans> kcEvaluationansList13 = kcEvaluationansService.list(kcEvaluationansQueryWrapper13);
				if(kcEvaluationansList13!=null && kcEvaluationansList13.size()>0){
					kcEvaluations.setId(null);
					kcEvaluations.setQueid(kcEvaluationansList13.get(0).getQueid());
					kcEvaluations.setAnsid(kcEvaluationansList13.get(0).getId());
					kcEvaluationsService.save(kcEvaluations);
				}

				QueryWrapper<KcEvaluationans> kcEvaluationansQueryWrapper14 = new QueryWrapper<>();
				kcEvaluationansQueryWrapper14.eq("queid","75");
				kcEvaluationansQueryWrapper14.eq("ordernum",ans14);
				List<KcEvaluationans> kcEvaluationansList14 = kcEvaluationansService.list(kcEvaluationansQueryWrapper14);
				if(kcEvaluationansList14!=null && kcEvaluationansList14.size()>0){
					kcEvaluations.setId(null);
					kcEvaluations.setQueid(kcEvaluationansList14.get(0).getQueid());
					kcEvaluations.setAnsid(kcEvaluationansList14.get(0).getId());
					kcEvaluationsService.save(kcEvaluations);
				}

				if(StringUtils.isNotBlank(ans15)){
					kcEvaluations.setId(null);
					kcEvaluations.setQueid(74);
					kcEvaluations.setAnsid(0);
					kcEvaluations.setTextanscontent(ans15);
					kcEvaluationsService.save(kcEvaluations);
				}


				if(StringUtils.isNotBlank(ans16)){
					kcEvaluations.setId(null);
					kcEvaluations.setQueid(76);
					kcEvaluations.setAnsid(0);
					kcEvaluations.setTextanscontent(ans16);
					kcEvaluationsService.save(kcEvaluations);
				}
				kcZzSzkcService.save(kcZzSzkc);
			}else{
				return Result.error("课堂表数据错误，未查出对应数据");
			}
		}


		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param kcZzSzkc
	 * @return
	 */
	@AutoLog(value = "思政课程评价记录-编辑")
	@ApiOperation(value="思政课程评价记录-编辑", notes="思政课程评价记录-编辑")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody KcZzSzkc kcZzSzkc) {
		kcZzSzkcService.updateById(kcZzSzkc);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "思政课程评价记录-通过id删除")
	@ApiOperation(value="思政课程评价记录-通过id删除", notes="思政课程评价记录-通过id删除")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		kcZzSzkcService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "思政课程评价记录-批量删除")
	@ApiOperation(value="思政课程评价记录-批量删除", notes="思政课程评价记录-批量删除")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.kcZzSzkcService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "思政课程评价记录-通过id查询")
	@ApiOperation(value="思政课程评价记录-通过id查询", notes="思政课程评价记录-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<KcZzSzkc> queryById(@RequestParam(name="id",required=true) String id) {
		KcZzSzkc kcZzSzkc = kcZzSzkcService.getById(id);
		if(kcZzSzkc==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(kcZzSzkc);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param kcZzSzkc
    */
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, KcZzSzkc kcZzSzkc) {
        return super.exportXls(request, kcZzSzkc, KcZzSzkc.class, "思政课程评价记录");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
		MultipartHttpServletRequest multipartRequest = (MultipartHttpServletRequest) request;
		Map<String, MultipartFile> fileMap = multipartRequest.getFileMap();
		for (Map.Entry<String, MultipartFile> entity : fileMap.entrySet()) {
			// 获取上传文件对象
			MultipartFile file = entity.getValue();
			ImportParams params = new ImportParams();
			params.setTitleRows(2);
			params.setHeadRows(1);
			params.setNeedSave(true);
			try {
				List<KcZzSzkc> list = ExcelImportUtil.importExcel(file.getInputStream(), KcZzSzkc.class, params);
				String rest = "";
				String errorRest = "";
				for(KcZzSzkc KcZzSzkcPar : list){
					if(StringUtils.isBlank(KcZzSzkcPar.getTkjsbh())){
						QueryWrapper<KcAssessuser> queryWrapper1 = new QueryWrapper<>();
						String upuser = KcZzSzkcPar.getTkjsxm();
						queryWrapper1.eq("username",upuser);
						queryWrapper1.last("limit 1");
						KcAssessuser KcCasusers = kcAssessuserService.getOne(queryWrapper1);
						if(KcCasusers!=null){
							KcZzSzkcPar.setTkjsbh(KcCasusers.getUsercode()+"");
						}
					}

				}
				List<KcZzSzkc> newList = new ArrayList<>();
				int errNum = 0;
				for(int i=0;i<list.size();i++){
					KcZzSzkc KcZzSzkcPar = list.get(i);
					QueryWrapper<KcZzSzkc> queryWrapper = new QueryWrapper<>();
//					queryWrapper.eq("kcbh",KcZzSzkcPar.getKcbh());
					queryWrapper.eq("kcmc",KcZzSzkcPar.getKcmc());
					queryWrapper.eq("skjs",KcZzSzkcPar.getSkjs());
					queryWrapper.eq("skdd",KcZzSzkcPar.getSkdd());
					queryWrapper.eq("skrq",KcZzSzkcPar.getSkrq());
					queryWrapper.eq("tkjsbh",KcZzSzkcPar.getTkjsbh());
					queryWrapper.eq("tkjsxm",KcZzSzkcPar.getTkjsxm());
					queryWrapper.like("pksj",DateUtil.format(KcZzSzkcPar.getPksj(),"yyyy-MM-dd"));
					List<KcZzSzkc> listPar = kcZzSzkcService.list(queryWrapper);
					if(listPar!=null&&listPar.size()>0){
						errNum++;
						errorRest += "已经导入（重复数据）："+KcZzSzkcPar.getKcmc()+"-"+KcZzSzkcPar.getSkjs()+"-"+KcZzSzkcPar.getSkdd()+"-"+KcZzSzkcPar.getTkjsbh()+"-"+KcZzSzkcPar.getTkjsxm()+"<br/>";
					}else{
						QueryWrapper<KcKetangbiao> kcKetangbiaoQueryWrapper = new QueryWrapper<>();
//						kcKetangbiaoQueryWrapper.eq("kcbh",KcZzSzkcPar.getKcbh());
						kcKetangbiaoQueryWrapper.eq("kcmc",KcZzSzkcPar.getKcmc());
						kcKetangbiaoQueryWrapper.eq("skdd",KcZzSzkcPar.getSkdd());
						kcKetangbiaoQueryWrapper.eq("skrq",DateUtil.format(KcZzSzkcPar.getSkrq(),"yyyy-MM-dd"));
						kcKetangbiaoQueryWrapper.eq("skjs",KcZzSzkcPar.getSkjs());
						List<KcKetangbiao> kcKetangBiaoList = kcKetangbiaoService.list(kcKetangbiaoQueryWrapper);
						if(kcKetangBiaoList!=null && kcKetangBiaoList.size()>0){
							KcKetangbiao KcKetangbiao = kcKetangBiaoList.get(0);
							KcZzSzkcPar.setKcbh(KcKetangbiao.getKcbh());
							newList.add(KcZzSzkcPar);

							KcTingke kcTingke = new KcTingke();
							kcTingke.setTingketime(DateUtil.format(KcZzSzkcPar.getSkrq(),"yyyy-MM-dd"));
							kcTingke.setKechengbiaoid(KcKetangbiao.getId());
							kcTingke.setUserid(KcZzSzkcPar.getTkjsbh());
							kcTingke.setUsername(KcZzSzkcPar.getTkjsxm());
							kcTingkeService.save(kcTingke);

							String ans1 = KcZzSzkcPar.getAns1();//25	授课有启发性，能给予学生思考、联想、创造的启迪
							String ans2 = KcZzSzkcPar.getAns2();//26	能有效利用各种教学媒体，课件或板书使用效果好
							String ans3 = KcZzSzkcPar.getAns3();//27	仪表得体，按时上下课，严格要求学生
							String ans4 = KcZzSzkcPar.getAns4();//23	讲课有热情，精神饱满，能调动学生情绪，课堂气氛活跃
							String ans5 = KcZzSzkcPar.getAns5();//24	教学目标明确，内容丰富，重点突出，语言表达清楚
							String ans6 = KcZzSzkcPar.getAns6();//28	无迟到、早退、旷课现象
							String ans7 = KcZzSzkcPar.getAns7();//29	课堂教学秩序好，无喧闹、打瞌睡、发短信、玩手机等现象
							int upuserid = 0;
							if(StringUtils.isNotBlank(KcZzSzkcPar.getTkjsbh())){
								upuserid = Integer.parseInt(KcZzSzkcPar.getTkjsbh());
							}
							String upuser = KcZzSzkcPar.getTkjsxm();
							Date tkrq = KcZzSzkcPar.getPksj();
							int evaluationver = 5;
							String kcid = KcKetangbiao.getId();
							KcEvaluation kcEvaluation = new KcEvaluation();
							kcEvaluation.setUpuserid(upuserid);
							kcEvaluation.setUpuser(upuser);
							kcEvaluation.setEvaluationver(evaluationver);
							kcEvaluation.setUpTimestamp(DateUtil.format(tkrq,"yyyy-MM-dd HH:mm:ss"));
							kcEvaluation.setMinkcid(kcid);
							kcEvaluation.setUpDate(tkrq);
							kcEvaluation.setSource(3);
							kcEvaluationService.save(kcEvaluation);

							KcEvaluations kcEvaluations = new KcEvaluations();
							kcEvaluations.setKetangbiaoid(kcid+"");
							kcEvaluations.setUpuser(upuser);
							kcEvaluations.setUpuserid(upuserid+"");
							kcEvaluations.setEvaluationid(kcEvaluation.getId());
							kcEvaluations.setUpTimestamp(DateUtil.format(tkrq,"yyyy-MM-dd HH:mm:ss"));
							kcEvaluations.setUpDate(tkrq);


							if("A".equals(ans1)){ans1 = "5";}
							else if("B".equals(ans1)){ans1 = "4";}
							else if("C".equals(ans1)){ans1 = "3";}
							else if("D".equals(ans1)){ans1 = "2";}
							else if("E".equals(ans1)){ans1 = "1";}

							if("A".equals(ans2)){ans2 = "5";}
							else if("B".equals(ans2)){ans2 = "4";}
							else if("C".equals(ans2)){ans2 = "3";}
							else if("D".equals(ans2)){ans2 = "2";}
							else if("E".equals(ans2)){ans2 = "1";}

							if("A".equals(ans3)){ans3 = "5";}
							else if("B".equals(ans3)){ans3 = "4";}
							else if("C".equals(ans3)){ans3 = "3";}
							else if("D".equals(ans3)){ans3 = "2";}
							else if("E".equals(ans3)){ans3 = "1";}

							if("A".equals(ans4)){ans4 = "5";}
							else if("B".equals(ans4)){ans4 = "4";}
							else if("C".equals(ans4)){ans4 = "3";}
							else if("D".equals(ans4)){ans4 = "2";}
							else if("E".equals(ans4)){ans4 = "1";}

							if("A".equals(ans5)){ans5 = "5";}
							else if("B".equals(ans5)){ans5 = "4";}
							else if("C".equals(ans5)){ans5 = "3";}
							else if("D".equals(ans5)){ans5 = "2";}
							else if("E".equals(ans5)){ans5 = "1";}

							if("A".equals(ans6)){ans6 = "5";}
							else if("B".equals(ans6)){ans6 = "4";}
							else if("C".equals(ans6)){ans6 = "3";}
							else if("D".equals(ans6)){ans6 = "2";}
							else if("E".equals(ans6)){ans6 = "1";}

							if("A".equals(ans7)){ans7 = "5";}
							else if("B".equals(ans7)){ans7 = "4";}
							else if("C".equals(ans7)){ans7 = "3";}
							else if("D".equals(ans7)){ans7 = "2";}
							else if("E".equals(ans7)){ans7 = "1";}



							QueryWrapper<KcEvaluationans> kcEvaluationansQueryWrapper1 = new QueryWrapper<>();
							kcEvaluationansQueryWrapper1.eq("queid","61");
							kcEvaluationansQueryWrapper1.eq("ordernum",ans1);
							List<KcEvaluationans> kcEvaluationansList1 = kcEvaluationansService.list(kcEvaluationansQueryWrapper1);
							if(kcEvaluationansList1!=null && kcEvaluationansList1.size()>0){
								kcEvaluations.setId(null);
								kcEvaluations.setQueid(kcEvaluationansList1.get(0).getQueid());
								kcEvaluations.setAnsid(kcEvaluationansList1.get(0).getId());
								kcEvaluationsService.save(kcEvaluations);
							}

							QueryWrapper<KcEvaluationans> kcEvaluationansQueryWrapper2 = new QueryWrapper<>();
							kcEvaluationansQueryWrapper2.eq("queid","62");
							kcEvaluationansQueryWrapper2.eq("ordernum",ans2);
							List<KcEvaluationans> kcEvaluationansList2 = kcEvaluationansService.list(kcEvaluationansQueryWrapper2);
							if(kcEvaluationansList2!=null && kcEvaluationansList2.size()>0){
								kcEvaluations.setId(null);
								kcEvaluations.setQueid(kcEvaluationansList2.get(0).getQueid());
								kcEvaluations.setAnsid(kcEvaluationansList2.get(0).getId());
								kcEvaluationsService.save(kcEvaluations);
							}


							QueryWrapper<KcEvaluationans> kcEvaluationansQueryWrapper3 = new QueryWrapper<>();
							kcEvaluationansQueryWrapper3.eq("queid","63");
							kcEvaluationansQueryWrapper3.eq("ordernum",ans3);
							List<KcEvaluationans> kcEvaluationansList3 = kcEvaluationansService.list(kcEvaluationansQueryWrapper3);
							if(kcEvaluationansList3!=null && kcEvaluationansList3.size()>0){
								kcEvaluations.setId(null);
								kcEvaluations.setQueid(kcEvaluationansList3.get(0).getQueid());
								kcEvaluations.setAnsid(kcEvaluationansList3.get(0).getId());
								kcEvaluationsService.save(kcEvaluations);
							}

							QueryWrapper<KcEvaluationans> kcEvaluationansQueryWrapper4 = new QueryWrapper<>();
							kcEvaluationansQueryWrapper4.eq("queid","64");
							kcEvaluationansQueryWrapper4.eq("ordernum",ans4);
							List<KcEvaluationans> kcEvaluationansList4 = kcEvaluationansService.list(kcEvaluationansQueryWrapper4);
							if(kcEvaluationansList4!=null && kcEvaluationansList4.size()>0){
								kcEvaluations.setId(null);
								kcEvaluations.setQueid(kcEvaluationansList4.get(0).getQueid());
								kcEvaluations.setAnsid(kcEvaluationansList4.get(0).getId());
								kcEvaluationsService.save(kcEvaluations);
							}

							if(StringUtils.isNotBlank(ans5)){
								kcEvaluations.setId(null);
								kcEvaluations.setQueid(65);
								kcEvaluations.setAnsid(0);
								kcEvaluations.setTextanscontent(ans5);
								kcEvaluationsService.save(kcEvaluations);
							}

							QueryWrapper<KcEvaluationans> kcEvaluationansQueryWrapper6 = new QueryWrapper<>();
							kcEvaluationansQueryWrapper6.eq("queid","66");
							kcEvaluationansQueryWrapper6.eq("ordernum",ans6);
							List<KcEvaluationans> kcEvaluationansList6 = kcEvaluationansService.list(kcEvaluationansQueryWrapper6);
							if(kcEvaluationansList6!=null && kcEvaluationansList6.size()>0){
								kcEvaluations.setId(null);
								kcEvaluations.setQueid(kcEvaluationansList6.get(0).getQueid());
								kcEvaluations.setAnsid(kcEvaluationansList6.get(0).getId());
								kcEvaluationsService.save(kcEvaluations);
							}

							if(StringUtils.isNotBlank(ans7)){
								kcEvaluations.setId(null);
								kcEvaluations.setQueid(67);
								kcEvaluations.setAnsid(0);
								kcEvaluations.setTextanscontent(ans7);
								kcEvaluationsService.save(kcEvaluations);
							}


						}else{
							errNum++;
							newList.remove(KcZzSzkcPar);
							errorRest += "未查到匹配课堂："+KcZzSzkcPar.getKcmc()+"-"+KcZzSzkcPar.getSkjs()+"-"+KcZzSzkcPar.getSkdd()+"-"+KcZzSzkcPar.getTkjsbh()+"-"+KcZzSzkcPar.getTkjsxm()+"<br/>";
						}
					}
				}
				//update-begin-author:taoyan date:20190528 for:批量插入数据
				long start = System.currentTimeMillis();
				service.saveBatch(newList);
				//400条 saveBatch消耗时间1592毫秒  循环插入消耗时间1947毫秒
				//1200条  saveBatch消耗时间3687毫秒 循环插入消耗时间5212毫秒
				log.info("消耗时间" + (System.currentTimeMillis() - start) + "毫秒");
				//update-end-author:taoyan date:20190528 for:批量插入数据
//				rest = "文件导入成功！数据行数：" + newList.size();
				if(newList.size()>0){
					rest = "文件导入成功!数据行数：" + newList.size();
				}
				if(StringUtils.isNotBlank(errorRest)){
					errorRest = "<br/>共错误："+errNum+"行；错误数据如下：<br/>"+errorRest;
				}
				//刷新统计
				changeTingKeTongJi.changeTingKeTongji();
				return Result.ok(rest+errorRest);
			} catch (Exception e) {
				//update-begin-author:taoyan date:20211124 for: 导入数据重复增加提示
				String msg = e.getMessage();
				log.error(msg, e);
				if(msg!=null && msg.indexOf("Duplicate entry")>=0){
					return Result.error("文件导入失败:有重复数据！");
				}else{
					return Result.error("文件导入失败:" + e.getMessage());
				}
				//update-end-author:taoyan date:20211124 for: 导入数据重复增加提示
			} finally {
				try {
					file.getInputStream().close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
		}
		return Result.error("文件导入失败！");
	}

}
