package org.jeecg.modules.kc.kcZzSzkc.entity;

import java.io.Serializable;
import java.io.UnsupportedEncodingException;
import java.util.Date;
import java.math.BigDecimal;

import com.baomidou.mybatisplus.annotation.*;
import lombok.Data;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;
import org.jeecgframework.poi.excel.annotation.Excel;
import org.jeecg.common.aspect.annotation.Dict;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * @Description: 思政课程评价记录
 * @Author: jeecg-boot
 * @Date:   2024-09-25
 * @Version: V1.0
 */
@Data
@TableName("kc_zz_szkc")
@Accessors(chain = true)
@EqualsAndHashCode(callSuper = false)
@ApiModel(value="kc_zz_szkc对象", description="思政课程评价记录")
public class KcZzSzkc implements Serializable {
    private static final long serialVersionUID = 1L;

	/**id*/
	@TableId(type = IdType.ASSIGN_ID)
    @ApiModelProperty(value = "id")
    private java.lang.String id;
	/**创建人*/
    @ApiModelProperty(value = "创建人")
    private java.lang.String createBy;
	/**创建日期*/
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd")
    @DateTimeFormat(pattern="yyyy-MM-dd")
    @ApiModelProperty(value = "创建日期")
    private java.util.Date createTime;
	/**更新人*/
    @ApiModelProperty(value = "更新人")
    private java.lang.String updateBy;
	/**更新日期*/
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd")
    @DateTimeFormat(pattern="yyyy-MM-dd")
    @ApiModelProperty(value = "更新日期")
    private java.util.Date updateTime;
	/**所属部门*/
    @ApiModelProperty(value = "所属部门")
    private java.lang.String sysOrgCode;
	/**课程编号*/
	@Excel(name = "课程编号", width = 15)
    @ApiModelProperty(value = "课程编号")
    private java.lang.String kcbh;
	/**课程名称*/
	@Excel(name = "课程名称", width = 15)
    @ApiModelProperty(value = "课程名称")
    private java.lang.String kcmc;
	/**授课教师*/
	@Excel(name = "授课教师", width = 15)
    @ApiModelProperty(value = "授课教师")
    private java.lang.String skjs;
	/**授课时间*/
	@Excel(name = "授课时间", width = 15, format = "yyyy-MM-dd")
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd")
    @DateTimeFormat(pattern="yyyy-MM-dd")
    @ApiModelProperty(value = "授课时间")
    private java.util.Date skrq;
	/**上课地点*/
	@Excel(name = "上课地点", width = 15)
    @ApiModelProperty(value = "上课地点")
    private java.lang.String skdd;
	/**听课教师编号*/
	@Excel(name = "听课教师编号", width = 15)
    @ApiModelProperty(value = "听课教师编号")
    private java.lang.String tkjsbh;
	/**听课教师姓名*/
	@Excel(name = "听课教师姓名", width = 15)
    @ApiModelProperty(value = "听课教师姓名")
    private java.lang.String tkjsxm;
	/**评课时间*/
	@Excel(name = "评课时间", width = 15, format = "yyyy-MM-dd")
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd")
    @DateTimeFormat(pattern="yyyy-MM-dd")
    @ApiModelProperty(value = "评课时间")
    private java.util.Date pksj;
	/**教学态度*/
	@Excel(name = "仪表整洁、举止得体、精神饱满", width = 15,dicCode = "five_dict")
    @ApiModelProperty(value = "仪表整洁、举止得体、精神饱满")
    @Dict(dicCode = "five_dict")
    private java.lang.String ans1;
	/**教学内容*/
	@Excel(name = "遵守教学纪律，严格课堂管理", width = 15,dicCode = "five_dict")
    @ApiModelProperty(value = "遵守教学纪律，严格课堂管理")
    @Dict(dicCode = "five_dict")
    private java.lang.String ans2;
	/**教学方法*/
	@Excel(name = "备课充分，精心设计教学（有课件、教案等教学素材），教学投入", width = 15,dicCode = "five_dict")
    @ApiModelProperty(value = "备课充分，精心设计教学（有课件、教案等教学素材），教学投入")
    @Dict(dicCode = "five_dict")
    private java.lang.String ans3;
	/**教学效果*/
	@Excel(name = "坚持马克思主义立场观点方法，具有较为扎实的马克思主义理论功底，教学目标明确", width = 15,dicCode = "five_dict")
    @ApiModelProperty(value = "坚持马克思主义立场观点方法，具有较为扎实的马克思主义理论功底，教学目标明确")
    @Dict(dicCode = "five_dict")
    private java.lang.String ans4;
	/**课堂诊断*/
	@Excel(name = "有效使用统编教材配套课件、参考讲义、辅导用书，教学内容科学完整，基本理论阐释清楚，基本事实讲述准确，重点、难点比较突出", width = 15,dicCode = "five_dict")
    @ApiModelProperty(value = "有效使用统编教材配套课件、参考讲义、辅导用书，教学内容科学完整，基本理论阐释清楚，基本事实讲述准确，重点、难点比较突出")
    @Dict(dicCode = "five_dict")
    private java.lang.String ans5;
	/**总体评价*/
	@Excel(name = "理论联系实际，熟悉党史、新中国史、改革开放史、社会主义发展史、中华民族发展史，注重史论结合，教学素材多样，案例鲜活生动，及时将新时代中国特色社会主义的生动实践转化为课堂教学资源", width = 15,dicCode = "five_dict")
    @ApiModelProperty(value = "理论联系实际，熟悉党史、新中国史、改革开放史、社会主义发展史、中华民族发展史，注重史论结合，教学素材多样，案例鲜活生动，及时将新时代中国特色社会主义的生动实践转化为课堂教学资源")
    @Dict(dicCode = "five_dict")
    private java.lang.String ans6;
	/**指导建议*/
	@Excel(name = "贴近学生实际，善于发掘身边人身边事蕴含的育人元素，有效回应学生关心问题和思想困惑", width = 15,dicCode = "five_dict")
    @ApiModelProperty(value = "贴近学生实际，善于发掘身边人身边事蕴含的育人元素，有效回应学生关心问题和思想困惑")
    @Dict(dicCode = "five_dict")
    private java.lang.String ans7;
    @Dict(dicCode = "five_dict")
    @Excel(name = "熟悉教学法基本原理，注重教学逻辑与学术逻辑的辩证统一，教学设计符合学生认知规律、关注学生差异性", width = 15,dicCode = "five_dict")
    private java.lang.String ans8;
    @Dict(dicCode = "five_dict")
    @Excel(name = "熟练运用启发式、案例式等教学法，注重课堂互动，不照本宣科，善于调动学生积极性，启发学生思考", width = 15,dicCode = "five_dict")
    private java.lang.String ans9;
    @Dict(dicCode = "five_dict")
    @Excel(name = "综合运用现代信息技术手段，增强课堂教学的生动性、吸引力，帮助学生理解领会教学内容", width = 15,dicCode = "five_dict")
    private java.lang.String ans10;
    @Dict(dicCode = "five_dict")
    @Excel(name = "注重思想性和理论性，具有亲和力和感染力，能够把道理讲深、讲透、讲活，学生学习积极性高，愿意与教师交流反馈", width = 15,dicCode = "five_dict")
    private java.lang.String ans11;
    @Dict(dicCode = "five_dict")
    @Excel(name = "注重价值引领，增进对党的创新理论的政治认同、思想认同、理论认同、情感认同，坚定“四个自信”", width = 15,dicCode = "five_dict")
    private java.lang.String ans12;
    @Dict(dicCode = "five_dict")
    @Excel(name = "完成教学计划，课堂秩序良好", width = 15,dicCode = "five_dict")
    private java.lang.String ans13;
    @Dict(dicCode = "five_dict")
    @Excel(name = "总体评价", width = 15,dicCode = "five_dict")
    private java.lang.String ans14;
    @Excel(name = "课堂诊断", width = 15)
    private java.lang.String ans15;
    @Excel(name = "指导建议", width = 15)
    private java.lang.String ans16;

    @TableField(exist = false)
    private String xqxn;
}
