package org.jeecg.modules.kc.kcZzThpjb.controller;

import java.util.*;
import java.util.stream.Collectors;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import cn.hutool.core.date.DateUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.SecurityUtils;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.system.vo.LoginUser;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.kc.grab.SynchronizationService.tools.ChangeTingKeTongJi;
import org.jeecg.modules.kc.kcAssessuser.entity.KcAssessuser;
import org.jeecg.modules.kc.kcAssessuser.service.IKcAssessuserService;
import org.jeecg.modules.kc.kcZzThpjb.entity.KcZzThpjb;
import org.jeecg.modules.kc.kcZzThpjb.service.IKcZzThpjbService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecg.modules.kc.kcZzYbtkb.entity.KcZzYbtkb;
import org.jeecg.modules.kc.ktgl.entity.KcKetangbiao;
import org.jeecg.modules.kc.ktgl.service.IKcKetangbiaoService;
import org.jeecg.modules.kc.qa.entity.KcEvaluation;
import org.jeecg.modules.kc.qa.entity.KcEvaluationans;
import org.jeecg.modules.kc.qa.entity.KcEvaluations;
import org.jeecg.modules.kc.qa.service.IKcEvaluationService;
import org.jeecg.modules.kc.qa.service.IKcEvaluationansService;
import org.jeecg.modules.kc.qa.service.IKcEvaluationsService;
import org.jeecg.modules.kc.tktj.entity.KcTingke;
import org.jeecg.modules.kc.tktj.service.IKcTingkeService;
import org.jeecg.modules.system.service.impl.SysBaseApiImpl;
import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

 /**
 * @Description: 纸质同行评价表
 * @Author: jeecg-boot
 * @Date:   2023-05-24
 * @Version: V1.0
 */
@Api(tags="纸质同行评价表")
@RestController
@RequestMapping("/kcZzThpjb/kcZzThpjb")
@Slf4j
public class KcZzThpjbController extends JeecgController<KcZzThpjb, IKcZzThpjbService> {
	@Autowired
	private IKcZzThpjbService kcZzThpjbService;
	 @Autowired
	 private IKcKetangbiaoService kcKetangbiaoService;
	 @Autowired
	 private IKcEvaluationService kcEvaluationService;
	 @Autowired
	 private IKcEvaluationsService kcEvaluationsService;
	 @Autowired
	 private IKcEvaluationansService kcEvaluationansService;
	 @Autowired
	 private ChangeTingKeTongJi changeTingKeTongJi;
	 @Autowired
	 private IKcAssessuserService kcAssessuserService;

	 @Autowired
	 private IKcTingkeService kcTingkeService;
	 @Autowired
	 private SysBaseApiImpl sysBaseApi;
	/**
	 * 分页列表查询
	 *
	 * @param kcZzThpjb
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "纸质同行评价表-分页列表查询")
	@ApiOperation(value="纸质同行评价表-分页列表查询", notes="纸质同行评价表-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<KcZzThpjb>> queryPageList(KcZzThpjb kcZzThpjb,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<KcZzThpjb> queryWrapper = QueryGenerator.initQueryWrapper(kcZzThpjb, req.getParameterMap());
		queryWrapper.eq(StringUtils.isNotBlank(kcZzThpjb.getXqxn()),"b.title",kcZzThpjb.getXqxn());

		//-------------获取当前登陆人是否是管理员角色，如果不是都按照教务秘书处理---------------------------
		LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
		List<String> roleList = sysBaseApi.getRolesByUsername(sysUser.getUsername());
		String adminRole = "1";//0 admin
		for(String role :roleList){
			if(StringUtils.equals("admin",role)){
				adminRole = "0";
				break;
			}
		}
		if(StringUtils.equals("1",adminRole)){
			queryWrapper.eq("a.create_by",sysUser.getUsername());
		}
		//-------------获取当前登陆人是否是管理员角色，如果不是都按照教务秘书处理---------------------------
		Page<KcZzThpjb> page = new Page<KcZzThpjb>(pageNo, pageSize);
		IPage<KcZzThpjb> pageList = kcZzThpjbService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param kcZzThpjb
	 * @return
	 */
	@AutoLog(value = "纸质同行评价表-添加")
	@ApiOperation(value="纸质同行评价表-添加", notes="纸质同行评价表-添加")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody KcZzThpjb kcZzThpjb) {
		{
			KcZzThpjb KcZzThpjbPar = kcZzThpjb;
			QueryWrapper<KcZzThpjb> queryWrapper = new QueryWrapper<>();
			queryWrapper.eq("kcmc",KcZzThpjbPar.getKcmc());
			queryWrapper.eq("skjs",KcZzThpjbPar.getSkjs());
			queryWrapper.eq("skdd",KcZzThpjbPar.getSkdd());
			queryWrapper.eq("sksj",KcZzThpjbPar.getSksj());
			queryWrapper.eq("pjsj",KcZzThpjbPar.getPjsj());
			queryWrapper.eq("pkjsbh",KcZzThpjbPar.getPkjsbh());
			queryWrapper.eq("pkjsxm",KcZzThpjbPar.getPkjsxm());
			List<KcZzThpjb> listPar = kcZzThpjbService.list(queryWrapper);
			if(listPar!=null&&listPar.size()>0){
				return Result.error("数据重复了，已经有评价数据");
			}else{
				QueryWrapper<KcKetangbiao> kcKetangbiaoQueryWrapper = new QueryWrapper<>();
				kcKetangbiaoQueryWrapper.eq("kcmc",KcZzThpjbPar.getKcmc());
				kcKetangbiaoQueryWrapper.eq("skjs",KcZzThpjbPar.getSkjs());
				kcKetangbiaoQueryWrapper.eq("skdd",KcZzThpjbPar.getSkdd());
				kcKetangbiaoQueryWrapper.eq("skrq", DateUtil.format(KcZzThpjbPar.getSksj(),"yyyy-MM-dd"));
				List<KcKetangbiao> kcKetangBiaoList = kcKetangbiaoService.list(kcKetangbiaoQueryWrapper);
				if(kcKetangBiaoList!=null && kcKetangBiaoList.size()>0){
					KcKetangbiao KcKetangbiao = kcKetangBiaoList.get(0);
					KcZzThpjbPar.setKcbh(KcKetangbiao.getKcbh());
					KcTingke kcTingke = new KcTingke();
					kcTingke.setTingketime(DateUtil.format(KcZzThpjbPar.getSksj(),"yyyy-MM-dd"));
					kcTingke.setKechengbiaoid(KcKetangbiao.getId());
					kcTingke.setUserid(KcZzThpjbPar.getPkjsbh());
					kcTingke.setUsername(KcZzThpjbPar.getPkjsxm());
					kcTingkeService.save(kcTingke);


					String ans1 = KcZzThpjbPar.getAns1();//
					String ans2 = KcZzThpjbPar.getAns2();//
					String ans3 = KcZzThpjbPar.getAns3();//
					String ans4 = KcZzThpjbPar.getAns4();//
					String ans5 = KcZzThpjbPar.getAns5();//
					String ans6 = KcZzThpjbPar.getAns6();//
					String ans7 = KcZzThpjbPar.getAns7();//
					String ans8 = KcZzThpjbPar.getAns8();//
					String ans9 = KcZzThpjbPar.getAns9();//
					String ans10 = KcZzThpjbPar.getAns10();//
					String ans11 = KcZzThpjbPar.getAns11();//
					String ans12 = KcZzThpjbPar.getAns12();//
					String ans13 = KcZzThpjbPar.getAns13();//
					String ans14 = KcZzThpjbPar.getAns14();//
					String ans15 = KcZzThpjbPar.getAns15();//
					String ans16 = KcZzThpjbPar.getAns16();//
					String ans17 = KcZzThpjbPar.getAns17();//
					String ans18 = KcZzThpjbPar.getAns18();//
					String ans19 = KcZzThpjbPar.getAns19();//

					String jxlj = KcZzThpjbPar.getJxlj();
					if(StringUtils.isBlank(jxlj)){
						jxlj = "0";
					}
					int dqfs1 = Integer.parseInt(jxlj) / 3;
					ans1 = dqfs1+"";
					ans2 = dqfs1 +"";
					ans3 = (Integer.parseInt(jxlj) - dqfs1-dqfs1)+"";
					if(Integer.parseInt(ans1)>5){ans1="5";}
					if(Integer.parseInt(ans2)>5){ans2="5";}
					if(Integer.parseInt(ans3)>5){ans3="5";}
//							教学理解（10分）
//							33	具有教育理想、敬业精神和教学追求，热爱学生、学科和教学工作。
//							34	掌握所教学科必需的专业与教学知识。具备所教学科的教学设计、实施、评价、反思和研究能力。
//							35	把握学生身心发展规律与特点，尊重学生主体性与差异性。
					String jxtd = KcZzThpjbPar.getJxtd();
					if(StringUtils.isBlank(jxtd)){
						jxtd = "0";
					}
					int dqfs2 = Integer.parseInt(jxtd) / 2;
					ans4 = dqfs2+"";
					ans5 = (Integer.parseInt(jxtd) - dqfs2)+"";
					if(Integer.parseInt(ans4)>5){ans4="5";}
					if(Integer.parseInt(ans5)>5){ans5="5";}
//							教学态度（10分）
//							36	立德树人，为人师表，语言规范，情绪饱满，思想积极向上。
//							37	执行教学计划，遵守教学纪律，严谨从教。
					String jxgc = KcZzThpjbPar.getJxgc();
					if(StringUtils.isBlank(jxgc)){
						jxgc = "0";
					}
					int dqfs3 = Integer.parseInt(jxgc) / 3;
					ans6 = dqfs3+"";
					ans7 = dqfs3 +"";
					ans8 = dqfs3 +"";
					ans9 = dqfs3 +"";
					ans10 = (Integer.parseInt(jxgc) - dqfs3-dqfs3-dqfs3-dqfs3)+"";
					if(Integer.parseInt(ans6)>5){ans6="5";}
					if(Integer.parseInt(ans7)>5){ans7="5";}
					if(Integer.parseInt(ans8)>5){ans8="5";}
					if(Integer.parseInt(ans9)>5){ans9="5";}
					if(Integer.parseInt(ans10)>5){ans10="5";}
//							教学过程（30分）
//							38	系统规划和设计教学活动，合理确定教学目标和教学内容的重难点，选择合适的教学方法、教学媒体和教学形式。
//							39	清晰讲解课程内容，恰当解释知识中蕴含的本源性思想和学科方法，适时引导学生关注课程领域发展新动态。
//							40	启发学生思考，鼓励学生发现、提出问题，恰当给予回应和引导。
//							41	监控教学过程，富有教学机智，教学体现生成性。
//							42	运用多元评价方式，了解学习状况，诊断学习问题，及时反馈。
					String jxxg = KcZzThpjbPar.getJxxg();
					if(StringUtils.isBlank(jxxg)){
						jxxg = "0";
					}
					int dqfs4 = Integer.parseInt(jxxg) / 2;
					ans11 = dqfs4+"";
					ans12 = (Integer.parseInt(jxxg) - dqfs4)+"";
					if(Integer.parseInt(ans11)>5){ans11="5";}
					if(Integer.parseInt(ans12)>5){ans12="5";}
//							教学效果（30分）
//							43	学习认真积极，踊跃参与课堂活动，体会课程学习的挑战与乐趣，感悟课程的意义与价值。
//							44	掌握所学课程的基本概念与原理，理解课程的知识结构与思想体系，了解所学知识的运用情境、策略和方法。
					String jxts = KcZzThpjbPar.getJxts();
					if(StringUtils.isBlank(jxts)){
						jxts = "0";
					}
					int dqfs5 = Integer.parseInt(jxts) / 3;
					ans13 = dqfs5+"";
					ans14 = dqfs5 +"";
					ans15 = (Integer.parseInt(jxts) - dqfs5-dqfs5)+"";
					if(Integer.parseInt(ans13)>5){ans13="5";}
					if(Integer.parseInt(ans14)>5){ans14="5";}
					if(Integer.parseInt(ans15)>5){ans15="5";}



					int upuserid = Integer.parseInt(KcZzThpjbPar.getPkjsbh());
					String upuser = KcZzThpjbPar.getPkjsxm();
					Date tkrq = KcZzThpjbPar.getPjsj();
					int evaluationver = 4;
					String kcid = KcKetangbiao.getId();
					KcEvaluation kcEvaluation = new KcEvaluation();
					kcEvaluation.setUpuserid(upuserid);
					kcEvaluation.setUpuser(upuser);
					kcEvaluation.setEvaluationver(evaluationver);
					kcEvaluation.setUpTimestamp(DateUtil.format(tkrq,"yyyy-MM-dd HH:mm:ss"));
					kcEvaluation.setMinkcid(kcid);
					kcEvaluation.setUpDate(tkrq);
					kcEvaluation.setSource(3);
					kcEvaluationService.save(kcEvaluation);

					KcEvaluations kcEvaluations = new KcEvaluations();
					kcEvaluations.setKetangbiaoid(kcid+"");
					kcEvaluations.setUpuser(upuser);
					kcEvaluations.setUpuserid(upuserid+"");
					kcEvaluations.setEvaluationid(kcEvaluation.getId());
					kcEvaluations.setUpTimestamp(DateUtil.format(tkrq,"yyyy-MM-dd HH:mm:ss"));
					kcEvaluations.setUpDate(tkrq);

					QueryWrapper<KcEvaluationans> kcEvaluationansQueryWrapper1 = new QueryWrapper<>();
					kcEvaluationansQueryWrapper1.eq("queid","33");
					kcEvaluationansQueryWrapper1.eq("ordernum",ans1);
					List<KcEvaluationans> kcEvaluationansList1 = kcEvaluationansService.list(kcEvaluationansQueryWrapper1);
					if(kcEvaluationansList1!=null && kcEvaluationansList1.size()>0){
						kcEvaluations.setId(null);
						kcEvaluations.setQueid(kcEvaluationansList1.get(0).getQueid());
						kcEvaluations.setAnsid(kcEvaluationansList1.get(0).getId());
						kcEvaluationsService.save(kcEvaluations);
					}

					QueryWrapper<KcEvaluationans> kcEvaluationansQueryWrapper2 = new QueryWrapper<>();
					kcEvaluationansQueryWrapper2.eq("queid","34");
					kcEvaluationansQueryWrapper2.eq("ordernum",ans2);
					List<KcEvaluationans> kcEvaluationansList2 = kcEvaluationansService.list(kcEvaluationansQueryWrapper2);
					if(kcEvaluationansList2!=null && kcEvaluationansList2.size()>0){
						kcEvaluations.setId(null);
						kcEvaluations.setQueid(kcEvaluationansList2.get(0).getQueid());
						kcEvaluations.setAnsid(kcEvaluationansList2.get(0).getId());
						kcEvaluationsService.save(kcEvaluations);
					}


					QueryWrapper<KcEvaluationans> kcEvaluationansQueryWrapper3 = new QueryWrapper<>();
					kcEvaluationansQueryWrapper3.eq("queid","35");
					kcEvaluationansQueryWrapper3.eq("ordernum",ans3);
					List<KcEvaluationans> kcEvaluationansList3 = kcEvaluationansService.list(kcEvaluationansQueryWrapper3);
					if(kcEvaluationansList3!=null && kcEvaluationansList3.size()>0){
						kcEvaluations.setId(null);
						kcEvaluations.setQueid(kcEvaluationansList3.get(0).getQueid());
						kcEvaluations.setAnsid(kcEvaluationansList3.get(0).getId());
						kcEvaluationsService.save(kcEvaluations);
					}

					QueryWrapper<KcEvaluationans> kcEvaluationansQueryWrapper4 = new QueryWrapper<>();
					kcEvaluationansQueryWrapper4.eq("queid","36");
					kcEvaluationansQueryWrapper4.eq("ordernum",ans4);
					List<KcEvaluationans> kcEvaluationansList4 = kcEvaluationansService.list(kcEvaluationansQueryWrapper4);
					if(kcEvaluationansList4!=null && kcEvaluationansList4.size()>0){
						kcEvaluations.setId(null);
						kcEvaluations.setQueid(kcEvaluationansList4.get(0).getQueid());
						kcEvaluations.setAnsid(kcEvaluationansList4.get(0).getId());
						kcEvaluationsService.save(kcEvaluations);
					}

					QueryWrapper<KcEvaluationans> kcEvaluationansQueryWrapper5 = new QueryWrapper<>();
					kcEvaluationansQueryWrapper5.eq("queid","37");
					kcEvaluationansQueryWrapper5.eq("ordernum",ans5);
					List<KcEvaluationans> kcEvaluationansList5 = kcEvaluationansService.list(kcEvaluationansQueryWrapper5);
					if(kcEvaluationansList5!=null && kcEvaluationansList5.size()>0){
						kcEvaluations.setId(null);
						kcEvaluations.setQueid(kcEvaluationansList5.get(0).getQueid());
						kcEvaluations.setAnsid(kcEvaluationansList5.get(0).getId());
						kcEvaluationsService.save(kcEvaluations);
					}

					QueryWrapper<KcEvaluationans> kcEvaluationansQueryWrapper6 = new QueryWrapper<>();
					kcEvaluationansQueryWrapper6.eq("queid","38");
					kcEvaluationansQueryWrapper6.eq("ordernum",ans6);
					List<KcEvaluationans> kcEvaluationansList6 = kcEvaluationansService.list(kcEvaluationansQueryWrapper6);
					if(kcEvaluationansList6!=null && kcEvaluationansList6.size()>0){
						kcEvaluations.setId(null);
						kcEvaluations.setQueid(kcEvaluationansList6.get(0).getQueid());
						kcEvaluations.setAnsid(kcEvaluationansList6.get(0).getId());
						kcEvaluationsService.save(kcEvaluations);
					}

					QueryWrapper<KcEvaluationans> kcEvaluationansQueryWrapper7 = new QueryWrapper<>();
					kcEvaluationansQueryWrapper7.eq("queid","39");
					kcEvaluationansQueryWrapper7.eq("ordernum",ans7);
					List<KcEvaluationans> kcEvaluationansList7 = kcEvaluationansService.list(kcEvaluationansQueryWrapper7);
					if(kcEvaluationansList7!=null && kcEvaluationansList7.size()>0){
						kcEvaluations.setId(null);
						kcEvaluations.setQueid(kcEvaluationansList7.get(0).getQueid());
						kcEvaluations.setAnsid(kcEvaluationansList7.get(0).getId());
						kcEvaluationsService.save(kcEvaluations);
					}

					QueryWrapper<KcEvaluationans> kcEvaluationansQueryWrapper8 = new QueryWrapper<>();
					kcEvaluationansQueryWrapper8.eq("queid","40");
					kcEvaluationansQueryWrapper8.eq("ordernum",ans8);
					List<KcEvaluationans> kcEvaluationansList8 = kcEvaluationansService.list(kcEvaluationansQueryWrapper8);
					if(kcEvaluationansList8!=null && kcEvaluationansList8.size()>0){
						kcEvaluations.setId(null);
						kcEvaluations.setQueid(kcEvaluationansList8.get(0).getQueid());
						kcEvaluations.setAnsid(kcEvaluationansList8.get(0).getId());
						kcEvaluationsService.save(kcEvaluations);
					}

					QueryWrapper<KcEvaluationans> kcEvaluationansQueryWrapper9 = new QueryWrapper<>();
					kcEvaluationansQueryWrapper9.eq("queid","41");
					kcEvaluationansQueryWrapper9.eq("ordernum",ans9);
					List<KcEvaluationans> kcEvaluationansList9 = kcEvaluationansService.list(kcEvaluationansQueryWrapper9);
					if(kcEvaluationansList9!=null && kcEvaluationansList9.size()>0){
						kcEvaluations.setId(null);
						kcEvaluations.setQueid(kcEvaluationansList9.get(0).getQueid());
						kcEvaluations.setAnsid(kcEvaluationansList9.get(0).getId());
						kcEvaluationsService.save(kcEvaluations);
					}

					QueryWrapper<KcEvaluationans> kcEvaluationansQueryWrapper10 = new QueryWrapper<>();
					kcEvaluationansQueryWrapper10.eq("queid","42");
					kcEvaluationansQueryWrapper10.eq("ordernum",ans10);
					List<KcEvaluationans> kcEvaluationansList10 = kcEvaluationansService.list(kcEvaluationansQueryWrapper10);
					if(kcEvaluationansList10!=null && kcEvaluationansList10.size()>0){
						kcEvaluations.setId(null);
						kcEvaluations.setQueid(kcEvaluationansList10.get(0).getQueid());
						kcEvaluations.setAnsid(kcEvaluationansList10.get(0).getId());
						kcEvaluationsService.save(kcEvaluations);
					}

					QueryWrapper<KcEvaluationans> kcEvaluationansQueryWrapper11 = new QueryWrapper<>();
					kcEvaluationansQueryWrapper11.eq("queid","43");
					kcEvaluationansQueryWrapper11.eq("ordernum",ans11);
					List<KcEvaluationans> kcEvaluationansList11 = kcEvaluationansService.list(kcEvaluationansQueryWrapper11);
					if(kcEvaluationansList11!=null && kcEvaluationansList11.size()>0){
						kcEvaluations.setId(null);
						kcEvaluations.setQueid(kcEvaluationansList11.get(0).getQueid());
						kcEvaluations.setAnsid(kcEvaluationansList11.get(0).getId());
						kcEvaluationsService.save(kcEvaluations);
					}

					QueryWrapper<KcEvaluationans> kcEvaluationansQueryWrapper12 = new QueryWrapper<>();
					kcEvaluationansQueryWrapper12.eq("queid","44");
					kcEvaluationansQueryWrapper12.eq("ordernum",ans12);
					List<KcEvaluationans> kcEvaluationansList12 = kcEvaluationansService.list(kcEvaluationansQueryWrapper12);
					if(kcEvaluationansList12!=null && kcEvaluationansList12.size()>0){
						kcEvaluations.setId(null);
						kcEvaluations.setQueid(kcEvaluationansList12.get(0).getQueid());
						kcEvaluations.setAnsid(kcEvaluationansList12.get(0).getId());
						kcEvaluationsService.save(kcEvaluations);
					}

					QueryWrapper<KcEvaluationans> kcEvaluationansQueryWrapper13 = new QueryWrapper<>();
					kcEvaluationansQueryWrapper13.eq("queid","45");
					kcEvaluationansQueryWrapper13.eq("ordernum",ans13);
					List<KcEvaluationans> kcEvaluationansList13 = kcEvaluationansService.list(kcEvaluationansQueryWrapper13);
					if(kcEvaluationansList13!=null && kcEvaluationansList13.size()>0){
						kcEvaluations.setId(null);
						kcEvaluations.setQueid(kcEvaluationansList13.get(0).getQueid());
						kcEvaluations.setAnsid(kcEvaluationansList13.get(0).getId());
						kcEvaluationsService.save(kcEvaluations);
					}

					QueryWrapper<KcEvaluationans> kcEvaluationansQueryWrapper14 = new QueryWrapper<>();
					kcEvaluationansQueryWrapper14.eq("queid","46");
					kcEvaluationansQueryWrapper14.eq("ordernum",ans14);
					List<KcEvaluationans> kcEvaluationansList14 = kcEvaluationansService.list(kcEvaluationansQueryWrapper14);
					if(kcEvaluationansList14!=null && kcEvaluationansList14.size()>0){
						kcEvaluations.setId(null);
						kcEvaluations.setQueid(kcEvaluationansList14.get(0).getQueid());
						kcEvaluations.setAnsid(kcEvaluationansList14.get(0).getId());
						kcEvaluationsService.save(kcEvaluations);
					}

					QueryWrapper<KcEvaluationans> kcEvaluationansQueryWrapper15 = new QueryWrapper<>();
					kcEvaluationansQueryWrapper15.eq("queid","47");
					kcEvaluationansQueryWrapper15.eq("ordernum",ans15);
					List<KcEvaluationans> kcEvaluationansList15 = kcEvaluationansService.list(kcEvaluationansQueryWrapper15);
					if(kcEvaluationansList15!=null && kcEvaluationansList15.size()>0){
						kcEvaluations.setId(null);
						kcEvaluations.setQueid(kcEvaluationansList15.get(0).getQueid());
						kcEvaluations.setAnsid(kcEvaluationansList15.get(0).getId());
						kcEvaluationsService.save(kcEvaluations);
					}

					if(StringUtils.isNotBlank(ans19)){
						kcEvaluations.setId(null);
						kcEvaluations.setQueid(51);
						kcEvaluations.setAnsid(0);
						kcEvaluations.setTextanscontent(ans19);
						kcEvaluationsService.save(kcEvaluations);
					}
					kcZzThpjbService.save(kcZzThpjb);

				}else{
					return Result.error("课堂表数据错误，未查出对应数据");

				}
			}
		}
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param kcZzThpjb
	 * @return
	 */
	@AutoLog(value = "纸质同行评价表-编辑")
	@ApiOperation(value="纸质同行评价表-编辑", notes="纸质同行评价表-编辑")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody KcZzThpjb kcZzThpjb) {
		kcZzThpjbService.updateById(kcZzThpjb);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "纸质同行评价表-通过id删除")
	@ApiOperation(value="纸质同行评价表-通过id删除", notes="纸质同行评价表-通过id删除")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		kcZzThpjbService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "纸质同行评价表-批量删除")
	@ApiOperation(value="纸质同行评价表-批量删除", notes="纸质同行评价表-批量删除")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.kcZzThpjbService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "纸质同行评价表-通过id查询")
	@ApiOperation(value="纸质同行评价表-通过id查询", notes="纸质同行评价表-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<KcZzThpjb> queryById(@RequestParam(name="id",required=true) String id) {
		KcZzThpjb kcZzThpjb = kcZzThpjbService.getById(id);
		if(kcZzThpjb==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(kcZzThpjb);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param kcZzThpjb
    */
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, KcZzThpjb kcZzThpjb) {
        return super.exportXls(request, kcZzThpjb, KcZzThpjb.class, "纸质同行评价表");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
		MultipartHttpServletRequest multipartRequest = (MultipartHttpServletRequest) request;
		Map<String, MultipartFile> fileMap = multipartRequest.getFileMap();
		for (Map.Entry<String, MultipartFile> entity : fileMap.entrySet()) {
			// 获取上传文件对象
			MultipartFile file = entity.getValue();
			ImportParams params = new ImportParams();
			params.setTitleRows(2);
			params.setHeadRows(1);
			params.setNeedSave(true);
			try {
				List<KcZzThpjb> list = ExcelImportUtil.importExcel(file.getInputStream(), KcZzThpjb.class, params);
				String rest = "";
				String errorRest = "";
				for(KcZzThpjb KcZzThpjb : list){
					if(StringUtils.isBlank(KcZzThpjb.getPkjsbh())){
						QueryWrapper<KcAssessuser> queryWrapper1 = new QueryWrapper<>();
						String upuser = KcZzThpjb.getPkjsxm();
						queryWrapper1.eq("username",upuser);
						queryWrapper1.last("limit 1");
						KcAssessuser KcCasusers = kcAssessuserService.getOne(queryWrapper1);
						if(KcCasusers!=null){
							KcZzThpjb.setPkjsbh(KcCasusers.getUsercode()+"");
						}
					}

				}
				List<KcZzThpjb> newList = new ArrayList<>();
				int errNum = 0;
				for(int i=0;i<list.size();i++){
					KcZzThpjb KcZzThpjbPar = list.get(i);
					QueryWrapper<KcZzThpjb> queryWrapper = new QueryWrapper<>();
//					queryWrapper.eq("kcbh",KcZzThpjbPar.getKcbh());
					queryWrapper.eq("kcmc",KcZzThpjbPar.getKcmc());
					queryWrapper.eq("skjs",KcZzThpjbPar.getSkjs());
					queryWrapper.eq("skdd",KcZzThpjbPar.getSkdd());
					queryWrapper.eq("sksj",KcZzThpjbPar.getSksj());
					queryWrapper.eq("pjsj",KcZzThpjbPar.getPjsj());
					queryWrapper.eq("pkjsbh",KcZzThpjbPar.getPkjsbh());
					queryWrapper.eq("pkjsxm",KcZzThpjbPar.getPkjsxm());
					List<KcZzThpjb> listPar = kcZzThpjbService.list(queryWrapper);
					if(listPar!=null&&listPar.size()>0){
						errNum++;
						errorRest += "已经导入（重复数据）："+KcZzThpjbPar.getKcbh()+"-"+KcZzThpjbPar.getKcmc()+"-"+KcZzThpjbPar.getSkjs()+"-"+KcZzThpjbPar.getSkdd()+"-"+"<br/>";
					}else{
						QueryWrapper<KcKetangbiao> kcKetangbiaoQueryWrapper = new QueryWrapper<>();
//						kcKetangbiaoQueryWrapper.eq("kcbh",KcZzThpjbPar.getKcbh());
						kcKetangbiaoQueryWrapper.eq("kcmc",KcZzThpjbPar.getKcmc());
						kcKetangbiaoQueryWrapper.eq("skjs",KcZzThpjbPar.getSkjs());
						kcKetangbiaoQueryWrapper.eq("skdd",KcZzThpjbPar.getSkdd());
						kcKetangbiaoQueryWrapper.eq("skrq", DateUtil.format(KcZzThpjbPar.getSksj(),"yyyy-MM-dd"));
						List<KcKetangbiao> kcKetangBiaoList = kcKetangbiaoService.list(kcKetangbiaoQueryWrapper);
						if(kcKetangBiaoList!=null && kcKetangBiaoList.size()>0){
							KcKetangbiao KcKetangbiao = kcKetangBiaoList.get(0);
							KcZzThpjbPar.setKcbh(KcKetangbiao.getKcbh());
							newList.add(KcZzThpjbPar);
							KcTingke kcTingke = new KcTingke();
							kcTingke.setTingketime(DateUtil.format(KcZzThpjbPar.getSksj(),"yyyy-MM-dd"));
							kcTingke.setKechengbiaoid(KcKetangbiao.getId());
							kcTingke.setUserid(KcZzThpjbPar.getPkjsbh());
							kcTingke.setUsername(KcZzThpjbPar.getPkjsxm());
							kcTingkeService.save(kcTingke);


							String ans1 = KcZzThpjbPar.getAns1();//
							String ans2 = KcZzThpjbPar.getAns2();//
							String ans3 = KcZzThpjbPar.getAns3();//
							String ans4 = KcZzThpjbPar.getAns4();//
							String ans5 = KcZzThpjbPar.getAns5();//
							String ans6 = KcZzThpjbPar.getAns6();//
							String ans7 = KcZzThpjbPar.getAns7();//
							String ans8 = KcZzThpjbPar.getAns8();//
							String ans9 = KcZzThpjbPar.getAns9();//
							String ans10 = KcZzThpjbPar.getAns10();//
							String ans11 = KcZzThpjbPar.getAns11();//
							String ans12 = KcZzThpjbPar.getAns12();//
							String ans13 = KcZzThpjbPar.getAns13();//
							String ans14 = KcZzThpjbPar.getAns14();//
							String ans15 = KcZzThpjbPar.getAns15();//
							String ans16 = KcZzThpjbPar.getAns16();//
							String ans17 = KcZzThpjbPar.getAns17();//
							String ans18 = KcZzThpjbPar.getAns18();//
							String ans19 = KcZzThpjbPar.getAns19();//

							String jxlj = KcZzThpjbPar.getJxlj();
							if(StringUtils.isBlank(jxlj)){
								jxlj = "0";
							}
							int dqfs1 = Integer.parseInt(jxlj) / 3;
							ans1 = dqfs1+"";
							ans2 = dqfs1 +"";
							ans3 = (Integer.parseInt(jxlj) - dqfs1-dqfs1)+"";
							if(Integer.parseInt(ans1)>5){ans1="5";}
							if(Integer.parseInt(ans2)>5){ans2="5";}
							if(Integer.parseInt(ans3)>5){ans3="5";}
//							教学理解（10分）
//							33	具有教育理想、敬业精神和教学追求，热爱学生、学科和教学工作。
//							34	掌握所教学科必需的专业与教学知识。具备所教学科的教学设计、实施、评价、反思和研究能力。
//							35	把握学生身心发展规律与特点，尊重学生主体性与差异性。
							String jxtd = KcZzThpjbPar.getJxtd();
							if(StringUtils.isBlank(jxtd)){
								jxtd = "0";
							}
							int dqfs2 = Integer.parseInt(jxtd) / 2;
							ans4 = dqfs2+"";
							ans5 = (Integer.parseInt(jxtd) - dqfs2)+"";
							if(Integer.parseInt(ans4)>5){ans4="5";}
							if(Integer.parseInt(ans5)>5){ans5="5";}
//							教学态度（10分）
//							36	立德树人，为人师表，语言规范，情绪饱满，思想积极向上。
//							37	执行教学计划，遵守教学纪律，严谨从教。
							String jxgc = KcZzThpjbPar.getJxgc();
							if(StringUtils.isBlank(jxgc)){
								jxgc = "0";
							}
							int dqfs3 = Integer.parseInt(jxgc) / 3;
							ans6 = dqfs3+"";
							ans7 = dqfs3 +"";
							ans8 = dqfs3 +"";
							ans9 = dqfs3 +"";
							ans10 = (Integer.parseInt(jxgc) - dqfs3-dqfs3-dqfs3-dqfs3)+"";
							if(Integer.parseInt(ans6)>5){ans6="5";}
							if(Integer.parseInt(ans7)>5){ans7="5";}
							if(Integer.parseInt(ans8)>5){ans8="5";}
							if(Integer.parseInt(ans9)>5){ans9="5";}
							if(Integer.parseInt(ans10)>5){ans10="5";}
//							教学过程（30分）
//							38	系统规划和设计教学活动，合理确定教学目标和教学内容的重难点，选择合适的教学方法、教学媒体和教学形式。
//							39	清晰讲解课程内容，恰当解释知识中蕴含的本源性思想和学科方法，适时引导学生关注课程领域发展新动态。
//							40	启发学生思考，鼓励学生发现、提出问题，恰当给予回应和引导。
//							41	监控教学过程，富有教学机智，教学体现生成性。
//							42	运用多元评价方式，了解学习状况，诊断学习问题，及时反馈。
							String jxxg = KcZzThpjbPar.getJxxg();
							if(StringUtils.isBlank(jxxg)){
								jxxg = "0";
							}
							int dqfs4 = Integer.parseInt(jxxg) / 2;
							ans11 = dqfs4+"";
							ans12 = (Integer.parseInt(jxxg) - dqfs4)+"";
							if(Integer.parseInt(ans11)>5){ans11="5";}
							if(Integer.parseInt(ans12)>5){ans12="5";}
//							教学效果（30分）
//							43	学习认真积极，踊跃参与课堂活动，体会课程学习的挑战与乐趣，感悟课程的意义与价值。
//							44	掌握所学课程的基本概念与原理，理解课程的知识结构与思想体系，了解所学知识的运用情境、策略和方法。
							String jxts = KcZzThpjbPar.getJxts();
							if(StringUtils.isBlank(jxts)){
								jxts = "0";
							}
							int dqfs5 = Integer.parseInt(jxts) / 3;
							ans13 = dqfs5+"";
							ans14 = dqfs5 +"";
							ans15 = (Integer.parseInt(jxts) - dqfs5-dqfs5)+"";
							if(Integer.parseInt(ans13)>5){ans13="5";}
							if(Integer.parseInt(ans14)>5){ans14="5";}
							if(Integer.parseInt(ans15)>5){ans15="5";}
//							教学特色（20分）
//							45	遵循教学一般规律，具有鲜明的创新意识和个性风貌。
//							46	尊重学科本质属性，凸显学科育人价值，注重培养学科核心素养。
//							47	课堂教学蕴含理性美，具有教学魅力，体现教学艺术性。






//							48	你对该课程的总体评价情况，5分是满分，您给打几分？
//							49	您认为该课堂值得肯定的方面
//							50	您认为该课堂需要改进的方面
//							51	其它建议



							int upuserid = Integer.parseInt(KcZzThpjbPar.getPkjsbh());
							String upuser = KcZzThpjbPar.getPkjsxm();
							Date tkrq = KcZzThpjbPar.getPjsj();
							int evaluationver = 4;
							String kcid = KcKetangbiao.getId();
							KcEvaluation kcEvaluation = new KcEvaluation();
							kcEvaluation.setUpuserid(upuserid);
							kcEvaluation.setUpuser(upuser);
							kcEvaluation.setEvaluationver(evaluationver);
							kcEvaluation.setUpTimestamp(DateUtil.format(tkrq,"yyyy-MM-dd HH:mm:ss"));
							kcEvaluation.setMinkcid(kcid);
							kcEvaluation.setUpDate(tkrq);
							kcEvaluation.setSource(3);
							kcEvaluationService.save(kcEvaluation);

							KcEvaluations kcEvaluations = new KcEvaluations();
							kcEvaluations.setKetangbiaoid(kcid+"");
							kcEvaluations.setUpuser(upuser);
							kcEvaluations.setUpuserid(upuserid+"");
							kcEvaluations.setEvaluationid(kcEvaluation.getId());
							kcEvaluations.setUpTimestamp(DateUtil.format(tkrq,"yyyy-MM-dd HH:mm:ss"));
							kcEvaluations.setUpDate(tkrq);

							if("A".equals(ans1)){ans1 = "5";}
							else if("B".equals(ans1)){ans1 = "4";}
							else if("C".equals(ans1)){ans1 = "3";}
							else if("D".equals(ans1)){ans1 = "2";}
							else if("E".equals(ans1)){ans1 = "1";}

							if("A".equals(ans2)){ans2 = "5";}
							else if("B".equals(ans2)){ans2 = "4";}
							else if("C".equals(ans2)){ans2 = "3";}
							else if("D".equals(ans2)){ans2 = "2";}
							else if("E".equals(ans2)){ans2 = "1";}

							if("A".equals(ans3)){ans3 = "5";}
							else if("B".equals(ans3)){ans3 = "4";}
							else if("C".equals(ans3)){ans3 = "3";}
							else if("D".equals(ans3)){ans3 = "2";}
							else if("E".equals(ans3)){ans3 = "1";}

							if("A".equals(ans4)){ans4 = "5";}
							else if("B".equals(ans4)){ans4 = "4";}
							else if("C".equals(ans4)){ans4 = "3";}
							else if("D".equals(ans4)){ans4 = "2";}
							else if("E".equals(ans4)){ans4 = "1";}

							if("A".equals(ans5)){ans5 = "5";}
							else if("B".equals(ans5)){ans5 = "4";}
							else if("C".equals(ans5)){ans5 = "3";}
							else if("D".equals(ans5)){ans5 = "2";}
							else if("E".equals(ans5)){ans5 = "1";}

							if("A".equals(ans6)){ans6 = "5";}
							else if("B".equals(ans6)){ans6 = "4";}
							else if("C".equals(ans6)){ans6 = "3";}
							else if("D".equals(ans6)){ans6 = "2";}
							else if("E".equals(ans6)){ans6 = "1";}

							if("A".equals(ans7)){ans7 = "5";}
							else if("B".equals(ans7)){ans7 = "4";}
							else if("C".equals(ans7)){ans7 = "3";}
							else if("D".equals(ans7)){ans7 = "2";}
							else if("E".equals(ans7)){ans7 = "1";}

							if("A".equals(ans8)){ans8 = "5";}
							else if("B".equals(ans8)){ans8 = "4";}
							else if("C".equals(ans8)){ans8 = "3";}
							else if("D".equals(ans8)){ans8 = "2";}
							else if("E".equals(ans8)){ans8 = "1";}

							if("A".equals(ans9)){ans9 = "5";}
							else if("B".equals(ans9)){ans9 = "4";}
							else if("C".equals(ans9)){ans9 = "3";}
							else if("D".equals(ans9)){ans9 = "2";}
							else if("E".equals(ans9)){ans9 = "1";}

							if("A".equals(ans10)){ans10 = "5";}
							else if("B".equals(ans10)){ans10 = "4";}
							else if("C".equals(ans10)){ans10 = "3";}
							else if("D".equals(ans10)){ans10 = "2";}
							else if("E".equals(ans10)){ans10 = "1";}

							if("A".equals(ans11)){ans11 = "5";}
							else if("B".equals(ans11)){ans11 = "4";}
							else if("C".equals(ans11)){ans11 = "3";}
							else if("D".equals(ans11)){ans11 = "2";}
							else if("E".equals(ans11)){ans11 = "1";}

							if("A".equals(ans12)){ans12 = "5";}
							else if("B".equals(ans12)){ans12 = "4";}
							else if("C".equals(ans12)){ans12 = "3";}
							else if("D".equals(ans12)){ans12 = "2";}
							else if("E".equals(ans12)){ans12 = "1";}

							if("A".equals(ans13)){ans13 = "5";}
							else if("B".equals(ans13)){ans13 = "4";}
							else if("C".equals(ans13)){ans13 = "3";}
							else if("D".equals(ans13)){ans13 = "2";}
							else if("E".equals(ans13)){ans13 = "1";}

							if("A".equals(ans14)){ans14 = "5";}
							else if("B".equals(ans14)){ans14 = "4";}
							else if("C".equals(ans14)){ans14 = "3";}
							else if("D".equals(ans14)){ans14 = "2";}
							else if("E".equals(ans14)){ans14 = "1";}

							if("A".equals(ans15)){ans15 = "1";}
							else if("B".equals(ans15)){ans15 = "2";}
							else if("C".equals(ans15)){ans15 = "3";}
							else if("D".equals(ans15)){ans15 = "4";}
							else if("E".equals(ans15)){ans15 = "5";}
							else if("F".equals(ans15)){ans15 = "6";}

//							if("A".equals(ans16)){ans16 = "1";}
//							else if("B".equals(ans16)){ans16 = "2";}
//							else if("C".equals(ans16)){ans16 = "3";}
//							else if("D".equals(ans16)){ans16 = "4";}
//							else if("E".equals(ans16)){ans16 = "5";}
//							else if("F".equals(ans16)){ans16 = "6";}



							QueryWrapper<KcEvaluationans> kcEvaluationansQueryWrapper1 = new QueryWrapper<>();
							kcEvaluationansQueryWrapper1.eq("queid","33");
							kcEvaluationansQueryWrapper1.eq("ordernum",ans1);
							List<KcEvaluationans> kcEvaluationansList1 = kcEvaluationansService.list(kcEvaluationansQueryWrapper1);
							if(kcEvaluationansList1!=null && kcEvaluationansList1.size()>0){
								kcEvaluations.setId(null);
								kcEvaluations.setQueid(kcEvaluationansList1.get(0).getQueid());
								kcEvaluations.setAnsid(kcEvaluationansList1.get(0).getId());
								kcEvaluationsService.save(kcEvaluations);
							}

							QueryWrapper<KcEvaluationans> kcEvaluationansQueryWrapper2 = new QueryWrapper<>();
							kcEvaluationansQueryWrapper2.eq("queid","34");
							kcEvaluationansQueryWrapper2.eq("ordernum",ans2);
							List<KcEvaluationans> kcEvaluationansList2 = kcEvaluationansService.list(kcEvaluationansQueryWrapper2);
							if(kcEvaluationansList2!=null && kcEvaluationansList2.size()>0){
								kcEvaluations.setId(null);
								kcEvaluations.setQueid(kcEvaluationansList2.get(0).getQueid());
								kcEvaluations.setAnsid(kcEvaluationansList2.get(0).getId());
								kcEvaluationsService.save(kcEvaluations);
							}


							QueryWrapper<KcEvaluationans> kcEvaluationansQueryWrapper3 = new QueryWrapper<>();
							kcEvaluationansQueryWrapper3.eq("queid","35");
							kcEvaluationansQueryWrapper3.eq("ordernum",ans3);
							List<KcEvaluationans> kcEvaluationansList3 = kcEvaluationansService.list(kcEvaluationansQueryWrapper3);
							if(kcEvaluationansList3!=null && kcEvaluationansList3.size()>0){
								kcEvaluations.setId(null);
								kcEvaluations.setQueid(kcEvaluationansList3.get(0).getQueid());
								kcEvaluations.setAnsid(kcEvaluationansList3.get(0).getId());
								kcEvaluationsService.save(kcEvaluations);
							}

							QueryWrapper<KcEvaluationans> kcEvaluationansQueryWrapper4 = new QueryWrapper<>();
							kcEvaluationansQueryWrapper4.eq("queid","36");
							kcEvaluationansQueryWrapper4.eq("ordernum",ans4);
							List<KcEvaluationans> kcEvaluationansList4 = kcEvaluationansService.list(kcEvaluationansQueryWrapper4);
							if(kcEvaluationansList4!=null && kcEvaluationansList4.size()>0){
								kcEvaluations.setId(null);
								kcEvaluations.setQueid(kcEvaluationansList4.get(0).getQueid());
								kcEvaluations.setAnsid(kcEvaluationansList4.get(0).getId());
								kcEvaluationsService.save(kcEvaluations);
							}

							QueryWrapper<KcEvaluationans> kcEvaluationansQueryWrapper5 = new QueryWrapper<>();
							kcEvaluationansQueryWrapper5.eq("queid","37");
							kcEvaluationansQueryWrapper5.eq("ordernum",ans5);
							List<KcEvaluationans> kcEvaluationansList5 = kcEvaluationansService.list(kcEvaluationansQueryWrapper5);
							if(kcEvaluationansList5!=null && kcEvaluationansList5.size()>0){
								kcEvaluations.setId(null);
								kcEvaluations.setQueid(kcEvaluationansList5.get(0).getQueid());
								kcEvaluations.setAnsid(kcEvaluationansList5.get(0).getId());
								kcEvaluationsService.save(kcEvaluations);
							}

							QueryWrapper<KcEvaluationans> kcEvaluationansQueryWrapper6 = new QueryWrapper<>();
							kcEvaluationansQueryWrapper6.eq("queid","38");
							kcEvaluationansQueryWrapper6.eq("ordernum",ans6);
							List<KcEvaluationans> kcEvaluationansList6 = kcEvaluationansService.list(kcEvaluationansQueryWrapper6);
							if(kcEvaluationansList6!=null && kcEvaluationansList6.size()>0){
								kcEvaluations.setId(null);
								kcEvaluations.setQueid(kcEvaluationansList6.get(0).getQueid());
								kcEvaluations.setAnsid(kcEvaluationansList6.get(0).getId());
								kcEvaluationsService.save(kcEvaluations);
							}

							QueryWrapper<KcEvaluationans> kcEvaluationansQueryWrapper7 = new QueryWrapper<>();
							kcEvaluationansQueryWrapper7.eq("queid","39");
							kcEvaluationansQueryWrapper7.eq("ordernum",ans7);
							List<KcEvaluationans> kcEvaluationansList7 = kcEvaluationansService.list(kcEvaluationansQueryWrapper7);
							if(kcEvaluationansList7!=null && kcEvaluationansList7.size()>0){
								kcEvaluations.setId(null);
								kcEvaluations.setQueid(kcEvaluationansList7.get(0).getQueid());
								kcEvaluations.setAnsid(kcEvaluationansList7.get(0).getId());
								kcEvaluationsService.save(kcEvaluations);
							}

							QueryWrapper<KcEvaluationans> kcEvaluationansQueryWrapper8 = new QueryWrapper<>();
							kcEvaluationansQueryWrapper8.eq("queid","40");
							kcEvaluationansQueryWrapper8.eq("ordernum",ans8);
							List<KcEvaluationans> kcEvaluationansList8 = kcEvaluationansService.list(kcEvaluationansQueryWrapper8);
							if(kcEvaluationansList8!=null && kcEvaluationansList8.size()>0){
								kcEvaluations.setId(null);
								kcEvaluations.setQueid(kcEvaluationansList8.get(0).getQueid());
								kcEvaluations.setAnsid(kcEvaluationansList8.get(0).getId());
								kcEvaluationsService.save(kcEvaluations);
							}

							QueryWrapper<KcEvaluationans> kcEvaluationansQueryWrapper9 = new QueryWrapper<>();
							kcEvaluationansQueryWrapper9.eq("queid","41");
							kcEvaluationansQueryWrapper9.eq("ordernum",ans9);
							List<KcEvaluationans> kcEvaluationansList9 = kcEvaluationansService.list(kcEvaluationansQueryWrapper9);
							if(kcEvaluationansList9!=null && kcEvaluationansList9.size()>0){
								kcEvaluations.setId(null);
								kcEvaluations.setQueid(kcEvaluationansList9.get(0).getQueid());
								kcEvaluations.setAnsid(kcEvaluationansList9.get(0).getId());
								kcEvaluationsService.save(kcEvaluations);
							}

							QueryWrapper<KcEvaluationans> kcEvaluationansQueryWrapper10 = new QueryWrapper<>();
							kcEvaluationansQueryWrapper10.eq("queid","42");
							kcEvaluationansQueryWrapper10.eq("ordernum",ans10);
							List<KcEvaluationans> kcEvaluationansList10 = kcEvaluationansService.list(kcEvaluationansQueryWrapper10);
							if(kcEvaluationansList10!=null && kcEvaluationansList10.size()>0){
								kcEvaluations.setId(null);
								kcEvaluations.setQueid(kcEvaluationansList10.get(0).getQueid());
								kcEvaluations.setAnsid(kcEvaluationansList10.get(0).getId());
								kcEvaluationsService.save(kcEvaluations);
							}

							QueryWrapper<KcEvaluationans> kcEvaluationansQueryWrapper11 = new QueryWrapper<>();
							kcEvaluationansQueryWrapper11.eq("queid","43");
							kcEvaluationansQueryWrapper11.eq("ordernum",ans11);
							List<KcEvaluationans> kcEvaluationansList11 = kcEvaluationansService.list(kcEvaluationansQueryWrapper11);
							if(kcEvaluationansList11!=null && kcEvaluationansList11.size()>0){
								kcEvaluations.setId(null);
								kcEvaluations.setQueid(kcEvaluationansList11.get(0).getQueid());
								kcEvaluations.setAnsid(kcEvaluationansList11.get(0).getId());
								kcEvaluationsService.save(kcEvaluations);
							}

							QueryWrapper<KcEvaluationans> kcEvaluationansQueryWrapper12 = new QueryWrapper<>();
							kcEvaluationansQueryWrapper12.eq("queid","44");
							kcEvaluationansQueryWrapper12.eq("ordernum",ans12);
							List<KcEvaluationans> kcEvaluationansList12 = kcEvaluationansService.list(kcEvaluationansQueryWrapper12);
							if(kcEvaluationansList12!=null && kcEvaluationansList12.size()>0){
								kcEvaluations.setId(null);
								kcEvaluations.setQueid(kcEvaluationansList12.get(0).getQueid());
								kcEvaluations.setAnsid(kcEvaluationansList12.get(0).getId());
								kcEvaluationsService.save(kcEvaluations);
							}

							QueryWrapper<KcEvaluationans> kcEvaluationansQueryWrapper13 = new QueryWrapper<>();
							kcEvaluationansQueryWrapper13.eq("queid","45");
							kcEvaluationansQueryWrapper13.eq("ordernum",ans13);
							List<KcEvaluationans> kcEvaluationansList13 = kcEvaluationansService.list(kcEvaluationansQueryWrapper13);
							if(kcEvaluationansList13!=null && kcEvaluationansList13.size()>0){
								kcEvaluations.setId(null);
								kcEvaluations.setQueid(kcEvaluationansList13.get(0).getQueid());
								kcEvaluations.setAnsid(kcEvaluationansList13.get(0).getId());
								kcEvaluationsService.save(kcEvaluations);
							}

							QueryWrapper<KcEvaluationans> kcEvaluationansQueryWrapper14 = new QueryWrapper<>();
							kcEvaluationansQueryWrapper14.eq("queid","46");
							kcEvaluationansQueryWrapper14.eq("ordernum",ans14);
							List<KcEvaluationans> kcEvaluationansList14 = kcEvaluationansService.list(kcEvaluationansQueryWrapper14);
							if(kcEvaluationansList14!=null && kcEvaluationansList14.size()>0){
								kcEvaluations.setId(null);
								kcEvaluations.setQueid(kcEvaluationansList14.get(0).getQueid());
								kcEvaluations.setAnsid(kcEvaluationansList14.get(0).getId());
								kcEvaluationsService.save(kcEvaluations);
							}

							QueryWrapper<KcEvaluationans> kcEvaluationansQueryWrapper15 = new QueryWrapper<>();
							kcEvaluationansQueryWrapper15.eq("queid","47");
							kcEvaluationansQueryWrapper15.eq("ordernum",ans15);
							List<KcEvaluationans> kcEvaluationansList15 = kcEvaluationansService.list(kcEvaluationansQueryWrapper15);
							if(kcEvaluationansList15!=null && kcEvaluationansList15.size()>0){
								kcEvaluations.setId(null);
								kcEvaluations.setQueid(kcEvaluationansList15.get(0).getQueid());
								kcEvaluations.setAnsid(kcEvaluationansList15.get(0).getId());
								kcEvaluationsService.save(kcEvaluations);
							}

//							QueryWrapper<KcEvaluationans> kcEvaluationansQueryWrapper16 = new QueryWrapper<>();
//							kcEvaluationansQueryWrapper16.eq("queid","48");
//							kcEvaluationansQueryWrapper16.eq("ordernum",ans16);
//							List<KcEvaluationans> kcEvaluationansList16 = kcEvaluationansService.list(kcEvaluationansQueryWrapper16);
//							if(kcEvaluationansList16!=null && kcEvaluationansList16.size()>0){
//								kcEvaluations.setId(null);
//								kcEvaluations.setQueid(kcEvaluationansList16.get(0).getQueid());
//								kcEvaluations.setAnsid(kcEvaluationansList16.get(0).getId());
//								kcEvaluationsService.save(kcEvaluations);
//							}
//
//
//							if(StringUtils.isNotBlank(ans17)){
//								kcEvaluations.setId(null);
//								kcEvaluations.setQueid(49);
//								kcEvaluations.setAnsid(0);
//								kcEvaluations.setTextanscontent(ans17);
//								kcEvaluationsService.save(kcEvaluations);
//							}
//							if(StringUtils.isNotBlank(ans18)){
//								kcEvaluations.setId(null);
//								kcEvaluations.setQueid(50);
//								kcEvaluations.setAnsid(0);
//								kcEvaluations.setTextanscontent(ans18);
//								kcEvaluationsService.save(kcEvaluations);
//							}
							if(StringUtils.isNotBlank(ans19)){
								kcEvaluations.setId(null);
								kcEvaluations.setQueid(51);
								kcEvaluations.setAnsid(0);
								kcEvaluations.setTextanscontent(ans19);
								kcEvaluationsService.save(kcEvaluations);
							}





						}else{
							errNum++;
							newList.remove(KcZzThpjbPar);
							errorRest += "未查到匹配课堂："+KcZzThpjbPar.getKcmc()+"-"+KcZzThpjbPar.getSkjs()+"-"+KcZzThpjbPar.getSkdd()+"-"+KcZzThpjbPar.getPkjsbh()+"-"+KcZzThpjbPar.getPkjsxm()+"<br/>";
						}
					}
				}
				//update-begin-author:taoyan date:20190528 for:批量插入数据
				long start = System.currentTimeMillis();
				service.saveBatch(newList);
				//400条 saveBatch消耗时间1592毫秒  循环插入消耗时间1947毫秒
				//1200条  saveBatch消耗时间3687毫秒 循环插入消耗时间5212毫秒
				log.info("消耗时间" + (System.currentTimeMillis() - start) + "毫秒");
				//update-end-author:taoyan date:20190528 for:批量插入数据
				if(newList.size()>0){
					rest = "文件导入成功!数据行数：" + newList.size();
				}
				if(StringUtils.isNotBlank(errorRest)){
					errorRest = "<br/>共错误："+errNum+"行；错误数据如下：<br/>"+errorRest;
				}
				//刷新统计
				changeTingKeTongJi.changeTingKeTongji();
				return Result.ok(rest+errorRest);
			} catch (Exception e) {
				//update-begin-author:taoyan date:20211124 for: 导入数据重复增加提示
				String msg = e.getMessage();
				log.error(msg, e);
				if(msg!=null && msg.indexOf("Duplicate entry")>=0){
					return Result.error("文件导入失败:有重复数据！");
				}else{
					return Result.error("文件导入失败:" + e.getMessage());
				}
				//update-end-author:taoyan date:20211124 for: 导入数据重复增加提示
			} finally {
				try {
					file.getInputStream().close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
		}


		return Result.error("文件导入失败！");
	}

}
