package org.jeecg.modules.kc.kcZzThpjb.entity;

import java.io.Serializable;
import java.io.UnsupportedEncodingException;
import java.util.Date;
import java.math.BigDecimal;

import com.baomidou.mybatisplus.annotation.*;
import lombok.Data;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;
import org.jeecgframework.poi.excel.annotation.Excel;
import org.jeecg.common.aspect.annotation.Dict;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * @Description: 纸质同行评价表
 * @Author: jeecg-boot
 * @Date:   2023-05-28
 * @Version: V1.0
 */
@Data
@TableName("kc_zz_thpjb")
@Accessors(chain = true)
@EqualsAndHashCode(callSuper = false)
@ApiModel(value="kc_zz_thpjb对象", description="纸质同行评价表")
public class KcZzThpjb implements Serializable {
    private static final long serialVersionUID = 1L;

	/**主键*/
	@TableId(type = IdType.ASSIGN_ID)
    @ApiModelProperty(value = "主键")
    private java.lang.String id;
	/**创建人*/
    @ApiModelProperty(value = "创建人")
    private java.lang.String createBy;
	/**创建日期*/
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "创建日期")
    private java.util.Date createTime;
	/**更新人*/
    @ApiModelProperty(value = "更新人")
    private java.lang.String updateBy;
	/**更新日期*/
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "更新日期")
    private java.util.Date updateTime;
	/**所属部门*/
    @ApiModelProperty(value = "所属部门")
    private java.lang.String sysOrgCode;
	/**课程编号*/
	@Excel(name = "课程编号", width = 15)
    @ApiModelProperty(value = "课程编号")
    private java.lang.String kcbh;
	/**课程名称*/
	@Excel(name = "课程名称", width = 15)
    @ApiModelProperty(value = "课程名称")
    private java.lang.String kcmc;
	/**授课教师*/
	@Excel(name = "授课教师", width = 15)
    @ApiModelProperty(value = "授课教师")
    private java.lang.String skjs;
	/**授课时间*/
	@Excel(name = "授课时间", width = 15, format = "yyyy-MM-dd")
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd")
    @DateTimeFormat(pattern="yyyy-MM-dd")
    @ApiModelProperty(value = "授课时间")
    private java.util.Date sksj;
    /**评价时间*/
    @Excel(name = "评价时间", width = 20, format = "yyyy-MM-dd")
    @JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "评价时间")
    private java.util.Date pjsj;
    /**评课教师工号*/
    @Excel(name = "评课教师工号", width = 15)
    @ApiModelProperty(value = "评课教师工号")
    private java.lang.String pkjsbh;
    /**评课教师姓名*/
    @Excel(name = "评课教师姓名", width = 15)
    @ApiModelProperty(value = "评课教师姓名")
    private java.lang.String pkjsxm;
	/**上课地点*/
	@Excel(name = "上课地点", width = 15)
    @ApiModelProperty(value = "上课地点")
    private java.lang.String skdd;
	/**使用教材*/
	@Excel(name = "使用教材", width = 15)
    @ApiModelProperty(value = "使用教材")
    private java.lang.String syjc;
	/**教学理解*/
    @Excel(name = "教学理解", width = 15)
    @ApiModelProperty(value = "教学理解")
    private java.lang.String jxlj;
	/**教学态度*/
    @Excel(name = "教学态度", width = 15)
    @ApiModelProperty(value = "教学态度")
    private java.lang.String jxtd;
	/**教学过程*/
    @Excel(name = "教学过程", width = 15)
    @ApiModelProperty(value = "教学过程")
    private java.lang.String jxgc;
	/**教学效果*/
    @Excel(name = "教学效果", width = 15)
    @ApiModelProperty(value = "教学效果")
    private java.lang.String jxxg;
	/**教学特殊*/
    @Excel(name = "教学特殊", width = 15)
    @ApiModelProperty(value = "教学特殊")
    private java.lang.String jxts;
	/**总分*/
    @Excel(name = "总分", width = 15)
    @ApiModelProperty(value = "总分")
    private java.lang.String zf;
	/**优点或建议*/
    @Excel(name = "优点或建议", width = 15)
    @ApiModelProperty(value = "优点或建议")
    private java.lang.String ydhjy;
	/**1.具有教育理想、敬业精神和教学追求，热爱学生、学科和教学工作。*/
//	@Excel(name = "1.具有教育理想、敬业精神和教学追求，热爱学生、学科和教学工作。", width = 15, dicCode = "five_dict")
    @ApiModelProperty(value = "1.具有教育理想、敬业精神和教学追求，热爱学生、学科和教学工作。")
    @Dict(dicCode = "five_dict")
    private java.lang.String ans1;
	/**2.掌握所教学科必需的专业与教学知识。具备所教学科的教学设计、实施、评价、反思和研究能力。*/
//	@Excel(name = "2.掌握所教学科必需的专业与教学知识。具备所教学科的教学设计、实施、评价、反思和研究能力。", width = 15, dicCode = "five_dict")
    @ApiModelProperty(value = "2.掌握所教学科必需的专业与教学知识。具备所教学科的教学设计、实施、评价、反思和研究能力。")
    @Dict(dicCode = "five_dict")
    private java.lang.String ans2;
	/**3.把握学生身心发展规律与特点，尊重学生主体性与差异性。*/
//	@Excel(name = "3.把握学生身心发展规律与特点，尊重学生主体性与差异性。", width = 15, dicCode = "five_dict")
    @ApiModelProperty(value = "3.把握学生身心发展规律与特点，尊重学生主体性与差异性。")
    @Dict(dicCode = "five_dict")
    private java.lang.String ans3;
	/**4.立德树人，为人师表，语言规范，情绪饱满，思想积极向上*/
//	@Excel(name = "4.立德树人，为人师表，语言规范，情绪饱满，思想积极向上", width = 15, dicCode = "five_dict")
    @ApiModelProperty(value = "4.立德树人，为人师表，语言规范，情绪饱满，思想积极向上")
    @Dict(dicCode = "five_dict")
    private java.lang.String ans4;
	/**5.执行教学计划，遵守教学纪律，严谨从教*/
//	@Excel(name = "5.执行教学计划，遵守教学纪律，严谨从教", width = 15, dicCode = "five_dict")
    @ApiModelProperty(value = "5.执行教学计划，遵守教学纪律，严谨从教")
    @Dict(dicCode = "five_dict")
    private java.lang.String ans5;
	/**6.系统规划和设计教学活动，合理确定教学目标和教学内容的重难点，选择合适的教学方法、教学媒体和教学形式*/
//	@Excel(name = "6.系统规划和设计教学活动，合理确定教学目标和教学内容的重难点，选择合适的教学方法、教学媒体和教学形式", width = 15, dicCode = "five_dict")
    @ApiModelProperty(value = "6.系统规划和设计教学活动，合理确定教学目标和教学内容的重难点，选择合适的教学方法、教学媒体和教学形式")
    @Dict(dicCode = "five_dict")
    private java.lang.String ans6;
	/**7.清晰讲解课程内容，恰当解释知识中蕴含的本源性思想和学科方法，适时引导学生关注课程领域发展新动态。*/
//	@Excel(name = "7.清晰讲解课程内容，恰当解释知识中蕴含的本源性思想和学科方法，适时引导学生关注课程领域发展新动态。", width = 15, dicCode = "five_dict")
    @ApiModelProperty(value = "7.清晰讲解课程内容，恰当解释知识中蕴含的本源性思想和学科方法，适时引导学生关注课程领域发展新动态。")
    @Dict(dicCode = "five_dict")
    private java.lang.String ans7;
	/**8.启发学生思考，鼓励学生发现、提出问题，恰当给予回应和引导。*/
//	@Excel(name = "8.启发学生思考，鼓励学生发现、提出问题，恰当给予回应和引导。", width = 15, dicCode = "five_dict")
    @ApiModelProperty(value = "8.启发学生思考，鼓励学生发现、提出问题，恰当给予回应和引导。")
    @Dict(dicCode = "five_dict")
    private java.lang.String ans8;
	/**9.监控教学过程，富有教学机智，教学体现生成性。*/
//	@Excel(name = "9.监控教学过程，富有教学机智，教学体现生成性。", width = 15, dicCode = "five_dict")
    @ApiModelProperty(value = "9.监控教学过程，富有教学机智，教学体现生成性。")
    @Dict(dicCode = "five_dict")
    private java.lang.String ans9;
	/**10.运用多元评价方式，了解学习状况，诊断学习问题，及时反馈*/
//	@Excel(name = "10.运用多元评价方式，了解学习状况，诊断学习问题，及时反馈", width = 15, dicCode = "five_dict")
    @ApiModelProperty(value = "10.运用多元评价方式，了解学习状况，诊断学习问题，及时反馈")
    @Dict(dicCode = "five_dict")
    private java.lang.String ans10;
	/**11.学习认真积极，踊跃参与课堂活动，体会课程学习的挑战与乐趣，感悟课程的意义与价值。*/
//	@Excel(name = "11.学习认真积极，踊跃参与课堂活动，体会课程学习的挑战与乐趣，感悟课程的意义与价值。", width = 15, dicCode = "five_dict")
    @ApiModelProperty(value = "11.学习认真积极，踊跃参与课堂活动，体会课程学习的挑战与乐趣，感悟课程的意义与价值。")
    @Dict(dicCode = "five_dict")
    private java.lang.String ans11;
	/**12.掌握所学课程的基本概念与原理，理解课程的知识结构与思想体系，了解所学知识的运用情境、策略和方法。*/
//	@Excel(name = "12.掌握所学课程的基本概念与原理，理解课程的知识结构与思想体系，了解所学知识的运用情境、策略和方法。", width = 15, dicCode = "five_dict")
    @ApiModelProperty(value = "12.掌握所学课程的基本概念与原理，理解课程的知识结构与思想体系，了解所学知识的运用情境、策略和方法。")
    @Dict(dicCode = "five_dict")
    private java.lang.String ans12;
	/**13.遵循教学一般规律，具有鲜明的创新意识和个性风貌。*/
//	@Excel(name = "13.遵循教学一般规律，具有鲜明的创新意识和个性风貌。", width = 15, dicCode = "five_dict")
    @ApiModelProperty(value = "13.遵循教学一般规律，具有鲜明的创新意识和个性风貌。")
    @Dict(dicCode = "five_dict")
    private java.lang.String ans13;
	/**14.尊重学科本质属性，凸显学科育人价值，注重培养学科核心素养。*/
//	@Excel(name = "14.尊重学科本质属性，凸显学科育人价值，注重培养学科核心素养。", width = 15, dicCode = "five_dict")
    @ApiModelProperty(value = "14.尊重学科本质属性，凸显学科育人价值，注重培养学科核心素养。")
    @Dict(dicCode = "five_dict")
    private java.lang.String ans14;
	/**15.课堂教学蕴含理性美，具有教学魅力，体现教学艺术性。*/
//	@Excel(name = "15.课堂教学蕴含理性美，具有教学魅力，体现教学艺术性。", width = 15, dicCode = "five_dict")
    @ApiModelProperty(value = "15.课堂教学蕴含理性美，具有教学魅力，体现教学艺术性。")
    @Dict(dicCode = "five_dict")
    private java.lang.String ans15;
	/**16.你对该课程的总体评价情况，5分是满分，您给打几分？*/
//	@Excel(name = "16.你对该课程的总体评价情况，5分是满分，您给打几分？", width = 15, dicCode = "five_dict")
    @ApiModelProperty(value = "16.你对该课程的总体评价情况，5分是满分，您给打几分？")
    @Dict(dicCode = "five_dict")
    private java.lang.String ans16;
	/**17.您认为该课堂值得肯定的方面*/
//	@Excel(name = "17.您认为该课堂值得肯定的方面", width = 15, dicCode = "five_dict")
    @ApiModelProperty(value = "17.您认为该课堂值得肯定的方面")
    private java.lang.String ans17;
	/**18.您认为该课堂需要改进的方面*/
//	@Excel(name = "18.您认为该课堂需要改进的方面", width = 15, dicCode = "five_dict")
    @ApiModelProperty(value = "18.您认为该课堂需要改进的方面")
    private java.lang.String ans18;
	/**19.其它建议*/
//	@Excel(name = "19.其它建议", width = 15)
    @ApiModelProperty(value = "19.其它建议")
    private java.lang.String ans19;

    @TableField(exist = false)
    private String xqxn;
}
