package org.jeecg.modules.kc.kcZzXstkb.entity;

import java.io.Serializable;
import java.io.UnsupportedEncodingException;
import java.util.Date;
import java.math.BigDecimal;

import com.baomidou.mybatisplus.annotation.*;
import lombok.Data;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;
import org.jeecgframework.poi.excel.annotation.Excel;
import org.jeecg.common.aspect.annotation.Dict;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * @Description: 纸质线上听课表
 * @Author: jeecg-boot
 * @Date:   2023-05-24
 * @Version: V1.0
 */
@Data
@TableName("kc_zz_xstkb")
@Accessors(chain = true)
@EqualsAndHashCode(callSuper = false)
@ApiModel(value="kc_zz_xstkb对象", description="纸质线上听课表")
public class KcZzXstkb implements Serializable {
    private static final long serialVersionUID = 1L;

	/**主键*/
	@TableId(type = IdType.ASSIGN_ID)
    @ApiModelProperty(value = "主键")
    private java.lang.String id;
	/**创建人*/
    @ApiModelProperty(value = "创建人")
    private java.lang.String createBy;
	/**创建日期*/
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "创建日期")
    private java.util.Date createTime;
	/**更新人*/
    @ApiModelProperty(value = "更新人")
    private java.lang.String updateBy;
	/**更新日期*/
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "更新日期")
    private java.util.Date updateTime;
	/**所属部门*/
    @ApiModelProperty(value = "所属部门")
    private java.lang.String sysOrgCode;
	/**课程编号*/
	@Excel(name = "课程编号", width = 15)
    @ApiModelProperty(value = "课程编号")
    private java.lang.String kcbh;
	/**课程名称*/
	@Excel(name = "课程名称", width = 15)
    @ApiModelProperty(value = "课程名称")
    private java.lang.String kcmc;
	/**授课教师*/
	@Excel(name = "授课教师", width = 15)
    @ApiModelProperty(value = "授课教师")
    private java.lang.String skjs;
	/**授课时间*/
	@Excel(name = "授课时间", width = 15, format = "yyyy-MM-dd")
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd")
    @DateTimeFormat(pattern="yyyy-MM-dd")
    @ApiModelProperty(value = "授课时间")
    private java.util.Date sksj;
	/**上课地点*/
	@Excel(name = "上课地点", width = 15)
    @ApiModelProperty(value = "上课地点")
    private java.lang.String skdd;
	/**听课教师姓名*/
	@Excel(name = "听课教师姓名", width = 15)
    @ApiModelProperty(value = "听课教师姓名")
    private java.lang.String tkjsxm;
	/**听课教师工号*/
	@Excel(name = "听课教师工号", width = 15)
    @ApiModelProperty(value = "听课教师工号")
    private java.lang.String tkjsgh;
	/**听课时间*/
	@Excel(name = "听课时间", width = 20, format = "yyyy-MM-dd")
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd")
    @DateTimeFormat(pattern="yyyy-MM-dd")
    @ApiModelProperty(value = "听课时间")
    private java.util.Date tksj;
	/**1.声音和画面情况*/
	@Excel(name = "1.声音和画面情况", width = 15, dicCode = "five_dict")
	@Dict(dicCode = "five_dict")
    @ApiModelProperty(value = "1.声音和画面情况")
    private java.lang.String ans1;
	/**2.ppt等课件情况*/
	@Excel(name = "2.ppt等课件情况", width = 15, dicCode = "five_dict")
	@Dict(dicCode = "five_dict")
    @ApiModelProperty(value = "2.ppt等课件情况")
    private java.lang.String ans2;
	/**3.教师出镜情况*/
	@Excel(name = "3.教师出镜情况", width = 15, dicCode = "five_dict")
	@Dict(dicCode = "five_dict")
    @ApiModelProperty(value = "3.教师出镜情况")
    private java.lang.String ans3;
	/**4.教师仪态仪表方面*/
	@Excel(name = "4.以下那些描述符合本节课的教学实际情况（多选）", width = 15, dicCode = "five_dict")
	@Dict(dicCode = "five_dict")
    @ApiModelProperty(value = "4.以下那些描述符合本节课的教学实际情况（多选）")
    private java.lang.String ans4;
	/**5.教师所在环境情况*/
	@Excel(name = "5.学生出席情况", width = 15, dicCode = "five_dict")
	@Dict(dicCode = "five_dict")
    @ApiModelProperty(value = "5.学生出席情况")
    private java.lang.String ans5;
	/**6.学生出席情况*/
	@Excel(name = " 6.学生参与课堂活动情况", width = 15, dicCode = "five_dict")
	@Dict(dicCode = "five_dict")
    @ApiModelProperty(value = " 6.学生参与课堂活动情况")
    private java.lang.String ans6;
	/**7.课堂秩序情况*/
	@Excel(name = "7.如果让您给本节课打分，5分是满分，您给打几分？", width = 15, dicCode = "five_dict")
	@Dict(dicCode = "five_dict")
    @ApiModelProperty(value = "7.课堂秩序情况")
    private java.lang.String ans7;
	/**8.课堂教学互动情况*/
	@Excel(name = "8.您认为该课堂值得肯定的方面", width = 15)
    @ApiModelProperty(value = "8.您认为该课堂值得肯定的方面")
    private java.lang.String ans8;
	/**9.过程性评价情况*/
	@Excel(name = "9.您认为该课堂需要改进的方面", width = 15 )
    @ApiModelProperty(value = "9.您认为该课堂需要改进的方面")
    private java.lang.String ans9;
	/**总体评价*/
	@Dict(dicCode = "five_dict")
    @ApiModelProperty(value = "10.其它建议")
    private java.lang.String ztpj;
	/**您认为课堂值得肯定的方面或者需要改进的方面*/
	@Excel(name = "10.其它建议", width = 15)
    @ApiModelProperty(value = "10.其它建议")
    private java.lang.String pjnr;

	@TableField(exist = false)
	private String xqxn;
}
