package org.jeecg.modules.kc.kcZzYbtkb.entity;

import java.io.Serializable;
import java.io.UnsupportedEncodingException;
import java.util.Date;
import java.math.BigDecimal;

import com.baomidou.mybatisplus.annotation.*;
import lombok.Data;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;
import org.jeecgframework.poi.excel.annotation.Excel;
import org.jeecg.common.aspect.annotation.Dict;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * @Description: 纸质一般听课表
 * @Author: jeecg-boot
 * @Date:   2023-05-24
 * @Version: V1.0
 */
@Data
@TableName("kc_zz_ybtkb")
@Accessors(chain = true)
@EqualsAndHashCode(callSuper = false)
@ApiModel(value="kc_zz_ybtkb对象", description="纸质一般听课表")
public class KcZzYbtkb implements Serializable {
    private static final long serialVersionUID = 1L;

	/**主键*/
	@TableId(type = IdType.ASSIGN_ID)
    @ApiModelProperty(value = "主键")
    private java.lang.String id;
	/**创建人*/
    @ApiModelProperty(value = "创建人")
    private java.lang.String createBy;
	/**创建日期*/
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "创建日期")
    private java.util.Date createTime;
	/**更新人*/
    @ApiModelProperty(value = "更新人")
    private java.lang.String updateBy;
	/**更新日期*/
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "更新日期")
    private java.util.Date updateTime;
	/**所属部门*/
    @ApiModelProperty(value = "所属部门")
    private java.lang.String sysOrgCode;
	/**课程编号*/
	@Excel(name = "课程编号", width = 15)
    @ApiModelProperty(value = "课程编号")
    private java.lang.String kcbh;
	/**课程名称*/
	@Excel(name = "课程名称", width = 15)
    @ApiModelProperty(value = "课程名称")
    private java.lang.String kcmc;
	/**授课教师*/
	@Excel(name = "授课教师", width = 15)
    @ApiModelProperty(value = "授课教师")
    private java.lang.String skjs;
	/**授课时间*/
	@Excel(name = "授课时间", width = 15, format = "yyyy-MM-dd")
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd")
    @DateTimeFormat(pattern="yyyy-MM-dd")
    @ApiModelProperty(value = "授课时间")
    private java.util.Date skrq;
	/**上课地点*/
	@Excel(name = "上课地点", width = 15)
    @ApiModelProperty(value = "上课地点")
    private java.lang.String skdd;
	/**听课教师编号*/
	@Excel(name = "听课教师编号", width = 15)
    @ApiModelProperty(value = "听课教师编号")
    private java.lang.String tkjsbh;
	/**听课教师姓名*/
	@Excel(name = "听课教师姓名", width = 15)
    @ApiModelProperty(value = "听课教师姓名")
    private java.lang.String tkjsxm;
	/**评课时间*/
	@Excel(name = "评课时间", width = 20, format = "yyyy-MM-dd")
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd")
    @DateTimeFormat(pattern="yyyy-MM-dd")
    @ApiModelProperty(value = "评课时间")
    private java.util.Date pksj;
	/**授课有启发性，能给予学生思考、联想、创造的启迪*/
	@Excel(name = "授课有启发性，能给予学生思考、联想、创造的启迪", width = 15, dicCode = "five_dict")
	@Dict(dicCode = "five_dict")
    @ApiModelProperty(value = "授课有启发性，能给予学生思考、联想、创造的启迪")
    private java.lang.String ans1;
	/**能有效利用各种教学媒体，课件或板书使用效果好*/
	@Excel(name = "能有效利用各种教学媒体，课件或板书使用效果好", width = 15, dicCode = "five_dict")
	@Dict(dicCode = "five_dict")
    @ApiModelProperty(value = "能有效利用各种教学媒体，课件或板书使用效果好")
    private java.lang.String ans2;
	/**仪表得体，按时上下课，严格要求学生*/
	@Excel(name = "仪表得体，按时上下课，严格要求学生", width = 15, dicCode = "five_dict")
	@Dict(dicCode = "five_dict")
    @ApiModelProperty(value = "仪表得体，按时上下课，严格要求学生")
    private java.lang.String ans3;
	/**讲课有热情，精神饱满，能调动学生情绪，课堂气氛活跃*/
	@Excel(name = "讲课有热情，精神饱满，能调动学生情绪，课堂气氛活跃", width = 15, dicCode = "five_dict")
	@Dict(dicCode = "five_dict")
    @ApiModelProperty(value = "讲课有热情，精神饱满，能调动学生情绪，课堂气氛活跃")
    private java.lang.String ans4;
	/**教学目标明确，内容丰富，重点突出，言语表达清楚。*/
	@Excel(name = "教学目标明确，内容丰富，重点突出，言语表达清楚。", width = 15, dicCode = "five_dict")
	@Dict(dicCode = "five_dict")
    @ApiModelProperty(value = "教学目标明确，内容丰富，重点突出，言语表达清楚。")
    private java.lang.String ans5;
	/**无迟到、早退、旷课现象*/
	@Excel(name = "无迟到、早退、旷课现象", width = 15, dicCode = "five_dict")
	@Dict(dicCode = "five_dict")
    @ApiModelProperty(value = "无迟到、早退、旷课现象")
    private java.lang.String ans6;
	/**课堂教学秩序好，无喧闹、打瞌睡、发短信、玩手机等现象*/
	@Excel(name = "课堂教学秩序好，无喧闹、打瞌睡、发短信、玩手机等现象", width = 15, dicCode = "five_dict")
	@Dict(dicCode = "five_dict")
    @ApiModelProperty(value = "课堂教学秩序好，无喧闹、打瞌睡、发短信、玩手机等现象")
    private java.lang.String ans7;
	/**上课认真听讲、积极思考、主动与老师交流互动*/
	@Excel(name = "上课认真听讲、积极思考、主动与老师交流互动", width = 15, dicCode = "five_dict")
	@Dict(dicCode = "five_dict")
    @ApiModelProperty(value = "上课认真听讲、积极思考、主动与老师交流互动")
    private java.lang.String ans8;
	/**课堂教学总体印象评价*/
	@Excel(name = "课堂教学总体印象评价", width = 15, dicCode = "five_dict")
	@Dict(dicCode = "five_dict")
    @ApiModelProperty(value = "课堂教学总体印象评价")
    private java.lang.String ans9;
	/**请填写对课堂内容以及其他方面的具体意见或建议*/
	@Excel(name = "请填写对课堂内容以及其他方面的具体意见或建议", width = 15)
    @ApiModelProperty(value = "请填写对课堂内容以及其他方面的具体意见或建议")
    private java.lang.String ans10;

	@TableField(exist = false)
	private String xqxn;
}
