package org.jeecg.modules.kc.ktgl.controller;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.SecurityUtils;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.system.vo.LoginUser;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.kc.kcSysConfig.entity.KcSysConfig;
import org.jeecg.modules.kc.kcSysConfig.service.IKcSysConfigService;
import org.jeecg.modules.kc.kcSzkc.entity.KcSzkc;
import org.jeecg.modules.kc.kcSzkc.service.IKcSzkcService;
import org.jeecg.modules.kc.ktgl.entity.KcKechengbiao;
import org.jeecg.modules.kc.ktgl.entity.KcKetangbiao;
import org.jeecg.modules.kc.ktgl.service.IKcKechengbiaoService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecg.modules.kc.zyDbtx.entity.ZyDbtx;
import org.jeecg.modules.kc.zyDbtx.service.IZyDbtxService;
import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

 /**
 * @Description: 课程管理-主表
 * @Author: jeecg-boot
 * @Date:   2023-04-01
 * @Version: V1.0
 */
@Api(tags="课程管理-主表")
@RestController
@RequestMapping("/ktgl/kcKechengbiao")
@Slf4j
public class KcKechengbiaoController extends JeecgController<KcKechengbiao, IKcKechengbiaoService> {
	@Autowired
	private IKcKechengbiaoService kcKechengbiaoService;
	 @Autowired
	 private IKcSzkcService kcSzkcService;
	 @Autowired
	 private IKcSysConfigService kcSysConfigService;
	 @Autowired
	 private IZyDbtxService zyDbtxService;
	/**
	 * 分页列表查询
	 *
	 * @param kcKechengbiao
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "课程管理-主表-分页列表查询")
	@ApiOperation(value="课程管理-主表-分页列表查询", notes="课程管理-主表-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<KcKechengbiao>> queryPageList(KcKechengbiao kcKechengbiao,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<KcKechengbiao> queryWrapper = QueryGenerator.initQueryWrapper(kcKechengbiao, req.getParameterMap());
		if(StringUtils.isNotBlank(kcKechengbiao.getSearchInput())){
			queryWrapper.apply("(kcmc like CONCAT('%','"+kcKechengbiao.getSearchInput()+"','%') or skjs like CONCAT('%','"+kcKechengbiao.getSearchInput()+"','%'))");
		}
		queryWrapper.apply(StringUtils.isNotBlank(kcKechengbiao.getYwcol())," length(kcbh)<25");
//		queryWrapper.apply("kcmc not like '%实习%' and  kcmc not like '%实训%' and  kcmc not like '%实践%' and  kcmc not like '%实验%' and  kcmc not like '%美术%'");
		Page<KcKechengbiao> page = new Page<KcKechengbiao>(pageNo, pageSize);
		IPage<KcKechengbiao> pageList = kcKechengbiaoService.page(page, queryWrapper);
		return Result.OK(pageList);
	}


	 @ApiOperation(value="课程管理-主表-分页列表查询", notes="课程管理-主表-分页列表查询")
	 @GetMapping(value = "/listGroupBy")
	 public Result<IPage<KcKechengbiao>> listGroupBy(KcKechengbiao kcKechengbiao,
													   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
													   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
													   HttpServletRequest req) {
		 QueryWrapper<KcKechengbiao> queryWrapper = QueryGenerator.initQueryWrapper("a",kcKechengbiao, req.getParameterMap());
		 if(StringUtils.isNotBlank(kcKechengbiao.getSearchInput())){
			 queryWrapper.like("kcmc",kcKechengbiao.getSearchInput());
//			 queryWrapper.apply("(kcmc like CONCAT('%','"+kcKechengbiao.getSearchInput()+"','%') or skjs like CONCAT('%','"+kcKechengbiao.getSearchInput()+"','%'))");
		 }
//		 queryWrapper.apply(StringUtils.isNotBlank(kcKechengbiao.getYwcol())," length(kcbh)<25");
		 Page<KcKechengbiao> page = new Page<KcKechengbiao>(pageNo, pageSize);
		 IPage<KcKechengbiao> pageList = kcKechengbiaoService.listGroupBy(page, queryWrapper);
		 return Result.OK(pageList);
	 }

	/**
	 *   添加
	 *
	 * @param kcKechengbiao
	 * @return
	 */
	@AutoLog(value = "课程管理-主表-添加")
	@ApiOperation(value="课程管理-主表-添加", notes="课程管理-主表-添加")
//	@RequiresPermissions("ktgl:kc_kechengbiao:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody KcKechengbiao kcKechengbiao) {
		kcKechengbiaoService.save(kcKechengbiao);
		return Result.OK("添加成功！");
	}

	/**
	 *  编辑
	 *
	 * @param kcKechengbiao
	 * @return
	 */
	@AutoLog(value = "课程管理-主表-编辑")
	@ApiOperation(value="课程管理-主表-编辑", notes="课程管理-主表-编辑")
//	@RequiresPermissions("ktgl:kc_kechengbiao:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody KcKechengbiao kcKechengbiao) {
		kcKechengbiaoService.updateById(kcKechengbiao);
		return Result.OK("编辑成功!");
	}


	 @AutoLog(value = "修改课程思政课程")
	 @ApiOperation(value="修改课程思政课程", notes="修改课程思政课程")
	 @RequestMapping(value = "/editSzkc", method = {RequestMethod.PUT,RequestMethod.POST})
	 public Result<String> editSzkc(@RequestBody KcKechengbiao kcKechengbiao) {
		 UpdateWrapper<KcKechengbiao> updateWrapper = new UpdateWrapper<>();
		 updateWrapper.setSql("szkc = '1' where kcbh = '"+kcKechengbiao.getKcbh()+"' and kcmc = '"+kcKechengbiao.getKcmc()+"' and kkdw = '"+kcKechengbiao.getKkdw()+"' and kcxz = '"+kcKechengbiao.getKcxz()+"' ");
 		 kcKechengbiaoService.update(updateWrapper);
		 KcSzkc kcSzkc = new KcSzkc();
		 kcSzkc.setKcbh(kcKechengbiao.getKcbh());
		 kcSzkc.setKcmc(kcKechengbiao.getKcmc());
		 kcSzkc.setKkdw(kcKechengbiao.getKkdw());
		 kcSzkcService.save(kcSzkc);
		 return Result.OK("编辑成功!");
	 }


	 @AutoLog(value = "移除课程思政课程")
	 @ApiOperation(value="移除课程思政课程", notes="移除课程思政课程")
	 @RequestMapping(value = "/editYichu", method = {RequestMethod.PUT,RequestMethod.POST})
	 public Result<String> editYichu(@RequestBody KcKechengbiao kcKechengbiao) {
		 UpdateWrapper<KcKechengbiao> updateWrapper = new UpdateWrapper<>();
		 updateWrapper.setSql("szkc = '0' where kcbh = '"+kcKechengbiao.getKcbh()+"' and kcmc = '"+kcKechengbiao.getKcmc()+"' and kkdw = '"+kcKechengbiao.getKkdw()+"' and kcxz = '"+kcKechengbiao.getKcxz()+"' ");
		 kcKechengbiaoService.update(updateWrapper);

		 QueryWrapper<KcSzkc> queryWrapper = new QueryWrapper<>();
		 queryWrapper.apply("kcbh = '"+kcKechengbiao.getKcbh()+"' and kcmc = '"+kcKechengbiao.getKcmc()+"' and kkdw = '"+kcKechengbiao.getKkdw()+"'  ");
		 kcSzkcService.remove(queryWrapper);
		 return Result.OK("编辑成功!");
	 }
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "课程管理-主表-通过id删除")
	@ApiOperation(value="课程管理-主表-通过id删除", notes="课程管理-主表-通过id删除")
//	@RequiresPermissions("ktgl:kc_kechengbiao:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		kcKechengbiaoService.removeById(id);
		return Result.OK("删除成功!");
	}

	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "课程管理-主表-批量删除")
	@ApiOperation(value="课程管理-主表-批量删除", notes="课程管理-主表-批量删除")
//	@RequiresPermissions("ktgl:kc_kechengbiao:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.kcKechengbiaoService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}

	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "课程管理-主表-通过id查询")
	@ApiOperation(value="课程管理-主表-通过id查询", notes="课程管理-主表-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<KcKechengbiao> queryById(@RequestParam(name="id",required=true) String id) {
		KcKechengbiao kcKechengbiao = kcKechengbiaoService.getById(id);
		if(kcKechengbiao==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(kcKechengbiao);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param kcKechengbiao
    */
    @RequiresPermissions("ktgl:kc_kechengbiao:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, KcKechengbiao kcKechengbiao) {
        return super.exportXls(request, kcKechengbiao, KcKechengbiao.class, "课程管理-主表");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
//    @RequiresPermissions("ktgl:kc_kechengbiao:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, KcKechengbiao.class);
    }

	 @ApiOperation(value="教师端我的课程", notes="教师端我的课程")
	 @GetMapping(value = "/getKechengbiaolist")
	 public Result<IPage<KcKechengbiao>> getKechengbiaolist(KcKechengbiao kcKechengbiao,
													   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
													   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
													   HttpServletRequest req) {
		 QueryWrapper<KcKechengbiao> queryWrapper = QueryGenerator.initQueryWrapper(kcKechengbiao, req.getParameterMap());
		 KcSysConfig kcSysConfig = kcSysConfigService.getById("1");
		 if(StringUtils.equals("0",kcKechengbiao.getCheckType())){//当前学年
			 queryWrapper.eq("xqxn",kcSysConfig.getFlag1());
		 }else{//历史学年
//			 queryWrapper.ne("xqxn",kcSysConfig.getFlag1());
		 }
		 LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
		 queryWrapper.eq("jgh",sysUser.getUsername());
		 queryWrapper.eq("flag","0");
		 queryWrapper.orderByDesc("xqxn");
		 Page<KcKechengbiao> page = new Page<KcKechengbiao>(pageNo, pageSize);
		 IPage<KcKechengbiao> pageList = kcKechengbiaoService.getKechengbiaolist(page, queryWrapper);


		 //展示代办提醒
		 if(pageList.getRecords().size()>0){
			 ZyDbtx zyDbtx = new ZyDbtx();
			 zyDbtx.setCreateBy(sysUser.getUsername());
			 zyDbtx.setFlag("0");
			 List<ZyDbtx> dbtxList = zyDbtxService.getDbtxList(zyDbtx);
			 for(KcKechengbiao par:pageList.getRecords()){
				 int i = 0;
				 for(ZyDbtx txPar : dbtxList){
					 if(StringUtils.equals(par.getRwbh(),txPar.getRwbh())){
						 i++;
					 }
				 }
				 par.setDbtxType(i+"");
			 }
		 }


		 return Result.OK(pageList);
	 }


	 @ApiOperation(value="助教查询我的课程", notes="助教查询我的课程")
	 @GetMapping(value = "/getZjlist")
	 public Result<IPage<KcKechengbiao>> getZjlist(KcKechengbiao kcKechengbiao,
															@RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
															@RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
															HttpServletRequest req) {
		 QueryWrapper<KcKechengbiao> queryWrapper = QueryGenerator.initQueryWrapper(kcKechengbiao, req.getParameterMap());
		 KcSysConfig kcSysConfig = kcSysConfigService.getById("1");
		 if(StringUtils.equals("0",kcKechengbiao.getCheckType())){//当前学年
			 queryWrapper.eq("xqxn",kcSysConfig.getFlag1());
		 }else{//历史学年
		 }
		 LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
		 queryWrapper.apply("rwbh in (select rwbh from kc_zj_info where zjbh = "+sysUser.getUsername()+")");
		 queryWrapper.eq("flag","0");
		 queryWrapper.orderByDesc("xqxn");
		 Page<KcKechengbiao> page = new Page<KcKechengbiao>(pageNo, pageSize);
		 IPage<KcKechengbiao> pageList = kcKechengbiaoService.getZjlist(page, queryWrapper);

		 return Result.OK(pageList);
	 }

	 @ApiOperation(value="学生端我的课程", notes="学生端我的课程")
	 @GetMapping(value = "/getStudentKclist")
	 public Result<IPage<KcKechengbiao>> getStudentKclist(KcKechengbiao kcKechengbiao,
															@RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
															@RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
															HttpServletRequest req) {
		 QueryWrapper<KcKechengbiao> queryWrapper = QueryGenerator.initQueryWrapper(kcKechengbiao, req.getParameterMap());
		 LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
		 KcSysConfig kcSysConfig = kcSysConfigService.getById("1");
		 queryWrapper.apply("kc.rwbh = xkb.kcapzbbh and kc.flag = '0'");
		 queryWrapper.eq("xkb.xh",sysUser.getUsername());
		 queryWrapper.eq("kc.xqxn",kcSysConfig.getFlag1());
		 Page<KcKechengbiao> page = new Page<KcKechengbiao>(pageNo, pageSize);
		 IPage<KcKechengbiao> pageList = kcKechengbiaoService.getStudentKclist(page, queryWrapper);


		 //展示代办提醒
		 if(pageList.getRecords().size()>0){
			 ZyDbtx zyDbtx = new ZyDbtx();
			 zyDbtx.setCreateBy(sysUser.getUsername());
			 zyDbtx.setFlag("0");
			 List<ZyDbtx> dbtxList = zyDbtxService.getDbtxList(zyDbtx);
			 for(KcKechengbiao par:pageList.getRecords()){
				 for(ZyDbtx txPar : dbtxList){
					 if(StringUtils.equals(par.getRwbh(),txPar.getRwbh())&&StringUtils.equals(par.getJgh(),txPar.getFbr())){
						 par.setDbtxType(txPar.getType());
						 break;
					 }
				 }
			 }
		 }



		 return Result.OK(pageList);
	 }


	 @ApiOperation(value="根据课程的任务编号学期学年获取课程信息", notes="根据课程的任务编号学期学年获取课程信息")
	 @GetMapping(value = "/getKcxxByRwbhXqxn")
	 public Result<KcKechengbiao> getKcxxByRwbh(@RequestParam(name="rwbh",required=true) String rwbh,@RequestParam(name="xqxn",required=true) String xqxn) {
		QueryWrapper<KcKechengbiao> kcKechengbiaoQueryWrapper = new QueryWrapper<>();
		 kcKechengbiaoQueryWrapper.eq("rwbh",rwbh);
		 kcKechengbiaoQueryWrapper.eq("xqxn",xqxn);
		 kcKechengbiaoQueryWrapper.eq("flag","0");
		 kcKechengbiaoQueryWrapper.last("limit 1");
		 KcKechengbiao kcKechengbiao = kcKechengbiaoService.getOne(kcKechengbiaoQueryWrapper);
		 return Result.OK(kcKechengbiao);
	 }


}
