package org.jeecg.modules.kc.ktgl.controller;

import java.io.File;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.util.*;
import java.util.concurrent.atomic.AtomicReference;
import java.util.stream.Collectors;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import cn.hutool.core.date.DateField;
import cn.hutool.core.date.DatePattern;
import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.beust.jcommander.internal.Sets;
import com.google.common.collect.Maps;
import org.apache.commons.compress.utils.Lists;
import org.apache.commons.lang3.StringUtils;
import org.apache.shiro.SecurityUtils;
import org.jeecg.common.api.CommonAPI;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.system.vo.LoginUser;
import org.jeecg.common.util.SftpConfig;
import org.jeecg.common.util.SpringContextUtils;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.kc.detection.entity.KcDetectionDetailed;
import org.jeecg.modules.kc.detection.entity.KcDetectionMain;
import org.jeecg.modules.kc.detection.service.IKcDetectionDetailedService;
import org.jeecg.modules.kc.detection.service.IKcDetectionMainService;
import org.jeecg.modules.kc.grab.SynchronizationService.tools.ChangeTingKeTongJi;
import org.jeecg.modules.kc.jiaoshi.entity.KcJiaoshirongliang;
import org.jeecg.modules.kc.jiaoshi.service.IKcJiaoshirongliangService;
import org.jeecg.modules.kc.kcSysConfig.entity.KcSysConfig;
import org.jeecg.modules.kc.kcSysConfig.service.IKcSysConfigService;
import org.jeecg.modules.kc.kcXqxnHistory.entity.KcXqxnHistory;
import org.jeecg.modules.kc.kcXqxnHistory.service.IKcXqxnHistoryService;
import org.jeecg.modules.kc.ktgl.entity.KcKechengbiao;
import org.jeecg.modules.kc.ktgl.entity.KcKetangbiao;
import org.jeecg.modules.kc.ktgl.entity.KcKetangbiaoNum;
import org.jeecg.modules.kc.ktgl.service.IKcKechengbiaoService;
import org.jeecg.modules.kc.ktgl.service.IKcKetangbiaoService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecg.modules.kc.qa.entity.KcEvaluationstudent;
import org.jeecg.modules.kc.qa.service.IKcEvaluationstudentService;
import org.jeecg.common.system.base.controller.JeecgController;
import org.jeecg.modules.kc.zyJxdg.entity.ZyJxdg;
import org.jeecg.modules.kc.zyJxdg.service.IZyJxdgService;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.Lazy;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;

/**
 * @Description: 课堂管理-子表
 * @Author: jeecg-boot
 * @Date:   2023-04-01
 * @Version: V1.0
 */
@Api(tags="课堂管理-子表")
@RestController
@RequestMapping("/ktgl/kcKetangbiao")
@Slf4j
public class KcKetangbiaoController extends JeecgController<KcKetangbiao, IKcKetangbiaoService> {
	@Autowired
	private IKcKetangbiaoService kcKetangbiaoService;
	@Autowired
	private IKcKechengbiaoService kcKechengbiaoService;
	@Autowired
	private ChangeTingKeTongJi changeTingKeTongJi;

	@Autowired
	private IKcEvaluationstudentService kcEvaluationstudentService;
	@Autowired
	private IKcSysConfigService kcSysConfigService;

	@Autowired
	private IKcJiaoshirongliangService kcJiaoshirongliangService;

	@Autowired
	private IKcXqxnHistoryService kcXqxnHistoryService;

	@Autowired
	private IKcDetectionMainService kcDetectionMainService;
	@Autowired
	private IKcDetectionDetailedService kcDetectionDetailedService;

	@Autowired
	private IZyJxdgService zyJxdgService;

	@Autowired
	private SftpConfig sftpConfig;

	@Value("${jeecg.path.upload}")
	private String upLoadPath;

	public static String separator = "/";

	 @Lazy
	 @Autowired
	 private CommonAPI commonApi;

	 String startTime = "";
	 String endTime = "";

	 private String getBxqStartTime(){
		 if(StringUtils.isNotBlank(startTime)) return startTime;
		 //查找本学期学年的
		 KcXqxnHistory kcXqxnHistory = changeTingKeTongJi.getXqConfig();

		 startTime = DateUtil.format(kcXqxnHistory.getStartTime(), DatePattern.NORM_DATETIME_FORMAT);
		 return startTime;
	 }

	 private String getBxqEndTime(){
		 if(StringUtils.isNotBlank(endTime)) return endTime;
		 //查找本学期学年的
		 KcXqxnHistory kcXqxnHistory = changeTingKeTongJi.getXqConfig();

		 endTime = DateUtil.format(kcXqxnHistory.getEndTime(), DatePattern.NORM_DATETIME_FORMAT);
		 return endTime;
	 }

	/**
	 * 分页列表查询
	 *
	 * @param kcKetangbiao
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "课堂管理-子表-分页列表查询")
	@ApiOperation(value="课堂管理-子表-分页列表查询", notes="课堂管理-子表-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<KcKetangbiao>> queryPageList(KcKetangbiao kcKetangbiao,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<KcKetangbiao> queryWrapper = QueryGenerator.initQueryWrapper(kcKetangbiao, req.getParameterMap());
		//查本学期学年的
		if(kcKetangbiao.isSearchByNowXqxn()){
			queryWrapper.ge("skrq",getBxqStartTime());//<=
			queryWrapper.le("skrq",getBxqEndTime());//>=
		}
		if(StringUtils.isNotEmpty(kcKetangbiao.getStartTime())){
			queryWrapper.ge("skrq",kcKetangbiao.getStartTime());//<=
		}
		if(StringUtils.isNotEmpty(kcKetangbiao.getEndTime())){
			queryWrapper.le("skrq",kcKetangbiao.getEndTime());//>=
		}
		queryWrapper.apply(StringUtils.isNotBlank(kcKetangbiao.getYwmc())," (skjs like '%"+kcKetangbiao.getYwmc()+"%' or kcmc like '%"+kcKetangbiao.getYwmc()+"%')");
		queryWrapper.ne(StringUtils.isNotBlank(kcKetangbiao.getYwskxs()),"skxs",kcKetangbiao.getYwskxs());
		Page<KcKetangbiao> page = new Page<KcKetangbiao>(pageNo, pageSize);
		IPage<KcKetangbiao> pageList = kcKetangbiaoService.page(page, queryWrapper);
		return Result.OK(pageList);
	}

	/**
	 * 分页列表查询
	 *
	 * @param kcKetangbiao
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "课堂管理-子表-分页列表查询")
	@ApiOperation(value="课堂管理-子表-分页列表查询", notes="课堂管理-子表-分页列表查询")
	@GetMapping(value = "/fundAllPjjgList")
	public Result<IPage<KcKetangbiao>> fundAllPjjgList(KcKetangbiao kcKetangbiao,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<KcKetangbiao> queryWrapper = QueryGenerator.initQueryWrapper(kcKetangbiao, req.getParameterMap());
		//查本学期学年的
		if(kcKetangbiao.isSearchByNowXqxn()){
			KcSysConfig kcSysConfig =kcSysConfigService.getById("1");
			queryWrapper.ge("skrq",kcSysConfig.getBxqkssj());//<=
			queryWrapper.le("skrq",kcSysConfig.getBxqjssj()+" 23:59:59");//>=
		}
		queryWrapper.apply(StringUtils.isNotBlank(kcKetangbiao.getYwmc())," (skjs like '%"+kcKetangbiao.getYwmc()+"%' or kcmc like '%"+kcKetangbiao.getYwmc()+"%')");
		queryWrapper.ne(StringUtils.isNotBlank(kcKetangbiao.getYwskxs()),"skxs",kcKetangbiao.getYwskxs());
		queryWrapper.orderByDesc("skrq");
		Page<KcKetangbiao> page = new Page<KcKetangbiao>(pageNo, pageSize);

		Set<String> idSet = Sets.newHashSet();
		IPage<KcKetangbiao> pageList = kcKetangbiaoService.fundAllPjjgList(page, queryWrapper);
		pageList.getRecords().forEach(x -> idSet.add(x.getId()));
		//查询教师平均分,查完了
		if(idSet.isEmpty()){
			return Result.OK(pageList);
		}

		//查询学生平均分
		QueryWrapper<KcEvaluationstudent> qw = new QueryWrapper<>();
		qw.in("ketangbiaoid",idSet);
		List<KcEvaluationstudent> evaluationstudentList = kcEvaluationstudentService.list(qw);

		Map<String, List<KcEvaluationstudent>> evaluationstudentListMap = evaluationstudentList.stream().collect(Collectors.groupingBy(KcEvaluationstudent::getKetangbiaoid));

		Map<String, Integer> evaluationstudentAllDivideMap = Maps.newHashMap();

		evaluationstudentListMap.forEach((k,v) -> {
			String allNumKey = "allNum-" + k;
			String numKey = "num-" + k;
			evaluationstudentAllDivideMap.put(allNumKey, v.size());//数量
			AtomicReference<Integer> sum = new AtomicReference<>(0);
			v.forEach(x -> sum.updateAndGet(v1 -> v1 + x.getStars()));
			evaluationstudentAllDivideMap.put(numKey,sum.get());//总分
//			if(evaluationstudentAllDivideMap.containsKey(allNumKey)){
//				Integer allNum = evaluationstudentAllDivideMap.get(allNumKey);
//				allNum += 1;
//				evaluationstudentAllDivideMap.put(allNumKey,allNum);
//			}else{
//				evaluationstudentAllDivideMap.put(allNumKey,1);
//			}
//			if(evaluationstudentAllDivideMap.containsKey(numKey)){
//				Integer num = evaluationstudentAllDivideMap.get(numKey);
//				num += v.
//			}
		});
		//再计算平均数扔给主list

		pageList.getRecords().forEach(x -> {
			x.setXspjPjf("0");

			String allNumKey = "allNum-" + x.getId();
			String numKey = "num-" + x.getId();
			Integer allNUm = null;
			Integer num = null;
			if(evaluationstudentAllDivideMap.containsKey(allNumKey)){
				allNUm = evaluationstudentAllDivideMap.get(allNumKey);
			}
			if(evaluationstudentAllDivideMap.containsKey(numKey)){
				num = evaluationstudentAllDivideMap.get(numKey);
			}
			if(allNUm != null && num != null && num != 0){
				x.setXspjPjf(String.valueOf(num / allNUm));
			}
		});
		return Result.OK(pageList);
	}

	@GetMapping(value = "/getBizPath")
	public Result<?> getBizPath(String rwbh, String xqxn, String wjlx, String kkdw, String kcmc, String skjs) {
		Result<String> r = new Result<>();

		String uploadpath = sftpConfig.getUploadpath();
		if(uploadpath.indexOf(separator) == 0){
			uploadpath = uploadpath.substring(1);
		}
		if(uploadpath.lastIndexOf(separator) != uploadpath.length()-1){
			uploadpath = uploadpath + separator;
		}
		if(StringUtils.isNotBlank(rwbh) && StringUtils.isNotBlank(xqxn) && StringUtils.isNotBlank(wjlx)) {
			//根据任务编号查询80%数据
			QueryWrapper<KcKetangbiao> qw = new QueryWrapper<>();
			qw.last("limit 1");
			KcKetangbiao ketangbiao = kcKetangbiaoService.getOne(qw);
			String sb = uploadpath + xqxn + separator +
					ketangbiao.getKkdw() + separator +
					ketangbiao.getKcmc() + separator +
					ketangbiao.getSkjs() + separator +
					wjlx;
			r.setResult(sb);
		}else{
			if(StringUtils.isNotBlank(xqxn) && StringUtils.isNotBlank(wjlx) && StringUtils.isNotBlank(kkdw) && StringUtils.isNotBlank(kcmc) && StringUtils.isNotBlank(skjs)){
				String sb = uploadpath + xqxn + separator +
						kkdw + separator +
						kcmc + separator +
						skjs + separator +
						wjlx;
				r.setResult(sb);
			}else{
				r.setSuccess(false);
				r.setMessage("缺少关键参数");
			}
		}
		//rwbh
		//xqxn
		//学期学年不能为空
		//kkdw
		//开课单位不能为空
		//kcmc
		//课程名称不能为空
		//skjs
		//授课教师不能为空
		//wjlx
		//文件类型不能为空

		return r;
	}


	/**
	 *   添加
	 *
	 * @param kcKetangbiao
	 * @return
	 */
	@AutoLog(value = "课堂管理-子表-添加")
	@ApiOperation(value="课堂管理-子表-添加", notes="课堂管理-子表-添加")
//	@RequiresPermissions("ktgl:kc_ketangbiao:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody KcKetangbiao kcKetangbiao) {
		kcKetangbiaoService.save(kcKetangbiao);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param kcKetangbiao
	 * @return
	 */
	@AutoLog(value = "课堂管理-子表-编辑")
	@ApiOperation(value="课堂管理-子表-编辑", notes="课堂管理-子表-编辑")
//	@RequiresPermissions("ktgl:kc_ketangbiao:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody KcKetangbiao kcKetangbiao) {
		kcKetangbiaoService.updateById(kcKetangbiao);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "课堂管理-子表-通过id删除")
	@ApiOperation(value="课堂管理-子表-通过id删除", notes="课堂管理-子表-通过id删除")
//	@RequiresPermissions("ktgl:kc_ketangbiao:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		UpdateWrapper<KcKetangbiao> uw = new UpdateWrapper<>();
		uw.set("is_delete",1);
		uw.eq("id",id);
//		kcKetangbiaoService.removeById(id);
		kcKetangbiaoService.update(uw);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "课堂管理-子表-批量删除")
	@ApiOperation(value="课堂管理-子表-批量删除", notes="课堂管理-子表-批量删除")
//	@RequiresPermissions("ktgl:kc_ketangbiao:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
//		this.kcKetangbiaoService.removeByIds(Arrays.asList(ids.split(",")));
		UpdateWrapper<KcKetangbiao> uw = new UpdateWrapper<>();
		uw.set("is_delete",1);
		uw.in("id",Arrays.asList(ids.split(",")));
//		kcKetangbiaoService.removeById(id);
		kcKetangbiaoService.update(uw);
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "课堂管理-子表-通过id查询")
	@ApiOperation(value="课堂管理-子表-通过id查询", notes="课堂管理-子表-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<KcKetangbiao> queryById(@RequestParam(name="id",required=true) String id) {
		KcKetangbiao kcKetangbiao = kcKetangbiaoService.getById(id);
		if(kcKetangbiao==null) {
			return Result.error("未找到对应数据");
		}
		//查询对应教室数据
		QueryWrapper<KcJiaoshirongliang> jiaoshirongliangQw = new QueryWrapper<>();
		jiaoshirongliangQw.eq("jsbh",kcKetangbiao.getJsbh());
		jiaoshirongliangQw.last("limit 1");
		KcJiaoshirongliang jiaoshirongliang = kcJiaoshirongliangService.getOne(jiaoshirongliangQw);
		kcKetangbiao.setJiaoshirongliang(jiaoshirongliang);
		return Result.OK(kcKetangbiao);
	}

	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "课堂管理-子表-通过id查询")
	@ApiOperation(value="课堂管理-子表-通过id查询", notes="课堂管理-子表-通过id查询")
	@GetMapping(value = "/queryAllDataById")
	public Result<KcKetangbiao> queryAllDataById(@RequestParam(name="id",required=true) String id) {
		KcKetangbiao kcKetangbiao = kcKetangbiaoService.getById(id);
		if(kcKetangbiao==null) {
			return Result.error("未找到对应数据");
		}

		//查询是否思政课程
		try {
			QueryWrapper<KcKechengbiao> kcKechengbiaoQueryWrapper = new QueryWrapper<>();
			kcKechengbiaoQueryWrapper.eq("rwbh",kcKetangbiao.getRwbh());
			kcKechengbiaoQueryWrapper.last("limit 1");
			KcKechengbiao kechengbiao = kcKechengbiaoService.getOne(kcKechengbiaoQueryWrapper);
			kcKetangbiao.setSzkc(kechengbiao.getSzkc());
		} catch (Exception e) {
			e.printStackTrace();
		}



		//查询对应教室数据
		QueryWrapper<KcJiaoshirongliang> jiaoshirongliangQw = new QueryWrapper<>();
		jiaoshirongliangQw.eq("jsbh",kcKetangbiao.getJsbh());
		jiaoshirongliangQw.last("limit 1");
		KcJiaoshirongliang jiaoshirongliang = kcJiaoshirongliangService.getOne(jiaoshirongliangQw);
		kcKetangbiao.setJiaoshirongliang(jiaoshirongliang);

		//查询教学大纲
		String rwbh = kcKetangbiao.getRwbh();
		String xqxn = kcKetangbiao.getXnxq();
		QueryWrapper<ZyJxdg> queryWrapper = new QueryWrapper<ZyJxdg>();
		queryWrapper.eq("rwbh",rwbh);
		queryWrapper.eq("xqxn",xqxn);
//		 LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
//		 queryWrapper.eq("create_by",sysUser.getUsername());
		queryWrapper.last("limit 1");
		ZyJxdg zyJxdg = zyJxdgService.getOne(queryWrapper);
		kcKetangbiao.setZyJxdg(zyJxdg);

		//查询
		DateTime now = DateTime.now();
		String nowStr = now.toString("yyyy-MM-dd");
		QueryWrapper<KcDetectionMain> kdmQw = new QueryWrapper<>();
		kdmQw.apply("create_time >= '" + nowStr + " 00:00:00' and create_time <= '" + nowStr + " 23:59:59'");
		kdmQw.lambda().eq(KcDetectionMain::getRwbh,rwbh);
		kdmQw.lambda().eq(KcDetectionMain::getXnxq,xqxn);
//		kdmQw.eq("id","1791360521757487106");

		kdmQw.last("limit 1");
		KcDetectionMain detectionMain = kcDetectionMainService.getOne(kdmQw);
		kcKetangbiao.setDetectionMain(detectionMain);

		try {
			if(detectionMain!=null){
				QueryWrapper<KcDetectionDetailed> rsQw = new QueryWrapper<>();
				rsQw.eq("pid",detectionMain.getId());
//				rsQw.like("create_time",nowStr);
				rsQw.apply("create_time >= '" + nowStr + " 00:00:00' and create_time <= '" + nowStr + " 23:59:59'");
				rsQw.orderByDesc("create_time");
				rsQw.last("limit 1");
				KcDetectionDetailed kcDetectionDetailed = kcDetectionDetailedService.getOne(rsQw);
				kcKetangbiao.setKcDetectionDetailed(kcDetectionDetailed);
				QueryWrapper<KcDetectionDetailed> rsQwList = new QueryWrapper<>();
				rsQwList.eq("pid",detectionMain.getId());
				rsQwList.apply("create_time >= '" + nowStr + " 00:00:00' and create_time <= '" + nowStr + " 23:59:59'");
				rsQwList.orderByDesc("create_time");
				List<KcDetectionDetailed> zqrsList = kcDetectionDetailedService.list(rsQwList);
				kcKetangbiao.setZqrsList(zqrsList);

			}
		}catch(Exception e){
			e.printStackTrace();
		}

		return Result.OK(kcKetangbiao);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param kcKetangbiao
    */
//    @RequiresPermissions("ktgl:kc_ketangbiao:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, KcKetangbiao kcKetangbiao) {
        return super.exportXls(request, kcKetangbiao, KcKetangbiao.class, "课堂管理-子表");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
//    @RequiresPermissions("ktgl:kc_ketangbiao:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, KcKetangbiao.class);
    }

	 /**
	  * 查询统计信息
	  *
	  * @param skrq
	  * @return
	  */
	 //@AutoLog(value = "课堂管理-子表-查询统计信息")
	 @ApiOperation(value="课堂管理-子表-查询统计信息", notes="课堂管理-子表-查询统计信息")
	 @GetMapping(value = "/getCountList")
	 public Result<Object> getCountList(String skrq) {
		 Map<String, Object> rmap = Maps.newHashMap();
		 //第一句-今日课堂
		 QueryWrapper qw = new QueryWrapper();
		 qw.select("count(*) - 0 num",//【今日课堂数：总数】
			"count( CASE WHEN zbpx = '1' THEN '1' END ) txktnum",//【今日课堂数：腾讯】
			"count( CASE WHEN zbpx = '4' THEN '1' END ) ddktnum",//【今日课堂数：钉钉】
			"count( CASE WHEN zbpx IN ( '2', '3', '5', '6', '7', '8' ) THEN '1' END ) qtktnum",//【今日课堂数：其他】
			"count( CASE WHEN date_format( now(), '%H%i' ) > hhjs THEN 1 END ) xkktnum",//【今日课堂数：已下课】
			"count( CASE WHEN date_format( now(), '%H%i' ) < hhjs AND date_format( now(), '%H%i' ) > hhks THEN 1 END ) zzsknum"//【上课中】
		 );
		 qw.eq("skrq",skrq);
		 qw.eq("is_delete","0");
		 List<Map<String, Object>> kcKetangbiaoList = kcKetangbiaoService.listMaps(qw);
		 if(kcKetangbiaoList != null && !kcKetangbiaoList.isEmpty()){
			 rmap.put("jinRiKeTang",kcKetangbiaoList.get(0));
		 }
		 //第二句-今日听课

		 List<Map<String, Object>> kcKetangbiao2List = kcKetangbiaoService.selectJrTkCount(skrq);
		 if(kcKetangbiao2List != null && !kcKetangbiao2List.isEmpty()){
			 rmap.put("jinRiTingKe",kcKetangbiao2List.get(0));
		 }
		 //查询第三句-累计课堂

		 KcSysConfig kcSysConfig =kcSysConfigService.getById("1");

		QueryWrapper qw3 = new QueryWrapper();
		 qw3.select("count(*) - 0 num",//【已开课堂数：总数】
			"count( CASE WHEN zbpx = '1' THEN '1' END ) txktnum",//【腾讯课堂数】
			"count( CASE WHEN zbpx = '4' THEN '1' END ) ddktnum",//【钉钉课堂数】
			"count( CASE WHEN zbpx IN ( '2', '3', '5', '6', '7', '8' ) THEN '1' END ) qtktnum",//【其他课堂数】
			"count( CASE WHEN date_format( now(), '%H%i' ) > hhjs THEN 1 END ) xkktnum",//【下课课堂数】
			"count( CASE WHEN date_format( now(), '%H%i' ) < hhjs AND date_format( now(), '%H%i' ) > hhks THEN 1 END ) zzsknum"//【正在上课课堂数】
		);
		 qw3.ge("skrq",kcSysConfig.getBxqkssj());//<=
		 qw3.le("skrq",DateUtil.format(new Date(),"yyyy-MM-dd")+" 23:59:59");//>=
		 qw3.eq("is_delete","0");
		 List<Map<String, Object>> kcKetangbiao3List = kcKetangbiaoService.listMaps(qw3);
		 if(kcKetangbiao3List != null && !kcKetangbiao3List.isEmpty()){
			 rmap.put("yiKaiKeTang",kcKetangbiao3List.get(0));
		 }
		 KcKetangbiao kcKetangbiao = new KcKetangbiao();
		 kcKetangbiao.setStartTime(kcSysConfig.getBxqkssj());
		 kcKetangbiao.setEndTime(kcSysConfig.getBxqjssj()+" 23:59:59");
		 List<Map<String, Object>> listTjIndex = kcKetangbiaoService.getIndexYkktstj(kcKetangbiao);
		 if(listTjIndex != null && !listTjIndex.isEmpty()){
			 rmap.put("yiKaiKeTangNew",listTjIndex.get(0));
		 }
		 return Result.OK(rmap);
	 }

	 /**
	  * 今日课堂总数详情
	  *
	  * @param skrq
	  * @return
	  */
	 @ApiOperation(value="课堂管理-子表-今日课堂总数详情", notes="课堂管理-子表-今日课堂总数详情")
	 @GetMapping(value = "/jrktzsList")
	 public Result<?> jrktzsList(@RequestParam(name="pageNo", defaultValue="1") Integer pageNo,@RequestParam(name="pageSize", defaultValue="10") Integer pageSize,String skrq) {
		 //第一句-今日课堂-总数
		 QueryWrapper qw = new QueryWrapper();
		 qw.select("*");
		 qw.eq("skrq", skrq);
		 Page<Map<String, Object>> page = new Page<>(pageNo, pageSize);
		 IPage<Map<String, Object>> kcKetangbiaoList = kcKetangbiaoService.pageMaps(page,qw);
		 return Result.OK(kcKetangbiaoList);
	 }

	 /**
	  * 今日课堂已下课数详情
	  *
	  * @param skrq
	  * @return
	  */
	 @ApiOperation(value="课堂管理-子表-今日课堂已下课数详情", notes="课堂管理-子表-今日课堂已下课数详情")
	 @GetMapping(value = "/jrktyxkList")
	 public Result<?> jrktyxkList(@RequestParam(name="pageNo", defaultValue="1") Integer pageNo,@RequestParam(name="pageSize", defaultValue="10") Integer pageSize,String skrq) {
		 //第一句-今日课堂-已下课数
		 QueryWrapper qw = new QueryWrapper();
		 qw.select("*");
		 qw.eq("skrq", skrq);
		 qw.apply("date_format( now(), '%H%i' ) > hhjs");
		 Page<Map<String, Object>> page = new Page<>(pageNo, pageSize);
		 IPage<Map<String, Object>> kcKetangbiaoList = kcKetangbiaoService.pageMaps(page,qw);
		 return Result.OK(kcKetangbiaoList);
	 }

	 /**
	  * 今日课堂上课中详情
	  *
	  * @param skrq
	  * @return
	  */
	 @ApiOperation(value="课堂管理-子表-今日课堂上课中详情", notes="课堂管理-子表-今日课堂上课中详情")
	 @GetMapping(value = "/skzList")
	 public Result<?> skzList(@RequestParam(name="pageNo", defaultValue="1") Integer pageNo,@RequestParam(name="pageSize", defaultValue="10") Integer pageSize,String skrq) {
		 //第一句-今日课堂-上课中
		 QueryWrapper qw = new QueryWrapper();
		 qw.select("*");
		 qw.eq("skrq", skrq);
		 qw.apply("date_format( now(), '%H%i' ) < hhjs AND date_format( now(), '%H%i' ) > hhks");
		 Page<Map<String, Object>> page = new Page<>(pageNo, pageSize);
		 IPage<Map<String, Object>> kcKetangbiaoList = kcKetangbiaoService.pageMaps(page,qw);
		 return Result.OK(kcKetangbiaoList);
	 }

	 /**
	  * 已开课堂总数详情
	  *
	  * @param skrq
	  * @return
	  */
	 @ApiOperation(value="课堂管理-子表-已开课堂总数详情", notes="课堂管理-子表-已开课堂总数详情")
	 @GetMapping(value = "/ykktzsList")
	 public Result<?> ykktzsList(@RequestParam(name="pageNo", defaultValue="1") Integer pageNo,@RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								 String skrq,String kkdw,String hh,String kcxz,String ywTime,String ywmc) {


		 KcSysConfig kcSysConfig =kcSysConfigService.getById("1");

		 QueryWrapper<KcKetangbiao> qw3 = new QueryWrapper<>();
		 qw3.ge("kt.skrq",kcSysConfig.getBxqkssj());//<=
		 qw3.le("kt.skrq",DateUtil.format(new Date(),"yyyy-MM-dd")+" 23:59:59");//>=
		 qw3.eq(StringUtils.isNotBlank(kkdw),"kt.kkdw",kkdw);
		 qw3.eq(StringUtils.isNotBlank(hh),"kt.hh",hh);
		 qw3.eq(StringUtils.isNotBlank(kcxz),"kt.kcxz",kcxz);
		 qw3.eq(StringUtils.isNotBlank(ywTime),"kt.skrq",ywTime);
		 qw3.apply(StringUtils.isNotBlank(ywmc),"(kt.skjs like '%"+ywmc+"%' or kt.kcmc like '%"+ywmc+"%') ");
		 Page<KcKetangbiao> page = new Page<KcKetangbiao>(pageNo, pageSize);
		 IPage<KcKetangbiao> pageList = kcKetangbiaoService.indexYkktzsPage(page, qw3);

//		 //查询第三句-已开课堂总数
//		 QueryWrapper qw3 = new QueryWrapper();
//		 qw3.select("*");
//		 qw3.ge("skrq",getBxqStartTime());//<=
//		 qw3.le("skrq",skrq);//>=
//		 qw3.eq(StringUtils.isNotBlank(kkdw),"kkdw",kkdw);
//		 qw3.eq(StringUtils.isNotBlank(hh),"hh",hh);
//		 qw3.eq(StringUtils.isNotBlank(kcxz),"kcxz",kcxz);
//		 qw3.eq(StringUtils.isNotBlank(ywTime),"skrq",ywTime);
//		 qw3.apply(StringUtils.isNotBlank(ywmc),"(skjs like '%"+ywmc+"%' or kcmc like '%"+ywmc+"%') ");
//		 Page<Map<String, Object>> page = new Page<>(pageNo, pageSize);
//		 IPage<Map<String, Object>> kcKetangbiao3List = kcKetangbiaoService.pageMaps(page,qw3);
//		 List<Map<String, Object>> list = kcKetangbiao3List.getRecords();
//		 for(int i=0;i<list.size();i++){
//			 Map<String, Object> map = list.get(i);
//			 String ketangbiaoid = map.get("id")+"";
//			 KcKetangbiao kcKetangbiao = new KcKetangbiao();
//			 kcKetangbiao.setId(ketangbiaoid);
//			 KcKetangbiao kcKetangbiaoPar = kcKetangbiaoService.getScoreById(kcKetangbiao);
//			 if(kcKetangbiaoPar!=null&&StringUtils.isNotBlank(kcKetangbiaoPar.getScore())){
//				 map.put("score",kcKetangbiaoPar.getScore());
//			 }
//		 }
		 return Result.OK(pageList);
	 }

	 /**
	  * 已开课堂听课课堂详情
	  *
	  * @param skrq
	  * @return
	  */
	 @ApiOperation(value="课堂管理-子表-已开课堂听课课堂详情", notes="课堂管理-子表-已开课堂听课课堂详情")
	 @GetMapping(value = "/ykkttkktList")
	 public Result<?> ykkttkktList(@RequestParam(name="pageNo", defaultValue="1") Integer pageNo,@RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   String skrq,String kkdw,String hh,String kcxz,String ywTime,String ywmc) {
		 //查询第三句-已开课堂听课课堂

		 KcSysConfig kcSysConfig =kcSysConfigService.getById("1");

		 KcKetangbiao kcKetangbiao = new KcKetangbiao();
		 kcKetangbiao.setStartTime(kcSysConfig.getBxqkssj());
		 kcKetangbiao.setEndTime(kcSysConfig.getBxqjssj()+" 23:59:59");
		 kcKetangbiao.setKkdw(kkdw);
		 kcKetangbiao.setHh(hh);
		 kcKetangbiao.setKcxz(kcxz);
		 kcKetangbiao.setYwmc(ywmc);
		 kcKetangbiao.setYwTime(ywTime);
		 Page<Map<String, Object>> page = new Page<>(pageNo, pageSize);
		 IPage<Map<String, Object>> listTjIndex = kcKetangbiaoService.getIndexYkktstjYkkttkktList(page,kcKetangbiao);
		 return Result.OK(listTjIndex);
	 }

	 /**
	  * 已开课堂听课课堂详情 听课人次
	  *
	  * @param skrq
	  * @return
	  */
	 @ApiOperation(value="课堂管理-子表-已开课堂听课课堂详情", notes="课堂管理-子表-已开课堂听课课堂详情")
	 @GetMapping(value = "/ykkttkrcList")
	 public Result<?> ykkttkrcList(@RequestParam(name="pageNo", defaultValue="1") Integer pageNo,@RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   String skrq,String kkdw,String hh,String kcxz,String ywTime,String ywmc) {
		 //查询第三句-已开课堂听课课堂
		 KcSysConfig kcSysConfig =kcSysConfigService.getById("1");
		 KcKetangbiao kcKetangbiao = new KcKetangbiao();
		 kcKetangbiao.setStartTime(kcSysConfig.getBxqkssj());
		 kcKetangbiao.setEndTime(kcSysConfig.getBxqjssj()+" 23:59:59");
		 kcKetangbiao.setKkdw(kkdw);
		 kcKetangbiao.setHh(hh);
		 kcKetangbiao.setKcxz(kcxz);
		 kcKetangbiao.setYwmc(ywmc);
		 kcKetangbiao.setYwTime(ywTime);
		 Page<Map<String, Object>> page = new Page<>(pageNo, pageSize);
		 IPage<Map<String, Object>> listTjIndex = kcKetangbiaoService.getIndexYkktstjYkkttkrcList(page,kcKetangbiao);
		 return Result.OK(listTjIndex);
	 }

	 /**
	  * 已开课堂听课课堂详情 听课人次
	  *
	  * @param skrq
	  * @return
	  */
	 @ApiOperation(value="课堂管理-子表-已开课堂听课课堂详情", notes="课堂管理-子表-已开课堂听课课堂详情")
	 @GetMapping(value = "/jrtkktsList")
	 public Result<?> jrtkktsList(@RequestParam(name="pageNo", defaultValue="1") Integer pageNo,@RequestParam(name="pageSize", defaultValue="10") Integer pageSize,String skrq) {
		 //查询第三句-已开课堂听课课堂
		 Page<Map<String, Object>> page = new Page<>(pageNo, pageSize);
		 IPage<Map<String, Object>> kcKetangbiao2List = kcKetangbiaoService.selectJrTkJrtkktsList(page,skrq);
		 return Result.OK(kcKetangbiao2List);
	 }

	 /**
	  * 已开课堂听课课堂详情 听课人次
	  *
	  *
	  * @param skrq
	  * @return
	  */
	 @ApiOperation(value="课堂管理-子表-已开课堂听课课堂详情", notes="课堂管理-子表-已开课堂听课课堂详情")
	 @GetMapping(value = "/jrtktkrcList")
	 public Result<?> jrtktkrcList(@RequestParam(name="pageNo", defaultValue="1") Integer pageNo,@RequestParam(name="pageSize", defaultValue="10") Integer pageSize,String skrq) {
		 //查询第三句-已开课堂听课课堂
		 Page<Map<String, Object>> page = new Page<>(pageNo, pageSize);
		 IPage<Map<String, Object>> kcKetangbiao2List = kcKetangbiaoService.selectJrTkJrtktkrcList(page,skrq);
		 return Result.OK(kcKetangbiao2List);
	 }

	//------------------------------yangjun------------------------------

	 @ApiOperation(value="课堂管理-子表-分页列表查询", notes="课堂管理-子表-分页列表查询")
	 @GetMapping(value = "/getKclblist")
	 public Result<IPage<KcKetangbiao>> getKclblist(KcKetangbiao kcKetangbiao,
													  @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
													  @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
													  HttpServletRequest req) {

//		 String username = JwtUtil.getUserNameByToken(req);
//		 LoginUser loginUser = commonApi.getUserByName(username);
//		 kcKetangbiao.setUserid(loginUser.getUsername());
//		 QueryWrapper<KcKetangbiao> queryWrapper = QueryGenerator.initQueryWrapper(kcKetangbiao, req.getParameterMap());
//		 queryWrapper.apply(StringUtils.isNotBlank(kcKetangbiao.getYwmc())," (skjs like '%"+kcKetangbiao.getYwmc()+"%' or kcmc like '%"+kcKetangbiao.getYwmc()+"%')");
//		 queryWrapper.ne(StringUtils.isNotBlank(kcKetangbiao.getYwskxs()),"skxs",kcKetangbiao.getYwskxs());
		 Page<KcKetangbiao> page = new Page<KcKetangbiao>(pageNo, pageSize);
		 IPage<KcKetangbiao> pageList = kcKetangbiaoService.getKclblist(page, kcKetangbiao);
		 log.info("-----videoScreenshotByJsbh-----pageList--------------{},{}",pageList.getRecords().size(),pageList.getRecords());
		 return Result.OK(pageList);
	 }



	 @ApiOperation(value="学生首页课程信息", notes="学生首页课程信息")
	 @GetMapping(value = "/getStudentKclblist")
	 public Result<IPage<KcKetangbiao>> getStudentKclblist(KcKetangbiao kcKetangbiao,
													@RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
													@RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
													HttpServletRequest req) {
		 Page<KcKetangbiao> page = new Page<KcKetangbiao>(pageNo, pageSize);
		 IPage<KcKetangbiao> pageList = kcKetangbiaoService.getStudentKclblist(page, kcKetangbiao);
		 return Result.OK(pageList);
	 }
	 // ------------------------------yangjun------------------------------


	 //按照时间取得即将上课的节次条件，大于课前15分钟，小于上课开始时间
	 //统计用
	 public String getJieciBytimejjsk(String time) {
		 int $time = Integer.parseInt(time);
		 String $str;
		 if ($time <= 800 && $time >= 745) {
			 $str = "kt.hh in ('01、02','01','02')";
		 } else if ($time <= 1000 && $time >= 945) {
			 $str = "kt.hh in ('03、04','03','04')";
		 } else if ($time <= 1330 && $time >= 1315) {
			 $str = "kt.hh in ('05、06','05','06')";
		 } else if ($time <= 1530 && $time >= 1515) {
			 $str = "kt.hh in ('07、08','07','08')";
		 } else if ($time <= 1730 && $time >= 1715) {
			 $str = "kt.hh in ('09、10','09','10')";
		 } else if ($time <= 1930 && $time >= 1915) {
			 $str = "kt.hh in ('11、12','11','12')";
		 } else {
			 $str = "1<>1 ";
		 }
		 return $str;
	 }
	 //按照时间取得正在上课信息节次条件，大于上课开始时间，小于课程结束时间
	 //统计用
	 public String getJieciBytimezzsk(String time) {
		 int $time = Integer.parseInt(time);
		 String $str;
		 if ($time <= 930 && $time >= 800) {
			 $str = "kt.hh in ('01、02','01','02')";
		 } else if ($time <= 1130 && $time >= 1000) {
			 $str = "kt.hh in ('03、04','03','04')";
		 } else if ($time <= 1500 && $time >= 1330) {
			 $str = "kt.hh in ('05、06','05','06')";
		 } else if ($time <= 1700 && $time >= 1530) {
			 $str = "kt.hh in ('07、08','07','08')";
		 } else if ($time <= 1900 && $time >= 1730) {
			 $str = "kt.hh in ('09、10','09','10')";
		 } else if ($time <= 2100 && $time >= 1930) {
			 $str = "kt.hh in ('11、12','11','12')";
		 } else {
			 $str = "1<>1 ";
		 }

		 return $str;
	 }

	 //按照时间取得正在上课节次条件，大于课前30分钟，小于课程结束时间
	 public String getJieciBytime(String time) {
		 int $time = Integer.parseInt(time);
		 String $str;
		 if ($time <= 930 && $time >= 730) {
			 $str = "kt.hh in ('01、02','01','02')";
		 } else if ($time <= 1130 && $time >= 930) {
			 $str = "kt.hh in ('03、04','03','04')";
		 } else if ($time <= 1500 && $time >= 1300) {
			 $str = "kt.hh in ('05、06','05','06')";
		 } else if ($time <= 1700 && $time >= 1500) {
			 $str = "kt.hh in ('07、08','07','08')";
		 } else if ($time <= 1900 && $time >= 1700) {
			 $str = "kt.hh in ('09、10','09','20')";
		 } else if ($time <= 2100 && $time >= 1900) {
			 $str = "kt.hh in ('11、12','11','12')";
		 } else {
			 $str = "1<>1 ";
		 }

		 return $str;
	 }

	 //按照时间取得下一节课节次，大于上课开始30分钟，小于上课结束时间30分钟
	 public String getNextJieciBytime(String time) {
		 int $time = Integer.parseInt(time);
		 String $str;
		 //根据时间获得下一课节次
		 if ($time <= 730 && $time >= 0) {
			$str = "kt.hh in ('01、02','01')";
		 } else if ($time <= 900 && $time >= 730) {
			$str = "kt.hh in ('03、04','03')";
		 } else if ($time <= 1300 && $time >= 900) {
			$str = "kt.hh in ('05、06','05')";
		 } else if ($time <= 1500 && $time >= 1300) {
			$str = "kt.hh in ('07、08','07')";
		 } else if ($time <= 1700 && $time >= 1500) {
			$str = "kt.hh in ('09、10','09')";
		 } else if ($time <= 1830 && $time > 1700) {
			$str = "kt.hh in ('11、12','11')";
		 } else if ($time > 1900) {
		 	$str = "kt.hh in ('01、02','01')";
		 } else {
			$str = "true ";
		 }
		 return $str;
 }

	@ApiOperation(value="首页任教课程-即将上课", notes="首页任教课程-即将上课")
	@GetMapping(value = "/getTeacherjjsk")
	public Result<List<Map<String, Object>>> getTeacherjjsk(KcKetangbiao kcKetangbiao){
		Date now = new Date();
		String currDate = DateUtil.format(now,"yyyy-MM-dd");
		String currTime = DateUtil.format(now,"HHmm");
		Map<String,String> queryMap = Maps.newHashMap();
		queryMap.put("jieciSql",getJieciBytimejjsk(currTime));
		queryMap.put("currDate",currDate);
		queryMap.put("userid",kcKetangbiao.getUserid());
		return Result.OK(kcKetangbiaoService.getTeacherjjsk(queryMap));
	}

	 @ApiOperation(value="首页任教课程-正在上课", notes="首页任教课程-正在上课")
	 @GetMapping(value = "/getTeacherzzsk")
	 public Result<List<Map<String, Object>>> getTeacherzzsk(KcKetangbiao kcKetangbiao){
		 Date now = new Date();
		 String currDate = DateUtil.format(now,"yyyy-MM-dd");
		 String currTime = DateUtil.format(now,"HHmm");
		 Map<String,String> queryMap = Maps.newHashMap();
		 queryMap.put("jieciSql",getJieciBytimezzsk(currTime));
		 queryMap.put("currDate",currDate);
		 queryMap.put("userid",kcKetangbiao.getUserid());
		 return Result.OK(kcKetangbiaoService.getTeacherzzsk(queryMap));
	 }
	 @ApiOperation(value="首页任教课程-待上课程", notes="首页任教课程-待上课程")
	 @GetMapping(value = "/getTeacherdskc")
	 public Result<List<Map<String, Object>>> getTeacherdskc(KcKetangbiao kcKetangbiao){
		 Date now = new Date();
		 String currDate = DateUtil.format(now,"yyyy-MM-dd");
		 String currTime = DateUtil.format(now,"HH:mm");
		 Map<String,String> queryMap = Maps.newHashMap();
		 queryMap.put("currDate",currDate);
		 queryMap.put("currTime",currTime);
		 queryMap.put("userid",kcKetangbiao.getUserid());
		 return Result.OK(kcKetangbiaoService.getTeacherdskc(queryMap));
	 }
	 @ApiOperation(value="首页任教课程-已上课程", notes="首页任教课程-已上课程")
	 @GetMapping(value = "/getTeacheryskc")
	 public Result<List<Map<String, Object>>> getTeacheryskc(KcKetangbiao kcKetangbiao){
		 Date now = new Date();
		 String currDate = DateUtil.format(now,"yyyy-MM-dd");
		 String currTime = DateUtil.format(now,"HH:mm");
		 Map<String,String> queryMap = Maps.newHashMap();
		 queryMap.put("currDate",currDate);
		 queryMap.put("currTime",currTime);
		 queryMap.put("userid",kcKetangbiao.getUserid());
		 return Result.OK(kcKetangbiaoService.getTeacheryskc(queryMap));
	 }
	 @ApiOperation(value="首页任教课程-近6日课程表", notes="首页任教课程-近6日课程表")
	 @GetMapping(value = "/getTeacherjlrkcb")
	 public Result<List<Map<String, Object>>> getTeacherjlrkcb(KcKetangbiao kcKetangbiao){
		 Date now = new Date();
		 String currDate = DateUtil.format(now,"yyyy-MM-dd");
		 String currTime = DateUtil.format(now,"HHmm");

		 DateTime currDate7d = DateUtil.offset(now, DateField.DAY_OF_MONTH, 7);

		 String currDate7 = DateUtil.format(currDate7d,"yyyy-MM-dd");

		 Map<String,String> queryMap = Maps.newHashMap();
//		 queryMap.put("jieciSql",getJieciBytimejjsk(currTime));
		 queryMap.put("currDate",currDate);
		 queryMap.put("currDate7",currDate7);
		 queryMap.put("userid",kcKetangbiao.getUserid());

		 return Result.OK(kcKetangbiaoService.getTeacherjlrkcb(queryMap));
	 }

	 @ApiOperation(value="首页获取课堂笔记", notes="学生首页课程信息")
	 @GetMapping(value = "/getKtbjList")
	 public Result<List<KcKetangbiao>> getKtbjList(KcKetangbiao kcKetangbiao, HttpServletRequest req) {
		 List<KcKetangbiao> pageList = kcKetangbiaoService.getKtbjList(kcKetangbiao);
		 return Result.OK(pageList);
	 }

	@ApiOperation(value="课堂管理-子表-分页列表查询", notes="课堂管理-子表-分页列表查询")
	@GetMapping(value = "/getKtsbMorelist")
	public Result<IPage<KcKetangbiao>> getKtsbMorelist(KcKetangbiao kcKetangbiao,
													 @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
													 @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
													 HttpServletRequest req) {
		QueryWrapper<KcKetangbiao> queryWrapper = QueryGenerator.initQueryWrapper(kcKetangbiao, req.getParameterMap());
		queryWrapper.ge(StringUtils.isNotBlank(kcKetangbiao.getStartTime()),"a.create_time",kcKetangbiao.getStartTime());//
		queryWrapper.le(StringUtils.isNotBlank(kcKetangbiao.getEndTime()),"a.create_time",kcKetangbiao.getEndTime()+" 23:59:59");//
		queryWrapper.eq(StringUtils.isNotBlank(kcKetangbiao.getUserid()),"a.user_id",kcKetangbiao.getUserid());//
		queryWrapper.orderByDesc("a.create_time");
		Page<KcKetangbiao> page = new Page<KcKetangbiao>(pageNo, pageSize);
		IPage<KcKetangbiao> pageList = kcKetangbiaoService.getKtsbMorelist(page, queryWrapper);
		return Result.OK(pageList);
	}

	@ApiOperation(value="获取课程信息", notes="获取课程信息")
	@GetMapping(value = "/getKtbinfo")
	public Result<KcKetangbiao> getKtbinfo(KcKetangbiao kcKetangbiao, HttpServletRequest req) {
		 QueryWrapper<KcKetangbiao> queryWrapper = new QueryWrapper<>();
		queryWrapper.like("kcmc",kcKetangbiao.getKcmc());
		queryWrapper.like("skjs",kcKetangbiao.getSkjs());
		queryWrapper.like("skrq",kcKetangbiao.getSkrq());
		queryWrapper.like("skdd",kcKetangbiao.getSkdd());
		queryWrapper.last("limit 1");
		KcKetangbiao pageList = kcKetangbiaoService.getOne(queryWrapper);
		return Result.OK(pageList);
	}



	@ApiOperation(value="统计年度课程信息数量", notes="统计年度课程信息数量")
	@GetMapping(value = "/getKccountList")
	public Result<?> getKccountList(KcKetangbiao kcKetangbiao,
									@RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
									@RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
									HttpServletRequest req) {
		Page<Map<String, Object>> page = new Page<>(pageNo, pageSize);
		if(StringUtils.isBlank(kcKetangbiao.getXnxq())){
			KcSysConfig kcSysConfig = kcSysConfigService.getById("1");
			kcKetangbiao.setXnxq(kcSysConfig.getFlag1());
		}
		IPage<Map<String, Object>> kcKetangbiaoList = kcKetangbiaoService.getKccountList(page,kcKetangbiao);
		return Result.OK(kcKetangbiaoList);
	}


	@RequestMapping(value = "/exportKcnumXls")
	public ModelAndView exportKcnumXls(HttpServletRequest request, KcKetangbiaoNum kcKetangbiaoNum) {
		return exportKcnumXls(request, kcKetangbiaoNum, KcKetangbiaoNum.class, "课堂统计");
	}
	protected ModelAndView exportKcnumXls(HttpServletRequest request, KcKetangbiaoNum object, Class<KcKetangbiaoNum> clazz, String title) {
		// Step.1 组装查询条件
		QueryWrapper<KcKetangbiaoNum> queryWrapper = QueryGenerator.initQueryWrapper(object, request.getParameterMap());
		LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();

		// Step.2 获取导出数据
		if(StringUtils.isBlank(object.getXnxq())){
			KcSysConfig kcSysConfig = kcSysConfigService.getById("1");
			object.setXnxq(kcSysConfig.getFlag1());
		}
		List<KcKetangbiaoNum> exportList = service.getKccountExportList(object);

		// Step.3 AutoPoi 导出Excel
		ModelAndView mv = new ModelAndView(new JeecgEntityExcelView());
		//此处设置的filename无效 ,前端会重更新设置一下
		mv.addObject(NormalExcelConstants.FILE_NAME, title);
		mv.addObject(NormalExcelConstants.CLASS, clazz);
		//update-begin--Author:liusq  Date:20210126 for：图片导出报错，ImageBasePath未设置--------------------
		ExportParams exportParams=new ExportParams(title + "报表", "导出人:" + sysUser.getRealname(), title);
//		exportParams.setImageBasePath(upLoadPath);
		//update-end--Author:liusq  Date:20210126 for：图片导出报错，ImageBasePath未设置----------------------
		mv.addObject(NormalExcelConstants.PARAMS,exportParams);
		mv.addObject(NormalExcelConstants.DATA_LIST, exportList);
		return mv;
	}


	@ApiOperation(value="统计年度课程信息数量", notes="统计年度课程信息数量")
	@GetMapping(value = "/getKtcountList")
	public Result<?> getKtcountList(KcKetangbiao kcKetangbiao,
									@RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
									@RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
									HttpServletRequest req) {
		QueryWrapper<KcKetangbiao> queryWrapper = QueryGenerator.initQueryWrapper(kcKetangbiao, req.getParameterMap());
		if(StringUtils.isBlank(kcKetangbiao.getXnxq())){
			KcSysConfig kcSysConfig = kcSysConfigService.getById("1");
			kcKetangbiao.setXnxq(kcSysConfig.getFlag1());
		}
		Page<Map<String, Object>> page = new Page<>(pageNo, pageSize);
		IPage<Map<String, Object>> kcKetangbiaoList = kcKetangbiaoService.getKtcountList(page,kcKetangbiao);
		return Result.OK(kcKetangbiaoList);
	}


	@RequestMapping(value = "/exportKtnumXls")
	public ModelAndView exportKtnumXls(HttpServletRequest request, KcKetangbiaoNum kcKetangbiaoNum) {
		return exportKtnumXls(request, kcKetangbiaoNum, KcKetangbiaoNum.class, "课堂统计");
	}
	protected ModelAndView exportKtnumXls(HttpServletRequest request, KcKetangbiaoNum object, Class<KcKetangbiaoNum> clazz, String title) {
		// Step.1 组装查询条件
		QueryWrapper<KcKetangbiaoNum> queryWrapper = QueryGenerator.initQueryWrapper(object, request.getParameterMap());
		LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();

		// Step.2 获取导出数据
		if(StringUtils.isBlank(object.getXnxq())){
			KcSysConfig kcSysConfig = kcSysConfigService.getById("1");
			object.setXnxq(kcSysConfig.getFlag1());
		}
		List<KcKetangbiaoNum> exportList = service.getKtcountExportList(object);

		// Step.3 AutoPoi 导出Excel
		ModelAndView mv = new ModelAndView(new JeecgEntityExcelView());
		//此处设置的filename无效 ,前端会重更新设置一下
		mv.addObject(NormalExcelConstants.FILE_NAME, title);
		mv.addObject(NormalExcelConstants.CLASS, clazz);
		//update-begin--Author:liusq  Date:20210126 for：图片导出报错，ImageBasePath未设置--------------------
		ExportParams exportParams=new ExportParams(title + "报表", "导出人:" + sysUser.getRealname(), title);
//		exportParams.setImageBasePath(upLoadPath);
		//update-end--Author:liusq  Date:20210126 for：图片导出报错，ImageBasePath未设置----------------------
		mv.addObject(NormalExcelConstants.PARAMS,exportParams);
		mv.addObject(NormalExcelConstants.DATA_LIST, exportList);
		return mv;
	}



	/**
	 * 学生日历课程
	 * @param kcKetangbiao
	 * @param req
	 * @return
	 */
	@GetMapping(value = "/getStudentRiliKclist")
	public Result<List<KcKetangbiao>> getStudentRiliKclist(KcKetangbiao kcKetangbiao,
														   HttpServletRequest req) {
		QueryWrapper<KcKetangbiao> queryWrapper = QueryGenerator.initQueryWrapper(kcKetangbiao, req.getParameterMap());
		LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
		KcSysConfig kcSysConfig = kcSysConfigService.getById("1");
		kcKetangbiao.setXnxq(kcSysConfig.getFlag1());
		kcKetangbiao.setXh(sysUser.getUsername());

		List pageList = kcKechengbiaoService.getStudentRiliKclist(kcKetangbiao);



		return Result.OK(pageList);
	}

}
