package org.jeecg.modules.kc.ktgl.entity;

import java.io.Serializable;
import java.io.UnsupportedEncodingException;
import java.util.Date;
import java.math.BigDecimal;

import com.baomidou.mybatisplus.annotation.*;
import lombok.Data;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;
import org.jeecgframework.poi.excel.annotation.Excel;
import org.jeecg.common.aspect.annotation.Dict;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * @Description: 课程管理-主表
 * @Author: jeecg-boot
 * @Date:   2023-04-01
 * @Version: V1.0
 */
@Data
@TableName("kc_kechengbiao")
@Accessors(chain = true)
@EqualsAndHashCode(callSuper = false)
@ApiModel(value="kc_kechengbiao对象", description="课程管理-主表")
public class KcKechengbiao implements Serializable {
    private static final long serialVersionUID = 1L;

	/**id*/
	@TableId(type = IdType.ASSIGN_ID)
    @ApiModelProperty(value = "id")
    private java.lang.String id;
	/**创建人登录名称*/
//    @ApiModelProperty(value = "创建人登录名称")
//    private java.lang.String createBy;
//	/**创建日期*/
//	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd")
//    @DateTimeFormat(pattern="yyyy-MM-dd")
//    @ApiModelProperty(value = "创建日期")
//    private java.util.Date createTime;
//	/**更新人登录名称*/
//    @ApiModelProperty(value = "更新人登录名称")
//    private java.lang.String updateBy;
//	/**更新日期*/
//	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd")
//    @DateTimeFormat(pattern="yyyy-MM-dd")
//    @ApiModelProperty(value = "更新日期")
//    private java.util.Date updateTime;
//	/**所属部门*/
//    @ApiModelProperty(value = "所属部门")
//    private java.lang.String sysOrgCode;
	/**课程编号*/
	@Excel(name = "课程编号", width = 15)
    @ApiModelProperty(value = "课程编号")
    private java.lang.String kcbh;
	/**课程名称*/
	@Excel(name = "课程名称", width = 15)
    @ApiModelProperty(value = "课程名称")
    private java.lang.String kcmc;
	/**授课教师*/
	@Excel(name = "授课教师", width = 15)
    @ApiModelProperty(value = "授课教师")
    private java.lang.String skjs;
	/**职称*/
	@Excel(name = "职称", width = 15)
    @ApiModelProperty(value = "职称")
    private java.lang.String zc;
	/**学科人数*/
	@Excel(name = "学科人数", width = 15)
    @ApiModelProperty(value = "学科人数")
    private java.lang.String xkrs;
	/**评课人数*/
	@Excel(name = "评课人数", width = 15)
    @ApiModelProperty(value = "评课人数")
    private java.lang.String pkrs;
	/**任务编号*/
	@Excel(name = "任务编号", width = 15)
    @ApiModelProperty(value = "任务编号")
    private java.lang.String rwbh;
	/**开课单位*/
    @Excel(name = "开课单位", width = 15, dicCode = "tkrszdw_view,college,college")
    @Dict(dicCode = "tkrszdw_view,college,college")
    @ApiModelProperty(value = "开课单位")
    private java.lang.String kkdw;
	/**课程性质*/
    @Excel(name = "课程性质", width = 15, dicCode = "kcxz")
    @Dict(dicCode = "kcxz")
    @ApiModelProperty(value = "课程性质")
    private java.lang.String kcxz;
    /**教室编号*/
    @Excel(name = "教室编号", width = 15)
    private String jsbh;
	/**上课地点*/
	@Excel(name = "上课地点", width = 15)
    @ApiModelProperty(value = "上课地点")
    private java.lang.String skdd;
	/**授课时间*/
	@Excel(name = "授课时间", width = 15)
    @ApiModelProperty(value = "授课时间")
    private java.lang.String sksj;
	/**上课周次*/
    @Excel(name = "上课周次", width = 15, dicCode = "skzc")
    @Dict(dicCode = "skzc")
    @ApiModelProperty(value = "上课周次")
    private java.lang.String jkzc;
	/**节次*/
    @Excel(name = "节次", width = 15, dicCode = "skjc")
    @Dict(dicCode = "skjc")
    @ApiModelProperty(value = "节次")
    private java.lang.String hh;
	/**星期几*/
    @Excel(name = "周几", width = 15, dicCode = "week")
    @Dict(dicCode = "week")
    @ApiModelProperty(value = "星期几")
    private java.lang.String week;
	/**课程开始时间*/
	@Excel(name = "课程开始时间", width = 15)
    @ApiModelProperty(value = "课程开始时间")
    private java.lang.String hhks;
	/**课程结束时间*/
	@Excel(name = "课程结束时间", width = 15)
    @ApiModelProperty(value = "课程结束时间")
    private java.lang.String hhjs;
	/**未知*/
	@Excel(name = "未知", width = 15)
    @ApiModelProperty(value = "未知")
    private java.lang.String dsz;
	/**课程开始日期*/
	@Excel(name = "课程开始日期", width = 15)
    @ApiModelProperty(value = "课程开始日期")
    private java.lang.String wwks;
	/**课程结束日期*/
	@Excel(name = "课程结束日期", width = 15)
    @ApiModelProperty(value = "课程结束日期")
    private java.lang.String wwjs;
	/**直播方式*/
    @Excel(name = "直播方式", width = 15, dicCode = "skpt")
    @Dict(dicCode = "skpt")
    @ApiModelProperty(value = "直播方式")
    private java.lang.String zbfs;
	/**会议号*/
	@Excel(name = "会议号", width = 15)
    @ApiModelProperty(value = "会议号")
    private java.lang.String hyh;
	/**会议密码*/
	@Excel(name = "会议密码", width = 15)
    @ApiModelProperty(value = "会议密码")
    private java.lang.String hymm;
	/**课程链接*/
	@Excel(name = "课程链接", width = 15)
    @ApiModelProperty(value = "课程链接")
    private java.lang.String kclj;
	/**备注*/
	@Excel(name = "备注", width = 15)
    @ApiModelProperty(value = "备注")
    private java.lang.String beizhu;
	/**直播平台*/
	@Excel(name = "直播平台", width = 15)
    @ApiModelProperty(value = "直播平台")
    private java.lang.String zbpx;
	/**开课单位id*/
	@Excel(name = "开课单位id", width = 15)
    @ApiModelProperty(value = "开课单位id")
    private java.lang.String kkdwid;
	/**未知*/
	@Excel(name = "未知", width = 15)
    @ApiModelProperty(value = "未知")
    private java.lang.String jrfs;
	/**二维码文件*/
	@Excel(name = "二维码文件", width = 15)
    @ApiModelProperty(value = "二维码文件")
    private java.lang.String ewmwj;
	/**群名称*/
	@Excel(name = "群名称", width = 15)
    @ApiModelProperty(value = "群名称")
    private java.lang.String qmc;
	/**群类型*/
	@Excel(name = "群类型", width = 15)
    @ApiModelProperty(value = "群类型")
    private java.lang.String qlx;
	/**类型*/
	@Excel(name = "类型", width = 15)
    @ApiModelProperty(value = "类型")
    private java.lang.String leixing;
	/**是否需要群主验证*/
	@Excel(name = "是否需要群主验证", width = 15)
    @ApiModelProperty(value = "是否需要群主验证")
    private java.lang.String isqzyz;
	/**教课周次1*/
	@Excel(name = "教课周次1", width = 15)
    @ApiModelProperty(value = "教课周次1")
    private java.lang.String jkzc1;
	/**学分*/
	@Excel(name = "学分", width = 15)
    @ApiModelProperty(value = "学分")
    private java.lang.String xf;
	/**校区*/
	@Excel(name = "校区", width = 15)
    @ApiModelProperty(value = "校区")
    private java.lang.String xq;
	/**教工号*/
	@Excel(name = "教工号", width = 15)
    @ApiModelProperty(value = "教工号")
    private java.lang.String jgh;
	/**学年学期*/
	@Excel(name = "学年学期", width = 15)
    @ApiModelProperty(value = "学年学期")
    private java.lang.String xnxq;
	/**教职工类别*/
	@Excel(name = "教职工类别", width = 15)
    @ApiModelProperty(value = "教职工类别")
    private java.lang.String jzglb;
	/**是否出镜，0-出镜，1-不出镜*/
	@Excel(name = "是否出镜，0-出镜，1-不出镜", width = 15)
    @ApiModelProperty(value = "是否出镜，0-出镜，1-不出镜")
    private java.lang.Integer sfcj;
	/**上课形式，0-线上，1-线下，2-线上线下混合*/
	@Excel(name = "上课形式，0-线上，1-线下，2-线上线下混合", width = 15)
    @ApiModelProperty(value = "上课形式，0-线上，1-线下，2-线上线下混合")
    private java.lang.Integer skxs;
	/**是否正常？*/
	@Excel(name = "是否正常？", width = 15)
    @ApiModelProperty(value = "是否正常？")
    private java.lang.String sfzc;
	/**备注*/
	@Excel(name = "备注", width = 15)
    @ApiModelProperty(value = "备注")
    private java.lang.String bz;
	/**状态*/
	@Excel(name = "状态", width = 15)
    @ApiModelProperty(value = "状态")
    private java.lang.String zt;

    private java.lang.String kcdl;
    private java.lang.String szkc;//思政课程
    private String xqxn;
    private String flag;

	/**课程名称或教师名*/
    @TableField(exist = false)
    private java.lang.String searchInput;

    @TableField(exist = false)
    private java.lang.String startTime;
    @TableField(exist = false)
    private java.lang.String endTime;
    @TableField(exist = false)
    private java.lang.String ts;
    @TableField(exist = false)
    private java.lang.String ywcol;
    @TableField(exist = false)
    private java.lang.String checkType;
    @TableField(exist = false)
    private java.lang.String dbtxType;

}
