package org.jeecg.modules.kc.ktgl.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.jeecg.common.aspect.annotation.Dict;
import org.jeecgframework.poi.excel.annotation.Excel;

import java.io.Serializable;
import java.util.Date;

/**
 * @Description: 课程管理-主表
 * @Author: jeecg-boot
 * @Date:   2023-04-01
 * @Version: V1.0
 */
@Data
@TableName("kc_kechengbiao_his")
@Accessors(chain = true)
@EqualsAndHashCode(callSuper = false)
@ApiModel(value="kc_kechengbiao对象", description="课程管理-主表")
public class KcKechengbiaoHis implements Serializable {
    private static final long serialVersionUID = 1L;

	/**id*/
    @TableId(type = IdType.ASSIGN_ID)
    @ApiModelProperty(value = "id")
    private String id;
	/**课程编号*/
	@Excel(name = "课程编号", width = 15)
    @ApiModelProperty(value = "课程编号")
    private String kcbh;
	/**课程名称*/
	@Excel(name = "课程名称", width = 15)
    @ApiModelProperty(value = "课程名称")
    private String kcmc;
	/**授课教师*/
	@Excel(name = "授课教师", width = 15)
    @ApiModelProperty(value = "授课教师")
    private String skjs;
	/**职称*/
	@Excel(name = "职称", width = 15)
    @ApiModelProperty(value = "职称")
    private String zc;
	/**学科人数*/
	@Excel(name = "学科人数", width = 15)
    @ApiModelProperty(value = "学科人数")
    private String xkrs;
	/**评课人数*/
	@Excel(name = "评课人数", width = 15)
    @ApiModelProperty(value = "评课人数")
    private String pkrs;
	/**任务编号*/
	@Excel(name = "任务编号", width = 15)
    @ApiModelProperty(value = "任务编号")
    private String rwbh;
	/**开课单位*/
    @Excel(name = "开课单位", width = 15, dicCode = "tkrszdw_view,college,college")
    @Dict(dicCode = "tkrszdw_view,college,college")
    @ApiModelProperty(value = "开课单位")
    private String kkdw;
	/**课程性质*/
    @Excel(name = "课程性质", width = 15, dicCode = "kcxz")
    @Dict(dicCode = "kcxz")
    @ApiModelProperty(value = "课程性质")
    private String kcxz;
    /**教室编号*/
    @Excel(name = "教室编号", width = 15)
    private String jsbh;
	/**上课地点*/
	@Excel(name = "上课地点", width = 15)
    @ApiModelProperty(value = "上课地点")
    private String skdd;
	/**授课时间*/
	@Excel(name = "授课时间", width = 15)
    @ApiModelProperty(value = "授课时间")
    private String sksj;
	/**上课周次*/
    @Excel(name = "上课周次", width = 15, dicCode = "skzc")
    @Dict(dicCode = "skzc")
    @ApiModelProperty(value = "上课周次")
    private String jkzc;
	/**节次*/
    @Excel(name = "节次", width = 15, dicCode = "skjc")
    @Dict(dicCode = "skjc")
    @ApiModelProperty(value = "节次")
    private String hh;
	/**星期几*/
    @Excel(name = "周几", width = 15, dicCode = "week")
    @Dict(dicCode = "week")
    @ApiModelProperty(value = "星期几")
    private String week;
	/**课程开始时间*/
	@Excel(name = "课程开始时间", width = 15)
    @ApiModelProperty(value = "课程开始时间")
    private String hhks;
	/**课程结束时间*/
	@Excel(name = "课程结束时间", width = 15)
    @ApiModelProperty(value = "课程结束时间")
    private String hhjs;
	/**未知*/
	@Excel(name = "未知", width = 15)
    @ApiModelProperty(value = "未知")
    private String dsz;
	/**课程开始日期*/
	@Excel(name = "课程开始日期", width = 15)
    @ApiModelProperty(value = "课程开始日期")
    private String wwks;
	/**课程结束日期*/
	@Excel(name = "课程结束日期", width = 15)
    @ApiModelProperty(value = "课程结束日期")
    private String wwjs;
	/**直播方式*/
    @Excel(name = "直播方式", width = 15, dicCode = "skpt")
    @Dict(dicCode = "skpt")
    @ApiModelProperty(value = "直播方式")
    private String zbfs;
	/**会议号*/
	@Excel(name = "会议号", width = 15)
    @ApiModelProperty(value = "会议号")
    private String hyh;
	/**会议密码*/
	@Excel(name = "会议密码", width = 15)
    @ApiModelProperty(value = "会议密码")
    private String hymm;
	/**课程链接*/
	@Excel(name = "课程链接", width = 15)
    @ApiModelProperty(value = "课程链接")
    private String kclj;
	/**备注*/
	@Excel(name = "备注", width = 15)
    @ApiModelProperty(value = "备注")
    private String beizhu;
	/**直播平台*/
	@Excel(name = "直播平台", width = 15)
    @ApiModelProperty(value = "直播平台")
    private String zbpx;
	/**开课单位id*/
	@Excel(name = "开课单位id", width = 15)
    @ApiModelProperty(value = "开课单位id")
    private String kkdwid;
	/**未知*/
	@Excel(name = "未知", width = 15)
    @ApiModelProperty(value = "未知")
    private String jrfs;
	/**二维码文件*/
	@Excel(name = "二维码文件", width = 15)
    @ApiModelProperty(value = "二维码文件")
    private String ewmwj;
	/**群名称*/
	@Excel(name = "群名称", width = 15)
    @ApiModelProperty(value = "群名称")
    private String qmc;
	/**群类型*/
	@Excel(name = "群类型", width = 15)
    @ApiModelProperty(value = "群类型")
    private String qlx;
	/**类型*/
	@Excel(name = "类型", width = 15)
    @ApiModelProperty(value = "类型")
    private String leixing;
	/**是否需要群主验证*/
	@Excel(name = "是否需要群主验证", width = 15)
    @ApiModelProperty(value = "是否需要群主验证")
    private String isqzyz;
	/**教课周次1*/
	@Excel(name = "教课周次1", width = 15)
    @ApiModelProperty(value = "教课周次1")
    private String jkzc1;
	/**学分*/
	@Excel(name = "学分", width = 15)
    @ApiModelProperty(value = "学分")
    private String xf;
	/**校区*/
	@Excel(name = "校区", width = 15)
    @ApiModelProperty(value = "校区")
    private String xq;
	/**教工号*/
	@Excel(name = "教工号", width = 15)
    @ApiModelProperty(value = "教工号")
    private String jgh;
	/**学年学期*/
	@Excel(name = "学年学期", width = 15)
    @ApiModelProperty(value = "学年学期")
    private String xnxq;
	/**教职工类别*/
	@Excel(name = "教职工类别", width = 15)
    @ApiModelProperty(value = "教职工类别")
    private String jzglb;
	/**是否出镜，0-出镜，1-不出镜*/
	@Excel(name = "是否出镜，0-出镜，1-不出镜", width = 15)
    @ApiModelProperty(value = "是否出镜，0-出镜，1-不出镜")
    private Integer sfcj;
	/**上课形式，0-线上，1-线下，2-线上线下混合*/
	@Excel(name = "上课形式，0-线上，1-线下，2-线上线下混合", width = 15)
    @ApiModelProperty(value = "上课形式，0-线上，1-线下，2-线上线下混合")
    private Integer skxs;
	/**是否正常？*/
	@Excel(name = "是否正常？", width = 15)
    @ApiModelProperty(value = "是否正常？")
    private String sfzc;
	/**备注*/
	@Excel(name = "备注", width = 15)
    @ApiModelProperty(value = "备注")
    private String bz;
	/**状态*/
	@Excel(name = "状态", width = 15)
    @ApiModelProperty(value = "状态")
    private String zt;

    private String kcdl;
    private String szkc;//思政课程
    private String xqxn;
    private Date sjc;

	/**课程名称或教师名*/
    @TableField(exist = false)
    private String searchInput;

    @TableField(exist = false)
    private String startTime;
    @TableField(exist = false)
    private String endTime;
    @TableField(exist = false)
    private String ts;
    @TableField(exist = false)
    private String ywcol;

}
