package org.jeecg.modules.kc.ktgl.entity;

import java.io.Serializable;
import java.io.UnsupportedEncodingException;
import java.util.Date;
import java.math.BigDecimal;
import java.util.List;

import com.baomidou.mybatisplus.annotation.*;
import lombok.Data;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.jeecg.modules.kc.detection.entity.KcDetectionDetailed;
import org.jeecg.modules.kc.detection.entity.KcDetectionMain;
import org.jeecg.modules.kc.jiaoshi.entity.KcJiaoshirongliang;
import org.jeecg.modules.kc.zyJxdg.entity.ZyJxdg;
import org.springframework.format.annotation.DateTimeFormat;
import org.jeecgframework.poi.excel.annotation.Excel;
import org.jeecg.common.aspect.annotation.Dict;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * @Description: 课堂管理-子表
 * @Author: jeecg-boot
 * @Date:   2023-04-01
 * @Version: V1.0
 */
@Data
@TableName("kc_ketangbiao")
@Accessors(chain = true)
@EqualsAndHashCode(callSuper = false)
@ApiModel(value="kc_ketangbiao对象", description="课堂管理-子表")
public class KcKetangbiao implements Serializable {
    private static final long serialVersionUID = 1L;

	/**主键*/
	@TableId(type = IdType.ASSIGN_ID)
    @ApiModelProperty(value = "主键")
    private java.lang.String id;
//	/**创建人登录名称*/
//    @ApiModelProperty(value = "创建人登录名称")
//    private java.lang.String createBy;
//	/**创建日期*/
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd")
    @DateTimeFormat(pattern="yyyy-MM-dd")
    @ApiModelProperty(value = "创建日期")
    @TableField(exist = false)
    private java.util.Date createTime;
//	/**更新人登录名称*/
//    @ApiModelProperty(value = "更新人登录名称")
//    private java.lang.String updateBy;
//	/**更新日期*/
//	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd")
//    @DateTimeFormat(pattern="yyyy-MM-dd")
//    @ApiModelProperty(value = "更新日期")
//    private java.util.Date updateTime;
//	/**所属部门*/
//    @ApiModelProperty(value = "所属部门")
//    private java.lang.String sysOrgCode;
	/**课程编号*/
	@Excel(name = "课程编号", width = 15)
    @ApiModelProperty(value = "课程编号")
    private java.lang.String kcbh;
	/**课程名称*/
	@Excel(name = "课程名称", width = 15)
    @ApiModelProperty(value = "课程名称")
    private java.lang.String kcmc;
	/**学分*/
	@Excel(name = "学分", width = 15)
    @ApiModelProperty(value = "学分")
    private java.lang.String xf;
	/**授课教师*/
	@Excel(name = "授课教师", width = 15)
    @ApiModelProperty(value = "授课教师")
    private java.lang.String skjs;
	/**职称*/
	@Excel(name = "职称", width = 15)
    @ApiModelProperty(value = "职称")
    private java.lang.String zc;
	/**教职工类别*/
	@Excel(name = "教职工类别", width = 15)
    @ApiModelProperty(value = "教职工类别")
    private java.lang.String jzglb;
	/**选课人数*/
	@Excel(name = "选课人数", width = 15)
    @ApiModelProperty(value = "选课人数")
    private java.lang.String xkrs;
	/**评课人数*/
	@Excel(name = "评课人数", width = 15)
    @ApiModelProperty(value = "评课人数")
    private java.lang.String pkrs;
	/**任务编号*/
	@Excel(name = "任务编号", width = 15)
    @ApiModelProperty(value = "任务编号")
    private java.lang.String rwbh;
	/**开课单位*/
    @Excel(name = "开课单位", width = 15, dicCode = "tkrszdw_view,college,college")
    @Dict(dicCode = "tkrszdw_view,college,college")
    @ApiModelProperty(value = "开课单位")
    private java.lang.String kkdw;
	/**课程性质*/
	@Excel(name = "课程性质", width = 15, dicCode = "kcxz")
	@Dict(dicCode = "kcxz")
    @ApiModelProperty(value = "课程性质")
    private java.lang.String kcxz;
    /**教室编号*/
    @Excel(name = "教室编号", width = 15)
    private String jsbh;
	/**上课地点*/
	@Excel(name = "上课地点", width = 15)
    @ApiModelProperty(value = "上课地点")
    private java.lang.String skdd;
	/**上课时间*/
	@Excel(name = "上课时间", width = 15)
    @ApiModelProperty(value = "上课时间")
    private java.lang.String sksj;
	/**未知*/
	@Excel(name = "未知", width = 15)
    @ApiModelProperty(value = "未知")
    private java.lang.String jkzc;
	/**节次*/
	@Excel(name = "节次", width = 15, dicCode = "skjc")
	@Dict(dicCode = "skjc")
    @ApiModelProperty(value = "节次")
    private java.lang.String hh;
	/**周几*/
	@Excel(name = "周几", width = 15, dicCode = "week")
	@Dict(dicCode = "week")
    @ApiModelProperty(value = "周几")
    private java.lang.String week;
	/**开始时间*/
	@Excel(name = "开始时间", width = 15)
    @ApiModelProperty(value = "开始时间")
    private java.lang.String hhks;
	/**结束时间*/
	@Excel(name = "结束时间", width = 15)
    @ApiModelProperty(value = "结束时间")
    private java.lang.String hhjs;
	/**未知*/
	@Excel(name = "未知", width = 15)
    @ApiModelProperty(value = "未知")
    private java.lang.String dsz;
	/**课堂开始日期*/
	@Excel(name = "课堂开始日期", width = 15)
    @ApiModelProperty(value = "课堂开始日期")
    private java.lang.String wwks;
	/**课堂结束日期*/
	@Excel(name = "课堂结束日期", width = 15)
    @ApiModelProperty(value = "课堂结束日期")
    private java.lang.String wwjs;
	/**直播方式*/
	@Excel(name = "直播方式", width = 15, dicCode = "skpt")
	@Dict(dicCode = "skpt")
    @ApiModelProperty(value = "直播方式")
    private java.lang.String zbfs;
	/**会议id*/
	@Excel(name = "会议id", width = 15)
    @ApiModelProperty(value = "会议id")
    private java.lang.String hyid;
	/**会议号*/
	@Excel(name = "会议号", width = 15)
    @ApiModelProperty(value = "会议号")
    private java.lang.String hyh;
	/**会议密码*/
	@Excel(name = "会议密码", width = 15)
    @ApiModelProperty(value = "会议密码")
    private java.lang.String hymm;
	/**课程链接*/
	@Excel(name = "课程链接", width = 15)
    @ApiModelProperty(value = "课程链接")
    private java.lang.String kclj;
	/**备注*/
	@Excel(name = "备注", width = 15)
    @ApiModelProperty(value = "备注")
    private java.lang.String beizhu;
	/**直播平台*/
	@Excel(name = "直播平台", width = 15)
    @ApiModelProperty(value = "直播平台")
    private java.lang.String zbpx;
	/**开课单位id*/
	@Excel(name = "开课单位id", width = 15)
    @ApiModelProperty(value = "开课单位id")
    private java.lang.Integer kkdwid;
	/**上课日期*/
	@Excel(name = "上课日期", width = 15)
    @ApiModelProperty(value = "上课日期")
    private java.lang.String skrq;
	/**课程表id*/
	@Excel(name = "课程表id", width = 15)
    @ApiModelProperty(value = "课程表id")
    private java.lang.Integer kechengbiaoid;
	/**听课次数*/
	@Excel(name = "听课次数", width = 15)
    @ApiModelProperty(value = "听课次数")
    private java.lang.Integer tingkecishu;
	/**开课周次*/
	@Excel(name = "开课周次", width = 15, dicCode = "skzc")
	@Dict(dicCode = "skzc")
    @ApiModelProperty(value = "开课周次")
    private java.lang.String kkzc;
	/**第几周*/
	@Excel(name = "第几周", width = 15)
    @ApiModelProperty(value = "第几周")
    private java.lang.Integer dijizhou;
	/**未知*/
	@Excel(name = "未知", width = 15)
    @ApiModelProperty(value = "未知")
    private java.lang.String jkzc1;
	/**是否停课*/
	@Excel(name = "是否停课", width = 15)
    @ApiModelProperty(value = "是否停课")
    @Dict(dicCode = "sftk_kc")
    private java.lang.Integer sftk;
	/**停课原因*/
	@Excel(name = "停课原因", width = 15)
    @ApiModelProperty(value = "停课原因")
    private java.lang.String tkyy;
	/**补课计划*/
	@Excel(name = "补课计划", width = 15)
    @ApiModelProperty(value = "补课计划")
    private java.lang.String bkjh;
	/**是否出镜，0-出镜，1-不出镜*/
	@Excel(name = "是否出镜，0-出镜，1-不出镜", width = 15)
    @ApiModelProperty(value = "是否出镜，0-出镜，1-不出镜")
    private java.lang.Integer sfcj;
	/**上课形式，0-线上，1-线下，2-线上线下混合*/
	@Excel(name = "上课形式，0-线上，1-线下，2-线上线下混合", width = 15)
    @ApiModelProperty(value = "上课形式，0-线上，1-线下，2-线上线下混合")
    @Dict(dicCode = "sftk_kc")
    private java.lang.Integer skxs;
	/**未知*/
	@Excel(name = "未知", width = 15)
    @ApiModelProperty(value = "未知")
    private java.lang.Integer kechengbiao1;
	/**是否新生课 0 = 是*/
	@Excel(name = "是否新生课 0 = 是", width = 15)
    @ApiModelProperty(value = "是否新生课 0 = 是")
    private java.lang.String sfxsk;
	/**教工号*/
	@Excel(name = "教工号", width = 15)
    @ApiModelProperty(value = "教工号")
    private java.lang.String jgh;
	/**备注*/
	@Excel(name = "备注", width = 15)
    @ApiModelProperty(value = "备注")
    private java.lang.String bz;
	/**状态*/
	@Excel(name = "状态", width = 15)
    @ApiModelProperty(value = "状态")
    private java.lang.String zt;
    /**是否删除（0：未删除，1：已删除）*/
    @Excel(name = "是否删除（0：未删除，1：已删除）", width = 15)
    @ApiModelProperty(value = "是否删除（0：未删除，1：已删除）")
    private java.lang.Integer isDelete;
    private java.lang.String xnxq;



    @TableField(exist = false)
    private String jssj;


    @TableField(exist = false)
    private java.lang.String ywmc;
    @TableField(exist = false)
    private java.lang.String ywTime;
    @TableField(exist = false)
    private java.lang.String ywskxs;
    @TableField(exist = false)
    private java.lang.String sfyy;
    @TableField(exist = false)
    private java.lang.String userid;
    @TableField(exist = false)
    private java.lang.Integer isdeleted;

    @TableField(exist = false)
    private String startTime;
    @TableField(exist = false)
    private String endTime;
    @TableField(exist = false)
    private String xh;
    @TableField(exist = false)
    private String xjkssj;
    @TableField(exist = false)
    private String stars;
    @TableField(exist = false)
    private String ts;

    @TableField(exist = false)
    private String zhjsId;
    @TableField(exist = false)
    private String sfyzhjs;
    @TableField(exist = false)
    private String jzwh;
    @TableField(exist = false)
    private String szkc;

    @TableField(exist = false)
    private boolean searchByNowXqxn;
    @TableField(exist = false)
    private String score;

    @TableField(exist = false)
    private String jspjPjf;

    @TableField(exist = false)
    private String xspjPjf;

    @TableField(exist = false)
    private String sbType;
    @TableField(exist = false)
    private String title;
    @TableField(exist = false)
    private String notes;
    @TableField(exist = false)
    private String sftkb;

	@TableField(exist = false)
	private String tksy;

    @TableField(exist = false)
    private String num;

	@TableField(exist = false)
	private KcJiaoshirongliang jiaoshirongliang;

    @TableField(exist = false)
    private String zhjs;
    @TableField(exist = false)
    private String bmdId;
    @TableField(exist = false)
    private String a1;
    @TableField(exist = false)
    private String a2;
    @TableField(exist = false)
    private String a3;
    @TableField(exist = false)
    private String a4;
    @TableField(exist = false)
    private String a5;
    @TableField(exist = false)
    private String a6;
    @TableField(exist = false)
    private String a7;

    @TableField(exist = false)
    private String flag;

	@TableField(exist = false)
	private KcDetectionMain detectionMain;
	@TableField(exist = false)
	private KcDetectionDetailed kcDetectionDetailed;
    @TableField(exist = false)
    private List<KcDetectionDetailed> zqrsList;

	@TableField(exist = false)
	private ZyJxdg zyJxdg;

}
