package org.jeecg.modules.kc.ktgl.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import org.apache.commons.lang3.StringUtils;
import org.apache.shiro.SecurityUtils;
import org.apache.shiro.UnavailableSecurityManagerException;
import org.jeecg.common.system.vo.LoginUser;
import org.jeecg.modules.kc.kcTingkeBmd.entity.KcTingkeBmd;
import org.jeecg.modules.kc.kcTingkeBmd.mapper.KcTingkeBmdKcxxMapper;
import org.jeecg.modules.kc.kcTingkeBmd.mapper.KcTingkeBmdMapper;
import org.jeecg.modules.kc.ktgl.entity.KcKetangbiao;
import org.jeecg.modules.kc.ktgl.entity.KcKetangbiaoNum;
import org.jeecg.modules.kc.ktgl.mapper.KcKetangbiaoMapper;
import org.jeecg.modules.kc.ktgl.service.IKcKetangbiaoService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;

import java.util.List;
import java.util.Map;

/**
 * @Description: 课堂管理-子表
 * @Author: jeecg-boot
 * @Date:   2023-04-01
 * @Version: V1.0
 */
@Service
public class KcKetangbiaoServiceImpl extends ServiceImpl<KcKetangbiaoMapper, KcKetangbiao> implements IKcKetangbiaoService {

    @Autowired
    private KcTingkeBmdMapper kcTingkeBmdMapper;
    @Autowired
    private KcTingkeBmdKcxxMapper kcTingkeBmdKcxxMapper;

    @Override
    public IPage<KcKetangbiao> getKclblist(Page<KcKetangbiao> page, KcKetangbiao kcKetangbiao) {
        LoginUser user = null;
        try {
            user = (LoginUser) SecurityUtils.getSubject().getPrincipal();
        } catch (UnavailableSecurityManagerException e) {
            log.error("无法获取用户");
        }

        //获取当前用户是否有白名单权限
        QueryWrapper<KcTingkeBmd> kcTingkeBmdQueryWrapper = new QueryWrapper<>();
        if(user != null){
            kcTingkeBmdQueryWrapper.eq("jgh",user.getUsername());
        }
        List<KcTingkeBmd> list = kcTingkeBmdMapper.selectList(kcTingkeBmdQueryWrapper);
        String bmdId = "";
        for(int i = 0; i < list.size(); i++){
            bmdId = list.get(i).getId()+",";
        }
        if(bmdId.contains(",")){
            bmdId = bmdId.substring(0,bmdId.length()-1);
        }
        if(StringUtils.isNotBlank(bmdId)){
            kcKetangbiao.setBmdId(bmdId);
        }
        return baseMapper.getKclblist(page,kcKetangbiao);
    }

    @Override
    public List<Map<String, Object>> selectJrTkCount(String skrq) {
        return baseMapper.selectJrTkCount(skrq);
    }

    @Override
    public List<Map<String, Object>> getIndexYkktstj(KcKetangbiao kcKetangbiao) {
        return baseMapper.getIndexYkktstj(kcKetangbiao);
    }

    @Override
    public IPage<KcKetangbiao> getStudentKclblist(Page<KcKetangbiao> page, KcKetangbiao kcKetangbiao) {
        return baseMapper.getStudentKclblist(page,kcKetangbiao);
    }

    @Override
    public List<KcKetangbiao> selectSyncList(KcKetangbiao kcKetangbiao) {
        return baseMapper.selectSyncList(kcKetangbiao);
    }

    @Override
    public void saveHis(KcKetangbiao kcKetangbiaohis) {
        baseMapper.saveHis(kcKetangbiaohis);
    }

    @Override
    public IPage<Map<String, Object>> getIndexYkktstjYkkttkktList(Page<Map<String, Object>> page, KcKetangbiao kcKetangbiao) {
        return page.setRecords(baseMapper.getIndexYkktstjYkkttkktList(page, kcKetangbiao));
    }

    @Override
    public IPage<Map<String, Object>> getIndexYkktstjYkkttkrcList(Page<Map<String, Object>> page, KcKetangbiao kcKetangbiao) {
        return page.setRecords(baseMapper.getIndexYkktstjYkkttkrcList(page, kcKetangbiao));
    }

    @Override
    public IPage<Map<String, Object>> selectJrTkJrtkktsList(Page<Map<String, Object>> page, String skrq) {
        return page.setRecords(baseMapper.selectJrTkJrtkktsList(page, skrq));
    }

    @Override
    public IPage<Map<String, Object>> selectJrTkJrtktkrcList(Page<Map<String, Object>> page, String skrq) {
        return page.setRecords(baseMapper.selectJrTkJrtktkrcList(page, skrq));
    }

    @Override
    public List<Map<String, Object>> getTeacherjjsk(Map<String, String> queryMap) {
        return baseMapper.getTeacherjjsk(queryMap);
    }

    @Override
    public List<Map<String, Object>> getTeacherzzsk(Map<String, String> queryMap) {
        return baseMapper.getTeacherzzsk(queryMap);
    }

    @Override
    public List<Map<String, Object>> getTeacherdskc(Map<String, String> queryMap) {
        return baseMapper.getTeacherdskc(queryMap);
    }

    @Override
    public List<Map<String, Object>> getTeacheryskc(Map<String, String> queryMap) {
        return baseMapper.getTeacheryskc(queryMap);
    }

    @Override
    public List<Map<String, Object>> getTeacherjlrkcb(Map<String, String> queryMap) {
        return baseMapper.getTeacherjlrkcb(queryMap);
    }

    @Override
    public List<KcKetangbiao> getKtbjList(KcKetangbiao kcKetangbiao) {
        return baseMapper.getKtbjList(kcKetangbiao);
    }

    @Override
    public IPage<KcKetangbiao> fundAllPjjgList(Page<KcKetangbiao> page, QueryWrapper<KcKetangbiao> queryWrapper) {
        return baseMapper.fundAllPjjgList(page,queryWrapper);
    }

    @Override
    public KcKetangbiao getScoreById(KcKetangbiao kcKetangbiao) {
        return baseMapper.getScoreById(kcKetangbiao);
    }

    @Override
    public IPage<KcKetangbiao> indexYkktzsPage(Page<KcKetangbiao> page, QueryWrapper<KcKetangbiao> qw3) {
        return baseMapper.indexYkktzsPage(page,qw3);
    }

    @Override
    public IPage<KcKetangbiao> getKtsbMorelist(Page<KcKetangbiao> page, QueryWrapper<KcKetangbiao> queryWrapper) {
        return baseMapper.getKtsbMorelist(page,queryWrapper);
    }

    @Override
    public void updateJsbh() {
        baseMapper.updateJsbh();
    }

    @Override
    public void updateSkxs(KcKetangbiao kcKetangbiaoup) {
        baseMapper.updateSkxs(kcKetangbiaoup);
    }

    @Override
    public IPage<Map<String, Object>> getKtcountList(Page<Map<String, Object>> page, KcKetangbiao kcKetangbiao) {
        return baseMapper.getKtcountList(page,kcKetangbiao);
    }

    @Override
    public List<KcKetangbiaoNum> getKtcountExportList(KcKetangbiaoNum object) {
        return baseMapper.getKtcountExportList(object);
    }

    @Override
    public IPage<Map<String, Object>> getKccountList(Page<Map<String, Object>> page, KcKetangbiao kcKetangbiao) {
        return baseMapper.getKccountList(page,kcKetangbiao);
    }

    @Override
    public List<KcKetangbiaoNum> getKccountExportList(KcKetangbiaoNum object) {
        return baseMapper.getKccountExportList(object);
    }

    @Override
    public void updateKechengbiaoid(String skrq) {
        baseMapper.updateKechengbiaoid(skrq);
    }


}
