package org.jeecg.modules.kc.pjxxJszbpjf.controller;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.kc.pjxxJszbpjf.entity.PjxxJszbpjf;
import org.jeecg.modules.kc.pjxxJszbpjf.service.IPjxxJszbpjfService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

 /**
 * @Description: pjxx_jszbpjf
 * @Author: jeecg-boot
 * @Date:   2025-01-13
 * @Version: V1.0
 */
@Api(tags="pjxx_jszbpjf")
@RestController
@RequestMapping("/pjxxJszbpjf/pjxxJszbpjf")
@Slf4j
public class PjxxJszbpjfController extends JeecgController<PjxxJszbpjf, IPjxxJszbpjfService> {
	@Autowired
	private IPjxxJszbpjfService pjxxJszbpjfService;
	
	/**
	 * 分页列表查询
	 *
	 * @param pjxxJszbpjf
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "pjxx_jszbpjf-分页列表查询")
	@ApiOperation(value="pjxx_jszbpjf-分页列表查询", notes="pjxx_jszbpjf-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<PjxxJszbpjf>> queryPageList(PjxxJszbpjf pjxxJszbpjf,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<PjxxJszbpjf> queryWrapper = QueryGenerator.initQueryWrapper(pjxxJszbpjf, req.getParameterMap());
		Page<PjxxJszbpjf> page = new Page<PjxxJszbpjf>(pageNo, pageSize);
		IPage<PjxxJszbpjf> pageList = pjxxJszbpjfService.page(page, queryWrapper);
		return Result.OK(pageList);
	}


	 @ApiOperation(value="首页查询教师平均分", notes="首页查询教师平均分")
	 @GetMapping(value = "/listIndex")
	 public Result<IPage<PjxxJszbpjf>> listIndex(PjxxJszbpjf pjxxJszbpjf,
													 @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
													 @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
													 HttpServletRequest req) {
		 QueryWrapper<PjxxJszbpjf> queryWrapper = QueryGenerator.initQueryWrapper(pjxxJszbpjf, req.getParameterMap());
		 Page<PjxxJszbpjf> page = new Page<PjxxJszbpjf>(pageNo, 4);
		 IPage<PjxxJszbpjf> pageList = pjxxJszbpjfService.page(page, queryWrapper);
		 return Result.OK(pageList);
	 }
	
	/**
	 *   添加
	 *
	 * @param pjxxJszbpjf
	 * @return
	 */
	@AutoLog(value = "pjxx_jszbpjf-添加")
	@ApiOperation(value="pjxx_jszbpjf-添加", notes="pjxx_jszbpjf-添加")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody PjxxJszbpjf pjxxJszbpjf) {
		pjxxJszbpjfService.save(pjxxJszbpjf);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param pjxxJszbpjf
	 * @return
	 */
	@AutoLog(value = "pjxx_jszbpjf-编辑")
	@ApiOperation(value="pjxx_jszbpjf-编辑", notes="pjxx_jszbpjf-编辑")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody PjxxJszbpjf pjxxJszbpjf) {
		pjxxJszbpjfService.updateById(pjxxJszbpjf);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "pjxx_jszbpjf-通过id删除")
	@ApiOperation(value="pjxx_jszbpjf-通过id删除", notes="pjxx_jszbpjf-通过id删除")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		pjxxJszbpjfService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "pjxx_jszbpjf-批量删除")
	@ApiOperation(value="pjxx_jszbpjf-批量删除", notes="pjxx_jszbpjf-批量删除")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.pjxxJszbpjfService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	@ApiOperation(value="pjxx_jszbpjf-通过id查询", notes="pjxx_jszbpjf-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<PjxxJszbpjf> queryById(@RequestParam(name="id",required=true) String id) {
		PjxxJszbpjf pjxxJszbpjf = pjxxJszbpjfService.getById(id);
		if(pjxxJszbpjf==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(pjxxJszbpjf);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param pjxxJszbpjf
    */
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, PjxxJszbpjf pjxxJszbpjf) {
        return super.exportXls(request, pjxxJszbpjf, PjxxJszbpjf.class, "学生评教结果");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, PjxxJszbpjf.class);
    }

}
