package org.jeecg.modules.kc.qa.controller;

import java.util.Arrays;
import java.util.Date;
import java.util.List;
import java.util.Map;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import cn.hutool.core.date.DatePattern;
import cn.hutool.core.date.DateUtil;
import com.google.common.collect.Maps;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.SecurityUtils;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.system.vo.LoginUser;
import org.jeecg.modules.kc.grab.SynchronizationService.tools.ChangeTingKeTongJi;
import org.jeecg.modules.kc.kcSysConfig.entity.KcSysConfig;
import org.jeecg.modules.kc.kcXqxnHistory.entity.KcXqxnHistory;
import org.jeecg.modules.kc.kcXqxnHistory.service.IKcXqxnHistoryService;
import org.jeecg.modules.kc.qa.entity.KcEvaluation;
import org.jeecg.modules.kc.qa.entity.KcEvaluationPkmx;
import org.jeecg.modules.kc.qa.entity.KcEvaluations;
import org.jeecg.modules.kc.qa.service.IKcEvaluationService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecg.common.system.base.controller.JeecgController;
import org.jeecg.modules.kc.qa.service.IKcEvaluationsService;
import org.jeecg.modules.kc.tktj.entity.KcKkdw;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

 /**
 * @Description: 调查问卷-回答主表
 * @Author: jeecg-boot
 * @Date:   2023-04-09
 * @Version: V1.0
 */
@Api(tags="调查问卷-回答主表")
@RestController
@RequestMapping("/qa/kcEvaluation")
@Slf4j
public class KcEvaluationController extends JeecgController<KcEvaluation, IKcEvaluationService> {
	@Autowired
	private IKcEvaluationService kcEvaluationService;

	 @Autowired
	 private IKcEvaluationsService kcEvaluationsService;

	 @Autowired
	 private ChangeTingKeTongJi changeTingKeTongJi;

	 @Autowired
	 private IKcXqxnHistoryService kcXqxnHistoryService;

	 @Value("${jeecg.path.upload}")
	 private String upLoadPath;

	/**
	 * 分页列表查询
	 *
	 * @param kcEvaluation
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "调查问卷-回答主表-分页列表查询")
	@ApiOperation(value="调查问卷-回答主表-分页列表查询", notes="调查问卷-回答主表-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<KcEvaluation>> queryPageList(KcEvaluation kcEvaluation,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<KcEvaluation> queryWrapper = QueryGenerator.initQueryWrapper(kcEvaluation, req.getParameterMap());
		if(StringUtils.isNotBlank(kcEvaluation.getXnxq())){
			KcXqxnHistory common = changeTingKeTongJi.getXqConfig(kcEvaluation.getXnxq());
			Date startSjDate = common.getStartTime();
			Date endSjDate = common.getEndTime();
			String startSj = DateUtil.format(startSjDate, DatePattern.NORM_DATETIME_FORMAT);
			String endSj = DateUtil.format(endSjDate,DatePattern.NORM_DATETIME_FORMAT);
			String xqxn = common.getTitle();
//			if(StringUtils.equals(xqxn,kcEvaluation.getXnxq())){
			queryWrapper.apply("up_date >= STR_TO_DATE('"+ startSj +"', '%Y-%m-%d') ");
			queryWrapper.apply("up_date <= STR_TO_DATE('"+ endSj +"', '%Y-%m-%d') ");
//			}

		}
		Page<KcEvaluation> page = new Page<KcEvaluation>(pageNo, pageSize);
		IPage<KcEvaluation> pageList = kcEvaluationService.page(page, queryWrapper);
		return Result.OK(pageList);
	}

	 /**
	  * 分页列表查询
	  *
	  * @param kcEvaluation
	  * @param pageNo
	  * @param pageSize
	  * @param req
	  * @return
	  */
	 //@AutoLog(value = "调查问卷-回答主表-分页列表查询")
	 @ApiOperation(value="调查问卷-回答主表-分页列表查询", notes="调查问卷-回答主表-分页列表查询")
	 @GetMapping(value = "/keTangList")
	 public Result<IPage<KcEvaluation>> keTangList(KcEvaluation kcEvaluation,
													  @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
													  @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
													  HttpServletRequest req) {
		 QueryWrapper<KcEvaluation> queryWrapper = QueryGenerator.initQueryWrapper("a",kcEvaluation, req.getParameterMap());
		 if(StringUtils.isNotBlank(kcEvaluation.getXnxq())){
			 KcXqxnHistory common = changeTingKeTongJi.getXqConfig(kcEvaluation.getXnxq());
			 Date startSjDate = common.getStartTime();
			 Date endSjDate = common.getEndTime();
			 String startSj = DateUtil.format(startSjDate,DatePattern.NORM_DATETIME_FORMAT);
			 String endSj = DateUtil.format(endSjDate,DatePattern.NORM_DATETIME_FORMAT);
			 String xqxn = common.getTitle();
//			 if(StringUtils.equals(xqxn,kcEvaluation.getXnxq())){
			 queryWrapper.apply("a.up_date >= STR_TO_DATE('"+ startSj +"', '%Y-%m-%d') ");
			 queryWrapper.apply("a.up_date <= STR_TO_DATE('"+ endSj +"', '%Y-%m-%d') ");
//			 }
		 }
		 queryWrapper.isNotNull("a.minkcid");
		 Page<KcEvaluation> page = new Page<KcEvaluation>(pageNo, pageSize);
		 IPage<KcEvaluation> pageList = kcEvaluationService.keTangList(page, queryWrapper);
		 return Result.OK(pageList);
	 }

	/**
	 *   添加
	 *
	 * @param kcEvaluation
	 * @return
	 */
	@AutoLog(value = "调查问卷-回答主表-添加")
	@ApiOperation(value="调查问卷-回答主表-添加", notes="调查问卷-回答主表-添加")
	@RequiresPermissions("qa:kc_evaluation:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody KcEvaluation kcEvaluation) {
		kcEvaluationService.save(kcEvaluation);
		return Result.OK("添加成功！");
	}

	/**
	 *  编辑
	 *
	 * @param kcEvaluation
	 * @return
	 */
	@AutoLog(value = "调查问卷-回答主表-编辑")
	@ApiOperation(value="调查问卷-回答主表-编辑", notes="调查问卷-回答主表-编辑")
	@RequiresPermissions("qa:kc_evaluation:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody KcEvaluation kcEvaluation) {
		kcEvaluationService.updateById(kcEvaluation);
		return Result.OK("编辑成功!");
	}

	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "调查问卷-回答主表-通过id删除")
	@ApiOperation(value="调查问卷-回答主表-通过id删除", notes="调查问卷-回答主表-通过id删除")
	@RequiresPermissions("qa:kc_evaluation:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		kcEvaluationService.removeById(id);
		return Result.OK("删除成功!");
	}

	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "调查问卷-回答主表-批量删除")
	@ApiOperation(value="调查问卷-回答主表-批量删除", notes="调查问卷-回答主表-批量删除")
	@RequiresPermissions("qa:kc_evaluation:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.kcEvaluationService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}

	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "调查问卷-回答主表-通过id查询")
	@ApiOperation(value="调查问卷-回答主表-通过id查询", notes="调查问卷-回答主表-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<KcEvaluation> queryById(@RequestParam(name="id",required=true) String id) {
		KcEvaluation kcEvaluation = kcEvaluationService.getById(id);
		if(kcEvaluation==null) {
			return Result.error("未找到对应数据");
		}
		//查询子表
		QueryWrapper<KcEvaluations> qw = new QueryWrapper<>();
		qw.eq("",id);
		kcEvaluationsService.list(qw);
		return Result.OK(kcEvaluation);
	}

	 /**
	  * 通过id查询
	  *
	  * @return
	  */
	 //@AutoLog(value = "调查问卷-回答主表-通过id查询")
	 @ApiOperation(value="调查问卷-回答主表-通过id查询", notes="调查问卷-回答主表-通过id查询")
	 @GetMapping(value = "/queryByParam")
	 public Result<KcEvaluation> queryById(KcEvaluation kcEvaluation) {
		 QueryWrapper<KcEvaluation> qw = new QueryWrapper<>();
		 qw.eq("upuserid",kcEvaluation.getUserid());
		 qw.eq("minkcid",kcEvaluation.getMinkcid());
		 qw.eq("evaluationver",kcEvaluation.getEvaluationver());
		 qw.last("limit 1");
		 KcEvaluation data = kcEvaluationService.getOne(qw);
		 if(data==null) {
			 return Result.error("未找到对应数据");
		 }
		 //查询子表
		 QueryWrapper<KcEvaluations> qaw = new QueryWrapper<>();
		 qaw.eq("evaluationid",data.getId());
		 data.setAnsList(kcEvaluationsService.list(qaw));
		 return Result.OK(data);
	 }

    /**
    * 导出excel
    *
    * @param request
    * @param kcEvaluation
    */
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, KcEvaluation kcEvaluation) {
		String title = "评课统计";
		//TODO 统计4
		// Step.1 组装查询条件
		LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();

		// 过滤选中数据
		// Step.2 获取导出数据
		List<KcEvaluation> exportList = kcEvaluationService.selectKkdwExportList(kcEvaluation);
		Map<Integer,String> sourceDictMap = Maps.newHashMap();
		//0：门户添加，1：老系统，2：政务大厅，3后台导入
//		sourceDictMap.put(0,"课程中心");
//		sourceDictMap.put(1,"老系统");
//		sourceDictMap.put(2,"服务大厅");
//		sourceDictMap.put(3,"线下纸质");
		//更改字典项
		exportList.forEach(x -> {
			x.setSourceName(sourceDictMap.get(x.getSource()));
		});

		// Step.3 AutoPoi 导出Excel
		ModelAndView mv = new ModelAndView(new JeecgEntityExcelView());
		//此处设置的filename无效 ,前端会重更新设置一下
		mv.addObject(NormalExcelConstants.FILE_NAME, title);
		mv.addObject(NormalExcelConstants.CLASS, KcEvaluation.class);
		//update-begin--Author:liusq  Date:20210126 for：图片导出报错，ImageBasePath未设置--------------------
		ExportParams exportParams=new ExportParams(title + "报表", "导出人:" + sysUser.getRealname(), title);
		exportParams.setImageBasePath(upLoadPath);
		//update-end--Author:liusq  Date:20210126 for：图片导出报错，ImageBasePath未设置----------------------
		mv.addObject(NormalExcelConstants.PARAMS,exportParams);
		mv.addObject(NormalExcelConstants.DATA_LIST, exportList);
		return mv;
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("qa:kc_evaluation:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, KcEvaluation.class);
    }

	 @ApiOperation(value="kc_evaluation-评课统计表分页列表查询", notes="kc_evaluation-评课统计表分页列表查询")
	 @GetMapping(value = "/getPktjbList")
	 public Result<IPage<KcEvaluation>> getPktjbList(KcEvaluation kcEvaluation,
													 @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
													 @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
													 HttpServletRequest req) {
		 Page<KcEvaluation> page = new Page<KcEvaluation>(pageNo, pageSize);
		 IPage<KcEvaluation> pageList = kcEvaluationService.getPktjbList(page, kcEvaluation);
		 return Result.OK(pageList);
	 }
	 @ApiOperation(value="kc_evaluation-评课明细表分页列表查询", notes="kc_evaluation-评课明细表分页列表查询")
	 @GetMapping(value = "/getPkmxbList")
	 public Result<IPage<KcEvaluation>> getPkmxbList(KcEvaluation kcEvaluation,
													 @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
													 @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
													 HttpServletRequest req) {
		 Page<KcEvaluation> page = new Page<KcEvaluation>(pageNo, pageSize);
		 String xnxq = kcEvaluation.getXnxq();
		 if(org.apache.commons.lang3.StringUtils.isNotBlank(xnxq)){
			 QueryWrapper<KcXqxnHistory> kcXqxnHistoryQueryWrapper = new QueryWrapper<>();
			 kcXqxnHistoryQueryWrapper.eq("title",xnxq);
			 kcXqxnHistoryQueryWrapper.last("limit 1");
			 KcXqxnHistory kcXqxnHistory =kcXqxnHistoryService.getOne(kcXqxnHistoryQueryWrapper);
			 kcEvaluation.setStartTime(DateUtil.format(kcXqxnHistory.getStartTime(),"yyyy-MM-dd"));
			 kcEvaluation.setEndTime(DateUtil.format(kcXqxnHistory.getEndTime(),"yyyy-MM-dd"));
		 }
		 if(org.apache.commons.lang3.StringUtils.equals("是",kcEvaluation.getSzkc())){
			 kcEvaluation.setSzkc("1");
		 }else if(org.apache.commons.lang3.StringUtils.equals("否",kcEvaluation.getSzkc())){
			 kcEvaluation.setSzkc("0");
		 }
		 IPage<KcEvaluation> pageList = kcEvaluationService.getPkmxbList(page, kcEvaluation);
		 return Result.OK(pageList);
	 }


	 @ApiOperation(value="kc_evaluation-评课周统计图查询", notes="kc_evaluation-评课周统计图查询")
	 @GetMapping(value = "/getPkztjTjt")
	 public Result<List<KcEvaluation>> getPkztjTjt(KcEvaluation kcEvaluation) {
		 List<KcEvaluation> list = kcEvaluationService.getPkztjTjt(kcEvaluation);
		 return Result.OK(list);
	 }


	 @ApiOperation(value="kc_evaluation-评课覆盖率统计图查询", notes="kc_evaluation-评课覆盖率统计图查询")
	 @GetMapping(value = "/getPkfglTjt")
	 public Result<List<KcEvaluation>> getPkfglTjt(KcEvaluation kcEvaluation) {
		 List<KcEvaluation> list = kcEvaluationService.getPkfglTjt(kcEvaluation);
		 return Result.OK(list);
	 }

	 /**
	  *   添加
	  *
	  * @param kcEvaluation
	  * @return
	  */
	 @AutoLog(value = "调查问卷-回答主表-综合添加")
	 @ApiOperation(value="调查问卷-回答主表-综合添加", notes="调查问卷-回答主表-综合添加")
//	 @RequiresPermissions("qa:kc_evaluation:add")
	 @PostMapping(value = "/addQaAll")
	 public Result<String> addQaAll(@RequestBody KcEvaluation kcEvaluation) {
		 kcEvaluationService.addQaAll(kcEvaluation);
		 return Result.OK("添加成功！");
	 }


	 @RequestMapping(value = "/exportPkmxbXls")
	 public ModelAndView exportPkmxbXls(HttpServletRequest request, KcEvaluationPkmx kcEvaluationPkmx) {
		 String title = "评课明细";
//TODO 导出3
		 // Step.1 组装查询条件
		 LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();

		 // 过滤选中数据
		 // Step.2 获取导出数据
		 String xnxq = kcEvaluationPkmx.getXnxq();
		 if(org.apache.commons.lang3.StringUtils.isNotBlank(xnxq)){
			 QueryWrapper<KcXqxnHistory> kcXqxnHistoryQueryWrapper = new QueryWrapper<>();
			 kcXqxnHistoryQueryWrapper.eq("title",xnxq);
			 kcXqxnHistoryQueryWrapper.last("limit 1");
			 KcXqxnHistory kcXqxnHistory =kcXqxnHistoryService.getOne(kcXqxnHistoryQueryWrapper);
			 kcEvaluationPkmx.setStartTime(DateUtil.format(kcXqxnHistory.getStartTime(),"yyyy-MM-dd"));
			 kcEvaluationPkmx.setEndTime(DateUtil.format(kcXqxnHistory.getEndTime(),"yyyy-MM-dd"));
		 }
		 if(org.apache.commons.lang3.StringUtils.equals("是",kcEvaluationPkmx.getSzkc())){
			 kcEvaluationPkmx.setSzkc("1");
		 }else if(org.apache.commons.lang3.StringUtils.equals("否",kcEvaluationPkmx.getSzkc())){
			 kcEvaluationPkmx.setSzkc("0");
		 }
		 List<KcEvaluationPkmx> exportList = kcEvaluationService.selectPkmxExportList(kcEvaluationPkmx);

		 Map<Integer,String> sourceDictMap = Maps.newHashMap();
		 //0：门户添加，1：老系统，2：政务大厅，3后台导入
		 sourceDictMap.put(0,"课程中心");
		 sourceDictMap.put(1,"老系统");
		 sourceDictMap.put(2,"服务大厅");
		 sourceDictMap.put(3,"线下纸质");

		 Map<String,String> pjlblxMap = Maps.newHashMap();
		 //0：门户添加，1：老系统，2：政务大厅，3后台导入
//		 sourceDictMap.put(0,"课程中心");
//		 sourceDictMap.put(1,"老系统");
		 pjlblxMap.put("2","线上课堂评价表");
		 pjlblxMap.put("3","听课记录表");
		 pjlblxMap.put("4","同行评价表");


		 //更改字典项
		 exportList.forEach(x -> {
			 x.setSourceName(sourceDictMap.get(x.getSource()));
			 x.setPjlblx(pjlblxMap.get(x.getEvaluationver()));
		 });

		 // Step.3 AutoPoi 导出Excel
		 ModelAndView mv = new ModelAndView(new JeecgEntityExcelView());
		 //此处设置的filename无效 ,前端会重更新设置一下
		 mv.addObject(NormalExcelConstants.FILE_NAME, title);
		 mv.addObject(NormalExcelConstants.CLASS, KcEvaluationPkmx.class);
		 //update-begin--Author:liusq  Date:20210126 for：图片导出报错，ImageBasePath未设置--------------------
		 ExportParams exportParams=new ExportParams(title + "报表", "导出人:" + sysUser.getRealname(), title);
		 exportParams.setImageBasePath(upLoadPath);
		 //update-end--Author:liusq  Date:20210126 for：图片导出报错，ImageBasePath未设置----------------------
		 mv.addObject(NormalExcelConstants.PARAMS,exportParams);
		 mv.addObject(NormalExcelConstants.DATA_LIST, exportList);
		 return mv;
	 }

	 /**
	  * 分页列表查询
	  *
	  * @param kcEvaluation
	  * @param pageNo
	  * @param pageSize
	  * @param req
	  * @return
	  */
	 //@AutoLog(value = "调查问卷-回答主表-分页列表查询")
	 @ApiOperation(value="调查问卷-回答主表-分页列表查询", notes="调查问卷-回答主表-分页列表查询")
	 @GetMapping(value = "/queryPkZuJiList")
	 public Result<IPage<KcEvaluation>> queryPkZuJiList(KcEvaluation kcEvaluation,
													  @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
													  @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
													  HttpServletRequest req) {
		 String xnxq = kcEvaluation.getXnxq();
		 if(org.apache.commons.lang3.StringUtils.isNotBlank(xnxq)){
			 QueryWrapper<KcXqxnHistory> kcXqxnHistoryQueryWrapper = new QueryWrapper<>();
			 kcXqxnHistoryQueryWrapper.eq("title",xnxq);
			 kcXqxnHistoryQueryWrapper.last("limit 1");
			 KcXqxnHistory kcXqxnHistory =kcXqxnHistoryService.getOne(kcXqxnHistoryQueryWrapper);
			 kcEvaluation.setStartDate(DateUtil.format(kcXqxnHistory.getStartTime(),"yyyy-MM-dd"));
			 kcEvaluation.setEndDate(DateUtil.format(kcXqxnHistory.getEndTime(),"yyyy-MM-dd"));
		 }
		 QueryWrapper<KcEvaluation> queryWrapper = QueryGenerator.initQueryWrapper("a",kcEvaluation, req.getParameterMap());
		 queryWrapper.eq(StringUtils.isNotBlank(kcEvaluation.getJgh()),"kt.jgh",kcEvaluation.getJgh());
		 queryWrapper.eq("eq.genre",0);
		 queryWrapper.ge(org.apache.commons.lang3.StringUtils.isNotBlank(kcEvaluation.getStartDate()),"a.up_date",kcEvaluation.getStartDate());
		 queryWrapper.le(org.apache.commons.lang3.StringUtils.isNotBlank(kcEvaluation.getEndDate()),"a.up_date",kcEvaluation.getEndDate()+" 23:59:59");
//		 queryWrapper.eq("a.upuserid",);
		 queryWrapper.orderByDesc("a.up_timestamp");
		 Page<KcEvaluation> page = new Page<KcEvaluation>(pageNo, pageSize);
		 IPage<KcEvaluation> pageList = kcEvaluationService.queryPkZuJiPage(page, queryWrapper);
		 return Result.OK(pageList);
	 }

 }
