package org.jeecg.modules.kc.qa.entity;

import java.io.Serializable;
import java.io.UnsupportedEncodingException;
import java.util.Date;
import java.math.BigDecimal;
import java.util.List;

import com.baomidou.mybatisplus.annotation.*;
import lombok.Data;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.apache.ibatis.type.JdbcType;
import org.apache.ibatis.type.MappedJdbcTypes;
import org.springframework.format.annotation.DateTimeFormat;
import org.jeecgframework.poi.excel.annotation.Excel;
import org.jeecg.common.aspect.annotation.Dict;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * @Description: 调查问卷-回答主表
 * @Author: jeecg-boot
 * @Date:   2023-04-09
 * @Version: V1.0
 */
@Data
@TableName("kc_evaluation")
@Accessors(chain = true)
@EqualsAndHashCode(callSuper = false)
@ApiModel(value="kc_evaluation对象", description="调查问卷-回答主表")
public class KcEvaluation implements Serializable {
    private static final long serialVersionUID = 1L;

	@TableId(type = IdType.ASSIGN_ID)
    @ApiModelProperty(value = "id")
    private java.lang.String id;
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd")
    @DateTimeFormat(pattern="yyyy-MM-dd")
    @ApiModelProperty(value = "上传日期")
    private java.util.Date upDate;
	@JsonFormat(timezone = "GMT+8",pattern = "HH:mm")
    @DateTimeFormat(pattern="HH:mm")
    @ApiModelProperty(value = "上传时间")
    private java.util.Date upTime;
    @ApiModelProperty(value = "答案")
    private java.lang.String answer1;
	/**上传人*/
    @ApiModelProperty(value = "上传人")
    private java.lang.String upuser;
	/**上传人id*/
    @ApiModelProperty(value = "上传人id")
    private java.lang.Integer upuserid;
	/**上传时间戳*/
    @ApiModelProperty(value = "上传时间戳")
    private java.lang.String upTimestamp;
	/**课程最小id*/
    @ApiModelProperty(value = "课程最小id")
    private java.lang.String minkcid;
	/**答案2*/
    @ApiModelProperty(value = "答案2")
    private java.lang.String answer2;
	/**答案3*/
    @ApiModelProperty(value = "答案3")
    private java.lang.String answer3;
	/**答案4*/
    @ApiModelProperty(value = "答案4")
    private java.lang.String answer4;
	/**答案5*/
    @ApiModelProperty(value = "答案5")
    private java.lang.String answer5;
	/**答案6*/
    @ApiModelProperty(value = "答案6")
    private java.lang.String answer6;
	/**答案7*/
    @ApiModelProperty(value = "答案7")
    private java.lang.String answer7;
	/**答案8*/
    @ApiModelProperty(value = "答案8")
    private java.lang.String answer8;
	/**答案9*/
    @ApiModelProperty(value = "答案9")
    private java.lang.String answer9;
	/**答案10*/
    @ApiModelProperty(value = "答案10")
    //@MappedJdbcTypes(JdbcType.LONGVARCHAR)
    //@TableField(jdbcType = JdbcType.LONGVARCHAR)
    private java.lang.String answer10;
	/**答案11*/
    @ApiModelProperty(value = "答案11")
    private java.lang.String answer11;
	/**问卷版本*/
    @ApiModelProperty(value = "问卷版本")
    private java.lang.Integer evaluationver;

    /**数据来源（0：门户添加，1：老系统，2：政务大厅，3后台导入）*/
    @ApiModelProperty(value = "数据来源（0：课程中心，1：老系统，2：政务大厅，3：纸质评价）")
    private java.lang.Integer source;

    @TableField(exist = false)
    private String sourceName;

    @Excel(name = "职工号", width = 15)
    @TableField(exist = false)
    private java.lang.String userid;

    @Excel(name = "姓名", width = 15)
    @TableField(exist = false)
    private java.lang.String username;
    @Excel(name = "听课人所在单位", width = 15)
    @TableField(exist = false)
    private java.lang.String tkdw;
    @Excel(name = "听课身份", width = 15)
    @TableField(exist = false)
    private java.lang.String tksf1;
    @Excel(name = "评课要求", width = 15)
    @TableField(exist = false)
    private java.lang.String tkyq;
    @Excel(name = "实际评课数", width = 15)
    @TableField(exist = false)
    private java.lang.String sjtksl;
    @Excel(name = "其中马列教研室课程数", width = 15)
    @TableField(exist = false)
    private java.lang.String mltksl;
    @TableField(exist = false)
    private String bz;

    @TableField(exist = false)
    private String xnxq;//学期学年
    @TableField(exist = false)
    private String startDate;//
    @TableField(exist = false)
    private String endDate;//

















    @TableField(exist = false)
    private java.lang.String tksf;
    @TableField(exist = false)
    private java.lang.String szdw;
    @TableField(exist = false)
    private String startTime;
    @TableField(exist = false)
    private String endTime;
    @TableField(exist = false)
    private java.lang.String kcxz;
    @TableField(exist = false)
    private java.lang.String kkdw;
    @TableField(exist = false)
    private java.lang.String college;
    @TableField(exist = false)
    private java.lang.String kcmc;
    @TableField(exist = false)
    private java.lang.String skjs;
    @TableField(exist = false)
    private java.lang.String zc;
    @TableField(exist = false)
    private java.lang.String jc;
    @TableField(exist = false)
    private java.lang.String evaId;

    @TableField(exist = false)
    private java.lang.String skrq;
    @TableField(exist = false)
    private java.lang.String kssl;
    @TableField(exist = false)
    private java.lang.String tkkts;
    @TableField(exist = false)
    private java.lang.String tkrcs;

    @TableField(exist = false)
    private java.lang.String dwjc;
    @TableField(exist = false)
    private java.lang.String ljtkv;
    @TableField(exist = false)
    private java.lang.String avgtkv;
    @TableField(exist = false)
    private java.lang.String jrtkv;
    @TableField(exist = false)
    private java.lang.String jravgtkv;
    @TableField(exist = false)
    private java.lang.String xsid;

    @TableField(exist = false)
    private List<KcEvaluations> ansList;

    @TableField(exist = false)
    private Integer pkNum;


    //批量补充课堂信息

    /**课程编号*/
    @TableField(exist = false)
    private java.lang.String kcbh;
    /**学分*/
    @TableField(exist = false)
    private java.lang.String xf;
    /**教职工类别*/
    @TableField(exist = false)
    private java.lang.String jzglb;
    /**选课人数*/
    @TableField(exist = false)
    private java.lang.String xkrs;
    /**评课人数*/
    @TableField(exist = false)
    private java.lang.String pkrs;
    /**任务编号*/
    @TableField(exist = false)
    private java.lang.String rwbh;
    /**教室编号*/
    @TableField(exist = false)
    private String jsbh;
    /**上课地点*/
    @TableField(exist = false)
    private java.lang.String skdd;
    /**上课时间*/
    @TableField(exist = false)
    private java.lang.String sksj;
    /**未知*/
    @TableField(exist = false)
    private java.lang.String jkzc;
    /**节次*/
    @TableField(exist = false)
    @Dict(dicCode = "skjc")
    private java.lang.String hh;
    /**周几*/
    @TableField(exist = false)
    @Dict(dicCode = "week")
    private java.lang.String week;
    /**开始时间*/
    @TableField(exist = false)
    private java.lang.String hhks;
    /**结束时间*/
    @TableField(exist = false)
    private java.lang.String hhjs;
    /**未知*/
    @TableField(exist = false)
    private java.lang.String dsz;
    /**课堂开始日期*/
    @TableField(exist = false)
    private java.lang.String wwks;
    /**课堂结束日期*/
    @TableField(exist = false)
    private java.lang.String wwjs;
    /**直播方式*/
    @TableField(exist = false)
    private java.lang.String zbfs;
    /**会议id*/
    @TableField(exist = false)
    private java.lang.String hyid;
    /**会议号*/
    @TableField(exist = false)
    private java.lang.String hyh;
    /**会议密码*/
    @TableField(exist = false)
    private java.lang.String hymm;
    /**课程链接*/
    @TableField(exist = false)
    private java.lang.String kclj;
    /**备注*/
    @TableField(exist = false)
    private java.lang.String beizhu;
    /**直播平台*/
    @TableField(exist = false)
    private java.lang.String zbpx;
    /**开课单位id*/
    @TableField(exist = false)
    private java.lang.Integer kkdwid;
    /**课程表id*/
    @TableField(exist = false)
    private java.lang.String kechengbiaoid;
    /**听课次数*/
    @TableField(exist = false)
    private java.lang.Integer tingkecishu;
    /**开课周次*/
    @TableField(exist = false)
    private java.lang.String kkzc;
    /**第几周*/
    @TableField(exist = false)
    private java.lang.Integer dijizhou;
    /**未知*/
    @TableField(exist = false)
    private java.lang.String jkzc1;
    /**是否停课*/
    @TableField(exist = false)
    private java.lang.Integer sftk;
    /**停课原因*/
    @TableField(exist = false)
    private java.lang.String tkyy;
    /**补课计划*/
    @TableField(exist = false)
    private java.lang.String bkjh;
    /**是否出镜，0-出镜，1-不出镜*/
    @TableField(exist = false)
    private java.lang.Integer sfcj;
    /**上课形式，0-线上，1-线下，2-线上线下混合*/
    @TableField(exist = false)
    private java.lang.Integer skxs;
    /**未知*/
    @TableField(exist = false)
    private java.lang.Integer kechengbiao1;
    /**是否新生课 0 = 是*/
    @TableField(exist = false)
    private java.lang.String sfxsk;
    /**教工号*/
    @TableField(exist = false)
    private java.lang.String jgh;
   /**状态*/
   @TableField(exist = false)
   private java.lang.String zt;

    @TableField(exist = false)
    private String dwmc;

    @TableField(exist = false)
    private String xqxn;

    @TableField(exist = false)
    private String evaluationid;

    @TableField(exist = false)
    private String ketangbiaoid;

    @TableField(exist = false)
    private String score;

    @TableField(exist = false)
    private String tkrq;

    @TableField(exist = false)
    private String shijian;

    @TableField(exist = false)
    private String szkc;

}
