package org.jeecg.modules.kc.qa.entity;

import java.io.Serializable;
import java.io.UnsupportedEncodingException;
import java.util.Date;
import java.math.BigDecimal;

import com.baomidou.mybatisplus.annotation.*;
import lombok.Data;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;
import org.jeecgframework.poi.excel.annotation.Excel;
import org.jeecg.common.aspect.annotation.Dict;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * @Description: 调查问卷-答案表
 * @Author: jeecg-boot
 * @Date:   2023-04-09
 * @Version: V1.0
 */
@Data
@TableName("kc_evaluationans")
@Accessors(chain = true)
@EqualsAndHashCode(callSuper = false)
@ApiModel(value="kc_evaluationans对象", description="调查问卷-答案表")
public class KcEvaluationans implements Serializable {
    private static final long serialVersionUID = 1L;

	/**id*/
	@TableId(type = IdType.ASSIGN_ID)
    @ApiModelProperty(value = "id")
    private java.lang.Integer id;
	/**问题ID*/
	@Excel(name = "问题ID", width = 15)
    @ApiModelProperty(value = "问题ID")
    private java.lang.Integer queid;
	/**内容*/
	@Excel(name = "内容", width = 15)
    @ApiModelProperty(value = "内容")
    private java.lang.String content;
	/**分数*/
	@Excel(name = "分数", width = 15)
    @ApiModelProperty(value = "分数")
    private java.lang.Integer score;
	/**排序*/
	@Excel(name = "排序", width = 15)
    @ApiModelProperty(value = "排序")
    private java.lang.Integer ordernum;
	/**状态 0：可用 1：停用*/
	@Excel(name = "状态 0：可用 1：停用", width = 15)
    @ApiModelProperty(value = "状态 0：可用 1：停用")
    private java.lang.Integer status;
	/**是否参与评分 0：参与 1：不参与*/
	@Excel(name = "是否参与评分 0：参与 1：不参与", width = 15)
    @ApiModelProperty(value = "是否参与评分 0：参与 1：不参与")
    private java.lang.Integer inavg;
    /**数据来源（0：门户添加，1：老系统，2：政务大厅，3后台导入）*/
    @ApiModelProperty(value = "数据来源（0：课程中心，1：老系统，2：政务大厅，3：纸质评价）")
    private java.lang.Integer source;
}
