package org.jeecg.modules.kc.qa.entity;

import java.io.Serializable;
import java.io.UnsupportedEncodingException;
import java.util.Date;
import java.math.BigDecimal;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.TableLogic;
import lombok.Data;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;
import org.jeecgframework.poi.excel.annotation.Excel;
import org.jeecg.common.aspect.annotation.Dict;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * @Description: 调查问卷-题目表
 * @Author: jeecg-boot
 * @Date:   2023-04-09
 * @Version: V1.0
 */
@Data
@TableName("kc_evaluationque")
@Accessors(chain = true)
@EqualsAndHashCode(callSuper = false)
@ApiModel(value="kc_evaluationque对象", description="调查问卷-题目表")
public class KcEvaluationque implements Serializable {
    private static final long serialVersionUID = 1L;

	/**id*/
	@TableId(type = IdType.ASSIGN_ID)
    @ApiModelProperty(value = "id")
    private java.lang.Integer id;
	/**内容*/
	@Excel(name = "内容", width = 15)
    @ApiModelProperty(value = "内容")
    private java.lang.String content;
	/**状态 0：可用 1：不可用*/
	@Excel(name = "状态 0：可用 1：不可用", width = 15)
    @ApiModelProperty(value = "状态 0：可用 1：不可用")
    private java.lang.Integer status;
	/**分类 0:总评 1：教学准备 2：教师情况 3：学生情况 4：教学效果 5：其他*/
	@Excel(name = "分类 0:总评 1：教学准备 2：教师情况 3：学生情况 4：教学效果 5：其他", width = 15)
    @ApiModelProperty(value = "分类 0:总评 1：教学准备 2：教师情况 3：学生情况 4：教学效果 5：其他")
    private java.lang.Integer genre;
	/**排序*/
	@Excel(name = "排序", width = 15)
    @ApiModelProperty(value = "排序")
    private java.lang.Integer ordernum;
	/**问题形式 1：单选 2：多选 3：多行文本*/
	@Excel(name = "问题形式 1：单选 2：多选 3：多行文本", width = 15)
    @ApiModelProperty(value = "问题形式 1：单选 2：多选 3：多行文本")
    private java.lang.Integer quetype;
	/**是否必填 0：是 1：否*/
	@Excel(name = "是否必填 0：是 1：否", width = 15)
    @ApiModelProperty(value = "是否必填 0：是 1：否")
    private java.lang.Integer isrequire;
	/**问题版本*/
	@Excel(name = "问题版本", width = 15)
    @ApiModelProperty(value = "问题版本")
    private java.lang.Integer evaluationver;
    /**数据来源（0：门户添加，1：老系统，2：政务大厅，3后台导入）*/
    @ApiModelProperty(value = "数据来源（0：课程中心，1：老系统，2：政务大厅，3：纸质评价）")
    private java.lang.Integer source;
}
