package org.jeecg.modules.kc.qa.entity;

import java.io.Serializable;
import java.io.UnsupportedEncodingException;
import java.util.Date;
import java.math.BigDecimal;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.TableLogic;
import lombok.Data;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;
import org.jeecgframework.poi.excel.annotation.Excel;
import org.jeecg.common.aspect.annotation.Dict;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * @Description: 调查问卷-回答子表
 * @Author: jeecg-boot
 * @Date:   2023-04-09
 * @Version: V1.0
 */
@Data
@TableName("kc_evaluations")
@Accessors(chain = true)
@EqualsAndHashCode(callSuper = false)
@ApiModel(value="kc_evaluations对象", description="调查问卷-回答子表")
public class KcEvaluations implements Serializable {
    private static final long serialVersionUID = 1L;

	/**id*/
	@TableId(type = IdType.ASSIGN_ID)
    @ApiModelProperty(value = "id")
    private java.lang.String id;
	/**上传日期*/
	@Excel(name = "上传日期", width = 15, format = "yyyy-MM-dd")
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd")
    @DateTimeFormat(pattern="yyyy-MM-dd")
    @ApiModelProperty(value = "上传日期")
    private java.util.Date upDate;
	/**上传时间*/
	@Excel(name = "上传时间", width = 15, format = "yyyy-MM-dd")
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd")
    @DateTimeFormat(pattern="yyyy-MM-dd")
    @ApiModelProperty(value = "上传时间")
    private java.util.Date upTime;
	/**上传人*/
	@Excel(name = "上传人", width = 15)
    @ApiModelProperty(value = "上传人")
    private java.lang.String upuser;
	/**上传人id*/
	@Excel(name = "上传人id", width = 15)
    @ApiModelProperty(value = "上传人id")
    private java.lang.String upuserid;
	/**上传时间戳*/
	@Excel(name = "上传时间戳", width = 15)
    @ApiModelProperty(value = "上传时间戳")
    private java.lang.String upTimestamp;
	/**课堂表id*/
	@Excel(name = "课堂表id", width = 15)
    @ApiModelProperty(value = "课堂表id")
    private java.lang.String ketangbiaoid;
	/**问题id*/
	@Excel(name = "问题id", width = 15)
    @ApiModelProperty(value = "问题id")
    private java.lang.Integer queid;
	/**答案id*/
	@Excel(name = "答案id", width = 15)
    @ApiModelProperty(value = "答案id")
    private java.lang.Integer ansid;
	/**多行文本型答案内容*/
	@Excel(name = "多行文本型答案内容", width = 15)
    @ApiModelProperty(value = "多行文本型答案内容")
    private java.lang.String textanscontent;
	/**问卷版本*/
	@Excel(name = "问卷版本", width = 15)
    @ApiModelProperty(value = "问卷版本")
    private java.lang.String evaluationid;
    /**数据来源（0：门户添加，1：老系统，2：政务大厅，3后台导入）*/
    @ApiModelProperty(value = "数据来源（0：课程中心，1：老系统，2：政务大厅，3：纸质评价）")
    private java.lang.Integer source;
}
