package org.jeecg.modules.kc.qa.service.impl;

import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.xkcoding.http.HttpUtil;
import org.apache.commons.lang3.StringUtils;
import org.apache.shiro.SecurityUtils;
import org.jeecg.common.exception.JeecgBootException;
import org.jeecg.common.system.vo.LoginUser;
import org.jeecg.common.util.DateUtils;
import org.jeecg.modules.kc.KcBdgxbcopy.entity.KcBdgxbcopy;
import org.jeecg.modules.kc.grab.SynchronizationService.tools.ChangeTingKeTongJi;
import org.jeecg.modules.kc.ktgl.entity.KcKetangbiao;
import org.jeecg.modules.kc.ktgl.service.IKcKetangbiaoService;
import org.jeecg.modules.kc.qa.entity.KcEvaluation;
import org.jeecg.modules.kc.qa.entity.KcEvaluationPkmx;
import org.jeecg.modules.kc.qa.mapper.KcEvaluationMapper;
import org.jeecg.modules.kc.qa.service.IKcEvaluationService;
import org.jeecg.modules.kc.qa.service.IKcEvaluationsService;
import org.jeecg.modules.kc.statistics.KcEvaluationVo;
import org.jeecg.modules.kc.statistics.KcEvaluationVo2;
import org.jeecg.modules.system.entity.SysUser;
import org.jeecg.modules.system.service.ISysUserService;
import org.jeecg.modules.wxgzh.WeChatTemplateMsg;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.client.RestTemplate;

import java.text.ParseException;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @Description: 调查问卷-回答主表
 * @Author: jeecg-boot
 * @Date:   2023-04-09
 * @Version: V1.0
 */
@Service
public class KcEvaluationServiceImpl extends ServiceImpl<KcEvaluationMapper, KcEvaluation> implements IKcEvaluationService {

    @Autowired
    private IKcEvaluationsService kcEvaluationsService;

    @Lazy//防止循环
    @Autowired
    private ChangeTingKeTongJi changeTingKeTongJi;
    @Autowired
    private IKcKetangbiaoService kcKetangbiaoService;
    @Autowired
    private ISysUserService sysUserService;

    public IPage<KcEvaluation> getPktjbList(Page<KcEvaluation> page, KcEvaluation kcEvaluation) {
        return baseMapper.getPktjbList(page,kcEvaluation);
    }

    @Override
    public IPage<KcEvaluation> getPkmxbList(Page<KcEvaluation> page, KcEvaluation kcEvaluation) {
        return baseMapper.getPkmxbList(page,kcEvaluation);
    }

    @Override
    public List<KcEvaluation> getPkztjTjt(KcEvaluation kcEvaluation) {
        return baseMapper.getPkztjTjt(kcEvaluation);
    }

    @Override
    public List<KcEvaluation> getPkfglTjt(KcEvaluation kcEvaluation) {
        return baseMapper.getPkfglTjt(kcEvaluation);
    }

    @Transactional(rollbackFor = JeecgBootException.class)
    @Override
    public void addQaAll(KcEvaluation kcEvaluation) {
        //取当前用户ID和用户名
        LoginUser loginUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
        //kcEvaluation.setUpuserid(Integer.parseInt(loginUser.getUsername()));
        kcEvaluation.setUpuser(loginUser.getRealname());
        Date now = DateUtil.date();
        if(kcEvaluation.getUpTimestamp()!=null){
            try {
                now = DateUtils.parseDate(kcEvaluation.getUpTimestamp(),"yyyy-MM-dd HH:mm:ss");
            } catch (ParseException e) {
                e.printStackTrace();
            }
        }
//        DateUtil.format(now,"yyyyMMddHHmmssSSS");
        kcEvaluation.setUpDate(now);
        kcEvaluation.setUpTime(now);
        kcEvaluation.setUpTimestamp(DateUtils.formatDate(now,"yyyy-MM-dd HH:mm:ss"));
//        DateUtil.format(now,"yyyy-MM-dd");
        save(kcEvaluation);
        if(kcEvaluation.getAnsList() != null && !kcEvaluation.getAnsList().isEmpty()){
            kcEvaluation.getAnsList().forEach(x -> {
                x.setEvaluationid(kcEvaluation.getId());
                x.setUpDate(kcEvaluation.getUpDate());
                x.setUpTime(kcEvaluation.getUpTime());
                x.setUpTimestamp(kcEvaluation.getUpTimestamp());
                x.setUpuser(kcEvaluation.getUpuser());
            });
            kcEvaluationsService.saveBatch(kcEvaluation.getAnsList());
        }
        //添加评课数据和统计数据
        changeTingKeTongJi.updateTingKeTongJiAndPingKeByUserId(String.valueOf(kcEvaluation.getUpuserid()),kcEvaluation.getMinkcid());


        String ketangbiaoid = kcEvaluation.getMinkcid();//课堂表id
        KcKetangbiao kcKetangbiao = kcKetangbiaoService.getById(ketangbiaoid);
        sendWxmessage(kcKetangbiao);
    }

    @Override
    public List<KcEvaluation> selectKkdwExportList(KcEvaluation kcEvaluation) {
        return baseMapper.selectKkdwExportList(kcEvaluation);
    }

    @Override
    public List<KcEvaluationPkmx> selectPkmxExportList(KcEvaluationPkmx kcEvaluationPkmx) {
        return baseMapper.selectPkmxExportList(kcEvaluationPkmx);
    }

    @Override
    public IPage<KcEvaluation> keTangList(Page<KcEvaluation> page, QueryWrapper<KcEvaluation> queryWrapper) {
        return page.setRecords(baseMapper.keTangList(page,queryWrapper));
    }

    @Override
    public IPage<KcEvaluationVo> selectPageAndKcmc(Page<KcEvaluationVo> page, QueryWrapper<KcEvaluationVo> queryWrapper) {
        return page.setRecords(baseMapper.selectPageAndKcmc(page,queryWrapper));
    }

    @Override
    public IPage<KcEvaluationVo2> selectPageAndKcmc2(Page<KcEvaluationVo2> page, QueryWrapper<KcEvaluationVo2> queryWrapper) {
        return page.setRecords(baseMapper.selectPageAndKcmc2(page,queryWrapper));
    }

    @Override
    public IPage<KcEvaluation> queryPkZuJiPage(Page<KcEvaluation> page, QueryWrapper<KcEvaluation> queryWrapper) {
        return page.setRecords(baseMapper.queryPkZuJiPage(page,queryWrapper));
    }

    @Override
    public List<KcEvaluation> findTj(QueryWrapper<KcEvaluation> queryWrapper) {
        return baseMapper.findTj(queryWrapper);
    }

    @Override
    public List<KcEvaluation> getCountlist(KcEvaluation kcEvaluation) {
        return baseMapper.getCountlist(kcEvaluation);
    }

    @Override
    public List<KcEvaluation> findTkcsTj(QueryWrapper<KcEvaluation> kcEvaluationQueryWrapper) {
        return baseMapper.findTkcsTj(kcEvaluationQueryWrapper);
    }

    // appId
    private static final String appId = "wx59920eb69d611d7f";//东师

    // appIdSecret
    private static final String appIdSecret = "bf0c19af0e956f447ede4dd902ea63b7";//东师

    // 公众号的模板id(也有相应的接口可以查询到)
    private static final String templateId = "KtWw0lwQ8FOgJdKgrmya0eoafGkMfMN8ECdZs8oSJys";//东师

    //微信通知点击后跳转的页面
    private static final String domainTo = "https://smartedu.nenu.edu.cn";

    /**
     * 发送微信通知
     * @param kcKetangbiao
     */
    public void sendWxmessage(KcKetangbiao kcKetangbiao) {

        String skjs = kcKetangbiao.getSkjs();
//        QueryWrapper<SysUser> queryWrapper = new QueryWrapper<>();
//        queryWrapper.eq("realname",skjs);
//        List<SysUser> sysUserList = sysUserService.list(queryWrapper);
        String openId = "";
        try{
            System.out.println("skjs:"+skjs+"");
            KcBdgxbcopy kcBdgxbcopy=baseMapper.getOpenId(skjs);
            if(kcBdgxbcopy !=null){
                System.out.println("kcBdgxbcopy.getOpenid():"+kcBdgxbcopy.getOpenid()+"");
                openId = kcBdgxbcopy.getOpenid();
            }
        }catch (Exception e){e.printStackTrace();}
//        openId = "oak6lwKGlGQQwt83nuynZnP4HUR4";//曹老师账号
        System.out.println("openId:"+openId+"");
        if(StringUtils.isNotEmpty(openId)){
            String urlToken = "https://api.weixin.qq.com/cgi-bin/token?grant_type=client_credential&appid="+ appId +"&secret=" + appIdSecret;
            System.out.println("urlToken：  "+ urlToken);
            String res = HttpUtil.get(urlToken);
            JSONObject jsonObjectToken = JSONObject.parseObject(res);
            System.out.println("jsonObjectToken：{}"+ jsonObjectToken);
            String accessToken = jsonObjectToken.getString("access_token");
            System.out.println("accessToken：{}"+ accessToken);

            // 模板参数
            Map<String, WeChatTemplateMsg> sendMag = new HashMap<String, WeChatTemplateMsg>();

            // 微信的基础accessToken
            String url = "https://api.weixin.qq.com/cgi-bin/message/template/send?access_token=" + accessToken;
//            xx老师，你好，您于2023.12.01在逸夫楼101室任教的“马克思列宁主义”课程，收到一条听课评价，评价分数为5分（满分5分）。
//            如需查看，请点击：课程信息中心（链接）
            System.out.println("getSkjs : " + kcKetangbiao.getSkjs() + ", getSkrq: " +kcKetangbiao.getSkrq()+ ", getKcmc: " +kcKetangbiao.getKcmc());

            sendMag.put("first", new WeChatTemplateMsg(kcKetangbiao.getSkjs()+"老师您好"));//授课老师
            sendMag.put("keyword1", new WeChatTemplateMsg(kcKetangbiao.getSkrq()));//授课老师
            sendMag.put("keyword2", new WeChatTemplateMsg("听课记录"));//授课老师
            String message = "收到一条听课评价，评价分数为*分（满分5分）";
            sendMag.put("remark", new WeChatTemplateMsg(message));//授课老师

//            sendMag.put("thing7", new WeChatTemplateMsg(kcKetangbiao.getSkjs()));//授课老师
//            sendMag.put("date5", new WeChatTemplateMsg(kcKetangbiao.getSkrq()));//上课时间
//            sendMag.put("thing6", new WeChatTemplateMsg(kcKetangbiao.getKcmc()));//课程名称
//            sendMag.put("thing4", new WeChatTemplateMsg("评价分数为5分（满分5分）"));//课后作业
            RestTemplate restTemplate = new RestTemplate();
            //拼接base参数
            Map<String, Object> sendBody = new HashMap<>();
            sendBody.put("touser", openId);               // openId
            sendBody.put("url", domainTo);         // 点击模板信息跳转地址
//            sendBody.put("topcolor", "#FF0000");          // 顶色
            sendBody.put("data", sendMag);                   // 模板参数
            sendBody.put("template_id", "PDS1hf6s8P5Ce-SFa9J95XvHhMIGlyhITAGq_CIoNMM");      // 模板Id
            ResponseEntity<String> forEntity = restTemplate.postForEntity(url, sendBody, String.class);
            JSONObject jsonObject2 = JSONObject.parseObject(forEntity.getBody());
            System.out.println("jsonObject2 : " + jsonObject2);
            String messageCode = jsonObject2.getString("errcode");
            String msgId = jsonObject2.getString("msgid");
            System.out.println("messageCode : " + messageCode + ", msgId: " +msgId);
        }
    }


}
