package org.jeecg.modules.kc.statistics;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.jeecg.common.aspect.annotation.Dict;
import org.jeecg.modules.kc.qa.entity.KcEvaluations;
import org.jeecgframework.poi.excel.annotation.Excel;
import org.springframework.format.annotation.DateTimeFormat;

import java.io.Serializable;
import java.util.Date;
import java.util.List;

/**
 * @Description: 调查问卷-回答主表
 * @Author: jeecg-boot
 * @Date:   2023-04-09
 * @Version: V1.0
 */
@Data
@TableName("kc_evaluation")
@Accessors(chain = true)
@EqualsAndHashCode(callSuper = false)
@ApiModel(value="kc_evaluation对象", description="调查问卷-回答主表")
public class KcEvaluationVo implements Serializable {
    private static final long serialVersionUID = 1L;

    @TableId(type = IdType.ASSIGN_ID)
    @ApiModelProperty(value = "id")
    private String id;
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd")
    @DateTimeFormat(pattern="yyyy-MM-dd")
    @ApiModelProperty(value = "上传日期")
    private Date upDate;
	@JsonFormat(timezone = "GMT+8",pattern = "HH:mm")
    @DateTimeFormat(pattern="HH:mm")
    @ApiModelProperty(value = "上传时间")
    private Date upTime;
    @ApiModelProperty(value = "答案")
    private String answer1;
	/**上传人id*/
    @ApiModelProperty(value = "上传人id")
    private Integer upuserid;
    /**上传人id*/
    @ApiModelProperty(value = "上传人id")
    @TableField(exist = false)
    private String upuseridLike;
	/**上传时间戳*/
    @ApiModelProperty(value = "上传时间戳")
    private String upTimestamp;
	/**课程最小id*/
    @ApiModelProperty(value = "课程最小id")
    private String minkcid;
	/**答案2*/
    @ApiModelProperty(value = "答案2")
    private String answer2;
	/**答案3*/
    @ApiModelProperty(value = "答案3")
    private String answer3;
	/**答案4*/
    @ApiModelProperty(value = "答案4")
    private String answer4;
	/**答案5*/
    @ApiModelProperty(value = "答案5")
    private String answer5;
	/**答案6*/
    @ApiModelProperty(value = "答案6")
    private String answer6;
	/**答案7*/
    @ApiModelProperty(value = "答案7")
    private String answer7;
	/**答案8*/
    @ApiModelProperty(value = "答案8")
    private String answer8;
	/**答案9*/
    @ApiModelProperty(value = "答案9")
    private String answer9;
	/**答案10*/
    @ApiModelProperty(value = "答案10")
    //@MappedJdbcTypes(JdbcType.LONGVARCHAR)
    //@TableField(jdbcType = JdbcType.LONGVARCHAR)
    private String answer10;
	/**答案11*/
    @ApiModelProperty(value = "答案11")
    private String answer11;
	/**问卷版本*/
    @ApiModelProperty(value = "问卷版本")
    private Integer evaluationver;

    /**数据来源（0：门户添加，1：老系统，2：政务大厅，3后台导入）*/
    @ApiModelProperty(value = "数据来源（0：课程中心，1：老系统，2：政务大厅，3：纸质评价）")
    private Integer source;
    


    @Excel(name = "学期", width = 15)
    @TableField(exist = false)
    private String xqxn;

    @Excel(name = "课程名称", width = 15)
    @TableField(exist = false)
    private String kcmc;

    @TableField(exist = false)
    private String week;

    @TableField(exist = false)
    private String hh;

    @Excel(name = "开课单位", width = 15)
    @TableField(exist = false)
    private String kkdw;

    @Excel(name = "授课教师", width = 15)
    @TableField(exist = false)
    private String skjs;

    @Excel(name = "授课教师工号", width = 15)
    @TableField(exist = false)
    private String skjgh;

    //授课日期（时间/节次）
    @Excel(name = "授课日期", width = 15)
    @TableField(exist = false)
    private String skrq;

    @Excel(name = "授课时间", width = 15)
    @TableField(exist = false)
    private String sksj;

    @Excel(name = "授课节次", width = 15)
    @TableField(exist = false)
    private String jieci;

    @Excel(name = "授课地点", width = 15)
    @TableField(exist = false)
    private String skdd;
    
    @Excel(name = "听课教师单位", width = 15)
    @TableField(exist = false)
    private String tkdwmc;

    @Excel(name = "听课教师工号", width = 15)
    @TableField(exist = false)
    private String tkjgh;

    @Excel(name = "听课教师姓名", width = 15)
    @TableField(exist = false)
    private String tkjsxm;

    @Excel(name = "听课身份", width = 15)
    @TableField(exist = false)
    private String tksf;

    @TableField(exist = false)
    private String tksfLike;

    @Excel(name = "听课评价结果（5分制）", width = 15)
    @TableField(exist = false)
    private String tkpjjg;

    @Excel(name = "评价量表类型", width = 15)
    @TableField(exist = false)
    private String pjlblx;

    @Excel(name = "数据来源", width = 15)
    @TableField(exist = false)
    private String sourceName;

    @TableField(exist = false)
    private String upUserName;
    @TableField(exist = false)
    private String kcxz;
    @TableField(exist = false)
    private String szkc;

    @TableField(exist = false)
    private String findGh;

    /**
     * 按当前用户的部门查询评课
     */
    @TableField(exist = false)
    private boolean findByPkdwmc;

    /**
     * 按当前用户的部门查询被评课
     */
    @TableField(exist = false)
    private boolean findByBeiTkkdwmc;

}
