package org.jeecg.modules.kc.statistics;

import cn.hutool.core.date.DatePattern;
import cn.hutool.core.date.DateUnit;
import cn.hutool.core.date.DateUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.beust.jcommander.internal.Sets;
import com.google.common.collect.Maps;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.SecurityUtils;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.system.vo.LoginUser;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.kc.config.entity.KcExportConfigTpkwcqkjzglx;
import org.jeecg.modules.kc.config.service.IKcExportConfigTpkwcqkjzglxService;
import org.jeecg.modules.kc.grab.SynchronizationService.tools.ChangeTingKeTongJi;
import org.jeecg.modules.kc.grab.imports.entity.Xxhbuser;
import org.jeecg.modules.kc.grab.imports.service.IXxhbuserService;
import org.jeecg.modules.kc.kcXqxnHistory.entity.KcXqxnHistory;
import org.jeecg.modules.kc.kcXqxnHistory.service.IKcXqxnHistoryService;
import org.jeecg.modules.kc.qa.entity.KcEvaluationans;
import org.jeecg.modules.kc.qa.service.IKcEvaluationService;
import org.jeecg.modules.kc.tksf.kctksfrzb.entity.KcTksfrzb;
import org.jeecg.modules.kc.tksf.kctksfrzb.service.IKcTksfrzbService;
import org.jeecg.modules.kc.tksf.kctksfyq.entity.KcTksfyq;
import org.jeecg.modules.kc.tksf.kctksfyq.service.IKcTksfyqService;
import org.jeecg.modules.tools.DictUtils;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.enmus.ExcelType;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.http.HttpServletRequest;
import java.util.*;
import java.util.stream.Collectors;

/**
 * @Description: 调查问卷-答案表
 * @Author: jeecg-boot
 * @Date:   2023-04-09
 * @Version: V1.0
 */
@Api(tags="调查问卷-答案表")
@RestController
@RequestMapping("/statistics")
@Slf4j
public class TingKeStatisticsController {

    @Value("${jeecg.path.upload}")
    private String upLoadPath;

    @Autowired
    private DictUtils dictUtils;

    @Autowired
    private IKcEvaluationService service;

    @Autowired
    private IXxhbuserService xxhbuserService;

    @Autowired
    private IKcTksfrzbService kcTksfrzbService;

    @Autowired
    private IKcExportConfigTpkwcqkjzglxService kcExportConfigTpkwcqkjzglxService;

    @Autowired
    private IKcXqxnHistoryService kcXqxnHistoryService;

    @Autowired
    private ChangeTingKeTongJi changeTingKeTongJi;


    public IPage<KcEvaluationVo> loadPageData(KcEvaluationVo evaluation,QueryWrapper<KcEvaluationVo> queryWrapper,Page<KcEvaluationVo> page){

        //查询当前用户的学院
        if(evaluation.isFindByPkdwmc() || evaluation.isFindByBeiTkkdwmc()){
            QueryWrapper<Xxhbuser> uqw = new QueryWrapper<>();
            //LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
            uqw.eq("gh",evaluation.getFindGh());
            uqw.last("limit 1");
            Xxhbuser xxhbUser = xxhbuserService.getOne(uqw);
            if(xxhbUser == null) {
                return new Page<>();
            }
            //queryWrapper.eq()
            if(evaluation.isFindByPkdwmc()){
                queryWrapper.eq("xu.DWMC",xxhbUser.getDwmc());
            }
            if(evaluation.isFindByBeiTkkdwmc()){
                queryWrapper.eq("kt.kkdw ",xxhbUser.getDwmc());
            }
        }


        queryWrapper.isNotNull("a.upuserid");
        queryWrapper.isNotNull("a.minkcid");

//        if(StringUtils.isNotBlank(evaluation.getDwmc())){
//            List<Xxhbuser> xxhbuserList = szdwList.stream().filter(x -> StringUtils.equals(x.getDwh(),evaluation.getDwmc())).collect(Collectors.toList());
//            Set<String> ghSet = xxhbuserList.stream().map(x -> x.getGh()).collect(Collectors.toSet());
//            queryWrapper.in("a.upuserid",ghSet);
//        }
        queryWrapper.like(StringUtils.isNotBlank(evaluation.getKkdw()),"kt.kkdw",evaluation.getKkdw());
        queryWrapper.like(StringUtils.isNotBlank(evaluation.getSkjs()),"kt.skjs",evaluation.getSkjs());
        queryWrapper.like(StringUtils.isNotBlank(evaluation.getSkjgh()),"kt.jgh",evaluation.getSkjgh());
        queryWrapper.like(StringUtils.isNotBlank(evaluation.getUpuseridLike()),"a.upuserid",evaluation.getUpuseridLike());
        queryWrapper.like(StringUtils.isNotBlank(evaluation.getUpUserName()),"a.upuser",evaluation.getUpUserName());
        queryWrapper.like(StringUtils.isNotBlank(evaluation.getTkdwmc()),"xu.DWMC",evaluation.getTkdwmc());



        List<KcXqxnHistory> kcXqxnHistoryList = kcXqxnHistoryService.list();
        //查询所在单位
        List<Xxhbuser> szdwList =  xxhbuserService.list();
        Map<String, Xxhbuser> szdwMap = Maps.newHashMap();
        szdwList.forEach(x -> {
            szdwMap.put(x.getGh(),x);
        });

        //补充搜索
        if(StringUtils.isNotBlank(evaluation.getXqxn())){
            KcXqxnHistory common = changeTingKeTongJi.getXqConfig(evaluation.getXqxn());
            Date startSjDate = common.getStartTime();
            Date endSjDate = common.getEndTime();
            String startSj = DateUtil.format(startSjDate, DatePattern.NORM_DATETIME_FORMAT);
            String endSj = DateUtil.format(endSjDate,DatePattern.NORM_DATETIME_FORMAT);
            String xqxn = common.getTitle();

            queryWrapper.apply("a.up_date >= STR_TO_DATE('"+ startSj +"', '%Y-%m-%d') ");
            queryWrapper.apply("a.up_date <= STR_TO_DATE('"+ endSj +"', '%Y-%m-%d') ");

//            queryWrapper.ge("a.up_date",xqxnHistory.getStartTime());
//            queryWrapper.le("a.up_date",xqxnHistory.getEndTime());
        }

        //按听课身份查询
        if(StringUtils.isNotBlank(evaluation.getTksf())){
            QueryWrapper<KcExportConfigTpkwcqkjzglx> tksfSerachQw = new QueryWrapper<>();
            tksfSerachQw.eq("tklx",evaluation.getTksf());
            List<KcExportConfigTpkwcqkjzglx> tksfGhList =  kcExportConfigTpkwcqkjzglxService.list(tksfSerachQw);
            if(tksfGhList != null && !tksfGhList.isEmpty()){
                Set<String> ghSet = tksfGhList.stream().map(x -> x.getGh()).collect(Collectors.toSet());
                queryWrapper.in("a.upuserid",ghSet);
            }else{
                queryWrapper.eq("a.upuserid","-1");
            }
        }
        //按听课身份模糊查询
        if(StringUtils.isNotBlank(evaluation.getTksfLike())){
            QueryWrapper<KcTksfrzb> tksfSerachQw = new QueryWrapper<>();
            tksfSerachQw.like("kc_tksfrzb.ZWMC",evaluation.getTksfLike());
            List<KcTksfrzb> tksfGhList =  kcTksfrzbService.list(tksfSerachQw);
            if(tksfGhList != null && !tksfGhList.isEmpty()){
                Set<String> ghSet = tksfGhList.stream().map(x -> x.getGh()).collect(Collectors.toSet());
                queryWrapper.in("a.upuserid",ghSet);
            }else{
                queryWrapper.eq("a.upuserid","-1");
            }
        }
        IPage<KcEvaluationVo> pageList = service.selectPageAndKcmc(page, queryWrapper);
        //---------------------补数据1------------------------------------------
        Map<Integer,String> sourceDictMap = Maps.newHashMap();
        //0：门户添加，1：老系统，2：政务大厅，3后台导入
        sourceDictMap.put(0,"课程中心");
        sourceDictMap.put(1,"老系统");
        sourceDictMap.put(2,"服务大厅");
        sourceDictMap.put(3,"线下纸质");
        Map<String,String> pjlblxMap = Maps.newHashMap();
        //0：门户添加，1：老系统，2：政务大厅，3后台导入
//		 sourceDictMap.put(0,"课程中心");
//		 sourceDictMap.put(1,"老系统");
        pjlblxMap.put("2","线上课堂评价表");
        pjlblxMap.put("3","听课记录表");
        pjlblxMap.put("4","同行评价表");
        //---------------------补数据1------------------------------------------

        Set<String> tjSet = Sets.newHashSet();
        pageList.getRecords().forEach(x -> {
            //补充信息
            x.setSourceName(sourceDictMap.get(x.getSource()));//数据来源
            x.setPjlblx(pjlblxMap.get(x.getPjlblx()));
            Integer ixuserId = x.getUpuserid();
            String xuserId = String.valueOf(ixuserId);
            tjSet.add(xuserId);
        });

        if(tjSet.isEmpty()){
            return new Page<>();
        }
        //---------------------补数据2------------------------------------------

        //查询听课身份
        QueryWrapper<KcExportConfigTpkwcqkjzglx> tksfQw = new QueryWrapper<>();
        tksfQw.in("gh",tjSet);
        tksfQw.groupBy("tklx");
        List<KcExportConfigTpkwcqkjzglx> tksfList =  kcExportConfigTpkwcqkjzglxService.list(tksfQw);
        Map<String, KcExportConfigTpkwcqkjzglx> tksfMap = Maps.newHashMap();
        tksfList.forEach(x -> {
            if(tksfMap.containsKey(x.getGh())){
                //存在了，拼接职务名称，取最大的听课要求
                KcExportConfigTpkwcqkjzglx currentData = tksfMap.get(x.getGh());
                String currentTkyq = currentData.getYtkcs();
                String currentTklx = currentData.getTklx();
                String currentZwmc = currentData.getZwmc();
                if(StringUtils.isNotBlank(currentZwmc)){
                    int tkyq = Integer.parseInt(StringUtils.defaultString(currentTkyq,"0"));
                    int xtkyq = Integer.parseInt(StringUtils.defaultString(x.getTklx(),"0"));
                    String xZwmc = dictUtils.translateDictValue("tpkwcqkjzglx", x.getTklx());
                    currentData.setZwmc(currentZwmc + "、" + xZwmc);
                    if(tkyq > xtkyq){
                        currentData.setYtkcs(String.valueOf(tkyq));
                    }else{
                        currentData.setYtkcs(String.valueOf(xtkyq));
                    }
                }else{
                    String xZwmc = dictUtils.translateDictValue("tpkwcqkjzglx", x.getTklx());
                    currentData.setZwmc(xZwmc);
                }
//                tksfMap.put(x.getGh(),x);
            }else{
                String xZwmc = dictUtils.translateDictValue("tpkwcqkjzglx", x.getTklx());
                x.setZwmc(xZwmc);
                tksfMap.put(x.getGh(),x);
            }
        });
        //---------------------补数据2------------------------------------------
        pageList.getRecords().forEach(x -> {
            Integer ixuserId = x.getUpuserid();
            String xuserId = String.valueOf(ixuserId);
//            if(szdwMap.containsKey(xuserId)){
//                Xxhbuser currentData = szdwMap.get(xuserId);
//                x.setDwmc(currentData.getDwmc());
//            }
            if(tksfMap.containsKey(xuserId)){
                KcExportConfigTpkwcqkjzglx currentData = tksfMap.get(xuserId);
                //tj.setJsxm(currentData.getXm());
                x.setTksf(currentData.getZwmc());
                //tj.setYskcs(currentData.getTkyq());
            }

//            Date upDate = x.getUpDate();
            String skrq = x.getSkrq();
            if(StringUtils.isNotBlank(skrq)){
                Date upDate = DateUtil.parseDate(skrq);
                kcXqxnHistoryList.forEach(hx -> {
                    Date startTime = hx.getStartTime();
                    Date endTime = hx.getEndTime();
                    long betweenStartDay = DateUtil.between(startTime, upDate, DateUnit.DAY,false);
                    long betweenEndDay = DateUtil.between(endTime, upDate, DateUnit.DAY,false);
                    if(betweenStartDay >=0 && betweenEndDay <=0) {
                        x.setXqxn(hx.getTitle());
                    }
                } );
            }
        });

        return pageList;
    }

    public IPage<KcEvaluationVo2> loadPageData2(KcEvaluationVo2 evaluation,QueryWrapper<KcEvaluationVo2> queryWrapper,Page<KcEvaluationVo2> page){
        //查询当前用户的学院
        if(evaluation.isFindByPkdwmc() || evaluation.isFindByBeiTkkdwmc()){
            QueryWrapper<Xxhbuser> uqw = new QueryWrapper<>();
            //LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
            uqw.eq("gh",evaluation.getFindGh());
            uqw.last("limit 1");
            Xxhbuser xxhbUser = xxhbuserService.getOne(uqw);
            if(xxhbUser == null) {
                return new Page<>();
            }
            //queryWrapper.eq()
            if(evaluation.isFindByPkdwmc()){
                queryWrapper.eq("xu.DWMC",xxhbUser.getDwmc());
            }
            if(evaluation.isFindByBeiTkkdwmc()){
                queryWrapper.eq("kt.kkdw ",xxhbUser.getDwmc());
            }
        }

        queryWrapper.isNotNull("a.upuserid");
        queryWrapper.isNotNull("a.minkcid");

//        if(StringUtils.isNotBlank(evaluation.getDwmc())){
//            List<Xxhbuser> xxhbuserList = szdwList.stream().filter(x -> StringUtils.equals(x.getDwh(),evaluation.getDwmc())).collect(Collectors.toList());
//            Set<String> ghSet = xxhbuserList.stream().map(x -> x.getGh()).collect(Collectors.toSet());
//            queryWrapper.in("a.upuserid",ghSet);
//        }
        queryWrapper.like(StringUtils.isNotBlank(evaluation.getKkdw()),"kt.kkdw",evaluation.getKkdw());
        queryWrapper.like(StringUtils.isNotBlank(evaluation.getSkjs()),"kt.skjs",evaluation.getSkjs());
        queryWrapper.like(StringUtils.isNotBlank(evaluation.getSkjgh()),"kt.jgh",evaluation.getSkjgh());
        queryWrapper.like(StringUtils.isNotBlank(evaluation.getUpuseridLike()),"a.upuserid",evaluation.getUpuseridLike());



        List<KcXqxnHistory> kcXqxnHistoryList = kcXqxnHistoryService.list();
        //查询所在单位
        List<Xxhbuser> szdwList =  xxhbuserService.list();
        Map<String, Xxhbuser> szdwMap = Maps.newHashMap();
        szdwList.forEach(x -> {
            szdwMap.put(x.getGh(),x);
        });

        //补充搜索
        if(StringUtils.isNotBlank(evaluation.getXqxn())){
            List<KcXqxnHistory> xqxnHistoryList = kcXqxnHistoryList.stream().filter(x -> StringUtils.equals(x.getTitle(),evaluation.getXqxn())).collect(Collectors.toList());
            if(xqxnHistoryList != null && !xqxnHistoryList.isEmpty()){
                KcXqxnHistory xqxnHistory = xqxnHistoryList.get(0);
                queryWrapper.ge("a.up_date",xqxnHistory.getStartTime());
                queryWrapper.le("a.up_date",xqxnHistory.getEndTime());
            }
        }
        //按听课身份查询
        if(StringUtils.isNotBlank(evaluation.getTksf())){
            QueryWrapper<KcExportConfigTpkwcqkjzglx> tksfSerachQw = new QueryWrapper<>();
            tksfSerachQw.eq("tklx",evaluation.getTksf());
            List<KcExportConfigTpkwcqkjzglx> tksfGhList =  kcExportConfigTpkwcqkjzglxService.list(tksfSerachQw);
            if(tksfGhList != null && !tksfGhList.isEmpty()){
                Set<String> ghSet = tksfGhList.stream().map(x -> x.getGh()).collect(Collectors.toSet());
                queryWrapper.in("a.upuserid",ghSet);
            }else{
                queryWrapper.eq("a.upuserid","-1");
            }
        }
        //按听课身份模糊查询
        if(StringUtils.isNotBlank(evaluation.getTksfLike())){
            QueryWrapper<KcTksfrzb> tksfSerachQw = new QueryWrapper<>();
            tksfSerachQw.like("kc_tksfrzb.ZWMC",evaluation.getTksfLike());
            List<KcTksfrzb> tksfGhList =  kcTksfrzbService.list(tksfSerachQw);
            if(tksfGhList != null && !tksfGhList.isEmpty()){
                Set<String> ghSet = tksfGhList.stream().map(x -> x.getGh()).collect(Collectors.toSet());
                queryWrapper.in("a.upuserid",ghSet);
            }else{
                queryWrapper.eq("a.upuserid","-1");
            }
        }
        IPage<KcEvaluationVo2> pageList = service.selectPageAndKcmc2(page, queryWrapper);
        //---------------------补数据1------------------------------------------
        Map<Integer,String> sourceDictMap = Maps.newHashMap();
        //0：门户添加，1：老系统，2：政务大厅，3后台导入
        sourceDictMap.put(0,"课程中心");
        sourceDictMap.put(1,"老系统");
        sourceDictMap.put(2,"服务大厅");
        sourceDictMap.put(3,"线下纸质");

        Map<String,String> pjlblxMap = Maps.newHashMap();
        //0：门户添加，1：老系统，2：政务大厅，3后台导入
//		 sourceDictMap.put(0,"课程中心");
//		 sourceDictMap.put(1,"老系统");
        pjlblxMap.put("2","线上课堂评价表");
        pjlblxMap.put("3","听课记录表");
        pjlblxMap.put("4","同行评价表");

        //---------------------补数据1------------------------------------------

        Set<String> tjSet = Sets.newHashSet();
        pageList.getRecords().forEach(x -> {
            //补充信息
            x.setSourceName(sourceDictMap.get(x.getSource()));//数据来源
            x.setPjlblx(pjlblxMap.get(x.getPjlblx()));
            Integer ixuserId = x.getUpuserid();
            String xuserId = String.valueOf(ixuserId);
            tjSet.add(xuserId);
        });

        if(tjSet.isEmpty()){
            return new Page<>();
        }
        //---------------------补数据2------------------------------------------

        //查询听课身份
        QueryWrapper<KcExportConfigTpkwcqkjzglx> tksfQw = new QueryWrapper<>();
        tksfQw.in("gh",tjSet);
        List<KcExportConfigTpkwcqkjzglx> tksfList =  kcExportConfigTpkwcqkjzglxService.list(tksfQw);
        Map<String, KcExportConfigTpkwcqkjzglx> tksfMap = Maps.newHashMap();
        tksfList.forEach(x -> {
            if(tksfMap.containsKey(x.getGh())){
                //存在了，拼接职务名称，取最大的听课要求
                KcExportConfigTpkwcqkjzglx currentData = tksfMap.get(x.getGh());
                String currentTkyq = currentData.getYtkcs();
                String currentTklx = currentData.getTklx();
                String currentZwmc = currentData.getZwmc();
                if(StringUtils.isNotBlank(currentZwmc)){
                    int tkyq = Integer.parseInt(StringUtils.defaultString(currentTkyq,"0"));
                    int xtkyq = Integer.parseInt(StringUtils.defaultString(x.getTklx(),"0"));
                    String xZwmc = dictUtils.translateDictValue("tpkwcqkjzglx", x.getTklx());
                    currentData.setZwmc(currentZwmc + "、" + xZwmc);
                    if(tkyq > xtkyq){
                        currentData.setYtkcs(String.valueOf(tkyq));
                    }else{
                        currentData.setYtkcs(String.valueOf(xtkyq));
                    }
                }else{
                    String xZwmc = dictUtils.translateDictValue("tpkwcqkjzglx", x.getTklx());
                    currentData.setZwmc(xZwmc);
                  }
//                tksfMap.put(x.getGh(),x);
            }else{
                String xZwmc = dictUtils.translateDictValue("tpkwcqkjzglx", x.getTklx());
                x.setZwmc(xZwmc);
                tksfMap.put(x.getGh(),x);
            }
        });
        //---------------------补数据2------------------------------------------
        pageList.getRecords().forEach(x -> {
            Integer ixuserId = x.getUpuserid();
            String xuserId = String.valueOf(ixuserId);
//            if(szdwMap.containsKey(xuserId)){
//                Xxhbuser currentData = szdwMap.get(xuserId);
//                x.setDwmc(currentData.getDwmc());
//            }
            if(tksfMap.containsKey(xuserId)){
                KcExportConfigTpkwcqkjzglx currentData = tksfMap.get(xuserId);
                //tj.setJsxm(currentData.getXm());
                x.setTksf(currentData.getZwmc());
                //tj.setYskcs(currentData.getTkyq());
            }

//            Date upDate = x.getUpDate();
            String skrq = x.getSkrq();
            if(StringUtils.isNotBlank(skrq)){
                Date upDate = DateUtil.parseDate(skrq);
                kcXqxnHistoryList.forEach(hx -> {
                    Date startTime = hx.getStartTime();
                    Date endTime = hx.getEndTime();
                    long betweenStartDay = DateUtil.between(startTime, upDate, DateUnit.DAY,false);
                    long betweenEndDay = DateUtil.between(endTime, upDate, DateUnit.DAY,false);
                    if(betweenStartDay >=0 && betweenEndDay <=0) {
                        x.setXqxn(hx.getTitle());
                    }
                } );
            }
        });

        return pageList;
    }


    @ApiOperation(value="调查问卷-答案表-分页列表查询", notes="调查问卷-答案表-分页列表查询")
    @GetMapping(value = "/getEvaluationList")
    public Result<IPage<KcEvaluationVo>> list(KcEvaluationVo evaluation,
                                            @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
                                            @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
                                            HttpServletRequest req) {
        Page<KcEvaluationVo> page = new Page<>(pageNo, pageSize);
        QueryWrapper<KcEvaluationVo> queryWrapper = QueryGenerator.initQueryWrapper("a",evaluation, req.getParameterMap());
        IPage<KcEvaluationVo> pageList = loadPageData(evaluation,queryWrapper,page);
        return Result.OK(pageList);
    }


    /**
     * 导出excel
     *
     * @param request
     */
    @RequestMapping(value = "/exportEvaluationXls")
    public ModelAndView exportXls(HttpServletRequest request, KcEvaluationVo kcEvaluationVo) {
        return exportXls(request, kcEvaluationVo, KcEvaluationVo.class, "评价量表统计");
    }

    /**
     * 导出excel
     *
     * @param request
     */
    @RequestMapping(value = "/exportEvaluationXls2")
    public ModelAndView exportXls2(HttpServletRequest request, KcEvaluationVo2 kcEvaluationVo) {
        return exportXls(request, kcEvaluationVo, KcEvaluationVo2.class, "评价量表统计");
    }



    /**
     * 导出excel
     *
     * @param request
     */
    public ModelAndView exportXls(HttpServletRequest request, KcEvaluationVo object, Class<KcEvaluationVo> clazz, String title) {
        // Step.1 组装查询条件
        QueryWrapper<KcEvaluationVo> queryWrapper = QueryGenerator.initQueryWrapper(object, request.getParameterMap());
        LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();

        // 过滤选中数据
        String selections = request.getParameter("selections");
        if (oConvertUtils.isNotEmpty(selections)) {
            List<String> selectionList = Arrays.asList(selections.split(","));
            queryWrapper.in("id",selectionList);
        }
        // Step.2 获取导出数据
//        List<KcEvaluationVo> exportList = service.selectPageAndKcmc(queryWrapper);
        Page<KcEvaluationVo> page = new Page<>(1, -1);
        IPage<KcEvaluationVo> pageList = loadPageData(object,queryWrapper,page);

        // Step.3 AutoPoi 导出Excel
        ModelAndView mv = new ModelAndView(new JeecgEntityExcelView());
        //此处设置的filename无效 ,前端会重更新设置一下
        mv.addObject(NormalExcelConstants.FILE_NAME, title);
        mv.addObject(NormalExcelConstants.CLASS, clazz);
        //update-begin--Author:liusq  Date:20210126 for：图片导出报错，ImageBasePath未设置--------------------
        ExportParams exportParams=new ExportParams(title + "报表", "导出人:" + sysUser.getRealname(), title);
        exportParams.setImageBasePath(upLoadPath);
        //update-end--Author:liusq  Date:20210126 for：图片导出报错，ImageBasePath未设置----------------------
        mv.addObject(NormalExcelConstants.PARAMS,exportParams);
        mv.addObject(NormalExcelConstants.DATA_LIST, pageList.getRecords());
        return mv;
    }

    /**
     * 导出excel
     *
     * @param request
     */
    public ModelAndView exportXls(HttpServletRequest request, KcEvaluationVo2 object, Class<KcEvaluationVo2> clazz, String title) {
        // Step.1 组装查询条件
        QueryWrapper<KcEvaluationVo2> queryWrapper = QueryGenerator.initQueryWrapper(object, request.getParameterMap());
        LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();

        // 过滤选中数据
        String selections = request.getParameter("selections");
        if (oConvertUtils.isNotEmpty(selections)) {
            List<String> selectionList = Arrays.asList(selections.split(","));
            queryWrapper.in("id",selectionList);
        }
        // Step.2 获取导出数据
//        List<KcEvaluationVo> exportList = service.selectPageAndKcmc(queryWrapper);
        Page<KcEvaluationVo2> page = new Page<>(1, -1);
        IPage<KcEvaluationVo2> pageList = loadPageData2(object,queryWrapper,page);

        // Step.3 AutoPoi 导出Excel
        ModelAndView mv = new ModelAndView(new JeecgEntityExcelView());
        //此处设置的filename无效 ,前端会重更新设置一下
        mv.addObject(NormalExcelConstants.FILE_NAME, title);
        mv.addObject(NormalExcelConstants.CLASS, clazz);
        //update-begin--Author:liusq  Date:20210126 for：图片导出报错，ImageBasePath未设置--------------------
        ExportParams exportParams=new ExportParams(title + "报表", "导出人:" + sysUser.getRealname(), title);
        exportParams.setImageBasePath(upLoadPath);
        //update-end--Author:liusq  Date:20210126 for：图片导出报错，ImageBasePath未设置----------------------
        mv.addObject(NormalExcelConstants.PARAMS,exportParams);
        mv.addObject(NormalExcelConstants.DATA_LIST, pageList.getRecords());
        return mv;
    }

    public static void main(String[] args) {
        Date upDate = DateUtil.parseDateTime("2023-03-13 00:00:00");
        Date startTime = DateUtil.parseDateTime("2023-05-01 00:00:00");
        Date endTime = DateUtil.parseDateTime("2023-07-01 00:00:00");
        long betweenStartDay = DateUtil.between(startTime, upDate, DateUnit.DAY,false);
        long betweenEndDay = DateUtil.between(endTime, upDate, DateUnit.DAY,false);

        if(betweenStartDay >=0 && betweenEndDay <=0) {
            System.out.println("在范围内");
        }

        System.out.println(betweenStartDay);
        System.out.println(betweenEndDay);

    }

}
