package org.jeecg.modules.kc.teachingunitcontent.controller;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.google.common.collect.Maps;
import org.apache.commons.compress.utils.Lists;
import org.apache.commons.lang.StringUtils;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.kc.teachingunitcontent.entity.KcTeachingUnitContentOne;
import org.jeecg.modules.kc.teachingunitcontent.entity.KcTeachingUnitContentThree;
import org.jeecg.modules.kc.teachingunitcontent.entity.KcTeachingUnitContentTwo;
import org.jeecg.modules.kc.teachingunitcontent.service.IKcTeachingUnitContentOneService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecg.modules.kc.teachingunitcontent.service.IKcTeachingUnitContentThreeService;
import org.jeecg.modules.kc.teachingunitcontent.service.IKcTeachingUnitContentTwoService;
import org.jeecg.modules.kc.teachingunitcontent.vo.KcTeachingUnitContentSave;
import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

 /**
 * @Description: 教学单元内容-第一层
 * @Author: jeecg-boot
 * @Date:   2024-05-15
 * @Version: V1.0
 */
@Api(tags="教学单元内容-第一层")
@RestController
@RequestMapping("/teachingunitcontent/kcTeachingUnitContentOne")
@Slf4j
public class KcTeachingUnitContentOneController extends JeecgController<KcTeachingUnitContentOne, IKcTeachingUnitContentOneService> {
	@Autowired
	private IKcTeachingUnitContentOneService kcTeachingUnitContentOneService;

	@Autowired
	private IKcTeachingUnitContentTwoService kcTeachingUnitContentTwoService;

	@Autowired
	private IKcTeachingUnitContentThreeService kcTeachingUnitContentThreeService;

	
	/**
	 * 分页列表查询
	 *
	 * @param kcTeachingUnitContentOne
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "教学单元内容-第一层-分页列表查询")
	@ApiOperation(value="教学单元内容-第一层-分页列表查询", notes="教学单元内容-第一层-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<KcTeachingUnitContentOne>> queryPageList(KcTeachingUnitContentOne kcTeachingUnitContentOne,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<KcTeachingUnitContentOne> queryWrapper = QueryGenerator.initQueryWrapper(kcTeachingUnitContentOne, req.getParameterMap());
		Page<KcTeachingUnitContentOne> page = new Page<>(pageNo, pageSize);
		IPage<KcTeachingUnitContentOne> pageList = kcTeachingUnitContentOneService.page(page, queryWrapper);
		return Result.OK(pageList);
	}


	 /**
	  *
	  * @param kcTeachingUnitContentOne
	  * @param req
	  * @return
	  */
	 //@AutoLog(value = "教学单元内容-第一层-分页列表查询")
	 @ApiOperation(value="教学单元内容-第一层-分页列表查询", notes="教学单元内容-第一层-分页列表查询")
	 @GetMapping(value = "/allList")
	 public Result<List<KcTeachingUnitContentOne>> allList(KcTeachingUnitContentOne kcTeachingUnitContentOne, HttpServletRequest req) {
		 QueryWrapper<KcTeachingUnitContentOne> queryWrapper = QueryGenerator.initQueryWrapper(kcTeachingUnitContentOne, req.getParameterMap());
		 queryWrapper.eq(StringUtils.isNotBlank(kcTeachingUnitContentOne.getTeano()),"create_by",kcTeachingUnitContentOne.getTeano());
		 List<KcTeachingUnitContentOne> list = kcTeachingUnitContentOneService.list(queryWrapper);

		 //转成map
		 Map<String, KcTeachingUnitContentOne> oneMap = Maps.newHashMap();
		 list.forEach(x -> oneMap.put(x.getId(), x));

		 //查询子列表
		 QueryWrapper<KcTeachingUnitContentTwo> twoQW = new QueryWrapper<>();
		 twoQW.lambda().eq(KcTeachingUnitContentTwo::getXqxn, kcTeachingUnitContentOne.getXqxn());
		 twoQW.lambda().eq(KcTeachingUnitContentTwo::getRwbh, kcTeachingUnitContentOne.getRwbh());
		 twoQW.lambda().orderByAsc(KcTeachingUnitContentTwo::getSort);
		 List<KcTeachingUnitContentTwo> twoList = kcTeachingUnitContentTwoService.list(twoQW);
		 Map<String, KcTeachingUnitContentTwo> twoMap = Maps.newHashMap();
		 twoList.forEach(x -> {
			 twoMap.put(x.getId(), x);
			 if(oneMap.containsKey(x.getPid())){
				 KcTeachingUnitContentOne one = oneMap.get(x.getPid());
				 if(one.getChildrenList() == null){
					 one.setChildrenList(Lists.newArrayList());
				 }
				 one.getChildrenList().add(x);
			 }
		 });

		 QueryWrapper<KcTeachingUnitContentThree> threeQW = new QueryWrapper<>();
		 threeQW.lambda().eq(KcTeachingUnitContentThree::getXqxn, kcTeachingUnitContentOne.getXqxn());
		 threeQW.lambda().eq(KcTeachingUnitContentThree::getRwbh, kcTeachingUnitContentOne.getRwbh());
		 threeQW.lambda().orderByAsc(KcTeachingUnitContentThree::getSort);
		 List<KcTeachingUnitContentThree> threeList = kcTeachingUnitContentThreeService.list(threeQW);

		 threeList.forEach(x -> {
			 if(twoMap.containsKey(x.getPid())){
				 KcTeachingUnitContentTwo two = twoMap.get(x.getPid());
				 if(two.getChildrenList() == null){
					 two.setChildrenList(Lists.newArrayList());
				 }
				 two.getChildrenList().add(x);
			 }
		 });

		 return Result.OK(list);
	 }

	 /**
	  *  编辑
	  *
	  * @param teachingUnitContentSave
	  * @return
	  */
	 @AutoLog(value = "教学单元内容-全部-编辑")
	 @ApiOperation(value="教学单元内容-全部-编辑", notes="教学单元内容-全部-编辑")
//	@RequiresPermissions("teachingunitcontent:kc_teaching_unit_content_one:edit")
	 @RequestMapping(value = "/editAll", method = {RequestMethod.PUT,RequestMethod.POST})
	 public Result<String> editAll(@RequestBody KcTeachingUnitContentSave teachingUnitContentSave) {
		 kcTeachingUnitContentOneService.updateAllById(teachingUnitContentSave);
		 return Result.OK("编辑成功!");
	 }

	/**
	 *   添加
	 *
	 * @param kcTeachingUnitContentOne
	 * @return
	 */
	@AutoLog(value = "教学单元内容-第一层-添加")
	@ApiOperation(value="教学单元内容-第一层-添加", notes="教学单元内容-第一层-添加")
//	@RequiresPermissions("teachingunitcontent:kc_teaching_unit_content_one:add")
	@PostMapping(value = "/add")
	public Result<?> add(@RequestBody KcTeachingUnitContentOne kcTeachingUnitContentOne) {
		kcTeachingUnitContentOneService.save(kcTeachingUnitContentOne);
		Result<KcTeachingUnitContentOne> r = Result.OK("添加成功！");
		r.setResult(kcTeachingUnitContentOne);
		return r;
	}
	
	/**
	 *  编辑
	 *
	 * @param kcTeachingUnitContentOne
	 * @return
	 */
	@AutoLog(value = "教学单元内容-第一层-编辑")
	@ApiOperation(value="教学单元内容-第一层-编辑", notes="教学单元内容-第一层-编辑")
//	@RequiresPermissions("teachingunitcontent:kc_teaching_unit_content_one:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody KcTeachingUnitContentOne kcTeachingUnitContentOne) {
		kcTeachingUnitContentOneService.updateById(kcTeachingUnitContentOne);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "教学单元内容-第一层-通过id删除")
	@ApiOperation(value="教学单元内容-第一层-通过id删除", notes="教学单元内容-第一层-通过id删除")
//	@RequiresPermissions("teachingunitcontent:kc_teaching_unit_content_one:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		kcTeachingUnitContentOneService.removeById(id);
		return Result.OK("删除成功!");
	}
//
//	/**
//	 *  批量删除
//	 *
//	 * @param ids
//	 * @return
//	 */
//	@AutoLog(value = "教学单元内容-第一层-批量删除")
//	@ApiOperation(value="教学单元内容-第一层-批量删除", notes="教学单元内容-第一层-批量删除")
//	@RequiresPermissions("teachingunitcontent:kc_teaching_unit_content_one:deleteBatch")
//	@DeleteMapping(value = "/deleteBatch")
//	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
//		this.kcTeachingUnitContentOneService.removeByIds(Arrays.asList(ids.split(",")));
//		return Result.OK("批量删除成功!");
//	}
//
//	/**
//	 * 通过id查询
//	 *
//	 * @param id
//	 * @return
//	 */
//	//@AutoLog(value = "教学单元内容-第一层-通过id查询")
//	@ApiOperation(value="教学单元内容-第一层-通过id查询", notes="教学单元内容-第一层-通过id查询")
//	@GetMapping(value = "/queryById")
//	public Result<KcTeachingUnitContentOne> queryById(@RequestParam(name="id",required=true) String id) {
//		KcTeachingUnitContentOne kcTeachingUnitContentOne = kcTeachingUnitContentOneService.getById(id);
//		if(kcTeachingUnitContentOne==null) {
//			return Result.error("未找到对应数据");
//		}
//		return Result.OK(kcTeachingUnitContentOne);
//	}
//
//    /**
//    * 导出excel
//    *
//    * @param request
//    * @param kcTeachingUnitContentOne
//    */
//    @RequiresPermissions("teachingunitcontent:kc_teaching_unit_content_one:exportXls")
//    @RequestMapping(value = "/exportXls")
//    public ModelAndView exportXls(HttpServletRequest request, KcTeachingUnitContentOne kcTeachingUnitContentOne) {
//        return super.exportXls(request, kcTeachingUnitContentOne, KcTeachingUnitContentOne.class, "教学单元内容-第一层");
//    }
//
//    /**
//      * 通过excel导入数据
//    *
//    * @param request
//    * @param response
//    * @return
//    */
//    @RequiresPermissions("teachingunitcontent:kc_teaching_unit_content_one:importExcel")
//    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
//    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
//        return super.importExcel(request, response, KcTeachingUnitContentOne.class);
//    }


	 @AutoLog(value = "发布教学单元内容")
	 @ApiOperation(value="发布教学单元内容", notes="发布教学单元内容")
	 @RequestMapping(value = "/editJxdyOne", method = {RequestMethod.PUT,RequestMethod.POST})
	 public Result<String> editJxdyOne(@RequestBody KcTeachingUnitContentOne kcTeachingUnitContentOne) {
		 kcTeachingUnitContentOneService.updateById(kcTeachingUnitContentOne);
		 return Result.OK("编辑成功!");
	 }



	 @ApiOperation(value="教学单元内容-第三层-分页列表查询", notes="教学单元内容-第三层-分页列表查询")
	 @GetMapping(value = "/getAllList")
	 public Result<List<KcTeachingUnitContentOne>> getAllList(KcTeachingUnitContentOne kcTeachingUnitContentOne) {
		 List<KcTeachingUnitContentOne> pageList = kcTeachingUnitContentOneService.getAllList(kcTeachingUnitContentOne);
		 return Result.OK(pageList);
	 }
}
