package org.jeecg.modules.kc.teachingunitcontent.controller;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.kc.teachingunitcontent.entity.KcTeachingUnitContentOne;
import org.jeecg.modules.kc.teachingunitcontent.entity.KcTeachingUnitContentTwo;
import org.jeecg.modules.kc.teachingunitcontent.service.IKcTeachingUnitContentTwoService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

 /**
 * @Description: 教学单元内容-第二层
 * @Author: jeecg-boot
 * @Date:   2024-05-15
 * @Version: V1.0
 */
@Api(tags="教学单元内容-第二层")
@RestController
@RequestMapping("/teachingunitcontent/kcTeachingUnitContentTwo")
@Slf4j
public class KcTeachingUnitContentTwoController extends JeecgController<KcTeachingUnitContentTwo, IKcTeachingUnitContentTwoService> {
	@Autowired
	private IKcTeachingUnitContentTwoService kcTeachingUnitContentTwoService;
	
	/**
	 * 分页列表查询
	 *
	 * @param kcTeachingUnitContentTwo
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "教学单元内容-第二层-分页列表查询")
	@ApiOperation(value="教学单元内容-第二层-分页列表查询", notes="教学单元内容-第二层-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<KcTeachingUnitContentTwo>> queryPageList(KcTeachingUnitContentTwo kcTeachingUnitContentTwo,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<KcTeachingUnitContentTwo> queryWrapper = QueryGenerator.initQueryWrapper(kcTeachingUnitContentTwo, req.getParameterMap());
		Page<KcTeachingUnitContentTwo> page = new Page<KcTeachingUnitContentTwo>(pageNo, pageSize);
		IPage<KcTeachingUnitContentTwo> pageList = kcTeachingUnitContentTwoService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param kcTeachingUnitContentTwo
	 * @return
	 */
	@AutoLog(value = "教学单元内容-第二层-添加")
	@ApiOperation(value="教学单元内容-第二层-添加", notes="教学单元内容-第二层-添加")
//	@RequiresPermissions("teachingunitcontent:kc_teaching_unit_content_two:add")
	@PostMapping(value = "/add")
	public Result<?> add(@RequestBody KcTeachingUnitContentTwo kcTeachingUnitContentTwo) {
		kcTeachingUnitContentTwoService.save(kcTeachingUnitContentTwo);
		Result<KcTeachingUnitContentTwo> r = Result.OK("添加成功！");
		r.setResult(kcTeachingUnitContentTwo);
		return r;
	}

	/**
	 *  编辑
	 *
	 * @param kcTeachingUnitContentTwo
	 * @return
	 */
	@AutoLog(value = "教学单元内容-第二层-编辑")
	@ApiOperation(value="教学单元内容-第二层-编辑", notes="教学单元内容-第二层-编辑")
//	@RequiresPermissions("teachingunitcontent:kc_teaching_unit_content_two:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody KcTeachingUnitContentTwo kcTeachingUnitContentTwo) {
		kcTeachingUnitContentTwoService.updateById(kcTeachingUnitContentTwo);
		return Result.OK("编辑成功!");
	}

	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "教学单元内容-第二层-通过id删除")
	@ApiOperation(value="教学单元内容-第二层-通过id删除", notes="教学单元内容-第二层-通过id删除")
//	@RequiresPermissions("teachingunitcontent:kc_teaching_unit_content_two:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		kcTeachingUnitContentTwoService.removeById(id);
		return Result.OK("删除成功!");
	}
//
//	/**
//	 *  批量删除
//	 *
//	 * @param ids
//	 * @return
//	 */
//	@AutoLog(value = "教学单元内容-第二层-批量删除")
//	@ApiOperation(value="教学单元内容-第二层-批量删除", notes="教学单元内容-第二层-批量删除")
//	@RequiresPermissions("teachingunitcontent:kc_teaching_unit_content_two:deleteBatch")
//	@DeleteMapping(value = "/deleteBatch")
//	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
//		this.kcTeachingUnitContentTwoService.removeByIds(Arrays.asList(ids.split(",")));
//		return Result.OK("批量删除成功!");
//	}
//
//	/**
//	 * 通过id查询
//	 *
//	 * @param id
//	 * @return
//	 */
//	//@AutoLog(value = "教学单元内容-第二层-通过id查询")
//	@ApiOperation(value="教学单元内容-第二层-通过id查询", notes="教学单元内容-第二层-通过id查询")
//	@GetMapping(value = "/queryById")
//	public Result<KcTeachingUnitContentTwo> queryById(@RequestParam(name="id",required=true) String id) {
//		KcTeachingUnitContentTwo kcTeachingUnitContentTwo = kcTeachingUnitContentTwoService.getById(id);
//		if(kcTeachingUnitContentTwo==null) {
//			return Result.error("未找到对应数据");
//		}
//		return Result.OK(kcTeachingUnitContentTwo);
//	}
//
//    /**
//    * 导出excel
//    *
//    * @param request
//    * @param kcTeachingUnitContentTwo
//    */
//    @RequiresPermissions("teachingunitcontent:kc_teaching_unit_content_two:exportXls")
//    @RequestMapping(value = "/exportXls")
//    public ModelAndView exportXls(HttpServletRequest request, KcTeachingUnitContentTwo kcTeachingUnitContentTwo) {
//        return super.exportXls(request, kcTeachingUnitContentTwo, KcTeachingUnitContentTwo.class, "教学单元内容-第二层");
//    }
//
//    /**
//      * 通过excel导入数据
//    *
//    * @param request
//    * @param response
//    * @return
//    */
//    @RequiresPermissions("teachingunitcontent:kc_teaching_unit_content_two:importExcel")
//    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
//    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
//        return super.importExcel(request, response, KcTeachingUnitContentTwo.class);
//    }

}
