package org.jeecg.modules.kc.tktj.controller;

import cn.hutool.core.date.DatePattern;
import cn.hutool.core.date.DateUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.beust.jcommander.internal.Sets;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.apache.shiro.SecurityUtils;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.jeecg.common.system.base.controller.JeecgController;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.system.vo.LoginUser;
import org.jeecg.modules.kc.grab.SynchronizationService.tools.ChangeTingKeTongJi;
import org.jeecg.modules.kc.kcXqxnHistory.entity.KcXqxnHistory;
import org.jeecg.modules.kc.kcXqxnHistory.service.IKcXqxnHistoryService;
import org.jeecg.modules.kc.qa.entity.KcEvaluation;
import org.jeecg.modules.kc.qa.service.IKcEvaluationService;
import org.jeecg.modules.kc.tktj.entity.KcKkdw;
import org.jeecg.modules.kc.tktj.entity.KcTingke;
import org.jeecg.modules.kc.tktj.entity.KcTkmx;
import org.jeecg.modules.kc.tktj.service.IKcTingkeService;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.*;

/**
 * @Description: kc_tingke
 * @Author: jeecg-boot
 * @Date:   2023-03-29
 * @Version: V1.0
 */
@Api(tags="kc_tingke")
@RestController
@RequestMapping("/kcTingke/kcTingke")
@Slf4j
public class KcTingkeController extends JeecgController<KcTingke, IKcTingkeService> {
	@Autowired
	private IKcTingkeService kcTingkeService;
	@Autowired
	private IKcEvaluationService kcEvaluationService;

	@Autowired
	private ChangeTingKeTongJi changeTingKeTongJi;
	@Autowired
	private IKcXqxnHistoryService kcXqxnHistoryService;

	 @Value("${jeecg.path.upload}")
	 private String upLoadPath;
	/**
	 * 分页列表查询
	 *
	 * @param kcTingke
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "kc_tingke-分页列表查询")
	@ApiOperation(value="kc_tingke-分页列表查询", notes="kc_tingke-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<KcTingke>> queryPageList(KcTingke kcTingke,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
//		QueryWrapper<KcTingke> queryWrapper = QueryGenerator.initQueryWrapper(kcTingke, req.getParameterMap());
//		queryWrapper.ge(StringUtils.isNotBlank(kcTingke.getStartTime()),"tk.skrq",kcTingke.getStartTime());
//		queryWrapper.le(StringUtils.isNotBlank(kcTingke.getEndTime()),"tk.skrq",kcTingke.getEndTime()+" 23:59:59");
//
//		queryWrapper.eq(StringUtils.isNotBlank(kcTingke.getTksf()),"au.assesscode",kcTingke.getTksf());
//		queryWrapper.eq(StringUtils.isNotBlank(kcTingke.getSzdw()),"tk.tkdw",kcTingke.getSzdw());
//		queryWrapper.eq(StringUtils.isNotBlank(kcTingke.getKkdw()),"au.dwmc",kcTingke.getKkdw());
//		queryWrapper.eq(StringUtils.isNotBlank(kcTingke.getKcxz()),"tk.kcxz",kcTingke.getKcxz());

		Page<KcTingke> page = new Page<KcTingke>(pageNo, pageSize);
		IPage<KcTingke> pageList = kcTingkeService.queryPageList(page, kcTingke);
		return Result.OK(pageList);
	}


	 @ApiOperation(value="kc_tingke-分页列表查询", notes="kc_tingke-分页列表查询")
	 @GetMapping(value = "/indexListPage")
	 public Result<?> indexListPage(KcTingke kcTingke,
												  @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
												  @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
												  HttpServletRequest req) {
		String xnxq = kcTingke.getXnxq();
		if(StringUtils.isNotBlank(xnxq)){
			QueryWrapper<KcXqxnHistory> kcXqxnHistoryQueryWrapper = new QueryWrapper<>();
			kcXqxnHistoryQueryWrapper.eq("title",xnxq);
			kcXqxnHistoryQueryWrapper.last("limit 1");
			KcXqxnHistory kcXqxnHistory =kcXqxnHistoryService.getOne(kcXqxnHistoryQueryWrapper);
			kcTingke.setStartDate(DateUtil.format(kcXqxnHistory.getStartTime(),"yyyy-MM-dd"));
			kcTingke.setEndDate(DateUtil.format(kcXqxnHistory.getEndTime(),"yyyy-MM-dd"));
		}
		QueryWrapper<KcTingke> queryWrapper = QueryGenerator.initQueryWrapper("a",kcTingke, req.getParameterMap());
		queryWrapper.apply(StringUtils.isNotBlank(kcTingke.getSearchInput()),"( a.kcmc like '%"+kcTingke.getSearchInput()+"%' or a.skjs like '%"+kcTingke.getSearchInput()+"%')");
		 queryWrapper.ge(StringUtils.isNotBlank(kcTingke.getStartDate()),"a.tingketime",kcTingke.getStartDate());
		 queryWrapper.le(StringUtils.isNotBlank(kcTingke.getEndDate()),"a.tingketime",kcTingke.getEndDate()+" 23:59:59");
		 queryWrapper.eq(StringUtils.isNotBlank(kcTingke.getKkdw()),"a.kkdw",kcTingke.getKkdw());
		 queryWrapper.eq(StringUtils.isNotBlank(kcTingke.getHh()),"a.hh",kcTingke.getHh());
		 if("0".equals(kcTingke.getPj())){
			 queryWrapper.apply("score is null");
		 }else if("1".equals(kcTingke.getPj())){
			 queryWrapper.apply("score is not null");
		 }
		 queryWrapper.orderByDesc("a.tingketime");
		 Page<KcTingke> page = new Page<KcTingke>(pageNo, pageSize);
		 IPage<Map<String,Object>> pageList = kcTingkeService.indexListPage(page, queryWrapper);
		 return Result.OK(pageList);
	 }
	
	/**
	 *   添加
	 *
	 * @param kcTingke
	 * @return
	 */
	@AutoLog(value = "kc_tingke-添加")
	@ApiOperation(value="kc_tingke-添加", notes="kc_tingke-添加")
	@RequiresPermissions("kcTingke:kc_tingke:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody KcTingke kcTingke) {
		kcTingkeService.save(kcTingke);
		return Result.OK("添加成功！");
	}

	 /**
	  *   添加
	  *
	  * @param kcTingke
	  * @return
	  */
	 @AutoLog(value = "kc_tingke-添加听课记录")
	 @ApiOperation(value="kc_tingke-添加听课记录", notes="kc_tingke-添加听课记录")
	 @PostMapping(value = "/addTingKeLog")
	 public Result<String> addTingKeLog(@RequestBody KcTingke kcTingke) {
		 changeTingKeTongJi.addTingKeData(kcTingke.getUserid(),kcTingke.getKechengbiaoid());
		 return Result.OK("添加成功！");
	 }

	/**
	 *  编辑
	 *
	 * @param kcTingke
	 * @return
	 */
	@AutoLog(value = "kc_tingke-编辑")
	@ApiOperation(value="kc_tingke-编辑", notes="kc_tingke-编辑")
	@RequiresPermissions("kcTingke:kc_tingke:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody KcTingke kcTingke) {
		kcTingkeService.updateById(kcTingke);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "kc_tingke-通过id删除")
	@ApiOperation(value="kc_tingke-通过id删除", notes="kc_tingke-通过id删除")
	@RequiresPermissions("kcTingke:kc_tingke:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		kcTingkeService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "kc_tingke-批量删除")
	@ApiOperation(value="kc_tingke-批量删除", notes="kc_tingke-批量删除")
	@RequiresPermissions("kcTingke:kc_tingke:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.kcTingkeService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "kc_tingke-通过id查询")
	@ApiOperation(value="kc_tingke-通过id查询", notes="kc_tingke-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<KcTingke> queryById(@RequestParam(name="id",required=true) String id) {
		KcTingke kcTingke = kcTingkeService.getById(id);
		if(kcTingke==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(kcTingke);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param kcTingke
    */
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls( KcTingke kcTingke,HttpServletRequest request) {
		String title = "听课人员统计";
//TODO 统计
		System.out.println(request.getParameter("startTime"));
		BeanUtils.copyProperties(kcTingke, request.getParameterMap());
		// Step.1 组装查询条件
		LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();

		// 过滤选中数据
		// Step.2 获取导出数据
		List<KcTingke> exportList = kcTingkeService.selectExportList(kcTingke);

		// Step.3 AutoPoi 导出Excel
		ModelAndView mv = new ModelAndView(new JeecgEntityExcelView());
		//此处设置的filename无效 ,前端会重更新设置一下
		mv.addObject(NormalExcelConstants.FILE_NAME, title);
		mv.addObject(NormalExcelConstants.CLASS, KcTingke.class);
		//update-begin--Author:liusq  Date:20210126 for：图片导出报错，ImageBasePath未设置--------------------
		ExportParams exportParams=new ExportParams(title + "报表", "导出人:" + sysUser.getRealname(), title);
		exportParams.setImageBasePath(upLoadPath);
		//update-end--Author:liusq  Date:20210126 for：图片导出报错，ImageBasePath未设置----------------------
		mv.addObject(NormalExcelConstants.PARAMS,exportParams);
		mv.addObject(NormalExcelConstants.DATA_LIST, exportList);
		return mv;
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("kcTingke:kc_tingke:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, KcTingke.class);
    }


	 @ApiOperation(value="kc_tingke-分页列表查询", notes="kc_tingke-分页列表查询")
	 @GetMapping(value = "/getTkmxlist")
	 public Result<IPage<KcTingke>> getTkmxlist(KcTingke kcTingke,
												  @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
												  @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
												  HttpServletRequest req) {
		 String xnxq = kcTingke.getXnxq();
		 if(StringUtils.isNotBlank(xnxq)){
			 QueryWrapper<KcXqxnHistory> kcXqxnHistoryQueryWrapper = new QueryWrapper<>();
			 kcXqxnHistoryQueryWrapper.eq("title",xnxq);
			 kcXqxnHistoryQueryWrapper.last("limit 1");
			 KcXqxnHistory kcXqxnHistory =kcXqxnHistoryService.getOne(kcXqxnHistoryQueryWrapper);
			 kcTingke.setStartTime(DateUtil.format(kcXqxnHistory.getStartTime(),"yyyy-MM-dd"));
			 kcTingke.setEndTime(DateUtil.format(kcXqxnHistory.getEndTime(),"yyyy-MM-dd"));
		 }
		 QueryWrapper<KcTingke> queryWrapper = QueryGenerator.initQueryWrapper(kcTingke, req.getParameterMap());
		 queryWrapper.ge(StringUtils.isNotBlank(kcTingke.getStartTime()),"tk.tingketime",kcTingke.getStartTime());
		 queryWrapper.le(StringUtils.isNotBlank(kcTingke.getEndTime()),"tk.tingketime",kcTingke.getEndTime()+" 23:59:59");
		 queryWrapper.like(StringUtils.isNotBlank(kcTingke.getJsxm()),"tk.username",kcTingke.getJsxm());
		 queryWrapper.eq(StringUtils.isNotBlank(kcTingke.getSzdw()),"college",kcTingke.getSzdw());
		 queryWrapper.eq(StringUtils.isNotBlank(kcTingke.getTksf()),"sf.assess1",kcTingke.getTksf());
		 queryWrapper.eq(StringUtils.isNotBlank(kcTingke.getKkdw()),"tk.kkdw",kcTingke.getKkdw());
		 queryWrapper.eq(StringUtils.isNotBlank(kcTingke.getKcxz()),"tk.kcxz",kcTingke.getKcxz());
		 if(StringUtils.equals("是",kcTingke.getSzkc())){
			 queryWrapper.eq("kcb.szkc","1");
		 }else if(StringUtils.equals("否",kcTingke.getSzkc())){
			 queryWrapper.apply(" (kcb.szkc = '0' or kcb.szkc is null )");
		 }
//		 AND ( cn LIKE '%jiaoshi%' )
//		 AND c.college = '国际合作与交流处'
//		 AND assesscode = '1101'
//		 queryWrapper.eq(StringUtils.isNotBlank(kcTingke.getTksf()),"assesscode",kcTingke.getTksf());
//		 queryWrapper.eq(StringUtils.isNotBlank(kcTingke.getSzdw()),"tkdw",kcTingke.getSzdw());
//		 queryWrapper.eq(StringUtils.isNotBlank(kcTingke.getKkdw()),"dwmc",kcTingke.getKkdw());
//		 queryWrapper.eq(StringUtils.isNotBlank(kcTingke.getKcxz()),"kcxz",kcTingke.getKcxz());

		 Page<KcTingke> page = new Page<KcTingke>(pageNo, pageSize);
		 IPage<KcTingke> pageList = kcTingkeService.getTkmxlist(page, queryWrapper);
		 return Result.OK(pageList);
	 }


	 @GetMapping(value = "/getKkdwlist")
	 public Result<IPage<KcTingke>> getKkdwlist(KcTingke kcTingke,
												@RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
												@RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
												HttpServletRequest req) {
		 Page<KcTingke> page = new Page<KcTingke>(pageNo, pageSize);
		 if(StringUtils.isNotBlank(kcTingke.getEndTime())){
			 kcTingke.setEndTime(kcTingke.getEndTime()+" 23:59:59");
		 }
		 IPage<KcTingke> pageList = kcTingkeService.getKkdwlist(page, kcTingke);
		 return Result.OK(pageList);
	 }


	 @RequestMapping(value = "/exportKkdwXls")
	 public ModelAndView exportKkdwXls(KcKkdw kcKkdw, HttpServletRequest request) {
		 String title = "开课单位统计";

		 // Step.1 组装查询条件
		 LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();

		 // 过滤选中数据
		 // Step.2 获取导出数据
		 List<KcKkdw> exportList = kcTingkeService.selectKkdwExportList(kcKkdw);

		 // Step.3 AutoPoi 导出Excel
		 ModelAndView mv = new ModelAndView(new JeecgEntityExcelView());
		 //此处设置的filename无效 ,前端会重更新设置一下
		 mv.addObject(NormalExcelConstants.FILE_NAME, title);
		 mv.addObject(NormalExcelConstants.CLASS, KcKkdw.class);
		 //update-begin--Author:liusq  Date:20210126 for：图片导出报错，ImageBasePath未设置--------------------
		 ExportParams exportParams=new ExportParams(title + "报表", "导出人:" + sysUser.getRealname(), title);
		 exportParams.setImageBasePath(upLoadPath);
		 //update-end--Author:liusq  Date:20210126 for：图片导出报错，ImageBasePath未设置----------------------
		 mv.addObject(NormalExcelConstants.PARAMS,exportParams);
		 mv.addObject(NormalExcelConstants.DATA_LIST, exportList);
		 return mv;
	 }


	 /**
	  * 听课周统计 echarts
	  * @param kcTingke
	  * @return
	  */
	 @GetMapping(value = "/getTkztjList")
	 public Result<List<KcTingke>> getTkztjList(KcTingke kcTingke) {
		 List<KcTingke> pageList = kcTingkeService.getTkztjList(kcTingke);
		 return Result.OK(pageList);
	 }

	 /**
	  * 听课覆盖率统计 echarts
	  * @param kcTingke
	  * @return
	  */
	 @GetMapping(value = "/getTkfglList")
	 public Result<List<KcTingke>> getTkfglList(KcTingke kcTingke) {
		 List<KcTingke> pageList = kcTingkeService.getTkfglList(kcTingke);
		 return Result.OK(pageList);
	 }

	 /**
	  * 按UserId和时间查询听课
	  * @param kcTingke
	  * @return
	  */
	 @GetMapping(value = "/findTingKeZuJiBytingketimeAndUserId")
	 public Result<?> findTingKeZuJiBytingketimeAndUserId(KcTingke kcTingke){
		 return Result.OK(service.findTingKeZuJiBytingketimeAndUserId(kcTingke));
	 }


	 @GetMapping(value = "/getIndexTpkztjList")
	 public Result<List<KcTingke>> getIndexTpkztjList(KcTingke kcTingke) {
		 List<KcTingke> pageList = kcTingkeService.getTkztjList(kcTingke);//听课周统计
		 KcEvaluation kcEvaluation = new KcEvaluation();
		 kcEvaluation.setStartTime(kcTingke.getStartTime());
		 kcEvaluation.setEndTime(kcTingke.getEndTime());
		 kcEvaluation.setKkdw(kcTingke.getKkdw());
		 kcEvaluation.setKcxz(kcTingke.getKcxz());
		 List<KcEvaluation> list = kcEvaluationService.getPkztjTjt(kcEvaluation);
		 for(int i=0;i<pageList.size();i++){
			 if(list.size()==0 || list.get(i)==null){
				 pageList.get(i).setPkrc("0");
			 }else{
				 pageList.get(i).setPkrc(list.get(i).getTkrcs());
			 }
		 }
		 return Result.OK(pageList);
	 }


	 @GetMapping(value = "/getIndexTpkfglList")
	 public Result<List<KcTingke>> getIndexTpkfglList(KcTingke kcTingke) {
		 List<KcTingke> pageList = kcTingkeService.getTkfglList(kcTingke);

		 KcEvaluation kcEvaluation = new KcEvaluation();
		 kcEvaluation.setStartTime(kcTingke.getStartTime());
		 kcEvaluation.setEndTime(kcTingke.getEndTime());
		 kcEvaluation.setKcxz(kcTingke.getKcxz());
		 List<KcEvaluation> list = kcEvaluationService.getPkfglTjt(kcEvaluation);
		 for(int i=0;i<pageList.size();i++){

			 if(i<list.size()){
				 pageList.get(i).setPkrc(list.get(i).getLjtkv());
				 pageList.get(i).setLjqxpkrl(list.get(i).getAvgtkv());
			 }else{
				 pageList.get(i).setPkrc("0");
				 pageList.get(i).setLjqxpkrl("0");
			 }
		 }
		 return Result.OK(pageList);
	 }



	 @GetMapping(value = "/getHtindexTkmxlist")
	 public Result<List<KcTingke>> getHtindexTkmxlist(KcTingke kcTingke) {

		 List<KcTingke> pageList = kcTingkeService.getHtindexTkmxlist(kcTingke);
		 return Result.OK(pageList);
	 }
	 @RequestMapping(value = "/exportTkmxXls")
	 public ModelAndView exportTkmxXls(KcTkmx kcTkmx, HttpServletRequest request) {
		 String title = "听课明细";
//TODO 统计2
		 // Step.1 组装查询条件
		 LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();

		 String xnxq = kcTkmx.getXnxq();

		 if(StringUtils.isNotBlank(xnxq)){
			 QueryWrapper<KcXqxnHistory> kcXqxnHistoryQueryWrapper = new QueryWrapper<>();
			 kcXqxnHistoryQueryWrapper.eq("title",xnxq);
			 kcXqxnHistoryQueryWrapper.last("limit 1");
			 KcXqxnHistory kcXqxnHistory =kcXqxnHistoryService.getOne(kcXqxnHistoryQueryWrapper);
			 kcTkmx.setStartTime(DateUtil.format(kcXqxnHistory.getStartTime(),"yyyy-MM-dd"));
			 kcTkmx.setEndTime(DateUtil.format(kcXqxnHistory.getEndTime(),"yyyy-MM-dd"));
		 }

		 // 过滤选中数据
		 // Step.2 获取导出数据
		 List<KcTkmx> exportList = kcTingkeService.selectTkmxExportList(kcTkmx);

		 // Step.3 AutoPoi 导出Excel
		 ModelAndView mv = new ModelAndView(new JeecgEntityExcelView());
		 //此处设置的filename无效 ,前端会重更新设置一下
		 mv.addObject(NormalExcelConstants.FILE_NAME, title);
		 mv.addObject(NormalExcelConstants.CLASS, KcTkmx.class);
		 //update-begin--Author:liusq  Date:20210126 for：图片导出报错，ImageBasePath未设置--------------------
		 ExportParams exportParams=new ExportParams(title + "报表", "导出人:" + sysUser.getRealname(), title);
		 exportParams.setImageBasePath(upLoadPath);
		 //update-end--Author:liusq  Date:20210126 for：图片导出报错，ImageBasePath未设置----------------------
		 mv.addObject(NormalExcelConstants.PARAMS,exportParams);
		 mv.addObject(NormalExcelConstants.DATA_LIST, exportList);
		 return mv;
	 }



	 @GetMapping(value = "/getSftk")
	 public Result<List<KcTingke>> getSftk(KcTingke kcTingke) {
		 QueryWrapper<KcTingke> queryWrapper = new QueryWrapper<>();
		 queryWrapper.eq("kechengbiaoid",kcTingke.getKechengbiaoid());
		 queryWrapper.eq("userid",kcTingke.getUserid());
		 List<KcTingke> list = kcTingkeService.getSftk(queryWrapper);
		 return Result.OK(list);
	 }

	 /**
	  * 分页列表查询
	  *
	  * @param kcTingke
	  * @param pageNo
	  * @param pageSize
	  * @param req
	  * @return
	  */
	 //@AutoLog(value = "调查问卷-回答主表-分页列表查询")
	 @ApiOperation(value="调查问卷-回答主表-分页列表查询", notes="调查问卷-回答主表-分页列表查询")
	 @GetMapping(value = "/keTangList")
	 public Result<IPage<?>> keTangList(KcTingke kcTingke,
												   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
												   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
												   HttpServletRequest req) {
		 QueryWrapper<KcTingke> queryWrapper = QueryGenerator.initQueryWrapper("a",kcTingke, req.getParameterMap());
		 if(org.apache.commons.lang.StringUtils.isNotBlank(kcTingke.getXnxq())){
			 KcXqxnHistory common = changeTingKeTongJi.getXqConfig(kcTingke.getXnxq());
			 Date startSjDate = common.getStartTime();
			 Date endSjDate = common.getEndTime();
			 String startSj = DateUtil.format(startSjDate, DatePattern.NORM_DATETIME_FORMAT);
			 String endSj = DateUtil.format(endSjDate,DatePattern.NORM_DATETIME_FORMAT);
			 String xqxn = common.getTitle();
//			 if(org.apache.commons.lang.StringUtils.equals(xqxn,kcTingke.getXnxq())){
			 queryWrapper.apply("a.tingketime >= STR_TO_DATE('"+ startSj +"', '%Y-%m-%d') ");
			 queryWrapper.apply("a.tingketime <= STR_TO_DATE('"+ endSj +"', '%Y-%m-%d') ");
//			 }
		 }

		 queryWrapper.isNotNull("a.kechengbiaoid");
		 queryWrapper.isNotNull("kb.id");
		 Page<KcTingke> page = new Page<>(pageNo, pageSize);
		 IPage<?> pageList = kcTingkeService.keTangList(page, queryWrapper);
		 return Result.OK(pageList);
	 }

	 @ApiOperation(value="获取当前用户的听课要求及实际听课数量", notes="获取当前用户的听课要求及实际听课数量")
	 @GetMapping(value = "/getUserTingkeInfo")
	 public Result<KcTingke> getUserTingkeInfo(KcTingke kcTingke,
												  HttpServletRequest req) {
		 KcXqxnHistory common = changeTingKeTongJi.getXqConfig(null);
		 KcTingke kcTingkePar = new KcTingke();
		 if(common != null) {
			 //清洗数据核心
			 Date startSjDate = common.getStartTime();
			 Date endSjDate = common.getEndTime();
			 String xnxq = common.getTitle();
			 String startSj = DateUtil.format(startSjDate, DatePattern.NORM_DATETIME_FORMAT);
			 String endSj = DateUtil.format(endSjDate, DatePattern.NORM_DATETIME_FORMAT);
			 QueryWrapper<KcTingke> evaQw = new QueryWrapper<>();
			 LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
			 if("admin".equals(sysUser.getUsername())){
				 sysUser.setUsername("2016900057");
			 }
			 kcTingke.setXnxq(xnxq);
			 kcTingke.setUserid(sysUser.getUsername());
			 kcTingke.setStartTime(startSj.substring(0,10));
			 kcTingke.setEndTime(endSj.substring(0,10));
			 List<KcTingke> countTjList = kcTingkeService.getUserTingkeInfo(kcTingke);
			 if(countTjList!=null&&countTjList.size()>0){
				 kcTingkePar = countTjList.get(0);
			 }

		 }
		 return Result.OK(kcTingkePar);
	 }


}
