package org.jeecg.modules.kc.tktj.entity;

import java.io.Serializable;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;
import org.jeecgframework.poi.excel.annotation.Excel;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * @Description: kc_tingke
 * @Author: jeecg-boot
 * @Date:   2023-03-29
 * @Version: V1.0
 */
@Data
@TableName("kc_tingke")
@Accessors(chain = true)
@EqualsAndHashCode(callSuper = false)
@ApiModel(value="kc_tingke对象", description="kc_tingke")
public class KcTingke implements Serializable {
    private static final long serialVersionUID = 1L;

	/**id*/
	@TableId(type = IdType.ASSIGN_ID)
    @ApiModelProperty(value = "id")
    private java.lang.String id;

    /**用户id*/
    @Excel(name = "职工号", width = 15)
    @ApiModelProperty(value = "职工号")
    private java.lang.String userid;

    /**用户名*/
    @Excel(name = "姓名", width = 15)
    @ApiModelProperty(value = "姓名")
    private java.lang.String username;

    /**usertksf1*/
    @Excel(name = "听课人所在单位", width = 15)
    @ApiModelProperty(value = "听课人所在单位")
    private java.lang.String tkdw;

    /**听课身份*/
    @Excel(name = "听课身份", width = 15)
    @ApiModelProperty(value = "听课身份")
    @TableField(exist = false)
    private java.lang.String tksf1;

    @Excel(name = "听课要求", width = 15)
    @TableField(exist = false)
    private java.lang.String tkyq;

    @TableField(exist = false)
    @Excel(name = "实际听课数", width = 15)
    private java.lang.String sjtksl;

    @TableField(exist = false)
    @Excel(name = "其中马列教研室课程数", width = 15)
    private java.lang.String mltksl;


    private java.lang.Integer usertkyq;
    private java.lang.String usertksf1;


	/**听课时间*/
    private java.lang.String tingketime;
	/**检查时间*/
    private java.lang.String jianchatime;
	/**课程表id*/
    private java.lang.String kechengbiaoid;
	/**用户单位名称*/
    private java.lang.String userdwmc;
	/**usertksf2*/
    private java.lang.String usertksf2;
	/**usertksfcode*/
    private java.lang.String usertksfcode;
	/**创建人*/
    //@ApiModelProperty(value = "创建人")
    //private java.lang.String createBy;
	/**创建时间*/
//	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd")
//    @DateTimeFormat(pattern="yyyy-MM-dd")
//    @ApiModelProperty(value = "创建时间")
//    private java.util.Date createTime;
//	/**修改人*/
//    @ApiModelProperty(value = "修改人")
//    private java.lang.String updateBy;
//	/**修改时间*/
//	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd")
//    @DateTimeFormat(pattern="yyyy-MM-dd")
//    @ApiModelProperty(value = "修改时间")
//    private java.util.Date updateTime;
//	/**所属部门编码*/
//    @ApiModelProperty(value = "所属部门编码")
//    private java.lang.String sysOrgCode;

    @TableField(exist = false)
    private java.lang.String startTime;
    @TableField(exist = false)
    private java.lang.String endTime;

    @TableField(exist = false)
    private java.lang.String college;
    @TableField(exist = false)
    private java.lang.String tksf;
    @TableField(exist = false)
    private java.lang.String kkdw;
    @TableField(exist = false)
    private java.lang.String kcmc;
    @TableField(exist = false)
    private java.lang.String kcxz;
    @TableField(exist = false)
    private java.lang.String skjs;
    @TableField(exist = false)
    private java.lang.String zc;
    @TableField(exist = false)
    private java.lang.String jc;

    @TableField(exist = false)
    private java.lang.String kkdwid;
    @TableField(exist = false)
    private java.lang.String kkkts;
    @TableField(exist = false)
    private java.lang.String tkkts;
    @TableField(exist = false)
    private java.lang.String tkrcs;
    @TableField(exist = false)
    private java.lang.String pkrcs;
    @TableField(exist = false)
    private java.lang.String pkkts;
    @TableField(exist = false)
    private java.lang.String bdwpkrcs;
    @TableField(exist = false)
    private java.lang.String bdwtkrcs;
    @TableField(exist = false)
    private java.lang.String bdwtks;
    @TableField(exist = false)
    private java.lang.String bdwpks;
    @TableField(exist = false)
    private java.lang.String kssl;
    @TableField(exist = false)
    private java.lang.String assesscode;
    @TableField(exist = false)
    private java.lang.String dwjc;
    @TableField(exist = false)
    private java.lang.String ljtkv;
    @TableField(exist = false)
    private java.lang.String avgtkv;
    @TableField(exist = false)
    private java.lang.String jrtkv;
    @TableField(exist = false)
    private java.lang.String jravgtkv;
    @TableField(exist = false)
    private java.lang.String xsid;
    @TableField(exist = false)
    private java.lang.String skrq;
    @TableField(exist = false)
    private java.lang.String szdw;
    @TableField(exist = false)
    private java.lang.String jsxm;

    @TableField(exist = false)
    private java.lang.String pkrc;
    @TableField(exist = false)
    private java.lang.String ljqxpkrl;

    @TableField(exist = false)
    private java.lang.Integer pageKs;
    @TableField(exist = false)
    private java.lang.Integer pageJs;
    @TableField(exist = false)
    private java.lang.String type;

    /**
     * 课程名和教程明
     */
    @TableField(exist = false)
    private java.lang.String searchInput;

    /**
     * 是否评价，0否，1是，空全部
     */
    @TableField(exist = false)
    private java.lang.String pj;


    /**
     * 分页
     */
    @TableField(exist = false)
    private Integer pageSize;

    /**
     * 开始时间搜索
     */
    @TableField(exist = false)
    private String startDate;

    /**
     * 结束时间搜索
     */
    @TableField(exist = false)
    private String endDate;

    /**
     * 节次
     */
    @TableField(exist = false)
    private String hh;

    @TableField(exist = false)
    private String score;
    @TableField(exist = false)
    private String ketangbiaoid;

    @TableField(exist = false)
    private String evaluationver;
    @TableField(exist = false)
    private String tkrq;
    @TableField(exist = false)
    private String shijian;
    @TableField(exist = false)
    private String hq;
    @TableField(exist = false)
    private String mq;
    @TableField(exist = false)
    private String WEEK;
    @TableField(exist = false)
    private String evaluationid;
    @TableField(exist = false)
    private String source;
    @TableField(exist = false)
    private String suibiId;
    @TableField(exist = false)
    private String suibiNotes;
    @TableField(exist = false)
    private String skdd;
    @TableField(exist = false)
    private String bh;
    @TableField(exist = false)
    private String kcbh;

    @TableField(exist = false)
    private String pkNum;

    @TableField(exist = false)
    private String xnxq;
    @TableField(exist = false)
    private String szkc;


//    private java.lang.String tingketime;
}
