package org.jeecg.modules.kc.wjxDjxx.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.apache.shiro.SecurityUtils;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.base.controller.JeecgController;
import org.jeecg.common.system.vo.LoginUser;
import org.jeecg.common.util.text.StringUtils;
import org.jeecg.modules.kc.config.entity.KcExportConfigTpkwcqkjzglx;
import org.jeecg.modules.kc.config.service.IKcExportConfigTpkwcqkjzglxService;
import org.jeecg.modules.kc.kcSysConfig.entity.KcSysConfig;
import org.jeecg.modules.kc.kcSysConfig.service.IKcSysConfigService;
import org.jeecg.modules.kc.wjxDjxx.entity.*;
import org.jeecg.modules.kc.wjxDjxx.service.IWjxDjxxService;
import org.jeecg.modules.system.service.impl.SysBaseApiImpl;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.http.HttpServletRequest;
import java.util.Date;
import java.util.List;

/**
* @Description: 答卷信息
* @Author: jeecg-boot
* @Date:   2024-05-07
* @Version: V1.0
*/
@Api(tags="答卷信息")
@RestController
@RequestMapping("/wjxDjxx")
@Slf4j
public class WjxDjxxController extends JeecgController<WjxDjxx, IWjxDjxxService> {
    @Autowired
    private IWjxDjxxService wjxDjxxService;

    @Value("${jeecg.path.upload}")
    private String upLoadPath;


    @Value(value="${jeecg.uploadType}")
    private String uploadType;

    @Autowired
    private SysBaseApiImpl sysBaseApi;
    @Autowired
    private IKcExportConfigTpkwcqkjzglxService kcExportConfigTpkwcqkjzglxService;
    @Autowired
    private IKcSysConfigService kcSysConfigService;

    @ApiOperation(value="答卷提交", notes="答卷提交")
    @PostMapping(value = "/djtj")
    public Result<String> djtj(@RequestBody List<WjxDjxxTmlbPage> list) {
        String res = "提交成功！";
        if(list.size()>0) {
            res = wjxDjxxService.djtj(list);
        }

        return Result.OK(res);
    }

    @ApiOperation(value="选项信息主表ID查询", notes="选项信息-通主表ID查询")
    @GetMapping(value = "/queryByMainId")
    public Result<WjxDjxx> queryByMainId(@RequestParam(name="id",required=true) String id) {
        WjxDjxx wjxDjxx = wjxDjxxService.queryByMainId(id);
        return Result.OK(wjxDjxx);
    }

    @ApiOperation(value="选项信息主表ID查询", notes="选项信息-通主表ID查询")
    @GetMapping(value = "/djjglist")
    public Result<IPage<WjxDjxx>> djjglist(WjxDjxx wjxDjxx,
                                                @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
                                                @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
                                                HttpServletRequest req) {
        Page<WjxDjxx> pageList = wjxDjxxService.findDjjgsPage(wjxDjxx,new Page<>(pageNo, pageSize));
        return Result.OK(pageList);
    }





    @ApiOperation(value="教学大纲-分页列表查询", notes="教学大纲-分页列表查询")
    @GetMapping(value = "/sysList")
    public Result<IPage<StudentCyglSys>> sysList(StudentCyglSys studentCyglSys,
                                                 @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
                                                 @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
                                                 HttpServletRequest req) {
        LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
        //-------------获取当前登陆人是否是管理员角色，如果不是都按照教务秘书处理---------------------------
        List<String> roleList = sysBaseApi.getRolesByUsername(sysUser.getUsername());
        String adminRole = "1";//0 admin  1教务秘书
        for(String role :roleList){
            if(org.apache.commons.lang.StringUtils.equals("admin",role)){
                adminRole = "0";
                break;
            }
        }
        QueryWrapper<StudentCyglSys> queryWrapper = new QueryWrapper<StudentCyglSys>();
        if(org.apache.commons.lang.StringUtils.equals("1",adminRole)){
            QueryWrapper<KcExportConfigTpkwcqkjzglx> queryWrapperCon = new QueryWrapper<KcExportConfigTpkwcqkjzglx>();
            queryWrapperCon.eq("gh",sysUser.getUsername());
            queryWrapperCon.orderByDesc("create_time");
            queryWrapperCon.last("limit 1");
            KcExportConfigTpkwcqkjzglx kcExportConfigTpkwcqkjzglx = kcExportConfigTpkwcqkjzglxService.getOne(queryWrapperCon);
            queryWrapper.eq("kkdw",kcExportConfigTpkwcqkjzglx.getDwmc());
        }

        if(com.baomidou.mybatisplus.core.toolkit.StringUtils.isEmpty(studentCyglSys.getXqxn())){
            KcSysConfig kcSysConfig = kcSysConfigService.getById("1");
            queryWrapper.eq("xqxn",kcSysConfig.getFlag1());
        }else{
            queryWrapper.eq("xqxn",studentCyglSys.getXqxn());
        }
        queryWrapper.like(com.baomidou.mybatisplus.core.toolkit.StringUtils.isNotEmpty(studentCyglSys.getKkdw()),"kkdw",studentCyglSys.getKkdw());
        queryWrapper.like(com.baomidou.mybatisplus.core.toolkit.StringUtils.isNotEmpty(studentCyglSys.getKcmc()),"kcmc",studentCyglSys.getKcmc());
        queryWrapper.like(com.baomidou.mybatisplus.core.toolkit.StringUtils.isNotEmpty(studentCyglSys.getKcbh()),"kcbh",studentCyglSys.getKcbh());
        queryWrapper.like(com.baomidou.mybatisplus.core.toolkit.StringUtils.isNotEmpty(studentCyglSys.getSkjs()),"skjs",studentCyglSys.getSkjs());


        Page<StudentCyglSys> page = new Page<StudentCyglSys>(pageNo, pageSize);
        IPage<StudentCyglSys> pageList = wjxDjxxService.sysList(page, queryWrapper,studentCyglSys);
        return Result.OK(pageList);
    }


    @RequestMapping(value = "/exportSysXls")
    public ModelAndView exportSysXls(HttpServletRequest request, StudentCyglSys studentCyglSys) {
        String title = "学生作业管理";
        // Step.1 组装查询条件
        QueryWrapper<StudentCyglSys> queryWrapper = new QueryWrapper<>();
        LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();


        //-------------获取当前登陆人是否是管理员角色，如果不是都按照教务秘书处理---------------------------
        List<String> roleList = sysBaseApi.getRolesByUsername(sysUser.getUsername());
        String adminRole = "1";//0 admin  1教务秘书
        for(String role :roleList){
            if(org.apache.commons.lang.StringUtils.equals("admin",role)){
                adminRole = "0";
                break;
            }
        }
        if(org.apache.commons.lang.StringUtils.equals("1",adminRole)){
            QueryWrapper<KcExportConfigTpkwcqkjzglx> queryWrapperCon = new QueryWrapper<KcExportConfigTpkwcqkjzglx>();
            queryWrapperCon.eq("gh",sysUser.getUsername());
            queryWrapperCon.orderByDesc("create_time");
            queryWrapperCon.last("limit 1");
            KcExportConfigTpkwcqkjzglx kcExportConfigTpkwcqkjzglx = kcExportConfigTpkwcqkjzglxService.getOne(queryWrapperCon);
            queryWrapper.eq("kkdw",kcExportConfigTpkwcqkjzglx.getDwmc());
        }

        if(com.baomidou.mybatisplus.core.toolkit.StringUtils.isEmpty(studentCyglSys.getXqxn())){
            KcSysConfig kcSysConfig = kcSysConfigService.getById("1");
            queryWrapper.eq("xqxn",kcSysConfig.getFlag1());
        }else{
            queryWrapper.eq("xqxn",studentCyglSys.getXqxn());
        }
        queryWrapper.like(com.baomidou.mybatisplus.core.toolkit.StringUtils.isNotEmpty(studentCyglSys.getKkdw()),"kkdw",studentCyglSys.getKkdw());
        queryWrapper.like(com.baomidou.mybatisplus.core.toolkit.StringUtils.isNotEmpty(studentCyglSys.getKcmc()),"kcmc",studentCyglSys.getKcmc());
        queryWrapper.like(com.baomidou.mybatisplus.core.toolkit.StringUtils.isNotEmpty(studentCyglSys.getKcbh()),"kcbh",studentCyglSys.getKcbh());
        queryWrapper.like(com.baomidou.mybatisplus.core.toolkit.StringUtils.isNotEmpty(studentCyglSys.getSkjs()),"skjs",studentCyglSys.getSkjs());

        // Step.2 获取导出数据
        List<StudentCyglSys> exportList = service.exportSysXls(queryWrapper,studentCyglSys);

        // Step.3 AutoPoi 导出Excel
        ModelAndView mv = new ModelAndView(new JeecgEntityExcelView());
        //此处设置的filename无效 ,前端会重更新设置一下
        mv.addObject(NormalExcelConstants.FILE_NAME, title);
        mv.addObject(NormalExcelConstants.CLASS, StudentCyglSys.class);
        //update-begin--Author:liusq  Date:20210126 for：图片导出报错，ImageBasePath未设置--------------------
        ExportParams exportParams=new ExportParams(title + "报表", "导出人:" + sysUser.getRealname(), title);
        exportParams.setImageBasePath(upLoadPath);
        //update-end--Author:liusq  Date:20210126 for：图片导出报错，ImageBasePath未设置----------------------
        mv.addObject(NormalExcelConstants.PARAMS,exportParams);
        mv.addObject(NormalExcelConstants.DATA_LIST, exportList);
        return mv;
    }



    @ApiOperation(value="教学大纲-分页列表查询", notes="教学大纲-分页列表查询")
    @GetMapping(value = "/sysWjglList")
    public Result<IPage<StudentWjglSys>> sysList(StudentWjglSys studentWjglSys,
                                                 @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
                                                 @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
                                                 HttpServletRequest req) {
        LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
        //-------------获取当前登陆人是否是管理员角色，如果不是都按照教务秘书处理---------------------------
        List<String> roleList = sysBaseApi.getRolesByUsername(sysUser.getUsername());
        String adminRole = "1";//0 admin  1教务秘书
        for(String role :roleList){
            if(org.apache.commons.lang.StringUtils.equals("admin",role)){
                adminRole = "0";
                break;
            }
        }
        QueryWrapper<StudentWjglSys> queryWrapper = new QueryWrapper<StudentWjglSys>();
        if(org.apache.commons.lang.StringUtils.equals("1",adminRole)){
            QueryWrapper<KcExportConfigTpkwcqkjzglx> queryWrapperCon = new QueryWrapper<KcExportConfigTpkwcqkjzglx>();
            queryWrapperCon.eq("gh",sysUser.getUsername());
            queryWrapperCon.orderByDesc("create_time");
            queryWrapperCon.last("limit 1");
            KcExportConfigTpkwcqkjzglx kcExportConfigTpkwcqkjzglx = kcExportConfigTpkwcqkjzglxService.getOne(queryWrapperCon);
            queryWrapper.eq("kkdw",kcExportConfigTpkwcqkjzglx.getDwmc());
        }

        if(com.baomidou.mybatisplus.core.toolkit.StringUtils.isEmpty(studentWjglSys.getXqxn())){
            KcSysConfig kcSysConfig = kcSysConfigService.getById("1");
            queryWrapper.eq("xqxn",kcSysConfig.getFlag1());
        }else{
            queryWrapper.eq("xqxn",studentWjglSys.getXqxn());
        }
        queryWrapper.like(com.baomidou.mybatisplus.core.toolkit.StringUtils.isNotEmpty(studentWjglSys.getKkdw()),"kkdw",studentWjglSys.getKkdw());
        queryWrapper.like(com.baomidou.mybatisplus.core.toolkit.StringUtils.isNotEmpty(studentWjglSys.getKcmc()),"kcmc",studentWjglSys.getKcmc());
        queryWrapper.like(com.baomidou.mybatisplus.core.toolkit.StringUtils.isNotEmpty(studentWjglSys.getKcbh()),"kcbh",studentWjglSys.getKcbh());
        queryWrapper.like(com.baomidou.mybatisplus.core.toolkit.StringUtils.isNotEmpty(studentWjglSys.getSkjs()),"skjs",studentWjglSys.getSkjs());


        Page<StudentWjglSys> page = new Page<StudentWjglSys>(pageNo, pageSize);
        IPage<StudentWjglSys> pageList = wjxDjxxService.sysWjglList(page, queryWrapper,studentWjglSys);
        return Result.OK(pageList);
    }


    @RequestMapping(value = "/exportWjglSysXls")
    public ModelAndView exportWjglSysXls(HttpServletRequest request, StudentWjglSys studentWjglSys) {
        String title = "学生作业管理";
        // Step.1 组装查询条件
        QueryWrapper<StudentWjglSys> queryWrapper = new QueryWrapper<>();
        LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();


        //-------------获取当前登陆人是否是管理员角色，如果不是都按照教务秘书处理---------------------------
        List<String> roleList = sysBaseApi.getRolesByUsername(sysUser.getUsername());
        String adminRole = "1";//0 admin  1教务秘书
        for(String role :roleList){
            if(org.apache.commons.lang.StringUtils.equals("admin",role)){
                adminRole = "0";
                break;
            }
        }
        if(org.apache.commons.lang.StringUtils.equals("1",adminRole)){
            QueryWrapper<KcExportConfigTpkwcqkjzglx> queryWrapperCon = new QueryWrapper<KcExportConfigTpkwcqkjzglx>();
            queryWrapperCon.eq("gh",sysUser.getUsername());
            queryWrapperCon.orderByDesc("create_time");
            queryWrapperCon.last("limit 1");
            KcExportConfigTpkwcqkjzglx kcExportConfigTpkwcqkjzglx = kcExportConfigTpkwcqkjzglxService.getOne(queryWrapperCon);
            queryWrapper.eq("kkdw",kcExportConfigTpkwcqkjzglx.getDwmc());
        }

        if(com.baomidou.mybatisplus.core.toolkit.StringUtils.isEmpty(studentWjglSys.getXqxn())){
            KcSysConfig kcSysConfig = kcSysConfigService.getById("1");
            queryWrapper.eq("xqxn",kcSysConfig.getFlag1());
        }else{
            queryWrapper.eq("xqxn",studentWjglSys.getXqxn());
        }
        queryWrapper.like(com.baomidou.mybatisplus.core.toolkit.StringUtils.isNotEmpty(studentWjglSys.getKkdw()),"kkdw",studentWjglSys.getKkdw());
        queryWrapper.like(com.baomidou.mybatisplus.core.toolkit.StringUtils.isNotEmpty(studentWjglSys.getKcmc()),"kcmc",studentWjglSys.getKcmc());
        queryWrapper.like(com.baomidou.mybatisplus.core.toolkit.StringUtils.isNotEmpty(studentWjglSys.getKcbh()),"kcbh",studentWjglSys.getKcbh());
        queryWrapper.like(com.baomidou.mybatisplus.core.toolkit.StringUtils.isNotEmpty(studentWjglSys.getSkjs()),"skjs",studentWjglSys.getSkjs());

        // Step.2 获取导出数据
        List<StudentWjglSys> exportList = service.exportWjglSysXls(queryWrapper,studentWjglSys);

        // Step.3 AutoPoi 导出Excel
        ModelAndView mv = new ModelAndView(new JeecgEntityExcelView());
        //此处设置的filename无效 ,前端会重更新设置一下
        mv.addObject(NormalExcelConstants.FILE_NAME, title);
        mv.addObject(NormalExcelConstants.CLASS, StudentWjglSys.class);
        //update-begin--Author:liusq  Date:20210126 for：图片导出报错，ImageBasePath未设置--------------------
        ExportParams exportParams=new ExportParams(title + "报表", "导出人:" + sysUser.getRealname(), title);
        exportParams.setImageBasePath(upLoadPath);
        //update-end--Author:liusq  Date:20210126 for：图片导出报错，ImageBasePath未设置----------------------
        mv.addObject(NormalExcelConstants.PARAMS,exportParams);
        mv.addObject(NormalExcelConstants.DATA_LIST, exportList);
        return mv;
    }


    @ApiOperation(value="查询主观题带评分内容", notes="查询主观题带评分内容")
    @GetMapping(value = "/queryZgtdpf")
    public Result<WjxDjxx> queryZgtdpf(WjxDjxx wjxDjxx) {
        QueryWrapper<WjxDjxx> wjxDjxxQueryWrapper = new QueryWrapper<>();
        wjxDjxxQueryWrapper.eq("vid",wjxDjxx.getVid());
        wjxDjxxQueryWrapper.eq(StringUtils.isNotEmpty(wjxDjxx.getJid()),"jid",wjxDjxx.getJid());
        wjxDjxxQueryWrapper.eq("sfxysdpy","1");
        wjxDjxxQueryWrapper.last("limit 1");
        wjxDjxx = wjxDjxxService.getOne(wjxDjxxQueryWrapper);
        if(wjxDjxx!=null){
            WjxDjxx wjxDjxx2 = wjxDjxxService.querySdpfById(wjxDjxx.getId());
            wjxDjxx = wjxDjxx2;
        }
        return Result.OK(wjxDjxx);
    }


    @ApiOperation(value="手动评分", notes="手动评分")
    @PostMapping(value = "/editSdpf")
    public Result<String> editSdpf(@RequestBody List<WjxDjxxTmxx> list) {
        String res = "提交成功！";
        for(WjxDjxxTmxx par:list){
            String djid = par.getDjid();
            String djtmid = par.getDjtmid();

            WjxDjxxTmxx wjxDjxxTmxx = new WjxDjxxTmxx();
            wjxDjxxTmxx.setId(djtmid);
            wjxDjxxTmxx.setItemScore(par.getItemScore());
            wjxDjxxService.updateDjxxTmxx(wjxDjxxTmxx);

            wjxDjxxTmxx = wjxDjxxService.getByDjxxId(djtmid);

            WjxDjxxTmxx wjxDjxxTmxx2 = wjxDjxxService.getSumScore(wjxDjxxTmxx);

            WjxDjxx wjxDjxx = new WjxDjxx();
            wjxDjxx.setId(djid);
            wjxDjxx.setSfxysdpy("0");
            wjxDjxx.setScore(wjxDjxxTmxx2.getItemScore());
            wjxDjxxService.editSdpf(wjxDjxx);

        }

        return Result.OK(res);
    }


    @ApiOperation(value="修复答卷结果，因时间问题导致的数据", notes="修复答卷结果，因时间问题导致的数据")
    @PostMapping(value = "/updateDjjg")
    public Result<String> updateDjjg(@RequestBody WjxDjxx wjxDjxx) {
        String res = "提交成功！";
        res = wjxDjxxService.updateDjjg(wjxDjxx);

        return Result.OK(res);
    }

    @ApiOperation(value="修复答卷结果，因时间问题导致的数据", notes="修复答卷结果，因时间问题导致的数据")
    @PostMapping(value = "/getDjjg")
    public Result<String> getDjjg(@RequestBody WjxDjxx wjxDjxx) {
        String res = "提交成功！";
        res = wjxDjxxService.getDjjg(wjxDjxx);

        return Result.OK(res);
    }

    @PostMapping(value = "/upZbcs")
    public Result<Integer> upZbcs(@RequestBody WjxDjxx wjxDjxx) {
        return Result.OK(wjxDjxxService.upZbcs(wjxDjxx));
    }

}
