package org.jeecg.modules.kc.wjxDjxx.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.jeecg.common.aspect.annotation.Dict;
import org.jeecgframework.poi.excel.annotation.Excel;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;
import java.util.List;

/**
 * @Description: 学生答卷信息
 * @Author: jeecg-boot
 * @Date:   2024-05-7
 * @Version: V1.0
 */
@Data
@ApiModel(value="wjx_djxx对象", description="学生答卷信息")
public class WjxDjxx {
	private static final long serialVersionUID = 1L;
	@TableId(type = IdType.ASSIGN_ID)
	@ApiModelProperty(value = "id")
	private java.lang.String id;
	@ApiModelProperty(value = "创建人")
	private String createBy;
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm:ss")
	@DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
	@ApiModelProperty(value = "创建时间")
	private Date createTime;
	@ApiModelProperty(value = "修改人")
	private String updateBy;
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm:ss")
	@DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
	@ApiModelProperty(value = "修改时间")
	private Date updateTime;
	@ApiModelProperty(value = "vid")
    private String vid;

	@ApiModelProperty(value = "名称")
	@TableField(exist = false)
	private String title;






	@Excel(name = "序号", width = 15)
	@TableField(exist = false)
	private String xuhao;
	@Excel(name = "学号", width = 15)
	@ApiModelProperty(value = "学号")
	private String userId;
	@Excel(name = "学生", width = 15)
	@ApiModelProperty(value = "学生")
	private String userName;
	@Excel(name = "得分", width = 15)
	@ApiModelProperty(value = "得分")
	private double score;
	@Excel(name = "总分", width = 15)
	@ApiModelProperty(value = "总分")
	private double totalScore;
	@Excel(name = "答卷时间", width = 15,format = "yyyy-MM-dd HH:mm:ss")
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm:ss")
	@DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
	@ApiModelProperty(value = "答卷时间")
	private Date openTime;
	@Excel(name = "交卷时间", width = 15,format = "yyyy-MM-dd HH:mm:ss")
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm:ss")
	@DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
	@ApiModelProperty(value = "交卷时间")
	private Date commitTime;
	@Excel(name = "答卷用时", width = 15)
	@TableField(exist = false)
	@ApiModelProperty(value = "答卷用时")
	private String answerSfm;

	private String sfxysdpy;//是否需要手动批阅

	@Dict(dicCode = "sfsckhcl")
	private String sfsckhcl;//是否上传考核材料（0否  1是）
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm")
	@DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
	private Date sfsckhclTime;//上传考核材料时间

	@ApiModelProperty(value = "学期学年")
	@TableField(exist = false)
	private String xqxn;
	@ApiModelProperty(value = "提交内容")
	private String submitData;
	@ApiModelProperty(value = "答卷编号")
	private String jid;
	@ApiModelProperty(value = "问卷作答用时")
	private int answerSeconds;
	@ApiModelProperty(value = "问卷类型")
	@TableField(exist = false)
	private String atype;
	@ApiModelProperty(value = "问卷描述")
	@TableField(exist = false)
	private java.lang.String content;

	@TableField(exist = false)
	private List<WjxDjxxTmxx> wjxDjxxTmxxList;


	@ApiModelProperty(value = "任务编号")
	@TableField(exist = false)
	private String rwbh;
	@ApiModelProperty(value = "课程名称")
	@TableField(exist = false)
	private String kcmc;
	@ApiModelProperty(value = "开始时间")
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm:ss")
	@DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
	@TableField(exist = false)
	private Date startTime;
	@ApiModelProperty(value = "结束时间")
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm:ss")
	@DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
	@TableField(exist = false)
	private Date endTime;

	@ApiModelProperty(value = "是否完成")
	@TableField(exist = false)
	private String isFinished;

	@ApiModelProperty(value = "作弊次数（单次考试作弊行为发生总次数）")
	private int zbcs;
}
