package org.jeecg.modules.kc.wjxDjxx.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.jeecg.modules.kc.wjxWjxxTmlb.entity.WjxWjxxTmxx;
import org.jeecg.modules.kc.wjxWjxxTmlb.vo.ScaleItemRows;
import org.jeecg.modules.kc.wjxWjxxTmlb.vo.ScaleItems;
import org.jeecgframework.poi.excel.annotation.Excel;
import org.springframework.format.annotation.DateTimeFormat;

import java.io.Serializable;
import java.util.Date;
import java.util.List;

/**
 * @Description: 答卷选项信息
 * @Author: jeecg-boot
 * @Date:   2024-04-26
 * @Version: V1.0
 */
@ApiModel(value="wjx_djxx_tmxx对象", description="答卷选项信息")
@Data
@TableName("wjx_djxx_tmxx")
public class WjxDjxxTmxx implements Serializable {
    private static final long serialVersionUID = 1L;
	@TableId(type = IdType.ASSIGN_ID)
    @ApiModelProperty(value = "id")
    private String id;
    @ApiModelProperty(value = "创建人")
    private String createBy;
    @JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "创建时间")
    private Date createTime;
    @ApiModelProperty(value = "修改人")
    private String updateBy;
    @JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "修改时间")
    private Date updateTime;
    @ApiModelProperty(value = "题目编号")
    private Integer wjIndex;
    @ApiModelProperty(value = "题目标题")
    private String wjTitle;
    @ApiModelProperty(value = "题目选项")
    private Integer itemIndex;
    @ApiModelProperty(value = "题目文本答案")
    private String answerText;
    @ApiModelProperty(value = "选项分值")
    private Double itemScore;
    @ApiModelProperty(value = "vid")
    private String vid;
    @ApiModelProperty(value = "答卷编号")
    private String jid;
    @ApiModelProperty(value = "答卷人ID")
    private String userId;
    private String picPath;
    private String fwqPath;

    @ApiModelProperty(value = "题目类型")
    @TableField(exist = false)
    private String wjType;
    @ApiModelProperty(value = "问题分值")
    @TableField(exist = false)
    private Double wjScore;
    @ApiModelProperty(value = "选中选项")
    @TableField(exist = false)
    private String itemSelected;

    @TableField(exist = false)
    private List<WjxWjxxTmxx> wjxWjxxTmxxList;

    @TableField(exist = false)
    private List<ScaleItems> items;

    @TableField(exist = false)
    private List<ScaleItemRows> itemRows;

    @TableField(exist = false)
    private String tktda;
    @TableField(exist = false)
    private String djid;
    @TableField(exist = false)
    private String djtmid;
    @TableField(exist = false)
    private String wjSubtype;
    @TableField(exist = false)
    private String xxtitle;
}
