package org.jeecg.modules.kc.wjxDjxx.service.impl;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.core.incrementer.DefaultIdentifierGenerator;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.apache.commons.compress.utils.Lists;
import org.apache.commons.lang3.StringUtils;
import org.apache.shiro.SecurityUtils;
import org.jeecg.common.system.vo.LoginUser;
import org.jeecg.common.util.DateUtils;
import org.jeecg.modules.kc.wjxDjxx.entity.*;
import org.jeecg.modules.kc.wjxDjxx.mapper.WjxDjxxMapper;
import org.jeecg.modules.kc.wjxDjxx.service.IWjxDjxxService;
import org.jeecg.modules.kc.wjxWjxx.entity.WjxWjxx;
import org.jeecg.modules.kc.wjxWjxx.mapper.WjxWjxxMapper;
import org.jeecg.modules.kc.wjxWjxx.utils.WjxUtil;
import org.jeecg.modules.kc.wjxWjxxTmlb.entity.WjxWjxxTmlb;
import org.jeecg.modules.kc.wjxWjxxTmlb.entity.WjxWjxxTmxx;
import org.jeecg.modules.kc.wjxWjxxTmlb.mapper.WjxWjxxTmlbMapper;
import org.jeecg.modules.kc.wjxWjxxTmlb.mapper.WjxWjxxTmxxMapper;
import org.jeecg.modules.kc.wjxWjxxTmlb.vo.ScaleItemRows;
import org.jeecg.modules.kc.wjxWjxxTmlb.vo.ScaleItems;
import org.jeecg.modules.kc.zyDbtx.entity.ZyDbtx;
import org.jeecg.modules.kc.zyDbtx.service.IZyDbtxService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.time.temporal.ChronoUnit;
import java.util.*;
import java.util.concurrent.TimeUnit;


/**
 * @Description: 答卷信息
 * @Author: jeecg-boot
 * @Date: 2024-05-07
 * @Version: V1.0
 */
@Service
public class WjxDjxxServiceImpl extends ServiceImpl<WjxDjxxMapper, WjxDjxx> implements IWjxDjxxService {

    @Autowired
    private WjxUtil wjxUtil;
    @Autowired
    private WjxWjxxTmxxMapper wjxWjxxTmxxMapper;
    @Autowired
    private WjxWjxxTmlbMapper wjxWjxxTmlbMapper;
    @Autowired
    private WjxWjxxMapper wjxWjxxMapper;

    @Autowired
    private IZyDbtxService zyDbtxService;

    /**
     * 提交问卷，并查询答卷
     *
     * @param list
     */
    public String djtj(List<WjxDjxxTmlbPage> list) {
        LoginUser user = (LoginUser) SecurityUtils.getSubject().getPrincipal();
        String vid = list.get(0).getVid();
        if (vid == null || vid.equals("")) {
            String mainId = list.get(0).getMainId();
            vid = baseMapper.findVid(mainId);
        }
        if (vid == null || vid.equals("")) {
            return "此试卷错误，无法提交！";
        }
        Date date = new Date();
        Date openTime = list.get(0).getOpenTime();
        if (openTime == null) {
            Calendar c = Calendar.getInstance();
            c.add(Calendar.MINUTE, -2);
            openTime = c.getTime();
        }
        WjxDjxx wds = new WjxDjxx();
        wds.setVid(vid);
        wds.setUserId(user.getUsername());
        wds.setUserName(user.getRealname());
        wds.setOpenTime(openTime);
        wds.setCommitTime(date);
        wds.setCreateBy(user.getUsername());
        wds.setCreateTime(date);
        StringBuffer submitDataSb = new StringBuffer();
        for (WjxDjxxTmlbPage wjxDjxxTmlbPage : list) {
            Integer WjIndex = wjxDjxxTmlbPage.getWjIndex();
            Integer wjType = wjxDjxxTmlbPage.getWjType();
            Integer wjSubtype = wjxDjxxTmlbPage.getWjSubtype();
            String itemSelected = "";
            if (wjType == 3 || wjType == 4) {
                itemSelected = wjxDjxxTmlbPage.getItemSelected().replaceAll(",", "|").trim();
                if (itemSelected == null || itemSelected.equals("null") || itemSelected.equals("")) {
                    itemSelected = "-3";
                }
            }
            if (wjType == 5) {
                itemSelected = wjxDjxxTmlbPage.getWjAnswer();
                if (itemSelected == null || itemSelected.equals("null") || itemSelected.equals("")) {
                    itemSelected = "(跳过)";
                }
                if (wjSubtype != null) {
                    if (wjSubtype == 5) {
                        itemSelected = "(跳过)";
                    }
                }
            }
            if (wjType == 8) {
                itemSelected = "-3";
            }

            if (wjType == 7) {
                //量表题
                itemSelected = wjxDjxxTmlbPage.getItemSelected();
                if (itemSelected == null || itemSelected.equals("null") || itemSelected.equals("")) {
                    itemSelected = "-3";
                }
            }

            submitDataSb.append(WjIndex);
            submitDataSb.append("$");
            submitDataSb.append(itemSelected);
            submitDataSb.append("}");
        }
        String submitData = submitDataSb.toString();
        if (StringUtils.isNotEmpty(submitData)) {
            submitData = submitData.substring(0, submitData.length() - 1);
        }
        wds.setSubmitData(submitData);
        baseMapper.deleteDj(wds);
        this.save(wds);

        Map<String, Object> map = new HashMap<>();
        map.put("vid", Integer.valueOf(vid));
        Long djys = ChronoUnit.SECONDS.between(wds.getOpenTime().toInstant(), wds.getCommitTime().toInstant());
        if (djys < 3) {
            djys = 10L;
        }
        System.out.println("--------------------------------------------------");
        System.out.println("---------------djys--" + djys + "---------------------------");
        System.out.println("--------------------------------------------------");
        map.put("inputcosttime", djys);
        map.put("submitdata", submitData);
        map.put("sojumpparm", user.getUsername());//自定义链接参数，用来透传用户ID
        //调用接口,提交
        String result = wjxUtil.openapi(map, "1001001");
        String jidRes = "";
        if (!result.equals("")) {
            JSONObject jsonResult = JSONObject.parseObject(result);
            if (jsonResult.getBoolean("result")) {
                JSONObject dataJson = jsonResult.getJSONObject("data");
                String vidRes = dataJson.getString("vid");
                jidRes = dataJson.getString("jid");
                String sojumpparmRes = dataJson.getString("sojumpparm");
                baseMapper.updateJid(sojumpparmRes, vidRes, jidRes);
                //调用接口，答卷查询
                Map<String, Object> selMap = new HashMap<>();
                selMap.put("vid", Integer.valueOf(vid));
                selMap.put("jid", Long.valueOf(jidRes));
                //调用接口,查询答卷结果
                String answerStr = wjxUtil.openapi(selMap, "1001002");
                if (!answerStr.equals("")) {
                    JSONObject ansJsonResult = JSONObject.parseObject(answerStr);
                    if (ansJsonResult.getBoolean("result")) {
                        JSONObject ansDataJson = ansJsonResult.getJSONObject("data");
                        String answerVid = ansDataJson.getString("vid");
                        JSONObject answerJsonArray = ansDataJson.getJSONObject("answers");
                        for (String key1 : answerJsonArray.keySet()) {
                            JSONObject answer = answerJsonArray.getJSONObject(key1);
                            String jidAns = answer.getString("jid");
                            Integer answerSeconds = answer.getInteger("answer_seconds");
                            Double score = answer.getDouble("score");
                            Double totalScore = answer.getDouble("total_score");
                            WjxDjxx wjxDjxx = new WjxDjxx();
                            wjxDjxx.setVid(answerVid);
                            wjxDjxx.setJid(jidAns);
                            wjxDjxx.setAnswerSeconds(answerSeconds);
                            wjxDjxx.setScore(score);
                            wjxDjxx.setTotalScore(totalScore);
                            //删除选项信息
                            baseMapper.deleteDjItem(wjxDjxx);
                            //处理选项
                            JSONObject answerItemJson = answer.getJSONObject("answer_items");
                            if (answerItemJson != null) {
                                for (String key2 : answerItemJson.keySet()) {
                                    JSONObject answerItem = answerItemJson.getJSONObject(key2);
                                    WjxDjxxTmxx wjxDjxxTmxx = new WjxDjxxTmxx();
                                    wjxDjxxTmxx.setVid(answerVid);
                                    wjxDjxxTmxx.setJid(jidAns);
                                    wjxDjxxTmxx.setUserId(user.getUsername());
                                    wjxDjxxTmxx.setCreateBy(user.getUsername());
                                    wjxDjxxTmxx.setCreateTime(new Date());

                                    if (answerItem.get("q_index") != null) {
                                        Integer wjIndex = answerItem.getInteger("q_index");
                                        wjxDjxxTmxx.setWjIndex(wjIndex);
                                    }
                                    if (answerItem.get("title") != null) {
                                        String wjTitle = answerItem.getString("title");
                                        wjxDjxxTmxx.setWjTitle(wjTitle);
                                    }

                                    if (answerItem.get("item_value") != null) {
                                        Double itemScore = answerItem.getDouble("item_value");
                                        wjxDjxxTmxx.setItemScore(itemScore);
                                    }
                                    if (answerItem.get("answer_text") != null) {
                                        String answerText = answerItem.getString("answer_text");
                                        wjxDjxxTmxx.setAnswerText(answerText);
                                    }
                                    if (answerItem.get("item_index") != null) {
                                        JSONArray itemIndex = answerItem.getJSONArray("item_index");

                                        QueryWrapper<WjxWjxx> wjxWjxxQueryWrapper = new QueryWrapper<>();
                                        wjxWjxxQueryWrapper.eq("vid", vid);
                                        wjxWjxxQueryWrapper.last("limit 1");
                                        WjxWjxx wjxxPar = wjxWjxxMapper.selectOne(wjxWjxxQueryWrapper);


                                        if (itemIndex.size() > 0) {
                                            for (Object index : itemIndex) {
                                                Integer ti = (Integer) index;


                                                wjxDjxxTmxx.setItemIndex(ti);
                                                String id = new DefaultIdentifierGenerator().nextId(new WjxDjxxTmxx()).toString();
                                                wjxDjxxTmxx.setId(id);

                                                try {
                                                    QueryWrapper<WjxWjxxTmlb> wjxWjxxTmlbQueryWrapper = new QueryWrapper<>();
                                                    wjxWjxxTmlbQueryWrapper.eq("main_id", wjxxPar.getId());
                                                    wjxWjxxTmlbQueryWrapper.eq("wj_index", wjxDjxxTmxx.getWjIndex());
                                                    wjxWjxxTmlbQueryWrapper.last("limit 1");
                                                    WjxWjxxTmlb tmlb = wjxWjxxTmlbMapper.selectOne(wjxWjxxTmlbQueryWrapper);
                                                    wjxDjxxTmxx.setPicPath(tmlb.getPicPath());
                                                } catch (Exception e) {
                                                    e.printStackTrace();
                                                }
                                                baseMapper.addDjTmxx(wjxDjxxTmxx);
                                            }
                                        } else {
                                            String id = new DefaultIdentifierGenerator().nextId(new WjxDjxxTmxx()).toString();

                                            try {
                                                QueryWrapper<WjxWjxxTmlb> wjxWjxxTmlbQueryWrapper = new QueryWrapper<>();
                                                wjxWjxxTmlbQueryWrapper.eq("main_id", wjxxPar.getId());
                                                wjxWjxxTmlbQueryWrapper.eq("wj_index", wjxDjxxTmxx.getWjIndex());
                                                wjxWjxxTmlbQueryWrapper.last("limit 1");
                                                WjxWjxxTmlb tmlb = wjxWjxxTmlbMapper.selectOne(wjxWjxxTmlbQueryWrapper);
                                                wjxDjxxTmxx.setPicPath(tmlb.getPicPath());
                                            } catch (Exception e) {
                                                e.printStackTrace();
                                            }
                                            wjxDjxxTmxx.setId(id);
                                            ;
                                            baseMapper.addDjTmxx(wjxDjxxTmxx);
                                        }
                                    } else {
                                        String id = new DefaultIdentifierGenerator().nextId(new WjxDjxxTmxx()).toString();

                                        try {
                                            QueryWrapper<WjxWjxx> wjxWjxxQueryWrapper = new QueryWrapper<>();
                                            wjxWjxxQueryWrapper.eq("vid", vid);
                                            wjxWjxxQueryWrapper.last("limit 1");
                                            WjxWjxx wjxxPar = wjxWjxxMapper.selectOne(wjxWjxxQueryWrapper);
                                            QueryWrapper<WjxWjxxTmlb> wjxWjxxTmlbQueryWrapper = new QueryWrapper<>();
                                            wjxWjxxTmlbQueryWrapper.eq("main_id", wjxxPar.getId());
                                            wjxWjxxTmlbQueryWrapper.eq("wj_index", wjxDjxxTmxx.getWjIndex());
                                            wjxWjxxTmlbQueryWrapper.last("limit 1");
                                            WjxWjxxTmlb tmlb = wjxWjxxTmlbMapper.selectOne(wjxWjxxTmlbQueryWrapper);
                                            wjxDjxxTmxx.setPicPath(tmlb.getPicPath());
                                        } catch (Exception e) {
                                            e.printStackTrace();
                                        }
                                        wjxDjxxTmxx.setId(id);
                                        ;
                                        baseMapper.addDjTmxx(wjxDjxxTmxx);
                                    }
                                }
                            }
                            //修改答卷信息
                            baseMapper.updateAnswer(wjxDjxx);
                        }
                    } else {
                        baseMapper.updateErrMsg(user.getUsername(), vid, ansJsonResult.getString("errormsg"));
                        return ansJsonResult.getString("errormsg");
                    }
                }
            } else {
                baseMapper.updateErrMsg(user.getUsername(), vid, jsonResult.getString("errormsg"));

                return jsonResult.getString("errormsg");
            }
        }


        String sfxgdjscore = "0";//是否修改答卷分数
        if (StringUtils.isNotBlank(jidRes)) {
            for (WjxDjxxTmlbPage wjxDjxxTmlbPage : list) {
                Integer WjIndex = wjxDjxxTmlbPage.getWjIndex();
                Integer wjType = wjxDjxxTmlbPage.getWjType();
                Integer wjSubtype = wjxDjxxTmlbPage.getWjSubtype();
                if (wjType == 8) {
                    sfxgdjscore = "1";
                    String id = new DefaultIdentifierGenerator().nextId(new WjxDjxxTmxx()).toString();
                    WjxDjxxTmxx wjxDjxxTmxx = new WjxDjxxTmxx();
                    wjxDjxxTmxx.setVid(vid);
                    wjxDjxxTmxx.setJid(jidRes);
                    wjxDjxxTmxx.setUserId(user.getUsername());
                    wjxDjxxTmxx.setCreateBy(user.getUsername());
                    wjxDjxxTmxx.setCreateTime(new Date());
                    wjxDjxxTmxx.setId(id);
                    wjxDjxxTmxx.setWjTitle(wjxDjxxTmlbPage.getWjTitle());
                    wjxDjxxTmxx.setWjIndex(WjIndex);
                    wjxDjxxTmxx.setAnswerText(wjxDjxxTmlbPage.getWjAnswer());
//                    wjxDjxxTmxx.setItemScore(wjxDjxxTmlbPage.getWjScore());
                    wjxDjxxTmxx.setPicPath(wjxDjxxTmlbPage.getPicPath());
                    baseMapper.addDjTmxx(wjxDjxxTmxx);
                } else if (wjType == 5 && wjSubtype != null && wjSubtype == 5) {
                    sfxgdjscore = "1";
                    String id = new DefaultIdentifierGenerator().nextId(new WjxDjxxTmxx()).toString();
                    WjxDjxxTmxx wjxDjxxTmxx = new WjxDjxxTmxx();
                    wjxDjxxTmxx.setVid(vid);
                    wjxDjxxTmxx.setJid(jidRes);
                    wjxDjxxTmxx.setUserId(user.getUsername());
                    wjxDjxxTmxx.setCreateBy(user.getUsername());
                    wjxDjxxTmxx.setCreateTime(new Date());
                    wjxDjxxTmxx.setId(id);
                    wjxDjxxTmxx.setWjTitle(wjxDjxxTmlbPage.getWjTitle());
                    wjxDjxxTmxx.setWjIndex(WjIndex);
                    wjxDjxxTmxx.setAnswerText(wjxDjxxTmlbPage.getWjAnswer());
//                    wjxDjxxTmxx.setItemScore(wjxDjxxTmlbPage.getWjScore());
                    wjxDjxxTmxx.setPicPath(wjxDjxxTmlbPage.getPicPath());
                    baseMapper.addDjTmxx(wjxDjxxTmxx);
                }
            }
        }

        //修改答卷信息的总分
        if (StringUtils.equals(sfxgdjscore, "1")) {
            try {
                WjxDjxx wjxDjxx = new WjxDjxx();
                wjxDjxx.setVid(vid);
                wjxDjxx.setJid(jidRes);
                wjxDjxx.setTotalScore(20);
                wjxDjxx.setSfxysdpy("1");
                baseMapper.updateTotalScore(wjxDjxx);
            } catch (Exception e) {
                e.printStackTrace();
            }
        }


        //修改问卷状态

        QueryWrapper<WjxWjxx> wjxWjxxQueryWrapper = new QueryWrapper<>();
        wjxWjxxQueryWrapper.eq("vid", vid);
        wjxWjxxQueryWrapper.last("limit 1");
        WjxWjxx wjxWjxx = wjxWjxxMapper.selectOne(wjxWjxxQueryWrapper);
        int xkrs = Integer.parseInt(wjxWjxx.getXkrs());

        QueryWrapper<WjxDjxx> djxxQueryWrapper = new QueryWrapper<>();
        djxxQueryWrapper.eq("vid", vid);
        List<WjxDjxx> listNum = baseMapper.selectList(djxxQueryWrapper);
        int djsl = listNum.size();
        System.out.println(xkrs + "------------------------" + djsl);
        if (xkrs == djsl) {
            wjxWjxx.setQpublish("2");
            wjxWjxxMapper.updateById(wjxWjxx);
        }
        String type = "";
        String content = "";
        if (StringUtils.equals("6", wjxWjxx.getAtype())) {
            type = "6";
            content = user.getRealname() + "学生提交了[" + wjxWjxx.getKcmc() + "]课程“" + wjxWjxx.getTitle() + "”测验，该测验完成时间为：" + DateUtils.formatDate(wjxWjxx.getStartTime(), "yyyy-MM-dd HH:mm") + " ~ " + DateUtils.formatDate(wjxWjxx.getEndTime(), "yyyy-MM-dd HH:mm") + "，请及时查看。学生提交时间：" + DateUtils.formatDate(new Date(), "yyyy-MM-dd HH:mm:ss");

        } else {
            type = "7";
            content = user.getRealname() + "学生提交了[" + wjxWjxx.getKcmc() + "]课程“" + wjxWjxx.getTitle() + "”问卷，该问卷完成时间为：" + DateUtils.formatDate(wjxWjxx.getStartTime(), "yyyy-MM-dd HH:mm") + " ~ " + DateUtils.formatDate(wjxWjxx.getEndTime(), "yyyy-MM-dd HH:mm") + "，请及时查看。学生提交时间：" + DateUtils.formatDate(new Date(), "yyyy-MM-dd HH:mm:ss");
        }
        //作业代办提醒
        ZyDbtx zyDbtx = new ZyDbtx();
        zyDbtx.setCreateBy(wjxWjxx.getCreateBy());
        zyDbtx.setType(type);//0发布作业 1评分 2测验 3问卷 4讨论 5学生提交作业  6学生提交测验  7学生提交问卷
        zyDbtx.setMainId(wjxWjxx.getId());
        zyDbtx.setRwbh(wjxWjxx.getRwbh());
        zyDbtx.setContent(content);
        zyDbtx.setFlag("0");
        zyDbtx.setFbr(wjxWjxx.getCreateBy());
        zyDbtxService.save(zyDbtx);


        UpdateWrapper<ZyDbtx> zyDbtxQx = new UpdateWrapper<>();
        zyDbtxQx.set("flag", "1");
        zyDbtxQx.eq("main_id", wjxWjxx.getId());
        zyDbtxQx.eq("create_by", user.getUsername());
        zyDbtxQx.eq("type", "2");
        zyDbtxService.update(zyDbtxQx);


        try {
            if (StringUtils.isNotBlank(jidRes)) {
                jsscore(jidRes);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }


        return "提交成功！";
    }

    /**
     * 获取未进行答卷查询操作的数据，如数据未提交问卷操作则先提交问卷，再查询答卷
     */
    public void doDjSelect() {
        List<WjxDjxx> list = baseMapper.findUnSelect();
        for (int i = 0; i < list.size(); i++) {
            WjxDjxx wjxDjxx = list.get(i);
            String jid = wjxDjxx.getJid();
            String vid = wjxDjxx.getVid();
            String userId = wjxDjxx.getUserId();
            if (jid == null || jid.equals("")) {
                Map<String, Object> map = new HashMap<>();
                map.put("vid", Integer.valueOf(wjxDjxx.getVid()));
                map.put("inputcosttime", ChronoUnit.SECONDS.between(wjxDjxx.getOpenTime().toInstant(), wjxDjxx.getCommitTime().toInstant()));
                map.put("submitdata", wjxDjxx.getSubmitData());
                map.put("sojumpparm", wjxDjxx.getUserId());//自定义链接参数，用来透传用户ID
                //调用接口,提交
                String result = wjxUtil.openapi(map, "1001001");
                if (!result.equals("")) {
                    JSONObject jsonResult = JSONObject.parseObject(result);
                    if (jsonResult.getBoolean("result")) {
                        JSONObject dataJson = jsonResult.getJSONObject("data");
                        String vidRes = dataJson.getString("vid");
                        jid = dataJson.getString("jid");
                        String sojumpparmRes = dataJson.getString("sojumpparm");
                        baseMapper.updateJid(sojumpparmRes, vidRes, jid);
                        wjxDjxx.setJid(jid);
                    } else {
                        baseMapper.updateErrMsg(wjxDjxx.getUserId(), wjxDjxx.getVid(), jsonResult.getString("errormsg"));
                        continue;
                    }
                }
            }
            //调用接口，答卷查询
            Map<String, Object> selMap = new HashMap<>();
            selMap.put("vid", Integer.valueOf(vid));
            selMap.put("jid", Long.valueOf(jid));
            //调用接口,提交
            String answerStr = wjxUtil.openapi(selMap, "1001002");
            if (!answerStr.equals("")) {
                JSONObject ansJsonResult = JSONObject.parseObject(answerStr);
                if (ansJsonResult.getBoolean("result")) {
                    JSONObject ansDataJson = ansJsonResult.getJSONObject("data");
                    String answerVid = ansDataJson.getString("vid");
                    JSONObject answerJsonArray = ansDataJson.getJSONObject("answers");
                    for (String key1 : answerJsonArray.keySet()) {
                        JSONObject answer = answerJsonArray.getJSONObject(key1);
                        String jidAns = answer.getString("jid");
                        Integer answerSeconds = answer.getInteger("answer_seconds");
                        Double score = answer.getDouble("score");
                        Double totalScore = answer.getDouble("total_score");
                        WjxDjxx wjxDjxx2 = new WjxDjxx();
                        wjxDjxx2.setVid(answerVid);
                        wjxDjxx2.setJid(jidAns);
                        wjxDjxx2.setAnswerSeconds(answerSeconds);
                        wjxDjxx2.setScore(score);
                        wjxDjxx2.setTotalScore(totalScore);
                        //删除选项信息
                        baseMapper.deleteDjItem(wjxDjxx2);
                        //处理选项
                        JSONObject answerItemJson = answer.getJSONObject("answer_items");
                        if (answerItemJson != null) {
                            for (String key2 : answerItemJson.keySet()) {
                                JSONObject answerItem = answerItemJson.getJSONObject(key2);
                                Integer wjIndex = answerItem.getInteger("q_index");
                                String wjTitle = answerItem.getString("title");
                                JSONArray itemIndex = answerItem.getJSONArray("item_index");
                                Double itemScore = answerItem.getDouble("item_value");
                                String answerText = answerItem.getString("answer_text");
                                WjxDjxxTmxx wjxDjxxTmxx = new WjxDjxxTmxx();
                                wjxDjxxTmxx.setVid(answerVid);
                                wjxDjxxTmxx.setJid(jidAns);
                                wjxDjxxTmxx.setUserId(userId);
                                wjxDjxxTmxx.setCreateBy(userId);
                                wjxDjxxTmxx.setCreateTime(new Date());
                                wjxDjxxTmxx.setWjIndex(wjIndex);
                                wjxDjxxTmxx.setWjTitle(wjTitle);
                                wjxDjxxTmxx.setItemScore(itemScore);
                                wjxDjxxTmxx.setAnswerText(answerText);
                                for (Object index : itemIndex) {
                                    Integer ti = (Integer) index;
                                    wjxDjxxTmxx.setItemIndex(ti);
                                    String id = new DefaultIdentifierGenerator().nextId(new WjxDjxxTmxx()).toString();
                                    wjxDjxxTmxx.setId(id);
                                    baseMapper.addDjTmxx(wjxDjxxTmxx);
                                }
                            }
                        }
                        //修改答卷信息
                        baseMapper.updateAnswer(wjxDjxx2);
                    }
                } else {
                    baseMapper.updateErrMsg(wjxDjxx.getUserId(), wjxDjxx.getVid(), ansJsonResult.getString("errormsg"));
                    continue;
                }
            }
        }
    }

    @Override
    public WjxDjxx queryByMainId(String id) {
        LoginUser user = (LoginUser) SecurityUtils.getSubject().getPrincipal();
        WjxDjxx djxx = baseMapper.findDjxx(id, user.getUsername());
        if (djxx != null) {
            djxx.setAnswerSfm(convertSecondsToHMS(djxx.getAnswerSeconds()));
            List<WjxDjxxTmxx> list = baseMapper.findDjtmxx(djxx.getVid(), djxx.getJid());
            List<WjxDjxxTmxx> resultList = Lists.newArrayList();
            for (int i = 0; i < list.size(); i++) {
                boolean searchBefore = false;
                WjxDjxxTmxx wjxDjxxTmxx = list.get(i);
                if(i == 0 || !(list.get(i).getId()).equals(list.get(i-1).getId())){
                    resultList.add(wjxDjxxTmxx);
                }else{
                    searchBefore = true;
                }
                List<WjxWjxxTmxx> list2 = wjxWjxxTmxxMapper.selectByMainId(wjxDjxxTmxx.getId());
                //处理量表（矩阵）题
                List<ScaleItems> items = Lists.newArrayList();
                List<ScaleItemRows> itemRows = Lists.newArrayList();
                for (int j = 0; j < list2.size(); j++) {
                    WjxWjxxTmxx WjxWjxxTmxx = list2.get(j);
                    if ("items".equals(WjxWjxxTmxx.getScaleSign())) {
                        ScaleItems scaleItem = new ScaleItems();
                        scaleItem.setItemScore(WjxWjxxTmxx.getScaleItemsItemScore());
                        scaleItem.setItemTitle(WjxWjxxTmxx.getScaleItemsItemTitle());
                        items.add(scaleItem);
                    }
                    if ("item_rows".equals(WjxWjxxTmxx.getScaleSign())) {
                        ScaleItemRows scaleItemRow = new ScaleItemRows();
                        scaleItemRow.setQIndex(WjxWjxxTmxx.getScaleItemrowsQIndex());
                        scaleItemRow.setItemIndex(WjxWjxxTmxx.getScaleItemrowsItemIndex());
                        scaleItemRow.setItemTitle(WjxWjxxTmxx.getScaleItemrowsItemTitle());
                        if(searchBefore){
                            //将之前同id的都要处理下
                            WjxDjxxTmxx wjxDjxxTmxx1 = resultList.get(resultList.size() - 1);
                            wjxDjxxTmxx1.getItemRows().stream().forEach(r -> {
                                if(wjxDjxxTmxx.getXxtitle().endsWith(r.getItemTitle())){
                                    r.setItemSelected(wjxDjxxTmxx.getAnswerText());
                                }
                            });
                        }
                        if(wjxDjxxTmxx.getXxtitle().endsWith(WjxWjxxTmxx.getScaleItemrowsItemTitle())){
                            scaleItemRow.setItemSelected(wjxDjxxTmxx.getAnswerText());
                        }
                        itemRows.add(scaleItemRow);
                    }
                }
                if ("7".equals(wjxDjxxTmxx.getWjType())) {
                    wjxDjxxTmxx.setItems(items);
                    wjxDjxxTmxx.setItemRows(itemRows);
                    wjxDjxxTmxx.setAnswerText(null);
                    wjxDjxxTmxx.setXxtitle(null);
                } else {
                    wjxDjxxTmxx.setWjxWjxxTmxxList(list2);
                }
                //获取填空题答案
                WjxWjxxTmlb tmlb = wjxWjxxTmlbMapper.selectById(wjxDjxxTmxx.getId());
                wjxDjxxTmxx.setTktda(tmlb.getWjAnswer());
            }
            djxx.setWjxDjxxTmxxList(resultList);

        }
        return djxx;
    }

    /**
     * 秒数转时分秒
     *
     * @param seconds
     * @return
     */
    String convertSecondsToHMS(long seconds) {
        long hours = TimeUnit.SECONDS.toHours(seconds);
        long remainingSeconds = seconds - TimeUnit.HOURS.toSeconds(hours);
        long minutes = TimeUnit.SECONDS.toMinutes(remainingSeconds);
        remainingSeconds = remainingSeconds - TimeUnit.MINUTES.toSeconds(minutes);
        return String.format("%02d:%02d:%02d", hours, minutes, remainingSeconds);
    }

    @Override
    public Page<WjxDjxx> findDjjgsPage(WjxDjxx wjxDjxx, Page<WjxDjxx> page) {
        if (StringUtils.equals("1", wjxDjxx.getIsFinished())) {
            //完成答卷的
            List<WjxDjxx> list = baseMapper.findDjjgsPage(page, wjxDjxx);
            for (WjxDjxx djxx : list) {
                djxx.setAnswerSfm(convertSecondsToHMS(djxx.getAnswerSeconds()));
            }
            page.setRecords(list);
        } else if (StringUtils.equals("0", wjxDjxx.getIsFinished())) {
            //未完成答卷的
            List<WjxDjxx> list = baseMapper.findUnDjjgsPage(page, wjxDjxx);
            page.setRecords(list);
        } else {
            //全部
            List<WjxDjxx> list = baseMapper.findAllDjjgsPage(page, wjxDjxx);
            for (WjxDjxx djxx : list) {
                if (djxx.getAnswerSeconds() != -1) {
                    djxx.setAnswerSfm(convertSecondsToHMS(djxx.getAnswerSeconds()));
                }
            }
            page.setRecords(list);

        }
        return page;
    }

    @Override
    public List<WjxDjxx> exportList(WjxDjxx wjxDjxx) {
        List<WjxDjxx> list = new ArrayList<>();
        if (StringUtils.equals("1", wjxDjxx.getIsFinished())) {
            //完成答卷的
            list = baseMapper.findDjjgsPage(null, wjxDjxx);
            for (WjxDjxx djxx : list) {
                djxx.setAnswerSfm(convertSecondsToHMS(djxx.getAnswerSeconds()));
            }
        } else if (StringUtils.equals("0", wjxDjxx.getIsFinished())) {
            //未完成答卷的
            list = baseMapper.findUnDjjgsPage(null, wjxDjxx);
        } else {
            //全部
            list = baseMapper.findAllDjjgsPage(null, wjxDjxx);
            for (WjxDjxx djxx : list) {
                if (djxx.getAnswerSeconds() != -1) {
                    djxx.setAnswerSfm(convertSecondsToHMS(djxx.getAnswerSeconds()));
                }
            }
        }
        return list;
    }

    @Override
    public List<WjxDjxxDj> exportDjXls(WjxDjxxDj wjxDjxxdj) {
        List<WjxDjxxDj> list = new ArrayList<>();
        if (StringUtils.equals("1", wjxDjxxdj.getIsFinished())) {
            //完成答卷的
            list = baseMapper.findDjjgsDjPage(wjxDjxxdj);
            for (WjxDjxxDj djxx : list) {
                djxx.setAnswerSfm(convertSecondsToHMS(djxx.getAnswerSeconds()));
            }
        } else if (StringUtils.equals("0", wjxDjxxdj.getIsFinished())) {
            //未完成答卷的
            list = baseMapper.findUnDjjgsDJPage(wjxDjxxdj);
        } else {
            //全部
            list = baseMapper.findAllDjjgsDjPage(wjxDjxxdj);
            for (WjxDjxxDj djxx : list) {
                if (djxx.getAnswerSeconds() != -1) {
                    djxx.setAnswerSfm(convertSecondsToHMS(djxx.getAnswerSeconds()));
                }
            }
        }
        return list;
    }

    @Override
    public IPage<StudentCyglSys> sysList(Page<StudentCyglSys> page, QueryWrapper<StudentCyglSys> queryWrapper, StudentCyglSys studentCyglSys) {
        return baseMapper.sysList(page, queryWrapper, studentCyglSys);
    }

    @Override
    public List<StudentCyglSys> exportSysXls(QueryWrapper<StudentCyglSys> queryWrapper, StudentCyglSys studentCyglSys) {
        return baseMapper.exportSysXls(queryWrapper, studentCyglSys);
    }

    @Override
    public List<StudentWjglSys> exportWjglSysXls(QueryWrapper<StudentWjglSys> queryWrapper, StudentWjglSys studentWjglSys) {
        return baseMapper.exportWjglSysXls(queryWrapper, studentWjglSys);
    }

    @Override
    public IPage<StudentWjglSys> sysWjglList(Page<StudentWjglSys> page, QueryWrapper<StudentWjglSys> queryWrapper, StudentWjglSys studentWjglSys) {
        return baseMapper.sysWjglList(page, queryWrapper, studentWjglSys);
    }

    @Override
    public WjxDjxx querySdpfById(String id) {
        LoginUser user = (LoginUser) SecurityUtils.getSubject().getPrincipal();
        WjxDjxx djxx = baseMapper.findDjxx(id, user.getUsername());
        if (djxx != null) {
            djxx.setAnswerSfm(convertSecondsToHMS(djxx.getAnswerSeconds()));
            List<WjxDjxxTmxx> list = baseMapper.findDjtmxx2(djxx.getVid(), djxx.getJid());
            for (WjxDjxxTmxx wjxDjxxTmxx : list) {
                List<WjxWjxxTmxx> list2 = wjxWjxxTmxxMapper.selectByMainId(wjxDjxxTmxx.getId());
                wjxDjxxTmxx.setWjxWjxxTmxxList(list2);
                //获取填空题答案
                WjxWjxxTmlb tmlb = wjxWjxxTmlbMapper.selectById(wjxDjxxTmxx.getId());
                wjxDjxxTmxx.setTktda(tmlb.getWjAnswer());
            }
            djxx.setWjxDjxxTmxxList(list);

        }
        return djxx;
    }

    @Override
    public void updateDjxxTmxx(WjxDjxxTmxx wjxDjxxTmxx) {
        baseMapper.updateDjxxTmxx(wjxDjxxTmxx);
    }

    @Override
    public WjxDjxxTmxx getSumScore(WjxDjxxTmxx wjxDjxxTmxx) {
        return baseMapper.getSumScore(wjxDjxxTmxx);
    }

    @Override
    public void editSdpf(WjxDjxx wjxDjxx) {
        baseMapper.editSdpf(wjxDjxx);
    }

    @Override
    public WjxDjxxTmxx getByDjxxId(String djtmid) {
        return baseMapper.getByDjxxId(djtmid);
    }

    @Override
    public void cxjcWjxScore(String vid) {
        QueryWrapper<WjxDjxx> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("vid", vid);
        List<WjxDjxx> list = baseMapper.selectList(queryWrapper);
        for (WjxDjxx par : list) {
            jsscore(par.getJid());
        }
    }

    @Override
    public String updateDjjg(WjxDjxx wjxDjxxPar) {
//        LoginUser user = (LoginUser) SecurityUtils.getSubject().getPrincipal();
        String vid = wjxDjxxPar.getVid();
        if (vid == null || vid.equals("")) {
            return "此试卷错误，无法提交！";
        }


        WjxDjxx wjxDjxx2 = baseMapper.getInfoByVidUser(wjxDjxxPar);


        String submitData = wjxDjxx2.getSubmitData();
        Map<String, Object> map = new HashMap<>();
        map.put("vid", Integer.valueOf(vid));
        Long djys = ChronoUnit.SECONDS.between(wjxDjxx2.getOpenTime().toInstant(), wjxDjxx2.getCommitTime().toInstant());
        if (djys < 3) {
            djys = 10L;
        }
        System.out.println("--------------------------------------------------");
        System.out.println("---------------djys--" + djys + "---------------------------");
        System.out.println("--------------------------------------------------");
        map.put("inputcosttime", djys);
        map.put("submitdata", submitData);
        map.put("sojumpparm", wjxDjxx2.getUserId());//自定义链接参数，用来透传用户ID
        //调用接口,提交
        String result = wjxUtil.openapi(map, "1001001");
        String jidRes = "";
        if (!result.equals("")) {
            JSONObject jsonResult = JSONObject.parseObject(result);
            if (jsonResult.getBoolean("result")) {
                JSONObject dataJson = jsonResult.getJSONObject("data");
                String vidRes = dataJson.getString("vid");
                jidRes = dataJson.getString("jid");
                String sojumpparmRes = dataJson.getString("sojumpparm");
                baseMapper.updateJid(sojumpparmRes, vidRes, jidRes);
                //调用接口，答卷查询
                Map<String, Object> selMap = new HashMap<>();
                selMap.put("vid", Integer.valueOf(vid));
                selMap.put("jid", Long.valueOf(jidRes));
                //调用接口,查询答卷结果
                String answerStr = wjxUtil.openapi(selMap, "1001002");
                if (!answerStr.equals("")) {
                    JSONObject ansJsonResult = JSONObject.parseObject(answerStr);
                    if (ansJsonResult.getBoolean("result")) {
                        JSONObject ansDataJson = ansJsonResult.getJSONObject("data");
                        String answerVid = ansDataJson.getString("vid");
                        JSONObject answerJsonArray = ansDataJson.getJSONObject("answers");
                        for (String key1 : answerJsonArray.keySet()) {
                            JSONObject answer = answerJsonArray.getJSONObject(key1);
                            String jidAns = answer.getString("jid");
                            Integer answerSeconds = answer.getInteger("answer_seconds");
                            Double score = answer.getDouble("score");
                            Double totalScore = answer.getDouble("total_score");
                            WjxDjxx wjxDjxx = new WjxDjxx();
                            wjxDjxx.setVid(answerVid);
                            wjxDjxx.setJid(jidAns);
                            wjxDjxx.setAnswerSeconds(answerSeconds);
                            wjxDjxx.setScore(score);
                            wjxDjxx.setTotalScore(totalScore);
                            //删除选项信息
                            baseMapper.deleteDjItem(wjxDjxx);
                            //处理选项
                            JSONObject answerItemJson = answer.getJSONObject("answer_items");
                            if (answerItemJson != null) {
                                for (String key2 : answerItemJson.keySet()) {
                                    JSONObject answerItem = answerItemJson.getJSONObject(key2);
                                    WjxDjxxTmxx wjxDjxxTmxx = new WjxDjxxTmxx();
                                    wjxDjxxTmxx.setVid(answerVid);
                                    wjxDjxxTmxx.setJid(jidAns);
                                    wjxDjxxTmxx.setUserId(wjxDjxx2.getUserId());
                                    wjxDjxxTmxx.setCreateBy(wjxDjxx2.getUserId());
                                    wjxDjxxTmxx.setCreateTime(new Date());

                                    if (answerItem.get("q_index") != null) {
                                        Integer wjIndex = answerItem.getInteger("q_index");
                                        wjxDjxxTmxx.setWjIndex(wjIndex);
                                    }
                                    if (answerItem.get("title") != null) {
                                        String wjTitle = answerItem.getString("title");
                                        wjxDjxxTmxx.setWjTitle(wjTitle);
                                    }

                                    if (answerItem.get("item_value") != null) {
                                        Double itemScore = answerItem.getDouble("item_value");
                                        wjxDjxxTmxx.setItemScore(itemScore);
                                    }
                                    if (answerItem.get("answer_text") != null) {
                                        String answerText = answerItem.getString("answer_text");
                                        wjxDjxxTmxx.setAnswerText(answerText);
                                    }
                                    if (answerItem.get("item_index") != null) {
                                        JSONArray itemIndex = answerItem.getJSONArray("item_index");

                                        QueryWrapper<WjxWjxx> wjxWjxxQueryWrapper = new QueryWrapper<>();
                                        wjxWjxxQueryWrapper.eq("vid", vid);
                                        wjxWjxxQueryWrapper.last("limit 1");
                                        WjxWjxx wjxxPar = wjxWjxxMapper.selectOne(wjxWjxxQueryWrapper);


                                        if (itemIndex.size() > 0) {
                                            for (Object index : itemIndex) {
                                                Integer ti = (Integer) index;


                                                wjxDjxxTmxx.setItemIndex(ti);
                                                String id = new DefaultIdentifierGenerator().nextId(new WjxDjxxTmxx()).toString();
                                                wjxDjxxTmxx.setId(id);

                                                try {
                                                    QueryWrapper<WjxWjxxTmlb> wjxWjxxTmlbQueryWrapper = new QueryWrapper<>();
                                                    wjxWjxxTmlbQueryWrapper.eq("main_id", wjxxPar.getId());
                                                    wjxWjxxTmlbQueryWrapper.eq("wj_index", wjxDjxxTmxx.getWjIndex());
                                                    wjxWjxxTmlbQueryWrapper.last("limit 1");
                                                    WjxWjxxTmlb tmlb = wjxWjxxTmlbMapper.selectOne(wjxWjxxTmlbQueryWrapper);
                                                    wjxDjxxTmxx.setPicPath(tmlb.getPicPath());
                                                } catch (Exception e) {
                                                    e.printStackTrace();
                                                }
                                                baseMapper.addDjTmxx(wjxDjxxTmxx);
                                            }
                                        } else {
                                            String id = new DefaultIdentifierGenerator().nextId(new WjxDjxxTmxx()).toString();

                                            try {
                                                QueryWrapper<WjxWjxxTmlb> wjxWjxxTmlbQueryWrapper = new QueryWrapper<>();
                                                wjxWjxxTmlbQueryWrapper.eq("main_id", wjxxPar.getId());
                                                wjxWjxxTmlbQueryWrapper.eq("wj_index", wjxDjxxTmxx.getWjIndex());
                                                wjxWjxxTmlbQueryWrapper.last("limit 1");
                                                WjxWjxxTmlb tmlb = wjxWjxxTmlbMapper.selectOne(wjxWjxxTmlbQueryWrapper);
                                                wjxDjxxTmxx.setPicPath(tmlb.getPicPath());
                                            } catch (Exception e) {
                                                e.printStackTrace();
                                            }
                                            wjxDjxxTmxx.setId(id);
                                            ;
                                            baseMapper.addDjTmxx(wjxDjxxTmxx);
                                        }
                                    } else {
                                        String id = new DefaultIdentifierGenerator().nextId(new WjxDjxxTmxx()).toString();

                                        try {
                                            QueryWrapper<WjxWjxx> wjxWjxxQueryWrapper = new QueryWrapper<>();
                                            wjxWjxxQueryWrapper.eq("vid", vid);
                                            wjxWjxxQueryWrapper.last("limit 1");
                                            WjxWjxx wjxxPar = wjxWjxxMapper.selectOne(wjxWjxxQueryWrapper);
                                            QueryWrapper<WjxWjxxTmlb> wjxWjxxTmlbQueryWrapper = new QueryWrapper<>();
                                            wjxWjxxTmlbQueryWrapper.eq("main_id", wjxxPar.getId());
                                            wjxWjxxTmlbQueryWrapper.eq("wj_index", wjxDjxxTmxx.getWjIndex());
                                            wjxWjxxTmlbQueryWrapper.last("limit 1");
                                            WjxWjxxTmlb tmlb = wjxWjxxTmlbMapper.selectOne(wjxWjxxTmlbQueryWrapper);
                                            wjxDjxxTmxx.setPicPath(tmlb.getPicPath());
                                        } catch (Exception e) {
                                            e.printStackTrace();
                                        }
                                        wjxDjxxTmxx.setId(id);
                                        ;
                                        baseMapper.addDjTmxx(wjxDjxxTmxx);
                                    }
                                }
                            }
                            //修改答卷信息
                            baseMapper.updateAnswer(wjxDjxx);
                        }
                    } else {
                        baseMapper.updateErrMsg(wjxDjxx2.getUserId(), vid, ansJsonResult.getString("errormsg"));
                        return ansJsonResult.getString("errormsg");
                    }
                }
            } else {
                baseMapper.updateErrMsg(wjxDjxx2.getUserId(), vid, jsonResult.getString("errormsg"));
                return jsonResult.getString("errormsg");
            }
        }


        try {
            if (StringUtils.isNotBlank(jidRes)) {
                jsscore(jidRes);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }


        return "提交成功！";
    }

    @Override
    public String getDjjg(WjxDjxx wjxDjxxPar) {
//        LoginUser user = (LoginUser) SecurityUtils.getSubject().getPrincipal();
        String vid = wjxDjxxPar.getVid();
        if (vid == null || vid.equals("")) {
            return "此试卷错误，无法提交！";
        }

        //调用接口,提交
        String jidRes = wjxDjxxPar.getJid();
        //调用接口，答卷查询
        Map<String, Object> selMap = new HashMap<>();
        selMap.put("vid", Integer.valueOf(vid));
        selMap.put("jid", Long.valueOf(jidRes));
        //调用接口,查询答卷结果
        String answerStr = wjxUtil.openapi(selMap, "1001002");
        if (!answerStr.equals("")) {
            JSONObject ansJsonResult = JSONObject.parseObject(answerStr);
            if (ansJsonResult.getBoolean("result")) {
                JSONObject ansDataJson = ansJsonResult.getJSONObject("data");
                String answerVid = ansDataJson.getString("vid");
                JSONObject answerJsonArray = ansDataJson.getJSONObject("answers");
                for (String key1 : answerJsonArray.keySet()) {
                    JSONObject answer = answerJsonArray.getJSONObject(key1);
                    String jidAns = answer.getString("jid");
                    Integer answerSeconds = answer.getInteger("answer_seconds");
                    Double score = answer.getDouble("score");
                    Double totalScore = answer.getDouble("total_score");
                    WjxDjxx wjxDjxx = new WjxDjxx();
                    wjxDjxx.setVid(answerVid);
                    wjxDjxx.setJid(jidAns);
                    wjxDjxx.setAnswerSeconds(answerSeconds);
                    wjxDjxx.setScore(score);
                    wjxDjxx.setTotalScore(totalScore);
                    //删除选项信息
//                            baseMapper.deleteDjItem(wjxDjxx);
                    //处理选项
                    JSONObject answerItemJson = answer.getJSONObject("answer_items");
                    if (answerItemJson != null) {
                        for (String key2 : answerItemJson.keySet()) {
                            JSONObject answerItem = answerItemJson.getJSONObject(key2);
                            WjxDjxxTmxx wjxDjxxTmxx = new WjxDjxxTmxx();
                            wjxDjxxTmxx.setVid(answerVid);
                            wjxDjxxTmxx.setJid(jidAns);
                            wjxDjxxTmxx.setUserId(wjxDjxxPar.getUserId());
                            wjxDjxxTmxx.setCreateBy(wjxDjxxPar.getUserId());
                            wjxDjxxTmxx.setCreateTime(new Date());

                            if (answerItem.get("q_index") != null) {
                                Integer wjIndex = answerItem.getInteger("q_index");
                                wjxDjxxTmxx.setWjIndex(wjIndex);
                            }
                            if (answerItem.get("title") != null) {
                                String wjTitle = answerItem.getString("title");
                                wjxDjxxTmxx.setWjTitle(wjTitle);
                            }

                            if (answerItem.get("item_value") != null) {
                                Double itemScore = answerItem.getDouble("item_value");
                                wjxDjxxTmxx.setItemScore(itemScore);
                            }
                            if (answerItem.get("answer_text") != null) {
                                String answerText = answerItem.getString("answer_text");
                                wjxDjxxTmxx.setAnswerText(answerText);
                            }
                            if (answerItem.get("item_index") != null) {
                                JSONArray itemIndex = answerItem.getJSONArray("item_index");

                                QueryWrapper<WjxWjxx> wjxWjxxQueryWrapper = new QueryWrapper<>();
                                wjxWjxxQueryWrapper.eq("vid", vid);
                                wjxWjxxQueryWrapper.last("limit 1");
                                WjxWjxx wjxxPar = wjxWjxxMapper.selectOne(wjxWjxxQueryWrapper);


                                if (itemIndex.size() > 0) {
                                    for (Object index : itemIndex) {
                                        Integer ti = (Integer) index;


                                        wjxDjxxTmxx.setItemIndex(ti);
                                        String id = new DefaultIdentifierGenerator().nextId(new WjxDjxxTmxx()).toString();
                                        wjxDjxxTmxx.setId(id);

                                        try {
                                            QueryWrapper<WjxWjxxTmlb> wjxWjxxTmlbQueryWrapper = new QueryWrapper<>();
                                            wjxWjxxTmlbQueryWrapper.eq("main_id", wjxxPar.getId());
                                            wjxWjxxTmlbQueryWrapper.eq("wj_index", wjxDjxxTmxx.getWjIndex());
                                            wjxWjxxTmlbQueryWrapper.last("limit 1");
                                            WjxWjxxTmlb tmlb = wjxWjxxTmlbMapper.selectOne(wjxWjxxTmlbQueryWrapper);
                                            wjxDjxxTmxx.setPicPath(tmlb.getPicPath());
                                        } catch (Exception e) {
                                            e.printStackTrace();
                                        }

                                        WjxDjxxTmxx djxxTmxx = baseMapper.getSfysj(wjxDjxxTmxx);
                                        if (djxxTmxx == null) {
                                            baseMapper.addDjTmxx(wjxDjxxTmxx);
                                        }

                                    }
                                } else {
                                    String id = new DefaultIdentifierGenerator().nextId(new WjxDjxxTmxx()).toString();

                                    try {
                                        QueryWrapper<WjxWjxxTmlb> wjxWjxxTmlbQueryWrapper = new QueryWrapper<>();
                                        wjxWjxxTmlbQueryWrapper.eq("main_id", wjxxPar.getId());
                                        wjxWjxxTmlbQueryWrapper.eq("wj_index", wjxDjxxTmxx.getWjIndex());
                                        wjxWjxxTmlbQueryWrapper.last("limit 1");
                                        WjxWjxxTmlb tmlb = wjxWjxxTmlbMapper.selectOne(wjxWjxxTmlbQueryWrapper);
                                        wjxDjxxTmxx.setPicPath(tmlb.getPicPath());
                                    } catch (Exception e) {
                                        e.printStackTrace();
                                    }
                                    wjxDjxxTmxx.setId(id);
                                    WjxDjxxTmxx djxxTmxx = baseMapper.getSfysj(wjxDjxxTmxx);
                                    if (djxxTmxx == null) {
                                        baseMapper.addDjTmxx(wjxDjxxTmxx);
                                    }
                                }
                            } else {
                                String id = new DefaultIdentifierGenerator().nextId(new WjxDjxxTmxx()).toString();

                                try {
                                    QueryWrapper<WjxWjxx> wjxWjxxQueryWrapper = new QueryWrapper<>();
                                    wjxWjxxQueryWrapper.eq("vid", vid);
                                    wjxWjxxQueryWrapper.last("limit 1");
                                    WjxWjxx wjxxPar = wjxWjxxMapper.selectOne(wjxWjxxQueryWrapper);
                                    QueryWrapper<WjxWjxxTmlb> wjxWjxxTmlbQueryWrapper = new QueryWrapper<>();
                                    wjxWjxxTmlbQueryWrapper.eq("main_id", wjxxPar.getId());
                                    wjxWjxxTmlbQueryWrapper.eq("wj_index", wjxDjxxTmxx.getWjIndex());
                                    wjxWjxxTmlbQueryWrapper.last("limit 1");
                                    WjxWjxxTmlb tmlb = wjxWjxxTmlbMapper.selectOne(wjxWjxxTmlbQueryWrapper);
                                    wjxDjxxTmxx.setPicPath(tmlb.getPicPath());
                                } catch (Exception e) {
                                    e.printStackTrace();
                                }
                                wjxDjxxTmxx.setId(id);
                                WjxDjxxTmxx djxxTmxx = baseMapper.getSfysj(wjxDjxxTmxx);
                                if (djxxTmxx == null) {
                                    baseMapper.addDjTmxx(wjxDjxxTmxx);
                                }
                            }
                        }
                    }

                    //修改答卷信息
                    baseMapper.updateAnswer(wjxDjxx);
                }
            } else {
                baseMapper.updateErrMsg(wjxDjxxPar.getUserId(), vid, ansJsonResult.getString("errormsg"));
                return ansJsonResult.getString("errormsg");
            }
        }

        try {
            if (StringUtils.isNotBlank(jidRes)) {
                jsscore(jidRes);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }


        return "获取成功！";
    }

    @Override
    public int upZbcs(WjxDjxx wjxDjxx) {
        LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
        wjxDjxx.setCreateBy(sysUser.getUsername());
        return baseMapper.upZbcs(wjxDjxx);
    }

    public void jsscore(String jid) {
        try {
            if (StringUtils.equals(jid, "122233965812")) {
                System.out.println("jid");
            }
            WjxDjxxTmxx wjxDjxxTmxx = new WjxDjxxTmxx();
            wjxDjxxTmxx.setJid(jid);
            wjxDjxxTmxx = baseMapper.getSumScore(wjxDjxxTmxx);
            WjxDjxx par2 = new WjxDjxx();
            if (wjxDjxxTmxx.getItemScore() != null && wjxDjxxTmxx.getItemScore() > 0) {
                par2.setScore(wjxDjxxTmxx.getItemScore());
                par2.setJid(jid);
                baseMapper.updateScoreByJid(par2);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

}
