package org.jeecg.modules.kc.wjxDjxxFzbtj.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.jeecg.common.system.base.controller.JeecgController;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.modules.kc.wjxDjxxFzbtj.entity.WjxDjxxFzbtj;
import org.jeecg.modules.kc.wjxDjxxFzbtj.service.IWjxDjxxFzbtjService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.Arrays;
import java.util.Map;

/**
 * @Description: wjx_djxx_fzbtj
 * @Author: jeecg-boot
 * @Date: 2025-01-07
 * @Version: V1.0
 */
@Api(tags = "wjx_djxx_fzbtj")
@RestController
@RequestMapping("/wjxDjxxFzbtj/wjxDjxxFzbtj")
@Slf4j
public class WjxDjxxFzbtjController extends JeecgController<WjxDjxxFzbtj, IWjxDjxxFzbtjService> {
    @Autowired
    private IWjxDjxxFzbtjService wjxDjxxFzbtjService;

    /**
     * 分页列表查询
     *
     * @param wjxDjxxFzbtj
     * @param pageNo
     * @param pageSize
     * @param req
     * @return
     */
    //@AutoLog(value = "wjx_djxx_fzbtj-分页列表查询")
    @ApiOperation(value = "wjx_djxx_fzbtj-分页列表查询", notes = "wjx_djxx_fzbtj-分页列表查询")
    @GetMapping(value = "/list")
    public Result<IPage<WjxDjxxFzbtj>> queryPageList(WjxDjxxFzbtj wjxDjxxFzbtj,
                                                     @RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo,
                                                     @RequestParam(name = "pageSize", defaultValue = "10") Integer pageSize,
                                                     HttpServletRequest req) {
        QueryWrapper<WjxDjxxFzbtj> queryWrapper = QueryGenerator.initQueryWrapper(wjxDjxxFzbtj, req.getParameterMap());
        Page<WjxDjxxFzbtj> page = new Page<WjxDjxxFzbtj>(pageNo, pageSize);
        queryWrapper.orderByAsc("create_time");
        IPage<WjxDjxxFzbtj> pageList = wjxDjxxFzbtjService.page(page, queryWrapper);
        return Result.OK(pageList);
    }

    /**
     * 添加
     *
     * @param wjxDjxxFzbtj
     * @return
     */
    @AutoLog(value = "wjx_djxx_fzbtj-添加")
    @ApiOperation(value = "wjx_djxx_fzbtj-添加", notes = "wjx_djxx_fzbtj-添加")
    @PostMapping(value = "/add")
    public Result<Map<String, Object>> add(@RequestBody WjxDjxxFzbtj wjxDjxxFzbtj) {
        return Result.OK(wjxDjxxFzbtjService.saveData(wjxDjxxFzbtj));
    }

    /**
     * 编辑
     *
     * @param wjxDjxxFzbtj
     * @return
     */
    @AutoLog(value = "wjx_djxx_fzbtj-编辑")
    @ApiOperation(value = "wjx_djxx_fzbtj-编辑", notes = "wjx_djxx_fzbtj-编辑")
    @RequestMapping(value = "/edit", method = {RequestMethod.PUT, RequestMethod.POST})
    public Result<String> edit(@RequestBody WjxDjxxFzbtj wjxDjxxFzbtj) {
        wjxDjxxFzbtjService.updateById(wjxDjxxFzbtj);
        return Result.OK("编辑成功!");
    }

    /**
     * 通过id删除
     *
     * @param id
     * @return
     */
    @AutoLog(value = "wjx_djxx_fzbtj-通过id删除")
    @ApiOperation(value = "wjx_djxx_fzbtj-通过id删除", notes = "wjx_djxx_fzbtj-通过id删除")
    @DeleteMapping(value = "/delete")
    public Result<String> delete(@RequestParam(name = "id", required = true) String id) {
        wjxDjxxFzbtjService.removeById(id);
        return Result.OK("删除成功!");
    }

    /**
     * 批量删除
     *
     * @param ids
     * @return
     */
    @AutoLog(value = "wjx_djxx_fzbtj-批量删除")
    @ApiOperation(value = "wjx_djxx_fzbtj-批量删除", notes = "wjx_djxx_fzbtj-批量删除")
    @DeleteMapping(value = "/deleteBatch")
    public Result<String> deleteBatch(@RequestParam(name = "ids", required = true) String ids) {
        this.wjxDjxxFzbtjService.removeByIds(Arrays.asList(ids.split(",")));
        return Result.OK("批量删除成功!");
    }

    /**
     * 通过id查询
     *
     * @param id
     * @return
     */
    //@AutoLog(value = "wjx_djxx_fzbtj-通过id查询")
    @ApiOperation(value = "wjx_djxx_fzbtj-通过id查询", notes = "wjx_djxx_fzbtj-通过id查询")
    @GetMapping(value = "/queryById")
    public Result<WjxDjxxFzbtj> queryById(@RequestParam(name = "id", required = true) String id) {
        WjxDjxxFzbtj wjxDjxxFzbtj = wjxDjxxFzbtjService.getById(id);
        if (wjxDjxxFzbtj == null) {
            return Result.error("未找到对应数据");
        }
        return Result.OK(wjxDjxxFzbtj);
    }

    /**
     * 导出excel
     *
     * @param request
     * @param wjxDjxxFzbtj
     */
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, WjxDjxxFzbtj wjxDjxxFzbtj) {
        return super.exportXls(request, wjxDjxxFzbtj, WjxDjxxFzbtj.class, "wjx_djxx_fzbtj");
    }

    /**
     * 通过excel导入数据
     *
     * @param request
     * @param response
     * @return
     */
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, WjxDjxxFzbtj.class);
    }

    /**
     * 获取考试剩余时间
     *
     * @param redisKey
     * @return
     */
    @PostMapping(value = "/getExamTime")
    public Result<String> getExamTime(@RequestBody String redisKey) {
        return Result.OK(wjxDjxxFzbtjService.getExamTime(redisKey));
    }
}
