package org.jeecg.modules.kc.wjxDjxxFzbtj.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.jeecgframework.poi.excel.annotation.Excel;
import org.springframework.format.annotation.DateTimeFormat;

import java.io.Serializable;
import java.util.Date;

/**
 * @Description: wjx_djxx_fzbtj
 * @Author: jeecg-boot
 * @Date: 2025-01-07
 * @Version: V1.0
 */
@Data
@TableName("wjx_djxx_fzbtj")
@Accessors(chain = true)
@EqualsAndHashCode(callSuper = false)
@ApiModel(value = "wjx_djxx_fzbtj对象", description = "wjx_djxx_fzbtj")
public class WjxDjxxFzbtj implements Serializable {
    private static final long serialVersionUID = 1L;

    /**
     * id
     */
    @TableId(type = IdType.ASSIGN_ID)
    @ApiModelProperty(value = "id")
    private String id;
    /**
     * wjx_djxx表id
     */
    @Excel(name = "wjx_djxx表id", width = 15)
    @ApiModelProperty(value = "wjx_djxx表id")
    private String djxxId;
    /**
     * 创建人
     */
    @ApiModelProperty(value = "创建人")
    private String createBy;
    /**
     * 学生姓名
     */
    @Excel(name = "学生姓名", width = 15)
    @ApiModelProperty(value = "学生姓名")
    private String studentName;
    /**
     * 创建时间
     */
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @ApiModelProperty(value = "创建时间")
    private Date createTime;
    /**
     * 修改时间
     */
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @ApiModelProperty(value = "修改时间")
    private Date updateTime;
    /**
     * 问卷编号(提交问卷、查询问卷会用到)
     */
    @Excel(name = "问卷编号(提交问卷、查询问卷会用到)", width = 15)
    @ApiModelProperty(value = "问卷编号(提交问卷、查询问卷会用到)")
    private String vid;
    /**
     * 答卷编号
     */
    @Excel(name = "答卷编号", width = 15)
    @ApiModelProperty(value = "答卷编号")
    private String jid;
    /**
     * 作弊类型
     * 1、退出全屏
     * 2、切屏
     * 3、考试超时
     */
    @Excel(name = "作弊类型1、退出全屏2、切屏3、考试超时4、开始答题", width = 15)
    @ApiModelProperty(value = "作弊类型1、退出全屏2、切屏3、考试超时4、开始答题")
    private Integer type;
    /**
     * 作弊内容：XX时间，XX操作；
     */
    @Excel(name = "作弊内容：XX时间，XX操作；", width = 15)
    @ApiModelProperty(value = "作弊内容：XX时间，XX操作；")
    private String content;

    //作答时限（分钟）
    @TableField(exist = false)
    private Integer zdsx;

    //结束时间
    @TableField(exist = false)
    private String endTime;
}
