package org.jeecg.modules.kc.wjxDjxxFzbtj.service.impl;

import cn.hutool.core.util.IdUtil;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.apache.commons.lang3.StringUtils;
import org.apache.shiro.SecurityUtils;
import org.jeecg.common.system.vo.LoginUser;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.kc.wjxDjxxFzbtj.entity.WjxDjxxFzbtj;
import org.jeecg.modules.kc.wjxDjxxFzbtj.mapper.WjxDjxxFzbtjMapper;
import org.jeecg.modules.kc.wjxDjxxFzbtj.service.IWjxDjxxFzbtjService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.stereotype.Service;

import java.time.Duration;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.time.format.DateTimeParseException;
import java.util.HashMap;
import java.util.Map;
import java.util.concurrent.TimeUnit;

/**
 * @Description: wjx_djxx_fzbtj
 * @Author: jeecg-boot
 * @Date: 2025-01-07
 * @Version: V1.0
 */
@Service
public class WjxDjxxFzbtjServiceImpl extends ServiceImpl<WjxDjxxFzbtjMapper, WjxDjxxFzbtj> implements IWjxDjxxFzbtjService {

    @Autowired
    public RedisTemplate redisTemplate;

    @Override
    public Map<String, Object> saveData(WjxDjxxFzbtj wjxDjxxFzbtj) {
        // 创建返回的Map
        Map<String, Object> resultMap = new HashMap<>();

        LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
        wjxDjxxFzbtj.setId(IdUtil.simpleUUID());
        wjxDjxxFzbtj.setStudentName(sysUser.getRealname());

        // 设置内容
        switch (wjxDjxxFzbtj.getType()) {
            case 1:
                wjxDjxxFzbtj.setContent(sysUser.getRealname() + "在" + LocalDateTime.now().format(DateTimeFormatter.ofPattern("yyyy年MM月dd日 HH:mm:ss")) + "退出全屏；");
                break;
            case 2:
                wjxDjxxFzbtj.setContent(sysUser.getRealname() + "在" + LocalDateTime.now().format(DateTimeFormatter.ofPattern("yyyy年MM月dd日 HH:mm:ss")) + "切屏；");
                break;
            case 3:
                wjxDjxxFzbtj.setContent(sysUser.getRealname() + "在" + LocalDateTime.now().format(DateTimeFormatter.ofPattern("yyyy年MM月dd日 HH:mm:ss")) + "提交超时；");
                break;
            case 4:
                if (wjxDjxxFzbtj.getZdsx() != null) {
                    String finishTime = oConvertUtils.getString(redisTemplate.opsForValue().get("ktcy" + ":" + wjxDjxxFzbtj.getVid() + ":" + sysUser.getUsername()));
                    resultMap.put("finishTime", finishTime);//考试结束时间
                    if (StringUtils.isBlank(finishTime)) {
                        //计算考试剩余时间
                        String endTimeStr = wjxDjxxFzbtj.getEndTime();
                        LocalDateTime endTime = LocalDateTime.parse(endTimeStr, DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm"));
                        LocalDateTime now = LocalDateTime.now();
                        Duration duration = Duration.between(now, endTime);
                        finishTime = LocalDateTime.now().plus(Duration.ofMinutes(wjxDjxxFzbtj.getZdsx())).format(DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss"));
                        redisTemplate.opsForValue().set(
                                "ktcy" + ":" + wjxDjxxFzbtj.getVid() + ":" + sysUser.getUsername(),
                                finishTime,
                                duration.getSeconds(),
                                TimeUnit.SECONDS);
                        resultMap.put("finishTime", finishTime);//考试结束时间
                    } else {
                        try {
                            // 解析结束时间并检查是否过期
                            LocalDateTime finishDateTime = LocalDateTime.parse(finishTime, DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss"));
                            LocalDateTime now = LocalDateTime.now();
                            boolean isExpired = !finishDateTime.isAfter(now);

                            resultMap.put("expired", isExpired);//是否超时

                            //未超时返回剩余时间格式化后的字符串
                            if (!isExpired) {
                                Duration duration = Duration.between(now, finishDateTime);

                                long hoursLeft = duration.toHours();
                                long minutesLeft = duration.toMinutes() % 60;
                                long secondsLeft = duration.getSeconds() % 60;

                                StringBuilder timeLeftBuilder = new StringBuilder();

                                if (hoursLeft > 0) {
                                    timeLeftBuilder.append(hoursLeft).append("小时");
                                }
                                if (minutesLeft > 0 || hoursLeft == 0) { // 如果没有小时或有分钟，则显示分钟
                                    if (timeLeftBuilder.length() > 0) {
                                        timeLeftBuilder.append(" ");
                                    }
                                    timeLeftBuilder.append(minutesLeft).append("分钟");
                                }
                                if (secondsLeft > 0 || (hoursLeft == 0 && minutesLeft == 0)) { // 如果没有小时和分钟或者有秒，则显示秒
                                    if (timeLeftBuilder.length() > 0) {
                                        timeLeftBuilder.append(" ");
                                    }
                                    timeLeftBuilder.append(secondsLeft).append("秒");
                                }

                                resultMap.put("timeLeft", timeLeftBuilder.toString());
                            }
                        } catch (DateTimeParseException e) {
                            // 如果解析失败，可以在这里处理异常
//                            Map<String, Object> errorResult = new HashMap<>();
//                            errorResult.put("error", "时间格式错误");
//                            return errorResult;
                            e.printStackTrace();
                        }
                    }
                }
                wjxDjxxFzbtj.setContent(sysUser.getRealname() + "在" + LocalDateTime.now().format(DateTimeFormatter.ofPattern("yyyy年MM月dd日 HH:mm:ss")) + "开始作答；");
                break;
            default:
                // 处理其他类型
                break;
        }

        baseMapper.insert(wjxDjxxFzbtj);

        return resultMap;
    }

    @Override
    public String getExamTime(String redisKey) {
        LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
        String string = oConvertUtils.getString(redisTemplate.opsForValue().get(redisKey + ":" + sysUser.getUsername()));
        return string;
    }
}
