package org.jeecg.modules.kc.wjxWjxx.controller;

import java.util.*;
import java.util.stream.Collectors;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.toolkit.StringUtils;
import com.xkcoding.http.HttpUtil;
import org.apache.shiro.SecurityUtils;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.system.vo.LoginUser;
import org.jeecg.common.util.DateUtils;
import org.jeecg.modules.kc.config.entity.KcExportConfigTpkwcqkjzglx;
import org.jeecg.modules.kc.config.service.IKcExportConfigTpkwcqkjzglxService;
import org.jeecg.modules.kc.grab.imports.entity.Xxhbbks;
import org.jeecg.modules.kc.grab.imports.service.IXxhbbksService;
import org.jeecg.modules.kc.kcSysConfig.entity.KcSysConfig;
import org.jeecg.modules.kc.kcSysConfig.service.IKcSysConfigService;
import org.jeecg.modules.kc.kcWechatSendLog.entity.KcWechatSendLog;
import org.jeecg.modules.kc.ktgl.entity.KcKechengbiao;
import org.jeecg.modules.kc.ktgl.service.IKcKechengbiaoService;
import org.jeecg.modules.kc.tksf.kctkcstj.entity.KcTkcstj;
import org.jeecg.modules.kc.wjxWjxx.entity.KccyglSys;
import org.jeecg.modules.kc.wjxWjxx.entity.WjxWjxx;
import org.jeecg.modules.kc.wjxWjxx.service.IWjxWjxxService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecg.modules.kc.wjxWjxxTmlb.entity.WjxWjxxTmlb;
import org.jeecg.modules.kc.wjxWjxxTmlb.service.IWjxWjxxTmlbService;
import org.jeecg.modules.kc.wjxWjxxTmlb.vo.WjxWjxxTmlbPage;
import org.jeecg.modules.kc.zyDbtx.entity.ZyDbtx;
import org.jeecg.modules.kc.zyDbtx.service.IZyDbtxService;
import org.jeecg.modules.kc.zyInfo.entity.ZyInfo;
import org.jeecg.modules.kc.zyInfoStudent.entity.ZyInfoStudent;
import org.jeecg.modules.system.service.impl.SysBaseApiImpl;
import org.jeecg.modules.tools.WjxAuthService;
import org.jeecg.common.system.base.controller.JeecgController;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.client.RestTemplate;
import org.springframework.web.servlet.ModelAndView;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

/**
 * @Description: 问卷信息
 * @Author: jeecg-boot
 * @Date: 2024-04-26
 * @Version: V1.0
 */
@Api(tags = "问卷信息")
@RestController
@RequestMapping("/wjxWjxx/wjxWjxx")
@Slf4j
public class WjxWjxxController extends JeecgController<WjxWjxx, IWjxWjxxService> {
    @Autowired
    private IWjxWjxxService wjxWjxxService;

    @Autowired
    private WjxAuthService wjxAuthService;

    @Autowired
    private IXxhbbksService xxhbbksService;

    @Autowired
    private IZyDbtxService zyDbtxService;
    @Autowired
    private IWjxWjxxTmlbService wjxWjxxTmlbService;


    @Autowired
    private SysBaseApiImpl sysBaseApi;
    @Autowired
    private IKcExportConfigTpkwcqkjzglxService kcExportConfigTpkwcqkjzglxService;
    @Autowired
    private IKcSysConfigService kcSysConfigService;

    @Value("${jeecg.path.upload}")
    private String upLoadPath;
    @Autowired
    private IKcKechengbiaoService kcKechengbiaoService;

    /**
     * 分页列表查询
     *
     * @param wjxWjxx
     * @param pageNo
     * @param pageSize
     * @param req
     * @return
     */
    //@AutoLog(value = "问卷信息-分页列表查询")
    @ApiOperation(value = "问卷信息-分页列表查询", notes = "问卷信息-分页列表查询")
    @GetMapping(value = "/list")
    public Result<IPage<WjxWjxx>> queryPageList(WjxWjxx wjxWjxx,
                                                @RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo,
                                                @RequestParam(name = "pageSize", defaultValue = "10") Integer pageSize,
                                                HttpServletRequest req) {
//		QueryWrapper<WjxWjxx> queryWrapper = QueryGenerator.initQueryWrapper(wjxWjxx, req.getParameterMap());
//		queryWrapper.orderByDesc("create_time");
//		queryWrapper.orderByAsc("start_time");
//		Page<WjxWjxx> page = new Page<WjxWjxx>(pageNo, pageSize);
//		IPage<WjxWjxx> pageList = wjxWjxxService.page(page, queryWrapper);
        LoginUser user = (LoginUser) SecurityUtils.getSubject().getPrincipal();
//		wjxWjxx.setCreateBy(user.getUsername());
        Page<WjxWjxx> pageList = wjxWjxxService.findPage(wjxWjxx, new Page<>(pageNo, pageSize));
        return Result.OK(pageList);
    }


    @ApiOperation(value = "问卷信息-分页列表查询", notes = "问卷信息-分页列表查询")
    @GetMapping(value = "/newlist")
    public Result<IPage<WjxWjxx>> newlist(WjxWjxx wjxWjxx,
                                          @RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo,
                                          @RequestParam(name = "pageSize", defaultValue = "10") Integer pageSize,
                                          HttpServletRequest req) {
        Page<WjxWjxx> pageList = wjxWjxxService.findPage(wjxWjxx, new Page<>(pageNo, pageSize));
        return Result.OK(pageList);
    }

    /**
     * 学生问卷分页列表查询
     *
     * @param wjxWjxx
     * @param pageNo
     * @param pageSize
     * @param req
     * @return
     */
    //@AutoLog(value = "问卷信息-分页列表查询")
    @ApiOperation(value = "问卷信息-分页列表查询", notes = "问卷信息-分页列表查询")
    @GetMapping(value = "/stuList")
    public Result<IPage<WjxWjxx>> queryPageStuList(WjxWjxx wjxWjxx,
                                                   @RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo,
                                                   @RequestParam(name = "pageSize", defaultValue = "10") Integer pageSize,
                                                   HttpServletRequest req) {
        Page<WjxWjxx> pageList = wjxWjxxService.findStuPage(wjxWjxx, new Page<>(pageNo, pageSize));
        return Result.OK(pageList);
    }

    /**
     * 添加
     *
     * @param wjxWjxx
     * @return
     */
    @AutoLog(value = "问卷信息-添加")
    @ApiOperation(value = "问卷信息-添加", notes = "问卷信息-添加")
    @PostMapping(value = "/add")
    public Result<String> add(@RequestBody WjxWjxx wjxWjxx) {
        wjxWjxxService.save(wjxWjxx);
        return Result.OK("添加成功！");
    }

    @AutoLog(value = "问卷发布-添加")
    @ApiOperation(value = "问卷发布-添加", notes = "问卷发布-添加")
    @PostMapping(value = "/batchAdd")
    public Result<String> batchAdd(@RequestBody List<WjxWjxx> list) {
        WjxWjxx zyInfo = list.get(0);

        //删除老师留过的问卷，重新生成新的
        QueryWrapper<WjxWjxx> query = new QueryWrapper<>();
        query.eq("rwbh", zyInfo.getRwbh());
        query.eq("create_by", zyInfo.getCreateBy());
        query.eq("atype", zyInfo.getAtype());
        List<WjxWjxx> oldList = wjxWjxxService.list(query);
        wjxWjxxService.remove(query);

        KcSysConfig kcSysConfig = kcSysConfigService.getById("1");
        QueryWrapper<KcKechengbiao> kcKechengbiaoQueryWrapper = new QueryWrapper<>();
        kcKechengbiaoQueryWrapper.eq("xqxn", kcSysConfig.getFlag1());
        kcKechengbiaoQueryWrapper.eq("rwbh", zyInfo.getRwbh());
        kcKechengbiaoQueryWrapper.last("limit 1");
        KcKechengbiao kcKechengbiao = kcKechengbiaoService.getOne(kcKechengbiaoQueryWrapper);
        for (int i = 0; i < list.size(); i++) {
            WjxWjxx par = list.get(i);
            List<WjxWjxx> zyInfo1 = oldList.stream().filter(zyInfo2 -> zyInfo2.getId().equals(par.getId())).collect(Collectors.toList());
            if (zyInfo1 != null && zyInfo1.size() > 0) {
                WjxWjxx zypar = zyInfo1.get(0);
                zypar.setSort(par.getSort());
                zypar.setScore(par.getScore());
                wjxWjxxService.save(zypar);
            } else {
                par.setXqxn(kcSysConfig.getFlag1());
                par.setQpublish("0");
                par.setXkrs(kcKechengbiao.getXkrs());
                par.setKcmc(kcKechengbiao.getKcmc());
                wjxWjxxService.save(par);
            }
        }
        return Result.OK("添加成功！");
    }

    @AutoLog(value = "问卷发布-添加")
    @ApiOperation(value = "问卷发布-添加", notes = "问卷发布-添加")
    @PostMapping(value = "/addOne")
    public Result<String> addOne(@RequestBody WjxWjxx zyInfo) {
        KcSysConfig kcSysConfig = kcSysConfigService.getById("1");
        QueryWrapper<KcKechengbiao> kcKechengbiaoQueryWrapper = new QueryWrapper<>();
        kcKechengbiaoQueryWrapper.eq("xqxn", kcSysConfig.getFlag1());
        kcKechengbiaoQueryWrapper.eq("rwbh", zyInfo.getRwbh());
        kcKechengbiaoQueryWrapper.last("limit 1");
        KcKechengbiao kcKechengbiao = kcKechengbiaoService.getOne(kcKechengbiaoQueryWrapper);


        LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
        QueryWrapper<WjxWjxx> zyInfoQueryWrapper = new QueryWrapper<>();
        zyInfoQueryWrapper.eq("xqxn", zyInfo.getXqxn());
//		 zyInfoQueryWrapper.eq("create_by",sysUser.getUsername());
        zyInfoQueryWrapper.eq("rwbh", zyInfo.getRwbh());
        zyInfoQueryWrapper.eq("atype", zyInfo.getAtype());
        List<WjxWjxx> list = wjxWjxxService.list(zyInfoQueryWrapper);

        zyInfo.setSort(list.size() + 1 + "");
        zyInfo.setXqxn(kcSysConfig.getFlag1());
        zyInfo.setQpublish("0");
        zyInfo.setXkrs(kcKechengbiao.getXkrs());
        zyInfo.setScore("0");
        zyInfo.setAtype(zyInfo.getAtype());
        zyInfo.setKcmc(kcKechengbiao.getKcmc());
        wjxWjxxService.save(zyInfo);
        return Result.OK("添加成功！");
    }

    /**
     * 编辑
     *
     * @param wjxWjxx
     * @return
     */
    @AutoLog(value = "问卷信息-编辑")
    @ApiOperation(value = "问卷信息-编辑", notes = "问卷信息-编辑")
    @RequestMapping(value = "/edit", method = {RequestMethod.PUT, RequestMethod.POST})
    public Result<String> edit(@RequestBody WjxWjxx wjxWjxx) {
        wjxWjxxService.updateById(wjxWjxx);


        List<WjxWjxxTmlbPage> list = wjxWjxx.getList();
        String mainId = wjxWjxx.getId();
        if (list.size() > 0) {

            QueryWrapper<WjxWjxxTmlb> wjxWjxxTmlbQueryWrapper = new QueryWrapper<WjxWjxxTmlb>();
            wjxWjxxTmlbQueryWrapper.eq("main_id", mainId);
            List<WjxWjxxTmlb> list2 = wjxWjxxTmlbService.list(wjxWjxxTmlbQueryWrapper);
            for (WjxWjxxTmlb WjxWjxxTmlb : list2) {
                wjxWjxxTmlbService.removeByMainId(WjxWjxxTmlb.getId());
            }

            for (WjxWjxxTmlbPage wjxWjxxTmlbPage : list) {
                wjxWjxxTmlbPage.setId(null);
                WjxWjxxTmlb wjxWjxxTmlb = new WjxWjxxTmlb();
                BeanUtils.copyProperties(wjxWjxxTmlbPage, wjxWjxxTmlb);
                wjxWjxxTmlb.setMainId(mainId);
                wjxWjxxTmlbService.saveMain(wjxWjxxTmlb, wjxWjxxTmlbPage);
            }
        }


        return Result.OK("编辑成功!");
    }

    /**
     * 通过id删除
     *
     * @param id
     * @return
     */
    @AutoLog(value = "问卷信息-通过id删除")
    @ApiOperation(value = "问卷信息-通过id删除", notes = "问卷信息-通过id删除")
    @DeleteMapping(value = "/delete")
    public Result<String> delete(@RequestParam(name = "id", required = true) String id) {
        WjxWjxx zyInfo = wjxWjxxService.getById(id);
        wjxWjxxService.removeById(id);
        QueryWrapper<WjxWjxx> zyInfoQueryWrapper = new QueryWrapper<>();
        zyInfoQueryWrapper.eq("rwbh", zyInfo.getRwbh());
        zyInfoQueryWrapper.eq("xqxn", zyInfo.getXqxn());
        zyInfoQueryWrapper.eq("atype", zyInfo.getAtype());
        zyInfoQueryWrapper.orderByAsc("sort-0");
        List<WjxWjxx> list = wjxWjxxService.list(zyInfoQueryWrapper);
        for (int i = 0; i < list.size(); i++) {
            WjxWjxx zyInfoPar = list.get(i);
            zyInfoPar.setSort(i + 1 + "");
            wjxWjxxService.updateById(zyInfoPar);
        }
        return Result.OK("删除成功!");
    }

    /**
     * 批量删除
     *
     * @param ids
     * @return
     */
    @AutoLog(value = "问卷信息-批量删除")
    @ApiOperation(value = "问卷信息-批量删除", notes = "问卷信息-批量删除")
    @RequiresPermissions("wjxWjxx:wjx_wjxx:deleteBatch")
    @DeleteMapping(value = "/deleteBatch")
    public Result<String> deleteBatch(@RequestParam(name = "ids", required = true) String ids) {
        this.wjxWjxxService.removeByIds(Arrays.asList(ids.split(",")));
        return Result.OK("批量删除成功!");
    }

    /**
     * 通过id查询
     *
     * @param id
     * @return
     */
    //@AutoLog(value = "问卷信息-通过id查询")
    @ApiOperation(value = "问卷信息-通过id查询", notes = "问卷信息-通过id查询")
    @GetMapping(value = "/queryById")
    public Result<WjxWjxx> queryById(@RequestParam(name = "id", required = true) String id) {
        WjxWjxx wjxWjxx = wjxWjxxService.getById(id);
        if (wjxWjxx == null) {
            return Result.error("未找到对应数据");
        }
        return Result.OK(wjxWjxx);
    }

    /**
     * 导出excel
     *
     * @param request
     * @param wjxWjxx
     */
    @RequiresPermissions("wjxWjxx:wjx_wjxx:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, WjxWjxx wjxWjxx) {
        return super.exportXls(request, wjxWjxx, WjxWjxx.class, "问卷信息");
    }

    /**
     * 通过excel导入数据
     *
     * @param request
     * @param response
     * @return
     */
    @RequiresPermissions("wjxWjxx:wjx_wjxx:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, WjxWjxx.class);
    }

    @ApiOperation(value = "问卷信息-通过id查询", notes = "问卷信息-通过id查询")
    @GetMapping(value = "/getWjxLogin")
    public Result<WjxWjxx> getWjxLogin() {
        try {
            // 注意这里仅为了简化编码每一次请求都去获取access_token，线上环境access_token有过期时间， 客户端可自行缓存，过期后重新获取。
            String accessToken = wjxAuthService.getAuth();
            System.out.println(accessToken);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return Result.OK(null);
    }

    @ApiOperation(value = "获取课程信息", notes = "获取课程信息")
    @GetMapping(value = "/kcxx")
    public Result<WjxWjxx> kcxx(@RequestParam(name = "rwbh", required = true) String rwbh, @RequestParam(name = "xqxn", required = true) String xqxn) {
        WjxWjxx wjxWjxx = wjxWjxxService.kcxx(rwbh, xqxn);
        return Result.OK(wjxWjxx);
    }

    @ApiOperation(value = "发布问卷", notes = "发布问卷")
    @GetMapping(value = "/fbwj")
    public Result<String> fbwj(@RequestParam(name = "id", required = true) String id, @RequestParam(name = "wjlx", required = true) String wjlx) {
        String res = wjxWjxxService.fbwj(id, wjlx);

        WjxWjxx wjxWjxx = wjxWjxxService.getById(id);
        QueryWrapper<Xxhbbks> queryWrapper = new QueryWrapper<>();
        queryWrapper.apply("a.xh = b.xh");
        queryWrapper.eq("b.KCAPZBBH", wjxWjxx.getRwbh());
        List<Xxhbbks> list = xxhbbksService.getXsxkbAllList(queryWrapper);
        String type = "";
        String content = "";

        LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
        if (StringUtils.equals(wjlx, "6")) {
            type = "2";
            content = sysUser.getRealname() + "教师发起了[" + wjxWjxx.getKcmc() + "]课程“" + wjxWjxx.getTitle() + "”测验,该测验完成时间： " + DateUtils.formatDate(wjxWjxx.getStartTime(), "yyyy-MM-dd") + " ~ " + DateUtils.formatDate(wjxWjxx.getEndTime(), "yyyy-MM-dd") + "，请及时完成";
        } else {
            type = "3";
            content = sysUser.getRealname() + "教师发起了[" + wjxWjxx.getKcmc() + "]课程“" + wjxWjxx.getTitle() + "”问卷,该问卷完成时间： " + DateUtils.formatDate(wjxWjxx.getStartTime(), "yyyy-MM-dd") + " ~ " + DateUtils.formatDate(wjxWjxx.getEndTime(), "yyyy-MM-dd") + "，请及时完成";
        }
        for (Xxhbbks xxhbbks : list) {

            //作业代办提醒
            ZyDbtx zyDbtx = new ZyDbtx();
            zyDbtx.setCreateBy(xxhbbks.getXh());
            zyDbtx.setType(type);//0发布作业 1评分 2测验 3问卷 4讨论
            zyDbtx.setMainId(wjxWjxx.getId());
            zyDbtx.setRwbh(wjxWjxx.getRwbh());
            zyDbtx.setContent(content);
            zyDbtx.setFlag("0");
            LoginUser user = (LoginUser) SecurityUtils.getSubject().getPrincipal();
            zyDbtx.setFbr(user.getUsername());
            zyDbtxService.save(zyDbtx);
//			try {
//				KcWechatSendLog kcWechatSendLog = new KcWechatSendLog();
//				 kcWechatSendLog.setOpenid(xxhbbks.getXh());
////				kcWechatSendLog.setOpenid("2016900057");//指定曹老师账号
//				kcWechatSendLog.setYtkcs(zyDbtx.getContent());
//				sendWxmessage(kcWechatSendLog);
//			}catch (Exception e){
//				e.printStackTrace();
//			}
        }
        return Result.OK(res);
    }


    @ApiOperation(value = "发布问卷", notes = "发布问卷")
    @GetMapping(value = "/sendWjWechat")
    public Result<WjxWjxx> sendWjWechat(@RequestParam(name = "id", required = true) String id, @RequestParam(name = "wjlx", required = true) String wjlx) {
        WjxWjxx wjxWjxx = wjxWjxxService.getById(id);
        QueryWrapper<Xxhbbks> queryWrapper = new QueryWrapper<>();
        queryWrapper.apply("a.xh = b.xh");
        queryWrapper.eq("b.KCAPZBBH", wjxWjxx.getRwbh());
        List<Xxhbbks> list = xxhbbksService.getXsxkbAllList(queryWrapper);
        String content = "";
        LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
        if (StringUtils.equals(wjlx, "6")) {
            content = sysUser.getRealname() + "教师发起了[" + wjxWjxx.getKcmc() + "]课程“" + wjxWjxx.getTitle() + "”测验,该测验完成时间： " + DateUtils.formatDate(wjxWjxx.getStartTime(), "yyyy-MM-dd") + " ~ " + DateUtils.formatDate(wjxWjxx.getEndTime(), "yyyy-MM-dd") + "，请及时完成";
        } else {
            content = sysUser.getRealname() + "教师发起了[" + wjxWjxx.getKcmc() + "]课程“" + wjxWjxx.getTitle() + "”问卷,该问卷完成时间： " + DateUtils.formatDate(wjxWjxx.getStartTime(), "yyyy-MM-dd") + " ~ " + DateUtils.formatDate(wjxWjxx.getEndTime(), "yyyy-MM-dd") + "，请及时完成";
        }
//		 for(Xxhbbks xxhbbks:list){
//			 try {
//				 KcWechatSendLog kcWechatSendLog = new KcWechatSendLog();
//				 kcWechatSendLog.setOpenid(xxhbbks.getXh());
////				 kcWechatSendLog.setOpenid("2016900057");//指定曹老师账号
//				 kcWechatSendLog.setYtkcs(content);
//				 sendWxmessage(kcWechatSendLog);
//			 }catch (Exception e){
//				 e.printStackTrace();
//			 }
//		 }
        return Result.OK(null);
    }

    // appId
    private static final String appId = "wx031697a8ca09a5ce";//东师

    private static final String agentid = "1000065";//
    // appIdSecret
    private static final String appIdSecret = "6Qhnge3xfzAQMDX2TcjEyE0vUGP96hP9OTYUsYBze2Y";//东师

    //微信通知点击后跳转的页面
    private static final String domainTo = "https://smartedu.nenu.edu.cn";

    public void sendWxmessage(KcWechatSendLog kcWechatSendLog) {
        String openId = kcWechatSendLog.getOpenid();//曹老师账号
        System.out.println("openId:" + openId + "");
        if (org.apache.commons.lang3.StringUtils.isNotEmpty(openId)) {
            try {
                String urlToken = "https://qyapi.weixin.qq.com/cgi-bin/gettoken?corpid=" + appId + "&corpsecret=" + appIdSecret;
                System.out.println("urlToken：  " + urlToken);
                String res = HttpUtil.get(urlToken);
                JSONObject jsonObjectToken = JSONObject.parseObject(res);
                System.out.println("jsonObjectToken：{}" + jsonObjectToken);
                String accessToken = jsonObjectToken.getString("access_token");
                System.out.println("accessToken：{}" + accessToken);

                // 微信的基础accessToken
                String url = "https://qyapi.weixin.qq.com/cgi-bin/message/send?access_token=" + accessToken;
                Map<String, Object> sendMag = new HashMap<>();

//				 1、xx老师，你好，您本学期（2023秋）听课要求为：5次，当前实际听课次数：3次，请尽快完成本学期的听课任务。
                String html = kcWechatSendLog.getYtkcs();
                html = html + "\n<a href=\"" + domainTo + "\">查看</a>";
                sendMag.put("content", html);//授课老师推送内容
                RestTemplate restTemplate = new RestTemplate();
                //拼接base参数
                Map<String, Object> sendBody = new HashMap<>();
                sendBody.put("touser", openId);                // openId
                sendBody.put("msgtype", "text");               // 消息类型，此时固定为：text
                sendBody.put("agentid", agentid);              // 企业id
                sendBody.put("text", sendMag);                //发送内容
                ResponseEntity<String> forEntity = restTemplate.postForEntity(url, sendBody, String.class);
                JSONObject jsonObject2 = JSONObject.parseObject(forEntity.getBody());
                System.out.println("jsonObject2 : " + jsonObject2);
                String messageCode = jsonObject2.getString("errcode");
                String msgId = jsonObject2.getString("msgid");
                System.out.println("messageCode : " + messageCode + ", msgId: " + msgId);
            } catch (Exception e) {
                e.printStackTrace();
            }
        } else {
        }
    }

    @ApiOperation(value = "统计分析", notes = "统计分析")
    @GetMapping(value = "/wjxxTjfx")
    public Result<JSONObject> wjxxTjfx(@RequestParam(name = "id", required = true) String id) {
        JSONObject res = wjxWjxxService.wjxxTjfx(id);

        return Result.OK(res);
    }

    @ApiOperation(value = "问卷下载", notes = "问卷下载")
    @GetMapping(value = "/wjxxDownLoad")
    public Result<JSONObject> wjxxDownLoad(@RequestParam(name = "id", required = true) String id) {
        JSONObject res = wjxWjxxService.wjxxDownLoad(id);
        return Result.OK(res);
    }


    @ApiOperation(value = "教学大纲-分页列表查询", notes = "教学大纲-分页列表查询")
    @GetMapping(value = "/sysList")
    public Result<IPage<KccyglSys>> sysList(KccyglSys kccyglSys,
                                            @RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo,
                                            @RequestParam(name = "pageSize", defaultValue = "10") Integer pageSize,
                                            HttpServletRequest req) {
        LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
        //-------------获取当前登陆人是否是管理员角色，如果不是都按照教务秘书处理---------------------------
        List<String> roleList = sysBaseApi.getRolesByUsername(sysUser.getUsername());
        String adminRole = "1";//0 admin  1教务秘书
        for (String role : roleList) {
            if (org.apache.commons.lang.StringUtils.equals("admin", role)) {
                adminRole = "0";
                break;
            }
        }
        QueryWrapper<KccyglSys> queryWrapper = new QueryWrapper<KccyglSys>();
        if (org.apache.commons.lang.StringUtils.equals("1", adminRole)) {
            QueryWrapper<KcExportConfigTpkwcqkjzglx> queryWrapperCon = new QueryWrapper<KcExportConfigTpkwcqkjzglx>();
            queryWrapperCon.eq("gh", sysUser.getUsername());
            queryWrapperCon.orderByDesc("create_time");
            queryWrapperCon.last("limit 1");
            KcExportConfigTpkwcqkjzglx kcExportConfigTpkwcqkjzglx = kcExportConfigTpkwcqkjzglxService.getOne(queryWrapperCon);
            queryWrapper.eq("kkdw", kcExportConfigTpkwcqkjzglx.getDwmc());
        }

        if (com.baomidou.mybatisplus.core.toolkit.StringUtils.isEmpty(kccyglSys.getXqxn())) {
            KcSysConfig kcSysConfig = kcSysConfigService.getById("1");
            queryWrapper.eq("xqxn", kcSysConfig.getFlag1());
        } else {
            queryWrapper.eq("xqxn", kccyglSys.getXqxn());
        }
        queryWrapper.like(com.baomidou.mybatisplus.core.toolkit.StringUtils.isNotEmpty(kccyglSys.getKkdw()), "kkdw", kccyglSys.getKkdw());
        queryWrapper.like(com.baomidou.mybatisplus.core.toolkit.StringUtils.isNotEmpty(kccyglSys.getKcmc()), "kcmc", kccyglSys.getKcmc());
        queryWrapper.like(com.baomidou.mybatisplus.core.toolkit.StringUtils.isNotEmpty(kccyglSys.getKcbh()), "kcbh", kccyglSys.getKcbh());
        queryWrapper.like(com.baomidou.mybatisplus.core.toolkit.StringUtils.isNotEmpty(kccyglSys.getSkjs()), "skjs", kccyglSys.getSkjs());

        Page<KccyglSys> page = new Page<KccyglSys>(pageNo, pageSize);
        IPage<KccyglSys> pageList = wjxWjxxService.sysList(page, queryWrapper, kccyglSys);
        return Result.OK(pageList);
    }


    @RequestMapping(value = "/exportSysXls")
    public ModelAndView exportSysXls(HttpServletRequest request, KccyglSys KccyglSys) {
        String title = "课程测验";
        // Step.1 组装查询条件
        QueryWrapper<KccyglSys> queryWrapper = new QueryWrapper<>();
        LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();


        //-------------获取当前登陆人是否是管理员角色，如果不是都按照教务秘书处理---------------------------
        List<String> roleList = sysBaseApi.getRolesByUsername(sysUser.getUsername());
        String adminRole = "1";//0 admin  1教务秘书
        for (String role : roleList) {
            if (org.apache.commons.lang.StringUtils.equals("admin", role)) {
                adminRole = "0";
                break;
            }
        }
        if (org.apache.commons.lang.StringUtils.equals("1", adminRole)) {
            QueryWrapper<KcExportConfigTpkwcqkjzglx> queryWrapperCon = new QueryWrapper<KcExportConfigTpkwcqkjzglx>();
            queryWrapperCon.eq("gh", sysUser.getUsername());
            queryWrapperCon.orderByDesc("create_time");
            queryWrapperCon.last("limit 1");
            KcExportConfigTpkwcqkjzglx kcExportConfigTpkwcqkjzglx = kcExportConfigTpkwcqkjzglxService.getOne(queryWrapperCon);
            queryWrapper.eq("kkdw", kcExportConfigTpkwcqkjzglx.getDwmc());
        }

        if (com.baomidou.mybatisplus.core.toolkit.StringUtils.isEmpty(KccyglSys.getXqxn())) {
            KcSysConfig kcSysConfig = kcSysConfigService.getById("1");
            queryWrapper.eq("xqxn", kcSysConfig.getFlag1());
        } else {
            queryWrapper.eq("xqxn", KccyglSys.getXqxn());
        }
        queryWrapper.like(com.baomidou.mybatisplus.core.toolkit.StringUtils.isNotEmpty(KccyglSys.getKkdw()), "kkdw", KccyglSys.getKkdw());
        queryWrapper.like(com.baomidou.mybatisplus.core.toolkit.StringUtils.isNotEmpty(KccyglSys.getKcmc()), "kcmc", KccyglSys.getKcmc());
        queryWrapper.like(com.baomidou.mybatisplus.core.toolkit.StringUtils.isNotEmpty(KccyglSys.getKcbh()), "kcbh", KccyglSys.getKcbh());
        queryWrapper.like(com.baomidou.mybatisplus.core.toolkit.StringUtils.isNotEmpty(KccyglSys.getSkjs()), "skjs", KccyglSys.getSkjs());

        // Step.2 获取导出数据
        List<KccyglSys> exportList = service.exportSysXls(queryWrapper, KccyglSys);

        // Step.3 AutoPoi 导出Excel
        ModelAndView mv = new ModelAndView(new JeecgEntityExcelView());
        //此处设置的filename无效 ,前端会重更新设置一下
        mv.addObject(NormalExcelConstants.FILE_NAME, title);
        mv.addObject(NormalExcelConstants.CLASS, KccyglSys.class);
        //update-begin--Author:liusq  Date:20210126 for：图片导出报错，ImageBasePath未设置--------------------
        ExportParams exportParams = new ExportParams(title + "报表", "导出人:" + sysUser.getRealname(), title);
        exportParams.setImageBasePath(upLoadPath);
        //update-end--Author:liusq  Date:20210126 for：图片导出报错，ImageBasePath未设置----------------------
        mv.addObject(NormalExcelConstants.PARAMS, exportParams);
        mv.addObject(NormalExcelConstants.DATA_LIST, exportList);
        return mv;
    }


    @ApiOperation(value="判断学生是否答过题", notes="判断学生是否答过题")
    @GetMapping(value = "/querySfdtById")
    public Result<WjxWjxx> querySfdtById(@RequestParam(name="id",required=true) String id) {
        LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
        String num = wjxWjxxService.querySfdtById(id,sysUser.getUsername());
        WjxWjxx WjxWjxx = new WjxWjxx();
        WjxWjxx.setNum(num);
        return Result.OK(WjxWjxx);
    }


    @ApiOperation(value = "是否是学生-是否允许答卷", notes = "是否是学生-是否允许答卷")
    @GetMapping(value = "/getSfxs")
    public Result<WjxWjxx> getSfxs(@RequestParam(name = "id", required = true) String id) {
        WjxWjxx WjxWjxx = wjxWjxxService.getById(id);
        if (WjxWjxx == null) {
            return Result.error("未找到对应数据");
        }

        LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
        QueryWrapper<Xxhbbks> queryWrapper = new QueryWrapper<>();
        queryWrapper.apply("a.xh = b.xh");
        queryWrapper.eq("b.KCAPZBBH", WjxWjxx.getRwbh());
        WjxWjxx.setNum("0");//不是本次学生，不可以答卷
        List<Xxhbbks> list = xxhbbksService.getXsxkbAllList(queryWrapper);
        for (Xxhbbks par : list) {
            String xh = par.getXh();
            if (org.apache.commons.lang.StringUtils.equals(xh, sysUser.getUsername())) {
                WjxWjxx.setNum("1");
                break;
            }
        }
        return Result.OK(WjxWjxx);

    }


    @ApiOperation(value = "测验结果-通过id查询", notes = "测验结果-通过id查询")
    @GetMapping(value = "/queryCyjgById")
    public Result<WjxWjxx> queryCyjgById(@RequestParam(name = "id", required = true) String id) {
        WjxWjxx wjxWjxx = wjxWjxxService.queryCyjgById(id);
        if (wjxWjxx == null) {
            return Result.error("未找到对应数据");
        }
        return Result.OK(wjxWjxx);
    }


    @ApiOperation(value = "问卷信息-微信提醒", notes = "微信提醒")
    @GetMapping(value = "/sendWxtx")
    public void sendWxtx(@RequestParam(name = "id", required = true) String id, @RequestParam(name = "wjlx", required = true) String wjlx) {
        WjxWjxx wjxWjxx = wjxWjxxService.getById(id);
        QueryWrapper<Xxhbbks> queryWrapper = new QueryWrapper<>();
        queryWrapper.apply("a.xh = b.xh");
        queryWrapper.eq("b.KCAPZBBH", wjxWjxx.getRwbh());
        List<Xxhbbks> list = xxhbbksService.getXsxkbAllList(queryWrapper);
        String content = "";

        LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
        if (StringUtils.equals(wjlx, "6")) {
            content = sysUser.getRealname() + "教师发起了[" + wjxWjxx.getKcmc() + "]课程“" + wjxWjxx.getTitle() + "”测验,该测验完成时间： " + DateUtils.formatDate(wjxWjxx.getStartTime(), "yyyy-MM-dd") + " ~ " + DateUtils.formatDate(wjxWjxx.getEndTime(), "yyyy-MM-dd") + "，请及时完成";
        } else {
            content = sysUser.getRealname() + "教师发起了[" + wjxWjxx.getKcmc() + "]课程“" + wjxWjxx.getTitle() + "”问卷,该问卷完成时间： " + DateUtils.formatDate(wjxWjxx.getStartTime(), "yyyy-MM-dd") + " ~ " + DateUtils.formatDate(wjxWjxx.getEndTime(), "yyyy-MM-dd") + "，请及时完成";
        }
        for (Xxhbbks xxhbbks : list) {

            try {
                KcWechatSendLog kcWechatSendLog = new KcWechatSendLog();
                kcWechatSendLog.setOpenid(xxhbbks.getXh());
//				kcWechatSendLog.setOpenid("2016900057");//指定曹老师账号
                kcWechatSendLog.setYtkcs(content);
//                sendWxmessage(kcWechatSendLog);
            } catch (Exception e) {
                e.printStackTrace();
            }
            break;
        }
    }


    @ApiOperation(value = "问卷信息-分页列表查询", notes = "问卷信息-分页列表查询")
    @GetMapping(value = "/listOther")
    public Result<IPage<WjxWjxx>> listOther(WjxWjxx wjxWjxx,
                                            @RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo,
                                            @RequestParam(name = "pageSize", defaultValue = "10") Integer pageSize,
                                            HttpServletRequest req) {
        LoginUser user = (LoginUser) SecurityUtils.getSubject().getPrincipal();
        wjxWjxx.setTeacherNo(user.getUsername());
        Page<WjxWjxx> pageList = wjxWjxxService.listOther(wjxWjxx, new Page<>(pageNo, pageSize));
        return Result.OK(pageList);
    }

    @GetMapping(value = "/khclList")
    public Result<IPage<WjxWjxx>> khclList(WjxWjxx wjxWjxx,
                                           @RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo,
                                           @RequestParam(name = "pageSize", defaultValue = "10") Integer pageSize,
                                           HttpServletRequest req) {

        QueryWrapper<WjxWjxx> queryWrapper = QueryGenerator.initQueryWrapper(wjxWjxx, req.getParameterMap());
        Page<WjxWjxx> page = new Page<WjxWjxx>(pageNo, pageSize);
        IPage<WjxWjxx> pageList = wjxWjxxService.page(page, queryWrapper);
        return Result.OK(pageList);
    }


    @PostMapping(value = "/uploadSckhcl")
    public Result<String> uploadSckhcl(@RequestBody WjxWjxx wjxWjxx) {
        try {
            System.out.println("ids:" + wjxWjxx.getId());
            wjxWjxxService.batchZyinfoKhcl(wjxWjxx.getId());
        } catch (Exception e) {
            e.printStackTrace();
        }

        return Result.OK("考核材料上传成功!");
    }

}
