package org.jeecg.modules.kc.wjxWjxx.entity;

import java.io.Serializable;
import java.util.Date;
import java.util.List;

import com.baomidou.mybatisplus.annotation.*;
import lombok.Data;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.jeecg.modules.kc.wjxWjxxTmlb.entity.WjxWjxxTmlb;
import org.jeecg.modules.kc.wjxWjxxTmlb.vo.WjxWjxxTmlbPage;
import org.springframework.format.annotation.DateTimeFormat;
import org.jeecgframework.poi.excel.annotation.Excel;
import org.jeecg.common.aspect.annotation.Dict;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * @Description: 问卷信息
 * @Author: jeecg-boot
 * @Date:   2024-04-26
 * @Version: V1.0
 */
@Data
@TableName("wjx_wjxx")
@Accessors(chain = true)
@EqualsAndHashCode(callSuper = false)
@ApiModel(value="wjx_wjxx对象", description="问卷信息")
public class WjxWjxx implements Serializable {
    private static final long serialVersionUID = 1L;

	/**id*/
	@TableId(type = IdType.ASSIGN_ID)
    @ApiModelProperty(value = "id")
    private java.lang.String id;
	/**创建人*/
    @ApiModelProperty(value = "创建人")
    private java.lang.String createBy;
	/**创建时间*/
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd")
    @DateTimeFormat(pattern="yyyy-MM-dd")
    @ApiModelProperty(value = "创建时间")
    private java.util.Date createTime;
	/**修改人*/
    @ApiModelProperty(value = "修改人")
    private java.lang.String updateBy;
	/**修改时间*/
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd")
    @DateTimeFormat(pattern="yyyy-MM-dd")
    @ApiModelProperty(value = "修改时间")
    private java.util.Date updateTime;
	/**创建账号*/
	@Excel(name = "创建账号", width = 15)
    @ApiModelProperty(value = "创建账号")
    private java.lang.String creater;
	/**问卷类型*/
	@Excel(name = "问卷类型", width = 15)
    @ApiModelProperty(value = "问卷类型")
    private java.lang.String atype;
	/**问卷名称*/
	@Excel(name = "问卷名称", width = 15)
    @ApiModelProperty(value = "问卷名称")
    private java.lang.String title;
	/**问卷描述*/
	@Excel(name = "问卷描述", width = 15)
    @ApiModelProperty(value = "问卷描述")
    private java.lang.String content;
	/**是否发布问卷*/
	@Excel(name = "是否发布问卷", width = 15, dicCode = "yn")
	@Dict(dicCode = "zy_status")
    @ApiModelProperty(value = "是否发布问卷")
    private java.lang.String qpublish;
	/**是否图片压缩*/
	@Excel(name = "是否图片压缩", width = 15)
    @ApiModelProperty(value = "是否图片压缩")
    private java.lang.String compressImg;
	/**题目列表*/
	@Excel(name = "题目列表", width = 15)
    @ApiModelProperty(value = "题目列表")
    private java.lang.String questions;

    @ApiModelProperty(value = "问卷编号")
    private String vid;
    @ApiModelProperty(value = "学期学年")
    private String xqxn;
    @ApiModelProperty(value = "任务编号")
    private String rwbh;
    @ApiModelProperty(value = "课程名称")
    private String kcmc;
    @ApiModelProperty(value = "选课人数")
    private String xkrs;
    @ApiModelProperty(value = "已完成人数")
    @TableField(exist = false)
    private Integer ywcrs;
    @ApiModelProperty(value = "未完成人数")
    @TableField(exist = false)
    private Integer wwcrs;
    @ApiModelProperty(value = "开始时间")
    @JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
    private Date startTime;
    @ApiModelProperty(value = "结束时间")
    @JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
    private Date endTime;
    @ApiModelProperty(value = "防作弊模式：Y-开启  N-关闭")
    private String fzbms;
    @ApiModelProperty(value = "作答时限（答题时间限制）")
    private Integer zdsx;

    private String sort;//排序
    private String score;//占比
    private String kcnr;//占比

    @Dict(dicCode = "sfsckhcl")
    private String sfsckhcl;//是否上传考核材料（0否  1是）
    @JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
    private Date sfsckhclTime;//上传考核材料时间


    @ApiModelProperty(value = "答卷状态标识")
    @TableField(exist = false)
    private String flag;// -1 未答卷 0已答卷 1已答卷查询
    @ApiModelProperty(value = "学生学号")
    @TableField(exist = false)
    private String userId;
    @ApiModelProperty(value = "答卷ID")
    @TableField(exist = false)
    private String djId;

    @ApiModelProperty(value = "开始时间")
    @JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    private Date zyStartTime;
    @ApiModelProperty(value = "结束时间")
    @JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    private Date zyEndTime;
    @TableField(exist = false)
    private String teano;

    @TableField(exist = false)
    private String skjs;

    @TableField(exist = false)
    private String num;


    @TableField(exist = false)
    private String titleNull;

    @TableField(exist = false)
    List<WjxWjxxTmlbPage> list;
    @TableField(exist = false)
    List<WjxWjxxTmlb> tmlbList;
    @TableField(exist = false)
    private String teacherNo;
    @TableField(exist = false)
    private String yuanTeacherNo;
    @TableField(exist = false)
    private String yuanTeacherName;
    @TableField(exist = false)
    private String ts;
    @TableField(exist = false)
    private String errorMsg;
}
