package org.jeecg.modules.kc.wjxWjxx.utils;

import com.alibaba.fastjson.JSONObject;
import org.jeecg.modules.tools.baidu.HttpUtil;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.time.Instant;
import java.util.Arrays;
import java.util.Map;
import java.util.Set;

@Service
public class WjxUtil {

    private static final Logger logger = LoggerFactory.getLogger(WjxUtil.class);

    @Autowired
    private WjxConfig wjxConfig;

    public String openapi(final Map<String, Object> data,String anction){
        String result = "";
        String sign = "";
        Long unixTimestamp = Instant.now().getEpochSecond();
        String ts = unixTimestamp.toString();
        data.put("appid",wjxConfig.getAppid());
        data.put("ts",ts);
        data.put("action",anction);
        data.put("encode","sha1");
        try {
            sign = generateSignature(data);
        }catch (Exception e) {
            e.printStackTrace();
        }
//        System.out.println("sign: "+sign);
        data.put("sign",sign);
        System.out.println("wjx_data--->:"+data.toString());
        String url = "https://www.wjx.cn/openapi/default.aspx";
        try {
            JSONObject json = new JSONObject(data);
            System.out.println("json:"+json.toString());
            result = HttpUtil.post(url, "" , "application/json", json.toString());
//            System.out.println(result);
        }catch (Exception e) {
            e.printStackTrace();
        }
        return result;
    }

    public String generateSignature(final Map<String, Object> data) throws Exception{
        String key = wjxConfig.getAppkey();
        Set<String> keySet = data.keySet();
        String[] keyArray = keySet.toArray(new String[keySet.size()]);
        Arrays.sort(keyArray);
        StringBuilder sb = new StringBuilder();
        for (String k : keyArray) {
            if (data.get(k).toString().length() > 0) // 参数值为空，则不参与签名
                sb.append(data.get(k).toString());
        }
        sb.append(key);
        return getSHA1(sb.toString()).toUpperCase();
    }

    public String getSHA1(String input) {
        try {
            MessageDigest sha1 = MessageDigest.getInstance("SHA-1");
            byte[] bytes = sha1.digest(input.getBytes());
            StringBuilder sb = new StringBuilder();
            for (byte b : bytes) {
                sb.append(String.format("%02x", b));//十六进制
            }
            return sb.toString();
        } catch (NoSuchAlgorithmException e) {
            throw new RuntimeException(e);
        }
    }

}
