package org.jeecg.modules.kc.wjxWjxxTmlb.entity;

import java.io.Serializable;

import com.baomidou.mybatisplus.annotation.*;
import lombok.Data;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.jeecg.common.aspect.annotation.Dict;
import org.springframework.format.annotation.DateTimeFormat;
import org.jeecgframework.poi.excel.annotation.Excel;
import java.util.Date;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.UnsupportedEncodingException;

/**
 * @Description: 选项信息
 * @Author: jeecg-boot
 * @Date:   2024-04-26
 * @Version: V1.0
 */
@ApiModel(value="wjx_wjxx_tmxx对象", description="选项信息")
@Data
@TableName("wjx_wjxx_tmxx")
public class WjxWjxxTmxx implements Serializable {
    private static final long serialVersionUID = 1L;

	/**id*/
	@TableId(type = IdType.ASSIGN_ID)
    @ApiModelProperty(value = "id")
    private java.lang.String id;
	/**创建人*/
    @ApiModelProperty(value = "创建人")
    private java.lang.String createBy;
	/**创建时间*/
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd")
    @DateTimeFormat(pattern="yyyy-MM-dd")
    @ApiModelProperty(value = "创建时间")
    private java.util.Date createTime;
	/**修改人*/
    @ApiModelProperty(value = "修改人")
    private java.lang.String updateBy;
	/**修改时间*/
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd")
    @DateTimeFormat(pattern="yyyy-MM-dd")
    @ApiModelProperty(value = "修改时间")
    private java.util.Date updateTime;
	/**问题编号*/
    @ApiModelProperty(value = "问题编号")
    private java.lang.Integer wjIndex;
	/**选项编号*/
	@Excel(name = "选项编号", width = 15)
    @ApiModelProperty(value = "选项编号")
    private java.lang.Integer itemIndex;
	/**选项标题*/
	@Excel(name = "选项标题", width = 15)
    @ApiModelProperty(value = "选项标题")
    private java.lang.String itemTitle;
	/**选项文字描述*/
    @ApiModelProperty(value = "选项文字描述")
    private java.lang.String itemImageText;
	/**正确答案*/
	@Excel(name = "正确答案", width = 15)
    @ApiModelProperty(value = "正确答案")
    @Dict(dicCode = "wj_zqda")
    private java.lang.String itemSelected;
	/**选项分值*/
    @ApiModelProperty(value = "选项分值")
    private java.lang.Double itemScore;

    private String mainId;

    @TableField(exist = false)
    private String num;

    @ApiModelProperty(value = "量表题标识，对应接口questions参数的key：items列内容item_rows行标题")
    private java.lang.String scaleSign;

    @ApiModelProperty(value = "量表题用对应item_rows的q_index")
    private java.lang.Integer scaleItemrowsQIndex;

    @ApiModelProperty(value = "量表题用对应item_rows的item_index")
    private java.lang.Integer scaleItemrowsItemIndex;

    @ApiModelProperty(value = "量表题用对应item_rows的item_title")
    private java.lang.String scaleItemrowsItemTitle;

    @ApiModelProperty(value = "量表题用对应items的item_score")
    private java.lang.String scaleItemsItemScore;

    @ApiModelProperty(value = "量表题用对应items的item_title")
    private java.lang.String scaleItemsItemTitle;
}
