package org.jeecg.modules.kc.xxhbfxcjb0016.controller;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.kc.xxhbfxcjb0016.entity.Xxhbfxcjb0016;
import org.jeecg.modules.kc.xxhbfxcjb0016.service.IXxhbfxcjb0016Service;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

 /**
 * @Description: 分项成绩表
 * @Author: jeecg-boot
 * @Date:   2025-01-22
 * @Version: V1.0
 */
@Api(tags="分项成绩表")
@RestController
@RequestMapping("/xxhbfxcjb0016/xxhbfxcjb0016")
@Slf4j
public class Xxhbfxcjb0016Controller extends JeecgController<Xxhbfxcjb0016, IXxhbfxcjb0016Service> {
	@Autowired
	private IXxhbfxcjb0016Service xxhbfxcjb0016Service;
	
	/**
	 * 分页列表查询
	 *
	 * @param xxhbfxcjb0016
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "分项成绩表-分页列表查询")
	@ApiOperation(value="分项成绩表-分页列表查询", notes="分项成绩表-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<Xxhbfxcjb0016>> queryPageList(Xxhbfxcjb0016 xxhbfxcjb0016,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<Xxhbfxcjb0016> queryWrapper = QueryGenerator.initQueryWrapper(xxhbfxcjb0016, req.getParameterMap());
		Page<Xxhbfxcjb0016> page = new Page<Xxhbfxcjb0016>(pageNo, pageSize);
		IPage<Xxhbfxcjb0016> pageList = xxhbfxcjb0016Service.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param xxhbfxcjb0016
	 * @return
	 */
	@AutoLog(value = "分项成绩表-添加")
	@ApiOperation(value="分项成绩表-添加", notes="分项成绩表-添加")
	@RequiresPermissions("xxhbfxcjb0016:xxhbfxcjb0016:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody Xxhbfxcjb0016 xxhbfxcjb0016) {
		xxhbfxcjb0016Service.save(xxhbfxcjb0016);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param xxhbfxcjb0016
	 * @return
	 */
	@AutoLog(value = "分项成绩表-编辑")
	@ApiOperation(value="分项成绩表-编辑", notes="分项成绩表-编辑")
	@RequiresPermissions("xxhbfxcjb0016:xxhbfxcjb0016:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody Xxhbfxcjb0016 xxhbfxcjb0016) {
		xxhbfxcjb0016Service.updateById(xxhbfxcjb0016);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "分项成绩表-通过id删除")
	@ApiOperation(value="分项成绩表-通过id删除", notes="分项成绩表-通过id删除")
	@RequiresPermissions("xxhbfxcjb0016:xxhbfxcjb0016:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		xxhbfxcjb0016Service.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "分项成绩表-批量删除")
	@ApiOperation(value="分项成绩表-批量删除", notes="分项成绩表-批量删除")
	@RequiresPermissions("xxhbfxcjb0016:xxhbfxcjb0016:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.xxhbfxcjb0016Service.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "分项成绩表-通过id查询")
	@ApiOperation(value="分项成绩表-通过id查询", notes="分项成绩表-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<Xxhbfxcjb0016> queryById(@RequestParam(name="id",required=true) String id) {
		Xxhbfxcjb0016 xxhbfxcjb0016 = xxhbfxcjb0016Service.getById(id);
		if(xxhbfxcjb0016==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(xxhbfxcjb0016);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param xxhbfxcjb0016
    */
    @RequiresPermissions("xxhbfxcjb0016:xxhbfxcjb0016:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, Xxhbfxcjb0016 xxhbfxcjb0016) {
        return super.exportXls(request, xxhbfxcjb0016, Xxhbfxcjb0016.class, "分项成绩表");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("xxhbfxcjb0016:xxhbfxcjb0016:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, Xxhbfxcjb0016.class);
    }

}
