package org.jeecg.modules.kc.xxhbfxcjmxb0015.controller;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.kc.xxhbfxcjmxb0015.entity.Xxhbfxcjmxb0015;
import org.jeecg.modules.kc.xxhbfxcjmxb0015.service.IXxhbfxcjmxb0015Service;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

 /**
 * @Description: 分项成绩明细表
 * @Author: jeecg-boot
 * @Date:   2025-01-22
 * @Version: V1.0
 */
@Api(tags="分项成绩明细表")
@RestController
@RequestMapping("/xxhbfxcjmxb0015/xxhbfxcjmxb0015")
@Slf4j
public class Xxhbfxcjmxb0015Controller extends JeecgController<Xxhbfxcjmxb0015, IXxhbfxcjmxb0015Service> {
	@Autowired
	private IXxhbfxcjmxb0015Service xxhbfxcjmxb0015Service;
	
	/**
	 * 分页列表查询
	 *
	 * @param xxhbfxcjmxb0015
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "分项成绩明细表-分页列表查询")
	@ApiOperation(value="分项成绩明细表-分页列表查询", notes="分项成绩明细表-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<Xxhbfxcjmxb0015>> queryPageList(Xxhbfxcjmxb0015 xxhbfxcjmxb0015,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<Xxhbfxcjmxb0015> queryWrapper = QueryGenerator.initQueryWrapper(xxhbfxcjmxb0015, req.getParameterMap());
		Page<Xxhbfxcjmxb0015> page = new Page<Xxhbfxcjmxb0015>(pageNo, pageSize);
		IPage<Xxhbfxcjmxb0015> pageList = xxhbfxcjmxb0015Service.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param xxhbfxcjmxb0015
	 * @return
	 */
	@AutoLog(value = "分项成绩明细表-添加")
	@ApiOperation(value="分项成绩明细表-添加", notes="分项成绩明细表-添加")
	@RequiresPermissions("xxhbfxcjmxb0015:xxhbfxcjmxb0015:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody Xxhbfxcjmxb0015 xxhbfxcjmxb0015) {
		xxhbfxcjmxb0015Service.save(xxhbfxcjmxb0015);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param xxhbfxcjmxb0015
	 * @return
	 */
	@AutoLog(value = "分项成绩明细表-编辑")
	@ApiOperation(value="分项成绩明细表-编辑", notes="分项成绩明细表-编辑")
	@RequiresPermissions("xxhbfxcjmxb0015:xxhbfxcjmxb0015:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody Xxhbfxcjmxb0015 xxhbfxcjmxb0015) {
		xxhbfxcjmxb0015Service.updateById(xxhbfxcjmxb0015);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "分项成绩明细表-通过id删除")
	@ApiOperation(value="分项成绩明细表-通过id删除", notes="分项成绩明细表-通过id删除")
	@RequiresPermissions("xxhbfxcjmxb0015:xxhbfxcjmxb0015:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		xxhbfxcjmxb0015Service.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "分项成绩明细表-批量删除")
	@ApiOperation(value="分项成绩明细表-批量删除", notes="分项成绩明细表-批量删除")
	@RequiresPermissions("xxhbfxcjmxb0015:xxhbfxcjmxb0015:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.xxhbfxcjmxb0015Service.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "分项成绩明细表-通过id查询")
	@ApiOperation(value="分项成绩明细表-通过id查询", notes="分项成绩明细表-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<Xxhbfxcjmxb0015> queryById(@RequestParam(name="id",required=true) String id) {
		Xxhbfxcjmxb0015 xxhbfxcjmxb0015 = xxhbfxcjmxb0015Service.getById(id);
		if(xxhbfxcjmxb0015==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(xxhbfxcjmxb0015);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param xxhbfxcjmxb0015
    */
    @RequiresPermissions("xxhbfxcjmxb0015:xxhbfxcjmxb0015:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, Xxhbfxcjmxb0015 xxhbfxcjmxb0015) {
        return super.exportXls(request, xxhbfxcjmxb0015, Xxhbfxcjmxb0015.class, "分项成绩明细表");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("xxhbfxcjmxb0015:xxhbfxcjmxb0015:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, Xxhbfxcjmxb0015.class);
    }

}
