package org.jeecg.modules.kc.zyCcjg.entity;

import java.io.Serializable;
import java.io.UnsupportedEncodingException;
import java.util.Date;
import java.math.BigDecimal;

import com.baomidou.mybatisplus.annotation.*;
import lombok.Data;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;
import org.jeecgframework.poi.excel.annotation.Excel;
import org.jeecg.common.aspect.annotation.Dict;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * @Description: 查重结果
 * @Author: jeecg-boot
 * @Date:   2024-05-07
 * @Version: V1.0
 */
@Data
@TableName("zy_ccjg")
@Accessors(chain = true)
@EqualsAndHashCode(callSuper = false)
@ApiModel(value="zy_ccjg对象", description="查重结果")
public class ZyCcjg implements Serializable {
    private static final long serialVersionUID = 1L;

	/**id*/
	@TableId(type = IdType.ASSIGN_ID)
    @ApiModelProperty(value = "id")
    private java.lang.String id;
	/**createBy*/
    @ApiModelProperty(value = "createBy")
    private java.lang.String createBy;
	/**createTime*/
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd")
    @DateTimeFormat(pattern="yyyy-MM-dd")
    @ApiModelProperty(value = "createTime")
    private java.util.Date createTime;
	/**updateBy*/
    @ApiModelProperty(value = "updateBy")
    private java.lang.String updateBy;
	/**updateTime*/
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd")
    @DateTimeFormat(pattern="yyyy-MM-dd")
    @ApiModelProperty(value = "updateTime")
    private java.util.Date updateTime;
	/**学生作业*/
	@Excel(name = "学生作业", width = 15)
    @ApiModelProperty(value = "学生作业")
    private java.lang.String zyStuId;
	/**文档id
*/
	@Excel(name = "文档id", width = 15)
    @ApiModelProperty(value = "文档id")
    private java.lang.String paperid;
	/**报告编号*/
	@Excel(name = "报告编号", width = 15)
    @ApiModelProperty(value = "报告编号")
    private java.lang.String paperguid;
	/**文件名
*/
	@Excel(name = "文件名", width = 15)
    @ApiModelProperty(value = "文件名")
    private java.lang.String papertitle;
	/**检测状态(1:检测中,2:检测完成,3:检测失败,0:未检测)
*/
	@Excel(name = "检测状态(1:检测中,2:检测完成,3:检测失败,0:未检测)", width = 15)
    @ApiModelProperty(value = "检测状态(1:检测中,2:检测完成,3:检测失败,0:未检测)")
    private java.lang.String filestateid;
	/**检测进度*/
	@Excel(name = "检测进度", width = 15)
    @ApiModelProperty(value = "检测进度")
    private java.lang.String detectprogress;
	/**相似率
*/
	@Excel(name = "相似率", width = 15)
    @ApiModelProperty(value = "相似率")
    private java.lang.String percentage;
	/**引用率*/
	@Excel(name = "引用率", width = 15)
    @ApiModelProperty(value = "引用率")
    private java.lang.String quotepercentage;
	/**复写率*/
	@Excel(name = "复写率", width = 15)
    @ApiModelProperty(value = "复写率")
    private java.lang.String duplicatepercentage;
	/**自写率*/
	@Excel(name = "自写率", width = 15)
    @ApiModelProperty(value = "自写率")
    private java.lang.String ownpercentage;
	/**文档检测完成时间
*/
	@Excel(name = "文档检测完成时间", width = 15)
    @ApiModelProperty(value = "文档检测完成时间")
    private java.lang.String checkdate;
	/**论文字数
*/
	@Excel(name = "论文字数", width = 15)
    @ApiModelProperty(value = "论文字数")
    private java.lang.String paperword;
	/**在线报告查看地址*/
	@Excel(name = "在线报告查看地址", width = 15)
    @ApiModelProperty(value = "在线报告查看地址")
    private java.lang.String paperviewurl;
	/**报告下载地址
*/
	@Excel(name = "报告下载地址", width = 15)
    @ApiModelProperty(value = "报告下载地址")
    private java.lang.String paperdownurl;
	/**他引率
*/
	@Excel(name = "他引率", width = 15)
    @ApiModelProperty(value = "他引率")
    private java.lang.String otherquoterate;
	/**自引率
*/
	@Excel(name = "自引率", width = 15)
    @ApiModelProperty(value = "自引率")
    private java.lang.String selfquoterate;
	/**专业术语率
*/
	@Excel(name = "专业术语率", width = 15)
    @ApiModelProperty(value = "专业术语率")
    private java.lang.String proWordRate;
	/**查重类型（0外网 1内网 2aigc）*/
	@Excel(name = "查重类型（0外网 1内网 2aigc）", width = 15)
    @ApiModelProperty(value = "查重类型（0外网 1内网 2aigc）")
    private java.lang.String ccType;

    private java.lang.String bdkbs;//比对库标识
    private java.lang.String aiRate;//疑似ai全文占比
    private java.lang.String humanRate;//人工占比
    private java.lang.String message;//
    private java.lang.String paichupercentage;//他引率
    private java.lang.String authorpercentage;//专业术语率


    @TableField(exist = false)
    private String cateid;



    @TableField(exist = false)
    private String xnxq;
    @TableField(exist = false)
    private String title;
    @TableField(exist = false)
    private String teaNo;
    @TableField(exist = false)
    private String teaName;
    @TableField(exist = false)
    private String stuNo;
    @TableField(exist = false)
    private String stuName;
    @TableField(exist = false)
    private String bdkname;



}
