package org.jeecg.modules.kc.zyCcjg.service.impl;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import org.apache.commons.lang3.StringUtils;
import org.jeecg.modules.kc.blZycc.entity.BlZycc;
import org.jeecg.modules.kc.zyCcjg.entity.ZyCcjg;
import org.jeecg.modules.kc.zyCcjg.mapper.ZyCcjgMapper;
import org.jeecg.modules.kc.zyCcjg.service.IZyCcjgService;
import org.jeecg.modules.kc.zyInfo.entity.ZyInfo;
import org.jeecg.modules.kc.zyInfo.service.IZyInfoService;
import org.jeecg.modules.kc.zyInfoStudent.entity.ZyInfoStudent;
import org.jeecg.modules.kc.zyInfoStudent.mapper.ZyInfoStudentMapper;
import org.jeecg.modules.kc.zyInfoStudent.service.IZyInfoStudent2Service;
import org.jeecg.modules.kc.zyInfoStudent.service.IZyInfoStudentService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;

import javax.activation.MimetypesFileTypeMap;
import javax.servlet.http.HttpServletResponse;
import java.io.*;
import java.net.HttpURLConnection;
import java.net.URL;
import java.nio.charset.StandardCharsets;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * @Description: 查重结果
 * @Author: jeecg-boot
 * @Date:   2024-05-07
 * @Version: V1.0
 */
@Service
public class ZyCcjgServiceImpl extends ServiceImpl<ZyCcjgMapper, ZyCcjg> implements IZyCcjgService {



    private static String uploadpath;

    @Value("${jeecg.path.upload}")
    public void setUploadPath(String uploadPath) {
        this.uploadpath = uploadPath;
    }

    private static String weipuId;

    @Value("${weipu.userId}")
    public void setWeipuId(String weipuId) {
        this.weipuId = weipuId;
    }


    private static String weipuKey;
    @Value("${weipu.userKey}")
    public void setWeipuKey(String weipuKey) {
        this.weipuKey = weipuKey;
    }




    @Autowired
    private IZyInfoService zyInfoService;

    @Autowired
    private ZyInfoStudentMapper zyInfoStudentService;

    @Autowired
    private IZyInfoStudentService zyInfoNewStudentService;
    @Autowired
    private IZyInfoStudent2Service zyInfoNewStudent2Service;


    @Override
    public void getCcjg() {
        QueryWrapper<ZyCcjg> zyCcjgQueryWrapper = new QueryWrapper<>();
        zyCcjgQueryWrapper.in("filestateid",0,1);//检测状态(1:检测中,2:检测完成,3:检测失败,0:未检测)

        List<ZyCcjg> list = baseMapper.selectList(zyCcjgQueryWrapper);
        for(ZyCcjg par : list){
            //查重类型（0外网 1内网 2aigc 3校内）
            if(StringUtils.equals(par.getCcType(), "0")){
                try {
                    wwCxjcjg(par);
                }catch (Exception e){
                    e.printStackTrace();
                }
            }else if(StringUtils.equals(par.getCcType(), "1")){
                try {
                    xfwbdCxjcjg(par);
                }catch (Exception e){
                    e.printStackTrace();
                }

            }else if(StringUtils.equals(par.getCcType(), "2")){
                try {
                    aigcCxjcjg(par);
                }catch (Exception e){
                    e.printStackTrace();
                }
            }else if(StringUtils.equals(par.getCcType(), "3")){
                try {
                    xnCxjcjg(par);
                }catch (Exception e){
                    e.printStackTrace();
                }
            }
        }
    }

    @Override
    public IPage<ZyCcjg> getQuaList(Page<ZyCcjg> page, QueryWrapper<ZyCcjg> queryWrapper) {
        return baseMapper.getQuaList(page, queryWrapper);
    }

    @Override
    public void deleteByZystuid(String id, HttpServletResponse response) {
        ZyInfoStudent zyInfoStudent = zyInfoStudentService.selectById(id);
        //删除维普已经提交的文档
//        zyInfoNewStudentService.delweipulunwen(zyInfoStudent, response);
        baseMapper.deleteByZystuid(id);
    }

    @Override
    public List<ZyCcjg> ccjglist(QueryWrapper<ZyCcjg> queryWrapper) {
        return  baseMapper.ccjglist(queryWrapper);
    }

    //更新指定查重结果
    @Override
    public void updateCcjg(String paperId) {
        QueryWrapper<ZyCcjg> zyCcjgQueryWrapper = new QueryWrapper<>();
        zyCcjgQueryWrapper.eq("paperid",paperId);//检测状态(1:检测中,2:检测完成,3:检测失败,0:未检测)
        zyCcjgQueryWrapper.last("limit 1");
        ZyCcjg par = baseMapper.selectOne(zyCcjgQueryWrapper);
        if(par!=null){
            if(StringUtils.equals(par.getCcType(), "0")){
                try {
                    wwCxjcjg(par);
                }catch (Exception e){
                    e.printStackTrace();
                }
            }else if(StringUtils.equals(par.getCcType(), "1")){
                try {
                    xfwbdCxjcjg(par);
                }catch (Exception e){
                    e.printStackTrace();
                }

            }else if(StringUtils.equals(par.getCcType(), "2")){
                try {
                    aigcCxjcjg(par);
                }catch (Exception e){
                    e.printStackTrace();
                }
            }else if(StringUtils.equals(par.getCcType(), "3")){
                try {
                    xnCxjcjg(par);
                }catch (Exception e){
                    e.printStackTrace();
                }
            }
        }
    }

    @Override
    public void delByPaperId(String paperId) {

    }

    @Override
    public void getCxtj() {
        List<ZyInfoStudent> list = zyInfoStudentService.getDtjzyxx();
        HttpServletResponse response = null;
        for(ZyInfoStudent zyInfoStudent:list){
            if(zyInfoStudent!=null && StringUtils.isNotBlank(zyInfoStudent.getFilePath())){
                zyInfoNewStudent2Service.stuWpKsjc(zyInfoStudent,response);
            }
        }
    }

    @Override
    public void getCxtjParam(Map<String, Object> param) {
        if(StringUtils.isNotBlank(param.get("id").toString())){
            ZyInfoStudent zyInfoStudent = zyInfoStudentService.selectById(param.get("id").toString());
            if(zyInfoStudent!=null){
                HttpServletResponse response = null;
                zyInfoStudent.setId(zyInfoStudent.getMainId());
                zyInfoNewStudent2Service.stuWpKsjc(zyInfoStudent,response);

            }
        }

    }

    @Override
    public void getCxtjWwcc() {
        List<ZyInfoStudent> list = zyInfoNewStudent2Service.cxtjByJccsbz();
        for(ZyInfoStudent zyInfoStudent:list){
            HttpServletResponse response = null;
            zyInfoNewStudent2Service.stuWpwwjc(zyInfoStudent,response);
        }
    }


    public Map<String,String> aigcCxjcjg(ZyCcjg zyCcjg) {
        String url = "https://vims.fanyu.com/tool/AIGCCheck/searchPaper";
        //文件路径，文件存在，不存在的话需要先下载下来
        String paperid = zyCcjg.getPaperid();
        Map<String, String> textMap = new HashMap<String, String>();
        //可以设置多个input的name，value
        String sign = getSign();
        textMap.put("userid", weipuId);
        textMap.put("sign", sign);
        textMap.put("paperids", paperid);//资源id,可多个，用逗号分割
        String contentType = "";//image/png
        Map<String, String> fileMap = new HashMap<String, String>();
        String ret = formUpload(url, textMap, fileMap,contentType);
        System.out.println("1-------->"+ret);
        JSONObject object= JSONObject.parseObject(ret);
        if("true".equals(object.getString("success"))){
            //{"success":true,"message":"查询成功", "datalist":[{"dataid":568,"message":"","paperguid":"5c384d6bd69y9ba9","papertitle":"","filestateid":2,"paperword":1958,"percentage":0,"duplicatepercentage":0,"quotepercentage":0,"paichupercentage":0,"selfyypercentage":0,"ownpercentage":100,"authorpercentage":0,"checkdate":"2024-04-13 13:51:51","paperviewurl":"https://vims.fanyu.com/toole/smallcheck/getonlineurl?guid=5c384d6bd69y9ba9","paperdownurl":"https://vims.fanyu.com/toole/smallcheck/getdownloadurl?guid=5c384d6bd69y9ba9"}]}
            //filestateid 检测状态{0未检测,1检测中,2检测完成, 3检测失败}
            String listpaper = object.getString("listpaper");
            JSONArray jsonArray = (JSONArray) JSONArray.parse(listpaper);
            JSONObject object2= jsonArray.getJSONObject(0);
            String filestateid = object2.getString("filestateid");
            if(StringUtils.equals(filestateid,"0")){
                System.out.println(paperid+":未检测");
            }else if(StringUtils.equals(filestateid,"1")){
                System.out.println(paperid+":检测中");
            }else if(StringUtils.equals(filestateid,"2")){
                System.out.println(paperid+":检测完成");
            }else if(StringUtils.equals(filestateid,"3")){
                System.out.println(paperid+":检测失败；"+object2.getString("message"));
            }else{
                System.out.println(paperid+":当前状态："+filestateid+"；"+object2.getString("message"));
            }
            System.out.println("listpaper----->"+listpaper);//结果结合
            System.out.println("object2----->"+object2);//实际单挑数据结果
            Map<String,String> map = new HashMap<String,String>();

            zyCcjg.setPaperguid(object2.getString("paperguid"));//报告编号
            zyCcjg.setPapertitle(object2.getString("papertitle"));//论文标题
            zyCcjg.setFilestateid(object2.getString("filestateid"));//检测状态0:未检测；1:检测中；2:检测完成；3:检测失败；
            zyCcjg.setCheckdate(object2.getString("checkdate"));//检测时间
            zyCcjg.setPaperword(object2.getString("paperword"));//论文字数
            zyCcjg.setAiRate(object2.getString("aiRate"));//疑似ai全文占比
            zyCcjg.setHumanRate(object2.getString("humanRate"));//人工占比
            zyCcjg.setPaperviewurl(object2.getString("paperviewurl"));//报告在线查看地址
            zyCcjg.setPaperdownurl(object2.getString("paperdownurl"));//报告下载地址
            zyCcjg.setMessage(object2.getString("message"));
            baseMapper.updateById(zyCcjg);

            //----------计算通过率--------------
            String stuId = zyCcjg.getZyStuId();
            ZyInfoStudent zyInfoStudent = zyInfoStudentService.selectById(stuId);
            if(StringUtils.equals("2",object2.getString("filestateid"))){
                ZyInfo zyInfo = zyInfoService.getById(zyInfoStudent.getMainId());
                Double tgl = 0.0;
                if(zyInfo.getWwtgl()>0){
                    tgl = zyInfo.getWwtgl();
                }
                Double cctgl = 0.0;
                if(StringUtils.isNotEmpty(object2.getString("aiRate"))){
                    cctgl = Double.parseDouble(object2.getString("aiRate"));
                }
                if(tgl > cctgl || tgl == 0){
                    zyInfoStudent.setAigcsftg("通过");
                }else{
                    zyInfoStudent.setAigcsftg("未通过");
                }
                zyInfoStudent.setAigcxsl(cctgl+"");
                zyInfoStudentService.updateById(zyInfoStudent);
            }else if(StringUtils.equals("3",object2.getString("filestateid"))){
                zyInfoStudent.setAigcsftg("失败:"+object.getString("message"));
            }else{
                zyInfoStudent.setAigcsftg("检测中");
            }

            //----------计算通过率--------------


            map.put("success","true");
            map.put("message",object.getString("message"));
            return map;
        }else{
            System.out.println("3-------->");
            Map<String,String> map = new HashMap<String,String>();
            map.put("success","false");
            map.put("message",object.getString("message"));
            zyCcjg.setMessage(object.getString("message"));
            baseMapper.updateById(zyCcjg);
            return map;
        }
    }


    public Map<String,String> wwCxjcjg(ZyCcjg zyCcjg) {
        String url = "https://vims.fanyu.com/toole/jianceorgan/paperlist.aspx";
        //文件路径，文件存在，不存在的话需要先下载下来
        String paperid = zyCcjg.getPaperid();
        Map<String, String> textMap = new HashMap<String, String>();
        //可以设置多个input的name，value
        String sign = getSign();
        textMap.put("userid", weipuId);
        textMap.put("sign", sign);
        textMap.put("paperids", paperid);//资源id,可多个，用逗号分割
        String contentType = "";//image/png
        Map<String, String> fileMap = new HashMap<String, String>();
        String ret = formUpload(url, textMap, fileMap,contentType);
        System.out.println("1-------->"+ret);
        JSONObject object= JSONObject.parseObject(ret);
        if("true".equals(object.getString("success"))){
            //{"success":true,"message":"查询成功", "datalist":[{"dataid":568,"message":"","paperguid":"5c384d6bd69y9ba9","papertitle":"","filestateid":2,"paperword":1958,"percentage":0,"duplicatepercentage":0,"quotepercentage":0,"paichupercentage":0,"selfyypercentage":0,"ownpercentage":100,"authorpercentage":0,"checkdate":"2024-04-13 13:51:51","paperviewurl":"https://vims.fanyu.com/toole/smallcheck/getonlineurl?guid=5c384d6bd69y9ba9","paperdownurl":"https://vims.fanyu.com/toole/smallcheck/getdownloadurl?guid=5c384d6bd69y9ba9"}]}
            //filestateid 检测状态{0未检测,1检测中,2检测完成, 3检测失败}
            String listpaper = object.getString("listpaper");
            JSONArray jsonArray = (JSONArray) JSONArray.parse(listpaper);
            JSONObject object2= jsonArray.getJSONObject(0);
            String filestateid = object2.getString("filestateid");
            String message = object2.getString("papermsg");
            if(StringUtils.equals(filestateid,"0")){
                System.out.println(paperid+":未检测");
            }else if(StringUtils.equals(filestateid,"1")){
                System.out.println(paperid+":检测中");
            }else if(StringUtils.equals(filestateid,"2")){
                System.out.println(paperid+":检测完成");
            }else if(StringUtils.equals(filestateid,"3")){
                System.out.println(paperid+":检测失败；"+message);
            }else{
                System.out.println(paperid+":当前状态："+filestateid+"；"+message);
            }
            System.out.println("listpaper----->"+listpaper);//结果结合
            System.out.println("object2----->"+object2);//实际单挑数据结果
            Map<String,String> map = new HashMap<String,String>();


            zyCcjg.setPaperguid(object2.getString("paperguid"));//报告编号
            zyCcjg.setPapertitle(object2.getString("papertitle"));//论文标题
            zyCcjg.setFilestateid(object2.getString("filestateid"));//检测状态0:未检测；1:检测中；2:检测完成；3:检测失败；
            zyCcjg.setCheckdate(object2.getString("checkdate"));//检测时间
            zyCcjg.setPaperword(object2.getString("paperword"));//论文字数
            zyCcjg.setPaperviewurl(object2.getString("paperviewurl"));//报告在线查看地址
            zyCcjg.setPaperdownurl(object2.getString("paperdownurl"));//报告下载地址
            zyCcjg.setMessage(message);
            zyCcjg.setDuplicatepercentage(object2.getString("duplicatepercentage"));//复写率
            zyCcjg.setPaichupercentage(object2.getString("paichupercentage"));//他引率
            zyCcjg.setOwnpercentage(object2.getString("ownpercentage"));//自写率
            zyCcjg.setPercentage(object2.getString("percentage"));//相似率
            zyCcjg.setQuotepercentage(object2.getString("quotepercentage"));//引用率
            zyCcjg.setSelfquoterate(object2.getString("selfyypercentage"));//自引率
            zyCcjg.setAuthorpercentage(object2.getString("authorpercentage"));//专业术语率
            baseMapper.updateById(zyCcjg);

            //----------计算通过率--------------
            String stuId = zyCcjg.getZyStuId();
            ZyInfoStudent zyInfoStudent = zyInfoStudentService.selectById(stuId);
            if(StringUtils.equals("2",object2.getString("filestateid"))) {
                ZyInfo zyInfo = zyInfoService.getById(zyInfoStudent.getMainId());
                Double tgl = 0.0;
                if (zyInfo.getWwtgl() > 0) {
                    tgl = zyInfo.getWwtgl();
                }
                Double cctgl = 0.0;
                if (StringUtils.isNotEmpty(object2.getString("percentage"))) {
                    cctgl = Double.parseDouble(object2.getString("percentage"));
                }
                if (tgl > cctgl || tgl == 0) {
                    zyInfoStudent.setWwsftg("通过");
                } else {
                    zyInfoStudent.setWwsftg("未通过");
                }
                zyInfoStudent.setWwxsl(cctgl + "");
                zyInfoStudentService.updateById(zyInfoStudent);
            }else if(StringUtils.equals("3",object2.getString("filestateid"))){
                zyInfoStudent.setWwsftg("失败:"+object.getString("message"));
                zyInfoStudentService.updateById(zyInfoStudent);
            }else{
                zyInfoStudent.setWwsftg("检测中");
                zyInfoStudentService.updateById(zyInfoStudent);
            }
            //----------计算通过率--------------

            map.put("success","true");
            map.put("message",object.getString("message"));

            return map;
        }else{
            System.out.println("3-------->");
            Map<String,String> map = new HashMap<String,String>();
            map.put("success","false");
            map.put("message",object.getString("message"));
            zyCcjg.setMessage(object.getString("message"));
            baseMapper.updateById(zyCcjg);
            return map;
        }
    }

    //小范围比对查询检测结果(作业内比对)
    public Map<String,String> xfwbdCxjcjg(ZyCcjg zyCcjg) {
        String url = "https://vims.fanyu.com/toole/smallcheck/searchCheckStatus";
        //文件路径，文件存在，不存在的话需要先下载下来
        String paperid = zyCcjg.getPaperid();
        Map<String, String> textMap = new HashMap<String, String>();
        //可以设置多个input的name，value
        String sign = getSign();
        textMap.put("userid", weipuId);
        textMap.put("sign", sign);
        textMap.put("cateid", zyCcjg.getBdkbs());//比对库的id
        textMap.put("dataids", paperid);//资源id
        String contentType = "";//image/png
        Map<String, String> fileMap = new HashMap<String, String>();
        String ret = formUpload(url, textMap, fileMap,contentType);
        System.out.println("1-------->"+ret);
        JSONObject object= JSONObject.parseObject(ret);
        if("true".equals(object.getString("success"))){
            //{"success":true,"message":"查询成功", "datalist":[{"dataid":568,"message":"","paperguid":"5c384d6bd69y9ba9","papertitle":"","filestateid":2,"paperword":1958,"percentage":0,"duplicatepercentage":0,"quotepercentage":0,"paichupercentage":0,"selfyypercentage":0,"ownpercentage":100,"authorpercentage":0,"checkdate":"2024-04-13 13:51:51","paperviewurl":"https://vims.fanyu.com/toole/smallcheck/getonlineurl?guid=5c384d6bd69y9ba9","paperdownurl":"https://vims.fanyu.com/toole/smallcheck/getdownloadurl?guid=5c384d6bd69y9ba9"}]}
            //filestateid 检测状态{0未检测,1检测中,2检测完成, 3检测失败}
            String listpaper = object.getString("datalist");
            JSONArray jsonArray = (JSONArray) JSONArray.parse(listpaper);
            JSONObject object2= jsonArray.getJSONObject(0);
            String filestateid = object2.getString("filestateid");
            if(StringUtils.equals(filestateid,"0")){
                System.out.println(paperid+":未检测");
            }else if(StringUtils.equals(filestateid,"1")){
                System.out.println(paperid+":检测中");
            }else if(StringUtils.equals(filestateid,"2")){
                System.out.println(paperid+":检测完成");
            }else if(StringUtils.equals(filestateid,"3")){
                System.out.println(paperid+":检测失败；"+object2.getString("message"));
            }else{
                System.out.println(paperid+":当前状态："+filestateid+"；"+object2.getString("message"));
            }
            System.out.println("listpaper----->"+listpaper);//结果结合
            System.out.println("object2----->"+object2);//实际单挑数据结果
            Map<String,String> map = new HashMap<String,String>();


            zyCcjg.setPaperguid(object2.getString("paperguid"));//报告编号
            zyCcjg.setPapertitle(object2.getString("papertitle"));//论文标题
            zyCcjg.setFilestateid(object2.getString("filestateid"));//检测状态0:未检测；1:检测中；2:检测完成；3:检测失败；
            zyCcjg.setCheckdate(object2.getString("checkdate"));//检测时间
            zyCcjg.setPaperword(object2.getString("paperword"));//论文字数
            zyCcjg.setPaperviewurl(object2.getString("paperviewurl"));//报告在线查看地址
            zyCcjg.setPaperdownurl(object2.getString("paperdownurl"));//报告下载地址
            zyCcjg.setMessage(object2.getString("message"));
            zyCcjg.setDuplicatepercentage(object2.getString("duplicatepercentage"));//复写率
            zyCcjg.setPaichupercentage(object2.getString("paichupercentage"));//他引率
            zyCcjg.setOwnpercentage(object2.getString("ownpercentage"));//自写率
            zyCcjg.setPercentage(object2.getString("percentage"));//相似率
            zyCcjg.setQuotepercentage(object2.getString("quotepercentage"));//引用率
            zyCcjg.setSelfquoterate(object2.getString("selfyypercentage"));//自引率
            zyCcjg.setAuthorpercentage(object2.getString("authorpercentage"));//专业术语率

            baseMapper.updateById(zyCcjg);
            //----------计算通过率--------------
            String stuId = zyCcjg.getZyStuId();
            ZyInfoStudent zyInfoStudent = zyInfoStudentService.selectById(stuId);
            if(StringUtils.equals("2",object2.getString("filestateid"))) {
                ZyInfo zyInfo = zyInfoService.getById(zyInfoStudent.getMainId());
                Double tgl = 0.0;
                if (zyInfo.getWwtgl() > 0) {
                    tgl = zyInfo.getWwtgl();
                }
                Double cctgl = 0.0;
                if (StringUtils.isNotEmpty(object2.getString("percentage"))) {
                    cctgl = Double.parseDouble(object2.getString("percentage"));
                }
                if (tgl > cctgl || tgl == 0) {
                    zyInfoStudent.setNwsftg("通过");
                } else {
                    zyInfoStudent.setNwsftg("未通过");
                }
                zyInfoStudent.setNwxsl(cctgl + "");
                zyInfoStudentService.updateById(zyInfoStudent);
            }else if(StringUtils.equals("3",object2.getString("filestateid"))){
                zyInfoStudent.setNwsftg("失败:"+object.getString("message"));
                zyInfoStudentService.updateById(zyInfoStudent);
            }else{
                zyInfoStudent.setNwsftg("检测中");
                zyInfoStudentService.updateById(zyInfoStudent);
            }
            //----------计算通过率--------------

            map.put("success","true");
            map.put("message",object.getString("message"));

            return map;
        }else{
            System.out.println("3-------->");
            Map<String,String> map = new HashMap<String,String>();
            map.put("success","false");
            map.put("message",object.getString("message"));
            zyCcjg.setMessage(object.getString("message"));
            baseMapper.updateById(zyCcjg);
            return map;
        }
    }

    //小范围比对查询检测结果
    public Map<String,String> xnCxjcjg(ZyCcjg zyCcjg) {
        String url = "https://vims.fanyu.com/toole/smallcheck/searchCheckStatus";
        //文件路径，文件存在，不存在的话需要先下载下来
        String paperid = zyCcjg.getPaperid();
        Map<String, String> textMap = new HashMap<String, String>();
        //可以设置多个input的name，value
        String sign = getSign();
        textMap.put("userid", weipuId);
        textMap.put("sign", sign);
        textMap.put("cateid", zyCcjg.getBdkbs());//比对库的id
        textMap.put("dataids", paperid);//资源id
        String contentType = "";//image/png
        Map<String, String> fileMap = new HashMap<String, String>();
        String ret = formUpload(url, textMap, fileMap,contentType);
        System.out.println("1-------->"+ret);
        JSONObject object= JSONObject.parseObject(ret);
        if("true".equals(object.getString("success"))){
            //{"success":true,"message":"查询成功", "datalist":[{"dataid":568,"message":"","paperguid":"5c384d6bd69y9ba9","papertitle":"","filestateid":2,"paperword":1958,"percentage":0,"duplicatepercentage":0,"quotepercentage":0,"paichupercentage":0,"selfyypercentage":0,"ownpercentage":100,"authorpercentage":0,"checkdate":"2024-04-13 13:51:51","paperviewurl":"https://vims.fanyu.com/toole/smallcheck/getonlineurl?guid=5c384d6bd69y9ba9","paperdownurl":"https://vims.fanyu.com/toole/smallcheck/getdownloadurl?guid=5c384d6bd69y9ba9"}]}
            //filestateid 检测状态{0未检测,1检测中,2检测完成, 3检测失败}
            String listpaper = object.getString("datalist");
            JSONArray jsonArray = (JSONArray) JSONArray.parse(listpaper);
            JSONObject object2= jsonArray.getJSONObject(0);
            String filestateid = object2.getString("filestateid");
            if(StringUtils.equals(filestateid,"0")){
                System.out.println(paperid+":未检测");
            }else if(StringUtils.equals(filestateid,"1")){
                System.out.println(paperid+":检测中");
            }else if(StringUtils.equals(filestateid,"2")){
                System.out.println(paperid+":检测完成");
            }else if(StringUtils.equals(filestateid,"3")){
                System.out.println(paperid+":检测失败；"+object2.getString("message"));
            }else{
                System.out.println(paperid+":当前状态："+filestateid+"；"+object2.getString("message"));
            }
            System.out.println("listpaper----->"+listpaper);//结果结合
            System.out.println("object2----->"+object2);//实际单挑数据结果
            Map<String,String> map = new HashMap<String,String>();


            zyCcjg.setPaperguid(object2.getString("paperguid"));//报告编号
            zyCcjg.setPapertitle(object2.getString("papertitle"));//论文标题
            zyCcjg.setFilestateid(object2.getString("filestateid"));//检测状态0:未检测；1:检测中；2:检测完成；3:检测失败；
            zyCcjg.setCheckdate(object2.getString("checkdate"));//检测时间
            zyCcjg.setPaperword(object2.getString("paperword"));//论文字数
            zyCcjg.setPaperviewurl(object2.getString("paperviewurl"));//报告在线查看地址
            zyCcjg.setPaperdownurl(object2.getString("paperdownurl"));//报告下载地址
            zyCcjg.setMessage(object2.getString("message"));
            zyCcjg.setDuplicatepercentage(object2.getString("duplicatepercentage"));//复写率
            zyCcjg.setPaichupercentage(object2.getString("paichupercentage"));//他引率
            zyCcjg.setOwnpercentage(object2.getString("ownpercentage"));//自写率
            zyCcjg.setPercentage(object2.getString("percentage"));//相似率
            zyCcjg.setQuotepercentage(object2.getString("quotepercentage"));//引用率
            zyCcjg.setSelfquoterate(object2.getString("selfyypercentage"));//自引率
            zyCcjg.setAuthorpercentage(object2.getString("authorpercentage"));//专业术语率

            baseMapper.updateById(zyCcjg);
            //----------计算通过率--------------
            String stuId = zyCcjg.getZyStuId();
            ZyInfoStudent zyInfoStudent = zyInfoStudentService.selectById(stuId);
            if(StringUtils.equals("2",object2.getString("filestateid"))) {
                ZyInfo zyInfo = zyInfoService.getById(zyInfoStudent.getMainId());
                Double tgl = 0.0;
                if (zyInfo.getWwtgl() > 0) {
                    tgl = zyInfo.getWwtgl();
                }
                Double cctgl = 0.0;
                if (StringUtils.isNotEmpty(object2.getString("percentage"))) {
                    cctgl = Double.parseDouble(object2.getString("percentage"));
                }
                if (tgl > cctgl || tgl == 0) {
                    zyInfoStudent.setXnsftg("通过");
                } else {
                    zyInfoStudent.setXnsftg("未通过");
                }
                zyInfoStudent.setXnxsl(cctgl + "");
                zyInfoStudentService.updateById(zyInfoStudent);



                try {
                    if(paperid != null){
                        String dataids = zyCcjg.getPaperid();
                        String bdkbs = zyCcjg.getBdkbs();
                        String url2 = "https://vims.fanyu.com/toole/smallcheck/delData";
                        delXfwWpFile(url2,bdkbs,dataids, null);
                    }
                } catch (Exception e) {
                    e.printStackTrace();
                }



            }else if(StringUtils.equals("3",object2.getString("filestateid"))){
                zyInfoStudent.setXnsftg("失败:"+object.getString("message"));
                zyInfoStudentService.updateById(zyInfoStudent);
            }else{
                zyInfoStudent.setXnsftg("检测中");
                zyInfoStudentService.updateById(zyInfoStudent);
            }
            //----------计算通过率--------------

            map.put("success","true");
            map.put("message",object.getString("message"));

            return map;
        }else{
            System.out.println("3-------->");
            Map<String,String> map = new HashMap<String,String>();
            map.put("success","false");
            map.put("message",object.getString("message"));
            zyCcjg.setMessage(object.getString("message"));
            baseMapper.updateById(zyCcjg);
            return map;
        }
    }

    private String delXfwWpFile(String url,String cateid,String paperids,HttpServletResponse response) {
//        String url = "https://vims.fanyu.com/toole/jianceorgan/paperdel.aspx";
        Map<String, String> textMap = new HashMap<String, String>();
        //可以设置多个input的name，value
        String sign = getSign();
        textMap.put("sign", sign);
        textMap.put("userid", weipuId);
        textMap.put("cateid", cateid);
        textMap.put("dataid", paperids);//文档paperid集合,多个请用英文逗号隔开
        String contentType = "";//image/png
        String ret = formUpload(url, textMap, null,contentType);
        log.error("1-------->"+ret);
        JSONObject object= JSONObject.parseObject(ret);
        if("true".equals(object.getString("success"))){
            String message = object.getString("message");
            System.out.println(message);
            return "success";
        }else{
            return "false";
        }
    }
    //生成sign
    public static String getSign() {
        String userid = weipuId;
        String key = weipuKey;
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH");
        String time = sdf.format( new Date());
        String md5Text = userid + key + time;
        String sign = org.springframework.util.DigestUtils.md5DigestAsHex((md5Text).getBytes()).toLowerCase();
        return sign;
    }

    /**
     * 上传图片
     * @param urlStr
     * @param textMap
     * @param fileMap
     * @param contentType 没有传入文件类型默认采用application/octet-stream
     * contentType非空采用filename匹配默认的图片类型
     * @return 返回response数据
     */
    @SuppressWarnings("rawtypes")
    public static String formUpload(String urlStr, Map<String, String> textMap,
                                    Map<String, String> fileMap,String contentType) {
        String res = "";
        HttpURLConnection conn = null;
        // boundary就是request头和上传文件内容的分隔符
        String BOUNDARY = "---------------------------123821742118716";
        try {
            URL url = new URL(urlStr);
            conn = (HttpURLConnection) url.openConnection();
            conn.setConnectTimeout(5000);
            conn.setReadTimeout(30000);
            conn.setDoOutput(true);
            conn.setDoInput(true);
            conn.setUseCaches(false);
            conn.setRequestMethod("POST");
            conn.setRequestProperty("Connection", "Keep-Alive");
            conn.setRequestProperty("Content-Type","multipart/form-data; boundary=" + BOUNDARY);
            OutputStream out = new DataOutputStream(conn.getOutputStream());
            // text
            if (textMap != null) {
                StringBuffer strBuf = new StringBuffer();
                Iterator iter = textMap.entrySet().iterator();
                while (iter.hasNext()) {
                    Map.Entry entry = (Map.Entry) iter.next();
                    String inputName = (String) entry.getKey();
                    String inputValue = (String) entry.getValue();
                    if (inputValue == null) {
                        continue;
                    }
                    strBuf.append("\r\n").append("--").append(BOUNDARY).append("\r\n");
                    strBuf.append("Content-Disposition: form-data; name=\"" + inputName + "\"\r\n\r\n");
                    strBuf.append(inputValue);
                }
                out.write(strBuf.toString().getBytes(StandardCharsets.UTF_8));
            }
            // file
            if (fileMap != null) {
                Iterator iter = fileMap.entrySet().iterator();
                while (iter.hasNext()) {
                    Map.Entry entry = (Map.Entry) iter.next();
                    String inputName = (String) entry.getKey();
                    String inputValue = (String) entry.getValue();
                    if (inputValue == null) {
                        continue;
                    }
                    File file = new File(inputValue);
                    String filename = file.getName();

                    //没有传入文件类型，同时根据文件获取不到类型，默认采用application/octet-stream
                    contentType = new MimetypesFileTypeMap().getContentType(file);
                    //contentType非空采用filename匹配默认的图片类型
                    if(!"".equals(contentType)){
                        if (filename.endsWith(".png")) {
                            contentType = "image/png";
                        }else if (filename.endsWith(".jpg") || filename.endsWith(".jpeg") || filename.endsWith(".jpe")) {
                            contentType = "image/jpeg";
                        }else if (filename.endsWith(".gif")) {
                            contentType = "image/gif";
                        }else if (filename.endsWith(".ico")) {
                            contentType = "image/image/x-icon";
                        }
                    }
                    if (contentType == null || "".equals(contentType)) {
                        contentType = "application/octet-stream";
                    }
                    StringBuffer strBuf = new StringBuffer();
                    strBuf.append("\r\n").append("--").append(BOUNDARY).append("\r\n");
                    strBuf.append("Content-Disposition: form-data; name=\"" + inputName + "\"; filename=\"" + filename + "\"\r\n");
                    strBuf.append("Content-Type:" + contentType + "\r\n\r\n");
                    out.write(strBuf.toString().getBytes());
                    DataInputStream in = new DataInputStream(new FileInputStream(file));
                    int bytes = 0;
                    byte[] bufferOut = new byte[1024];
                    while ((bytes = in.read(bufferOut)) != -1) {
                        out.write(bufferOut, 0, bytes);
                    }
                    in.close();
                }
            }
            byte[] endData = ("\r\n--" + BOUNDARY + "--\r\n").getBytes();
            out.write(endData);
            out.flush();
            out.close();
            // 读取返回数据
            StringBuffer strBuf = new StringBuffer();
            BufferedReader reader = new BufferedReader(new InputStreamReader(conn.getInputStream()));
            String line = null;
            while ((line = reader.readLine()) != null) {
                strBuf.append(line).append("\n");
            }
            res = strBuf.toString();
            reader.close();
            reader = null;
        } catch (Exception e) {
            System.out.println("发送POST请求出错。" + urlStr);
            e.printStackTrace();
        } finally {
            if (conn != null) {
                conn.disconnect();
                conn = null;
            }
        }
        return res;
    }
}
