package org.jeecg.modules.kc.zyCyFenxiang.controller;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.shiro.SecurityUtils;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.system.vo.LoginUser;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.kc.zyCyFenxiang.entity.ZyCyFenxiang;
import org.jeecg.modules.kc.zyCyFenxiang.service.IZyCyFenxiangService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

 /**
 * @Description: zy_cy_fenxiang
 * @Author: jeecg-boot
 * @Date:   2024-11-04
 * @Version: V1.0
 */
@Api(tags="zy_cy_fenxiang")
@RestController
@RequestMapping("/zyCyFenxiang/zyCyFenxiang")
@Slf4j
public class ZyCyFenxiangController extends JeecgController<ZyCyFenxiang, IZyCyFenxiangService> {
	@Autowired
	private IZyCyFenxiangService zyCyFenxiangService;
	
	/**
	 * 分页列表查询
	 *
	 * @param zyCyFenxiang
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "zy_cy_fenxiang-分页列表查询")
	@ApiOperation(value="zy_cy_fenxiang-分页列表查询", notes="zy_cy_fenxiang-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<ZyCyFenxiang>> queryPageList(ZyCyFenxiang zyCyFenxiang,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<ZyCyFenxiang> queryWrapper = QueryGenerator.initQueryWrapper(zyCyFenxiang, req.getParameterMap());
		Page<ZyCyFenxiang> page = new Page<ZyCyFenxiang>(pageNo, pageSize);
		IPage<ZyCyFenxiang> pageList = zyCyFenxiangService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param zyCyFenxiang
	 * @return
	 */
	@AutoLog(value = "zy_cy_fenxiang-添加")
	@ApiOperation(value="zy_cy_fenxiang-添加", notes="zy_cy_fenxiang-添加")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody ZyCyFenxiang zyCyFenxiang) {
		LoginUser loginUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
		zyCyFenxiang.setYuanTeacherNo(loginUser.getUsername());
		zyCyFenxiang.setYuanTeacherName(loginUser.getRealname());
		zyCyFenxiangService.save(zyCyFenxiang);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param zyCyFenxiang
	 * @return
	 */
	@AutoLog(value = "zy_cy_fenxiang-编辑")
	@ApiOperation(value="zy_cy_fenxiang-编辑", notes="zy_cy_fenxiang-编辑")
	@RequiresPermissions("zyCyFenxiang:zy_cy_fenxiang:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody ZyCyFenxiang zyCyFenxiang) {
		zyCyFenxiangService.updateById(zyCyFenxiang);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "zy_cy_fenxiang-通过id删除")
	@ApiOperation(value="zy_cy_fenxiang-通过id删除", notes="zy_cy_fenxiang-通过id删除")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		zyCyFenxiangService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "zy_cy_fenxiang-批量删除")
	@ApiOperation(value="zy_cy_fenxiang-批量删除", notes="zy_cy_fenxiang-批量删除")
	@RequiresPermissions("zyCyFenxiang:zy_cy_fenxiang:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.zyCyFenxiangService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "zy_cy_fenxiang-通过id查询")
	@ApiOperation(value="zy_cy_fenxiang-通过id查询", notes="zy_cy_fenxiang-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<ZyCyFenxiang> queryById(@RequestParam(name="id",required=true) String id) {
		ZyCyFenxiang zyCyFenxiang = zyCyFenxiangService.getById(id);
		if(zyCyFenxiang==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(zyCyFenxiang);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param zyCyFenxiang
    */
    @RequiresPermissions("zyCyFenxiang:zy_cy_fenxiang:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, ZyCyFenxiang zyCyFenxiang) {
        return super.exportXls(request, zyCyFenxiang, ZyCyFenxiang.class, "zy_cy_fenxiang");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("zyCyFenxiang:zy_cy_fenxiang:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, ZyCyFenxiang.class);
    }

}
