package org.jeecg.modules.kc.zyGonggao.controller;

import java.util.Arrays;
import java.util.Date;
import java.util.List;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.lang.StringUtils;
import org.apache.shiro.SecurityUtils;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.system.vo.LoginUser;
import org.jeecg.common.util.DateUtils;
import org.jeecg.modules.kc.grab.imports.entity.Xxhbbks;
import org.jeecg.modules.kc.grab.imports.service.IXxhbbksService;
import org.jeecg.modules.kc.zyDbtx.entity.ZyDbtx;
import org.jeecg.modules.kc.zyDbtx.service.IZyDbtxService;
import org.jeecg.modules.kc.zyGonggao.entity.ZyGonggao;
import org.jeecg.modules.kc.zyGonggao.service.IZyGonggaoService;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;
import org.jeecg.common.system.base.controller.JeecgController;
import org.jeecg.modules.kc.zyTlq.entity.ZyTlq;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

 /**
 * @Description: 公告
 * @Author: jeecg-boot
 * @Date:   2024-05-10
 * @Version: V1.0
 */
@Api(tags="公告")
@RestController
@RequestMapping("/zyGonggao/zyGonggao")
@Slf4j
public class ZyGonggaoController extends JeecgController<ZyGonggao, IZyGonggaoService> {
	@Autowired
	private IZyGonggaoService zyGonggaoService;

	 @Autowired
	 private IXxhbbksService xxhbbksService;

	 @Autowired
	 private IZyDbtxService zyDbtxService;
	/**
	 * 分页列表查询
	 *
	 * @param zyGonggao
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "公告-分页列表查询")
	@ApiOperation(value="公告-分页列表查询", notes="公告-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<ZyGonggao>> queryPageList(ZyGonggao zyGonggao,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<ZyGonggao> queryWrapper = QueryGenerator.initQueryWrapper(zyGonggao, req.getParameterMap());
		Page<ZyGonggao> page = new Page<ZyGonggao>(pageNo, pageSize);
//		queryWrapper.eq(StringUtils.isNotBlank(zyGonggao.getTeano()),"create_by",zyGonggao.getTeano());
		IPage<ZyGonggao> pageList = zyGonggaoService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param zyGonggao
	 * @return
	 */
	@AutoLog(value = "公告-添加")
	@ApiOperation(value="公告-添加", notes="公告-添加")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody ZyGonggao zyGonggao) {
		zyGonggao.setGgStatus("0");
		zyGonggaoService.save(zyGonggao);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param zyGonggao
	 * @return
	 */
	@AutoLog(value = "公告-编辑")
	@ApiOperation(value="公告-编辑", notes="公告-编辑")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody ZyGonggao zyGonggao) {
		String res = "编辑成功!";
		zyGonggao.setCreateTime(new Date());
		zyGonggaoService.updateById(zyGonggao);
		if(zyGonggao.getFlag()!=null){
			if(zyGonggao.getFlag().equals("1")){
				res = "发布成功!";


				ZyGonggao par=zyGonggaoService.getByKechengId(zyGonggao.getId());
				QueryWrapper<Xxhbbks> queryWrapper = new QueryWrapper<>();
				queryWrapper.apply("a.xh = b.xh");
				queryWrapper.eq("b.KCAPZBBH",par.getRwbh());
				List<Xxhbbks> list = xxhbbksService.getXsxkbAllList(queryWrapper);

				LoginUser user = (LoginUser) SecurityUtils.getSubject().getPrincipal();

				for(Xxhbbks xxhbbks:list){

					//作业代办提醒
					ZyDbtx zyDbtx = new ZyDbtx();
					zyDbtx.setCreateBy(xxhbbks.getXh());
					zyDbtx.setType("9");//0发布作业 1评分 2测验 3问卷 4讨论 9通知通告
					zyDbtx.setMainId(par.getId());
					zyDbtx.setRwbh(par.getRwbh());
					zyDbtx.setContent(user.getRealname()+"教师发布了["+par.getKcmc()+"]课程“"+par.getTitle()+"”的通知公告，发布时间："+DateUtils.formatDate(new Date(),"yyyy-MM-dd HH:mm:ss"));
					zyDbtx.setFlag("0");
					zyDbtx.setFbr(user.getUsername());
					zyDbtxService.save(zyDbtx);

				}



			}
			if(zyGonggao.getFlag().equals("0")){
				res = "撤回成功!";
			}
		}else{
			zyGonggaoService.addHistory(zyGonggao);
		}
		return Result.OK(res);
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "公告-通过id删除")
	@ApiOperation(value="公告-通过id删除", notes="公告-通过id删除")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		zyGonggaoService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "公告-批量删除")
	@ApiOperation(value="公告-批量删除", notes="公告-批量删除")
	@RequiresPermissions("zyGonggao:zy_gonggao:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.zyGonggaoService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "公告-通过id查询")
	@ApiOperation(value="公告-通过id查询", notes="公告-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<ZyGonggao> queryById(@RequestParam(name="id",required=true) String id) {
		ZyGonggao zyGonggao = zyGonggaoService.getById(id);
		if(zyGonggao==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(zyGonggao);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param zyGonggao
    */
    @RequiresPermissions("zyGonggao:zy_gonggao:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, ZyGonggao zyGonggao) {
        return super.exportXls(request, zyGonggao, ZyGonggao.class, "公告");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("zyGonggao:zy_gonggao:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, ZyGonggao.class);
    }

	 @AutoLog(value = "公告历史-分页列表查询")
	 @ApiOperation(value="公告历史-分页列表查询", notes="公告历史-分页列表查询")
	 @GetMapping(value = "/historyList")
	 public Result<IPage<ZyGonggao>> queryHistoryPageList(ZyGonggao zyGonggao,
												 @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
												 @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
												 HttpServletRequest req) {
		 Page<ZyGonggao> pageList = zyGonggaoService.findHistoryPage(zyGonggao,new Page<ZyGonggao>(pageNo, pageSize));
		 return Result.OK(pageList);
	 }

}
