package org.jeecg.modules.kc.zyInfo.controller;

import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.xkcoding.http.HttpUtil;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.SecurityUtils;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.jeecg.common.system.base.controller.JeecgController;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.system.vo.LoginUser;
import org.jeecg.common.util.DateUtils;
import org.jeecg.modules.kc.config.entity.KcExportConfigTpkwcqkjzglx;
import org.jeecg.modules.kc.config.service.IKcExportConfigTpkwcqkjzglxService;
import org.jeecg.modules.kc.grab.imports.entity.Xxhbbks;
import org.jeecg.modules.kc.grab.imports.service.IXxhbbksService;
import org.jeecg.modules.kc.kcSysConfig.entity.KcSysConfig;
import org.jeecg.modules.kc.kcSysConfig.service.IKcSysConfigService;
import org.jeecg.modules.kc.kcWechatSendLog.entity.KcWechatSendLog;
import org.jeecg.modules.kc.ktgl.entity.KcKechengbiao;
import org.jeecg.modules.kc.ktgl.service.IKcKechengbiaoService;
import org.jeecg.modules.kc.zyDbtx.entity.ZyDbtx;
import org.jeecg.modules.kc.zyDbtx.service.IZyDbtxService;
import org.jeecg.modules.kc.zyInfo.entity.CyInfoSys;
import org.jeecg.modules.kc.zyInfo.entity.ZyInfo;
import org.jeecg.modules.kc.zyInfo.entity.ZyInfoSys;
import org.jeecg.modules.kc.zyInfo.entity.ZyXzInfo;
import org.jeecg.modules.kc.zyInfo.pojo.ExportEntity1;
import org.jeecg.modules.kc.zyInfo.pojo.XzReq;
import org.jeecg.modules.kc.zyInfo.service.IZyInfoService;
import org.jeecg.modules.kc.zyInfoStudent.entity.ZyInfoStudent;
import org.jeecg.modules.kc.zyInfoStudent.service.IZyInfoStudentService;
import org.jeecg.modules.system.service.impl.SysBaseApiImpl;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.client.RestTemplate;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.*;
import java.util.stream.Collectors;

/**
 * @Description: 作业发布
 * @Author: jeecg-boot
 * @Date: 2024-05-06
 * @Version: V1.0
 */
@Api(tags = "作业发布")
@RestController
@RequestMapping("/zyInfo/zyInfo")
@Slf4j
public class ZyInfoController extends JeecgController<ZyInfo, IZyInfoService> {
    @Autowired
    private IZyInfoService zyInfoService;
    @Autowired
    private IKcSysConfigService kcSysConfigService;
    @Autowired
    private IKcKechengbiaoService kcKechengbiaoService;
    @Autowired
    private IXxhbbksService xxhbbksService;
    @Autowired
    private IZyInfoStudentService zyInfoStudentService;

    @Autowired
    private IZyDbtxService zyDbtxService;

    @Autowired
    private SysBaseApiImpl sysBaseApi;
    @Autowired
    private IKcExportConfigTpkwcqkjzglxService kcExportConfigTpkwcqkjzglxService;

    @Value("${jeecg.path.upload}")
    private String upLoadPath;


    /**
     * 分页列表查询
     *
     * @param zyInfo
     * @param pageNo
     * @param pageSize
     * @param req
     * @return
     */
    //@AutoLog(value = "作业发布-分页列表查询")
    @ApiOperation(value = "作业发布-分页列表查询", notes = "作业发布-分页列表查询")
    @GetMapping(value = "/list")
    public Result<IPage<ZyInfo>> queryPageList(ZyInfo zyInfo,
                                               @RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo,
                                               @RequestParam(name = "pageSize", defaultValue = "10") Integer pageSize,
                                               HttpServletRequest req) {


        QueryWrapper<ZyInfo> queryWrapper2 = new QueryWrapper<>();
//		queryWrapper2.eq("create_by",zyInfo.getTeano());
        queryWrapper2.eq("rwbh", zyInfo.getRwbh());
        queryWrapper2.eq("xnxq", zyInfo.getXnxq());
        queryWrapper2.eq("zy_status", "0");
        queryWrapper2.le("start_time", new Date());
        List<ZyInfo> list2 = zyInfoService.list(queryWrapper2);

        LoginUser user = (LoginUser) SecurityUtils.getSubject().getPrincipal();
        QueryWrapper<KcKechengbiao> kcKechengbiaoQueryWrapper = new QueryWrapper<>();
        kcKechengbiaoQueryWrapper.eq("rwbh", zyInfo.getRwbh());
        kcKechengbiaoQueryWrapper.eq("jgh", user.getUsername());
        kcKechengbiaoQueryWrapper.eq("xqxn", zyInfo.getXnxq());
//		kcKechengbiaoQueryWrapper.eq("flag","0");
        kcKechengbiaoQueryWrapper.last("limit 1");
        KcKechengbiao kcKechengbiao = kcKechengbiaoService.getOne(kcKechengbiaoQueryWrapper);

        for (ZyInfo par : list2) {
            par.setZyStatus("1");
            zyInfoService.updateById(par);

            if (par != null) {
                ZyInfo zyInfo2 = zyInfoService.getKechengById(par.getId());
                QueryWrapper<Xxhbbks> queryWrapper = new QueryWrapper<>();
                queryWrapper.apply("a.xh = b.xh");
                queryWrapper.eq("b.KCAPZBBH", zyInfo2.getRwbh());
                List<Xxhbbks> list = xxhbbksService.getXsxkbAllList(queryWrapper);
                zyInfoStudentService.deleteMainId(zyInfo2.getId());
                for (Xxhbbks xxhbbks : list) {
//					ZyInfoStudent zyInfoStudent = new ZyInfoStudent();
//					zyInfoStudent.setMainId(zyInfo2.getId());
//					zyInfoStudent.setCreateBy(xxhbbks.getXh());
//					zyInfoStudent.setStudentName(xxhbbks.getXm());
//					zyInfoStudentService.save(zyInfoStudent);

                    //作业代办提醒
                    ZyDbtx zyDbtx = new ZyDbtx();
                    zyDbtx.setCreateBy(xxhbbks.getXh());
                    zyDbtx.setMainId(zyInfo2.getId());
                    zyDbtx.setRwbh(zyInfo2.getRwbh());
                    String hpts = "";
                    if (StringUtils.equals(zyInfo2.getXshpkg(), "1")) {
                        hpts = "互评时间：" + DateUtils.formatDate(zyInfo2.getXshpkssj(), "yyyy-MM-dd HH:mm") + " ~ " + DateUtils.formatDate(zyInfo2.getXshpjssj(), "yyyy-MM-dd HH:mm");
                    }

                    if (StringUtils.equals(zyInfo2.getZyLeixing(), "0")) {
                        zyDbtx.setType("0");//0发布作业 1评分 2测验 3问卷 4讨论
                        zyDbtx.setContent(user.getRealname() + "老师主讲的[" + kcKechengbiao.getKcmc() + "]课程于" + DateUtils.formatDate(new Date(), "yyyy-MM-dd HH:mm:ss") + "发布了一篇题目为“" + zyInfo2.getTitle() + "”的作业，该作业提交时间为：" + DateUtils.formatDate(zyInfo2.getStartTime(), "yyyy-MM-dd HH:mm") + " ~ " + DateUtils.formatDate(zyInfo2.getEndTime(), "yyyy-MM-dd HH:mm") + "，请按时完成！  " + hpts);
                    } else if (StringUtils.equals(zyInfo.getZyLeixing(), "1")) {
                        zyDbtx.setType("10");//0发布作业 1评分 2测验 3问卷 4讨论
                        zyDbtx.setContent(user.getRealname() + "老师主讲的[" + kcKechengbiao.getKcmc() + "]课程于" + DateUtils.formatDate(new Date(), "yyyy-MM-dd HH:mm:ss") + "发布了一篇题目为“" + zyInfo2.getTitle() + "”的期末考试，该期末考试提交时间为：" + DateUtils.formatDate(zyInfo2.getStartTime(), "yyyy-MM-dd HH:mm") + " ~ " + DateUtils.formatDate(zyInfo2.getEndTime(), "yyyy-MM-dd HH:mm") + "，请按时完成！  " + hpts);
                    }
                    zyDbtx.setFlag("0");
                    zyDbtx.setFbr(user.getUsername());
                    zyDbtxService.save(zyDbtx);

                    try {
                        KcWechatSendLog kcWechatSendLog = new KcWechatSendLog();
                        kcWechatSendLog.setOpenid(xxhbbks.getXh());
//						kcWechatSendLog.setOpenid("2016900057");//指定曹老师账号
                        kcWechatSendLog.setYtkcs(zyDbtx.getContent());
//                        sendWxmessage(kcWechatSendLog);
                    } catch (Exception e) {
                        e.printStackTrace();
                    }
                }
            }
        }

        QueryWrapper<ZyInfo> queryWrapper = QueryGenerator.initQueryWrapper("a", zyInfo, req.getParameterMap());
        Page<ZyInfo> page = new Page<ZyInfo>(pageNo, pageSize);
        queryWrapper.eq(StringUtils.isNotBlank(zyInfo.getTeano()), "a.create_by", zyInfo.getTeano());
        queryWrapper.orderByAsc("a.sort - 0");
        IPage<ZyInfo> pageList = zyInfoService.page(page, queryWrapper);
        try {
            if (kcKechengbiao != null && StringUtils.isNotBlank(kcKechengbiao.getXkrs())) {
                pageList.getRecords().forEach(zyInfo1 -> {
                    String xkrs = kcKechengbiao.getXkrs();
                    zyInfo1.setXkxs(xkrs);
                    int wtj = Integer.parseInt(xkrs) - Integer.parseInt(zyInfo1.getDpynum()) - Integer.parseInt(zyInfo1.getYpynum());
                    if (wtj < 0) {
                        wtj = 0;
                    }
                    zyInfo1.setWtjnum(wtj + "");
                });
            }

        } catch (Exception e) {
            e.printStackTrace();
        }

        return Result.OK(pageList);
    }


    @ApiOperation(value = "引用作业列表", notes = "引用作业列表")
    @GetMapping(value = "/listOther")
    public Result<IPage<ZyInfo>> listOther(ZyInfo zyInfo,
                                           @RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo,
                                           @RequestParam(name = "pageSize", defaultValue = "10") Integer pageSize,
                                           HttpServletRequest req) {

        LoginUser user = (LoginUser) SecurityUtils.getSubject().getPrincipal();
        zyInfo.setTeacherNo(user.getUsername());
        Page<ZyInfo> page = new Page<ZyInfo>(pageNo, pageSize);
        IPage<ZyInfo> pageList = zyInfoService.listOther(page, zyInfo);

        return Result.OK(pageList);
    }

    /**
     * 添加
     *
     * @param zyInfo
     * @return
     */
    @AutoLog(value = "作业发布-添加")
    @ApiOperation(value = "作业发布-添加", notes = "作业发布-添加")
    @PostMapping(value = "/add")
    public Result<String> add(@RequestBody ZyInfo zyInfo) {
        KcSysConfig kcSysConfig = kcSysConfigService.getById("1");
        QueryWrapper<KcKechengbiao> kcKechengbiaoQueryWrapper = new QueryWrapper<>();
        kcKechengbiaoQueryWrapper.eq("xqxn", kcSysConfig.getFlag1());
        kcKechengbiaoQueryWrapper.eq("rwbh", zyInfo.getRwbh());
        kcKechengbiaoQueryWrapper.last("limit 1");
        KcKechengbiao kcKechengbiao = kcKechengbiaoService.getOne(kcKechengbiaoQueryWrapper);
        zyInfo.setXnxq(kcSysConfig.getFlag1());
        zyInfo.setZyStatus("0");
        zyInfo.setXkxs(kcKechengbiao.getXkrs());
        zyInfoService.save(zyInfo);
        return Result.OK("添加成功！");
    }

    /**
     * 添加
     *
     * @param zyInfo
     * @return
     */
    @AutoLog(value = "作业发布-添加")
    @ApiOperation(value = "作业发布-添加", notes = "作业发布-添加")
    @PostMapping(value = "/addOne")
    public Result<String> addOne(@RequestBody ZyInfo zyInfo) {
        KcSysConfig kcSysConfig = kcSysConfigService.getById("1");
        QueryWrapper<KcKechengbiao> kcKechengbiaoQueryWrapper = new QueryWrapper<>();
        kcKechengbiaoQueryWrapper.eq("xqxn", kcSysConfig.getFlag1());
        kcKechengbiaoQueryWrapper.eq("rwbh", zyInfo.getRwbh());
        kcKechengbiaoQueryWrapper.last("limit 1");
        KcKechengbiao kcKechengbiao = kcKechengbiaoService.getOne(kcKechengbiaoQueryWrapper);


        QueryWrapper<ZyInfo> zyInfoQueryWrapper = new QueryWrapper<>();
        zyInfoQueryWrapper.eq("xnxq", zyInfo.getXnxq());
//		zyInfoQueryWrapper.eq("create_by",zyInfo.getTeano());
        zyInfoQueryWrapper.eq("rwbh", zyInfo.getRwbh());
        if (StringUtils.isNotBlank(zyInfo.getZyLeixing())) {
            zyInfoQueryWrapper.eq("zy_leixing", zyInfo.getZyLeixing());
        }
        List<ZyInfo> list = zyInfoService.list(zyInfoQueryWrapper);

        zyInfo.setSort(list.size() + 1);
        zyInfo.setXnxq(kcSysConfig.getFlag1());
        zyInfo.setZyStatus("0");
        zyInfo.setXkxs(kcKechengbiao.getXkrs());
        zyInfo.setScore("0");
        zyInfoService.save(zyInfo);
        return Result.OK("添加成功！");
    }

    /**
     * 编辑
     *
     * @param zyInfo
     * @return
     */
    @AutoLog(value = "作业发布-编辑")
    @ApiOperation(value = "作业发布-编辑", notes = "作业发布-编辑")
    @RequestMapping(value = "/edit", method = {RequestMethod.PUT, RequestMethod.POST})
    public Result<String> edit(@RequestBody ZyInfo zyInfo) {
        zyInfoService.updateById(zyInfo);
        if("0".equals(zyInfo.getXshpkg()))zyInfoService.removeHPData(zyInfo.getId());
        if("0".equals(zyInfo.getSfcc()))zyInfoService.removeCCData(zyInfo.getId());
        ZyInfo zyInfo2 = zyInfoService.getById(zyInfo.getId());
        if (StringUtils.equals(zyInfo2.getZyStatus(), "1")) {
            QueryWrapper<KcKechengbiao> kcKechengbiaoQueryWrapper = new QueryWrapper<>();
            kcKechengbiaoQueryWrapper.eq("rwbh", zyInfo.getRwbh());
            kcKechengbiaoQueryWrapper.eq("jgh", zyInfo.getCreateBy());
            kcKechengbiaoQueryWrapper.eq("xqxn", zyInfo.getXnxq());
            kcKechengbiaoQueryWrapper.last("limit 1");
            KcKechengbiao kcKechengbiao = kcKechengbiaoService.getOne(kcKechengbiaoQueryWrapper);

            QueryWrapper<ZyDbtx> zyDbtxQueryWrapper = new QueryWrapper<>();
            zyDbtxQueryWrapper.eq("type", "2");//发送作业
            zyDbtxQueryWrapper.eq("rwbh", zyInfo.getRwbh());
            List<ZyDbtx> dbtxlist = zyDbtxService.list(zyDbtxQueryWrapper);
            String xharrs[] = new String[dbtxlist.size()];
            for (int i = 0; i < dbtxlist.size(); i++) {
                xharrs[i] = dbtxlist.get(i).getCreateBy();
            }

            QueryWrapper<Xxhbbks> queryWrapper = new QueryWrapper<>();
            queryWrapper.apply("a.xh = b.xh");
            queryWrapper.eq("b.KCAPZBBH", zyInfo2.getRwbh());
            if (xharrs.length > 0) {
                queryWrapper.notIn("a.xh", xharrs);
            }
            List<Xxhbbks> list = xxhbbksService.getXsxkbAllList(queryWrapper);

            LoginUser user = (LoginUser) SecurityUtils.getSubject().getPrincipal();
            for (Xxhbbks xxhbbks : list) {

                //作业代办提醒
                ZyDbtx zyDbtx = new ZyDbtx();
                zyDbtx.setCreateBy(xxhbbks.getXh());
                zyDbtx.setMainId(zyInfo.getId());
                zyDbtx.setRwbh(zyInfo.getRwbh());
                String hpts = "";
                if (StringUtils.equals(zyInfo.getXshpkg(), "1")) {
                    hpts = "互评时间：" + DateUtils.formatDate(zyInfo.getXshpkssj(), "yyyy-MM-dd HH:mm") + " ~ " + DateUtils.formatDate(zyInfo.getXshpjssj(), "yyyy-MM-dd HH:mm");
                }

                if (StringUtils.equals(zyInfo.getZyLeixing(), "0")) {
                    zyDbtx.setType("0");//0发布作业 1评分 2测验 3问卷 4讨论
                    zyDbtx.setContent(user.getRealname() + "老师主讲的[" + kcKechengbiao.getKcmc() + "]课程于" + DateUtils.formatDate(new Date(), "yyyy-MM-dd HH:mm:ss") + "发布了一篇题目为“" + zyInfo.getTitle() + "”的作业，该作业提交时间为：" + DateUtils.formatDate(zyInfo.getStartTime(), "yyyy-MM-dd HH:mm") + " ~ " + DateUtils.formatDate(zyInfo.getEndTime(), "yyyy-MM-dd HH:mm") + "，请按时完成！  " + hpts);
                } else if (StringUtils.equals(zyInfo.getZyLeixing(), "1")) {
                    zyDbtx.setType("10");//0发布作业 1评分 2测验 3问卷 4讨论
                    zyDbtx.setContent(user.getRealname() + "老师主讲的[" + kcKechengbiao.getKcmc() + "]课程于" + DateUtils.formatDate(new Date(), "yyyy-MM-dd HH:mm:ss") + "发布了一篇题目为“" + zyInfo.getTitle() + "”的期末考试，该期末考试提交时间为：" + DateUtils.formatDate(zyInfo.getStartTime(), "yyyy-MM-dd HH:mm") + " ~ " + DateUtils.formatDate(zyInfo.getEndTime(), "yyyy-MM-dd HH:mm") + "，请按时完成！  " + hpts);
                }
                zyDbtx.setFlag("0");
                zyDbtx.setFbr(user.getUsername());
                zyDbtxService.save(zyDbtx);

                try {
                    KcWechatSendLog kcWechatSendLog = new KcWechatSendLog();
                    kcWechatSendLog.setOpenid(xxhbbks.getXh());
                    kcWechatSendLog.setYtkcs(zyDbtx.getContent());
//                    sendWxmessage(kcWechatSendLog);
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
        }

        return Result.OK("编辑成功!");
    }


    @AutoLog(value = "撤回作业")
    @ApiOperation(value = "撤回作业", notes = "撤回作业")
    @RequestMapping(value = "/editChehui", method = {RequestMethod.PUT, RequestMethod.POST})
    public Result<String> editChehui(@RequestBody ZyInfo zyInfo) {
        UpdateWrapper<ZyInfo> queryWrapper = new UpdateWrapper<>();
        queryWrapper.set("start_time", null);
        queryWrapper.set("zy_status", "0");
        queryWrapper.eq("id", zyInfo.getId());
        zyInfoService.update(queryWrapper);

        //删除学生列表
        QueryWrapper<ZyInfoStudent> zyInfoStudentQueryWrapper = new QueryWrapper<>();
        zyInfoStudentQueryWrapper.eq("main_id", zyInfo.getId());
        zyInfoStudentService.remove(zyInfoStudentQueryWrapper);

        //删除代办信息
        QueryWrapper<ZyDbtx> zyDbtxQueryWrapper = new QueryWrapper<>();
        zyDbtxQueryWrapper.eq("main_id", zyInfo.getId());
        zyDbtxService.remove(zyDbtxQueryWrapper);


        return Result.OK("编辑成功!");
    }

    /**
     * 编辑
     *
     * @param zyInfo
     * @return
     */
    @AutoLog(value = "作业发布-发布")
    @ApiOperation(value = "作业发布-发布", notes = "作业发布-发布")
    @RequestMapping(value = "/release", method = {RequestMethod.PUT, RequestMethod.POST})
    public Result<String> release(@RequestBody ZyInfo zyInfo) {
        zyInfo.setStartTime(new Date());
        zyInfoService.updateById(zyInfo);
        return Result.OK("发布成功!");
    }

    @ApiOperation(value = "作业发布-通过id查询", notes = "作业发布-通过id查询")
    @GetMapping(value = "/editStudent")
    public Result<ZyInfo> editStudent(@RequestParam(name = "id", required = true) String id) {
        ZyInfo zyInfo = zyInfoService.getById(id);
        if (zyInfo != null) {
            zyInfo = zyInfoService.getKechengById(zyInfo.getId());
            QueryWrapper<Xxhbbks> queryWrapper = new QueryWrapper<>();
            queryWrapper.apply("a.xh = b.xh");
            queryWrapper.eq("b.KCAPZBBH", zyInfo.getRwbh());
            List<Xxhbbks> list = xxhbbksService.getXsxkbAllList(queryWrapper);
            zyInfoStudentService.deleteMainId(zyInfo.getId());


            LoginUser user = (LoginUser) SecurityUtils.getSubject().getPrincipal();

            QueryWrapper<KcKechengbiao> kcKechengbiaoQueryWrapper = new QueryWrapper<>();
            kcKechengbiaoQueryWrapper.eq("rwbh", zyInfo.getRwbh());
            kcKechengbiaoQueryWrapper.eq("jgh", zyInfo.getCreateBy());
            kcKechengbiaoQueryWrapper.eq("xqxn", zyInfo.getXnxq());
            kcKechengbiaoQueryWrapper.last("limit 1");
            KcKechengbiao kcKechengbiao = kcKechengbiaoService.getOne(kcKechengbiaoQueryWrapper);
            for (Xxhbbks xxhbbks : list) {
                ZyInfoStudent zyInfoStudent = new ZyInfoStudent();
                zyInfoStudent.setMainId(zyInfo.getId());
                zyInfoStudent.setCreateBy(xxhbbks.getXh());
                zyInfoStudent.setStudentName(xxhbbks.getXm());
                zyInfoStudent.setZyLeixing(zyInfo.getZyLeixing());
                zyInfoStudentService.save(zyInfoStudent);

                //作业代办提醒
                ZyDbtx zyDbtx = new ZyDbtx();
                zyDbtx.setCreateBy(xxhbbks.getXh());
                zyDbtx.setMainId(zyInfo.getId());
                zyDbtx.setRwbh(zyInfo.getRwbh());
                String hpts = "";
                if (StringUtils.equals(zyInfo.getXshpkg(), "1")) {
                    hpts = "互评时间：" + DateUtils.formatDate(zyInfo.getXshpkssj(), "yyyy-MM-dd HH:mm") + " ~ " + DateUtils.formatDate(zyInfo.getXshpjssj(), "yyyy-MM-dd HH:mm");
                }

                if (StringUtils.equals(zyInfo.getZyLeixing(), "0")) {
                    zyDbtx.setType("0");//0发布作业 1评分 2测验 3问卷 4讨论
                    zyDbtx.setContent(user.getRealname() + "老师主讲的[" + kcKechengbiao.getKcmc() + "]课程于" + DateUtils.formatDate(new Date(), "yyyy-MM-dd HH:mm:ss") + "发布了一篇题目为“" + zyInfo.getTitle() + "”的作业，该作业提交时间为：" + DateUtils.formatDate(zyInfo.getStartTime(), "yyyy-MM-dd HH:mm") + " ~ " + DateUtils.formatDate(zyInfo.getEndTime(), "yyyy-MM-dd HH:mm") + "，请按时完成！  " + hpts);
                } else if (StringUtils.equals(zyInfo.getZyLeixing(), "1")) {
                    zyDbtx.setType("10");//0发布作业 1评分 2测验 3问卷 4讨论
                    zyDbtx.setContent(user.getRealname() + "老师主讲的[" + kcKechengbiao.getKcmc() + "]课程于" + DateUtils.formatDate(new Date(), "yyyy-MM-dd HH:mm:ss") + "发布了一篇题目为“" + zyInfo.getTitle() + "”的期末考试，该期末考试提交时间为：" + DateUtils.formatDate(zyInfo.getStartTime(), "yyyy-MM-dd HH:mm") + " ~ " + DateUtils.formatDate(zyInfo.getEndTime(), "yyyy-MM-dd HH:mm") + "，请按时完成！  " + hpts);
                }
                zyDbtx.setFlag("0");
                zyDbtx.setFbr(user.getUsername());
                zyDbtxService.save(zyDbtx);

//				 try {
//					 KcWechatSendLog kcWechatSendLog = new KcWechatSendLog();
//				 kcWechatSendLog.setOpenid(xxhbbks.getXh());
////					 kcWechatSendLog.setOpenid("2016900057");//指定曹老师账号
//					 kcWechatSendLog.setYtkcs(zyDbtx.getContent());
//					 sendWxmessage(kcWechatSendLog);
//				 }catch (Exception e){
//					 e.printStackTrace();
//				 }

            }
        }
        return Result.OK(zyInfo);
    }

    @ApiOperation(value = "推送微信信息", notes = "推送微信信息")
    @GetMapping(value = "/sendZyWechat")
    public Result<ZyInfo> sendZyWechat(@RequestParam(name = "id", required = true) String id) {
        ZyInfo zyInfo = zyInfoService.getById(id);
        if (zyInfo != null) {
            zyInfo = zyInfoService.getKechengById(zyInfo.getId());
            QueryWrapper<Xxhbbks> queryWrapper = new QueryWrapper<>();
            queryWrapper.apply("a.xh = b.xh");
            queryWrapper.eq("b.KCAPZBBH", zyInfo.getRwbh());
            List<Xxhbbks> list = xxhbbksService.getXsxkbAllList(queryWrapper);

            LoginUser user = (LoginUser) SecurityUtils.getSubject().getPrincipal();

            QueryWrapper<KcKechengbiao> kcKechengbiaoQueryWrapper = new QueryWrapper<>();
            kcKechengbiaoQueryWrapper.eq("rwbh", zyInfo.getRwbh());
            kcKechengbiaoQueryWrapper.eq("jgh", zyInfo.getCreateBy());
            kcKechengbiaoQueryWrapper.eq("xqxn", zyInfo.getXnxq());
            kcKechengbiaoQueryWrapper.last("limit 1");
            KcKechengbiao kcKechengbiao = kcKechengbiaoService.getOne(kcKechengbiaoQueryWrapper);

            //作业代办提醒
            String hpts = "";
            if (StringUtils.equals(zyInfo.getXshpkg(), "1")) {
                hpts = "互评时间：" + DateUtils.formatDate(zyInfo.getXshpkssj(), "yyyy-MM-dd HH:mm") + " ~ " + DateUtils.formatDate(zyInfo.getXshpjssj(), "yyyy-MM-dd HH:mm");
            }
            String content = "";
            if (StringUtils.equals(zyInfo.getZyLeixing(), "0")) {
                content = user.getRealname() + "老师主讲的[" + kcKechengbiao.getKcmc() + "]课程于" + DateUtils.formatDate(new Date(), "yyyy-MM-dd HH:mm:ss") + "发布了一篇题目为“" + zyInfo.getTitle() + "”的作业，该作业提交时间为：" + DateUtils.formatDate(zyInfo.getStartTime(), "yyyy-MM-dd HH:mm") + " ~ " + DateUtils.formatDate(zyInfo.getEndTime(), "yyyy-MM-dd HH:mm") + "，请按时完成！  " + hpts;
            } else if (StringUtils.equals(zyInfo.getZyLeixing(), "1")) {
                content = user.getRealname() + "老师主讲的[" + kcKechengbiao.getKcmc() + "]课程于" + DateUtils.formatDate(new Date(), "yyyy-MM-dd HH:mm:ss") + "发布了一篇题目为“" + zyInfo.getTitle() + "”的期末考试，该期末考试提交时间为：" + DateUtils.formatDate(zyInfo.getStartTime(), "yyyy-MM-dd HH:mm") + " ~ " + DateUtils.formatDate(zyInfo.getEndTime(), "yyyy-MM-dd HH:mm") + "，请按时完成！  " + hpts;
            }

            for (Xxhbbks xxhbbks : list) {
                try {
                    KcWechatSendLog kcWechatSendLog = new KcWechatSendLog();
                    kcWechatSendLog.setOpenid(xxhbbks.getXh());
//					kcWechatSendLog.setOpenid("2016900057");//指定曹老师账号
                    kcWechatSendLog.setYtkcs(content);
//                    sendWxmessage(kcWechatSendLog);
                } catch (Exception e) {
                    e.printStackTrace();
                }

            }
        }
        return Result.OK(zyInfo);
    }

    /**
     * 通过id删除
     *
     * @param id
     * @return
     */
    @AutoLog(value = "作业发布-通过id删除")
    @ApiOperation(value = "作业发布-通过id删除", notes = "作业发布-通过id删除")
    @DeleteMapping(value = "/delete")
    public Result<String> delete(@RequestParam(name = "id", required = true) String id) {
        ZyInfo zyInfo = zyInfoService.getById(id);
        zyInfoService.removeById(id);
        QueryWrapper<ZyInfo> zyInfoQueryWrapper = new QueryWrapper<>();
        zyInfoQueryWrapper.eq("rwbh", zyInfo.getRwbh());
        zyInfoQueryWrapper.eq("xnxq", zyInfo.getXnxq());
        zyInfoQueryWrapper.eq("zy_leixing", "0");
        zyInfoQueryWrapper.orderByAsc("sort-0");
        List<ZyInfo> list = zyInfoService.list(zyInfoQueryWrapper);
        for (int i = 0; i < list.size(); i++) {
            ZyInfo zyInfoPar = list.get(i);
            zyInfoPar.setSort(i + 1);
            zyInfoService.updateById(zyInfoPar);
        }
        return Result.OK("删除成功!");
    }

    /**
     * 批量删除
     *
     * @param ids
     * @return
     */
    @AutoLog(value = "作业发布-批量删除")
    @ApiOperation(value = "作业发布-批量删除", notes = "作业发布-批量删除")
    @RequiresPermissions("zyInfo:zy_info:deleteBatch")
    @DeleteMapping(value = "/deleteBatch")
    public Result<String> deleteBatch(@RequestParam(name = "ids", required = true) String ids) {
        this.zyInfoService.removeByIds(Arrays.asList(ids.split(",")));
        return Result.OK("批量删除成功!");
    }

    /**
     * 通过id查询
     *
     * @param id
     * @return
     */
    //@AutoLog(value = "作业发布-通过id查询")
    @ApiOperation(value = "作业发布-通过id查询", notes = "作业发布-通过id查询")
    @GetMapping(value = "/queryById")
    public Result<ZyInfo> queryById(@RequestParam(name = "id", required = true) String id) {
        ZyInfo zyInfo = zyInfoService.getById(id);
        if (zyInfo == null) {
            return Result.error("未找到对应数据");
        }
        return Result.OK(zyInfo);
    }

    /**
     * 导出excel
     *
     * @param request
     * @param zyInfo
     */
    @RequiresPermissions("zyInfo:zy_info:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, ZyInfo zyInfo) {
        return super.exportXls(request, zyInfo, ZyInfo.class, "作业发布");
    }

    /**
     * 通过excel导入数据
     *
     * @param request
     * @param response
     * @return
     */
    @RequiresPermissions("zyInfo:zy_info:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, ZyInfo.class);
    }


    @ApiOperation(value = "作业发布-分页列表查询", notes = "作业发布-分页列表查询")
    @GetMapping(value = "/stuList")
    public Result<IPage<ZyInfo>> stuList(ZyInfo zyInfo,
                                         @RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo,
                                         @RequestParam(name = "pageSize", defaultValue = "10") Integer pageSize,
                                         HttpServletRequest req) {
        QueryWrapper<ZyInfo> queryWrapper = QueryGenerator.initQueryWrapper("a", zyInfo, req.getParameterMap());
        Page<ZyInfo> page = new Page<ZyInfo>(pageNo, pageSize);
        LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
        queryWrapper.eq("c.KCAPZBBH", zyInfo.getRwbh());
        queryWrapper.eq("c.xh", sysUser.getUsername());
        queryWrapper.orderByDesc("a.sort - 0");
        IPage<ZyInfo> pageList = zyInfoService.stuList(page, queryWrapper);
        return Result.OK(pageList);
    }


    @ApiOperation(value = "教学大纲-分页列表查询", notes = "教学大纲-分页列表查询")
    @GetMapping(value = "/sysList")
    public Result<IPage<ZyInfoSys>> sysList(ZyInfoSys zyInfoSys,
                                            @RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo,
                                            @RequestParam(name = "pageSize", defaultValue = "10") Integer pageSize,
                                            HttpServletRequest req) {
        LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
        //-------------获取当前登陆人是否是管理员角色，如果不是都按照教务秘书处理---------------------------
        List<String> roleList = sysBaseApi.getRolesByUsername(sysUser.getUsername());
        String adminRole = "1";//0 admin  1教务秘书
        for (String role : roleList) {
            if (org.apache.commons.lang.StringUtils.equals("admin", role)) {
                adminRole = "0";
                break;
            }
        }
        QueryWrapper<ZyInfoSys> queryWrapper = new QueryWrapper<ZyInfoSys>();
        if (org.apache.commons.lang.StringUtils.equals("1", adminRole)) {
            QueryWrapper<KcExportConfigTpkwcqkjzglx> queryWrapperCon = new QueryWrapper<KcExportConfigTpkwcqkjzglx>();
            queryWrapperCon.eq("gh", sysUser.getUsername());
            queryWrapperCon.orderByDesc("create_time");
            queryWrapperCon.last("limit 1");
            KcExportConfigTpkwcqkjzglx kcExportConfigTpkwcqkjzglx = kcExportConfigTpkwcqkjzglxService.getOne(queryWrapperCon);
            queryWrapper.eq("kkdw", kcExportConfigTpkwcqkjzglx.getDwmc());
        }

        if (com.baomidou.mybatisplus.core.toolkit.StringUtils.isEmpty(zyInfoSys.getXqxn())) {
            KcSysConfig kcSysConfig = kcSysConfigService.getById("1");
            queryWrapper.eq("xqxn", kcSysConfig.getFlag1());
        } else {
            queryWrapper.eq("xqxn", zyInfoSys.getXqxn());
        }
        queryWrapper.like(com.baomidou.mybatisplus.core.toolkit.StringUtils.isNotEmpty(zyInfoSys.getKkdw()), "kkdw", zyInfoSys.getKkdw());
        queryWrapper.like(com.baomidou.mybatisplus.core.toolkit.StringUtils.isNotEmpty(zyInfoSys.getKcmc()), "kcmc", zyInfoSys.getKcmc());
        queryWrapper.like(com.baomidou.mybatisplus.core.toolkit.StringUtils.isNotEmpty(zyInfoSys.getKcbh()), "kcbh", zyInfoSys.getKcbh());
        queryWrapper.like(com.baomidou.mybatisplus.core.toolkit.StringUtils.isNotEmpty(zyInfoSys.getSkjs()), "skjs", zyInfoSys.getSkjs());
        queryWrapper.eq("flag", 0);
        Page<ZyInfoSys> page = new Page<ZyInfoSys>(pageNo, pageSize);
        IPage<ZyInfoSys> pageList = zyInfoService.sysList(page, queryWrapper);
        return Result.OK(pageList);
    }


    @ApiOperation(value = "教学大纲-分页列表查询", notes = "教学大纲-分页列表查询")
    @GetMapping(value = "/sysStaticList")
    public Result<IPage<ZyInfoSys>> sysStaticList(ZyInfoSys zyInfoSys,
                                                  @RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo,
                                                  @RequestParam(name = "pageSize", defaultValue = "10") Integer pageSize,
                                                  HttpServletRequest req) {
        LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
        //-------------获取当前登陆人是否是管理员角色，如果不是都按照教务秘书处理---------------------------
        List<String> roleList = sysBaseApi.getRolesByUsername(sysUser.getUsername());
        String adminRole = "1";//0 admin  1教务秘书
        for (String role : roleList) {
            if (org.apache.commons.lang.StringUtils.equals("admin", role)) {
                adminRole = "0";
                break;
            }
        }
        QueryWrapper<ZyInfoSys> queryWrapper = new QueryWrapper<ZyInfoSys>();
        if (org.apache.commons.lang.StringUtils.equals("1", adminRole)) {
            QueryWrapper<KcExportConfigTpkwcqkjzglx> queryWrapperCon = new QueryWrapper<KcExportConfigTpkwcqkjzglx>();
            queryWrapperCon.eq("gh", sysUser.getUsername());
            queryWrapperCon.orderByDesc("create_time");
            queryWrapperCon.last("limit 1");
            KcExportConfigTpkwcqkjzglx kcExportConfigTpkwcqkjzglx = kcExportConfigTpkwcqkjzglxService.getOne(queryWrapperCon);
            zyInfoSys.setKkdw(kcExportConfigTpkwcqkjzglx.getDwmc());
        }

        if (com.baomidou.mybatisplus.core.toolkit.StringUtils.isEmpty(zyInfoSys.getXqxn())) {
            KcSysConfig kcSysConfig = kcSysConfigService.getById("1");
            zyInfoSys.setXqxn(kcSysConfig.getFlag1());
        }

        Page<ZyInfoSys> page = new Page<ZyInfoSys>(pageNo, pageSize);
        IPage<ZyInfoSys> pageList = zyInfoService.sysStaticList(page, zyInfoSys);
        return Result.OK(pageList);
    }


    @RequestMapping(value = "/exportSysXls")
    public ModelAndView exportSysXls(HttpServletRequest request, ZyInfoSys zyInfoSys) {
        String title = "课程作业";
        LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
        //-------------获取当前登陆人是否是管理员角色，如果不是都按照教务秘书处理---------------------------
        List<String> roleList = sysBaseApi.getRolesByUsername(sysUser.getUsername());
        String adminRole = "1";//0 admin  1教务秘书
        for (String role : roleList) {
            if (org.apache.commons.lang.StringUtils.equals("admin", role)) {
                adminRole = "0";
                break;
            }
        }
        QueryWrapper<ZyInfoSys> queryWrapper = new QueryWrapper<ZyInfoSys>();
        if (org.apache.commons.lang.StringUtils.equals("1", adminRole)) {
            QueryWrapper<KcExportConfigTpkwcqkjzglx> queryWrapperCon = new QueryWrapper<KcExportConfigTpkwcqkjzglx>();
            queryWrapperCon.eq("gh", sysUser.getUsername());
            queryWrapperCon.orderByDesc("create_time");
            queryWrapperCon.last("limit 1");
            KcExportConfigTpkwcqkjzglx kcExportConfigTpkwcqkjzglx = kcExportConfigTpkwcqkjzglxService.getOne(queryWrapperCon);
            queryWrapper.eq("kkdw", kcExportConfigTpkwcqkjzglx.getDwmc());
        }

        if (com.baomidou.mybatisplus.core.toolkit.StringUtils.isEmpty(zyInfoSys.getXqxn())) {
            KcSysConfig kcSysConfig = kcSysConfigService.getById("1");
            queryWrapper.eq("xqxn", kcSysConfig.getFlag1());
        } else {
            queryWrapper.eq("xqxn", zyInfoSys.getXqxn());
        }
        queryWrapper.like(com.baomidou.mybatisplus.core.toolkit.StringUtils.isNotEmpty(zyInfoSys.getKkdw()), "kkdw", zyInfoSys.getKkdw());
        queryWrapper.like(com.baomidou.mybatisplus.core.toolkit.StringUtils.isNotEmpty(zyInfoSys.getKcmc()), "kcmc", zyInfoSys.getKcmc());
        queryWrapper.like(com.baomidou.mybatisplus.core.toolkit.StringUtils.isNotEmpty(zyInfoSys.getKcbh()), "kcbh", zyInfoSys.getKcbh());
        queryWrapper.like(com.baomidou.mybatisplus.core.toolkit.StringUtils.isNotEmpty(zyInfoSys.getSkjs()), "skjs", zyInfoSys.getSkjs());
        queryWrapper.eq("flag", 0);
        // Step.2 获取导出数据
        List<ZyInfoSys> exportList = service.exportSysXls(zyInfoSys, queryWrapper);

        // Step.3 AutoPoi 导出Excel
        ModelAndView mv = new ModelAndView(new JeecgEntityExcelView());
        //此处设置的filename无效 ,前端会重更新设置一下
        mv.addObject(NormalExcelConstants.FILE_NAME, title);
        mv.addObject(NormalExcelConstants.CLASS, ZyInfoSys.class);
        //update-begin--Author:liusq  Date:20210126 for：图片导出报错，ImageBasePath未设置--------------------
        ExportParams exportParams = new ExportParams(title + "报表", "导出人:" + sysUser.getRealname(), title);
        exportParams.setImageBasePath(upLoadPath);
        //update-end--Author:liusq  Date:20210126 for：图片导出报错，ImageBasePath未设置----------------------
        mv.addObject(NormalExcelConstants.PARAMS, exportParams);
        mv.addObject(NormalExcelConstants.DATA_LIST, exportList);
        return mv;
    }


    @ApiOperation(value = "作业发布-通过id查询", notes = "作业发布-通过id查询")
    @GetMapping(value = "/queryZyinfoByStuId")
    public Result<ZyInfo> queryZyinfoByStuId(@RequestParam(name = "id", required = true) String id) {
//		ZyInfoStudent zyInfoStudent = zyInfoStudentService.getById(id);
        ZyInfo zyInfo = zyInfoService.getById(id);
        return Result.OK(zyInfo);
    }


    @AutoLog(value = "作业发布-添加")
    @ApiOperation(value = "作业发布-添加", notes = "作业发布-添加")
    @PostMapping(value = "/batchAdd")
    public Result<String> batchAdd(@RequestBody List<ZyInfo> list) {
        ZyInfo zyInfo = list.get(0);

        //删除老师留过的作业，重新生成新的
        QueryWrapper<ZyInfo> query = new QueryWrapper<>();
        query.eq("rwbh", zyInfo.getRwbh());
//        query.eq("create_by", zyInfo.getCreateBy());
        query.eq("zy_leixing", "0");
        List<ZyInfo> oldList = zyInfoService.list(query);
        zyInfoService.remove(query);

        KcSysConfig kcSysConfig = kcSysConfigService.getById("1");
        QueryWrapper<KcKechengbiao> kcKechengbiaoQueryWrapper = new QueryWrapper<>();
        kcKechengbiaoQueryWrapper.eq("xqxn", kcSysConfig.getFlag1());
        kcKechengbiaoQueryWrapper.eq("rwbh", zyInfo.getRwbh());
        kcKechengbiaoQueryWrapper.last("limit 1");
        KcKechengbiao kcKechengbiao = kcKechengbiaoService.getOne(kcKechengbiaoQueryWrapper);
        for (int i = 0; i < list.size(); i++) {
            ZyInfo par = list.get(i);
            List<ZyInfo> zyInfo1 = oldList.stream().filter(zyInfo2 -> zyInfo2.getId().equals(par.getId())).collect(Collectors.toList());
            if (zyInfo1 != null && zyInfo1.size() > 0) {
                ZyInfo zypar = zyInfo1.get(0);
                zypar.setSort(par.getSort());
                zypar.setScore(par.getScore());
                zyInfoService.save(zypar);
            } else {
                par.setXnxq(kcSysConfig.getFlag1());
                par.setZyStatus("0");
                par.setXkxs(kcKechengbiao.getXkrs());
                zyInfoService.save(par);
            }
        }
        return Result.OK("添加成功！");
    }

    @AutoLog(value = "期末作业发布-添加")
    @ApiOperation(value = "期末作业发布-添加", notes = "期末作业发布-添加")
    @PostMapping(value = "/batchQmAdd")
    public Result<String> batchQmAdd(@RequestBody List<ZyInfo> list) {
        ZyInfo zyInfo = list.get(0);

        //删除老师留过的作业，重新生成新的
        QueryWrapper<ZyInfo> query = new QueryWrapper<>();
        query.eq("rwbh", zyInfo.getRwbh());
        query.eq("create_by", zyInfo.getCreateBy());
        query.eq("zy_leixing", "1");
        List<ZyInfo> oldList = zyInfoService.list(query);
        zyInfoService.remove(query);

        KcSysConfig kcSysConfig = kcSysConfigService.getById("1");
        QueryWrapper<KcKechengbiao> kcKechengbiaoQueryWrapper = new QueryWrapper<>();
        kcKechengbiaoQueryWrapper.eq("xqxn", kcSysConfig.getFlag1());
        kcKechengbiaoQueryWrapper.eq("rwbh", zyInfo.getRwbh());
        kcKechengbiaoQueryWrapper.last("limit 1");
        KcKechengbiao kcKechengbiao = kcKechengbiaoService.getOne(kcKechengbiaoQueryWrapper);
        for (int i = 0; i < list.size(); i++) {
            ZyInfo par = list.get(i);
            List<ZyInfo> zyInfo1 = oldList.stream().filter(zyInfo2 -> zyInfo2.getId().equals(par.getId())).collect(Collectors.toList());
            if (zyInfo1 != null && zyInfo1.size() > 0) {
                ZyInfo zypar = zyInfo1.get(0);
                zypar.setSort(par.getSort());
                zypar.setScore(par.getScore());
                zyInfoService.save(zypar);
            } else {
                par.setXnxq(kcSysConfig.getFlag1());
                par.setZyStatus("0");
                par.setXkxs(kcKechengbiao.getXkrs());
                zyInfoService.save(par);
            }
        }
        return Result.OK("添加成功！");
    }

    // appId
    private static final String appId = "wx031697a8ca09a5ce";//东师

    private static final String agentid = "1000065";//
    // appIdSecret
    private static final String appIdSecret = "6Qhnge3xfzAQMDX2TcjEyE0vUGP96hP9OTYUsYBze2Y";//东师

    //微信通知点击后跳转的页面
    private static final String domainTo = "https://smartedu.nenu.edu.cn";

    public void sendWxmessage(KcWechatSendLog kcWechatSendLog) {
        String openId = kcWechatSendLog.getOpenid();//曹老师账号
        System.out.println("openId:" + openId + "");
        if (org.apache.commons.lang3.StringUtils.isNotEmpty(openId)) {
            try {
                String urlToken = "https://qyapi.weixin.qq.com/cgi-bin/gettoken?corpid=" + appId + "&corpsecret=" + appIdSecret;
                System.out.println("urlToken：  " + urlToken);
                String res = HttpUtil.get(urlToken);
                JSONObject jsonObjectToken = JSONObject.parseObject(res);
                System.out.println("jsonObjectToken：{}" + jsonObjectToken);
                String accessToken = jsonObjectToken.getString("access_token");
                System.out.println("accessToken：{}" + accessToken);

                // 微信的基础accessToken
                String url = "https://qyapi.weixin.qq.com/cgi-bin/message/send?access_token=" + accessToken;
                Map<String, Object> sendMag = new HashMap<>();

//				 1、xx老师，你好，您本学期（2023秋）听课要求为：5次，当前实际听课次数：3次，请尽快完成本学期的听课任务。
                String html = kcWechatSendLog.getYtkcs();
                html = html + "\n<a href=\"" + domainTo + "\">查看</a>";
                sendMag.put("content", html);//授课老师推送内容
                RestTemplate restTemplate = new RestTemplate();
                //拼接base参数
                Map<String, Object> sendBody = new HashMap<>();
                sendBody.put("touser", openId);                // openId
                sendBody.put("msgtype", "text");               // 消息类型，此时固定为：text
                sendBody.put("agentid", agentid);              // 企业id
                sendBody.put("text", sendMag);                //发送内容
                ResponseEntity<String> forEntity = restTemplate.postForEntity(url, sendBody, String.class);
                JSONObject jsonObject2 = JSONObject.parseObject(forEntity.getBody());
                System.out.println("jsonObject2 : " + jsonObject2);
                String messageCode = jsonObject2.getString("errcode");
                String msgId = jsonObject2.getString("msgid");
                System.out.println("messageCode : " + messageCode + ", msgId: " + msgId);
            } catch (Exception e) {
                e.printStackTrace();
            }
        } else {
        }
    }


    @ApiOperation(value = "作业发布-通过id查询", notes = "作业发布-通过id查询")
    @GetMapping(value = "/zyzb")
    public Result<List<ZyInfo>> zyzb(@RequestParam(name = "rwbh") String rwbh, @RequestParam(name = "xqxn") String xqxn, @RequestParam(name = "zyLeixing") String zyLeixing) {
        String teano = null;
        List<ZyInfo> zyInfo = zyInfoService.zyzb(rwbh, xqxn, teano, zyLeixing);
        return Result.OK(zyInfo);
    }


    /**
     * 编辑
     *
     * @param zyInfo
     * @return
     */
    @AutoLog(value = "作业发布-微信提醒")
    @ApiOperation(value = "作业发布-微信提醒", notes = "作业发布-微信提醒")
    @RequestMapping(value = "/sendWxtx", method = {RequestMethod.PUT, RequestMethod.POST})
    public void sendWxtx(@RequestBody ZyInfo zyInfo) {

        ZyInfo zyInfo2 = zyInfoService.getById(zyInfo.getId());
        if (StringUtils.equals(zyInfo2.getZyStatus(), "1")) {
            QueryWrapper<KcKechengbiao> kcKechengbiaoQueryWrapper = new QueryWrapper<>();
            kcKechengbiaoQueryWrapper.eq("rwbh", zyInfo.getRwbh());
            kcKechengbiaoQueryWrapper.eq("jgh", zyInfo.getCreateBy());
            kcKechengbiaoQueryWrapper.eq("xqxn", zyInfo.getXnxq());
            kcKechengbiaoQueryWrapper.last("limit 1");
            KcKechengbiao kcKechengbiao = kcKechengbiaoService.getOne(kcKechengbiaoQueryWrapper);

            QueryWrapper<ZyDbtx> zyDbtxQueryWrapper = new QueryWrapper<>();
            zyDbtxQueryWrapper.eq("type", "2");//发送作业
            zyDbtxQueryWrapper.eq("rwbh", zyInfo.getRwbh());
            List<ZyDbtx> dbtxlist = zyDbtxService.list(zyDbtxQueryWrapper);
            String xharrs[] = new String[dbtxlist.size()];
            for (int i = 0; i < dbtxlist.size(); i++) {
                xharrs[i] = dbtxlist.get(i).getCreateBy();
            }

            QueryWrapper<Xxhbbks> queryWrapper = new QueryWrapper<>();
            queryWrapper.apply("a.xh = b.xh");
            queryWrapper.eq("b.KCAPZBBH", zyInfo2.getRwbh());
            if (xharrs.length > 0) {
                queryWrapper.notIn("a.xh", xharrs);
            }
            List<Xxhbbks> list = xxhbbksService.getXsxkbAllList(queryWrapper);

            LoginUser user = (LoginUser) SecurityUtils.getSubject().getPrincipal();
            for (Xxhbbks xxhbbks : list) {

                ZyDbtx zyDbtx = new ZyDbtx();
                if (StringUtils.equals(zyInfo.getZyLeixing(), "0")) {
                    zyDbtx.setType("0");//0发布作业 1评分 2测验 3问卷 4讨论
                    zyDbtx.setContent(user.getRealname() + "老师主讲的[" + kcKechengbiao.getKcmc() + "]课程于" + DateUtils.formatDate(new Date(), "yyyy-MM-dd HH:mm:ss") + "发布了一篇题目为“" + zyInfo.getTitle() + "”的作业，该作业提交时间为：" + DateUtils.formatDate(zyInfo.getStartTime(), "yyyy-MM-dd HH:mm") + " ~ " + DateUtils.formatDate(zyInfo.getEndTime(), "yyyy-MM-dd HH:mm") + "，请按时完成！  ");
                } else if (StringUtils.equals(zyInfo.getZyLeixing(), "1")) {
                    zyDbtx.setType("10");//0发布作业 1评分 2测验 3问卷 4讨论
                    zyDbtx.setContent(user.getRealname() + "老师主讲的[" + kcKechengbiao.getKcmc() + "]课程于" + DateUtils.formatDate(new Date(), "yyyy-MM-dd HH:mm:ss") + "发布了一篇题目为“" + zyInfo.getTitle() + "”的期末考试，该期末考试提交时间为：" + DateUtils.formatDate(zyInfo.getStartTime(), "yyyy-MM-dd HH:mm") + " ~ " + DateUtils.formatDate(zyInfo.getEndTime(), "yyyy-MM-dd HH:mm") + "，请按时完成！  ");
                }
                try {
                    KcWechatSendLog kcWechatSendLog = new KcWechatSendLog();
//					kcWechatSendLog.setOpenid("2016900057");//指定曹老师账号
                    kcWechatSendLog.setOpenid(xxhbbks.getXh());
                    kcWechatSendLog.setYtkcs(zyDbtx.getContent());
//                    sendWxmessage(kcWechatSendLog);
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
        }
    }


    @ApiOperation(value = "统计作业测试使用情况", notes = "统计作业测试使用情况")
    @GetMapping(value = "/sysStaticNo")
    public Result<Map<String, Object>> sysStaticNo(ZyInfoSys zyInfoSys,
                                                   @RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo,
                                                   @RequestParam(name = "pageSize", defaultValue = "10") Integer pageSize,
                                                   HttpServletRequest req) {
        LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
        //-------------获取当前登陆人是否是管理员角色，如果不是都按照教务秘书处理---------------------------
        List<String> roleList = sysBaseApi.getRolesByUsername(sysUser.getUsername());
        String adminRole = "1";//0 admin  1教务秘书
        for (String role : roleList) {
            if (org.apache.commons.lang.StringUtils.equals("admin", role)) {
                adminRole = "0";
                break;
            }
        }
        QueryWrapper<ZyInfoSys> queryWrapper = new QueryWrapper<ZyInfoSys>();
        if (org.apache.commons.lang.StringUtils.equals("1", adminRole)) {
            QueryWrapper<KcExportConfigTpkwcqkjzglx> queryWrapperCon = new QueryWrapper<KcExportConfigTpkwcqkjzglx>();
            queryWrapperCon.eq("gh", sysUser.getUsername());
            queryWrapperCon.orderByDesc("create_time");
            queryWrapperCon.last("limit 1");
            KcExportConfigTpkwcqkjzglx kcExportConfigTpkwcqkjzglx = kcExportConfigTpkwcqkjzglxService.getOne(queryWrapperCon);
            zyInfoSys.setKkdw(kcExportConfigTpkwcqkjzglx.getDwmc());
        }

        if (com.baomidou.mybatisplus.core.toolkit.StringUtils.isEmpty(zyInfoSys.getXqxn())) {
            KcSysConfig kcSysConfig = kcSysConfigService.getById("1");
            zyInfoSys.setXqxn(kcSysConfig.getFlag1());
        }

        Map<String, Object> pageList = zyInfoService.sysStaticNo(zyInfoSys);
        return Result.OK(pageList);
    }


    @ApiOperation(value = "统计作业测试使用情况", notes = "刷新排行数据")
    @GetMapping(value = "/getPHData")
    public Result<List<ZyInfoSys>> getPHData(ZyInfoSys zyInfoSys,
                                             @RequestParam(name = "tag", required = false) String tag,
                                             HttpServletRequest req) {
        LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
        //-------------获取当前登陆人是否是管理员角色，如果不是都按照教务秘书处理---------------------------
        List<String> roleList = sysBaseApi.getRolesByUsername(sysUser.getUsername());
        String adminRole = "1";//0 admin  1教务秘书
        for (String role : roleList) {
            if (org.apache.commons.lang.StringUtils.equals("admin", role)) {
                adminRole = "0";
                break;
            }
        }
        QueryWrapper<ZyInfoSys> queryWrapper = new QueryWrapper<ZyInfoSys>();
        if (org.apache.commons.lang.StringUtils.equals("1", adminRole)) {
            QueryWrapper<KcExportConfigTpkwcqkjzglx> queryWrapperCon = new QueryWrapper<KcExportConfigTpkwcqkjzglx>();
            queryWrapperCon.eq("gh", sysUser.getUsername());
            queryWrapperCon.orderByDesc("create_time");
            queryWrapperCon.last("limit 1");
            KcExportConfigTpkwcqkjzglx kcExportConfigTpkwcqkjzglx = kcExportConfigTpkwcqkjzglxService.getOne(queryWrapperCon);
            zyInfoSys.setKkdw(kcExportConfigTpkwcqkjzglx.getDwmc());
        }

        if (com.baomidou.mybatisplus.core.toolkit.StringUtils.isEmpty(zyInfoSys.getXqxn())) {
            KcSysConfig kcSysConfig = kcSysConfigService.getById("1");
            zyInfoSys.setXqxn(kcSysConfig.getFlag1());
        }
        List<ZyInfoSys> list = zyInfoService.getPHData(zyInfoSys, tag);
        return Result.OK(list);
    }

    @ApiOperation(value = "统计作业测试使用情况", notes = "导出排行数据")
    @GetMapping(value = "/exportPHData")
    public ModelAndView exportPHData(ZyInfoSys zyInfoSys, @RequestParam(name = "tag", required = false) String tag) {
        LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
        //-------------获取当前登陆人是否是管理员角色，如果不是都按照教务秘书处理---------------------------
        List<String> roleList = sysBaseApi.getRolesByUsername(sysUser.getUsername());
        String adminRole = "1";//0 admin  1教务秘书
        for (String role : roleList) {
            if (org.apache.commons.lang.StringUtils.equals("admin", role)) {
                adminRole = "0";
                break;
            }
        }
        QueryWrapper<ZyInfoSys> queryWrapper = new QueryWrapper<ZyInfoSys>();
        if (org.apache.commons.lang.StringUtils.equals("1", adminRole)) {
            QueryWrapper<KcExportConfigTpkwcqkjzglx> queryWrapperCon = new QueryWrapper<KcExportConfigTpkwcqkjzglx>();
            queryWrapperCon.eq("gh", sysUser.getUsername());
            queryWrapperCon.orderByDesc("create_time");
            queryWrapperCon.last("limit 1");
            KcExportConfigTpkwcqkjzglx kcExportConfigTpkwcqkjzglx = kcExportConfigTpkwcqkjzglxService.getOne(queryWrapperCon);
            zyInfoSys.setKkdw(kcExportConfigTpkwcqkjzglx.getDwmc());
        }

        if (com.baomidou.mybatisplus.core.toolkit.StringUtils.isEmpty(zyInfoSys.getXqxn())) {
            KcSysConfig kcSysConfig = kcSysConfigService.getById("1");
            zyInfoSys.setXqxn(kcSysConfig.getFlag1());
        }
        List<ZyInfoSys> list = zyInfoService.getPHData(zyInfoSys, tag);

        List<ExportEntity1> exportList = list.stream()
                .map(zyInfo -> {
                    ExportEntity1 entity = new ExportEntity1();
                    // 使用 Spring 的 BeanUtils 复制属性
                    BeanUtils.copyProperties(zyInfo, entity);
                    String rn = entity.getRownum();
                    entity.setRownum(rn.substring(0, rn.indexOf(".")));
                    return entity;
                })
                .collect(Collectors.toList());

        String title = "";
        if ("xntop10".equals(tag)) {
            title = "本学年作业使用排行";
        }
        if ("jrtop10".equals(tag)) {
            title = "本学年测验使用排行";
        }
        if ("kctop10".equals(tag)) {
            title = "本学年课程使用排行";
        }
        if ("jstop10".equals(tag)) {
            title = "本学年教师使用排行";
        }
        ModelAndView mv = new ModelAndView(new JeecgEntityExcelView());
        //此处设置的filename无效 ,前端会重更新设置一下
        mv.addObject(NormalExcelConstants.FILE_NAME, title);
        mv.addObject(NormalExcelConstants.CLASS, ExportEntity1.class);
        //update-begin--Author:liusq  Date:20210126 for：图片导出报错，ImageBasePath未设置--------------------
        ExportParams exportParams = new ExportParams(title + "报表", "导出人:" + sysUser.getRealname(), title);
        exportParams.setImageBasePath(upLoadPath);
        //update-end--Author:liusq  Date:20210126 for：图片导出报错，ImageBasePath未设置----------------------
        mv.addObject(NormalExcelConstants.PARAMS, exportParams);
        mv.addObject(NormalExcelConstants.DATA_LIST, exportList);
        return mv;
    }

    @ApiOperation(value = "统计作业使用情况", notes = "统计作业使用情况")
    @GetMapping(value = "/sysStaticZyList")
    public Result<IPage<ZyInfoSys>> sysStaticZyList(ZyInfoSys zyInfoSys,
                                                    @RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo,
                                                    @RequestParam(name = "pageSize", defaultValue = "10") Integer pageSize,
                                                    HttpServletRequest req) {
        LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
        //-------------获取当前登陆人是否是管理员角色，如果不是都按照教务秘书处理---------------------------
        List<String> roleList = sysBaseApi.getRolesByUsername(sysUser.getUsername());
        String adminRole = "1";//0 admin  1教务秘书
        for (String role : roleList) {
            if (org.apache.commons.lang.StringUtils.equals("admin", role)) {
                adminRole = "0";
                break;
            }
        }
        QueryWrapper<ZyInfoSys> queryWrapper = new QueryWrapper<ZyInfoSys>();
        if (org.apache.commons.lang.StringUtils.equals("1", adminRole)) {
            QueryWrapper<KcExportConfigTpkwcqkjzglx> queryWrapperCon = new QueryWrapper<KcExportConfigTpkwcqkjzglx>();
            queryWrapperCon.eq("gh", sysUser.getUsername());
            queryWrapperCon.orderByDesc("create_time");
            queryWrapperCon.last("limit 1");
            KcExportConfigTpkwcqkjzglx kcExportConfigTpkwcqkjzglx = kcExportConfigTpkwcqkjzglxService.getOne(queryWrapperCon);
            zyInfoSys.setKkdw(kcExportConfigTpkwcqkjzglx.getDwmc());
        }

        if (com.baomidou.mybatisplus.core.toolkit.StringUtils.isEmpty(zyInfoSys.getXqxn())) {
            KcSysConfig kcSysConfig = kcSysConfigService.getById("1");
            zyInfoSys.setXqxn(kcSysConfig.getFlag1());
        }

        Page<ZyInfoSys> page = new Page<ZyInfoSys>(pageNo, pageSize);
        IPage<ZyInfoSys> pageList = zyInfoService.sysStaticZyList(page, zyInfoSys);
        return Result.OK(pageList);
    }

    @ApiOperation(value = "统计测验使用情况", notes = "统计测验使用情况")
    @GetMapping(value = "/sysStaticCyList")
    public Result<IPage<CyInfoSys>> sysStaticCyList(CyInfoSys cyInfoSys,
                                                    @RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo,
                                                    @RequestParam(name = "pageSize", defaultValue = "10") Integer pageSize,
                                                    HttpServletRequest req) {
        LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
        //-------------获取当前登陆人是否是管理员角色，如果不是都按照教务秘书处理---------------------------
        List<String> roleList = sysBaseApi.getRolesByUsername(sysUser.getUsername());
        String adminRole = "1";//0 admin  1教务秘书
        for (String role : roleList) {
            if (org.apache.commons.lang.StringUtils.equals("admin", role)) {
                adminRole = "0";
                break;
            }
        }
        QueryWrapper<ZyInfoSys> queryWrapper = new QueryWrapper<ZyInfoSys>();
        if (org.apache.commons.lang.StringUtils.equals("1", adminRole)) {
            QueryWrapper<KcExportConfigTpkwcqkjzglx> queryWrapperCon = new QueryWrapper<KcExportConfigTpkwcqkjzglx>();
            queryWrapperCon.eq("gh", sysUser.getUsername());
            queryWrapperCon.orderByDesc("create_time");
            queryWrapperCon.last("limit 1");
            KcExportConfigTpkwcqkjzglx kcExportConfigTpkwcqkjzglx = kcExportConfigTpkwcqkjzglxService.getOne(queryWrapperCon);
            cyInfoSys.setKkdw(kcExportConfigTpkwcqkjzglx.getDwmc());
        }

        if (com.baomidou.mybatisplus.core.toolkit.StringUtils.isEmpty(cyInfoSys.getXqxn())) {
            KcSysConfig kcSysConfig = kcSysConfigService.getById("1");
            cyInfoSys.setXqxn(kcSysConfig.getFlag1());
        }

        Page<CyInfoSys> page = new Page<CyInfoSys>(pageNo, pageSize);
        IPage<CyInfoSys> pageList = zyInfoService.sysStaticCyList(page, cyInfoSys);
        return Result.OK(pageList);
    }

    @RequestMapping(value = "/getStaticCyExportUrl")
    public ModelAndView getStaticCyExportUrl(HttpServletRequest request, CyInfoSys cyInfoSys) {
        String title = "课程作业";
        // Step.1 组装查询条件
        LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
        //-------------获取当前登陆人是否是管理员角色，如果不是都按照教务秘书处理---------------------------
        List<String> roleList = sysBaseApi.getRolesByUsername(sysUser.getUsername());
        String adminRole = "1";//0 admin  1教务秘书
        for (String role : roleList) {
            if (org.apache.commons.lang.StringUtils.equals("admin", role)) {
                adminRole = "0";
                break;
            }
        }
        QueryWrapper<ZyInfoSys> queryWrapper = new QueryWrapper<ZyInfoSys>();
        if (org.apache.commons.lang.StringUtils.equals("1", adminRole)) {
            QueryWrapper<KcExportConfigTpkwcqkjzglx> queryWrapperCon = new QueryWrapper<KcExportConfigTpkwcqkjzglx>();
            queryWrapperCon.eq("gh", sysUser.getUsername());
            queryWrapperCon.orderByDesc("create_time");
            queryWrapperCon.last("limit 1");
            KcExportConfigTpkwcqkjzglx kcExportConfigTpkwcqkjzglx = kcExportConfigTpkwcqkjzglxService.getOne(queryWrapperCon);
            cyInfoSys.setKkdw(kcExportConfigTpkwcqkjzglx.getDwmc());
        }

        if (com.baomidou.mybatisplus.core.toolkit.StringUtils.isEmpty(cyInfoSys.getXqxn())) {
            KcSysConfig kcSysConfig = kcSysConfigService.getById("1");
            cyInfoSys.setXqxn(kcSysConfig.getFlag1());
        }

        // Step.2 获取导出数据
        List<CyInfoSys> exportList = service.getStaticCyExportUrl(cyInfoSys);

        // Step.3 AutoPoi 导出Excel
        ModelAndView mv = new ModelAndView(new JeecgEntityExcelView());
        //此处设置的filename无效 ,前端会重更新设置一下
        mv.addObject(NormalExcelConstants.FILE_NAME, title);
        mv.addObject(NormalExcelConstants.CLASS, CyInfoSys.class);
        //update-begin--Author:liusq  Date:20210126 for：图片导出报错，ImageBasePath未设置--------------------
        ExportParams exportParams = new ExportParams(title + "报表", "导出人:" + sysUser.getRealname(), title);
        exportParams.setImageBasePath(upLoadPath);
        //update-end--Author:liusq  Date:20210126 for：图片导出报错，ImageBasePath未设置----------------------
        mv.addObject(NormalExcelConstants.PARAMS, exportParams);
        mv.addObject(NormalExcelConstants.DATA_LIST, exportList);
        return mv;
    }


    @ApiOperation(value = "作业发布-分页列表查询", notes = "作业发布-分页列表查询")
    @GetMapping(value = "/listKhcl")
    public Result<IPage<ZyInfo>> listKhcl(ZyInfo zyInfo,
                                          @RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo,
                                          @RequestParam(name = "pageSize", defaultValue = "10") Integer pageSize,
                                          HttpServletRequest req) {


        LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
        QueryWrapper<ZyInfo> queryWrapper = QueryGenerator.initQueryWrapper(zyInfo, req.getParameterMap());
        Page<ZyInfo> page = new Page<ZyInfo>(pageNo, pageSize);
        queryWrapper.eq("create_by", sysUser.getUsername());
        queryWrapper.orderByDesc("xnxq");
        queryWrapper.orderByAsc("sort - 0");
        IPage<ZyInfo> pageList = zyInfoService.listKhcl(page, queryWrapper);

        return Result.OK(pageList);
    }

    @PostMapping(value = "/getxzxx")
    public Result<List<ZyXzInfo>> getxzxx(@RequestBody ZyInfo zyInfo) {
        return Result.OK(zyInfoService.getxzxx(zyInfo));
    }

    @PostMapping(value = "/saveData")
    public Result<String> saveData(@RequestBody XzReq req) {
        zyInfoService.saveData(req.getZyinfoId(), req.getRs(), req.getList());
        return Result.OK("保存成功！");
    }

}
