package org.jeecg.modules.kc.zyInfo.entity;

import java.io.Serializable;
import java.io.UnsupportedEncodingException;
import java.util.Date;
import java.math.BigDecimal;

import com.baomidou.mybatisplus.annotation.*;
import lombok.Data;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;
import org.jeecgframework.poi.excel.annotation.Excel;
import org.jeecg.common.aspect.annotation.Dict;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * @Description: 作业发布
 * @Author: jeecg-boot
 * @Date:   2024-05-06
 * @Version: V1.0
 */
@Data
@TableName("zy_info")
@Accessors(chain = true)
@EqualsAndHashCode(callSuper = false)
@ApiModel(value="zy_info对象", description="作业发布")
public class ZyInfo implements Serializable {
    private static final long serialVersionUID = 1L;

	/**id*/
	@TableId(type = IdType.ASSIGN_ID)
    @ApiModelProperty(value = "id")
    private java.lang.String id;
	/**createBy*/
    @ApiModelProperty(value = "createBy")
    private java.lang.String createBy;
	/**createTime*/
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd")
    @DateTimeFormat(pattern="yyyy-MM-dd")
    @ApiModelProperty(value = "createTime")
    private java.util.Date createTime;
	/**updateBy*/
    @ApiModelProperty(value = "updateBy")
    private java.lang.String updateBy;
	/**updateTime*/
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd")
    @DateTimeFormat(pattern="yyyy-MM-dd")
    @ApiModelProperty(value = "updateTime")
    private java.util.Date updateTime;
	/**作业名称*/
	@Excel(name = "作业名称", width = 15)
    @ApiModelProperty(value = "作业名称")
    private java.lang.String title;
	/**类型*/
	@Excel(name = "类型", width = 15, dicCode = "zy_type")
	@Dict(dicCode = "zy_type")
    @ApiModelProperty(value = "类型")
    private java.lang.String zyType;
	/**描述*/
	@Excel(name = "描述", width = 15)
    @ApiModelProperty(value = "描述")
    private java.lang.String content;
	/**开始时间*/
	@Excel(name = "开始时间", width = 15, format = "yyyy-MM-dd HH:mm")
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
    @ApiModelProperty(value = "开始时间")
    private java.util.Date startTime;
	/**结束时间*/
	@Excel(name = "结束时间", width = 15, format = "yyyy-MM-dd HH:mm")
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
    @ApiModelProperty(value = "结束时间")
    private java.util.Date endTime;
	/**状态*/
	@Excel(name = "状态", width = 15)
    @ApiModelProperty(value = "状态")
    @Dict(dicCode = "zy_status")
    private java.lang.String zyStatus;
	/**学年学期*/
	@Excel(name = "学年学期", width = 15)
    @ApiModelProperty(value = "学年学期")
    private java.lang.String xnxq;
	/**外网是否查重*/
	@Excel(name = "外网是否查重", width = 15, dicCode = "yn")
	@Dict(dicCode = "yn")
    @ApiModelProperty(value = "外网是否查重")
    private java.lang.String wwcc;
	/**外网通过率*/
	@Excel(name = "外网通过率", width = 15)
    @ApiModelProperty(value = "外网通过率")
    @TableField(updateStrategy = FieldStrategy.DEFAULT)
    private java.lang.Double wwtgl;
	/**内网查重*/
	@Excel(name = "内网查重", width = 15, dicCode = "yn")
	@Dict(dicCode = "yn")
    @ApiModelProperty(value = "内网查重")
    private java.lang.String nwcc;
	/**内网通过率*/
	@Excel(name = "内网通过率", width = 15)
    @ApiModelProperty(value = "内网通过率")
    private java.lang.Double nwtgl;
	/**aigc查重*/
	@Excel(name = "aigc查重", width = 15, dicCode = "yn")
	@Dict(dicCode = "yn")
    @ApiModelProperty(value = "aigc查重")
    private java.lang.String aigccc;
	/**aigc通过率*/
	@Excel(name = "aigc通过率", width = 15)
    @ApiModelProperty(value = "aigc通过率")
    private java.lang.Double aigctgl;
    /**校内查重*/
    @Excel(name = "校内查重", width = 15, dicCode = "yn")
    @Dict(dicCode = "yn")
    @ApiModelProperty(value = "校内查重")
    private java.lang.String xncc;
    /**校内通过率*/
    @Excel(name = "校内通过率", width = 15)
    @ApiModelProperty(value = "校内通过率")
    private java.lang.Double xntgl;

    @ApiModelProperty(value = "是否以小组形式提交作业 Y N")
    private String xzxstjzy;

    @ApiModelProperty(value = "小组人数")
    private Integer xzrs;

    @ApiModelProperty(value = "是否配置过小组信息 Y N")
    private String sfpzgxzxx;

    //作业分值
    private String score;

    private java.lang.String rwbh;
    private java.lang.String filePath;
    private java.lang.String xkxs;//选课学生

    private java.lang.String kcnr;//考察内容（多选）
    private java.lang.String pfbz;//评分标准
    private java.lang.String sturead;//评分标准是否允许学生查看
    private Integer sort;//序号
    private java.lang.String xshpkg;//学生互评开关
    private java.lang.String xshprsq;//学生互评人数
    private String zyLeixing;//作业类型  0课程作业  1期末作业

    @JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
    private java.util.Date xshpkssj;//学生互评开始时间
    @JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
    private java.util.Date xshpjssj;//学生互评结束时间
    private java.lang.String sfzzcj;//是否最终成绩（1是 0否）
    private java.lang.String xssfck;//学生是否查看（1是 0否）
    private java.lang.String hpsfwcone;//第1次互评是否完成（1是 0否）
    private java.lang.String hpsfwctwo;//第2次互评是否完成（1是 0否）
    private String sfcc;//是否查重（0不查重  1查重）

    @Dict(dicCode = "sfsckhcl")
    private String sfsckhcl;//是否上传考核材料（0否  1是）
    @JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
    private Date sfsckhclTime;//上传考核材料时间


    @TableField(exist = false)
    private String sflssj;//是否历史数据

    @TableField(exist = false)
    private String stuId;
    @TableField(exist = false)
    private String stuFilePath;
    @TableField(exist = false)
    private String stuPdfPath;
    @TableField(exist = false)
    private String wtjnum;
    @TableField(exist = false)
    private String ytjnum;
    @TableField(exist = false)
    private String wpynum;
    @TableField(exist = false)
    private String ypynum;
    @TableField(exist = false)
    private String wwxsl;
    @TableField(exist = false)
    private String nwxsl;
    @TableField(exist = false)
    private String aigcxsl;
    @TableField(exist = false)
    private String xnxsl;
    @TableField(exist = false)
    private String teano;

    @TableField(exist = false)
    private String kcmc;
    @TableField(exist = false)
    private String skjs;
    @TableField(exist = false)
    private String stuscore;

    @TableField(exist = false)
    private String wwsftg;
    @TableField(exist = false)
    private String nwsftg;
    @TableField(exist = false)
    private String aigcsftg;
    @TableField(exist = false)
    private String xnsftg;
    @TableField(exist = false)
    private String zzdf;
    @TableField(exist = false)
    private String xshpfs;
    @TableField(exist = false)
    private String jxfs;
    @TableField(exist = false)
    private String dpynum;
    @TableField(exist = false)
    private String zgccl;
    @TableField(exist = false)
    private String zyzb;
    @TableField(exist = false)
    private String scoreFabu;
    @TableField(exist = false)
    private String pyContent;
    @TableField(exist = false)
    private String pyFilePath;
    @TableField(exist = false)
    private String teacherNo;
    @TableField(exist = false)
    private String yuanTeacherNo;
    @TableField(exist = false)
    private String yuanTeacherName;
    @TableField(exist = false)
    private String bhContent;

}
