package org.jeecg.modules.kc.zyInfo.service.impl;

import cn.hutool.core.util.IdUtil;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.google.common.collect.Lists;
import com.xkcoding.http.HttpUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.SecurityUtils;
import org.jeecg.common.system.vo.LoginUser;
import org.jeecg.modules.kc.grab.imports.entity.Xxhbbks;
import org.jeecg.modules.kc.grab.imports.service.IXxhbbksService;
import org.jeecg.modules.kc.kcWechatSendLog.entity.KcWechatSendLog;
import org.jeecg.modules.kc.ktgl.entity.KcKechengbiao;
import org.jeecg.modules.kc.ktgl.service.IKcKechengbiaoService;
import org.jeecg.modules.kc.zyDbtx.entity.ZyDbtx;
import org.jeecg.modules.kc.zyDbtx.service.IZyDbtxService;
import org.jeecg.modules.kc.zyInfo.entity.*;
import org.jeecg.modules.kc.zyInfo.mapper.ZyInfoMapper;
import org.jeecg.modules.kc.zyInfo.service.IZyInfoService;
import org.jeecg.modules.tools.DateUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.client.RestTemplate;

import java.util.*;
import java.util.stream.Collectors;

/**
 * @Description: 作业发布
 * @Author: jeecg-boot
 * @Date: 2024-05-06
 * @Version: V1.0
 */
@Service
public class ZyInfoServiceImpl extends ServiceImpl<ZyInfoMapper, ZyInfo> implements IZyInfoService {

    @Autowired
    private IKcKechengbiaoService kcKechengbiaoService;
    @Autowired
    private IZyDbtxService zyDbtxService;
    @Autowired
    private IXxhbbksService xxhbbksService;

    @Override
    public IPage<ZyInfo> stuList(Page<ZyInfo> page, QueryWrapper<ZyInfo> queryWrapper) {
        return baseMapper.stuList(page, queryWrapper);
    }

    @Override
    public IPage<ZyInfoSys> sysList(Page<ZyInfoSys> page, QueryWrapper<ZyInfoSys> queryWrapper) {
        return baseMapper.sysList(page, queryWrapper);
    }

    @Override
    public List<ZyInfoSys> exportSysXls(ZyInfoSys zyInfoSys, QueryWrapper<ZyInfoSys> queryWrapper) {
        return baseMapper.exportSysXls(zyInfoSys, queryWrapper);
    }

    @Override
    public ZyInfo getKechengById(String id) {
        return baseMapper.getKechengById(id);
    }

    @Override
    public List<ZyInfo> zyzb(String rwbh, String xqxn, String teano, String zyLeixing) {
        return baseMapper.zyzb(rwbh, xqxn, teano, zyLeixing);
    }

    @Override
    public void updateInfoZyStatus() {
        QueryWrapper<ZyInfo> zyInfoQueryWrapper = new QueryWrapper<>();
        zyInfoQueryWrapper.le("start_time", DateUtils.format(new Date(), "yyyy-MM-dd HH:mm:ss"));
        zyInfoQueryWrapper.eq("zy_status", "0");
        List<ZyInfo> list2 = baseMapper.selectList(zyInfoQueryWrapper);
        if (list2.size() > 0) {


            for (ZyInfo zyInfo : list2) {
                zyInfo.setZyStatus("1");
                baseMapper.updateById(zyInfo);

                try {

                    QueryWrapper<KcKechengbiao> kcKechengbiaoQueryWrapper = new QueryWrapper<>();
                    kcKechengbiaoQueryWrapper.eq("rwbh", zyInfo.getRwbh());
                    kcKechengbiaoQueryWrapper.eq("jgh", zyInfo.getCreateBy());
                    kcKechengbiaoQueryWrapper.eq("xqxn", zyInfo.getXnxq());
                    kcKechengbiaoQueryWrapper.last("limit 1");
                    KcKechengbiao kcKechengbiao = kcKechengbiaoService.getOne(kcKechengbiaoQueryWrapper);

                    QueryWrapper<ZyDbtx> zyDbtxQueryWrapper = new QueryWrapper<>();
                    zyDbtxQueryWrapper.eq("type", zyInfo.getZyLeixing());//发送作业
                    zyDbtxQueryWrapper.eq("rwbh", zyInfo.getRwbh());
                    zyDbtxQueryWrapper.eq("main_id", zyInfo.getId());
                    List<ZyDbtx> dbtxlist = zyDbtxService.list(zyDbtxQueryWrapper);
                    String xharrs[] = new String[dbtxlist.size()];
                    for (int i = 0; i < dbtxlist.size(); i++) {
                        xharrs[i] = dbtxlist.get(i).getCreateBy();
                    }

                    ZyInfo zyInfo2 = baseMapper.getKechengById(zyInfo.getId());
                    QueryWrapper<Xxhbbks> queryWrapper = new QueryWrapper<>();
                    queryWrapper.apply("a.xh = b.xh");
                    queryWrapper.eq("b.KCAPZBBH", zyInfo2.getRwbh());
                    if (xharrs.length > 0) {
                        queryWrapper.notIn("a.xh", xharrs);
                    }
                    List<Xxhbbks> list = xxhbbksService.getXsxkbAllList(queryWrapper);


                    for (Xxhbbks xxhbbks : list) {

                        //作业代办提醒
                        ZyDbtx zyDbtx = new ZyDbtx();
                        zyDbtx.setCreateBy(xxhbbks.getXh());
                        zyDbtx.setMainId(zyInfo.getId());
                        zyDbtx.setRwbh(zyInfo.getRwbh());
                        String hpts = "";
                        if (StringUtils.equals(zyInfo.getXshpkg(), "1")) {
                            hpts = "互评时间：" + org.jeecg.common.util.DateUtils.formatDate(zyInfo.getXshpkssj(), "yyyy-MM-dd HH:mm") + " ~ " + org.jeecg.common.util.DateUtils.formatDate(zyInfo.getXshpjssj(), "yyyy-MM-dd HH:mm");
                        }

                        if (StringUtils.equals(zyInfo.getZyLeixing(), "0")) {
                            zyDbtx.setType("0");//0发布作业 1评分 2测验 3问卷 4讨论
                            zyDbtx.setContent(kcKechengbiao.getSkjs() + "老师主讲的[" + kcKechengbiao.getKcmc() + "]课程于" + org.jeecg.common.util.DateUtils.formatDate(new Date(), "yyyy-MM-dd HH:mm:ss") + "发布了一篇题目为“" + zyInfo.getTitle() + "”的作业，该作业提交时间为：" + org.jeecg.common.util.DateUtils.formatDate(zyInfo.getStartTime(), "yyyy-MM-dd HH:mm") + " ~ " + org.jeecg.common.util.DateUtils.formatDate(zyInfo.getEndTime(), "yyyy-MM-dd HH:mm") + "，请按时完成！  " + hpts);
                        } else if (StringUtils.equals(zyInfo.getZyLeixing(), "1")) {
                            zyDbtx.setType("10");//0发布作业 1评分 2测验 3问卷 4讨论
                            zyDbtx.setContent(kcKechengbiao.getSkjs() + "老师主讲的[" + kcKechengbiao.getKcmc() + "]课程于" + org.jeecg.common.util.DateUtils.formatDate(new Date(), "yyyy-MM-dd HH:mm:ss") + "发布了一篇题目为“" + zyInfo.getTitle() + "”的期末考试，该期末考试提交时间为：" + org.jeecg.common.util.DateUtils.formatDate(zyInfo.getStartTime(), "yyyy-MM-dd HH:mm") + " ~ " + org.jeecg.common.util.DateUtils.formatDate(zyInfo.getEndTime(), "yyyy-MM-dd HH:mm") + "，请按时完成！  " + hpts);
                        }
                        zyDbtx.setFlag("0");
                        zyDbtx.setFbr(kcKechengbiao.getSkjs());
                        zyDbtxService.save(zyDbtx);

                        try {
                            KcWechatSendLog kcWechatSendLog = new KcWechatSendLog();
                            kcWechatSendLog.setOpenid(xxhbbks.getXh());
                            kcWechatSendLog.setYtkcs(zyDbtx.getContent());
                            sendWxmessage(kcWechatSendLog);
                        } catch (Exception e) {
                            e.printStackTrace();
                        }
                    }

                } catch (Exception e) {
                    e.printStackTrace();
                }

            }
        }

    }

    @Override
    public IPage<ZyInfoSys> sysStaticList(Page<ZyInfoSys> page, ZyInfoSys zyInfoSys) {
        return baseMapper.sysStaticList(page, zyInfoSys);
    }

    @Override
    public IPage<ZyInfo> listOther(Page<ZyInfo> page, ZyInfo zyInfo) {
        return baseMapper.listOther(page, zyInfo);
    }

    @Override
    public Map<String, Object> sysStaticNo(ZyInfoSys zyInfoSys) {
        Map<String, Object> map = new HashMap<>();

        String xn_zy_syzcs = "0";
        String xn_zy_hpzcs = "0";
        String xn_zy_ywczcs = "0";
        String xn_cy_syzcs = "0";
        String xn_cy_ywczcs = "0";
        String jr_zy_syzcs = "0";
        String jr_zy_hpzcs = "0";
        String jr_zy_ywczcs = "0";
        String jr_cy_syzcs = "0";
        String jr_cy_ywczcs = "0";
        String xn_zy_cccs = "0"; //查重次数
        String xn_kc_zyzxsrc = "0";//使用课程作业总学生人次
        String xn_kc_zyhp = "0";//使用课程作业互评总学生人次
        String xn_kc_zycc = "0";//使用课程作业查重总学生人次
        String xn_kc_zywczxsrc = "0";//完成课程作业总学生人次
        String xn_kc_ktcy = "0";//使用课堂测验总学生人次
        String xn_kc_wccy = "0";//完成课堂测验总学生人次

        List<ZyInfoSys> list = baseMapper.getZyStaticNo(zyInfoSys);
        for (ZyInfoSys par : list) {
            if (StringUtils.equals("1", par.getType())) {
                xn_zy_syzcs = par.getCount();
            } else if (StringUtils.equals("2", par.getType())) {
                xn_zy_hpzcs = par.getCount();
            } else if (StringUtils.equals("3", par.getType())) {
                xn_zy_ywczcs = par.getCount();
            } else if (StringUtils.equals("4", par.getType())) {
                jr_zy_syzcs = par.getCount();
            } else if (StringUtils.equals("5", par.getType())) {
                jr_zy_hpzcs = par.getCount();
            } else if (StringUtils.equals("6", par.getType())) {
                jr_zy_ywczcs = par.getCount();
            } else if (StringUtils.equals("7", par.getType())) {
                xn_cy_syzcs = par.getCount();
            } else if (StringUtils.equals("8", par.getType())) {
                xn_cy_ywczcs = par.getCount();
            } else if (StringUtils.equals("9", par.getType())) {
                jr_cy_syzcs = par.getCount();
            } else if (StringUtils.equals("10", par.getType())) {
                jr_cy_ywczcs = par.getCount();
            } else if (StringUtils.equals("11", par.getType())) {
                xn_zy_cccs = par.getCount();
            } else if (StringUtils.equals("12", par.getType())) {
                xn_kc_zyzxsrc = par.getCount();
            } else if (StringUtils.equals("13", par.getType())) {
                xn_kc_zyhp = par.getCount();
            } else if (StringUtils.equals("14", par.getType())) {
                xn_kc_zycc = par.getCount();
            } else if (StringUtils.equals("15", par.getType())) {
                xn_kc_zywczxsrc = par.getCount();
            } else if (StringUtils.equals("16", par.getType())) {
                xn_kc_ktcy = par.getCount();
            } else if (StringUtils.equals("17", par.getType())) {
                xn_kc_wccy = par.getCount();
            }
        }

        //本学年作业使用排行TOP10
        List<ZyInfoSys> list1 = baseMapper.getZyTopList(zyInfoSys);
        //本学年测验使用排行TOP10
        List<ZyInfoSys> list2 = baseMapper.getCyTopList(zyInfoSys);
        //本学年课程使用排行TOP10
        List<ZyInfoSys> list3 = baseMapper.getKcTopList(zyInfoSys);
        //本学年教师使用排行TOP10
        List<ZyInfoSys> list4 = baseMapper.getJsTopList(zyInfoSys);
        list.add(zyInfoSys);

        //本学年各个学院作业数
        List<ZyInfoSys> list5 = baseMapper.getXyZyList(zyInfoSys);
        //本学年各个学院测验数
        List<ZyInfoSys> list6 = baseMapper.getXYCyList(zyInfoSys);

        map.put("xn_zy_syzcs", xn_zy_syzcs);//本学年作业使用总次数：
        map.put("xn_zy_hpzcs", xn_zy_hpzcs);//本学年作业互评总次数：
        map.put("xn_zy_ywczcs", xn_zy_ywczcs);//本学年作业已完成总次数：
        map.put("xn_zy_cccs", xn_zy_cccs);//本学年查重次数：
        map.put("xn_cy_syzcs", xn_cy_syzcs);//本学年测验使用总次数：
        map.put("xn_cy_ywczcs", xn_cy_ywczcs);//本学年测验已完成总次数：
        map.put("jr_zy_syzcs", jr_zy_syzcs);//今日作业使用总次数：
        map.put("jr_zy_hpzcs", jr_zy_hpzcs);//今日作业互评总次数：
        map.put("jr_zy_ywczcs", jr_zy_ywczcs);//今日作业已完成总次数：
        map.put("jr_cy_syzcs", jr_cy_syzcs);//今日测验使用总次数：
        map.put("jr_cy_ywczcs", jr_cy_ywczcs);//今日测验已完成总次数：
        map.put("xn_kc_zyzxsrc", xn_kc_zyzxsrc);//使用课程作业总学生人次
        map.put("xn_kc_zyhp", xn_kc_zyhp);//使用课程作业互评总学生人次
        map.put("xn_kc_zycc", xn_kc_zycc);//使用课程作业查重总学生人次
        map.put("xn_kc_zywczxsrc", xn_kc_zywczxsrc);//完成课程作业总学生人次
        map.put("xn_kc_ktcy", xn_kc_ktcy);//使用课堂测验总学生人次
        map.put("xn_kc_wccy", xn_kc_wccy);//完成课堂测验总学生人次
        map.put("xntop10", list1);//本学年作业使用排行TOP10
        map.put("jrtop10", list2);//本学年测验使用排行TOP10
        map.put("kctop10", list3);//本学年课程使用排行TOP10
        map.put("jstop10", list4);//本学年教师使用排行TOP10
        map.put("xnxyzycs", list5);//本学年各个学院作业数
        map.put("xnxycycs", list6);//本学年各个学院测验数
        return map;
    }

    @Override
    public List<ZyInfoSys> getPHData(ZyInfoSys zyInfoSys, String tag) {
        List<ZyInfoSys> list = Lists.newArrayList();
        if ("xntop10".equals(tag)) {
            list = baseMapper.getZyList(zyInfoSys);
        }
        if ("jrtop10".equals(tag)) {
            list = baseMapper.getCyList(zyInfoSys);
        }
        if ("kctop10".equals(tag)) {
            list = baseMapper.getXnKcList(zyInfoSys);
        }
        if ("jstop10".equals(tag)) {
            list = baseMapper.getXnJsList(zyInfoSys);
        }
        return list;
    }

    @Override
    public IPage<ZyInfoSys> sysStaticZyList(Page<ZyInfoSys> page, ZyInfoSys zyInfoSys) {
        return baseMapper.sysStaticZyList(page, zyInfoSys);
    }

    @Override
    public IPage<CyInfoSys> sysStaticCyList(Page<CyInfoSys> page, CyInfoSys cyInfoSys) {
        return baseMapper.sysStaticCyList(page, cyInfoSys);
    }

    @Override
    public List<CyInfoSys> getStaticCyExportUrl(CyInfoSys cyInfoSys) {
        return baseMapper.getStaticCyExportUrl(cyInfoSys);
    }

    @Override
    public IPage<ZyInfo> listKhcl(Page<ZyInfo> page, QueryWrapper<ZyInfo> queryWrapper) {
        return baseMapper.listKhcl(page, queryWrapper);
    }

    @Override
    public List<ZyXzInfo> getxzxx(ZyInfo zyInfo) {
        return baseMapper.getxzxx(zyInfo);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public int saveData(String zyinfoId, Integer rs, List<ZyXzInfo> list) {
        LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();

        //先清除小组信息 然后重新插入
        baseMapper.deleteXzxx(zyinfoId);
        baseMapper.deleteXzryxx(zyinfoId);

        if (!list.isEmpty()) {
            list.stream().forEach(xz -> {
                xz.setId(IdUtil.simpleUUID());
                xz.setCreateBy(sysUser.getUsername());
                xz.setCreateTime(new Date());
            });
            this.baseMapper.insertBatchzyxz(list);

            List<ZyXzryInfo> childTableList = list.stream()
                    .flatMap(zyXzInfo -> zyXzInfo.getStudents().stream()
                            .peek(student -> {
                                student.setId(IdUtil.simpleUUID());
                                student.setZyxzinfoId(zyXzInfo.getId());
                            }))
                    .collect(Collectors.toList());

            if (!childTableList.isEmpty()) {
                baseMapper.insertBatchzyxzry(childTableList);
            }
            ZyInfo zyInfo = new ZyInfo().setId(zyinfoId).setSfpzgxzxx("Y").setXzrs(rs);
            baseMapper.updateById(zyInfo);
        } else {
            ZyInfo zyInfo = new ZyInfo().setId(zyinfoId).setSfpzgxzxx("N").setXzrs(rs);
            baseMapper.updateById(zyInfo);
        }
        return list.size();
    }

    @Override
    public int removeHPData(String id) {
        return baseMapper.removeHPData(id);
    }

    @Override
    public int removeCCData(String id) {
        return baseMapper.removeCCData(id);
    }

    // appId
    private static final String appId = "wx031697a8ca09a5ce";//东师

    private static final String agentid = "1000065";//
    // appIdSecret
    private static final String appIdSecret = "6Qhnge3xfzAQMDX2TcjEyE0vUGP96hP9OTYUsYBze2Y";//东师

    //微信通知点击后跳转的页面
    private static final String domainTo = "https://smartedu.nenu.edu.cn";

    public void sendWxmessage(KcWechatSendLog kcWechatSendLog) {
        String openId = kcWechatSendLog.getOpenid();//曹老师账号
        System.out.println("openId:" + openId + "");
        if (org.apache.commons.lang3.StringUtils.isNotEmpty(openId)) {
            try {
                String urlToken = "https://qyapi.weixin.qq.com/cgi-bin/gettoken?corpid=" + appId + "&corpsecret=" + appIdSecret;
                System.out.println("urlToken：  " + urlToken);
                String res = HttpUtil.get(urlToken);
                JSONObject jsonObjectToken = JSONObject.parseObject(res);
                System.out.println("jsonObjectToken：{}" + jsonObjectToken);
                String accessToken = jsonObjectToken.getString("access_token");
                System.out.println("accessToken：{}" + accessToken);

                // 微信的基础accessToken
                String url = "https://qyapi.weixin.qq.com/cgi-bin/message/send?access_token=" + accessToken;
                Map<String, Object> sendMag = new HashMap<>();

//				 1、xx老师，你好，您本学期（2023秋）听课要求为：5次，当前实际听课次数：3次，请尽快完成本学期的听课任务。
                String html = kcWechatSendLog.getYtkcs();
                html = html + "\n<a href=\"" + domainTo + "\">查看</a>";
                sendMag.put("content", html);//授课老师推送内容
                RestTemplate restTemplate = new RestTemplate();
                //拼接base参数
                Map<String, Object> sendBody = new HashMap<>();
                sendBody.put("touser", openId);                // openId
                sendBody.put("msgtype", "text");               // 消息类型，此时固定为：text
                sendBody.put("agentid", agentid);              // 企业id
                sendBody.put("text", sendMag);                //发送内容
                ResponseEntity<String> forEntity = restTemplate.postForEntity(url, sendBody, String.class);
                JSONObject jsonObject2 = JSONObject.parseObject(forEntity.getBody());
                System.out.println("jsonObject2 : " + jsonObject2);
                String messageCode = jsonObject2.getString("errcode");
                String msgId = jsonObject2.getString("msgid");
                System.out.println("messageCode : " + messageCode + ", msgId: " + msgId);
            } catch (Exception e) {
                e.printStackTrace();
            }
        } else {
        }
    }
}
