package org.jeecg.modules.kc.zyInfoScjl.entity;

import java.io.Serializable;
import java.io.UnsupportedEncodingException;
import java.util.Date;
import java.math.BigDecimal;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.TableLogic;
import lombok.Data;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;
import org.jeecgframework.poi.excel.annotation.Excel;
import org.jeecg.common.aspect.annotation.Dict;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * @Description: 作业上传记录
 * @Author: jeecg-boot
 * @Date:   2024-09-03
 * @Version: V1.0
 */
@Data
@TableName("zy_info_scjl")
@Accessors(chain = true)
@EqualsAndHashCode(callSuper = false)
@ApiModel(value="zy_info_scjl对象", description="作业上传记录")
public class ZyInfoScjl implements Serializable {
    private static final long serialVersionUID = 1L;

	/**id*/
	@TableId(type = IdType.ASSIGN_ID)
    @ApiModelProperty(value = "id")
    private java.lang.String id;
	/**createTime*/
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd")
    @DateTimeFormat(pattern="yyyy-MM-dd")
    @ApiModelProperty(value = "createTime")
    private java.util.Date createTime;
	/**createBy*/
    @ApiModelProperty(value = "createBy")
    private java.lang.String createBy;
	/**updateTime*/
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd")
    @DateTimeFormat(pattern="yyyy-MM-dd")
    @ApiModelProperty(value = "updateTime")
    private java.util.Date updateTime;
	/**updateBy*/
    @ApiModelProperty(value = "updateBy")
    private java.lang.String updateBy;
	/**作业id*/
	@Excel(name = "作业id", width = 15)
    @ApiModelProperty(value = "作业id")
    private java.lang.String zyId;
	/**作业名称*/
	@Excel(name = "作业名称", width = 15)
    @ApiModelProperty(value = "作业名称")
    private java.lang.String zyName;
	/**作业类型*/
	@Excel(name = "作业类型", width = 15)
    @ApiModelProperty(value = "作业类型")
    private java.lang.String zyLeixing;
	/**占比*/
	@Excel(name = "占比", width = 15)
    @ApiModelProperty(value = "占比")
    private java.lang.String zyZb;
	/**开课单位*/
	@Excel(name = "开课单位", width = 15)
    @ApiModelProperty(value = "开课单位")
    private java.lang.String kkdw;
	/**开课单位id*/
	@Excel(name = "开课单位id", width = 15)
    @ApiModelProperty(value = "开课单位id")
    private java.lang.String kkdwid;
	/**课程名称*/
	@Excel(name = "课程名称", width = 15)
    @ApiModelProperty(value = "课程名称")
    private java.lang.String kcmc;
	/**教工号*/
	@Excel(name = "教工号", width = 15)
    @ApiModelProperty(value = "教工号")
    private java.lang.String jgh;
	/**授课教师*/
	@Excel(name = "授课教师", width = 15)
    @ApiModelProperty(value = "授课教师")
    private java.lang.String skjs;
	/**授课地点*/
	@Excel(name = "授课地点", width = 15)
    @ApiModelProperty(value = "授课地点")
    private java.lang.String skdd;
	/**课程性质*/
	@Excel(name = "课程性质", width = 15)
    @ApiModelProperty(value = "课程性质")
    private java.lang.String kcxz;
	/**学年学期*/
	@Excel(name = "学年学期", width = 15)
    @ApiModelProperty(value = "学年学期")
    private java.lang.String xnxq;
	/**文件*/
	@Excel(name = "文件", width = 15)
    @ApiModelProperty(value = "文件")
    private java.lang.String filePath;
	/**学工号*/
	@Excel(name = "学工号", width = 15)
    @ApiModelProperty(value = "学工号")
    private java.lang.String studentNo;
	/**学生姓名*/
	@Excel(name = "学生姓名", width = 15)
    @ApiModelProperty(value = "学生姓名")
    private java.lang.String studentName;
}
