package org.jeecg.modules.kc.zyInfoStudent.controller;

import cn.hutool.core.io.FileUtil;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.StringUtils;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.google.common.collect.Maps;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.apache.shiro.SecurityUtils;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.jeecg.common.system.base.controller.JeecgController;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.system.vo.LoginUser;
import org.jeecg.common.util.*;
import org.jeecg.modules.kc.config.entity.KcExportConfigTpkwcqkjzglx;
import org.jeecg.modules.kc.config.service.IKcExportConfigTpkwcqkjzglxService;
import org.jeecg.modules.kc.kcSysConfig.entity.KcSysConfig;
import org.jeecg.modules.kc.kcSysConfig.service.IKcSysConfigService;
import org.jeecg.modules.kc.ktgl.entity.KcKechengbiao;
import org.jeecg.modules.kc.ktgl.service.IKcKechengbiaoService;
import org.jeecg.modules.kc.zyCcjg.entity.ZyCcjg;
import org.jeecg.modules.kc.zyCcjg.service.IZyCcjgService;
import org.jeecg.modules.kc.zyDbtx.entity.ZyDbtx;
import org.jeecg.modules.kc.zyDbtx.service.IZyDbtxService;
import org.jeecg.modules.kc.zyInfo.entity.ZyInfo;
import org.jeecg.modules.kc.zyInfo.entity.ZyXzryInfo;
import org.jeecg.modules.kc.zyInfo.service.IZyInfoService;
import org.jeecg.modules.kc.zyInfoScjl.entity.ZyInfoScjl;
import org.jeecg.modules.kc.zyInfoScjl.service.IZyInfoScjlService;
import org.jeecg.modules.kc.zyInfoStudent.entity.ZyInfoStudent;
import org.jeecg.modules.kc.zyInfoStudent.entity.ZyInfoStudentSys;
import org.jeecg.modules.kc.zyInfoStudent.service.IZyInfoStudentService;
import org.jeecg.modules.kc.zyInfoStudentHp.entity.ZyInfoStudentHp;
import org.jeecg.modules.kc.zyInfoStudentHp.service.IZyInfoStudentHpService;
import org.jeecg.modules.kc.zyInfoStudentPcz.service.IZyInfoStudentPczService;
import org.jeecg.modules.system.entity.SysUser;
import org.jeecg.modules.system.service.ISysUserService;
import org.jeecg.modules.system.service.impl.SysBaseApiImpl;
import org.jeecg.modules.tools.DictUtils;
import org.jeecg.modules.tools.Global;
import org.jeecg.modules.tools.office.pdf.PDFUtil;
import org.jeecg.modules.zyk.entity.ZykInfo;
import org.jeecg.modules.zyk.service.IZykService;
import org.jeecg.modules.zyk.utils.WjlxEnum;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.File;
import java.util.*;

/**
 * @Description: 学生提交作业
 * @Author: jeecg-boot
 * @Date:   2024-05-06
 * @Version: V1.0
 */
@Api(tags="学生提交作业")
@RestController
@RequestMapping("/zyInfoStudent/zyInfoStudent")
@Slf4j
public class ZyInfoStudentController extends JeecgController<ZyInfoStudent, IZyInfoStudentService> {
	@Autowired
	private IZyInfoStudentService zyInfoStudentService;

	 @Autowired
	 private IZyInfoService zyInfoService;

	 @Autowired
	 private IZyCcjgService zyCcjgService;

	 @Autowired
	 private IZyDbtxService zyDbtxService;

	 @Autowired
	 private IZykService zykService;

	 @Value("${jeecg.path.upload}")
	 private String upLoadPath;


	 @Value(value="${jeecg.uploadType}")
	 private String uploadType;

	 @Autowired
	 private SysBaseApiImpl sysBaseApi;
	 @Autowired
	 private IKcExportConfigTpkwcqkjzglxService kcExportConfigTpkwcqkjzglxService;
	 @Autowired
	 private IKcSysConfigService kcSysConfigService;
	 @Autowired
	 private IZyInfoStudentHpService zyInfoStudentHpService;
     @Autowired
     private DictUtils dictUtils;

	 @Autowired
	 private IZyInfoStudentPczService zyInfoStudentPczService;
	 @Autowired
	 private IKcKechengbiaoService kcKechengbiaoService;
	 @Autowired
	 private ISysUserService sysUserService;
	 @Autowired
	 private IZyInfoScjlService zyInfoScjlService;

	 @Autowired
	 SftpConfig sftpConfig;
	 /**
	 * 分页列表查询
	 *
	 * @param zyInfoStudent
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "学生提交作业-分页列表查询")
	@ApiOperation(value="学生提交作业-分页列表查询", notes="学生提交作业-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<ZyInfoStudent>> queryPageList(ZyInfoStudent zyInfoStudent,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {

//		//查询作业查重结果
//		zyCcjgService.getCcjg();


		QueryWrapper<ZyInfoStudent> queryWrapper = QueryGenerator.initQueryWrapper("a",zyInfoStudent, req.getParameterMap());
		Page<ZyInfoStudent> page = new Page<ZyInfoStudent>(pageNo, pageSize);

		if(StringUtils.isNotEmpty(zyInfoStudent.getQueryType())){
			if(StringUtils.equals("1",zyInfoStudent.getQueryType())){//未提交
				queryWrapper.isNull("a.file_path");
			}else if(StringUtils.equals("2",zyInfoStudent.getQueryType())){//已提交
				queryWrapper.isNotNull("a.file_path");
			}else if(StringUtils.equals("3",zyInfoStudent.getQueryType())){//未评阅
				queryWrapper.isNull("a.score");
			}else if(StringUtils.equals("4",zyInfoStudent.getQueryType())){//已评阅
				queryWrapper.isNotNull("a.score");
			}else if(StringUtils.equals("5",zyInfoStudent.getQueryType())){//已评阅
				queryWrapper.isNull("a.score");
				queryWrapper.isNotNull("a.file_path");
			}
		}
		IPage<ZyInfoStudent> pageList = zyInfoStudentService.page(page, queryWrapper);
		for(ZyInfoStudent ZyInfoStudentPar:pageList.getRecords()){
			List<ZyInfoStudent> list = zyInfoStudentService.getCcjg(ZyInfoStudentPar);
			for(ZyInfoStudent par:list){
				if(StringUtils.equals(par.getCcType(),"0")){//外网
					ZyInfoStudentPar.setWwpaperdownurl(par.getPaperdownurl());
					ZyInfoStudentPar.setWwpaperviewurl(par.getPaperviewurl());
					ZyInfoStudentPar.setWwfilestateid(par.getFilestateid());
					ZyInfoStudentPar.setWwmessage(par.getMessage());
				}else if(StringUtils.equals(par.getCcType(),"1")){//作业
					ZyInfoStudentPar.setZypaperdownurl(par.getPaperdownurl());
					ZyInfoStudentPar.setZypaperviewurl(par.getPaperviewurl());
					ZyInfoStudentPar.setZyfilestateid(par.getFilestateid());
					ZyInfoStudentPar.setZymessage(par.getMessage());
				}else if(StringUtils.equals(par.getCcType(),"2")){//aigc
					ZyInfoStudentPar.setAigcpaperdownurl(par.getPaperdownurl());
					ZyInfoStudentPar.setAigcpaperviewurl(par.getPaperviewurl());
					ZyInfoStudentPar.setAigcfilestateid(par.getFilestateid());
					ZyInfoStudentPar.setAigcmessage(par.getMessage());
				}else if(StringUtils.equals(par.getCcType(),"3")){//学校
					ZyInfoStudentPar.setXxpaperdownurl(par.getPaperdownurl());
					ZyInfoStudentPar.setXxpaperviewurl(par.getPaperviewurl());
					ZyInfoStudentPar.setXxfilestateid(par.getFilestateid());
					ZyInfoStudentPar.setXxmessage(par.getMessage());
				}
			}
		}
		return Result.OK(pageList);
	}



	 /**
	  * 分页列表查询
	  *
	  * @param zyInfoStudent
	  * @param pageNo
	  * @param pageSize
	  * @param req
	  * @return
	  */
	 //@AutoLog(value = "学生提交作业-分页列表查询")
	 @ApiOperation(value="学生提交作业-分页列表查询", notes="学生提交作业-分页列表查询")
	 @GetMapping(value = "/getList2")
	 public Result<IPage<ZyInfoStudent>> getList2(ZyInfoStudent zyInfoStudent,
													   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
													   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
													   HttpServletRequest req) {

		 QueryWrapper<ZyInfoStudent> queryWrapper = QueryGenerator.initQueryWrapper("a",zyInfoStudent, req.getParameterMap());
		 Page<ZyInfoStudent> page = new Page<ZyInfoStudent>(pageNo, pageSize);

		 if(StringUtils.isNotEmpty(zyInfoStudent.getQueryType())){
			 if(StringUtils.equals("1",zyInfoStudent.getQueryType())){//未提交
				 queryWrapper.isNull("a.file_path");
			 }else if(StringUtils.equals("2",zyInfoStudent.getQueryType())){//已提交
				 queryWrapper.isNotNull("a.file_path");
			 }else if(StringUtils.equals("3",zyInfoStudent.getQueryType())){//未评阅
				 queryWrapper.isNull("a.score");
			 }else if(StringUtils.equals("4",zyInfoStudent.getQueryType())){//已评阅
				 queryWrapper.isNotNull("a.score");
			 }else if(StringUtils.equals("5",zyInfoStudent.getQueryType())){//已评阅
				 queryWrapper.isNull("a.score");
				 queryWrapper.isNotNull("a.file_path");
			 }
		 }
		 queryWrapper.eq(StringUtils.isNotEmpty(zyInfoStudent.getYwid()),"b.id",zyInfoStudent.getYwid());
 		 queryWrapper.eq(StringUtils.isNotEmpty(zyInfoStudent.getRwbh()),"c.KCAPZBBH",zyInfoStudent.getRwbh());
		 IPage<ZyInfoStudent> pageList = zyInfoStudentService.getList2(page, queryWrapper);
		 for(ZyInfoStudent ZyInfoStudentPar:pageList.getRecords()){
			 List<ZyInfoStudent> list = zyInfoStudentService.getCcjg(ZyInfoStudentPar);
			 for(ZyInfoStudent par:list){
				 if(StringUtils.equals(par.getCcType(),"0")){//外网
					 ZyInfoStudentPar.setWwpaperdownurl(par.getPaperdownurl());
					 ZyInfoStudentPar.setWwpaperviewurl(par.getPaperviewurl());
					 ZyInfoStudentPar.setWwfilestateid(par.getFilestateid());
					 ZyInfoStudentPar.setWwmessage(par.getMessage());
				 }else if(StringUtils.equals(par.getCcType(),"1")){//作业
					 ZyInfoStudentPar.setZypaperdownurl(par.getPaperdownurl());
					 ZyInfoStudentPar.setZypaperviewurl(par.getPaperviewurl());
					 ZyInfoStudentPar.setZyfilestateid(par.getFilestateid());
					 ZyInfoStudentPar.setZymessage(par.getMessage());
				 }else if(StringUtils.equals(par.getCcType(),"2")){//aigc
					 ZyInfoStudentPar.setAigcpaperdownurl(par.getPaperdownurl());
					 ZyInfoStudentPar.setAigcpaperviewurl(par.getPaperviewurl());
					 ZyInfoStudentPar.setAigcfilestateid(par.getFilestateid());
					 ZyInfoStudentPar.setAigcmessage(par.getMessage());
				 }else if(StringUtils.equals(par.getCcType(),"3")){//学校
					 ZyInfoStudentPar.setXxpaperdownurl(par.getPaperdownurl());
					 ZyInfoStudentPar.setXxpaperviewurl(par.getPaperviewurl());
					 ZyInfoStudentPar.setXxfilestateid(par.getFilestateid());
					 ZyInfoStudentPar.setXxmessage(par.getMessage());
				 }
			 }
		 }
		 return Result.OK(pageList);
	 }

	/**
	 *   添加
	 *
	 * @param zyInfoStudent
	 * @return
	 */
	@AutoLog(value = "学生提交作业-添加")
	@ApiOperation(value="学生提交作业-添加", notes="学生提交作业-添加")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody ZyInfoStudent zyInfoStudent) {
		zyInfoStudentService.save(zyInfoStudent);
		return Result.OK("添加成功！");
	}

	/**
	 *  编辑
	 *
	 * @param zyInfoStudent
	 * @return
	 */
	@AutoLog(value = "学生提交作业-编辑")
	@ApiOperation(value="学生提交作业-编辑", notes="学生提交作业-编辑")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody ZyInfoStudent zyInfoStudent) {
		zyInfoStudentService.updateById(zyInfoStudent);
		return Result.OK("编辑成功!");
	}

	 @AutoLog(value = "发布评分状态")
	 @ApiOperation(value="发布评分状态", notes="发布评分状态")
	 @RequestMapping(value = "/editFabu", method = {RequestMethod.PUT,RequestMethod.POST})
	 public Result<ZyInfoStudent> editFabu(@RequestBody ZyInfoStudent zyInfoStudent) {
		 String score = zyInfoStudent.getScore();
		 zyInfoStudentService.editFabu(zyInfoStudent);

		 Integer hpcjjl = Integer.parseInt(dictUtils.translateDictValue("hpcjsz","1"));
		 //计算评分人的互评次数，计算互评人的绩效分数
//		 QueryWrapper<ZyInfoStudent> zyInfoStudentQueryWrapper = new QueryWrapper<>();
//		 zyInfoStudentQueryWrapper.eq("a.main_id",zyInfoStudent.getMainId());
//		 zyInfoStudentQueryWrapper.eq("a.create_by",zyInfoStudent.getCreateBy());
//		 List<ZyInfoStudent> listPfr = zyInfoStudentService.list(zyInfoStudentQueryWrapper);
//		 if(listPfr.size()>0){
			 ZyInfoStudent hprInfo = zyInfoStudentService.getById(zyInfoStudent.getId());
			 //计算绩效分数
			 QueryWrapper<ZyInfoStudentHp> zyInfoStudentHpQueryWrapper3 = new QueryWrapper<>();
			 zyInfoStudentHpQueryWrapper3.eq("main_id",hprInfo.getMainId());
			 zyInfoStudentHpQueryWrapper3.eq("stu_id",hprInfo.getCreateBy());
			 List<ZyInfoStudentHp> list3 = zyInfoStudentHpService.list(zyInfoStudentHpQueryWrapper3);
			 if(list3.size()>4){
				 if(StringUtils.isNotEmpty(hprInfo.getScore())){
					 double hpcj = Double.parseDouble(hprInfo.getScore());//获取教师的互评成绩
					 double jxcj = hpcj * hpcjjl / 100;
					 hprInfo.setJxfs(String.format("%.1f",jxcj));
				 }
			 }
			 //计算最终得分
			 if(StringUtils.isNotEmpty(hprInfo.getScore())){
				 double hpcj = Double.parseDouble(hprInfo.getScore());//获取教师的互评成绩
				 double jxcj = 0.0;//获取教师的互评成绩
				 if(StringUtils.isNotEmpty(hprInfo.getJxfs())){
					 jxcj = Double.parseDouble(hprInfo.getJxfs());//获取教师的互评成绩
				 }
				 double jxcj2 = 0.0;//获取教师的互评成绩
				 if(StringUtils.isNotEmpty(hprInfo.getJxfs2())){
					 jxcj2 = Double.parseDouble(hprInfo.getJxfs2());//获取教师的互评成绩
				 }
				 double zzcj = hpcj + jxcj + jxcj2;
				 if(zzcj>100){
					 zzcj = 100;
				 }
				 hprInfo.setZzdf(String.format("%.1f",zzcj));
			 }
			 zyInfoStudentService.updateById(hprInfo);
//		 }



		 //计算二次绩效奖励
		 ZyInfo jspc = new ZyInfo();
		 jspc.setId(zyInfoStudent.getMainId());
		 zyInfoStudentPczService.calculationPcz(jspc);


		 ZyInfoStudent zyInfoStudentPar = zyInfoStudentService.getById(zyInfoStudent.getId());
		 if(StringUtils.isNotEmpty(score)){
			 try {
				 ZyInfo zyInfo = zyInfoService.getKechengById(zyInfoStudentPar.getMainId());
				 //作业代办提醒
				 ZyDbtx zyDbtx = new ZyDbtx();
				 zyDbtx.setCreateBy(zyInfoStudentPar.getCreateBy());
				 zyDbtx.setType("1");//0发布作业 1评分 2测验 3问卷 4讨论
				 zyDbtx.setMainId(zyInfoStudentPar.getId());
				 zyDbtx.setRwbh(zyInfo.getRwbh());
				 zyDbtx.setContent(" ["+zyInfo.getKcmc()+"] "+zyInfo.getSkjs()+" 对作业进行了评分，请及时查看！");
				 zyDbtx.setFlag("0");
				 LoginUser user = (LoginUser) SecurityUtils.getSubject().getPrincipal();
				 zyDbtx.setFbr(user.getUsername());
				 zyDbtxService.save(zyDbtx);
			 } catch (Exception e) {
				 e.printStackTrace();
			 }
		 }

		 QueryWrapper<ZyInfoStudent> zyInfoStudentQueryWrappertt = new QueryWrapper<>();
		 zyInfoStudentQueryWrappertt.eq("main_id",zyInfoStudentPar.getMainId());
		 List<ZyInfoStudent> list = zyInfoStudentService.list(zyInfoStudentQueryWrappertt);
		 int a = list.size();

		 QueryWrapper<ZyInfoStudent> zyInfoStudentQueryWrapper2 = new QueryWrapper<>();
		 zyInfoStudentQueryWrapper2.eq("main_id",zyInfoStudentPar.getMainId());
		 zyInfoStudentQueryWrapper2.eq("score_fabu","1");
		 List<ZyInfoStudent> list2 = zyInfoStudentService.list(zyInfoStudentQueryWrapper2);
		 int b = list2.size();
		 if(a==b){
			 UpdateWrapper<ZyInfo> zyInfo = new UpdateWrapper<>();
			 zyInfo.eq("id",zyInfoStudentPar.getMainId());
			 zyInfo.set("zy_status","2");
			 zyInfoService.update(zyInfo);
		 }

		 return Result.OK(zyInfoStudent);
	 }
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "学生提交作业-通过id删除")
	@ApiOperation(value="学生提交作业-通过id删除", notes="学生提交作业-通过id删除")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		zyInfoStudentService.removeById(id);
		return Result.OK("删除成功!");
	}

	/**
	 *  批量发布
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "学生提交作业-批量发布")
	@ApiOperation(value="学生提交作业-批量发布", notes="学生提交作业-批量发布")
	@PostMapping(value = "/fabuBatch")
	public Result<String> fabuBatch(@RequestParam(name="ids",required=true) String ids) {
		this.zyInfoStudentService.fabuBatch(Arrays.asList(ids.split(",")));

		try {
			String idsList[] = ids.split(",");
			if(idsList.length>0){
				ZyInfoStudent zyInfoStudentPar = zyInfoStudentService.getById(idsList[0]);
				QueryWrapper<ZyInfoStudent> zyInfoStudentQueryWrapper = new QueryWrapper<>();
				zyInfoStudentQueryWrapper.eq("main_id",zyInfoStudentPar.getMainId());
				List<ZyInfoStudent> list = zyInfoStudentService.list(zyInfoStudentQueryWrapper);
				int a = list.size();

				QueryWrapper<ZyInfoStudent> zyInfoStudentQueryWrapper2 = new QueryWrapper<>();
				zyInfoStudentQueryWrapper2.eq("main_id",zyInfoStudentPar.getMainId());
				zyInfoStudentQueryWrapper2.eq("score_fabu","1");
				List<ZyInfoStudent> list2 = zyInfoStudentService.list(zyInfoStudentQueryWrapper2);
				int b = list2.size();
				if(a==b){
					UpdateWrapper<ZyInfo> zyInfo = new UpdateWrapper<>();
					zyInfo.eq("id",zyInfoStudentPar.getMainId());
					zyInfo.set("zy_status","2");
					zyInfoService.update(zyInfo);
				}
			}
		}catch (Exception e) {
			e.printStackTrace();
		}

		return Result.OK("批量发布成功!");
	}

	 @AutoLog(value = "学生提交作业-批量发布")
	 @ApiOperation(value="学生提交作业-批量发布", notes="学生提交作业-批量发布")
	 @PostMapping(value = "/fabuBatch2")
	 public Result<String> fabuBatch2(@RequestBody ZyInfoStudent zyInfoStudent) {


		 ZyInfo zyInfo = zyInfoService.getById(zyInfoStudent.getId());
		 if(zyInfo == null){
			 return Result.error("未找到对应数据");
		 }

		 QueryWrapper<ZyInfoStudent> zyInfoStudentQueryWrapper = new QueryWrapper<>();
//		 zyInfoStudentQueryWrapper.isNull("a.score");
		 zyInfoStudentQueryWrapper.eq("b.id",zyInfo.getId());
		 zyInfoStudentQueryWrapper.eq("c.KCAPZBBH",zyInfo.getRwbh());
		 Page<ZyInfoStudent> page = new Page<ZyInfoStudent>(1, -1);
		 IPage<ZyInfoStudent> list = zyInfoStudentService.getList2(page,zyInfoStudentQueryWrapper);
		for (ZyInfoStudent par:list.getRecords()){
			if(StringUtils.equals(par.getId(),par.getCreateBy())){//说明是伪数据，需要新增
				par.setId(null);
				par.setCreateTime(new Date());
				par.setMainId(zyInfo.getId());
				par.setScore("0");
				par.setZzdf("0");
				par.setScoreFabu("1");
				zyInfoStudentService.save(par);
			}else{//不相等则是帧数据，直接修改
				 UpdateWrapper<ZyInfoStudent> zyInfoStudentUp = new UpdateWrapper<>();
				 zyInfoStudentUp.eq("id",par.getId());

				String a = StringUtils.isNotEmpty(par.getScore())?par.getScore():"0";
				String b = StringUtils.isNotEmpty(par.getJxfs())?par.getJxfs():"0";
				String e = StringUtils.isNotEmpty(par.getJxfs2())?par.getJxfs2():"0";
				Double d = Double.parseDouble(a)+Double.parseDouble(b)+Double.parseDouble(e);
				if(d>100){
					d = 100.0;
				}
				String c = String.format("%.1f",d);
				 if(StringUtils.isEmpty(par.getScore())){
					 zyInfoStudentUp.set("score","0");
				 }
				zyInfoStudentUp.set("zzdf",c);
				zyInfoStudentUp.set("score_fabu","1");
				 zyInfoStudentService.update(zyInfoStudentUp);
			}
		}
		 zyInfo.setZyStatus("2");
		 zyInfoService.updateById(zyInfo);

//		 QueryWrapper<ZyInfoStudent> zyInfoStudentQueryWrapper = new QueryWrapper<>();
//		 zyInfoStudentQueryWrapper.eq("a.main_id",zyInfoStudent.getId());
//		 List<ZyInfoStudent> list = zyInfoStudentService.list(zyInfoStudentQueryWrapper);
//		 for(ZyInfoStudent par:list){
//			 UpdateWrapper<ZyInfoStudent> zyInfoStudentUp = new UpdateWrapper<>();
//			 zyInfoStudentUp.eq("id",par.getId());
//			 if(StringUtils.isEmpty(par.getScore())){
//				 zyInfoStudentUp.set("score","0");
//			 }
//			 zyInfoStudentUp.set("score_fabu","1");
//			 zyInfoStudentService.update(zyInfoStudentUp);
//		 }
//
//		 int a = list.size();
//
//		 QueryWrapper<ZyInfoStudent> zyInfoStudentQueryWrapper2 = new QueryWrapper<>();
//		 zyInfoStudentQueryWrapper2.eq("main_id",zyInfoStudent.getId());
//		 zyInfoStudentQueryWrapper2.eq("score_fabu","1");
//		 List<ZyInfoStudent> list2 = zyInfoStudentService.list(zyInfoStudentQueryWrapper2);
//		 int b = list2.size();
//		 if(a==b){
//			 UpdateWrapper<ZyInfo> zyInfo = new UpdateWrapper<>();
//			 zyInfo.eq("id",zyInfoStudent.getId());
//			 zyInfo.set("zy_status","2");
//			 zyInfoService.update(zyInfo);
//		 }

		 return Result.OK("发布成功!");
	 }


	 @AutoLog(value = "校内查重批量提交")
	 @ApiOperation(value="校内查重批量提交", notes="校内查重批量提交")
	 @PostMapping(value = "/xnccBatchWeipu")
	 public Result<List<ZyInfoStudent>> xnccBatchWeipu(@RequestBody ZyInfoStudent zyInfoStudent, HttpServletResponse response) {
		 List<ZyInfoStudent> list = zyInfoStudentService.xnccBatchWeipu(zyInfoStudent, response);
		 return Result.OK(list);
	 }

	 @AutoLog(value = "学生提交作业-批量发布")
	 @ApiOperation(value="学生提交作业-批量发布", notes="学生提交作业-批量发布")
	 @PostMapping(value = "/getNoScore")
	 public Result<List<ZyInfoStudent>> getNoScore(@RequestBody ZyInfoStudent zyInfoStudent) {


		ZyInfo zyInfo = zyInfoService.getById(zyInfoStudent.getId());
		if(zyInfo == null){
			return Result.error("未找到对应数据");
		}

		QueryWrapper<ZyInfoStudent> zyInfoStudentQueryWrapper = new QueryWrapper<>();
		zyInfoStudentQueryWrapper.isNull("a.score");
		 zyInfoStudentQueryWrapper.eq("b.id",zyInfo.getId());
		 zyInfoStudentQueryWrapper.eq("c.KCAPZBBH",zyInfo.getRwbh());
		Page<ZyInfoStudent> page = new Page<ZyInfoStudent>(1, -1);
		IPage<ZyInfoStudent> list = zyInfoStudentService.getList2(page,zyInfoStudentQueryWrapper);
		return Result.OK(list.getRecords());
	 }

	 /**
	  *  批量发布
	  *
	  * @param ids
	  * @return
	  */
	 @AutoLog(value = "学生提交作业-批量发布考核材料")
	 @ApiOperation(value="学生提交作业-批量发布考核材料", notes="学生提交作业-批量发布考核材料")
	 @PostMapping(value = "/batchKhcl")
	 public Result<String> batchKhcl(@RequestParam(name="ids",required=true) String ids) {
//		 this.zyInfoStudentService.batchKhcl(Arrays.asList(ids.split(",")));

		 try {
			 String idsList[] = ids.split(",");
			 if(idsList.length>0){
				 ZyInfoStudent zyInfoStudentPar = zyInfoStudentService.getById(idsList[0]);
				 ZyInfo zyInfo = zyInfoService.getById(zyInfoStudentPar.getMainId());
				 QueryWrapper<KcKechengbiao> kcKechengbiaoQueryWrapper = new QueryWrapper<>();
				 kcKechengbiaoQueryWrapper.eq("rwbh",zyInfo.getRwbh());
				 kcKechengbiaoQueryWrapper.eq("jgh",zyInfo.getCreateBy());
				 kcKechengbiaoQueryWrapper.eq("xqxn",zyInfo.getXnxq());
				 kcKechengbiaoQueryWrapper.last("limit 1");
				 KcKechengbiao kcKechengbiao = kcKechengbiaoService.getOne(kcKechengbiaoQueryWrapper);

				 zyInfo.setSfsckhcl("1");
				 zyInfo.setSfsckhclTime(new Date());
				 zyInfoService.updateById(zyInfo);



				 for(int i=0;i< idsList.length;i++){

					 ZyInfoStudent zyInfoStudentPar2 = zyInfoStudentService.getById(idsList[i]);

					 if(StringUtils.isNotEmpty(zyInfoStudentPar2.getFilePath())){
						 //上传文件
						 Map<String,String> uploadMap = SFTPUtil.upload(sftpConfig,upLoadPath+"/"+zyInfoStudentPar2.getFilePath(),zyInfoStudentPar2.getFilePath());
						 zyInfoStudentPar2.setSfsckhcl("1");
						 zyInfoStudentPar2.setFwqPath(uploadMap.get("data"));
						 zyInfoStudentPar2.setKhclTime(new Date());
						 zyInfoStudentService.updateById(zyInfoStudentPar2);

						 ZyInfoScjl zyInfoScjl = new ZyInfoScjl();
						 zyInfoScjl.setZyId(zyInfo.getId());
						 zyInfoScjl.setZyName(zyInfo.getTitle());
						 zyInfoScjl.setZyLeixing(zyInfo.getZyLeixing());
						 zyInfoScjl.setZyZb(zyInfo.getScore());
						 zyInfoScjl.setJgh(kcKechengbiao.getJgh());
						 zyInfoScjl.setSkjs(kcKechengbiao.getSkjs());
						 zyInfoScjl.setSkdd(kcKechengbiao.getSkdd());
						 zyInfoScjl.setKkdw(kcKechengbiao.getKkdw());
						 zyInfoScjl.setKkdwid(kcKechengbiao.getKkdwid());
						 zyInfoScjl.setKcxz(kcKechengbiao.getKcxz());
						 zyInfoScjl.setXnxq(zyInfo.getXnxq());
						 zyInfoScjl.setFilePath(zyInfoStudentPar2.getFwqPath());
						 zyInfoScjl.setStudentNo(zyInfoStudentPar2.getCreateBy());
						 zyInfoScjl.setStudentName(zyInfoStudentPar2.getStudentName());
						 zyInfoScjlService.save(zyInfoScjl);
					 }



				 }
			 }
		 }catch (Exception e) {
			 e.printStackTrace();
		 }

		 return Result.OK("上传成功!");
	 }


	 /**
	  *  批量上传考核材料
	  * @param ids
	  */
	 @AutoLog(value = "批量上传考核材料")
	 @ApiOperation(value="批量上传考核材料", notes="批量上传考核材料")
	 @PostMapping(value = "/batchZyinfoKhcl")
	 public void batchZyinfoKhcl(@RequestParam(name="ids",required=true) String ids) {
		zyInfoStudentService.batchZyinfoKhcl(ids);
	 }


	 @PostMapping(value = "/uploadSckhcl")
	 public Result<String> uploadSckhcl(@RequestBody ZyInfoStudent zyInfoStudent) {
		 try {
			  System.out.println("ids:"+zyInfoStudent.getId());
			  zyInfoStudentService.batchZyinfoKhcl(zyInfoStudent.getId());
		 }catch (Exception e) {
			 e.printStackTrace();
		 }

		 return Result.OK("考核材料上传成功!");
	 }


	 @AutoLog(value = "学生提交作业-批量删除")
	 @ApiOperation(value="学生提交作业-批量删除", notes="学生提交作业-批量删除")
	 @RequiresPermissions("zyInfoStudent:zy_info_student:deleteBatch")
	 @PostMapping(value = "/deleteBatch")
	 public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		 this.zyInfoStudentService.removeByIds(Arrays.asList(ids.split(",")));
		 return Result.OK("批量删除成功!");
	 }

	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "学生提交作业-通过id查询")
	@ApiOperation(value="学生提交作业-通过id查询", notes="学生提交作业-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<ZyInfoStudent> queryById(@RequestParam(name="id",required=true) String id) {
		ZyInfoStudent zyInfoStudent = zyInfoStudentService.getById(id);
		if(zyInfoStudent==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(zyInfoStudent);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param zyInfoStudent
    */
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, ZyInfoStudent zyInfoStudent) {
        return exportXls(request, zyInfoStudent, ZyInfoStudent.class, "学生提交作业");
    }
	 protected ModelAndView exportXls(HttpServletRequest request, ZyInfoStudent object, Class<ZyInfoStudent> clazz, String title) {
		 // Step.1 组装查询条件
		 QueryWrapper<ZyInfoStudent> queryWrapper = QueryGenerator.initQueryWrapper(object, request.getParameterMap());
		 LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();

		 String ywid = object.getYwid();
		 if(StringUtils.isEmpty(ywid)){
			 ywid = object.getMainId();
		 }
		 ZyInfo zyInfo = zyInfoService.getById(ywid);

		 SysUser teacher = sysUserService.getUserByName(zyInfo.getCreateBy());
		 // 过滤选中数据
		 String selections = request.getParameter("selections");
		 if (oConvertUtils.isNotEmpty(selections)) {
			 List<String> selectionList = Arrays.asList(selections.split(","));
			 queryWrapper.in("a.id",selectionList);
		 }
		 queryWrapper.eq("main_id",zyInfo.getId());
		 // Step.2 获取导出数据
		 List<ZyInfoStudent> exportList = service.list(queryWrapper);

		 // Step.3 AutoPoi 导出Excel
		 ModelAndView mv = new ModelAndView(new JeecgEntityExcelView());
		 //此处设置的filename无效 ,前端会重更新设置一下
		 mv.addObject(NormalExcelConstants.FILE_NAME, title);
		 mv.addObject(NormalExcelConstants.CLASS, clazz);
		 //update-begin--Author:liusq  Date:20210126 for：图片导出报错，ImageBasePath未设置--------------------
//		 课程名称:毕业论文 考试类型:考试-期末考试 打印日期:2024-05-11
		 String twoTitle = "作业名称:"+zyInfo.getTitle()+"      授课教师："+teacher.getRealname()+"        作业占比："+zyInfo.getScore()+"%       打印日期:"+ DateUtils.formatDate(new Date(),"yyyy-MM-dd HH:mm:ss");
		 ExportParams  exportParams=new ExportParams("[第"+zyInfo.getSort()+"次作业] "+title + "报表", twoTitle+"       导出人:" + sysUser.getRealname(), title);
		 exportParams.setImageBasePath(upLoadPath);
		 //update-end--Author:liusq  Date:20210126 for：图片导出报错，ImageBasePath未设置----------------------
		 mv.addObject(NormalExcelConstants.PARAMS,exportParams);
		 mv.addObject(NormalExcelConstants.DATA_LIST, exportList);
		 return mv;
	 }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("zyInfoStudent:zy_info_student:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, ZyInfoStudent.class);
    }


	 @AutoLog(value = "学生作业上传")
	 @ApiOperation(value="学生作业上传", notes="学生作业上传")
	 @RequestMapping(value = "/zyscStu", method = {RequestMethod.PUT,RequestMethod.POST})
	 public Result<Object> zyscStu(@RequestBody ZyInfoStudent zyInfoStudent, HttpServletResponse response) {

		 ZyInfoStudent stuPar = zyInfoStudentService.getById(zyInfoStudent.getStuId());
		 ZyInfo zyInfo = zyInfoService.getById(zyInfoStudent.getMainId());
		 if(stuPar==null) {

			 LoginUser user = (LoginUser) SecurityUtils.getSubject().getPrincipal();
			 //20241107新增判断，看原来是否有数据，防止重复添加
			 QueryWrapper<ZyInfoStudent> zyInfoStudentQueryWrapper = new QueryWrapper<>();
			 zyInfoStudentQueryWrapper.eq("a.create_by",user.getUsername());
			 zyInfoStudentQueryWrapper.eq("a.main_id",zyInfoStudent.getMainId());
			 zyInfoStudentQueryWrapper.last("limit 1");
			 ZyInfoStudent zyInfoStudent2 = zyInfoStudentService.getOne(zyInfoStudentQueryWrapper);
			 if(zyInfoStudent2!=null){
				 //20241107新增判断，看原来是否有数据，防止重复添加，将原来的id赋值到请求数据里
				 stuPar  = zyInfoStudent2;
				 stuPar.setFilePath(zyInfoStudent.getFilePath());
				 zyInfoStudent =stuPar;
			 }else{
				 ZyInfoStudent zyInfoStudent1 = new ZyInfoStudent();
				 zyInfoStudent1.setMainId(zyInfo.getId());
				 zyInfoStudent1.setCreateBy(user.getUsername());
				 zyInfoStudent1.setCreateTime(new Date());
				 zyInfoStudent1.setFilePath(zyInfoStudent.getFilePath());
				 zyInfoStudent1.setStudentName(user.getRealname());
				 zyInfoStudentService.save(zyInfoStudent1);
				 stuPar =zyInfoStudent1;
				 zyInfoStudent =zyInfoStudent1;
			 }

		 }else{
			 if(StringUtils.isNotEmpty(stuPar.getFilePath())){
				 return Result.error("您已上传了作业，请刷新后尝试");
			 }
			 stuPar.setFilePath(zyInfoStudent.getFilePath());

			 zyInfoStudent =stuPar;
		 }

		 //判断是否可以取消代办xshpkg
		 if(StringUtils.equals("0",zyInfo.getXshpkg())){
			 UpdateWrapper<ZyDbtx> zyDbtx = new UpdateWrapper<>();
			 zyDbtx.set("flag","1");
			 zyDbtx.eq("main_id",zyInfo.getId());
			 zyDbtx.eq("create_by",stuPar.getCreateBy());
			 zyDbtx.eq("type","0");
			 zyDbtxService.update(zyDbtx);
		 }


		 QueryWrapper<ZyInfoStudentHp> zyInfoStudentHpQueryWrapper3 = new QueryWrapper<>();
		 zyInfoStudentHpQueryWrapper3.eq("main_id",stuPar.getMainId());
		 zyInfoStudentHpQueryWrapper3.eq("stu_id",stuPar.getCreateBy());
		 List<ZyInfoStudentHp> list3 = zyInfoStudentHpService.list(zyInfoStudentHpQueryWrapper3);
		 if(list3.size()>4){
			 UpdateWrapper<ZyDbtx> zyDbtx = new UpdateWrapper<>();
			 zyDbtx.set("flag","1");
			 zyDbtx.eq("main_id",stuPar.getMainId());
			 zyDbtx.eq("create_by",stuPar.getCreateBy());
			 zyDbtx.eq("type","0");
			 zyDbtxService.update(zyDbtx);
		 }

		 String nameLast = zyInfoStudent.getFilePath().substring(zyInfoStudent.getFilePath().lastIndexOf(".")+1);
		 if(StringUtils.equals("pdf",nameLast)){
			 zyInfoStudent.setPdfPath(zyInfoStudent.getFilePath());
		 }else if(StringUtils.equals("doc",nameLast) || StringUtils.equals("docx",nameLast)){
			 if(StringUtils.equals("local",uploadType)){
				 Global global = SpringContextHolder.getBean(Global.class);
				 FileUtil.mkdir(global.getContractDickPath());
				 String dd = DateUtils.formatDate(new Date(),"yyyyMMddHHmmss");
				 String docPath = upLoadPath+ File.separator+ zyInfoStudent.getFilePath();
				 String namePath = dd + ".pdf";
				 String pdfPath = global.getContractDickPath() + namePath;
				 System.out.println("filPath:"+zyInfoStudent.getFilePath());
				 System.out.println("docPath:"+docPath);
				 System.out.println("pdfPath:"+pdfPath);
				 PDFUtil.office2PDF(docPath,pdfPath);
				 zyInfoStudent.setPdfPath("contract/"+namePath);
			 }else{
				 ZykInfo zykInfo = new ZykInfo();
				 zykInfo.setBizId(zyInfoStudent.getId());
				 zykInfo.setBizTable("zy_jxdg");
				 zykInfo.setWjlx(WjlxEnum.JXDG.getType());
				 zykInfo.setRwbh(zyInfo.getRwbh());
				 zykInfo.setFileName(zyInfoStudent.getFilePath());
				 Map<String,String> map = zykService.saveToZykJxdg(zykInfo);
				 String fileName = map.get("data");
				 String pdfName = map.get("pdfData");
				 zyInfoStudent.setFilePath(fileName);
				 zyInfoStudent.setPdfPath(pdfName);
			 }
		 }
		 zyInfoStudent.setPublishTime(new Date());
		 boolean bol = zyInfoStudentService.updateById(zyInfoStudent, response);
		 if(bol == false){
			 return Result.error("文件存储失败，请重新上传作业!");
		 }
		 QueryWrapper<KcKechengbiao> kcKechengbiaoQueryWrapper = new QueryWrapper<>();
		 kcKechengbiaoQueryWrapper.eq("rwbh",zyInfo.getRwbh());
		 kcKechengbiaoQueryWrapper.eq("jgh",zyInfo.getCreateBy());
		 kcKechengbiaoQueryWrapper.eq("xqxn",zyInfo.getXnxq());
		 kcKechengbiaoQueryWrapper.last("limit 1");
		 KcKechengbiao kcKechengbiao = kcKechengbiaoService.getOne(kcKechengbiaoQueryWrapper);
		 //作业代办提醒
		 ZyDbtx zyDbtx = new ZyDbtx();
		 zyDbtx.setCreateBy(zyInfo.getCreateBy());
		 zyDbtx.setType("5");//0发布作业 1评分 2测验 3问卷 4讨论 5学生提交作业  6学生提交测验  7学生提交问卷
		 zyDbtx.setMainId(zyInfo.getId());
		 zyDbtx.setRwbh(zyInfo.getRwbh());
		 LoginUser user = (LoginUser) SecurityUtils.getSubject().getPrincipal();
		 zyDbtx.setContent(user.getRealname()+"学生提交了["+kcKechengbiao.getKcmc()+"]课程“"+zyInfo.getTitle()+"”作业，该作业完成时间为："+DateUtils.formatDate(zyInfo.getEndTime(),"yyyy-MM-dd HH:mm")+"，请及时查看。学生提交时间："+DateUtils.formatDate(new Date(),"yyyy-MM-dd HH:mm:ss"));
		 zyDbtx.setFlag("0");
		 zyDbtx.setFbr(zyInfo.getCreateBy());
		 zyDbtxService.save(zyDbtx);

		 return Result.OK(zyInfoStudent);
	 }


	@AutoLog(value = "学生作业上传")
	@ApiOperation(value="学生作业上传", notes="学生作业上传")
	@RequestMapping(value = "/zyscStuBatch", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<Object> zyscStuBatch(@RequestBody ZyInfoStudent zyInfoStudent, HttpServletResponse response) {

		//20241107新增判断，看原来是否有数据，防止重复添加
		QueryWrapper<ZyInfoStudent> zyInfoStudentQueryWrapper = new QueryWrapper<>();
		zyInfoStudentQueryWrapper.eq("a.create_by",zyInfoStudent.getStuId());
		zyInfoStudentQueryWrapper.eq("a.main_id",zyInfoStudent.getMainId());
		zyInfoStudentQueryWrapper.last("limit 1");
		ZyInfoStudent stuPar = zyInfoStudentService.getOne(zyInfoStudentQueryWrapper);
		ZyInfo zyInfo = zyInfoService.getById(zyInfoStudent.getMainId());
		SysUser user = sysUserService.getUserByName(zyInfoStudent.getStuId());
		if(stuPar==null) {

				ZyInfoStudent zyInfoStudent1 = new ZyInfoStudent();
				zyInfoStudent1.setMainId(zyInfo.getId());
				zyInfoStudent1.setCreateBy(user.getUsername());
				zyInfoStudent1.setCreateTime(new Date());
				zyInfoStudent1.setFilePath(zyInfoStudent.getFilePath());
				zyInfoStudent1.setStudentName(user.getRealname());
				zyInfoStudentService.save(zyInfoStudent1);
				stuPar =zyInfoStudent1;
				zyInfoStudent =zyInfoStudent1;

		}else{
//			if(StringUtils.isNotEmpty(stuPar.getFilePath())){
//				return Result.error("您已上传了作业，请刷新后尝试");
//			}
			stuPar.setFilePath(zyInfoStudent.getFilePath());

			zyInfoStudent =stuPar;
		}

		//判断是否可以取消代办xshpkg
		if(StringUtils.equals("0",zyInfo.getXshpkg())){
			UpdateWrapper<ZyDbtx> zyDbtx = new UpdateWrapper<>();
			zyDbtx.set("flag","1");
			zyDbtx.eq("main_id",zyInfo.getId());
			zyDbtx.eq("create_by",stuPar.getCreateBy());
			zyDbtx.eq("type","0");
			zyDbtxService.update(zyDbtx);
		}


		QueryWrapper<ZyInfoStudentHp> zyInfoStudentHpQueryWrapper3 = new QueryWrapper<>();
		zyInfoStudentHpQueryWrapper3.eq("main_id",stuPar.getMainId());
		zyInfoStudentHpQueryWrapper3.eq("stu_id",stuPar.getCreateBy());
		List<ZyInfoStudentHp> list3 = zyInfoStudentHpService.list(zyInfoStudentHpQueryWrapper3);
		if(list3.size()>4){
			UpdateWrapper<ZyDbtx> zyDbtx = new UpdateWrapper<>();
			zyDbtx.set("flag","1");
			zyDbtx.eq("main_id",stuPar.getMainId());
			zyDbtx.eq("create_by",stuPar.getCreateBy());
			zyDbtx.eq("type","0");
			zyDbtxService.update(zyDbtx);
		}

		String nameLast = zyInfoStudent.getFilePath().substring(zyInfoStudent.getFilePath().lastIndexOf(".")+1);
		if(StringUtils.equals("pdf",nameLast)){
			zyInfoStudent.setPdfPath(zyInfoStudent.getFilePath());
		}else if(StringUtils.equals("doc",nameLast) || StringUtils.equals("docx",nameLast)){
			if(StringUtils.equals("local",uploadType)){
				Global global = SpringContextHolder.getBean(Global.class);
				FileUtil.mkdir(global.getContractDickPath());
				String dd = DateUtils.formatDate(new Date(),"yyyyMMddHHmmss");
				String docPath = upLoadPath+ File.separator+ zyInfoStudent.getFilePath();
				String namePath = dd + ".pdf";
				String pdfPath = global.getContractDickPath() + namePath;
				System.out.println("filPath:"+zyInfoStudent.getFilePath());
				System.out.println("docPath:"+docPath);
				System.out.println("pdfPath:"+pdfPath);
				PDFUtil.office2PDF(docPath,pdfPath);
				zyInfoStudent.setPdfPath("contract/"+namePath);
			}else{
				ZykInfo zykInfo = new ZykInfo();
				zykInfo.setBizId(zyInfoStudent.getId());
				zykInfo.setBizTable("zy_jxdg");
				zykInfo.setWjlx(WjlxEnum.JXDG.getType());
				zykInfo.setRwbh(zyInfo.getRwbh());
				zykInfo.setFileName(zyInfoStudent.getFilePath());
				Map<String,String> map = zykService.saveToZykJxdg(zykInfo);
				String fileName = map.get("data");
				String pdfName = map.get("pdfData");
				zyInfoStudent.setFilePath(fileName);
				zyInfoStudent.setPdfPath(pdfName);
			}
		}
		zyInfoStudent.setPublishTime(new Date());
		boolean bol = zyInfoStudentService.updateById(zyInfoStudent, response);
		if(bol == false){
			return Result.error("文件存储失败，请重新上传作业!");
		}
		QueryWrapper<KcKechengbiao> kcKechengbiaoQueryWrapper = new QueryWrapper<>();
		kcKechengbiaoQueryWrapper.eq("rwbh",zyInfo.getRwbh());
		kcKechengbiaoQueryWrapper.eq("jgh",zyInfo.getCreateBy());
		kcKechengbiaoQueryWrapper.eq("xqxn",zyInfo.getXnxq());
		kcKechengbiaoQueryWrapper.last("limit 1");
		KcKechengbiao kcKechengbiao = kcKechengbiaoService.getOne(kcKechengbiaoQueryWrapper);
		try {
			//作业代办提醒
			ZyDbtx zyDbtx = new ZyDbtx();
			zyDbtx.setCreateBy(zyInfo.getCreateBy());
			zyDbtx.setType("5");//0发布作业 1评分 2测验 3问卷 4讨论 5学生提交作业  6学生提交测验  7学生提交问卷
			zyDbtx.setMainId(zyInfo.getId());
			zyDbtx.setRwbh(zyInfo.getRwbh());
			zyDbtx.setContent(user.getRealname()+"学生提交了["+kcKechengbiao.getKcmc()+"]课程“"+zyInfo.getTitle()+"”作业，该作业完成时间为："+DateUtils.formatDate(zyInfo.getEndTime(),"yyyy-MM-dd HH:mm")+"，请及时查看。学生提交时间："+DateUtils.formatDate(new Date(),"yyyy-MM-dd HH:mm:ss"));
			zyDbtx.setFlag("0");
			zyDbtx.setFbr(zyInfo.getCreateBy());
			zyDbtxService.save(zyDbtx);
		} catch (Exception e) {
			e.printStackTrace();
		}

		return Result.OK(zyInfoStudent);
	}


	 @AutoLog(value = "学生作业开始检测")
	 @ApiOperation(value="学生作业开始检测", notes="学生作业开始检测")
	 @RequestMapping(value = "/stuWpKsjc", method = {RequestMethod.PUT,RequestMethod.POST})
	 public Result<String> stuWpKsjc(@RequestBody ZyInfoStudent zyInfoStudent, HttpServletResponse response) {
//		 Date date  = new Date();
//		 QueryWrapper<ZyCcjg> zyCcjgStudentQueryWrapper = new QueryWrapper<>();
//		 zyCcjgStudentQueryWrapper.eq("zy_stu_id",zyInfoStudent.getId());
//		 List<ZyCcjg> list = zyCcjgService.list(zyCcjgStudentQueryWrapper);
//		 if(list.size()>0){
//			 Date date1 = list.get(0).getCreateTime();
//			 long msNum = date1.getTime() - date.getTime(); // 时间戳相差的毫秒数
//			 long seconds = msNum / 1000; // 转换为秒
//			 if(seconds<=5){//如果是5s内重复操作，则给出提示，不允许继续操作
//				 return Result.error("不可以重复点击!");
//			 }
//		 }


		 boolean bol = zyInfoStudentService.stuWpKsjc(zyInfoStudent, response);
		 return Result.OK("提交成功!");
	 }


	 @AutoLog(value = "作业驳回")
	 @ApiOperation(value="作业驳回", notes="作业驳回")
	 @RequestMapping(value = "/editBohui", method = {RequestMethod.PUT,RequestMethod.POST})
	 public Result<Map> editBohui(@RequestBody ZyInfoStudent zyInfoStudent, HttpServletResponse response) {
		 UpdateWrapper<ZyInfoStudent> updateWrapper = new UpdateWrapper<>();
		 updateWrapper.set("file_path",null);
		 updateWrapper.set("pdf_path",null);
		 updateWrapper.set("wwsftg",null);
		 updateWrapper.set("nwsftg",null);
		 updateWrapper.set("aigcsftg",null);
		 updateWrapper.set("xnsftg",null);
		 updateWrapper.set("wwxsl",null);
		 updateWrapper.set("nwxsl",null);
		 updateWrapper.set("aigcxsl",null);
		 updateWrapper.set("xnxsl",null);
		 updateWrapper.set("hpcs","0");
		 updateWrapper.set("xshpfs",null);
		 updateWrapper.set("jxfs",null);
		 updateWrapper.set("jxfs2",null);
		 updateWrapper.set("zzdf",null);
		 updateWrapper.set("score",null);
		 updateWrapper.eq("id",zyInfoStudent.getId());
		 updateWrapper.set("bh_content",zyInfoStudent.getBhContent());
		 zyInfoStudentService.update(updateWrapper);



		 //删除互评数据
		 zyInfoStudentHpService.remove(new QueryWrapper<ZyInfoStudentHp>().eq("zy_stu_id",zyInfoStudent.getId()));

		 ZyInfoStudent zyInfoStudent1 = zyInfoStudentService.getById(zyInfoStudent.getId());
		 ZyInfo zyInfo = zyInfoService.getById(zyInfoStudent1.getMainId());
		 //作业代办提醒
		 ZyDbtx zyDbtx = new ZyDbtx();
		 zyDbtx.setCreateBy(zyInfoStudent1.getCreateBy());
		 zyDbtx.setType("0");//0发布作业 1评分 2测验 3问卷 4讨论
		 zyDbtx.setMainId(zyInfoStudent1.getMainId());
		 zyDbtx.setRwbh(zyInfo.getRwbh());
		 zyDbtx.setContent( "你提交的作业已经被老师驳回，请尽快重新提交作业！驳回时间："+DateUtils.formatDate(new Date(),"yyyy-MM-dd HH:mm:ss"));
		 zyDbtx.setFlag("0");
		 zyDbtx.setFbr(zyInfo.getCreateBy());
		 zyDbtxService.save(zyDbtx);


		 //查重前删除原来的查重数据
//		 zyCcjgService.deleteByZystuid(zyInfoStudent.getId(),response);
		 return Result.OK(new HashMap());
	 }

	 @AutoLog(value = "设置作业存档类型")
	 @ApiOperation(value="设置作业存档类型", notes="设置作业存档类型")
	 @RequestMapping(value = "/editCdlx", method = {RequestMethod.PUT,RequestMethod.POST})
	 public Result<String> editCdlx(@RequestBody ZyInfoStudent zyInfoStudent) {
		 UpdateWrapper<ZyInfoStudent> par = new UpdateWrapper<>();
		 par.eq("id",zyInfoStudent.getId());
		 par.set("cdlx",zyInfoStudent.getCdlx());
		 zyInfoStudentService.update(par);
		 return Result.OK("设置存档类型成功!");
	 }

	 @ApiOperation(value="获取存档信息", notes="获取存档信息")
	 @GetMapping(value = "/cdxxlist")
	 public Result<IPage<ZyInfoStudent>> cdxxlist(ZyInfoStudent zyInfoStudent,
													   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
													   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
													   HttpServletRequest req) {

		 QueryWrapper<ZyInfoStudent> queryWrapper = QueryGenerator.initQueryWrapper("a",zyInfoStudent, req.getParameterMap());
		 queryWrapper.eq(StringUtils.isNotEmpty(zyInfoStudent.getTeacherNo()),"b.create_by",zyInfoStudent.getTeacherNo());
		 queryWrapper.eq(StringUtils.isNotEmpty(zyInfoStudent.getRwbh()),"b.rwbh",zyInfoStudent.getRwbh());
		 queryWrapper.like(StringUtils.isNotEmpty(zyInfoStudent.getZyname()),"b.title",zyInfoStudent.getZyname());
		 queryWrapper.isNotNull("cdlx");
		 Page<ZyInfoStudent> page = new Page<ZyInfoStudent>(pageNo, pageSize);
		 IPage<ZyInfoStudent> pageList = zyInfoStudentService.cdxxlist(page, queryWrapper);
		 return Result.OK(pageList);
	 }


	 @ApiOperation(value="教学大纲-分页列表查询", notes="教学大纲-分页列表查询")
	 @GetMapping(value = "/sysList")
	 public Result<IPage<ZyInfoStudentSys>> sysList(ZyInfoStudentSys zyInfoStudentSys,
											 @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
											 @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
											 HttpServletRequest req) {



		 //查询作业查重结果
		 zyCcjgService.getCcjg();

		 LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
		 //-------------获取当前登陆人是否是管理员角色，如果不是都按照教务秘书处理---------------------------
		 List<String> roleList = sysBaseApi.getRolesByUsername(sysUser.getUsername());
		 String adminRole = "1";//0 admin  1教务秘书
		 for(String role :roleList){
			 if(org.apache.commons.lang.StringUtils.equals("admin",role)){
				 adminRole = "0";
				 break;
			 }
		 }
		 QueryWrapper<ZyInfoStudentSys> queryWrapper = new QueryWrapper<ZyInfoStudentSys>();
		 if(org.apache.commons.lang.StringUtils.equals("1",adminRole)){
			 QueryWrapper<KcExportConfigTpkwcqkjzglx> queryWrapperCon = new QueryWrapper<KcExportConfigTpkwcqkjzglx>();
			 queryWrapperCon.eq("gh",sysUser.getUsername());
			 queryWrapperCon.orderByDesc("create_time");
			 queryWrapperCon.last("limit 1");
			 KcExportConfigTpkwcqkjzglx kcExportConfigTpkwcqkjzglx = kcExportConfigTpkwcqkjzglxService.getOne(queryWrapperCon);
			 queryWrapper.eq("kkdw",kcExportConfigTpkwcqkjzglx.getDwmc());
		 }

		 if(com.baomidou.mybatisplus.core.toolkit.StringUtils.isEmpty(zyInfoStudentSys.getXnxq())){
			 KcSysConfig kcSysConfig = kcSysConfigService.getById("1");
			 queryWrapper.eq("xqxn",kcSysConfig.getFlag1());
		 }else{
			 queryWrapper.eq("xqxn",zyInfoStudentSys.getXnxq());
		 }
		 queryWrapper.like(com.baomidou.mybatisplus.core.toolkit.StringUtils.isNotEmpty(zyInfoStudentSys.getKkdw()),"kkdw",zyInfoStudentSys.getKkdw());
		 queryWrapper.like(com.baomidou.mybatisplus.core.toolkit.StringUtils.isNotEmpty(zyInfoStudentSys.getKcmc()),"kcmc",zyInfoStudentSys.getKcmc());
		 queryWrapper.like(com.baomidou.mybatisplus.core.toolkit.StringUtils.isNotEmpty(zyInfoStudentSys.getKcbh()),"kcbh",zyInfoStudentSys.getKcbh());
		 queryWrapper.like(com.baomidou.mybatisplus.core.toolkit.StringUtils.isNotEmpty(zyInfoStudentSys.getSkjs()),"skjs",zyInfoStudentSys.getSkjs());


		 Page<ZyInfoStudentSys> page = new Page<ZyInfoStudentSys>(pageNo, pageSize);
		 IPage<ZyInfoStudentSys> pageList = zyInfoStudentService.sysList(page, queryWrapper,zyInfoStudentSys);
		 return Result.OK(pageList);
	 }


	 @RequestMapping(value = "/exportSysXls")
	 public ModelAndView exportSysXls(HttpServletRequest request, ZyInfoStudentSys zyInfoStudentSys) {
		 String title = "学生作业管理";
		 // Step.1 组装查询条件
		 QueryWrapper<ZyInfoStudentSys> queryWrapper = new QueryWrapper<>();
		 LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();


		 //-------------获取当前登陆人是否是管理员角色，如果不是都按照教务秘书处理---------------------------
		 List<String> roleList = sysBaseApi.getRolesByUsername(sysUser.getUsername());
		 String adminRole = "1";//0 admin  1教务秘书
		 for(String role :roleList){
			 if(org.apache.commons.lang.StringUtils.equals("admin",role)){
				 adminRole = "0";
				 break;
			 }
		 }
		 if(org.apache.commons.lang.StringUtils.equals("1",adminRole)){
			 QueryWrapper<KcExportConfigTpkwcqkjzglx> queryWrapperCon = new QueryWrapper<KcExportConfigTpkwcqkjzglx>();
			 queryWrapperCon.eq("gh",sysUser.getUsername());
			 queryWrapperCon.orderByDesc("create_time");
			 queryWrapperCon.last("limit 1");
			 KcExportConfigTpkwcqkjzglx kcExportConfigTpkwcqkjzglx = kcExportConfigTpkwcqkjzglxService.getOne(queryWrapperCon);
			 queryWrapper.eq("kkdw",kcExportConfigTpkwcqkjzglx.getDwmc());
		 }

		 if(com.baomidou.mybatisplus.core.toolkit.StringUtils.isEmpty(zyInfoStudentSys.getXnxq())){
			 KcSysConfig kcSysConfig = kcSysConfigService.getById("1");
			 queryWrapper.eq("xqxn",kcSysConfig.getFlag1());
		 }else{
			 queryWrapper.eq("xqxn",zyInfoStudentSys.getXnxq());
		 }
		 queryWrapper.like(com.baomidou.mybatisplus.core.toolkit.StringUtils.isNotEmpty(zyInfoStudentSys.getKkdw()),"kkdw",zyInfoStudentSys.getKkdw());
		 queryWrapper.like(com.baomidou.mybatisplus.core.toolkit.StringUtils.isNotEmpty(zyInfoStudentSys.getKcmc()),"kcmc",zyInfoStudentSys.getKcmc());
		 queryWrapper.like(com.baomidou.mybatisplus.core.toolkit.StringUtils.isNotEmpty(zyInfoStudentSys.getKcbh()),"kcbh",zyInfoStudentSys.getKcbh());
		 queryWrapper.like(com.baomidou.mybatisplus.core.toolkit.StringUtils.isNotEmpty(zyInfoStudentSys.getSkjs()),"skjs",zyInfoStudentSys.getSkjs());

		 // Step.2 获取导出数据
		 List<ZyInfoStudentSys> exportList = service.exportSysXls(queryWrapper,zyInfoStudentSys);

		 // Step.3 AutoPoi 导出Excel
		 ModelAndView mv = new ModelAndView(new JeecgEntityExcelView());
		 //此处设置的filename无效 ,前端会重更新设置一下
		 mv.addObject(NormalExcelConstants.FILE_NAME, title);
		 mv.addObject(NormalExcelConstants.CLASS, ZyInfoStudentSys.class);
		 //update-begin--Author:liusq  Date:20210126 for：图片导出报错，ImageBasePath未设置--------------------
		 ExportParams exportParams=new ExportParams(title + "报表", "导出人:" + sysUser.getRealname(), title);
		 exportParams.setImageBasePath(upLoadPath);
		 //update-end--Author:liusq  Date:20210126 for：图片导出报错，ImageBasePath未设置----------------------
		 mv.addObject(NormalExcelConstants.PARAMS,exportParams);
		 mv.addObject(NormalExcelConstants.DATA_LIST, exportList);
		 return mv;
	 }


	 @ApiOperation(value="获取互评作业未评阅信息", notes="获取互评作业未评阅信息")
	 @GetMapping(value = "/getHpxxList")
	 public Result<IPage<ZyInfoStudent>> getHpxxList(ZyInfoStudent zyInfoStudent,
													   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
													   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
													   HttpServletRequest req) {


		 LoginUser user = (LoginUser) SecurityUtils.getSubject().getPrincipal();

		 String minhpcs = dictUtils.translateDictValue("hpcjsz","4");
		 QueryWrapper<ZyInfoStudentHp> zyInfoStudentHpQueryWrapper = new QueryWrapper<>();
		 zyInfoStudentHpQueryWrapper.eq("main_id",zyInfoStudent.getMainId());
		 zyInfoStudentHpQueryWrapper.eq("stu_id",user.getUsername());
		 List<ZyInfoStudentHp> hplist = zyInfoStudentHpService.list(zyInfoStudentHpQueryWrapper);
		 pageSize = Integer.parseInt(minhpcs);
		 if(hplist.size()>0){
			 pageSize = pageSize - hplist.size();
			 if(pageSize<0){
				 pageSize = 0;
			 }
		 }
		 QueryWrapper<ZyInfoStudent> queryWrapper = QueryGenerator.initQueryWrapper("a",zyInfoStudent, req.getParameterMap());
		 Page<ZyInfoStudent> page = new Page<ZyInfoStudent>(pageNo, pageSize);
		 queryWrapper.isNotNull("a.file_path");
		 queryWrapper.eq("a.xshpkg","1");
		 queryWrapper.eq("sfpf","0");
		 queryWrapper.apply("xshpkssj <= now() and xshpjssj >= now() and hpsfwctwo = 0");

		 queryWrapper.ne("a.create_by",user.getUsername());
		 queryWrapper.like(StringUtils.isNotEmpty(zyInfoStudent.getZytitle()),"a.title",zyInfoStudent.getZytitle());
		 queryWrapper.eq(StringUtils.isNotEmpty(zyInfoStudent.getRwbh()),"a.rwbh",zyInfoStudent.getRwbh());
		 queryWrapper.apply("a.hpcs - 0 < "+minhpcs);
		 queryWrapper.orderByAsc("a.hpcs - 0 ");
		 IPage<ZyInfoStudent> pageList = zyInfoStudentService.getHpxxList(page, queryWrapper,user.getUsername());
		 return Result.OK(pageList);
	 }


	 @ApiOperation(value="获取互评作业已评阅信息", notes="获取互评作业已评阅信息")
	 @GetMapping(value = "/getHpxxYpyList")
	 public Result<IPage<ZyInfoStudent>> getHpxxYpyList(ZyInfoStudent zyInfoStudent,
													 @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
													 @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
													 HttpServletRequest req) {


		 LoginUser user = (LoginUser) SecurityUtils.getSubject().getPrincipal();

		 QueryWrapper<ZyInfoStudent> queryWrapper = QueryGenerator.initQueryWrapper("a",zyInfoStudent, req.getParameterMap());
		 Page<ZyInfoStudent> page = new Page<ZyInfoStudent>(pageNo, pageSize);
		 queryWrapper.isNotNull("a.file_path");
		 queryWrapper.eq("a.xshpkg","1");
		 queryWrapper.eq("a.sfpf","1");
		 queryWrapper.apply("xshpkssj <= now() and xshpjssj >= now() and hpsfwctwo = 0");

		 queryWrapper.ne("a.create_by",user.getUsername());
		 queryWrapper.like(StringUtils.isNotEmpty(zyInfoStudent.getZytitle()),"a.title",zyInfoStudent.getZytitle());
		 queryWrapper.eq(StringUtils.isNotEmpty(zyInfoStudent.getRwbh()),"a.rwbh",zyInfoStudent.getRwbh());
		 queryWrapper.orderByAsc("a.hpcs - 0 ");
		 IPage<ZyInfoStudent> pageList = zyInfoStudentService.getHpxxList(page, queryWrapper,user.getUsername());
		 return Result.OK(pageList);
	 }



	 @AutoLog(value = "教师批阅作业")
	 @ApiOperation(value="教师批阅作业", notes="教师批阅作业")
	 @RequestMapping(value = "/editPiyue", method = {RequestMethod.PUT,RequestMethod.POST})
	 public Result<ZyInfoStudent> editPiyue(@RequestBody ZyInfoStudent zyInfoStudent) {
		 zyInfoStudentService.updateById(zyInfoStudent);
		 return Result.OK("批阅完成!");
	 }


	 @AutoLog(value = "教师批阅作业")
	 @ApiOperation(value="教师批阅作业", notes="教师批阅作业")
	 @RequestMapping(value = "/SyncZyStudentPdf", method = {RequestMethod.PUT,RequestMethod.POST})
	 public Result<ZyInfoStudent> SyncZyStudentPdf() {
		 List<ZyInfoStudent> ybtkblist = zyInfoStudentService.getDocNoPdfList();
		 for(ZyInfoStudent zyInfoStudent:ybtkblist){
			 try {
				 Global global = SpringContextHolder.getBean(Global.class);
				 FileUtil.mkdir(global.getContractDickPath());
				 String dd = DateUtils.formatDate(new Date(),"yyyyMMddHHmmss");
				 String docPath = upLoadPath+ File.separator+ zyInfoStudent.getFilePath();
				 String namePath = dd + ".pdf";
				 String pdfPath = global.getContractDickPath() + namePath;
				 System.out.println("filPath:"+zyInfoStudent.getFilePath());
				 System.out.println("docPath:"+docPath);
				 System.out.println("pdfPath:"+pdfPath);
				 PDFUtil.office2PDF(docPath,pdfPath);
				 zyInfoStudent.setPdfPath("contract/"+namePath);
				 zyInfoStudent.setPublishTime(new Date());
				 zyInfoStudentService.updateById(zyInfoStudent);
			 } catch (Exception e) {
				 throw new RuntimeException(e);
			 }
		 }
		 return Result.OK("批阅完成!");
	 }


	 @ApiOperation(value="重新提交作业查重信息", notes="重新提交作业查重信息")
	 @GetMapping(value = "/cxccByZyId")
	 public Result<IPage<ZyInfoStudent>> cxccByZyId(ZyInfoStudent zyInfoStudent2,  HttpServletRequest req, HttpServletResponse response) {
		 zyInfoStudent2.setMainId("1834795983056072705");
		 List<ZyInfoStudent> list =zyInfoStudentService.cxccByZyId(zyInfoStudent2);
		 for(ZyInfoStudent zyInfoStudent:list){
			 zyInfoStudentService.stuWpKsjc(zyInfoStudent, response);
		 }
		return null;
	 }


	 @ApiOperation(value="重新提交作业查重信息", notes="重新提交作业查重信息")
	 @GetMapping(value = "/Scccjg")
	 public Result<IPage<ZyInfoStudent>> Scccjg(ZyInfoStudent zyInfoStudent,  HttpServletRequest req, HttpServletResponse response) {
		ZyInfoStudent zyInfoStudent1 = zyInfoStudentService.scccjg(zyInfoStudent,req,response);
		return null;
	 }


	 @AutoLog(value = "学生提交作业-批量发布考核材料")
	 @ApiOperation(value="学生提交作业-批量发布考核材料", notes="学生提交作业-批量发布考核材料")
	 @PostMapping(value = "/batchKhclZyid")
	 public Result<String> batchKhclZyid(@RequestParam(name="ids",required=true) String ids) {
		 try {
			 String idsList[] = ids.split(",");
			 if(idsList.length>0){
				 ZyInfoStudent zyInfoStudentPar = zyInfoStudentService.getById(idsList[0]);
				 ZyInfo zyInfo = zyInfoService.getById(zyInfoStudentPar.getMainId());
				 QueryWrapper<KcKechengbiao> kcKechengbiaoQueryWrapper = new QueryWrapper<>();
				 kcKechengbiaoQueryWrapper.eq("rwbh",zyInfo.getRwbh());
				 kcKechengbiaoQueryWrapper.eq("jgh",zyInfo.getCreateBy());
				 kcKechengbiaoQueryWrapper.eq("xqxn",zyInfo.getXnxq());
				 kcKechengbiaoQueryWrapper.last("limit 1");
				 KcKechengbiao kcKechengbiao = kcKechengbiaoService.getOne(kcKechengbiaoQueryWrapper);

				 zyInfo.setSfsckhcl("1");
				 zyInfo.setSfsckhclTime(new Date());
				 zyInfoService.updateById(zyInfo);



				 for(int i=0;i< idsList.length;i++){

					 ZyInfoStudent zyInfoStudentPar2 = zyInfoStudentService.getById(idsList[i]);

					 if(StringUtils.isNotEmpty(zyInfoStudentPar2.getFilePath())){
						 //上传文件
						 Map<String,String> uploadMap = SFTPUtil.upload(sftpConfig,upLoadPath+"/"+zyInfoStudentPar2.getFilePath(),zyInfoStudentPar2.getFilePath());
						 zyInfoStudentPar2.setSfsckhcl("1");
						 zyInfoStudentPar2.setFwqPath(uploadMap.get("data"));
						 zyInfoStudentPar2.setKhclTime(new Date());
						 zyInfoStudentService.updateById(zyInfoStudentPar2);

						 ZyInfoScjl zyInfoScjl = new ZyInfoScjl();
						 zyInfoScjl.setZyId(zyInfo.getId());
						 zyInfoScjl.setZyName(zyInfo.getTitle());
						 zyInfoScjl.setZyLeixing(zyInfo.getZyLeixing());
						 zyInfoScjl.setZyZb(zyInfo.getScore());
						 zyInfoScjl.setJgh(kcKechengbiao.getJgh());
						 zyInfoScjl.setSkjs(kcKechengbiao.getSkjs());
						 zyInfoScjl.setSkdd(kcKechengbiao.getSkdd());
						 zyInfoScjl.setKkdw(kcKechengbiao.getKkdw());
						 zyInfoScjl.setKkdwid(kcKechengbiao.getKkdwid());
						 zyInfoScjl.setKcxz(kcKechengbiao.getKcxz());
						 zyInfoScjl.setXnxq(zyInfo.getXnxq());
						 zyInfoScjl.setFilePath(zyInfoStudentPar2.getFwqPath());
						 zyInfoScjl.setStudentNo(zyInfoStudentPar2.getCreateBy());
						 zyInfoScjl.setStudentName(zyInfoStudentPar2.getStudentName());
						 zyInfoScjlService.save(zyInfoScjl);
					 }
				 }
			 }
		 }catch (Exception e) {
			 e.printStackTrace();
		 }

		 return Result.OK("上传成功!");
	 }


	 /**
	  * 重新提交因为检测次数不足导致的错误
	  * @param response
	  * @return
	  */
	 @RequestMapping(value = "/cxtjByJccsbz", method = {RequestMethod.PUT,RequestMethod.POST})
	 public Result<String> cxtjByJccsbz(HttpServletResponse response) {
		 List<ZyInfoStudent> list =zyInfoStudentService.cxtjByJccsbz();
		 for(ZyInfoStudent zyInfoStudent:list){
			 zyInfoStudentService.sysWpKsjc(zyInfoStudent, response);
		 }
		 return Result.OK("提交成功!");
	 }


	 /**
	  * 获取维普查重次数
	  * @return
	  */
	 @GetMapping(value = "/getWpSycccs")
	 public Result<List<JSONObject>> queryById() {
		 List<JSONObject> zyInfoStudent = zyInfoStudentService.getWpSycccs();
		 return Result.OK(zyInfoStudent);
	 }

	 /**
	  * 获取同小组人员作业标识
	  * @return
	  */
	 @PostMapping(value = "/getZyStuId")
	 public Result<List<ZyInfoStudent>> getZyStuId(@RequestBody ZyXzryInfo zyXzryInfo) {
		 return Result.OK(zyInfoStudentService.getZyStuId(zyXzryInfo));
	 }

	 /**
	  * 获取同小组人员作业标识
	  * @return
	  */
	 @PostMapping(value = "/getZyStuIdById")
	 public Result<List<ZyInfoStudent>> getZyStuIdById(@RequestBody ZyXzryInfo zyXzryInfo) {
		 return Result.OK(zyInfoStudentService.getZyStuIdById(zyXzryInfo));
	 }



	@GetMapping(value = "/downStudentZip")
	public Result<Map<String,String>> downStudentZip(ZyInfoStudent zyInfoStudent) {
		 if(StringUtils.isEmpty(zyInfoStudent.getMainId())){
			 return Result.error("操作失败");
		 }
		String downPath = zyInfoStudentService.downStudentZip(zyInfoStudent);
		if(StringUtils.equals("0",downPath)){
			return Result.error("下载失败");
		}
		Map<String,String> map = new HashMap<>();
		map.put("status","1");
		map.put("downPath",downPath);
		return Result.OK(map);
	}


	@ApiOperation(value="学生手动更新查重结果", notes="学生手动更新查重结果")
	@GetMapping(value = "/getStudentCcjg")
	public Result<Map<String,String>> getStudentCcjg(@RequestParam(name="id",required=true) String id) {
		Map<String,String> map = new HashMap<>();
		ZyInfoStudent zyInfoStudent = zyInfoStudentService.getById(id);
		ZyInfo zyInfo = zyInfoService.getById(zyInfoStudent.getMainId());
		QueryWrapper<ZyCcjg> zyCcjgStudentQueryWrapper = new QueryWrapper<>();
		zyCcjgStudentQueryWrapper.eq("zy_stu_id",zyInfoStudent.getId());
		List<ZyCcjg> list = zyCcjgService.list(zyCcjgStudentQueryWrapper);
		Double wwtgl = zyInfo.getWwtgl();
		for(ZyCcjg par:list){
			if(StringUtils.equals(par.getCcType(),"0")){//外网
				String percetage = par.getPercentage();
				zyInfoStudent.setWwxsl(par.getPercentage());
				if(Double.parseDouble(percetage) <= wwtgl){
					zyInfoStudent.setWwsftg("通过");
				}else{
					zyInfoStudent.setWwsftg("未通过");
				}
			}else if(StringUtils.equals(par.getCcType(),"1")){//作业
				String percetage = par.getPercentage();
				zyInfoStudent.setNwxsl(par.getPercentage());
				if(Double.parseDouble(percetage) <= wwtgl){
					zyInfoStudent.setNwsftg("通过");
				}else{
					zyInfoStudent.setNwsftg("未通过");
				}
			}else if(StringUtils.equals(par.getCcType(),"2")){//aigc
				String percetage = par.getAiRate();
				zyInfoStudent.setAigcxsl(par.getAiRate());
				if(Double.parseDouble(percetage) <= wwtgl){
					zyInfoStudent.setAigcsftg("通过");
				}else{
					zyInfoStudent.setAigcsftg("未通过");
				}
			}else if(StringUtils.equals(par.getCcType(),"3")){//学校
				String percetage = par.getPercentage();
				zyInfoStudent.setXnxsl(par.getPercentage());
				if(Double.parseDouble(percetage) <= wwtgl){
					zyInfoStudent.setXnsftg("通过");
				}else{
					zyInfoStudent.setXnsftg("未通过");
				}
			}
		}
		zyInfoStudentService.updateById(zyInfoStudent);
		map.put("success","true");
		map.put("message","更新成功");

		return Result.OK(map);
	}
}
