package org.jeecg.modules.kc.zyInfoStudent.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.jeecg.common.aspect.annotation.Dict;
import org.jeecgframework.poi.excel.annotation.Excel;
import org.springframework.format.annotation.DateTimeFormat;

import java.io.Serializable;
import java.util.Date;

/**
 * @Description: 学生提交作业
 * @Author: jeecg-boot
 * @Date:   2024-05-06
 * @Version: V1.0
 */
@Data
@TableName("zy_info_student")
@Accessors(chain = true)
@EqualsAndHashCode(callSuper = false)
@ApiModel(value="zy_info_student对象", description="学生提交作业")
public class ZyInfoStudentExport implements Serializable {
    private static final long serialVersionUID = 1L;

	/**id*/
	@TableId(type = IdType.ASSIGN_ID)
    @ApiModelProperty(value = "id")
    private String id;
	/**updateBy*/
    @ApiModelProperty(value = "updateBy")
    private String updateBy;
	/**updateTime*/
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd")
    @DateTimeFormat(pattern="yyyy-MM-dd")
    @ApiModelProperty(value = "updateTime")
    private Date updateTime;


    @Excel(name = "学生姓名", width = 15)
    @ApiModelProperty(value = "studentName")
    private String studentName;
    @Excel(name = "学生学号", width = 15)
    @ApiModelProperty(value = "createBy")
    private String createBy;
    @Excel(name = "专业名称", width = 15)
    @ApiModelProperty(value = "zymc")
    @TableField(exist = false)
    private String zymc;

    @JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd")
    @DateTimeFormat(pattern="yyyy-MM-dd")
    @ApiModelProperty(value = "createTime")
    private Date createTime;

    @JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd")
    @DateTimeFormat(pattern="yyyy-MM-dd")
    @Excel(name = "提交时间", width = 15,format = "yyyy-MM-dd")
    private Date publishTime;

    @Excel(name = "教师评分", width = 15)
    private int score;

    @Excel(name = "互评分数", width = 15)
    private String xshpfs;
    @Excel(name = "绩效分", width = 15)
    private String jxfs;
    @Excel(name = "最终得分", width = 15)
    private int zzdf;
    @Excel(name = "最高查重率", width = 15)
    @TableField(exist = false)
    private String zgccl;//最高相似律

    /**外网相似律*/
//    @Excel(name = "维普查重（%）", width = 15)
    @ApiModelProperty(value = "维普查重（%）")
    private String wwxsl;
    /**内网相似律*/
//    @Excel(name = "作业查重（%）", width = 15)
    @ApiModelProperty(value = "作业查重（%）")
    private String nwxsl;
    /**aigc相似律*/
//    @Excel(name = "aigc查重（%）", width = 15)
    @ApiModelProperty(value = "aigc查重（%）")
    private String aigcxsl;
    /**校内相似律*/
//    @Excel(name = "校内查重（%）", width = 15)
    @ApiModelProperty(value = "校内查重（%）")
    private String xnxsl;
//    @Excel(name = "标记作业", width = 15,dicCode = "cdlx")
    @Dict(dicCode = "cdlx")
    private String cdlx;//存档类型


	/**作业名称*/
    @ApiModelProperty(value = "作业名称")
    private String mainId;
	/**作业附件*/
    @ApiModelProperty(value = "作业附件")
    private String filePath;
	/**外网是否通过*/
    @ApiModelProperty(value = "外网是否通过")
    private String wwsftg;
	/**内网是否通过*/
    @ApiModelProperty(value = "内网是否通过")
    private String nwsftg;
	/**aigc是否通过*/
    @ApiModelProperty(value = "aigc是否通过")
    private String aigcsftg;
    /**校内是否通过*/
    @ApiModelProperty(value = "校内是否通过")
    private String xnsftg;

    private String pdfPath;
    private String scoreFabu;
    private String hpcs;
    private String jxfs2;
    private String zyLeixing;//作业类型  0课程作业  1期末作业
    private String pyContent;//批阅内容
    private String pyFilePath;//批阅附件
    private String sfsckhcl;//是否上传考核材料（0否 1是）
    private String fwqPath;//文件服务器存储地址
    private String pyFwqFilePath;//评阅附件存储地址
    @JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    @Excel(name = "考核材料提交时间", width = 15,format = "yyyy-MM-dd HH:mm:ss")
    private Date khclTime;




    @TableField(exist = false)
    private String jxzf;

    @TableField(exist = false)
    private String catename;
    @TableField(exist = false)
    private String cateid;

    @TableField(exist = false)
    private String wwcc;
    @TableField(exist = false)
    private String nwcc;
    @TableField(exist = false)
    private String aigccc;
    @TableField(exist = false)
    private String xncc;
    @TableField(exist = false)
    private String zyname;
    @TableField(exist = false)
    private String teacherNo;
    @TableField(exist = false)
    private String rwbh;


    @TableField(exist = false)
    private String ccType;
    @TableField(exist = false)
    private String paperviewurl;
    @TableField(exist = false)
    private String paperdownurl;

    @TableField(exist = false)
    private String wwpaperviewurl;//外网预览
    @TableField(exist = false)
    private String wwpaperdownurl;//外网下载
    @TableField(exist = false)
    private String zypaperviewurl;//作业预览
    @TableField(exist = false)
    private String zypaperdownurl;//作业下载
    @TableField(exist = false)
    private String xxpaperviewurl;//学校预览
    @TableField(exist = false)
    private String xxpaperdownurl;//学校下载
    @TableField(exist = false)
    private String aigcpaperviewurl;//aigc预览
    @TableField(exist = false)
    private String aigcpaperdownurl;//aigc外网下载

    @TableField(exist = false)
    private String filestateid;//
    @TableField(exist = false)
    private String message;//
    @TableField(exist = false)
    private String wwfilestateid;//外网状态
    @TableField(exist = false)
    private String wwmessage;//外网说明
    @TableField(exist = false)
    private String zyfilestateid;//作业状态
    @TableField(exist = false)
    private String zymessage;//作业说明
    @TableField(exist = false)
    private String aigcfilestateid;//aigc状态
    @TableField(exist = false)
    private String aigcmessage;//aigc说明
    @TableField(exist = false)
    private String xxfilestateid;//学校状态
    @TableField(exist = false)
    private String xxmessage;//学校说明
    @TableField(exist = false)
    private String queryType;//作业状态查询
    @TableField(exist = false)
    private String alltgl;//通过率
    @TableField(exist = false)
    private String sfpf;//是否评分
    @TableField(exist = false)
    private String zytitle;//作业名称
    @TableField(exist = false)
    private String stuScore;//作业名称
    @TableField(exist = false)
    private String pfbz;//评分标准
    @TableField(exist = false)
    private String sturead;//评分标准是否允许学生查看
    @TableField(exist = false)
    private String ywid;//业务id
    @TableField(exist = false)
    private String stuId;//学生作业临时id

}
