package org.jeecg.modules.kc.zyInfoStudent.entity;

import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.jeecgframework.poi.excel.annotation.Excel;
import org.springframework.format.annotation.DateTimeFormat;

import java.io.Serializable;

/**
 * @Description: 教学大纲
 * @Author: jeecg-boot
 * @Date:   2024-05-11
 * @Version: V1.0
 */
@Data
@Accessors(chain = true)
@EqualsAndHashCode(callSuper = false)
public class ZyInfoStudentSys implements Serializable {
    private static final long serialVersionUID = 1L;

    private String id;

    @Excel(name = "学期学年", width = 15)
    private String xnxq;
    @Excel(name = "课程名称", width = 15)
    private String kcmc;
    @Excel(name = "授课教师", width = 15)
    private String skjs;
    @Excel(name = "作业名称", width = 15)
    private String title;
    @Excel(name = "学生姓名", width = 15)
    private String stuName;
    @Excel(name = "学号", width = 15)
    private String stuNo;
    @Excel(name = "作业状态", width = 15)
    private String status;
    @JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd")
    @DateTimeFormat(pattern="yyyy-MM-dd")
    @Excel(name = "发布时间", width = 15)
    private java.util.Date publishTime;

    @Excel(name = "网络相似率", width = 15)
    private String wwxsl;
    @Excel(name = "网络是否通过", width = 15)
    private String wwsftg;
    @Excel(name = "作业相似率", width = 15)
    private String nwxsl;
    @Excel(name = "作业是否通过", width = 15)
    private String nwsftg;
    @Excel(name = "aigc相似率", width = 15)
    private String aigcxsl;
    @Excel(name = "aigc是否通过", width = 15)
    private String aigcsftg;
    @Excel(name = "校内相似率", width = 15)
    private String xnxsl;
    @Excel(name = "校内是否通过", width = 15)
    private String xnsftg;

    @Excel(name = "成绩", width = 15)
    private String score;

    private String kcbh;
    private String kkdw;
    private String filePath;
    private String pdfPath;

    private String jgh;
    private String ywId;

    private String wwcc;
    private String nwcc;
    private String aigccc;
    private String xncc;

}
