package org.jeecg.modules.kc.zyInfoStudent.service.impl;

import cn.hutool.core.io.FileUtil;
import cn.hutool.core.util.RandomUtil;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.xkcoding.http.HttpUtil;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.apache.shiro.SecurityUtils;
import org.jeecg.common.constant.CommonConstant;
import org.jeecg.common.system.vo.LoginUser;
import org.jeecg.common.util.DateUtils;
import org.jeecg.common.util.SFTPUtil;
import org.jeecg.common.util.SftpConfig;
import org.jeecg.common.util.SpringContextHolder;
import org.jeecg.modules.kc.kcWechatSendLog.entity.KcWechatSendLog;
import org.jeecg.modules.kc.ktgl.entity.KcKechengbiao;
import org.jeecg.modules.kc.ktgl.service.IKcKechengbiaoService;
import org.jeecg.modules.kc.wjxWjxx.service.IWjxWjxxService;
import org.jeecg.modules.kc.zyCcjg.entity.ZyCcjg;
import org.jeecg.modules.kc.zyCcjg.mapper.ZyCcjgMapper;
import org.jeecg.modules.kc.zyInfo.entity.ZyInfo;
import org.jeecg.modules.kc.zyInfo.entity.ZyXzryInfo;
import org.jeecg.modules.kc.zyInfo.service.IZyInfoService;
import org.jeecg.modules.kc.zyInfoScjl.entity.ZyInfoScjl;
import org.jeecg.modules.kc.zyInfoScjl.service.IZyInfoScjlService;
import org.jeecg.modules.kc.zyInfoStudent.entity.ZyInfoStudent;
import org.jeecg.modules.kc.zyInfoStudent.entity.ZyInfoStudentSys;
import org.jeecg.modules.kc.zyInfoStudent.entity.ZyInfoStudentXbkhcl;
import org.jeecg.modules.kc.zyInfoStudent.mapper.ZyInfoStudentMapper;
import org.jeecg.modules.kc.zyInfoStudent.service.IZyInfoStudentService;
import org.jeecg.modules.tools.Global;
import org.jeecg.modules.tools.dbsdkfzpt.RestTemplateUtils;
import org.jeecg.modules.tools.office.pdf.PDFUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.test.annotation.Rollback;
import org.springframework.web.client.RestTemplate;

import javax.activation.MimetypesFileTypeMap;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.transaction.Transactional;
import java.io.*;
import java.net.HttpURLConnection;
import java.net.URL;
import java.nio.charset.StandardCharsets;
import java.text.SimpleDateFormat;
import java.util.*;
import java.util.zip.ZipEntry;
import java.util.zip.ZipOutputStream;

/**
 * @Description: 学生提交作业
 * @Author: jeecg-boot
 * @Date: 2024-05-06
 * @Version: V1.0
 */
@Slf4j
@Service
public class ZyInfoStudentServiceImpl extends ServiceImpl<ZyInfoStudentMapper, ZyInfoStudent> implements IZyInfoStudentService {

    @Autowired
    private IZyInfoService zyInfoService;

    @Autowired
    private ZyCcjgMapper zyCcjgMapper;

    @Autowired
    private IKcKechengbiaoService kcKechengbiaoService;

    @Autowired
    private IWjxWjxxService wjxWjxxService;

    @Autowired
    SftpConfig sftpConfig;

    private static String uploadpath;

    @Value("${jeecg.path.upload}")
    public void setUploadPath(String uploadPath) {
        this.uploadpath = uploadPath;
    }

    @Value(value = "${jeecg.uploadType}")
    private String uploadType;

    private static String weipuId;

    @Value("${weipu.userId}")
    public void setWeipuId(String weipuId) {
        this.weipuId = weipuId;
    }


    private static String weipuKey;

    @Value("${weipu.userKey}")
    public void setWeipuKey(String weipuKey) {
        this.weipuKey = weipuKey;
    }

    @Value(value = "${jeecg.path.webapp}")
    private String downloadpath;


    @Value("${jeecg.path.upload}")
    private String upLoadPath;

    @Autowired
    private IZyInfoScjlService zyInfoScjlService;


    @Override
    public boolean save(ZyInfoStudent zyInfoStudent) {
        baseMapper.insert(zyInfoStudent);

        return true;
    }

    @Override
    public void deleteMainId(String id) {
        baseMapper.deleteMainId(id);
    }

    @Override
    public boolean updateById(ZyInfoStudent zyInfoStudent, HttpServletResponse response) {
        baseMapper.updateById(zyInfoStudent);
        return true;
    }

    @Override
    public void editFabu(ZyInfoStudent zyInfoStudent) {
        baseMapper.updateById(zyInfoStudent);
    }

    @Override
    public IPage<ZyInfoStudent> cdxxlist(Page<ZyInfoStudent> page, QueryWrapper<ZyInfoStudent> queryWrapper) {
        return baseMapper.cdxxlist(page, queryWrapper);
    }

    @Override
    public List<ZyInfoStudent> getCcjg(ZyInfoStudent zyInfoStudent) {
        return baseMapper.getCcjg(zyInfoStudent);
    }

    @Override
    public void fabuBatch(List<String> asList) {
        for (int i = 0; i < asList.size(); i++) {
            ZyInfoStudent zyInfoStudent = new ZyInfoStudent();
            zyInfoStudent.setId(asList.get(i));
            zyInfoStudent.setScoreFabu("1");
            baseMapper.updateById(zyInfoStudent);
        }
    }

    @Override
    public IPage<ZyInfoStudentSys> sysList(Page<ZyInfoStudentSys> page, QueryWrapper<ZyInfoStudentSys> queryWrapper, ZyInfoStudentSys zyInfoStudentSys) {
        return baseMapper.sysList(page, queryWrapper, zyInfoStudentSys);
    }

    @Override
    public List<ZyInfoStudentSys> exportSysXls(QueryWrapper<ZyInfoStudentSys> queryWrapper, ZyInfoStudentSys zyInfoStudentSys) {
        return baseMapper.exportSysXls(queryWrapper, zyInfoStudentSys);
    }

    @Override
    public boolean stuWpKsjc(ZyInfoStudent zyInfoStudent, HttpServletResponse response) {
        String fileName = getFileName(zyInfoStudent.getFilePath(), response);
        zyInfoStudent.setFilePath(fileName);
        System.out.println("----------------1---------------------" + zyInfoStudent.getStuId());
        if (StringUtils.isEmpty(zyInfoStudent.getStuId())) {
            LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
            QueryWrapper<ZyInfoStudent> queryWrapper = new QueryWrapper<>();
            queryWrapper.eq("a.main_id", zyInfoStudent.getId());
            queryWrapper.eq("a.create_by", sysUser.getUsername());
            List<ZyInfoStudent> list1 = baseMapper.selectList(queryWrapper);
            zyInfoStudent = list1.get(0);
        } else {
            zyInfoStudent = baseMapper.selectById(zyInfoStudent.getStuId());
        }

        System.out.println("----------------2---------------------" + zyInfoStudent);
        ZyInfo zyInfo = zyInfoService.getById(zyInfoStudent.getMainId());
        System.out.println("----------------3---------------------" + zyInfo);


//        String rwbh = zyInfo.getRwbh();
//        QueryWrapper<KcKechengbiao> kcKechengbiaoQueryWrapper = new QueryWrapper<>();
//        kcKechengbiaoQueryWrapper.eq("xqxn",zyInfo.getXnxq());
//        kcKechengbiaoQueryWrapper.eq("rwbh",rwbh);
//        kcKechengbiaoQueryWrapper.last("limit 1");
//        KcKechengbiao kcKechengbiao = kcKechengbiaoService.getOne(kcKechengbiaoQueryWrapper);
        String cateid = zyInfo.getId() + "" + zyInfo.getTitle();
        String catename = zyInfo.getTitle();
        zyInfoStudent.setCateid(cateid);
        zyInfoStudent.setCatename(catename);

        System.out.println("----------------4---------------------");
        //删除维普已经提交的文档
        delweipulunwen(zyInfoStudent, response);

        System.out.println("----------------5---------------------");

        //外网查重及提交检测
        if (StringUtils.equals(zyInfo.getWwcc(), "true")) {
            wwccSave(zyInfoStudent, response);
        }
        //内网查重及提交检测
        if (StringUtils.equals(zyInfo.getNwcc(), "true")) {
            nwccSave(zyInfoStudent, response);
        }
        //aigc查重及提交检测
        if (StringUtils.equals(zyInfo.getAigccc(), "true")) {
            aigcSave(zyInfoStudent, response);
        }
        //校内查重及提交检测
        if (StringUtils.equals(zyInfo.getXncc(), "true")) {
            zyInfoStudent.setCateid("DBSDQXZYBDK001");
            zyInfoStudent.setCatename("东北师大全校作业比对库");
            xnccSave(zyInfoStudent, "1", response);//提交比对
//        }else{
//            zyInfoStudent.setCateid("DBSDQXZYBDK001");
//            zyInfoStudent.setCatename("东北师大全校作业比对库");
//            xnccSave(zyInfoStudent,"0",response);//不提交比对
        }
        System.out.println("----------------6---------------------");
        return true;
    }

    @Override
    public IPage<ZyInfoStudent> getHpxxList(Page<ZyInfoStudent> page, QueryWrapper<ZyInfoStudent> queryWrapper, String zyStuId) {
        return baseMapper.getHpxxList(page, queryWrapper, zyStuId);
    }

    @Override
    public void batchKhcl(List<String> asList) {
        for (int i = 0; i < asList.size(); i++) {
            ZyInfoStudent zyInfoStudent = new ZyInfoStudent();
            zyInfoStudent.setId(asList.get(i));
            zyInfoStudent.setSfsckhcl("1");
            baseMapper.updateById(zyInfoStudent);
        }
    }

    @Override
    public IPage<ZyInfoStudent> getList2(Page<ZyInfoStudent> page, QueryWrapper<ZyInfoStudent> queryWrapper) {
        return baseMapper.getList2(page, queryWrapper);
    }

    @Override
    public List<ZyInfoStudent> getDocNoPdfList() {
        List<ZyInfoStudent> ybtkblist = baseMapper.getDocNoPdfList();
        for(ZyInfoStudent zyInfoStudent:ybtkblist){
            try {
                Global global = SpringContextHolder.getBean(Global.class);
                FileUtil.mkdir(global.getContractDickPath());
                //六位随机数
                String r = RandomUtil.randomNumbers(6);
                String dd = DateUtils.formatDate(new Date(),"yyyyMMddHHmmss")+r;
                String docPath = upLoadPath+ File.separator+ zyInfoStudent.getFilePath();
                String namePath = dd + ".pdf";
                String pdfPath = global.getContractDickPath() + namePath;
                System.out.println("filPath:"+zyInfoStudent.getFilePath());
                System.out.println("docPath:"+docPath);
                System.out.println("pdfPath:"+pdfPath);

                PDFUtil.office2PDF(docPath,pdfPath);
                zyInfoStudent.setPdfPath("contract/"+namePath);
                zyInfoStudent.setPublishTime(new Date());
                baseMapper.updateById(zyInfoStudent);
            } catch (Exception e) {
                throw new RuntimeException(e);
            }
        }
        return ybtkblist;
    }

    //校内查重批量提交
    @Override
    public List<ZyInfoStudent> xnccBatchWeipu(ZyInfoStudent zyInfoStudent, HttpServletResponse response) {


        ZyInfo zyinfo = zyInfoService.getById(zyInfoStudent.getId());
        if (zyinfo != null && StringUtils.equals(zyinfo.getSfcc(), "1") && StringUtils.equals(zyinfo.getXncc(), "true")) {
            QueryWrapper<ZyInfoStudent> queryWrapper = new QueryWrapper<>();
            queryWrapper.eq("a.main_id", zyInfoStudent.getId());
            queryWrapper.isNotNull("a.file_path");
            List<ZyInfoStudent> list = baseMapper.selectList(queryWrapper);
            for (ZyInfoStudent par : list) {
                par.setCateid("DBSDQXZYBDK001");
                par.setCatename("东北师大全校作业比对库");
                xnccUpdate(par, "1", response);//提交比对
            }
        }


        return new ArrayList<>();
    }

    @Override
    public List<ZyInfoStudent> cxccByZyId(ZyInfoStudent zyInfoStudent2) {
        return baseMapper.cxccByZyId(zyInfoStudent2);
    }

    @Override
    public ZyInfoStudent scccjg(ZyInfoStudent zyInfoStudent, HttpServletRequest req, HttpServletResponse response) {
        ZyInfoStudent zyInfoStudent1 = baseMapper.selectById(zyInfoStudent.getId());
        return null;
    }

    @Override
    @Transactional
    public void batchZyinfoKhcl(String ids) {

        try {
            String token = wjxWjxxService.getAccessToken();//获取东北师大开放平台token
            System.out.println("=======================================");
            System.out.println("token:" + token);
            System.out.println("=======================================");
            if (org.jeecg.common.util.text.StringUtils.isNotEmpty(token)) {//判断如果token不为空则继续操作

                String idsList[] = ids.split(",");
                String yyyy = DateUtils.formatDate(new Date(), "yyyy");
                String mm = DateUtils.formatDate(new Date(), "MM");
                if (idsList.length > 0) {
                    for (String zyId : idsList) {
                        ZyInfo zyInfo = zyInfoService.getById(zyId);


                        //判断没有上传考核材料的数据，才进行上传，否则不上传
                        if (zyInfo != null && !org.jeecg.common.util.text.StringUtils.equals("1", zyInfo.getSfsckhcl())) {
                            QueryWrapper<KcKechengbiao> kcKechengbiaoQueryWrapper = new QueryWrapper<>();
                            kcKechengbiaoQueryWrapper.eq("rwbh", zyInfo.getRwbh());
                            kcKechengbiaoQueryWrapper.eq("jgh", zyInfo.getCreateBy());
                            kcKechengbiaoQueryWrapper.eq("xqxn", zyInfo.getXnxq());
                            kcKechengbiaoQueryWrapper.last("limit 1");
                            KcKechengbiao kcKechengbiao = kcKechengbiaoService.getOne(kcKechengbiaoQueryWrapper);


                            //调用师大接口将数据上传
                            String interfaceUrl = "https://intf.nenu.edu.cn/api/bd-api/post/JW_FXCJXMB";
                            List<Map<String, String>> paramsList = new ArrayList<>();
                            Map<String, String> paramMap = new HashMap<>();
                            paramMap.put("CJR", zyInfo.getCreateBy());//创建人
                            paramMap.put("TEABH", zyInfo.getCreateBy());//教工号
                            if (StringUtils.equals(zyInfo.getZyLeixing(), "0")) {
                                paramMap.put("FXCJMC", "课程作业" + zyInfo.getSort());//分项成绩名称
                                paramMap.put("FXCJLXMC", "0");//分项成绩类型
                            } else {
                                paramMap.put("FXCJMC", "期末考试" + zyInfo.getSort());//分项成绩名称
                                paramMap.put("FXCJLXMC", "1");//分项成绩类型
                            }
                            paramMap.put("TEADM", zyInfo.getCreateBy());//教工代码
                            paramMap.put("TEAXM", kcKechengbiao.getSkjs());//教师姓名
                            paramMap.put("FXCJBH", zyInfo.getId());//分项成绩编号
                            paramMap.put("XNXQMC", kcKechengbiao.getXnxq());//学年学期
                            if(StringUtils.isNotBlank(zyInfo.getContent())){
                                zyInfo.setContent(zyInfo.getContent().replaceAll("'","‘"));
                            }
                            paramMap.put("ZYYQ", zyInfo.getContent());//作业要求
                            paramMap.put("CJSJ", DateUtils.formatDate(zyInfo.getCreateTime(), "yyyy-MM-dd"));//创建时间
                            paramMap.put("FXCJBL", zyInfo.getScore());//比例，成绩占比
                            paramMap.put("KCMC", kcKechengbiao.getKcmc());//课程名称
                            paramMap.put("KCRWDM", zyInfo.getRwbh());//开课任务编号
                            if(StringUtils.isNotBlank(zyInfo.getPfbz())){
                                zyInfo.setPfbz(zyInfo.getPfbz().replaceAll("'","‘"));
                            }
                            paramMap.put("PFBZ", zyInfo.getPfbz());//评分标准
                            paramMap.put("FXCJDM", zyInfo.getId());//主键
//                        paramMap.put("OPERATE_STATUS","i");//操作状态
                            paramsList.add(paramMap);
                            String data = RestTemplateUtils.post(interfaceUrl, token, paramsList, MediaType.APPLICATION_JSON_UTF8, String.class);
                            System.out.println("=======================================");
                            System.out.println("data:" + data);
                            System.out.println("=======================================");


                            QueryWrapper<ZyInfoStudent> queryWrapper = new QueryWrapper<>();
                            queryWrapper.eq("a.main_id", zyId);
//                             queryWrapper.isNotNull("a.file_path");
                            List<ZyInfoStudent> list = baseMapper.selectList(queryWrapper);


                             List<Map<String, String>> paramsList2 =new ArrayList<>();
                             for (ZyInfoStudent zyInfoStudentPar2 : list) {
                                     if (StringUtils.isNotEmpty(zyInfoStudentPar2.getFilePath())) {
                                        //上传作业文件
                                         Map<String, String> uploadMap = SFTPUtil.upload(sftpConfig, upLoadPath + "/" + zyInfoStudentPar2.getFilePath(), yyyy + "/" + mm + "/" + zyInfo.getRwbh() + "/" + zyInfoStudentPar2.getFilePath().replace("temp/", "/"));
                                         System.out.println("=======================================");
                                         System.out.println("uploadMap:"+uploadMap);
                                         System.out.println("=======================================");
                                         if (StringUtils.equals(uploadMap.get("code"), "0")) {
                                             zyInfoStudentPar2.setFwqPath(uploadMap.get("data"));
                                         }
                                     }

                                if (StringUtils.isNotEmpty(zyInfoStudentPar2.getPyFilePath())) {
                                    //上传评阅附件
                                    Map<String, String> uploadMap2 = SFTPUtil.upload(sftpConfig, upLoadPath + "/" + zyInfoStudentPar2.getPyFilePath(), yyyy + "/" + mm + "/" + zyInfo.getRwbh() + "/" + zyInfoStudentPar2.getPyFilePath().replace("temp/", "/"));
                                    if (StringUtils.equals(uploadMap2.get("code"), "0")) {
                                        zyInfoStudentPar2.setPyFwqFilePath(uploadMap2.get("data"));
                                    }
                                }

                                zyInfoStudentPar2.setSfsckhcl("1");
                                zyInfoStudentPar2.setKhclTime(new Date());
                                baseMapper.updateById(zyInfoStudentPar2);

                                ZyInfoScjl zyInfoScjl = new ZyInfoScjl();
                                zyInfoScjl.setZyId(zyInfo.getId());
                                zyInfoScjl.setZyName(zyInfo.getTitle());
                                zyInfoScjl.setZyLeixing(zyInfo.getZyLeixing());
                                zyInfoScjl.setZyZb(zyInfo.getScore());
                                zyInfoScjl.setJgh(kcKechengbiao.getJgh());
                                zyInfoScjl.setSkjs(kcKechengbiao.getSkjs());
                                zyInfoScjl.setSkdd(kcKechengbiao.getSkdd());
                                zyInfoScjl.setKkdw(kcKechengbiao.getKkdw());
                                zyInfoScjl.setKkdwid(kcKechengbiao.getKkdwid());
                                zyInfoScjl.setKcxz(kcKechengbiao.getKcxz());
                                zyInfoScjl.setXnxq(zyInfo.getXnxq());
                                zyInfoScjl.setFilePath(zyInfoStudentPar2.getFwqPath());
                                zyInfoScjl.setStudentNo(zyInfoStudentPar2.getCreateBy());
                                zyInfoScjl.setStudentName(zyInfoStudentPar2.getStudentName());
                                zyInfoScjlService.save(zyInfoScjl);

                                Map<String, String> paramMap2 = new HashMap<>();
                                paramMap2.put("CJ", zyInfoStudentPar2.getZzdf() + "");//成绩
                                paramMap2.put("CJR", zyInfoStudentPar2.getCreateBy());//创建人
                                paramMap2.put("CJSJ", DateUtils.formatDate(zyInfoStudentPar2.getCreateTime(), "yyyy-MM-dd"));//创建时间
                                paramMap2.put("KCRWDM", zyInfo.getRwbh());//开课任务编号
                                paramMap2.put("KCMC", kcKechengbiao.getKcmc());//课程名称
                                if (StringUtils.equals(zyInfo.getZyLeixing(), "0")) {
                                    paramMap2.put("FXCJMC", "课程作业" + zyInfo.getSort());//分项成绩名称
                                } else {
                                    paramMap2.put("FXCJMC", "期末考试" + zyInfo.getSort());//分项成绩名称
                                }
                                paramMap2.put("TEAXM", kcKechengbiao.getSkjs());//教师姓名
                                paramMap2.put("XSXM", zyInfoStudentPar2.getStudentName());//学生姓名
                                paramMap2.put("KID", zyInfoStudentPar2.getId());//主键
                                paramMap2.put("XSBH", zyInfoStudentPar2.getCreateBy());//学号
                                paramMap2.put("FXCJBH", zyInfoStudentPar2.getMainId());//分项成绩编号
                                paramMap2.put("PATH", zyInfoStudentPar2.getFwqPath());//附件路径
                                paramMap2.put("TEABH", zyInfo.getCreateBy());//教工号
//                        paramMap2.put("OPERATE_STATUS","i");//操作状态
                                paramsList2.add(paramMap2);
//                                     }
//                                 }
                            }

                            System.out.println("=======================================");
                            System.out.println("paramsList2:" + paramsList2);
                            System.out.println("=======================================");
                            //调用师大接口进行上传
                            String interfaceUrl2 = "https://intf.nenu.edu.cn/api/bd-api/post/JW_FXXSCJMX";
                            String data2 = RestTemplateUtils.post(interfaceUrl2, token, paramsList2, MediaType.APPLICATION_JSON_UTF8, String.class);
                            System.out.println("=======================================");
                            System.out.println("data2:" + data2);
                            System.out.println("=======================================");

                            zyInfo.setSfsckhcl("1");
                            zyInfo.setSfsckhclTime(new Date());
                            zyInfoService.updateById(zyInfo);

                        }


                    }
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    @Override
    public List<ZyInfoStudent> cxtjByJccsbz() {
        return baseMapper.cxtjByJccsbz();
    }

    @Override
    public void sysWpKsjc(ZyInfoStudent zyInfoStudent, HttpServletResponse response) {
        String fileName = getFileName(zyInfoStudent.getFilePath(), response);
        zyInfoStudent.setFilePath(fileName);

        ZyInfo zyInfo = zyInfoService.getById(zyInfoStudent.getMainId());


        String cateid = zyInfo.getId() + "" + zyInfo.getTitle();
        String catename = zyInfo.getTitle();
        zyInfoStudent.setCateid(cateid);
        zyInfoStudent.setCatename(catename);

        //删除维普已经提交的文档
        delSysweipulunwen(zyInfoStudent, response);


        //外网查重及提交检测
        if(StringUtils.equals(zyInfo.getWwcc(),"true")){
            wwccSave(zyInfoStudent,response);
        }
        //内网查重及提交检测
        if(StringUtils.equals(zyInfo.getNwcc(),"true")){
            nwccSave(zyInfoStudent,response);
        }
        //aigc查重及提交检测
        if (StringUtils.equals(zyInfo.getAigccc(), "true")) {
            aigcSave(zyInfoStudent, response);
        }
        //校内查重及提交检测
        if(StringUtils.equals(zyInfo.getXncc(),"true")){
            zyInfoStudent.setCateid("DBSDQXZYBDK001");
            zyInfoStudent.setCatename("东北师大全校作业比对库");
            xnccSave(zyInfoStudent,"1",response);//提交比对
        }
    }

    @Override
    public List<JSONObject> getWpSycccs() {

        List<JSONObject> list = new ArrayList<>();

        String url = "https://vims.fanyu.com/toole/jianceorgan/papercheckcount.aspx";
        JSONObject object = getSycs(url, "1");
        object.put("name", "外网检测");

        JSONObject object2 = getSycs(url, "3");
        object2.put("name", "AIGC检测");

        list.add(object);
        list.add(object2);
        return list;
    }

    @Override
    public void getWpcccs() {
        String url = "https://vims.fanyu.com/toole/jianceorgan/papercheckcount.aspx";
        //获取外网检测剩余查重次数
        JSONObject object = getSycs(url, "1");
        int wwremaincount = object.getIntValue("remaincount");
        if (wwremaincount <= 200) {
            KcWechatSendLog kcWechatSendLog = new KcWechatSendLog();
            kcWechatSendLog.setOpenid("2016900057");
            kcWechatSendLog.setYtkcs("维普【外网检测】查重次数不足，剩余" + wwremaincount + "次，请及时充值！");
            sendWxmessage(kcWechatSendLog);
        }

        //获取AIGC检测剩余查重次数
        JSONObject object2 = getSycs(url, "3");
        int aigcremaincount = object2.getIntValue("remaincount");
        if (aigcremaincount <= 200) {
            KcWechatSendLog kcWechatSendLog = new KcWechatSendLog();
            kcWechatSendLog.setOpenid("2016900057");
            kcWechatSendLog.setYtkcs("维普【AIGC检测】查重次数不足，剩余" + aigcremaincount + "次，请及时充值！");
            sendWxmessage(kcWechatSendLog);
        }
    }

    @Override
    public List<ZyInfoStudent> getZyStuId(ZyXzryInfo zyXzryInfo) {
        return baseMapper.getZyStuId(zyXzryInfo);
    }

    @Override
    public List<ZyInfoStudent> getZyStuIdById(ZyXzryInfo zyXzryInfo) {
        return baseMapper.getZyStuIdById(zyXzryInfo);
    }

    @Override
    public void sckhclxb() {
        QueryWrapper<ZyInfoStudent> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("a.sfsckhcl", "1");
//        queryWrapper.eq("a.id", "1865917324597338113");
        queryWrapper.apply("a.fwq_path is null and a.file_path is not null");
        List<ZyInfoStudent> list = baseMapper.selectList(queryWrapper);

        String yyyy = DateUtils.formatDate(new Date(), "yyyy");
        String mm = DateUtils.formatDate(new Date(), "MM");
        for(ZyInfoStudent zyInfoStudentPar2 :list){
            Map<String, String> uploadMap = SFTPUtil.upload(sftpConfig, upLoadPath + "/" + zyInfoStudentPar2.getFilePath(), yyyy + "/" + mm + "/xbkhcl/" + zyInfoStudentPar2.getFilePath().replace("temp/", "/"));
            System.out.println("=======================================");
            System.out.println("uploadMap:"+uploadMap);
            System.out.println("=======================================");
            if (StringUtils.equals(uploadMap.get("code"), "0")) {
                zyInfoStudentPar2.setFwqPath(uploadMap.get("data"));
            }
            baseMapper.updateById(zyInfoStudentPar2);

            ZyInfoStudentXbkhcl zyInfoStudentXbkhcl = new ZyInfoStudentXbkhcl();
            zyInfoStudentXbkhcl.setKid(zyInfoStudentPar2.getId());
            zyInfoStudentXbkhcl.setPath(zyInfoStudentPar2.getFwqPath());
            baseMapper.insertXbkhcl(zyInfoStudentXbkhcl);

        }



    }

    @Override
    public String downStudentZip(ZyInfoStudent zyInfoStudent) {
        QueryWrapper<ZyInfoStudent> zyInfoStudentQueryWrapper = new QueryWrapper<>();
        zyInfoStudentQueryWrapper.eq("a.main_id", zyInfoStudent.getMainId());
        zyInfoStudentQueryWrapper.isNotNull("a.file_path");
        List<ZyInfoStudent> list = baseMapper.selectList(zyInfoStudentQueryWrapper);
        if(list.size()==0){
            return "0";
        }
        //六位随机数
        String title = DateUtils.formatDate(new Date(),"yyyyMMddHHmmss")+RandomUtil.randomNumbers(6);
        String downTemp = "downloadZyinfoTemp";
        String downTitle = downTemp+"/学生作业附件"+title+".zip";
        String zipFileName = getUpLoadPath(downTitle); // 输出ZIP文件的名称

        try {
            File localDirFile = new File(getUpLoadPath(downTemp));
            // 判断本地目录是否存在，不存在需要新建各级目录
            if (!localDirFile.exists()) {
                localDirFile.mkdirs();
            }
            // 创建ZipOutputStream来写入ZIP文件
            try (ZipOutputStream zos = new ZipOutputStream(new FileOutputStream(zipFileName))) {

                for (ZyInfoStudent par : list) {
                    // 创建FileInputStream来读取文件
                    try (FileInputStream fis = new FileInputStream(getUpLoadPath(par.getFilePath()))) {
                        // 创建ZipEntry，它将作为文件在ZIP归档中的条目
                        ZipEntry zipEntry = new ZipEntry(par.getFilePath());
                        zos.putNextEntry(zipEntry);

                        // 将文件内容写入到ZipOutputStream中
                        byte[] bytes = new byte[1024];
                        int length;
                        while ((length = fis.read(bytes)) >= 0) {
                            zos.write(bytes, 0, length);
                        }
                        zos.closeEntry(); // 关闭当前条目，以便写入下一个文件
                    }catch (Exception e){
                        e.printStackTrace();
                    }
                }
            }
            System.out.println("Files have been zipped successfully.");
        } catch (IOException e) {
            e.printStackTrace();
        }
        return downTitle;
    }



    public JSONObject getSycs(String url, String type) {
        Map<String, String> textMap = new HashMap<String, String>();
        //可以设置多个input的name，value
        String sign = getSign();
        textMap.put("sign", sign);
        textMap.put("userid", weipuId);
        textMap.put("type", type);
        String contentType = "";//image/png
        String ret = formUpload(url, textMap, null, contentType);
        log.error("1-------->" + ret);
        JSONObject object = JSONObject.parseObject(ret);
        return object;
    }

    private void delweipulunwen(ZyInfoStudent zyInfoStudent, HttpServletResponse response) {
        zyInfoStudent.setQueryType("0");//外网查重数据
        String paperids = baseMapper.getWpFile(zyInfoStudent);
        if (StringUtils.isNotEmpty(paperids)) {
            String url = "https://vims.fanyu.com/toole/jianceorgan/paperdel.aspx";
            delWpFile(url, paperids, response);
        }
        zyInfoStudent.setQueryType("1");//内网查重数据-作业内查重
        Map<String, String> paperids1 = baseMapper.getXfwWpFile(zyInfoStudent);
        if (paperids1 != null) {
            String dataids = paperids1.get("paperid");
            String bdkbs = paperids1.get("bdkbs");
            String url = "https://vims.fanyu.com/toole/smallcheck/delData";
            delXfwWpFile(url, bdkbs, dataids, response);
        }
        zyInfoStudent.setQueryType("3");//内网查重数据-全校内比对
        Map<String, String> paperids3 = baseMapper.getXfwWpFile(zyInfoStudent);
        if (paperids3 != null) {
            String dataids = paperids3.get("paperid");
            String bdkbs = paperids3.get("bdkbs");
            String url = "https://vims.fanyu.com/toole/smallcheck/delData";
            delXfwWpFile(url, bdkbs, dataids, response);
        }
        zyInfoStudent.setQueryType("2");//aigc查重数据
        String paperids2 = baseMapper.getWpFile(zyInfoStudent);
        if (StringUtils.isNotEmpty(paperids2)) {
            String url = "https://vims.fanyu.com/tool/AIGCCheck/paperDel";
            delWpFile(url, paperids2, response);
        }
        zyCcjgMapper.deleteByZystuid(zyInfoStudent.getId());
    }

    private void delSysweipulunwen(ZyInfoStudent zyInfoStudent, HttpServletResponse response) {
//        zyInfoStudent.setQueryType("0");//外网查重数据
//        String paperids = baseMapper.getWpFile(zyInfoStudent);
//        if(StringUtils.isNotEmpty(paperids)){
//            String url = "https://vims.fanyu.com/toole/jianceorgan/paperdel.aspx";
//            delWpFile(url,paperids, response);
//        }
//        zyInfoStudent.setQueryType("1");//内网查重数据-作业内查重
//        Map<String,String> paperids1 = baseMapper.getXfwWpFile(zyInfoStudent);
//        if(paperids1 != null){
//            String dataids = paperids1.get("paperid");
//            String bdkbs = paperids1.get("bdkbs");
//            String url = "https://vims.fanyu.com/toole/smallcheck/delData";
//            delXfwWpFile(url,bdkbs,dataids, response);
//        }
//        zyInfoStudent.setQueryType("3");//内网查重数据-全校内比对
//        Map<String,String> paperids3 = baseMapper.getXfwWpFile(zyInfoStudent);
//        if(paperids3 != null){
//            String dataids = paperids3.get("paperid");
//            String bdkbs = paperids3.get("bdkbs");
//            String url = "https://vims.fanyu.com/toole/smallcheck/delData";
//            delXfwWpFile(url,bdkbs,dataids, response);
//        }
        zyInfoStudent.setQueryType("2");//aigc查重数据
        String paperids2 = baseMapper.getWpFile(zyInfoStudent);
        if (StringUtils.isNotEmpty(paperids2)) {
            String url = "https://vims.fanyu.com/tool/AIGCCheck/paperDel";
            delWpFile(url, paperids2, response);
        }
        zyCcjgMapper.deleteByZystuid(zyInfoStudent.getId());
    }

    //aigc提交
    private void aigcSave(ZyInfoStudent zyInfoStudent, HttpServletResponse response) {
        String url = "https://vims.fanyu.com/tool/AIGCCheck/paperSubmit";
        //文件路径，文件存在，不存在的话需要先下载下来
//        String fileName = downloadpath+"/"+ zyInfoStudent.getFilePath();
//        if(CommonConstant.UPLOAD_TYPE_LOCAL.equals(uploadType)) {
//            fileName = uploadpath+"/"+ zyInfoStudent.getFilePath();
//        }
        String fileName = uploadpath + "/" + zyInfoStudent.getFilePath();
        Map<String, String> textMap = new HashMap<String, String>();
        //可以设置多个input的name，value
        String sign = getSign();
        textMap.put("userid", weipuId);
        textMap.put("sign", sign);
        String titlePar = fileName.substring(fileName.lastIndexOf("/") + 1, fileName.length());
        String title = titlePar.split("_")[0];
        textMap.put("title", title);

        LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
        if(sysUser==null){
            sysUser.setUsername(zyInfoStudent.getCreateBy());
            sysUser.setRealname(zyInfoStudent.getStudentName());
        }
        textMap.put("number", sysUser.getUsername());
        textMap.put("author", sysUser.getRealname());
        //设置file的name，路径
        Map<String, String> fileMap = new HashMap<String, String>();
        fileMap.put("file", fileName);
        String contentType = "";//image/png
        String ret = formUpload(url, textMap, fileMap, contentType);
        log.info("aigc1-------->" + ret);
        log.error("aigcSave:ret-------->" + ret);
        JSONObject object = JSONObject.parseObject(ret);
        if ("true".equals(object.getString("success"))) {


            String listpaper = object.getString("listPaper");
            JSONArray jsonArray = (JSONArray) JSONArray.parse(listpaper);
            JSONObject object2 = jsonArray.getJSONObject(0);
            String paperid = object2.getString("paperid");
            log.info("2-------->" + paperid);

            ZyCcjg zyCcjg = new ZyCcjg();
            zyCcjg.setZyStuId(zyInfoStudent.getId());
            zyCcjg.setPaperid(paperid);
            zyCcjg.setCcType("2");//查重类型（0外网 1内网 2aigc）
            zyCcjg.setFilestateid("1");
            zyCcjgMapper.insert(zyCcjg);

            ZyInfoStudent zyInfoStudentUp = new ZyInfoStudent();
            zyInfoStudentUp.setId(zyInfoStudent.getId());
            zyInfoStudentUp.setAigcsftg("检测中");
            baseMapper.updateById(zyInfoStudentUp);
            //提交后直接开始检测
            String message = aigcKsjc(zyCcjg);
            log.info("21-------->" + message);
        } else {
            log.info("3-------->");

            ZyCcjg zyCcjg = new ZyCcjg();
            zyCcjg.setZyStuId(zyInfoStudent.getId());
            zyCcjg.setMessage(object.getString("message"));
            zyCcjg.setCcType("2");//查重类型（0外网 1内网 2aigc）
            zyCcjg.setFilestateid("3");
            zyCcjgMapper.insert(zyCcjg);
            ZyInfoStudent zyInfoStudentUp = new ZyInfoStudent();
            zyInfoStudentUp.setId(zyInfoStudent.getId());
            zyInfoStudentUp.setAigcsftg(object.getString("message"));
            baseMapper.updateById(zyInfoStudentUp);
        }
    }

    //aigc开始检测
    public String aigcKsjc(ZyCcjg zyCcjg) {

        String url = "https://vims.fanyu.com/tool/AIGCCheck/paperBeginCheck\n";
        //文件路径，文件存在，不存在的话需要先下载下来
        String paperid = zyCcjg.getPaperid();
        Map<String, String> textMap = new HashMap<String, String>();
        //可以设置多个input的name，value
        String sign = getSign();
        textMap.put("userid", weipuId);
        textMap.put("sign", sign);
        textMap.put("paperids", paperid);//资源id
        String contentType = "";//image/png
        Map<String, String> fileMap = new HashMap<String, String>();
        String ret = formUpload(url, textMap, fileMap, contentType);
        JSONObject object = JSONObject.parseObject(ret);
        String message = object.getString("message");
        return message;
    }

    //小范围提交（校园内网提交）
    private void nwccSave(ZyInfoStudent zyInfoStudent, HttpServletResponse response) {
        String url = "https://vims.fanyu.com/toole/smallcheck/submitData";
        //文件路径，文件存在，不存在的话需要先下载下来
//        String fileName = downloadpath+"/"+ zyInfoStudent.getFilePath();
//        if(CommonConstant.UPLOAD_TYPE_LOCAL.equals(uploadType)) {
//            fileName = uploadpath+"/"+ zyInfoStudent.getFilePath();
//        }
        String fileName = uploadpath + "/" + zyInfoStudent.getFilePath();
        Map<String, String> textMap = new HashMap<String, String>();
        String titlePar = fileName.substring(fileName.lastIndexOf("/") + 1, fileName.length());
        String title = titlePar.split("_")[0];
        //可以设置多个input的name，value
        String sign = getSign();
        LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
        if(sysUser==null){
            sysUser.setUsername(zyInfoStudent.getCreateBy());
            sysUser.setRealname(zyInfoStudent.getStudentName());
        }
        textMap.put("sign", sign);
        textMap.put("userid", weipuId);
        textMap.put("title", title);//标题
        textMap.put("author", sysUser.getRealname());//作者
        textMap.put("cateid", zyInfoStudent.getCateid());//范围库唯一标识
        textMap.put("catename", zyInfoStudent.getCatename());//范围库名称
        textMap.put("number", sysUser.getUsername());//学号
        //设置file的name，路径
        Map<String, String> fileMap = new HashMap<String, String>();
        fileMap.put("file", fileName);
        String contentType = "";//image/png
        String ret = formUpload(url, textMap, fileMap, contentType);
        log.error("nwccSave:ret-------->" + ret);
        JSONObject object = JSONObject.parseObject(ret);
        if ("true".equals(object.getString("success"))) {
            String listpaper = object.getString("datainfo");
            JSONObject object2 = JSON.parseObject(listpaper);
            String dataid = object2.getString("dataid");//资源id 后续提交比对/删除文档会试用

            ZyCcjg zyCcjg = new ZyCcjg();
            zyCcjg.setZyStuId(zyInfoStudent.getId());
            zyCcjg.setPaperid(dataid);
            zyCcjg.setCcType("1");//查重类型（0外网 1内网 2aigc）
            zyCcjg.setFilestateid("1");
            zyCcjg.setBdkbs(zyInfoStudent.getCateid());
            zyCcjgMapper.insert(zyCcjg);

            ZyInfoStudent zyInfoStudentUp = new ZyInfoStudent();
            zyInfoStudentUp.setId(zyInfoStudent.getId());
            zyInfoStudentUp.setNwsftg("检测中");
            baseMapper.updateById(zyInfoStudentUp);
            //提交后直接开始检测
            String message = xfwbdKsjc(zyCcjg, "1");
            log.info("21-------->" + message);
        } else {
            log.info("3-------->");
            ZyCcjg zyCcjg = new ZyCcjg();
            zyCcjg.setZyStuId(zyInfoStudent.getId());
            zyCcjg.setMessage(object.getString("message"));
            zyCcjg.setCcType("1");//查重类型（0外网 1内网 2aigc）
            zyCcjg.setFilestateid("3");
            zyCcjgMapper.insert(zyCcjg);
            ZyInfoStudent zyInfoStudentUp = new ZyInfoStudent();
            zyInfoStudentUp.setId(zyInfoStudent.getId());
            zyInfoStudentUp.setNwsftg(object.getString("message"));
            baseMapper.updateById(zyInfoStudentUp);
        }
    }

    //小范围提交（校园内网提交）
    private void xnccSave(ZyInfoStudent zyInfoStudent, String type, HttpServletResponse response) {
        String url = "https://vims.fanyu.com/toole/smallcheck/submitData";
        //文件路径，文件存在，不存在的话需要先下载下来
//        String fileName = downloadpath+"/"+ zyInfoStudent.getFilePath();
//        if(CommonConstant.UPLOAD_TYPE_LOCAL.equals(uploadType)) {
//            fileName = uploadpath+"/"+ zyInfoStudent.getFilePath();
//        }
        String fileName = uploadpath + "/" + zyInfoStudent.getFilePath();
        Map<String, String> textMap = new HashMap<String, String>();
        String titlePar = fileName.substring(fileName.lastIndexOf("/") + 1, fileName.length());
        String title = titlePar.split("_")[0];
        //可以设置多个input的name，value
        String sign = getSign();
        LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
        if(sysUser==null){
            sysUser.setUsername(zyInfoStudent.getCreateBy());
            sysUser.setRealname(zyInfoStudent.getStudentName());
        }
        textMap.put("sign", sign);
        textMap.put("userid", weipuId);
        textMap.put("title", title);//标题
        textMap.put("author", sysUser.getRealname());//作者
        textMap.put("cateid", zyInfoStudent.getCateid());//范围库唯一标识
        textMap.put("catename", zyInfoStudent.getCatename());//范围库名称
        textMap.put("number", sysUser.getUsername());//学号
        //设置file的name，路径
        Map<String, String> fileMap = new HashMap<String, String>();
        fileMap.put("file", fileName);
        String contentType = "";//image/png
        log.info("url--->" + url);
        log.info("textMap--->" + textMap);
        log.info("fileMap--->" + fileMap);
        String ret = formUpload(url, textMap, fileMap, contentType);
        log.error("xnccSave:ret-------->" + ret);
        JSONObject object = JSONObject.parseObject(ret);
        if ("true".equals(object.getString("success"))) {
            String listpaper = object.getString("datainfo");
            JSONObject object2 = JSON.parseObject(listpaper);
            String dataid = object2.getString("dataid");//资源id 后续提交比对/删除文档会试用

            //判断是否开始查重  1的时候进行查重，0不查重
            if (StringUtils.equals("1", type)) {
                ZyCcjg zyCcjg = new ZyCcjg();
                zyCcjg.setZyStuId(zyInfoStudent.getId());
                zyCcjg.setPaperid(dataid);
                zyCcjg.setCcType("3");//查重类型（0外网 1内网 2aigc）
                zyCcjg.setFilestateid("1");
                zyCcjg.setBdkbs(zyInfoStudent.getCateid());
                zyCcjgMapper.insert(zyCcjg);
                //提交后直接开始检测
                String message = xfwbdKsjc(zyCcjg, "0");
                log.info("21-------->" + message);
                ZyInfoStudent zyInfoStudentUp = new ZyInfoStudent();
                zyInfoStudentUp.setId(zyInfoStudent.getId());
                zyInfoStudentUp.setXnsftg("检测中");
                baseMapper.updateById(zyInfoStudentUp);
            }

        } else {
            log.info("3-------->");
            ZyCcjg zyCcjg = new ZyCcjg();
            zyCcjg.setZyStuId(zyInfoStudent.getId());
            zyCcjg.setMessage(object.getString("message"));
            zyCcjg.setCcType("3");//查重类型（0外网 1内网 2aigc）
            zyCcjg.setFilestateid("3");
            zyCcjgMapper.insert(zyCcjg);
            ZyInfoStudent zyInfoStudentUp = new ZyInfoStudent();
            zyInfoStudentUp.setId(zyInfoStudent.getId());
            zyInfoStudentUp.setAigcsftg(object.getString("message"));
            baseMapper.updateById(zyInfoStudentUp);
        }
    }


    /**
     * 主要用于教师发布评分后，统一发往维普留存比对库
     *
     * @param zyInfoStudent
     * @param type
     * @param response
     */
    private void xnccUpdate(ZyInfoStudent zyInfoStudent, String type, HttpServletResponse response) {

        ZyCcjg zyCcjg = new ZyCcjg();
        try {
            QueryWrapper<ZyCcjg> zyCcjgQueryWrapper = new QueryWrapper<>();
            zyCcjgQueryWrapper.eq("zy_stu_id", zyInfoStudent.getId());
            zyCcjgQueryWrapper.eq("create_by", zyInfoStudent.getCreateBy());
            zyCcjgQueryWrapper.eq("cc_type", "3");
            zyCcjg = zyCcjgMapper.selectOne(zyCcjgQueryWrapper);
            if (zyCcjg.getPaperid() != null) {
                String dataids = zyCcjg.getPaperid();
                String bdkbs = zyCcjg.getBdkbs();
                String url2 = "https://vims.fanyu.com/toole/smallcheck/delData";
                delXfwWpFile(url2, bdkbs, dataids, null);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }

        String url = "https://vims.fanyu.com/toole/smallcheck/submitData";
        //文件路径，文件存在，不存在的话需要先下载下来
        String fileName = uploadpath + "/" + zyInfoStudent.getFilePath();
        Map<String, String> textMap = new HashMap<String, String>();
        String titlePar = fileName.substring(fileName.lastIndexOf("/") + 1, fileName.length());
        String title = titlePar.split("_")[0];
        //可以设置多个input的name，value
        String sign = getSign();
        LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
        if(sysUser==null){
            sysUser.setUsername(zyInfoStudent.getCreateBy());
            sysUser.setRealname(zyInfoStudent.getStudentName());
        }
        textMap.put("sign", sign);
        textMap.put("userid", weipuId);
        textMap.put("title", title);//标题
        textMap.put("author", sysUser.getRealname());//作者
        textMap.put("cateid", zyInfoStudent.getCateid());//范围库唯一标识
        textMap.put("catename", zyInfoStudent.getCatename());//范围库名称
        textMap.put("number", sysUser.getUsername());//学号
        //设置file的name，路径
        Map<String, String> fileMap = new HashMap<String, String>();
        fileMap.put("file", fileName);
        String contentType = "";//image/png
        log.info("url--->" + url);
        log.info("textMap--->" + textMap);
        log.info("fileMap--->" + fileMap);
        String ret = formUpload(url, textMap, fileMap, contentType);
        log.info("ret--->" + ret);
        JSONObject object = JSONObject.parseObject(ret);
        if ("true".equals(object.getString("success"))) {
            String listpaper = object.getString("datainfo");
            JSONObject object2 = JSON.parseObject(listpaper);
            String dataid = object2.getString("dataid");//资源id 后续提交比对/删除文档会试用
            zyCcjg.setPaperid(dataid);
            zyCcjgMapper.updateById(zyCcjg);
        }
    }

    //小范围对比开始检测
    public String xfwbdKsjc(ZyCcjg zyCcjg, String sfpj) {
        String url = "https://vims.fanyu.com/toole/smallcheck/beginCheck";
        //文件路径，文件存在，不存在的话需要先下载下来
        String paperid = zyCcjg.getPaperid();
        Map<String, String> textMap = new HashMap<String, String>();
        //可以设置多个input的name，value
        String sign = getSign();
        textMap.put("sign", sign);
        textMap.put("userid", weipuId);
        textMap.put("cateid", zyCcjg.getBdkbs());//比对库的id
        textMap.put("dataids", paperid);//资源id
        textMap.put("exclude", sfpj);//是否排已(1:排已, 0:不排已)
        String contentType = "";//image/png
        Map<String, String> fileMap = new HashMap<String, String>();
        String ret = formUpload(url, textMap, fileMap, contentType);
        JSONObject object = JSONObject.parseObject(ret);
        String message = object.getString("message");
        return message;
    }

    //外网查重提交方法
    private String wwccSave(ZyInfoStudent zyInfoStudent, HttpServletResponse response) {
        LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
        if(sysUser==null){
            sysUser.setUsername(zyInfoStudent.getCreateBy());
            sysUser.setRealname(zyInfoStudent.getStudentName());
        }
        String url = "https://vims.fanyu.com/toole/jianceorgan/papersubmit.aspx";
        //文件路径，文件存在，不存在的话需要先下载下来
//        String  fileName = downloadpath+"/"+ zyInfoStudent.getFilePath();
//        if(CommonConstant.UPLOAD_TYPE_LOCAL.equals(uploadType)) {
//            fileName = uploadpath+"/"+ zyInfoStudent.getFilePath();
//        }
        String fileName = uploadpath + "/" + zyInfoStudent.getFilePath();
        Map<String, String> textMap = new HashMap<String, String>();
        //可以设置多个input的name，value
        String sign = getSign();
        textMap.put("sign", sign);
        textMap.put("userid", weipuId);
        String titlePar = fileName.substring(fileName.lastIndexOf("/") + 1, fileName.length());
        String title = titlePar.split("_")[0];
        textMap.put("title", title);
        textMap.put("number", sysUser.getUsername());
        textMap.put("author", sysUser.getRealname());
        //设置file的name，路径
        Map<String, String> fileMap = new HashMap<String, String>();
        fileMap.put("file", fileName);
        String contentType = "";//image/png
        log.error("fileMap-------->"+fileMap);
        log.error("url-------->"+url);
        log.error("textMap-------->"+textMap);
        log.error("contentType-------->"+contentType);
        String ret = formUpload(url, textMap, fileMap,contentType);
        log.error("1-------->"+ret);
        JSONObject object= JSONObject.parseObject(ret);
        if("true".equals(object.getString("success"))){
            String listpaper = object.getString("listpaper");
            JSONArray jsonArray = (JSONArray) JSONArray.parse(listpaper);
            JSONObject object2 = jsonArray.getJSONObject(0);
            String paperid = object2.getString("paperid");
            log.info("2-------->" + paperid);
            ZyCcjg zyCcjg = new ZyCcjg();
            zyCcjg.setZyStuId(zyInfoStudent.getId());
            zyCcjg.setPaperid(paperid);
            zyCcjg.setCcType("0");//查重类型（0外网 1内网 2aigc）
            zyCcjg.setFilestateid("1");
            zyCcjgMapper.insert(zyCcjg);
            //提交后直接开始检测
            String message = wwKsjc(zyCcjg);
            log.info("21-------->" + message);
            ZyInfoStudent zyInfoStudentUp = new ZyInfoStudent();
            zyInfoStudentUp.setId(zyInfoStudent.getId());
            zyInfoStudentUp.setWwsftg("检测中");
            baseMapper.updateById(zyInfoStudentUp);
            return message;
        } else {
            log.info("3-------->");
            ZyCcjg zyCcjg = new ZyCcjg();
            zyCcjg.setZyStuId(zyInfoStudent.getId());
            zyCcjg.setMessage(object.getString("message"));
            zyCcjg.setCcType("0");//查重类型（0外网 1内网 2aigc）
            zyCcjg.setFilestateid("3");
            zyCcjgMapper.insert(zyCcjg);
            ZyInfoStudent zyInfoStudentUp = new ZyInfoStudent();
            zyInfoStudentUp.setId(zyInfoStudent.getId());
            zyInfoStudentUp.setWwsftg(object.getString("message"));
            baseMapper.updateById(zyInfoStudentUp);
            return "false";
        }
    }

    //外网开始检测
    public String wwKsjc(ZyCcjg zyCcjg) {
        String url = "https://vims.fanyu.com/toole/jianceorgan/paperbegincheck.aspx";
        //文件路径，文件存在，不存在的话需要先下载下来
        String paperid = zyCcjg.getPaperid();
        Map<String, String> textMap = new HashMap<String, String>();
        //可以设置多个input的name，value
        String sign = getSign();
        textMap.put("userid", weipuId);
        textMap.put("sign", sign);
        textMap.put("paperids", paperid);//资源id
        String contentType = "";//image/png
        Map<String, String> fileMap = new HashMap<String, String>();
        String ret = formUpload(url, textMap, fileMap, contentType);
        JSONObject object = JSONObject.parseObject(ret);
        String message = object.getString("message");
        return message;
    }

    private String getFileName(String imgPath, HttpServletResponse response) {
        String fileName = "";
        if (CommonConstant.UPLOAD_TYPE_LOCAL.equals(uploadType)) {
            fileName = imgPath;
            log.info("1111111111111111----------->");
        } else if (CommonConstant.UPLOAD_TYPE_SFTP.equals(uploadType)) {
            log.info("22222222222222----------->");
            InputStream inputStream = null;
            OutputStream outputStream = null;
            try {
                int index = imgPath.lastIndexOf("/");
                String path = "temp";
                if (index != -1) {
                    path = imgPath.substring(0, index);
                }

                log.info("path----------->" + path);
                Map<String, String> map = SFTPUtil.download(sftpConfig, imgPath, getDownloadPath(path));
                log.info("map----------->" + map);
//                if(!map.get("code").equals("0")){
//                    response.setStatus(404);
////                    throw new RuntimeException(map.get("msg"));
//                }
                String localFilePath = map.get("fileName");
//                File file = new File(localFilePath);
//                if(!file.exists()){
//                    response.setStatus(404);
////                    throw new RuntimeException("文件["+imgPath+"]不存在..");
//                }
//                log.info("localFilePath----------->"+localFilePath);
//                // 设置强制下载不打开
//                response.setContentType("application/force-download");
//                response.addHeader("Content-Disposition", "attachment;fileName=" + new String(file.getName().getBytes("UTF-8"),"iso-8859-1"));
//                inputStream = new BufferedInputStream(new FileInputStream(localFilePath));
//                outputStream = response.getOutputStream();
//                byte[] buf = new byte[1024];
//                int len;
//                while ((len = inputStream.read(buf)) > 0) {
//                    outputStream.write(buf, 0, len);
//                }
//                response.flushBuffer();
                fileName = localFilePath;
                log.info("fileName----------->" + fileName);
            } catch (Exception e) {
                log.info("catch----------->" + e);
//                    e.printStackTrace();
            } finally {
                SFTPUtil.disChannel();
                SFTPUtil.disSession();
                if (inputStream != null) {
                    try {
                        inputStream.close();
                    } catch (IOException e) {
                        log.error(e.getMessage(), e);
                    }
                }
                if (outputStream != null) {
                    try {
                        outputStream.close();
                    } catch (IOException e) {
//                    log.error(e.getMessage(), e);
                    }
                }
            }
        } else {
            log.info("333333333333333----------->");
        }
        return fileName;
    }

    private String delWpFile(String url, String paperids, HttpServletResponse response) {
//        String url = "https://vims.fanyu.com/toole/jianceorgan/paperdel.aspx";
        Map<String, String> textMap = new HashMap<String, String>();
        //可以设置多个input的name，value
        String sign = getSign();
        textMap.put("sign", sign);
        textMap.put("userid", weipuId);
        textMap.put("paperids", paperids);//文档paperid集合,多个请用英文逗号隔开
        String contentType = "";//image/png
        String ret = formUpload(url, textMap, null, contentType);
        log.error("1-------->" + ret);
        JSONObject object = JSONObject.parseObject(ret);
        if ("true".equals(object.getString("success"))) {
            String message = object.getString("message");
            log.info("2-------->" + message);
            return "success";
        } else {
            return "false";
        }
    }

    private String delXfwWpFile(String url, String cateid, String paperids, HttpServletResponse response) {
//        String url = "https://vims.fanyu.com/toole/jianceorgan/paperdel.aspx";
        Map<String, String> textMap = new HashMap<String, String>();
        //可以设置多个input的name，value
        String sign = getSign();
        textMap.put("sign", sign);
        textMap.put("userid", weipuId);
        textMap.put("cateid", cateid);
        textMap.put("dataid", paperids);//文档paperid集合,多个请用英文逗号隔开
        String contentType = "";//image/png
        String ret = formUpload(url, textMap, null, contentType);
        log.error("1-------->" + ret);
        JSONObject object = JSONObject.parseObject(ret);
        if ("true".equals(object.getString("success"))) {
            String message = object.getString("message");
            log.info("2-------->" + message);
            return "success";
        } else {
            return "false";
        }
    }

    /**
     * 获取文件真实路径
     *
     * @param path
     * @return
     */
    private String getDownloadPath(String path) {
        String filePath = "";
        if (org.jeecg.common.util.text.StringUtils.isEmpty(path)) {
            return "";
        }
        int idx = path.indexOf(downloadpath);
        if (idx == -1) {
            filePath = downloadpath + File.separator + path;
        } else {
            filePath = path;
        }
        return filePath;
    }


    /**
     * 获取文件真实路径
     *
     * @param path
     * @return
     */
    private String getUpLoadPath(String path) {
        String filePath = "";
        if (org.jeecg.common.util.text.StringUtils.isEmpty(path)) {
            return "";
        }
        int idx = path.indexOf(upLoadPath);
        if (idx == -1) {
            filePath = upLoadPath + File.separator + path;
        } else {
            filePath = path;
        }
        return filePath;
    }

    //生成sign
    public static String getSign() {
        String userid = weipuId;
        String key = weipuKey;
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH");
        String time = sdf.format(new Date());
        String md5Text = userid + key + time;
        String sign = org.springframework.util.DigestUtils.md5DigestAsHex((md5Text).getBytes()).toLowerCase();
        return sign;
    }

    //推送轻求
    public static String formUpload(String urlStr, Map<String, String> textMap, Map<String, String> fileMap, String contentType) {
        String res = "";
        HttpURLConnection conn = null;
        // boundary就是request头和上传文件内容的分隔符
        String BOUNDARY = "---------------------------123821742118716";
        try {
            URL url = new URL(urlStr);
            conn = (HttpURLConnection) url.openConnection();
            conn.setConnectTimeout(60000);
            conn.setReadTimeout(30000);
            conn.setDoOutput(true);
            conn.setDoInput(true);
            conn.setUseCaches(false);
            conn.setRequestMethod("POST");
            conn.setRequestProperty("Connection", "Keep-Alive");
            conn.setRequestProperty("Content-Type", "multipart/form-data; boundary=" + BOUNDARY);
            OutputStream out = new DataOutputStream(conn.getOutputStream());
            // text
            if (textMap != null) {
                StringBuffer strBuf = new StringBuffer();
                Iterator iter = textMap.entrySet().iterator();
                while (iter.hasNext()) {
                    Map.Entry entry = (Map.Entry) iter.next();
                    String inputName = (String) entry.getKey();
                    String inputValue = (String) entry.getValue();
                    if (inputValue == null) {
                        continue;
                    }
                    strBuf.append("\r\n").append("--").append(BOUNDARY).append("\r\n");
                    strBuf.append("Content-Disposition: form-data; name=\"" + inputName + "\"\r\n\r\n");
                    strBuf.append(inputValue);
                }
                out.write(strBuf.toString().getBytes(StandardCharsets.UTF_8));
            }
            // file
            if (fileMap != null) {
                Iterator iter = fileMap.entrySet().iterator();
                while (iter.hasNext()) {
                    Map.Entry entry = (Map.Entry) iter.next();
                    String inputName = (String) entry.getKey();
                    String inputValue = (String) entry.getValue();
                    if (inputValue == null) {
                        continue;
                    }
                    File file = new File(inputValue);
                    String filename = file.getName();

                    //没有传入文件类型，同时根据文件获取不到类型，默认采用application/octet-stream
                    contentType = new MimetypesFileTypeMap().getContentType(file);
                    //contentType非空采用filename匹配默认的图片类型
                    if (!"".equals(contentType)) {
                        if (filename.endsWith(".png")) {
                            contentType = "image/png";
                        } else if (filename.endsWith(".jpg") || filename.endsWith(".jpeg") || filename.endsWith(".jpe")) {
                            contentType = "image/jpeg";
                        } else if (filename.endsWith(".gif")) {
                            contentType = "image/gif";
                        } else if (filename.endsWith(".ico")) {
                            contentType = "image/image/x-icon";
                        }
                    }
                    if (contentType == null || "".equals(contentType)) {
                        contentType = "application/octet-stream";
                    }
                    StringBuffer strBuf = new StringBuffer();
                    strBuf.append("\r\n").append("--").append(BOUNDARY).append("\r\n");
                    strBuf.append("Content-Disposition: form-data; name=\"" + inputName + "\"; filename=\"" + filename + "\"\r\n");
                    strBuf.append("Content-Type:" + contentType + "\r\n\r\n");
                    out.write(strBuf.toString().getBytes());
                    DataInputStream in = new DataInputStream(new FileInputStream(file));
                    int bytes = 0;
                    byte[] bufferOut = new byte[1024];
                    while ((bytes = in.read(bufferOut)) != -1) {
                        out.write(bufferOut, 0, bytes);
                    }
                    in.close();
                }
            }
            byte[] endData = ("\r\n--" + BOUNDARY + "--\r\n").getBytes();
            out.write(endData);
            out.flush();
            out.close();
            // 读取返回数据
            StringBuffer strBuf = new StringBuffer();
            BufferedReader reader = new BufferedReader(new InputStreamReader(conn.getInputStream()));
            String line = null;
            while ((line = reader.readLine()) != null) {
                strBuf.append(line).append("\n");
            }
            res = strBuf.toString();
            reader.close();
            reader = null;
        } catch (Exception e) {
            log.info("发送POST请求出错。" + urlStr);
            e.printStackTrace();
        } finally {
            if (conn != null) {
                conn.disconnect();
                conn = null;
            }
        }
        return res;
    }

    // appId
    private static final String appId = "wx031697a8ca09a5ce";//东师

    private static final String agentid = "1000065";//
    // appIdSecret
    private static final String appIdSecret = "6Qhnge3xfzAQMDX2TcjEyE0vUGP96hP9OTYUsYBze2Y";//东师

    //微信通知点击后跳转的页面
    private static final String domainTo = "https://smartedu.nenu.edu.cn";

    public void sendWxmessage(KcWechatSendLog kcWechatSendLog) {
        String openId = kcWechatSendLog.getOpenid();//曹老师账号
        System.out.println("openId:" + openId + "");
        if (org.apache.commons.lang3.StringUtils.isNotEmpty(openId)) {
            try {
                String urlToken = "https://qyapi.weixin.qq.com/cgi-bin/gettoken?corpid=" + appId + "&corpsecret=" + appIdSecret;
                System.out.println("urlToken：  " + urlToken);
                String res = HttpUtil.get(urlToken);
                JSONObject jsonObjectToken = JSONObject.parseObject(res);
                System.out.println("jsonObjectToken：{}" + jsonObjectToken);
                String accessToken = jsonObjectToken.getString("access_token");
                System.out.println("accessToken：{}" + accessToken);

                // 微信的基础accessToken
                String url = "https://qyapi.weixin.qq.com/cgi-bin/message/send?access_token=" + accessToken;
                Map<String, Object> sendMag = new HashMap<>();

//				 1、xx老师，你好，您本学期（2023秋）听课要求为：5次，当前实际听课次数：3次，请尽快完成本学期的听课任务。
                String html = kcWechatSendLog.getYtkcs();
                html = html;
                sendMag.put("content", html);//授课老师推送内容
                RestTemplate restTemplate = new RestTemplate();
                //拼接base参数
                Map<String, Object> sendBody = new HashMap<>();
                sendBody.put("touser", openId);                // openId
                sendBody.put("msgtype", "text");               // 消息类型，此时固定为：text
                sendBody.put("agentid", agentid);              // 企业id
                sendBody.put("text", sendMag);                //发送内容
                ResponseEntity<String> forEntity = restTemplate.postForEntity(url, sendBody, String.class);
                JSONObject jsonObject2 = JSONObject.parseObject(forEntity.getBody());
                System.out.println("jsonObject2 : " + jsonObject2);
                String messageCode = jsonObject2.getString("errcode");
                String msgId = jsonObject2.getString("msgid");
                System.out.println("messageCode : " + messageCode + ", msgId: " + msgId);
            } catch (Exception e) {
                e.printStackTrace();
            }
        } else {
        }
    }
}
