package org.jeecg.modules.kc.zyInfoStudentHp.controller;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.core.toolkit.StringUtils;
import org.apache.shiro.SecurityUtils;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.system.vo.LoginUser;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.kc.zyDbtx.entity.ZyDbtx;
import org.jeecg.modules.kc.zyDbtx.service.IZyDbtxService;
import org.jeecg.modules.kc.zyInfo.entity.ZyInfo;
import org.jeecg.modules.kc.zyInfo.service.IZyInfoService;
import org.jeecg.modules.kc.zyInfoStudent.entity.ZyInfoStudent;
import org.jeecg.modules.kc.zyInfoStudent.service.IZyInfoStudentService;
import org.jeecg.modules.kc.zyInfoStudentHp.entity.ZyInfoStudentHp;
import org.jeecg.modules.kc.zyInfoStudentHp.service.IZyInfoStudentHpService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecg.modules.kc.zyInfoStudentPcz.service.IZyInfoStudentPczService;
import org.jeecg.modules.tools.DictUtils;
import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

 /**
 * @Description: 学生成绩互评
 * @Author: jeecg-boot
 * @Date:   2024-07-29
 * @Version: V1.0
 */
@Api(tags="学生成绩互评")
@RestController
@RequestMapping("/zyInfoStudentHp/zyInfoStudentHp")
@Slf4j
public class ZyInfoStudentHpController extends JeecgController<ZyInfoStudentHp, IZyInfoStudentHpService> {
	@Autowired
	private IZyInfoStudentHpService zyInfoStudentHpService;
	 @Autowired
	 private IZyInfoService zyInfoService;
	 @Autowired
	 private IZyInfoStudentService zyInfoStudentService;
	 @Autowired
	 private IZyInfoStudentPczService zyInfoStudentPczService;
     @Autowired
     private DictUtils dictUtils;

	 @Autowired
	 private IZyDbtxService zyDbtxService;

	 /**
	 * 分页列表查询
	 *
	 * @param zyInfoStudentHp
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "学生成绩互评-分页列表查询")
	@ApiOperation(value="学生成绩互评-分页列表查询", notes="学生成绩互评-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<ZyInfoStudentHp>> queryPageList(ZyInfoStudentHp zyInfoStudentHp,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<ZyInfoStudentHp> queryWrapper = QueryGenerator.initQueryWrapper(zyInfoStudentHp, req.getParameterMap());
		Page<ZyInfoStudentHp> page = new Page<ZyInfoStudentHp>(pageNo, pageSize);
		IPage<ZyInfoStudentHp> pageList = zyInfoStudentHpService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param zyInfoStudentHp
	 * @return
	 */
	@AutoLog(value = "学生成绩互评-添加")
	@ApiOperation(value="学生成绩互评-添加", notes="学生成绩互评-添加")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody ZyInfoStudentHp zyInfoStudentHp) {
		zyInfoStudentHpService.save(zyInfoStudentHp);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param zyInfoStudentHp
	 * @return
	 */
	@AutoLog(value = "学生成绩互评-编辑")
	@ApiOperation(value="学生成绩互评-编辑", notes="学生成绩互评-编辑")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody ZyInfoStudentHp zyInfoStudentHp) {
		zyInfoStudentHpService.updateById(zyInfoStudentHp);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "学生成绩互评-通过id删除")
	@ApiOperation(value="学生成绩互评-通过id删除", notes="学生成绩互评-通过id删除")
	@RequiresPermissions("zyInfoStudentHp:zy_info_student_hp:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		zyInfoStudentHpService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "学生成绩互评-批量删除")
	@ApiOperation(value="学生成绩互评-批量删除", notes="学生成绩互评-批量删除")
	@RequiresPermissions("zyInfoStudentHp:zy_info_student_hp:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.zyInfoStudentHpService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "学生成绩互评-通过id查询")
	@ApiOperation(value="学生成绩互评-通过id查询", notes="学生成绩互评-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<ZyInfoStudentHp> queryById(@RequestParam(name="id",required=true) String id) {
		ZyInfoStudentHp zyInfoStudentHp = zyInfoStudentHpService.getById(id);
		if(zyInfoStudentHp==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(zyInfoStudentHp);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param zyInfoStudentHp
    */
    @RequiresPermissions("zyInfoStudentHp:zy_info_student_hp:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, ZyInfoStudentHp zyInfoStudentHp) {
        return super.exportXls(request, zyInfoStudentHp, ZyInfoStudentHp.class, "学生成绩互评");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("zyInfoStudentHp:zy_info_student_hp:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, ZyInfoStudentHp.class);
    }


	 @AutoLog(value = "学生成绩第一次互评-添加")
	 @ApiOperation(value="学生成绩第一次互评-添加", notes="学生成绩第一次互评-添加")
	 @PostMapping(value = "/saveOne")
	 public Result<String> saveOne(@RequestBody ZyInfoStudentHp zyInfoStudentHp) {

		 zyInfoStudentHp.setId(null);
		String zyStuId = zyInfoStudentHp.getZyStuId();
		if(StringUtils.isNotEmpty(zyStuId)){
			LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
			QueryWrapper<ZyInfoStudentHp> zyInfoStudentHpQueryWrapper = new QueryWrapper<>();
			zyInfoStudentHpQueryWrapper.eq("zy_stu_id",zyStuId);
			zyInfoStudentHpQueryWrapper.eq("stu_id",sysUser.getUsername());
			zyInfoStudentHpQueryWrapper.eq("ver_type","1");
			List<ZyInfoStudentHp> list = zyInfoStudentHpService.list(zyInfoStudentHpQueryWrapper);
			if(list.size()>0){
				return Result.error("您已经互评过此作业，不可重复互评");
			}else{
				zyInfoStudentHp.setVerType("1");
				zyInfoStudentHp.setStuId(sysUser.getUsername());
				zyInfoStudentHp.setStuName(sysUser.getRealname());
				zyInfoStudentHpService.save(zyInfoStudentHp);

				//createBy是被评学生的id
				//stuId 是评价学生的的id
				ZyInfoStudent zyInfoStudentPar = zyInfoStudentService.getById(zyStuId);
				ZyInfo zyInfo = zyInfoService.getById(zyInfoStudentPar.getMainId());

				//计算互评次数
				QueryWrapper<ZyInfoStudentHp> zyInfoStudentHpQueryWrapper2 = new QueryWrapper<>();
				zyInfoStudentHpQueryWrapper2.eq("zy_stu_id",zyStuId);
				List<ZyInfoStudentHp> list2 = zyInfoStudentHpService.list(zyInfoStudentHpQueryWrapper2);
				ZyInfoStudent zyInfoStudent = new ZyInfoStudent();
				zyInfoStudent.setHpcs(list2.size()+"");
				zyInfoStudent.setId(zyStuId);

				//计算互评分数
				if(list2.size() == 3){
					//三个数的平均分，去掉差值最大的，剩余两个取平均分
					int[] numbers = new int[3];
					int i=0;
					// 假设有一个整数数组numbers
					for(ZyInfoStudentHp par:list2){
						numbers[i] =(Integer.parseInt(par.getStuScore()));
						i++;
					}
					double averageWithoutOutlier = calculateAverageWithoutOutlier(numbers);

					zyInfoStudent.setXshpfs(String.format("%.1f",averageWithoutOutlier));
				}else if(list2.size() > 3){
					//去掉做高分和最低分 取平均值
					ArrayList<Integer> numbers = new ArrayList<>();
					// 假设有一个整数数组numbers
					for(ZyInfoStudentHp par:list2){
						numbers.add(Integer.parseInt(par.getStuScore()));
					}
					// 去掉最大值和最小值
					int max = Integer.MIN_VALUE;
					int min = Integer.MAX_VALUE;
					int sum = 0;
					for (int num : numbers) {
						max = Math.max(max, num);
						min = Math.min(min, num);
						sum += num;
					}
					sum -= max + min;

					// 计算平均值
					double average = (double) sum / (numbers.size() - 2);
					zyInfoStudent.setXshpfs(String.format("%.1f",average)+"");
				}
				//判断互评成绩是否为最终成绩
				if(StringUtils.equals(zyInfo.getSfzzcj(),"1") && list2.size()>=3){
					zyInfoStudent.setScore(zyInfoStudent.getXshpfs());
				}
				zyInfoStudentService.updateById(zyInfoStudent);

				Integer hpcjjl = Integer.parseInt(dictUtils.translateDictValue("hpcjsz","1"));

				//计算二次绩效奖励
				ZyInfo jspc = new ZyInfo();
				jspc.setId(zyInfoStudentPar.getMainId());
				jspc.setCreateBy(sysUser.getUsername());
				zyInfoStudentPczService.calculationPcz(jspc);


				//计算所有人的最终得分
				QueryWrapper<ZyInfoStudent> zyInfoStudentQueryWrapper2 = new QueryWrapper<>();
				zyInfoStudentQueryWrapper2.eq("a.main_id",zyInfoStudentPar.getMainId());
				zyInfoStudentQueryWrapper2.isNotNull("a.score");
				List<ZyInfoStudent> stulist = zyInfoStudentService.list(zyInfoStudentQueryWrapper2);
				for(ZyInfoStudent par:stulist){
					//计算绩效分数
					QueryWrapper<ZyInfoStudentHp> zyInfoStudentHpQueryWrapper3 = new QueryWrapper<>();
					zyInfoStudentHpQueryWrapper3.eq("main_id",par.getMainId());
					zyInfoStudentHpQueryWrapper3.eq("stu_id",par.getCreateBy());
					List<ZyInfoStudentHp> list3 = zyInfoStudentHpService.list(zyInfoStudentHpQueryWrapper3);
					if(list3.size()>4){
						if(StringUtils.isNotEmpty(par.getScore())){
							double hpcj = Double.parseDouble(par.getScore());//获取教师的互评成绩
							double jxcj = hpcj * hpcjjl / 100;
							par.setJxfs(String.format("%.1f",jxcj));
						}
					}else{
						par.setJxfs("");
					}
					//计算最终得分
					if(StringUtils.isNotEmpty(par.getScore())){
						double hpcj = Double.parseDouble(par.getScore());//获取教师的互评成绩
						double jxcj = 0.0;//获取教师的互评成绩
						if(StringUtils.isNotEmpty(par.getJxfs())){
							jxcj = Double.parseDouble(par.getJxfs());//获取教师的互评成绩
						}
						double jxcj2 = 0.0;//获取教师的互评成绩
						if(StringUtils.isNotEmpty(par.getJxfs2())){
							jxcj2 = Double.parseDouble(par.getJxfs2());//获取教师的互评成绩
						}
						double zzcj = hpcj + jxcj + jxcj2;
						if(zzcj>100){
							zzcj = 100;
						}
						par.setZzdf(String.format("%.1f",zzcj));
					}
					zyInfoStudentService.updateById(par);
				}


				QueryWrapper<ZyInfoStudentHp> zyInfoStudentHpQueryWrapper3 = new QueryWrapper<>();
				zyInfoStudentHpQueryWrapper3.eq("main_id",zyInfoStudentPar.getMainId());
				zyInfoStudentHpQueryWrapper3.eq("stu_id",sysUser.getUsername());
				List<ZyInfoStudentHp> list3 = zyInfoStudentHpService.list(zyInfoStudentHpQueryWrapper3);
				if(list3.size()>4){
					UpdateWrapper<ZyDbtx> zyDbtx = new UpdateWrapper<>();
					zyDbtx.set("flag","1");
					zyDbtx.eq("main_id",zyInfoStudentPar.getMainId());
					zyDbtx.eq("create_by",sysUser.getUsername());
					zyDbtx.eq("type","0");
					zyDbtxService.update(zyDbtx);
				}
				return Result.OK("互评成功！");
			}
		}else{
			return Result.error("互评失败！");
		}

	 }

	 public static double calculateAverageWithoutOutlier(int[] scores) {
		 Arrays.sort(scores); // 将分数数组排序
		 int n = scores.length;

		 //三个数的计算方式
		 double bsum = 0;
		 double baverage;
		 for (int i = 0; i < n; i++) {
			 bsum += scores[i];
		 }
		 baverage = bsum / n;
		 double c = 0;//分差
		 int djg = 0;
		 for (int i = 0; i < n; i++){
			 if(c<Math.abs(baverage - scores[i])){
				 c = Math.abs(baverage - scores[i]);
				 djg = i;
			 }
		 }
		 int[] scores2 = removeElement(scores, djg);
		 double sum = 0;
		 double average;
		 // 去掉一个最高或最低的分数
		 sum = (scores2[0] + scores2[1]);

		 // 计算剩下分数的平均值
		 average = (sum / 2);

		 return average;
	 }
	 public static int[] removeElement(int[] array, int n) {
		 if (array == null || n < 0 || n >= array.length) {
			 throw new IllegalArgumentException("Invalid input");
		 }

		 int[] newArray = new int[array.length - 1];
		 System.arraycopy(array, 0, newArray, 0, n);
		 System.arraycopy(array, n + 1, newArray, n, array.length - n - 1);
		 return newArray;
	 }

	 @AutoLog(value = "学生成绩第二次互评-添加")
	 @ApiOperation(value="学生成绩第二次互评-添加", notes="学生成绩第二次互评-添加")
	 @PostMapping(value = "/saveTwo")
	 public Result<String> saveTwo(@RequestBody ZyInfoStudentHp zyInfoStudentHp) {
		 String zyStuId = zyInfoStudentHp.getZyStuId();
		 if(StringUtils.isNotEmpty(zyStuId)){
			 LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
			 QueryWrapper<ZyInfoStudentHp> zyInfoStudentHpQueryWrapper = new QueryWrapper<>();
			 zyInfoStudentHpQueryWrapper.eq("zy_stu_id",zyStuId);
			 zyInfoStudentHpQueryWrapper.eq("stu_id",sysUser.getUsername());
			 zyInfoStudentHpQueryWrapper.eq("ver_type","2");
			 List<ZyInfoStudentHp> list = zyInfoStudentHpService.list(zyInfoStudentHpQueryWrapper);
			 if(list.size()>0){
				 return Result.error("您已经互评过此作业，不可重复互评");
			 }else{
				 zyInfoStudentHp.setVerType("2");
				 zyInfoStudentHp.setStuId(sysUser.getUsername());
				 zyInfoStudentHp.setStuName(sysUser.getRealname());
				 zyInfoStudentHpService.save(zyInfoStudentHp);
				 return Result.OK("互评成功！");
			 }
		 }else{
			 return Result.error("互评失败！");
		 }
	 }


}
