package org.jeecg.modules.kc.zyInfoStudentPcz.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import org.jeecg.common.util.text.StringUtils;
import org.jeecg.modules.kc.zyInfo.entity.ZyInfo;
import org.jeecg.modules.kc.zyInfoStudent.entity.ZyInfoStudent;
import org.jeecg.modules.kc.zyInfoStudent.mapper.ZyInfoStudentMapper;
import org.jeecg.modules.kc.zyInfoStudentHp.entity.ZyInfoStudentHp;
import org.jeecg.modules.kc.zyInfoStudentHp.service.IZyInfoStudentHpService;
import org.jeecg.modules.kc.zyInfoStudentPcz.entity.ZyInfoStudentPcz;
import org.jeecg.modules.kc.zyInfoStudentPcz.mapper.ZyInfoStudentPczMapper;
import org.jeecg.modules.kc.zyInfoStudentPcz.service.IZyInfoStudentPczService;
import org.jeecg.modules.tools.DictUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;

import java.util.List;

/**
 * @Description: 作业偏差值
 * @Author: jeecg-boot
 * @Date:   2024-07-31
 * @Version: V1.0
 */
@Service
public class ZyInfoStudentPczServiceImpl extends ServiceImpl<ZyInfoStudentPczMapper, ZyInfoStudentPcz> implements IZyInfoStudentPczService {
    @Autowired
    private IZyInfoStudentHpService zyInfoStudentHpService;
    @Autowired
    private ZyInfoStudentMapper zyInfoStudentMapper;

    private final DictUtils dictUtils;

    public ZyInfoStudentPczServiceImpl(DictUtils dictUtils) {
        this.dictUtils = dictUtils;
    }

    @Override
    public void calculationPcz(ZyInfo jspc) {

        //删除所有方差作业数据
        baseMapper.delete(new QueryWrapper<ZyInfoStudentPcz>().eq("zy_id",jspc.getId()));

        //修改原来的绩效数据 将原来的第二次绩效修改成0
        zyInfoStudentMapper.updateJxfs2(jspc);

        //查询方差数据并重新插入到数据库中
        List<ZyInfoStudentPcz> list = baseMapper.getPczList(jspc);
        for (ZyInfoStudentPcz zyInfoStudentPcz : list) {
            baseMapper.insert(zyInfoStudentPcz);
        }

        //查询方差数据并按照方差数据的大小进行排序
        List<ZyInfoStudentPcz> list2 = baseMapper.selectList(new QueryWrapper<ZyInfoStudentPcz>().eq("zy_id",jspc.getId()).orderByAsc("pcz -0"));
        //获取百分比有效数据
        String bfb = dictUtils.translateDictValue("hpcjsz","2");
        String bfbFs = dictUtils.translateDictValue("hpcjsz","3");
        //计算有多少数据是需要给绩效的
        Double bfb2 =Double.parseDouble((Double.parseDouble(bfb)  * list2.size()  / 100)+"");
        int rounded = roundToInteger(bfb2);

        for (int i = 0; i < rounded; i++) {
            ZyInfoStudentPcz zyInfoStudentPcz = list2.get(i);

            //查询学生对应的数据
            QueryWrapper<ZyInfoStudent> wrapper = new QueryWrapper<>();
            wrapper.eq("a.main_id",zyInfoStudentPcz.getZyId());
            wrapper.eq("a.create_by",zyInfoStudentPcz.getStuId());
            wrapper.last("limit 1");
            ZyInfoStudent zyInfoStudent = zyInfoStudentMapper.selectOne(wrapper);

            QueryWrapper<ZyInfoStudentHp> zyInfoStudentHpQueryWrapper3 = new QueryWrapper<>();
            zyInfoStudentHpQueryWrapper3.eq("main_id",zyInfoStudentPcz.getZyId());
            zyInfoStudentHpQueryWrapper3.eq("stu_id",zyInfoStudentPcz.getStuId());
            List<ZyInfoStudentHp> list3 = zyInfoStudentHpService.list(zyInfoStudentHpQueryWrapper3);
            if(list3.size()>4){
                if(com.baomidou.mybatisplus.core.toolkit.StringUtils.isNotEmpty(zyInfoStudent.getScore())){
                    String score = zyInfoStudent.getScore();
                    if(StringUtils.isEmpty(score)){
                        score = "0";
                    }
                    Double jxfs2 = Double.parseDouble(score) * Double.parseDouble(bfbFs) /100;
                    zyInfoStudent.setJxfs2(String.format("%.1f",jxfs2));//第二次绩效
                    zyInfoStudentMapper.updateById(zyInfoStudent);
                }
            }
        }
    }
    public static int roundToInteger(double value) {
        return (int) Math.round(value);
    }

}
