package org.jeecg.modules.kc.zyJxdg.controller;

import cn.hutool.core.io.FileUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.core.incrementer.DefaultIdentifierGenerator;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.StringUtils;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.apache.shiro.SecurityUtils;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.jeecg.common.system.base.controller.JeecgController;
import org.jeecg.common.system.vo.LoginUser;
import org.jeecg.common.util.DateUtils;
import org.jeecg.modules.kc.config.entity.KcExportConfigTpkwcqkjzglx;
import org.jeecg.modules.kc.config.service.IKcExportConfigTpkwcqkjzglxService;
import org.jeecg.modules.kc.kcSysConfig.entity.KcSysConfig;
import org.jeecg.modules.kc.kcSysConfig.service.IKcSysConfigService;
import org.jeecg.modules.kc.ktgl.entity.KcKechengbiao;
import org.jeecg.modules.kc.ktgl.service.IKcKechengbiaoService;
import org.jeecg.modules.kc.zyJxdg.entity.ZyJxdg;
import org.jeecg.modules.kc.zyJxdg.entity.ZyJxdgSys;
import org.jeecg.modules.kc.zyJxdg.service.IZyJxdgService;
import org.jeecg.modules.system.service.impl.SysBaseApiImpl;
import org.jeecg.modules.tools.Global;
import org.jeecg.modules.tools.office.pdf.PDFUtil;
import org.jeecg.modules.zyk.entity.ZykInfo;
import org.jeecg.modules.zyk.service.IZykService;
import org.jeecg.modules.zyk.utils.WjlxEnum;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.File;
import java.util.Arrays;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * @Description: 教学大纲
 * @Author: jeecg-boot
 * @Date:   2024-05-11
 * @Version: V1.0
 */
@Api(tags="教学大纲")
@RestController
@RequestMapping("/zyJxdg/zyJxdg")
@Slf4j
public class ZyJxdgController extends JeecgController<ZyJxdg, IZyJxdgService> {
	@Autowired
	private IZyJxdgService zyJxdgService;

	@Autowired
	private IKcKechengbiaoService kcKechengbiaoService;

	@Value("${jeecg.path.upload}")
	private String upLoadPath;
	@Autowired
	private IZykService zykService;


	@Value(value="${jeecg.uploadType}")
	private String uploadType;


	@Autowired
	private Global global;

	@Autowired
	private SysBaseApiImpl sysBaseApi;
	@Autowired
	private IKcExportConfigTpkwcqkjzglxService kcExportConfigTpkwcqkjzglxService;

	@Autowired
	private IKcSysConfigService kcSysConfigService;

	 /**
	 * 分页列表查询
	 *
	 * @param zyJxdg
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "教学大纲-分页列表查询")
	@ApiOperation(value="教学大纲-分页列表查询", notes="教学大纲-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<ZyJxdg>> queryPageList(ZyJxdg zyJxdg,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
		QueryWrapper<ZyJxdg> queryWrapper = new QueryWrapper<ZyJxdg>();
		queryWrapper.eq("create_by",sysUser.getUsername());
		queryWrapper.eq(StringUtils.isNotEmpty(zyJxdg.getKcbh()),"kcbh",zyJxdg.getKcbh());
		queryWrapper.ne(StringUtils.isNotEmpty(zyJxdg.getRwbh()),"rwbh",zyJxdg.getRwbh());
		queryWrapper.ne(StringUtils.isNotEmpty(zyJxdg.getXqxn()),"xqxn",zyJxdg.getXqxn());
		queryWrapper.orderByDesc("create_time");
		Page<ZyJxdg> page = new Page<ZyJxdg>(pageNo, pageSize);
		IPage<ZyJxdg> pageList = zyJxdgService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param zyJxdg
	 * @return
	 */
	@AutoLog(value = "教学大纲-添加")
	@ApiOperation(value="教学大纲-添加", notes="教学大纲-添加")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody ZyJxdg zyJxdg) {

		if(StringUtils.isNotEmpty(zyJxdg.getFilePath())){

			String nameLast = zyJxdg.getFilePath().substring(zyJxdg.getFilePath().lastIndexOf(".")+1);
			if(StringUtils.equals("pdf",nameLast)){
				zyJxdg.setPdfPath(zyJxdg.getFilePath());
			}else{
				if(StringUtils.equals("local",global.uploadType)){
					FileUtil.mkdir(global.getContractDickPath());
					String dd = DateUtils.formatDate(new Date(),"yyyyMMddHHmmss");
					String docPath = upLoadPath+ File.separator+ zyJxdg.getFilePath();
					String namePath = dd + ".pdf";
					String pdfPath = global.getContractDickPath() + namePath;
					PDFUtil.office2PDF(docPath,pdfPath);
					zyJxdg.setPdfPath("contract/"+namePath);
				}else if(StringUtils.equals("sftp",global.uploadType)){

				}
			}
		}else if(StringUtils.isNotEmpty(zyJxdg.getJxrlFilePath())){

			String nameLast = zyJxdg.getJxrlFilePath().substring(zyJxdg.getJxrlFilePath().lastIndexOf(".")+1);
			if(StringUtils.equals("pdf",nameLast)){
				zyJxdg.setJxrlPdfPath(zyJxdg.getJxrlFilePath());
			}else{

				if(StringUtils.equals("local",global.uploadType)){
					FileUtil.mkdir(global.getContractDickPath());
					String dd = DateUtils.formatDate(new Date(),"yyyyMMddHHmmss");
					String docPath = upLoadPath+ File.separator+ zyJxdg.getJxrlFilePath();
					String namePath = dd + ".pdf";
					String pdfPath = global.getContractDickPath() + namePath;
					PDFUtil.office2PDF(docPath,pdfPath);
					zyJxdg.setJxrlPdfPath("contract/"+namePath);
				}else if(StringUtils.equals("sftp",uploadType)){

				}

			}

		}
		KcKechengbiao kcKechengbiao = new KcKechengbiao();
		kcKechengbiao.setRwbh(zyJxdg.getRwbh());
		kcKechengbiao.setXqxn(zyJxdg.getXqxn());
		kcKechengbiao.setJgh(zyJxdg.getTeano());
		kcKechengbiao = kcKechengbiaoService.getKcbhByRwbh(kcKechengbiao);
		if(kcKechengbiao != null){
			zyJxdg.setKcbh(kcKechengbiao.getKcbh());
			zyJxdg.setSkjs(kcKechengbiao.getSkjs());
		}else{
			zyJxdg.setKcbh("-1");
		}
		zyJxdgService.save(zyJxdg);
		return Result.OK("提交成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param zyJxdg
	 * @return
	 */
	@AutoLog(value = "教学大纲-编辑")
	@ApiOperation(value="教学大纲-编辑", notes="教学大纲-编辑")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody ZyJxdg zyJxdg) {

		UpdateWrapper<ZyJxdg> update = new UpdateWrapper<ZyJxdg>();
		if(StringUtils.isNotEmpty(zyJxdg.getFilePath())){
			String nameLast = zyJxdg.getFilePath().substring(zyJxdg.getFilePath().lastIndexOf(".")+1);
			if(StringUtils.equals("pdf",nameLast)){
				zyJxdg.setPdfPath(zyJxdg.getFilePath());
				update.set("file_path",zyJxdg.getFilePath());
				update.set("pdf_path",zyJxdg.getFilePath());
			}else{
				if(StringUtils.equals("local",uploadType)) {
					FileUtil.mkdir(global.getContractDickPath());
					String dd = DateUtils.formatDate(new Date(), "yyyyMMddHHmmss");
					String docPath = upLoadPath + File.separator + zyJxdg.getFilePath();
					String namePath = dd + ".pdf";
					String pdfPath = global.getContractDickPath() + namePath;
					System.out.println("filPath:" + zyJxdg.getFilePath());
					System.out.println("docPath:" + docPath);
					System.out.println("pdfPath:" + pdfPath);
					PDFUtil.office2PDF(docPath, pdfPath);
					zyJxdg.setPdfPath("contract/" + namePath);
				}else if(StringUtils.equals("sftp",uploadType)){

				}
				update.set("file_path",zyJxdg.getFilePath());
				update.set("pdf_path",zyJxdg.getPdfPath());
			}
		}
		if(StringUtils.isNotEmpty(zyJxdg.getJxrlFilePath())){
			String nameLast = zyJxdg.getJxrlFilePath().substring(zyJxdg.getJxrlFilePath().lastIndexOf(".")+1);
			if(StringUtils.equals("pdf",nameLast)){
				zyJxdg.setPdfPath(zyJxdg.getJxrlFilePath());
				update.set("jxrl_file_path",zyJxdg.getJxrlFilePath());
				update.set("jxrl_pdf_path",zyJxdg.getJxrlFilePath());
			}else{
				if(StringUtils.equals("local",uploadType)) {
					FileUtil.mkdir(global.getContractDickPath());
					String dd = DateUtils.formatDate(new Date(), "yyyyMMddHHmmss");
					String docPath = upLoadPath + File.separator + zyJxdg.getJxrlFilePath();
					String namePath = dd + ".pdf";
					String pdfPath = global.getContractDickPath() + namePath;
					PDFUtil.office2PDF(docPath, pdfPath);
					zyJxdg.setJxrlPdfPath("contract/" + namePath);
				}else {

				}
				update.set("jxrl_file_path",zyJxdg.getJxrlFilePath());
				update.set("jxrl_pdf_path",zyJxdg.getJxrlPdfPath());
			}
		}if(StringUtils.isNotEmpty(zyJxdg.getKcjs())){
			update.set("kcjs",zyJxdg.getKcjs());
		}
		update.eq("id",zyJxdg.getId());
		zyJxdgService.update(update);
		return Result.OK("提交成功!");
	}


	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "教学大纲-通过id删除")
	@ApiOperation(value="教学大纲-通过id删除", notes="教学大纲-通过id删除")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		zyJxdgService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "教学大纲-批量删除")
	@ApiOperation(value="教学大纲-批量删除", notes="教学大纲-批量删除")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.zyJxdgService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "教学大纲-通过id查询")
	@ApiOperation(value="教学大纲-通过id查询", notes="教学大纲-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<ZyJxdg> queryById(@RequestParam(name="id",required=true) String id) {
		ZyJxdg zyJxdg = zyJxdgService.getById(id);
		if(zyJxdg==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(zyJxdg);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param zyJxdg
    */
    @RequiresPermissions("zyJxdg:zy_jxdg:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, ZyJxdg zyJxdg) {
        return super.exportXls(request, zyJxdg, ZyJxdg.class, "教学大纲");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("zyJxdg:zy_jxdg:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, ZyJxdg.class);
    }


	 @ApiOperation(value="获取课程介绍和教学大纲内容", notes="获取课程介绍和教学大纲内容")
	 @GetMapping(value = "/getKcjsJxdg")
	 public Result<ZyJxdg> getKcjsJxdg(@RequestParam(name="rwbh",required=true) String rwbh,@RequestParam(name="xqxn",required=true) String xqxn,@RequestParam(name="teano",required=false) String teano) {
		QueryWrapper<ZyJxdg> queryWrapper = new QueryWrapper<ZyJxdg>();
		 queryWrapper.eq("rwbh",rwbh);
		 queryWrapper.eq("xqxn",xqxn);
		 if(StringUtils.isNotEmpty(teano)){
			 queryWrapper.eq("create_by",teano);
		 }
//		 LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
//		 queryWrapper.eq("create_by",sysUser.getUsername());
		 queryWrapper.last("limit 1");
		 ZyJxdg zyJxdg = zyJxdgService.getOne(queryWrapper);
		 return Result.OK(zyJxdg);
	 }


	 @AutoLog(value = "教学大纲-引用")
	 @ApiOperation(value="教学大纲-引用", notes="教学大纲-引用")
	 @RequestMapping(value = "/editJxdgyy", method = {RequestMethod.PUT,RequestMethod.POST})
	 public Result<String> editJxdgyy(@RequestBody ZyJxdg zyJxdg) {
		 zyJxdgService.editJxdgyy(zyJxdg);
		 return Result.OK("引用成功!");
	 }



	@AutoLog(value = "教学大纲-上传附件")
	@ApiOperation(value="教学大纲-上传附件", notes="教学大纲-上传附件")
	@PostMapping(value = "/jxdgScfj")
	public Result<ZyJxdg> jxdgScfj(@RequestBody ZyJxdg zyJxdg) {
    	boolean isAdd = false;
		if(StringUtils.isEmpty(zyJxdg.getId())){
			isAdd = true;
			zyJxdg.setId((new DefaultIdentifierGenerator().nextId(new ZyJxdg())).toString());
		}
		if(StringUtils.isNotEmpty(zyJxdg.getFilePath())){
			String nameLast = zyJxdg.getFilePath().substring(zyJxdg.getFilePath().lastIndexOf(".")+1);
			if(StringUtils.equals("pdf",nameLast)){
				zyJxdg.setPdfPath(zyJxdg.getFilePath());
			}else{

				ZykInfo zykInfo = new ZykInfo();
				zykInfo.setBizId(zyJxdg.getId());
				zykInfo.setBizTable("zy_jxdg");
				zykInfo.setWjlx(WjlxEnum.JXDG.getType());
				zykInfo.setRwbh(zyJxdg.getRwbh());
				zykInfo.setFileName(zyJxdg.getFilePath());
				zykService.saveLocal(zykInfo);
//				if(StringUtils.equals("local",global.uploadType)) {
//					FileUtil.mkdir(global.getContractDickPath());
//					String dd = DateUtils.formatDate(new Date(), "yyyyMMddHHmmss");
//					String docPath = upLoadPath + File.separator + zyJxdg.getFilePath();
//					String namePath = dd + ".pdf";
//					String pdfPath = global.getContractDickPath() + namePath;
//					System.out.println("pdfPath-----------》"+pdfPath);
//					PDFUtil.office2PDF(docPath, pdfPath);
//					zyJxdg.setPdfPath("contract/" + namePath);
//
//					ZykInfo zykInfo = new ZykInfo();
//					zykInfo.setBizId(zyJxdg.getId());
//					zykInfo.setBizTable("zy_jxdg");
//					zykInfo.setWjlx(WjlxEnum.JXDG.getType());
//					zykInfo.setRwbh(zyJxdg.getRwbh());
//					zykInfo.setFileName(zyJxdg.getFilePath());
//					zykInfo.setPdfName(zyJxdg.getPdfPath());
//					zykService.saveLocal(zykInfo);
//
//				}else if(StringUtils.equals("sftp",global.uploadType)){
//					ZykInfo zykInfo = new ZykInfo();
//					zykInfo.setBizId(zyJxdg.getId());
//					zykInfo.setBizTable("zy_jxdg");
//					zykInfo.setWjlx(WjlxEnum.JXDG.getType());
//					zykInfo.setRwbh(zyJxdg.getRwbh());
//					zykInfo.setFileName(zyJxdg.getFilePath());
//					Map<String,String> map = zykService.saveToZykJxdg(zykInfo);
//					String fileName = map.get("data");
//					String pdfName = map.get("pdfData");
//					System.out.println("pdfName------------>"+pdfName);
//					zyJxdg.setFilePath(fileName);
//					zyJxdg.setPdfPath(pdfName);
//					zykService.disConnect();
//				}
			}
		}else{
			System.out.println("------------8888888888888----------------");
			zyJxdg.setPdfPath(null);
		}
		System.out.println("------------99999999999999999----------------");
		if(isAdd){
			System.out.println("------------00000000000000000000----------------");
			KcKechengbiao kcKechengbiao = new KcKechengbiao();
			kcKechengbiao.setRwbh(zyJxdg.getRwbh());
			kcKechengbiao.setXqxn(zyJxdg.getXqxn());
			kcKechengbiao = kcKechengbiaoService.getKcbhByRwbh(kcKechengbiao);
			if(kcKechengbiao != null){
				zyJxdg.setKcbh(kcKechengbiao.getKcbh());
				zyJxdg.setSkjs(kcKechengbiao.getSkjs());
			}else{
				zyJxdg.setKcbh("-1");
			}
			zyJxdgService.save(zyJxdg);
		}else{
			System.out.println("------------aaaaaaaaaaaaaaa----------------");
			UpdateWrapper<ZyJxdg> updateWrapper = new UpdateWrapper<>();
			updateWrapper.set("file_path",zyJxdg.getFilePath());
			updateWrapper.set("pdf_path",zyJxdg.getPdfPath());
			updateWrapper.eq("id",zyJxdg.getId());
			zyJxdgService.update(updateWrapper);
		}

		return Result.OK(zyJxdg);
	}

	@AutoLog(value = "教学日历-上传附件")
	@ApiOperation(value="教学日历-上传附件", notes="教学日历-上传附件")
	@PostMapping(value = "/jxrlScfj")
	public Result<ZyJxdg> jxrlScfj(@RequestBody ZyJxdg zyJxdg) {
		if(StringUtils.isNotEmpty(zyJxdg.getJxrlFilePath())){
			String nameLast = zyJxdg.getJxrlFilePath().substring(zyJxdg.getJxrlFilePath().lastIndexOf(".")+1);
			if(StringUtils.equals("pdf",nameLast)){
				zyJxdg.setJxrlPdfPath(zyJxdg.getJxrlFilePath());
			}else{
				ZykInfo zykInfo = new ZykInfo();
				zykInfo.setBizId(zyJxdg.getId());
				zykInfo.setBizTable("zy_jxdg");
				zykInfo.setWjlx(WjlxEnum.JXRL.getType());
				zykInfo.setRwbh(zyJxdg.getRwbh());
				zykInfo.setFileName(zyJxdg.getJxrlFilePath());
//				zykInfo.setPdfName(zyJxdg.getJxrlPdfPath());
				zykService.saveLocal(zykInfo);

//				if(StringUtils.equals("local",uploadType)) {
//					FileUtil.mkdir(global.getContractDickPath());
//					String dd = DateUtils.formatDate(new Date(), "yyyyMMddHHmmss");
//					String docPath = upLoadPath + File.separator + zyJxdg.getJxrlFilePath();
//					String namePath = dd + ".pdf";
//					String pdfPath = global.getContractDickPath() + namePath;
//					PDFUtil.office2PDF(docPath, pdfPath);
//					zyJxdg.setJxrlPdfPath("contract/" + namePath);
//
//
//					ZykInfo zykInfo = new ZykInfo();
//					zykInfo.setBizId(zyJxdg.getId());
//					zykInfo.setBizTable("zy_jxdg");
//					zykInfo.setWjlx(WjlxEnum.JXRL.getType());
//					zykInfo.setRwbh(zyJxdg.getRwbh());
//					zykInfo.setFileName(zyJxdg.getJxrlFilePath());
//					zykInfo.setPdfName(zyJxdg.getJxrlPdfPath());
//					zykService.saveLocal(zykInfo);
//
//
//				}else if(StringUtils.equals("sftp",uploadType)){
//					ZykInfo zykInfo = new ZykInfo();
//					zykInfo.setBizId(zyJxdg.getId());
//					zykInfo.setBizTable("zy_jxdg");
//					zykInfo.setWjlx(WjlxEnum.JXRL.getType());
//					zykInfo.setRwbh(zyJxdg.getRwbh());
//					zykInfo.setFileName(zyJxdg.getJxrlFilePath());
//					Map<String,String> map = zykService.saveToZykJxdg(zykInfo);
//					String fileName = map.get("data");
//					String pdfName = map.get("pdfData");
//					zyJxdg.setJxrlFilePath(fileName);
//					zyJxdg.setJxrlPdfPath(pdfName);
//					zykService.disConnect();
//				}
			}
		}else{
			zyJxdg.setJxrlPdfPath(null);
		}
		if(StringUtils.isEmpty(zyJxdg.getId())){
			zyJxdgService.save(zyJxdg);
		}else{
			UpdateWrapper<ZyJxdg> updateWrapper = new UpdateWrapper<>();
			updateWrapper.set("jxrl_file_path",zyJxdg.getJxrlFilePath());
			updateWrapper.set("jxrl_pdf_path",zyJxdg.getJxrlPdfPath());
			updateWrapper.eq("id",zyJxdg.getId());
			zyJxdgService.update(updateWrapper);
		}
		return Result.OK(zyJxdg);
	}


	@ApiOperation(value="教学大纲-分页列表查询", notes="教学大纲-分页列表查询")
	@GetMapping(value = "/sysList")
	public Result<IPage<ZyJxdgSys>> sysList(ZyJxdgSys zyJxdg,
											   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
											   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
											   HttpServletRequest req) {
		LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
		//-------------获取当前登陆人是否是管理员角色，如果不是都按照教务秘书处理---------------------------
		List<String> roleList = sysBaseApi.getRolesByUsername(sysUser.getUsername());
		String adminRole = "1";//0 admin  1教务秘书
		for(String role :roleList){
			if(org.apache.commons.lang.StringUtils.equals("admin",role)){
				adminRole = "0";
				break;
			}
		}
		QueryWrapper<ZyJxdgSys> queryWrapper = new QueryWrapper<ZyJxdgSys>();
		if(org.apache.commons.lang.StringUtils.equals("1",adminRole)){
			QueryWrapper<KcExportConfigTpkwcqkjzglx> queryWrapperCon = new QueryWrapper<KcExportConfigTpkwcqkjzglx>();
			queryWrapperCon.eq("gh",sysUser.getUsername());
			queryWrapperCon.orderByDesc("create_time");
			queryWrapperCon.last("limit 1");
			KcExportConfigTpkwcqkjzglx kcExportConfigTpkwcqkjzglx = kcExportConfigTpkwcqkjzglxService.getOne(queryWrapperCon);
			queryWrapper.eq("kkdw",kcExportConfigTpkwcqkjzglx.getDwmc());
		}

		if(StringUtils.isEmpty(zyJxdg.getXqxn())){
			KcSysConfig kcSysConfig = kcSysConfigService.getById("1");
			queryWrapper.eq("xqxn",kcSysConfig.getFlag1());
		}else{
			queryWrapper.eq("xqxn",zyJxdg.getXqxn());
		}
		queryWrapper.like(StringUtils.isNotEmpty(zyJxdg.getKkdw()),"kkdw",zyJxdg.getKkdw());
		queryWrapper.like(StringUtils.isNotEmpty(zyJxdg.getKcmc()),"kcmc",zyJxdg.getKcmc());
		queryWrapper.like(StringUtils.isNotEmpty(zyJxdg.getKcbh()),"kcbh",zyJxdg.getKcbh());
		queryWrapper.like(StringUtils.isNotEmpty(zyJxdg.getSkjs()),"skjs",zyJxdg.getSkjs());

		Page<ZyJxdgSys> page = new Page<ZyJxdgSys>(pageNo, pageSize);
		IPage<ZyJxdgSys> pageList = zyJxdgService.sysList(page, queryWrapper);
		return Result.OK(pageList);
	}

	@AutoLog(value = "学院管理员修改教学内容")
	@ApiOperation(value="学院管理员修改教学内容", notes="学院管理员修改教学内容")
	@PostMapping(value = "/sysUpdateJxnr")
	public Result<ZyJxdg> sysUpdateJxnr(@RequestBody ZyJxdg zyJxdg) {
		if(StringUtils.isEmpty(zyJxdg.getYwId())){
			zyJxdg.setCreateBy(zyJxdg.getTeano());
			zyJxdgService.save(zyJxdg);
			return Result.OK(zyJxdg);
		}else{
			UpdateWrapper<ZyJxdg> zyJxdgUw = new UpdateWrapper<>();
			zyJxdgUw.set("file_path", zyJxdg.getFilePath());
			zyJxdgUw.set("jxrl_file_path", zyJxdg.getJxrlFilePath());
			zyJxdgUw.eq("id", zyJxdg.getYwId());
			zyJxdgService.update(zyJxdgUw);
			zyJxdg = zyJxdgService.getById(zyJxdg.getYwId());
			return Result.OK(zyJxdg);
		}
	}

	@ApiOperation(value="管理员word转pdf", notes="管理员word转pdf")
	@PostMapping(value = "/sysWordToPdf")
	public void sysWordToPdf(@RequestBody ZyJxdg zyJxdg) {
		if(StringUtils.isNotEmpty(zyJxdg.getJxrlFilePath())){
			String nameLast = zyJxdg.getJxrlFilePath().substring(zyJxdg.getJxrlFilePath().lastIndexOf(".")+1);
			if(StringUtils.equals("pdf",nameLast)){
				zyJxdg.setJxrlPdfPath(zyJxdg.getJxrlFilePath());
			}else{
				if(StringUtils.equals("local",uploadType)) {
					FileUtil.mkdir(global.getContractDickPath());
					String dd = DateUtils.formatDate(new Date(), "yyyyMMddHHmmss");
					String docPath = upLoadPath + File.separator + zyJxdg.getJxrlFilePath();
					String namePath = dd + ".pdf";
					String pdfPath = global.getContractDickPath() + namePath;
					PDFUtil.office2PDF(docPath, pdfPath);
					zyJxdg.setJxrlPdfPath("contract/" + namePath);
				}else if(StringUtils.equals("sftp",uploadType)){
					ZykInfo zykInfo = new ZykInfo();
					zykInfo.setBizId(zyJxdg.getId());
					zykInfo.setBizTable("zy_jxdg");
					zykInfo.setWjlx(WjlxEnum.JXRL.getType());
					zykInfo.setRwbh(zyJxdg.getRwbh());
					zykInfo.setFileName(zyJxdg.getJxrlFilePath());
					Map<String,String> map = zykService.saveToZykJxdg(zykInfo);
					String fileName = map.get("data");
					String pdfName = map.get("pdfData");
					zyJxdg.setJxrlFilePath(fileName);
					zyJxdg.setJxrlPdfPath(pdfName);
					zykService.disConnect();
				}
			}
		}else{
			zyJxdg.setJxrlFilePath(null);
			zyJxdg.setJxrlPdfPath(null);
		}
		if(StringUtils.isNotEmpty(zyJxdg.getFilePath())){
			String nameLast = zyJxdg.getFilePath().substring(zyJxdg.getFilePath().lastIndexOf(".")+1);
			if(StringUtils.equals("pdf",nameLast)){
				zyJxdg.setPdfPath(zyJxdg.getFilePath());
			}else{

				if(StringUtils.equals("local",global.uploadType)) {
					FileUtil.mkdir(global.getContractDickPath());
					String dd = DateUtils.formatDate(new Date(), "yyyyMMddHHmmss");
					String docPath = upLoadPath + File.separator + zyJxdg.getFilePath();
					String namePath = dd + ".pdf";
					String pdfPath = global.getContractDickPath() + namePath;
					PDFUtil.office2PDF(docPath, pdfPath);
					zyJxdg.setPdfPath("contract/" + namePath);
				}else if(StringUtils.equals("sftp",global.uploadType)){
					ZykInfo zykInfo = new ZykInfo();
					zykInfo.setBizId(zyJxdg.getId());
					zykInfo.setBizTable("zy_jxdg");
					zykInfo.setWjlx(WjlxEnum.JXDG.getType());
					zykInfo.setRwbh(zyJxdg.getRwbh());
					zykInfo.setFileName(zyJxdg.getFilePath());
					Map<String,String> map = zykService.saveToZykJxdg(zykInfo);
					String fileName = map.get("data");
					String pdfName = map.get("pdfData");
					zyJxdg.setFilePath(fileName);
					zyJxdg.setPdfPath(pdfName);
					zykService.disConnect();
				}
			}
		}else{
			zyJxdg.setFilePath(null);
			zyJxdg.setPdfPath(null);
		}
		UpdateWrapper<ZyJxdg> updateWrapper = new UpdateWrapper<>();
		updateWrapper.set("file_path",zyJxdg.getFilePath());
		updateWrapper.set("pdf_path",zyJxdg.getPdfPath());
		updateWrapper.set("jxrl_file_path",zyJxdg.getJxrlFilePath());
		updateWrapper.set("jxrl_pdf_path",zyJxdg.getJxrlPdfPath());
		updateWrapper.eq("id",zyJxdg.getId());
		zyJxdgService.update(updateWrapper);
	}



	@RequestMapping(value = "/exportSysXls")
	public ModelAndView exportSysXls(HttpServletRequest request, ZyJxdgSys zyJxdg) {
		String title = "教学内容";
		// Step.1 组装查询条件
		QueryWrapper<ZyJxdgSys> queryWrapper = new QueryWrapper<>();
		LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();


		//-------------获取当前登陆人是否是管理员角色，如果不是都按照教务秘书处理---------------------------
		List<String> roleList = sysBaseApi.getRolesByUsername(sysUser.getUsername());
		String adminRole = "1";//0 admin  1教务秘书
		for(String role :roleList){
			if(org.apache.commons.lang.StringUtils.equals("admin",role)){
				adminRole = "0";
				break;
			}
		}
		if(org.apache.commons.lang.StringUtils.equals("1",adminRole)){
			QueryWrapper<KcExportConfigTpkwcqkjzglx> queryWrapperCon = new QueryWrapper<KcExportConfigTpkwcqkjzglx>();
			queryWrapperCon.eq("gh",sysUser.getUsername());
			queryWrapperCon.orderByDesc("create_time");
			queryWrapperCon.last("limit 1");
			KcExportConfigTpkwcqkjzglx kcExportConfigTpkwcqkjzglx = kcExportConfigTpkwcqkjzglxService.getOne(queryWrapperCon);
			queryWrapper.eq("kkdw",kcExportConfigTpkwcqkjzglx.getDwmc());
		}

		if(StringUtils.isEmpty(zyJxdg.getXqxn())){
			KcSysConfig kcSysConfig = kcSysConfigService.getById("1");
			queryWrapper.eq("xqxn",kcSysConfig.getFlag1());
		}else{
			queryWrapper.eq("xqxn",zyJxdg.getXqxn());
		}
		queryWrapper.like(StringUtils.isNotEmpty(zyJxdg.getKkdw()),"kkdw",zyJxdg.getKkdw());
		queryWrapper.like(StringUtils.isNotEmpty(zyJxdg.getKcmc()),"kcmc",zyJxdg.getKcmc());
		queryWrapper.like(StringUtils.isNotEmpty(zyJxdg.getKcbh()),"kcbh",zyJxdg.getKcbh());
		queryWrapper.like(StringUtils.isNotEmpty(zyJxdg.getSkjs()),"skjs",zyJxdg.getSkjs());

		// Step.2 获取导出数据
		List<ZyJxdgSys> exportList = service.exportSysXls(queryWrapper);

		// Step.3 AutoPoi 导出Excel
		ModelAndView mv = new ModelAndView(new JeecgEntityExcelView());
		//此处设置的filename无效 ,前端会重更新设置一下
		mv.addObject(NormalExcelConstants.FILE_NAME, title);
		mv.addObject(NormalExcelConstants.CLASS, ZyJxdgSys.class);
		//update-begin--Author:liusq  Date:20210126 for：图片导出报错，ImageBasePath未设置--------------------
		ExportParams exportParams=new ExportParams(title + "报表", "导出人:" + sysUser.getRealname(), title);
		exportParams.setImageBasePath(upLoadPath);
		//update-end--Author:liusq  Date:20210126 for：图片导出报错，ImageBasePath未设置----------------------
		mv.addObject(NormalExcelConstants.PARAMS,exportParams);
		mv.addObject(NormalExcelConstants.DATA_LIST, exportList);
		return mv;
	}


	@AutoLog(value = "删除教学大纲及日历附件")
	@ApiOperation(value="删除教学大纲及日历附件", notes="删除教学大纲及日历附件")
	@PostMapping(value = "/deleteJxdgJxrl")
	public Result<ZyJxdg> deleteJxdgJxrl(@RequestBody ZyJxdg zyJxdg) {
		String id = zyJxdg.getId();
		String type = zyJxdg.getType();
		UpdateWrapper<ZyJxdg> update = new UpdateWrapper<ZyJxdg>();
		if(StringUtils.equals("1",type)){
			update.set("file_path",null);
			update.set("pdf_path",null);
			update.eq("id",id);
			service.update(update);
		}else if(StringUtils.equals("2",type)){
			update.set("jxrl_file_path",null);
			update.set("jxrl_pdf_path",null);
			update.eq("id",id);
			service.update(update);
		}

		return Result.OK("删除成功!");
	}


}
