package org.jeecg.modules.kc.zyJxdg.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import org.apache.commons.lang3.StringUtils;
import org.apache.shiro.SecurityUtils;
import org.jeecg.common.system.vo.LoginUser;
import org.jeecg.modules.kc.zyJxdg.entity.ZyJxdg;
import org.jeecg.modules.kc.zyJxdg.entity.ZyJxdgSys;
import org.jeecg.modules.kc.zyJxdg.mapper.ZyJxdgMapper;
import org.jeecg.modules.kc.zyJxdg.service.IZyJxdgService;
import org.springframework.stereotype.Service;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;

import java.util.Date;
import java.util.List;

/**
 * @Description: 教学大纲
 * @Author: jeecg-boot
 * @Date:   2024-05-11
 * @Version: V1.0
 */
@Service
public class ZyJxdgServiceImpl extends ServiceImpl<ZyJxdgMapper, ZyJxdg> implements IZyJxdgService {

    @Override
    public void editJxdgyy(ZyJxdg zyJxdg) {

        QueryWrapper<ZyJxdg> queryWrapper = new QueryWrapper<ZyJxdg>();
        queryWrapper.eq(StringUtils.isNotEmpty(zyJxdg.getRwbh()),"rwbh",zyJxdg.getRwbh());
        queryWrapper.eq(StringUtils.isNotEmpty(zyJxdg.getXqxn()),"xqxn",zyJxdg.getXqxn());
        LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
        queryWrapper.eq("create_by",sysUser.getUsername());
        queryWrapper.last("limit 1");
        ZyJxdg zyJxdgNew = baseMapper.selectOne(queryWrapper);
//        zyJxdgNew.setFilePath(zyJxdg.getFilePath());
//        zyJxdgNew.setSkjs(zyJxdg.getSkjs());
        if(zyJxdgNew==null){
            queryWrapper = new QueryWrapper<ZyJxdg>();
            queryWrapper.eq("create_by",sysUser.getUsername());
            queryWrapper.last("limit 1");
            zyJxdgNew = baseMapper.selectOne(queryWrapper);
            zyJxdgNew.setId(null);
            zyJxdgNew.setCreateTime(new Date());
            zyJxdgNew.setUpdateBy(null);
            zyJxdgNew.setUpdateTime(null);
            zyJxdgNew.setFilePath(null);
            zyJxdgNew.setKcjs(null);
        }
        zyJxdgNew.setKcjs(zyJxdg.getKcjs());
        zyJxdgNew.setXqxn(zyJxdg.getXqxn());
        zyJxdgNew.setRwbh(zyJxdg.getRwbh());
        if(StringUtils.isEmpty(zyJxdgNew.getId())){
            baseMapper.insert(zyJxdgNew);
        }else{
            baseMapper.updateById(zyJxdgNew);
        }
    }

    @Override
    public IPage<ZyJxdgSys> sysList(Page<ZyJxdgSys> page, QueryWrapper<ZyJxdgSys> queryWrapper) {
        return baseMapper.sysList(page, queryWrapper);
    }

    @Override
    public List<ZyJxdgSys> exportSysXls(QueryWrapper<ZyJxdgSys> queryWrapper) {
        return baseMapper.exportSysXls(queryWrapper);
    }
}
