package org.jeecg.modules.kc.zyJxdgBanben.controller;

import java.io.UnsupportedEncodingException;
import java.io.IOException;
import java.net.URLDecoder;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.jeecg.common.system.vo.LoginUser;
import org.apache.shiro.SecurityUtils;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.kc.zyJxdgBanben.entity.ZyJxdgMain;
import org.jeecg.modules.kc.zyJxdgBanben.entity.ZyJxdgBanben;
import org.jeecg.modules.kc.zyJxdgBanben.vo.ZyJxdgBanbenPage;
import org.jeecg.modules.kc.zyJxdgBanben.service.IZyJxdgBanbenService;
import org.jeecg.modules.kc.zyJxdgBanben.service.IZyJxdgMainService;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;
import com.alibaba.fastjson.JSON;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;


 /**
 * @Description: 教学大纲版本配置
 * @Author: jeecg-boot
 * @Date:   2024-08-19
 * @Version: V1.0
 */
@Api(tags="教学大纲版本配置")
@RestController
@RequestMapping("/zyJxdgBanben/zyJxdgBanben")
@Slf4j
public class ZyJxdgBanbenController {
	@Autowired
	private IZyJxdgBanbenService zyJxdgBanbenService;
	@Autowired
	private IZyJxdgMainService zyJxdgMainService;
	
	/**
	 * 分页列表查询
	 *
	 * @param zyJxdgBanben
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "教学大纲版本配置-分页列表查询")
	@ApiOperation(value="教学大纲版本配置-分页列表查询", notes="教学大纲版本配置-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<ZyJxdgBanben>> queryPageList(ZyJxdgBanben zyJxdgBanben,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<ZyJxdgBanben> queryWrapper = QueryGenerator.initQueryWrapper(zyJxdgBanben, req.getParameterMap());
		Page<ZyJxdgBanben> page = new Page<ZyJxdgBanben>(pageNo, pageSize);
		IPage<ZyJxdgBanben> pageList = zyJxdgBanbenService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param zyJxdgBanbenPage
	 * @return
	 */
	@AutoLog(value = "教学大纲版本配置-添加")
	@ApiOperation(value="教学大纲版本配置-添加", notes="教学大纲版本配置-添加")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody ZyJxdgBanbenPage zyJxdgBanbenPage) {
		ZyJxdgBanben zyJxdgBanben = new ZyJxdgBanben();
		BeanUtils.copyProperties(zyJxdgBanbenPage, zyJxdgBanben);
		zyJxdgBanbenService.saveMain(zyJxdgBanben, zyJxdgBanbenPage.getZyJxdgMainList());
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param zyJxdgBanbenPage
	 * @return
	 */
	@AutoLog(value = "教学大纲版本配置-编辑")
	@ApiOperation(value="教学大纲版本配置-编辑", notes="教学大纲版本配置-编辑")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody ZyJxdgBanbenPage zyJxdgBanbenPage) {
		ZyJxdgBanben zyJxdgBanben = new ZyJxdgBanben();
		BeanUtils.copyProperties(zyJxdgBanbenPage, zyJxdgBanben);
		ZyJxdgBanben zyJxdgBanbenEntity = zyJxdgBanbenService.getById(zyJxdgBanben.getId());
		if(zyJxdgBanbenEntity==null) {
			return Result.error("未找到对应数据");
		}
		zyJxdgBanbenService.updateMain(zyJxdgBanben, zyJxdgBanbenPage.getZyJxdgMainList());
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "教学大纲版本配置-通过id删除")
	@ApiOperation(value="教学大纲版本配置-通过id删除", notes="教学大纲版本配置-通过id删除")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		zyJxdgBanbenService.delMain(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "教学大纲版本配置-批量删除")
	@ApiOperation(value="教学大纲版本配置-批量删除", notes="教学大纲版本配置-批量删除")
    @RequiresPermissions("zyJxdgBanben:zy_jxdg_banben:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.zyJxdgBanbenService.delBatchMain(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功！");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "教学大纲版本配置-通过id查询")
	@ApiOperation(value="教学大纲版本配置-通过id查询", notes="教学大纲版本配置-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<ZyJxdgBanben> queryById(@RequestParam(name="id",required=true) String id) {
		ZyJxdgBanben zyJxdgBanben = zyJxdgBanbenService.getById(id);
		if(zyJxdgBanben==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(zyJxdgBanben);
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "教学大纲配置信息通过主表ID查询")
	@ApiOperation(value="教学大纲配置信息主表ID查询", notes="教学大纲配置信息-通主表ID查询")
	@GetMapping(value = "/queryZyJxdgMainByMainId")
	public Result<List<ZyJxdgMain>> queryZyJxdgMainListByMainId(@RequestParam(name="id",required=true) String id) {
		List<ZyJxdgMain> zyJxdgMainList = zyJxdgMainService.selectByMainId(id);
		return Result.OK(zyJxdgMainList);
	}


}
