package org.jeecg.modules.kc.zyJxdgBanben.controller;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.kc.zyJxdgBanben.entity.ZyJxdgPzxx;
import org.jeecg.modules.kc.zyJxdgBanben.service.IZyJxdgPzxxService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

 /**
 * @Description: zy_jxdg_pzxx
 * @Author: jeecg-boot
 * @Date:   2024-08-19
 * @Version: V1.0
 */
@Api(tags="zy_jxdg_pzxx")
@RestController
@RequestMapping("/zyJxdgBanben/zyJxdgPzxx")
@Slf4j
public class ZyJxdgPzxxController extends JeecgController<ZyJxdgPzxx, IZyJxdgPzxxService> {
	@Autowired
	private IZyJxdgPzxxService zyJxdgPzxxService;
	
	/**
	 * 分页列表查询
	 *
	 * @param zyJxdgPzxx
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "zy_jxdg_pzxx-分页列表查询")
	@ApiOperation(value="zy_jxdg_pzxx-分页列表查询", notes="zy_jxdg_pzxx-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<ZyJxdgPzxx>> queryPageList(ZyJxdgPzxx zyJxdgPzxx,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<ZyJxdgPzxx> queryWrapper = QueryGenerator.initQueryWrapper(zyJxdgPzxx, req.getParameterMap());
		Page<ZyJxdgPzxx> page = new Page<ZyJxdgPzxx>(pageNo, pageSize);
		IPage<ZyJxdgPzxx> pageList = zyJxdgPzxxService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param zyJxdgPzxx
	 * @return
	 */
	@AutoLog(value = "zy_jxdg_pzxx-添加")
	@ApiOperation(value="zy_jxdg_pzxx-添加", notes="zy_jxdg_pzxx-添加")
	@RequiresPermissions("zyJxdgBanben:zy_jxdg_pzxx:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody ZyJxdgPzxx zyJxdgPzxx) {
		zyJxdgPzxxService.save(zyJxdgPzxx);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param zyJxdgPzxx
	 * @return
	 */
	@AutoLog(value = "zy_jxdg_pzxx-编辑")
	@ApiOperation(value="zy_jxdg_pzxx-编辑", notes="zy_jxdg_pzxx-编辑")
	@RequiresPermissions("zyJxdgBanben:zy_jxdg_pzxx:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody ZyJxdgPzxx zyJxdgPzxx) {
		zyJxdgPzxxService.updateById(zyJxdgPzxx);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "zy_jxdg_pzxx-通过id删除")
	@ApiOperation(value="zy_jxdg_pzxx-通过id删除", notes="zy_jxdg_pzxx-通过id删除")
	@RequiresPermissions("zyJxdgBanben:zy_jxdg_pzxx:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		zyJxdgPzxxService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "zy_jxdg_pzxx-批量删除")
	@ApiOperation(value="zy_jxdg_pzxx-批量删除", notes="zy_jxdg_pzxx-批量删除")
	@RequiresPermissions("zyJxdgBanben:zy_jxdg_pzxx:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.zyJxdgPzxxService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "zy_jxdg_pzxx-通过id查询")
	@ApiOperation(value="zy_jxdg_pzxx-通过id查询", notes="zy_jxdg_pzxx-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<ZyJxdgPzxx> queryById(@RequestParam(name="id",required=true) String id) {
		ZyJxdgPzxx zyJxdgPzxx = zyJxdgPzxxService.getById(id);
		if(zyJxdgPzxx==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(zyJxdgPzxx);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param zyJxdgPzxx
    */
    @RequiresPermissions("zyJxdgBanben:zy_jxdg_pzxx:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, ZyJxdgPzxx zyJxdgPzxx) {
        return super.exportXls(request, zyJxdgPzxx, ZyJxdgPzxx.class, "zy_jxdg_pzxx");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("zyJxdgBanben:zy_jxdg_pzxx:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, ZyJxdgPzxx.class);
    }

}
