package org.jeecg.modules.kc.zyJxdgBanben.service.impl;

import org.jeecg.common.util.text.StringUtils;
import org.jeecg.modules.kc.zyJxdgBanben.entity.ZyJxdgBanben;
import org.jeecg.modules.kc.zyJxdgBanben.entity.ZyJxdgMain;
import org.jeecg.modules.kc.zyJxdgBanben.entity.ZyJxdgPzxx;
import org.jeecg.modules.kc.zyJxdgBanben.mapper.ZyJxdgMainMapper;
import org.jeecg.modules.kc.zyJxdgBanben.mapper.ZyJxdgBanbenMapper;
import org.jeecg.modules.kc.zyJxdgBanben.mapper.ZyJxdgPzxxMapper;
import org.jeecg.modules.kc.zyJxdgBanben.service.IZyJxdgBanbenService;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;
import java.io.Serializable;
import java.util.List;
import java.util.Collection;

/**
 * @Description: 教学大纲版本配置
 * @Author: jeecg-boot
 * @Date:   2024-08-19
 * @Version: V1.0
 */
@Service
public class ZyJxdgBanbenServiceImpl extends ServiceImpl<ZyJxdgBanbenMapper, ZyJxdgBanben> implements IZyJxdgBanbenService {

	@Autowired
	private ZyJxdgBanbenMapper zyJxdgBanbenMapper;
	@Autowired
	private ZyJxdgMainMapper zyJxdgMainMapper;
	@Autowired
	private ZyJxdgPzxxMapper zyJxdgPzxxMapper;
	
	@Override
	@Transactional(rollbackFor = Exception.class)
	public void saveMain(ZyJxdgBanben zyJxdgBanben, List<ZyJxdgMain> zyJxdgMainList) {
		zyJxdgBanbenMapper.insert(zyJxdgBanben);
		if(zyJxdgMainList!=null && zyJxdgMainList.size()>0) {
			for(ZyJxdgMain entity:zyJxdgMainList) {
				//外键设置
				entity.setMainId(zyJxdgBanben.getId());
				zyJxdgMainMapper.insert(entity);

				if(entity.getZyJxdgPzxxList()!=null && entity.getZyJxdgPzxxList().size()>0 && (StringUtils.equals("4",entity.getType()) || StringUtils.equals("5",entity.getType()) || StringUtils.equals("9",entity.getType()) || StringUtils.equals("10",entity.getType()) || StringUtils.equals("11",entity.getType())|| StringUtils.equals("12",entity.getType())|| StringUtils.equals("13",entity.getType())|| StringUtils.equals("14",entity.getType())|| StringUtils.equals("15",entity.getType()))) {
					for(ZyJxdgPzxx zyJxdgPzxx:entity.getZyJxdgPzxxList()) {
						zyJxdgPzxx.setMainId(zyJxdgBanben.getId());
						zyJxdgPzxx.setTwoMainId(entity.getId());
						zyJxdgPzxxMapper.insert(zyJxdgPzxx);
					}
				}
			}
		}
	}

	@Override
	@Transactional(rollbackFor = Exception.class)
	public void updateMain(ZyJxdgBanben zyJxdgBanben,List<ZyJxdgMain> zyJxdgMainList) {
		zyJxdgBanbenMapper.updateById(zyJxdgBanben);
		
		//1.先删除子表数据
		zyJxdgMainMapper.deleteByMainId(zyJxdgBanben.getId());
		//1.先删除子表数据
		zyJxdgPzxxMapper.deleteByMainId(zyJxdgBanben.getId());
		
		//2.子表数据重新插入
		if(zyJxdgMainList!=null && zyJxdgMainList.size()>0) {
			for(ZyJxdgMain entity:zyJxdgMainList) {
				//外键设置
				entity.setMainId(zyJxdgBanben.getId());
				zyJxdgMainMapper.insert(entity);

				if(entity.getZyJxdgPzxxList()!=null && entity.getZyJxdgPzxxList().size()>0 && (StringUtils.equals("4",entity.getType()) || StringUtils.equals("5",entity.getType()) || StringUtils.equals("9",entity.getType()) || StringUtils.equals("10",entity.getType())|| StringUtils.equals("11",entity.getType())|| StringUtils.equals("12",entity.getType())|| StringUtils.equals("13",entity.getType())|| StringUtils.equals("14",entity.getType())|| StringUtils.equals("15",entity.getType()))) {
					for(ZyJxdgPzxx zyJxdgPzxx:entity.getZyJxdgPzxxList()) {
						zyJxdgPzxx.setMainId(zyJxdgBanben.getId());
						zyJxdgPzxx.setTwoMainId(entity.getId());
						zyJxdgPzxxMapper.insert(zyJxdgPzxx);
					}
				}
			}
		}
	}

	@Override
	@Transactional(rollbackFor = Exception.class)
	public void delMain(String id) {
		zyJxdgMainMapper.deleteByMainId(id);
		zyJxdgBanbenMapper.deleteById(id);
	}

	@Override
	@Transactional(rollbackFor = Exception.class)
	public void delBatchMain(Collection<? extends Serializable> idList) {
		for(Serializable id:idList) {
			zyJxdgMainMapper.deleteByMainId(id.toString());
			zyJxdgBanbenMapper.deleteById(id);
		}
	}
	
}
