package org.jeecg.modules.kc.zyJxdgTeacherMain.controller;

import java.io.UnsupportedEncodingException;
import java.io.IOException;
import java.net.URLDecoder;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.jeecg.modules.kc.zyJxdgBanben.entity.ZyJxdgBanben;
import org.jeecg.modules.kc.zyJxdgBanben.entity.ZyJxdgMain;
import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.jeecg.common.system.vo.LoginUser;
import org.apache.shiro.SecurityUtils;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.kc.zyJxdgTeacherMain.entity.ZyJxdgTeacherCenter;
import org.jeecg.modules.kc.zyJxdgTeacherMain.entity.ZyJxdgTeacherMain;
import org.jeecg.modules.kc.zyJxdgTeacherMain.vo.ZyJxdgTeacherMainPage;
import org.jeecg.modules.kc.zyJxdgTeacherMain.service.IZyJxdgTeacherMainService;
import org.jeecg.modules.kc.zyJxdgTeacherMain.service.IZyJxdgTeacherCenterService;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;
import com.alibaba.fastjson.JSON;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;


 /**
 * @Description: 教师填写教学大纲
 * @Author: jeecg-boot
 * @Date:   2024-08-20
 * @Version: V1.0
 */
@Api(tags="教师填写教学大纲")
@RestController
@RequestMapping("/zyJxdgTeacherMain/zyJxdgTeacherMain")
@Slf4j
public class ZyJxdgTeacherMainController {
	@Autowired
	private IZyJxdgTeacherMainService zyJxdgTeacherMainService;
	@Autowired
	private IZyJxdgTeacherCenterService zyJxdgTeacherCenterService;
	
	/**
	 * 分页列表查询
	 *
	 * @param zyJxdgTeacherMain
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "教师填写教学大纲-分页列表查询")
	@ApiOperation(value="教师填写教学大纲-分页列表查询", notes="教师填写教学大纲-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<ZyJxdgTeacherMain>> queryPageList(ZyJxdgTeacherMain zyJxdgTeacherMain,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<ZyJxdgTeacherMain> queryWrapper = QueryGenerator.initQueryWrapper(zyJxdgTeacherMain, req.getParameterMap());
		Page<ZyJxdgTeacherMain> page = new Page<ZyJxdgTeacherMain>(pageNo, pageSize);
		IPage<ZyJxdgTeacherMain> pageList = zyJxdgTeacherMainService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param zyJxdgTeacherMainPage
	 * @return
	 */
	@AutoLog(value = "教师填写教学大纲-添加")
	@ApiOperation(value="教师填写教学大纲-添加", notes="教师填写教学大纲-添加")
    @RequiresPermissions("zyJxdgTeacherMain:zy_jxdg_teacher_main:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody ZyJxdgTeacherMainPage zyJxdgTeacherMainPage) {
		ZyJxdgTeacherMain zyJxdgTeacherMain = new ZyJxdgTeacherMain();
		BeanUtils.copyProperties(zyJxdgTeacherMainPage, zyJxdgTeacherMain);
		zyJxdgTeacherMainService.saveMain(zyJxdgTeacherMain, zyJxdgTeacherMainPage.getZyJxdgTeacherCenterList());
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param zyJxdgTeacherMainPage
	 * @return
	 */
	@AutoLog(value = "教师填写教学大纲-编辑")
	@ApiOperation(value="教师填写教学大纲-编辑", notes="教师填写教学大纲-编辑")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody ZyJxdgTeacherMainPage zyJxdgTeacherMainPage) {
		ZyJxdgTeacherMain zyJxdgTeacherMain = new ZyJxdgTeacherMain();
		BeanUtils.copyProperties(zyJxdgTeacherMainPage, zyJxdgTeacherMain);
//		ZyJxdgTeacherMain zyJxdgTeacherMainEntity = zyJxdgTeacherMainService.getById(zyJxdgTeacherMain.getId());
//		if(zyJxdgTeacherMainEntity==null) {
//			return Result.error("未找到对应数据");
//		}
		zyJxdgTeacherMainService.updateById(zyJxdgTeacherMain);
		return Result.OK("操作成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "教师填写教学大纲-通过id删除")
	@ApiOperation(value="教师填写教学大纲-通过id删除", notes="教师填写教学大纲-通过id删除")
    @RequiresPermissions("zyJxdgTeacherMain:zy_jxdg_teacher_main:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		zyJxdgTeacherMainService.delMain(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "教师填写教学大纲-批量删除")
	@ApiOperation(value="教师填写教学大纲-批量删除", notes="教师填写教学大纲-批量删除")
    @RequiresPermissions("zyJxdgTeacherMain:zy_jxdg_teacher_main:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.zyJxdgTeacherMainService.delBatchMain(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功！");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "教师填写教学大纲-通过id查询")
	@ApiOperation(value="教师填写教学大纲-通过id查询", notes="教师填写教学大纲-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<ZyJxdgTeacherMain> queryById(@RequestParam(name="id",required=true) String id) {
		ZyJxdgTeacherMain zyJxdgTeacherMain = zyJxdgTeacherMainService.getById(id);
		if(zyJxdgTeacherMain==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(zyJxdgTeacherMain);

	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "教师填写教学大纲内容通过主表ID查询")
	@ApiOperation(value="教师填写教学大纲内容主表ID查询", notes="教师填写教学大纲内容-通主表ID查询")
	@GetMapping(value = "/queryZyJxdgTeacherCenterByMainId")
	public Result<List<ZyJxdgTeacherCenter>> queryZyJxdgTeacherCenterListByMainId(@RequestParam(name="id",required=true) String id) {
		List<ZyJxdgTeacherCenter> zyJxdgTeacherCenterList = zyJxdgTeacherCenterService.selectByMainId(id);
		return Result.OK(zyJxdgTeacherCenterList);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param zyJxdgTeacherMain
    */
    @RequiresPermissions("zyJxdgTeacherMain:zy_jxdg_teacher_main:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, ZyJxdgTeacherMain zyJxdgTeacherMain) {
      // Step.1 组装查询条件查询数据
      QueryWrapper<ZyJxdgTeacherMain> queryWrapper = QueryGenerator.initQueryWrapper(zyJxdgTeacherMain, request.getParameterMap());
      LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();

      //配置选中数据查询条件
      String selections = request.getParameter("selections");
      if(oConvertUtils.isNotEmpty(selections)) {
         List<String> selectionList = Arrays.asList(selections.split(","));
         queryWrapper.in("id",selectionList);
      }
      //Step.2 获取导出数据
      List<ZyJxdgTeacherMain> zyJxdgTeacherMainList = zyJxdgTeacherMainService.list(queryWrapper);

      // Step.3 组装pageList
      List<ZyJxdgTeacherMainPage> pageList = new ArrayList<ZyJxdgTeacherMainPage>();
      for (ZyJxdgTeacherMain main : zyJxdgTeacherMainList) {
          ZyJxdgTeacherMainPage vo = new ZyJxdgTeacherMainPage();
          BeanUtils.copyProperties(main, vo);
          List<ZyJxdgTeacherCenter> zyJxdgTeacherCenterList = zyJxdgTeacherCenterService.selectByMainId(main.getId());
          vo.setZyJxdgTeacherCenterList(zyJxdgTeacherCenterList);
          pageList.add(vo);
      }

      // Step.4 AutoPoi 导出Excel
      ModelAndView mv = new ModelAndView(new JeecgEntityExcelView());
      mv.addObject(NormalExcelConstants.FILE_NAME, "教师填写教学大纲列表");
      mv.addObject(NormalExcelConstants.CLASS, ZyJxdgTeacherMainPage.class);
      mv.addObject(NormalExcelConstants.PARAMS, new ExportParams("教师填写教学大纲数据", "导出人:"+sysUser.getRealname(), "教师填写教学大纲"));
      mv.addObject(NormalExcelConstants.DATA_LIST, pageList);
      return mv;
    }

    /**
    * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("zyJxdgTeacherMain:zy_jxdg_teacher_main:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
      MultipartHttpServletRequest multipartRequest = (MultipartHttpServletRequest) request;
      Map<String, MultipartFile> fileMap = multipartRequest.getFileMap();
      for (Map.Entry<String, MultipartFile> entity : fileMap.entrySet()) {
          // 获取上传文件对象
          MultipartFile file = entity.getValue();
          ImportParams params = new ImportParams();
          params.setTitleRows(2);
          params.setHeadRows(1);
          params.setNeedSave(true);
          try {
              List<ZyJxdgTeacherMainPage> list = ExcelImportUtil.importExcel(file.getInputStream(), ZyJxdgTeacherMainPage.class, params);
              for (ZyJxdgTeacherMainPage page : list) {
                  ZyJxdgTeacherMain po = new ZyJxdgTeacherMain();
                  BeanUtils.copyProperties(page, po);
                  zyJxdgTeacherMainService.saveMain(po, page.getZyJxdgTeacherCenterList());
              }
              return Result.OK("文件导入成功！数据行数:" + list.size());
          } catch (Exception e) {
              log.error(e.getMessage(),e);
              return Result.error("文件导入失败:"+e.getMessage());
          } finally {
              try {
                  file.getInputStream().close();
              } catch (IOException e) {
                  e.printStackTrace();
              }
          }
      }
      return Result.OK("文件导入失败！");
    }



	 @PostMapping(value = "/addMap")
	 public Result<String> addMap(@RequestBody Map<String,Object> map) {
//		 ZyJxdgTeacherMain zyJxdgTeacherMain = new ZyJxdgTeacherMain();
//		 BeanUtils.copyProperties(zyJxdgTeacherMainPage, zyJxdgTeacherMain);
		 zyJxdgTeacherMainService.addMap(map);
		 return Result.OK("添加成功！");
	 }


	 @PostMapping(value = "/editMap")
	 public Result<String> editMap(@RequestBody Map<String,Object> map) {
		 zyJxdgTeacherMainService.editMap(map);
		 return Result.OK("添加成功！");
	 }



	 @ApiOperation(value="获取教学大纲教师填写信息", notes="获取教学大纲教师填写信息")
	 @GetMapping(value = "/queryByRwbhList")
	 public Result<List<ZyJxdgMain>> queryByRwbhList(@RequestParam(name="rwbh",required=true) String rwbh,@RequestParam(name="teacherNo",required=true) String teacherNo) {
		 List<ZyJxdgMain> list = zyJxdgTeacherMainService.queryByRwbhList(rwbh,teacherNo);
		 if(list==null) {
			 return Result.error("未找到对应数据");
		 }
		 return Result.OK(list);
	 }


	 @ApiOperation(value="获取教学大纲教师填写信息", notes="获取教学大纲教师填写信息")
	 @GetMapping(value = "/queryByRwbh")
	 public Result<ZyJxdgTeacherMain> queryByRwbh(ZyJxdgTeacherMain zyJxdgTeacherMain) {
		 QueryWrapper<ZyJxdgTeacherMain> queryWrapper = new QueryWrapper<>();
		 queryWrapper.eq("rwbh",zyJxdgTeacherMain.getRwbh());
//		 queryWrapper.eq("teacher_no",zyJxdgTeacherMain.getTeacherNo());
		 queryWrapper.last("limit 1");
		 ZyJxdgTeacherMain list = zyJxdgTeacherMainService.getOne(queryWrapper);
		 return Result.OK(list);
	 }


	 @ApiOperation(value="获取教学大纲教师填写信息", notes="获取教学大纲教师填写信息")
	 @GetMapping(value = "/queryZyJxdgMainListByMainId3")
	 public Result<List<ZyJxdgMain>> queryZyJxdgMainListByMainId3(ZyJxdgMain zyJxdgMain) {
		 List<ZyJxdgMain> list = zyJxdgTeacherMainService.queryZyJxdgMainListByMainId3(zyJxdgMain);
		 if(list==null) {
			 return Result.error("未找到对应数据");
		 }
		 return Result.OK(list);
	 }
}
