package org.jeecg.modules.kc.zyJxdgTeacherMain.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import org.apache.shiro.SecurityUtils;
import org.jeecg.common.system.vo.LoginUser;
import org.jeecg.common.util.text.StringUtils;
import org.jeecg.modules.kc.kcSysConfig.entity.KcSysConfig;
import org.jeecg.modules.kc.kcSysConfig.service.IKcSysConfigService;
import org.jeecg.modules.kc.ktgl.entity.KcKechengbiao;
import org.jeecg.modules.kc.ktgl.service.IKcKechengbiaoService;
import org.jeecg.modules.kc.zyJxdgBanben.entity.ZyJxdgBanben;
import org.jeecg.modules.kc.zyJxdgBanben.entity.ZyJxdgMain;
import org.jeecg.modules.kc.zyJxdgBanben.entity.ZyJxdgPzxx;
import org.jeecg.modules.kc.zyJxdgBanben.mapper.ZyJxdgBanbenMapper;
import org.jeecg.modules.kc.zyJxdgBanben.mapper.ZyJxdgMainMapper;
import org.jeecg.modules.kc.zyJxdgBanben.mapper.ZyJxdgPzxxMapper;
import org.jeecg.modules.kc.zyJxdgTeacherMain.entity.ZyJxdgTeacherMain;
import org.jeecg.modules.kc.zyJxdgTeacherMain.entity.ZyJxdgTeacherCenter;
import org.jeecg.modules.kc.zyJxdgTeacherMain.mapper.ZyJxdgTeacherCenterMapper;
import org.jeecg.modules.kc.zyJxdgTeacherMain.mapper.ZyJxdgTeacherMainMapper;
import org.jeecg.modules.kc.zyJxdgTeacherMain.service.IZyJxdgTeacherMainService;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;
import java.io.Serializable;
import java.util.*;

/**
 * @Description: 教师填写教学大纲
 * @Author: jeecg-boot
 * @Date:   2024-08-20
 * @Version: V1.0
 */
@Service
public class ZyJxdgTeacherMainServiceImpl extends ServiceImpl<ZyJxdgTeacherMainMapper, ZyJxdgTeacherMain> implements IZyJxdgTeacherMainService {

	@Autowired
	private ZyJxdgTeacherMainMapper zyJxdgTeacherMainMapper;
	@Autowired
	private ZyJxdgTeacherCenterMapper zyJxdgTeacherCenterMapper;

	@Autowired
	private ZyJxdgMainMapper zyJxdgMainMapper;
	@Autowired
	private ZyJxdgPzxxMapper zyJxdgPzxxMapper;
	@Autowired
	private IKcSysConfigService kcSysConfigService;
	@Autowired
	private IKcKechengbiaoService kcKechengbiaoService;
	@Autowired
	private ZyJxdgBanbenMapper zyJxdgBanbenMapper;
	
	@Override
	@Transactional(rollbackFor = Exception.class)
	public void saveMain(ZyJxdgTeacherMain zyJxdgTeacherMain, List<ZyJxdgTeacherCenter> zyJxdgTeacherCenterList) {
		zyJxdgTeacherMainMapper.insert(zyJxdgTeacherMain);
		if(zyJxdgTeacherCenterList!=null && zyJxdgTeacherCenterList.size()>0) {
			for(ZyJxdgTeacherCenter entity:zyJxdgTeacherCenterList) {
				//外键设置
				entity.setMainId(zyJxdgTeacherMain.getId());
				zyJxdgTeacherCenterMapper.insert(entity);
			}
		}
	}

	@Override
	@Transactional(rollbackFor = Exception.class)
	public void updateMain(ZyJxdgTeacherMain zyJxdgTeacherMain,List<ZyJxdgTeacherCenter> zyJxdgTeacherCenterList) {
		zyJxdgTeacherMainMapper.updateById(zyJxdgTeacherMain);
		
		//1.先删除子表数据
		zyJxdgTeacherCenterMapper.deleteByMainId(zyJxdgTeacherMain.getId());
		
		//2.子表数据重新插入
		if(zyJxdgTeacherCenterList!=null && zyJxdgTeacherCenterList.size()>0) {
			for(ZyJxdgTeacherCenter entity:zyJxdgTeacherCenterList) {
				//外键设置
				entity.setMainId(zyJxdgTeacherMain.getId());
				zyJxdgTeacherCenterMapper.insert(entity);
			}
		}
	}

	@Override
	@Transactional(rollbackFor = Exception.class)
	public void delMain(String id) {
		zyJxdgTeacherCenterMapper.deleteByMainId(id);
		zyJxdgTeacherMainMapper.deleteById(id);
	}

	@Override
	@Transactional(rollbackFor = Exception.class)
	public void delBatchMain(Collection<? extends Serializable> idList) {
		for(Serializable id:idList) {
			zyJxdgTeacherCenterMapper.deleteByMainId(id.toString());
			zyJxdgTeacherMainMapper.deleteById(id);
		}
	}

	@Override
	public void addMap(Map<String, Object> map) {
		KcSysConfig kcSysConfig = kcSysConfigService.getById("1");
		String rwbh = map.get("rwbh")+"";
		String banbenId = map.get("banbenId")+"";
		String teacherNo = map.get("teacherNo")+"";

		QueryWrapper<KcKechengbiao> kcKechengbiaoQueryWrapper = new QueryWrapper<>();
		kcKechengbiaoQueryWrapper.eq("xqxn",kcSysConfig.getFlag1());
		kcKechengbiaoQueryWrapper.eq("rwbh",rwbh);
		if(StringUtils.isNotEmpty(teacherNo)&&!StringUtils.equals(teacherNo,"null")){
			kcKechengbiaoQueryWrapper.eq("jgh",teacherNo);
		}
		kcKechengbiaoQueryWrapper.last("limit 1");
		KcKechengbiao kcKechengbiao = kcKechengbiaoService.getOne(kcKechengbiaoQueryWrapper);

		ZyJxdgBanben zyJxdgBanben = zyJxdgBanbenMapper.selectById(banbenId);


		String sffb = map.get("sffb")+"";
		String teacherName = kcKechengbiao.getSkjs();
		String kcmc = kcKechengbiao.getKcmc();
		String kkdw = kcKechengbiao.getKkdw();
		String kkdwid = kcKechengbiao.getKkdwid();
		String xkrs = kcKechengbiao.getXkrs();
		String xqxn = kcKechengbiao.getXqxn();
		teacherNo = kcKechengbiao.getJgh();
		String banbenName = zyJxdgBanben.getTitle();

		List<ZyJxdgTeacherCenter> zyJxdgTeacherCenterList = new ArrayList<>();
		List<Map<String,Object>> list = (List<Map<String, Object>>) map.get("list");
		for(Map<String,Object> par : list){
			String oneId = par.get("mainId")+"";
			String twoId = par.get("id")+"";
			if(StringUtils.equals(par.get("type")+"","3") || StringUtils.equals(par.get("type")+"","2") || StringUtils.equals(par.get("type")+"","1")){
				String content = par.get("content")+"";
				if(StringUtils.equals(content,"null")){
					content = "";
				}
				ZyJxdgTeacherCenter ZyJxdgTeacherCenter = new ZyJxdgTeacherCenter();
				ZyJxdgTeacherCenter.setOneId(oneId);
				ZyJxdgTeacherCenter.setTwoId(twoId);
				ZyJxdgTeacherCenter.setContent(content);
				ZyJxdgTeacherCenter.setType(par.get("type")+"");
				zyJxdgTeacherCenterList.add(ZyJxdgTeacherCenter);
			}else if(StringUtils.equals(par.get("type")+"","4")){
				List<Map<String,Object>> list2 = (List<Map<String, Object>>) par.get("zyJxdgPzxxList");
				if(list2!=null){
					for(Map<String,Object> par2 : list2){
						String threeId = par2.get("id")+"";
						String content = par2.get("content")+"";
						if(StringUtils.equals(content,"null")){
							content = "";
						}
						ZyJxdgTeacherCenter ZyJxdgTeacherCenter = new ZyJxdgTeacherCenter();
						ZyJxdgTeacherCenter.setOneId(oneId);
						ZyJxdgTeacherCenter.setTwoId(twoId);
						ZyJxdgTeacherCenter.setThreeId(threeId);
						ZyJxdgTeacherCenter.setContent(content);
						ZyJxdgTeacherCenter.setType(par.get("type")+"");
						zyJxdgTeacherCenterList.add(ZyJxdgTeacherCenter);
					}
				}
			}else if(StringUtils.equals(par.get("type")+"","5") || StringUtils.equals(par.get("type")+"","9") || StringUtils.equals(par.get("type")+"","10")|| StringUtils.equals(par.get("type")+"","11")|| StringUtils.equals(par.get("type")+"","13")|| StringUtils.equals(par.get("type")+"","14")|| StringUtils.equals(par.get("type")+"","15")){
				List<Map<String,Object>> list2 = (List<Map<String, Object>>) par.get("zyJxdgPzxxList");
				List<Map<String,Object>> list3 = (List<Map<String, Object>>) par.get("list");
				if(list2!=null && list3!=null){
					for(Map<String,Object> par2 : list2){
						for(Map<String,Object> par3 : list3){
							String threeId = par2.get("id")+"";
							String content = par3.get(threeId)+"";
							if(StringUtils.equals(content,"null")){
								content = "";
							}
							ZyJxdgTeacherCenter ZyJxdgTeacherCenter = new ZyJxdgTeacherCenter();
							ZyJxdgTeacherCenter.setOneId(oneId);
							ZyJxdgTeacherCenter.setTwoId(twoId);
							ZyJxdgTeacherCenter.setThreeId(threeId);
							ZyJxdgTeacherCenter.setContent(content);
							ZyJxdgTeacherCenter.setType(par.get("type")+"");
							zyJxdgTeacherCenterList.add(ZyJxdgTeacherCenter);
						}
					}

				}
			}else if(StringUtils.equals(par.get("type")+"","6") || StringUtils.equals(par.get("type")+"","7") || StringUtils.equals(par.get("type")+"","8")){
				List<Map<String,Object>> list2 = (List<Map<String, Object>>) par.get("list");
				if(list2!=null){
					for(Map<String,Object> par2 : list2){
						String content = par2.get("title")+"";
						if(StringUtils.equals(content,"null")){
							content = "";
						}
						ZyJxdgTeacherCenter ZyJxdgTeacherCenter = new ZyJxdgTeacherCenter();
						ZyJxdgTeacherCenter.setOneId(oneId);
						ZyJxdgTeacherCenter.setTwoId(twoId);
						ZyJxdgTeacherCenter.setContent(content);
						ZyJxdgTeacherCenter.setType(par.get("type")+"");
						zyJxdgTeacherCenterList.add(ZyJxdgTeacherCenter);
					}
				}
			}
			else if(StringUtils.equals(par.get("type")+"","12")){
				List<List<Map<String,Object>>> list2 = (List<List<Map<String, Object>>>) par.get("list2Map");
				for(List<Map<String,Object>> par2 : list2){
					for(Map<String,Object> par3 : par2){
						String threeId = par3.get("key")+"";
						String content = par3.get("title")+"";
						if(StringUtils.equals(content,"null")){
							content = "";
						}
						ZyJxdgTeacherCenter ZyJxdgTeacherCenter = new ZyJxdgTeacherCenter();
						ZyJxdgTeacherCenter.setOneId(oneId);
						ZyJxdgTeacherCenter.setTwoId(twoId);
						ZyJxdgTeacherCenter.setThreeId(threeId);
						ZyJxdgTeacherCenter.setContent(content);
						ZyJxdgTeacherCenter.setType(par.get("type")+"");
						zyJxdgTeacherCenterList.add(ZyJxdgTeacherCenter);
					}
				}
			}else if(StringUtils.equals(par.get("type")+"","13")){
				List<Map<String,Object>> list2 = (List<Map<String, Object>>) par.get("zyJxdgPzxxList");
				List<Map<String,Object>> list3 = (List<Map<String, Object>>) par.get("list");
				for(Map<String,Object> par2 : list2){
					for(Map<String,Object> par3 : list3){
						List<Map<String,Object>> map4 = (List<Map<String, Object>>) par3.get("list");
						for(Map<String,Object> par4 : map4){
							String threeId = par2.get("id")+"";
							String key = par4.get("key")+"";
							if(StringUtils.equals(threeId,key)){
								String content = par4.get("content")+"";
								if(StringUtils.equals(content,"null")){
									content = "";
								}else{
									if(content.indexOf("[")>-1){
										content = content.replace("[","");
										content = content.replace("]","");
									}
								}
								ZyJxdgTeacherCenter ZyJxdgTeacherCenter = new ZyJxdgTeacherCenter();
								ZyJxdgTeacherCenter.setOneId(oneId);
								ZyJxdgTeacherCenter.setTwoId(twoId);
								ZyJxdgTeacherCenter.setThreeId(threeId);
								ZyJxdgTeacherCenter.setContent(content);
								ZyJxdgTeacherCenter.setType(par4.get("type")+"");
								zyJxdgTeacherCenterList.add(ZyJxdgTeacherCenter);
							}

						}
					}
				}
			}
		}


		ZyJxdgTeacherMain zyJxdgTeacherMain = new ZyJxdgTeacherMain();
		zyJxdgTeacherMain.setRwbh(rwbh);
		zyJxdgTeacherMain.setBanbenId(banbenId);
		zyJxdgTeacherMain.setTeacherNo(teacherNo);
		zyJxdgTeacherMain.setTeacherName(teacherName);
		zyJxdgTeacherMain.setKcmc(kcmc);
		zyJxdgTeacherMain.setKkdw(kkdw);
		zyJxdgTeacherMain.setKkdwid(kkdwid);
		zyJxdgTeacherMain.setXkrs(xkrs);
		zyJxdgTeacherMain.setSffb("0");
		zyJxdgTeacherMain.setBanbenName(banbenName);
		zyJxdgTeacherMain.setXqxn(xqxn);


		zyJxdgTeacherMainMapper.insert(zyJxdgTeacherMain);
		if(zyJxdgTeacherCenterList!=null && zyJxdgTeacherCenterList.size()>0) {
			for(ZyJxdgTeacherCenter entity:zyJxdgTeacherCenterList) {
				//外键设置
				entity.setMainId(zyJxdgTeacherMain.getId());
				zyJxdgTeacherCenterMapper.insert(entity);
			}
		}
	}

	@Override
	public List<ZyJxdgMain> queryByRwbhList(String rwbh,String teacherNo) {

		QueryWrapper<ZyJxdgTeacherMain> queryWrapper = new QueryWrapper<>();
		queryWrapper.eq("rwbh",rwbh);
//		queryWrapper.eq("teacher_no",teacherNo);
		queryWrapper.last("limit 1");
		ZyJxdgTeacherMain zyJxdgTeacherMain= zyJxdgTeacherMainMapper.selectOne(queryWrapper);
		List<ZyJxdgTeacherCenter> conlist = zyJxdgTeacherCenterMapper.selectByMainId(zyJxdgTeacherMain.getId());

		List<ZyJxdgMain> list = zyJxdgMainMapper.selectByMainId(zyJxdgTeacherMain.getBanbenId());
		for(ZyJxdgMain par : list){
			List<ZyJxdgPzxx> list2 = zyJxdgPzxxMapper.selectByTwoMainId(par.getId());
			List<Map<String,Object>> listMap = new ArrayList<>();
			List<List<Map<String,Object>>> list2Map = new ArrayList<>();
			if(StringUtils.equals(par.getType(),"4")){
				for(ZyJxdgPzxx par2 : list2){
					for(ZyJxdgTeacherCenter par3 : conlist){
						if(StringUtils.equals(par2.getId(),par3.getThreeId())){
							par2.setContent(par3.getContent());
						}
					}
				}
			}else if(StringUtils.equals(par.getType(),"6") || StringUtils.equals(par.getType(),"7") || StringUtils.equals(par.getType(),"8")){
				for(ZyJxdgTeacherCenter par3 : conlist){
					if(StringUtils.equals(par.getId(),par3.getTwoId())&&StringUtils.isEmpty(par3.getThreeId())){
						Map<String,Object> map = new HashMap<>();
						map.put("title", par3.getContent());
						listMap.add(map);
					}
				}
			}else if(StringUtils.equals(par.getType(),"5") || StringUtils.equals(par.getType(),"9")|| StringUtils.equals(par.getType(),"10")|| StringUtils.equals(par.getType(),"11")|| StringUtils.equals("14",par.getType())|| StringUtils.equals("15",par.getType())) {

				List<Map<String,Object>> listmap2 =  new ArrayList<>();
				for(int i=0;i< list2.size();i++){
					int j=0;
					ZyJxdgPzxx par2 = list2.get(i);
					for(ZyJxdgTeacherCenter par3 : conlist){
						if(StringUtils.equals(par2.getId(),par3.getThreeId())) {
							Map<String, Object> map3 = new HashMap<>();
							if(i==0){
								map3.put(par2.getId(), par3.getContent());
								listmap2.add(map3);
							}else{
								listmap2.get(j).put(par3.getThreeId(), par3.getContent());
							}
							j++;
						}
					}
				}
				listMap = listmap2;
			}else if(StringUtils.equals("12",par.getType())){
				List<List<Map<String,Object>>> listmap2 =  new ArrayList<>();
				for(int i=0;i< list2.size();i++){
					ZyJxdgPzxx par2 = list2.get(i);
					int j=0;
					for(ZyJxdgTeacherCenter par3 : conlist){
						if(StringUtils.equals(par2.getId(),par3.getThreeId())) {

							List<Map<String,Object>> map3 =  new ArrayList<>();
							Map<String, Object> map4 = new HashMap<>();
							map4.put("key", par3.getThreeId());
							map4.put("title", par3.getContent());
							if(i==0){
								map3.add(map4);
								listmap2.add(map3);
							}else{
								listmap2.get(j).add(map4);
							}
							j++;
						}
					}

				}
				list2Map = listmap2;
			}else if(StringUtils.equals("13",par.getType())){
				List<Map<String,Object>> listmap2 =  new ArrayList<>();

				for(int i=0;i< list2.size();i++){
					int j=0;
					ZyJxdgPzxx par2 = list2.get(i);
					for(ZyJxdgTeacherCenter par3 : conlist){
						if(StringUtils.equals(par2.getId(),par3.getThreeId())) {



							if(i==0){
								Map<String,Object> map = new HashMap<>();
								List<Map<String,Object>> listmap3333 =  new ArrayList<>();
								Map<String,Object> map3 = new HashMap<>();
								map3.put("title", par2.getTitle());
								map3.put("type", par3.getType());
								map3.put("content", par3.getContent());
								map3.put("key", par3.getThreeId());
								listmap3333.add(map3);
								map.put("list", listmap3333);
								listmap2.add(map);
							}else{
								Map<String,Object> map = new HashMap<>();
								List<Map<String,Object>> listmap3333 = (List<Map<String, Object>>) listmap2.get(j).get("list");
								Map<String,Object> map3 = new HashMap<>();
								map3.put("title", par2.getTitle());
								map3.put("type", par3.getType());
								map3.put("content", par3.getContent());
								map3.put("key", par3.getThreeId());
								listmap3333.add(map3);
								map.put("list", listmap3333);
//								listmap2.get(j) = map;
//								listmap2.get(j).put(par3.getThreeId(), par3.getContent());
							}

							j++;
						}
					}
				}





				listMap = listmap2;
			}
			else{
				for(ZyJxdgTeacherCenter par3 : conlist){
					if(StringUtils.equals(par.getId(),par3.getTwoId())&&StringUtils.isEmpty(par3.getThreeId())){
						par.setContent(par3.getContent());
					}
				}
			}
			par.setList(listMap);
			par.setList2Map(list2Map);
			par.setZyJxdgPzxxList(list2);
		}


		return list;
	}

	@Override
	public void editMap(Map<String, Object> map) {
		String id = map.get("id")+"";
		String banbenId = map.get("banbenId")+"";
		String sffb = map.get("sffb")+"";

		List<ZyJxdgTeacherCenter> zyJxdgTeacherCenterList = new ArrayList<>();
		List<Map<String,Object>> list = (List<Map<String, Object>>) map.get("list");
		for(Map<String,Object> par : list){
			String oneId = par.get("mainId")+"";
			String twoId = par.get("id")+"";
			if(StringUtils.equals(par.get("type")+"","3") || StringUtils.equals(par.get("type")+"","2") || StringUtils.equals(par.get("type")+"","1")){
				String content = par.get("content")+"";
				if(StringUtils.equals(content,"null")){
					content = "";
				}
				ZyJxdgTeacherCenter ZyJxdgTeacherCenter = new ZyJxdgTeacherCenter();
				ZyJxdgTeacherCenter.setOneId(oneId);
				ZyJxdgTeacherCenter.setTwoId(twoId);
				ZyJxdgTeacherCenter.setContent(content);
				ZyJxdgTeacherCenter.setType(par.get("type")+"");
				zyJxdgTeacherCenterList.add(ZyJxdgTeacherCenter);
			}else if(StringUtils.equals(par.get("type")+"","4")){
				List<Map<String,Object>> list2 = (List<Map<String, Object>>) par.get("zyJxdgPzxxList");
				for(Map<String,Object> par2 : list2){
					String threeId = par2.get("id")+"";
					String content = par2.get("content")+"";
					if(StringUtils.equals(content,"null")){
						content = "";
					}
					ZyJxdgTeacherCenter ZyJxdgTeacherCenter = new ZyJxdgTeacherCenter();
					ZyJxdgTeacherCenter.setOneId(oneId);
					ZyJxdgTeacherCenter.setTwoId(twoId);
					ZyJxdgTeacherCenter.setThreeId(threeId);
					ZyJxdgTeacherCenter.setContent(content);
					ZyJxdgTeacherCenter.setType(par.get("type")+"");
					zyJxdgTeacherCenterList.add(ZyJxdgTeacherCenter);
				}
			}else if(StringUtils.equals(par.get("type")+"","5") || StringUtils.equals(par.get("type")+"","9") || StringUtils.equals(par.get("type")+"","10")|| StringUtils.equals(par.get("type")+"","11")|| StringUtils.equals(par.get("type")+"","14")|| StringUtils.equals(par.get("type")+"","15")){
				List<Map<String,Object>> list2 = (List<Map<String, Object>>) par.get("zyJxdgPzxxList");
				List<Map<String,Object>> list3 = (List<Map<String, Object>>) par.get("list");
				for(Map<String,Object> par2 : list2){
					for(Map<String,Object> par3 : list3){
//						if(StringUtils.equals(par2.get("id")+"",par3.get(par2.get("id")+"")+"")){
						String threeId = par2.get("id")+"";
						String content = par3.get(threeId)+"";
						if(StringUtils.equals(content,"null")){
							content = "";
						}
						ZyJxdgTeacherCenter ZyJxdgTeacherCenter = new ZyJxdgTeacherCenter();
						ZyJxdgTeacherCenter.setOneId(oneId);
						ZyJxdgTeacherCenter.setTwoId(twoId);
						ZyJxdgTeacherCenter.setThreeId(threeId);
						ZyJxdgTeacherCenter.setContent(content);
						ZyJxdgTeacherCenter.setType(par.get("type")+"");
						zyJxdgTeacherCenterList.add(ZyJxdgTeacherCenter);
//						}
					}
				}
			}else if(StringUtils.equals(par.get("type")+"","6") || StringUtils.equals(par.get("type")+"","7") || StringUtils.equals(par.get("type")+"","8")){
				List<Map<String,Object>> list2 = (List<Map<String, Object>>) par.get("list");
				for(Map<String,Object> par2 : list2){
					String content = par2.get("title")+"";
					if(StringUtils.equals(content,"null")){
						content = "";
					}
					ZyJxdgTeacherCenter ZyJxdgTeacherCenter = new ZyJxdgTeacherCenter();
					ZyJxdgTeacherCenter.setOneId(oneId);
					ZyJxdgTeacherCenter.setTwoId(twoId);
					ZyJxdgTeacherCenter.setContent(content);
					ZyJxdgTeacherCenter.setType(par.get("type")+"");
					zyJxdgTeacherCenterList.add(ZyJxdgTeacherCenter);
				}
			}
			else if(StringUtils.equals(par.get("type")+"","12")){
				List<List<Map<String,Object>>> list2 = (List<List<Map<String, Object>>>) par.get("list2Map");
				for(List<Map<String,Object>> par2 : list2){
					for(Map<String,Object> par3 : par2){
						String threeId = par3.get("key")+"";
						String content = par3.get("title")+"";
						if(StringUtils.equals(content,"null")){
							content = "";
						}
						ZyJxdgTeacherCenter ZyJxdgTeacherCenter = new ZyJxdgTeacherCenter();
						ZyJxdgTeacherCenter.setOneId(oneId);
						ZyJxdgTeacherCenter.setTwoId(twoId);
						ZyJxdgTeacherCenter.setThreeId(threeId);
						ZyJxdgTeacherCenter.setContent(content);
						ZyJxdgTeacherCenter.setType(par.get("type")+"");
						zyJxdgTeacherCenterList.add(ZyJxdgTeacherCenter);
					}
				}
			}else if(StringUtils.equals(par.get("type")+"","13")){
				List<Map<String,Object>> list2 = (List<Map<String, Object>>) par.get("zyJxdgPzxxList");
				List<Map<String,Object>> list3 = (List<Map<String, Object>>) par.get("list");
				for(Map<String,Object> par2 : list2){
					for(Map<String,Object> par3 : list3){
						List<Map<String,Object>> map4 = (List<Map<String, Object>>) par3.get("list");
						for(Map<String,Object> par4 : map4){
							String threeId = par2.get("id")+"";
							String key = par4.get("key")+"";
							if(StringUtils.equals(threeId,key)){
								String content = par4.get("content")+"";
								if(StringUtils.equals(content,"null")){
									content = "";
								}else{
									if(content.indexOf("[")>-1){
										content = content.replace("[","");
										content = content.replace("]","");
									}
								}
								ZyJxdgTeacherCenter ZyJxdgTeacherCenter = new ZyJxdgTeacherCenter();
								ZyJxdgTeacherCenter.setOneId(oneId);
								ZyJxdgTeacherCenter.setTwoId(twoId);
								ZyJxdgTeacherCenter.setThreeId(threeId);
								ZyJxdgTeacherCenter.setContent(content);
								ZyJxdgTeacherCenter.setType(par4.get("type")+"");
								zyJxdgTeacherCenterList.add(ZyJxdgTeacherCenter);
							}

						}
					}
				}
			}
		}


		ZyJxdgTeacherMain zyJxdgTeacherMain = new ZyJxdgTeacherMain();
		zyJxdgTeacherMain.setBanbenId(banbenId);
		zyJxdgTeacherMain.setId(id);
		zyJxdgTeacherMainMapper.updateById(zyJxdgTeacherMain);
		zyJxdgTeacherCenterMapper.deleteByMainId(id);
		if(zyJxdgTeacherCenterList!=null && zyJxdgTeacherCenterList.size()>0) {
			for(ZyJxdgTeacherCenter entity:zyJxdgTeacherCenterList) {
				//外键设置
				entity.setMainId(zyJxdgTeacherMain.getId());
				zyJxdgTeacherCenterMapper.insert(entity);
			}
		}
	}

	@Override
	public List<ZyJxdgMain> queryZyJxdgMainListByMainId3(ZyJxdgMain zyJxdgMain) {

		QueryWrapper<ZyJxdgTeacherMain> queryWrapper = new QueryWrapper<>();
		queryWrapper.eq("rwbh",zyJxdgMain.getRwbh());
		queryWrapper.eq("teacher_no",zyJxdgMain.getTeacherNo());
		queryWrapper.last("limit 1");
		ZyJxdgTeacherMain zyJxdgTeacherMain= zyJxdgTeacherMainMapper.selectOne(queryWrapper);
		List<ZyJxdgTeacherCenter> conlist = new ArrayList<>();
		if(zyJxdgTeacherMain!=null){
			conlist = zyJxdgTeacherCenterMapper.selectByMainId(zyJxdgTeacherMain.getId());
		}


		List<ZyJxdgMain> list = zyJxdgMainMapper.selectByMainId(zyJxdgMain.getMainId());
		for(ZyJxdgMain par : list){
			List<ZyJxdgPzxx> list2 = zyJxdgPzxxMapper.selectByTwoMainId(par.getId());
			List<Map<String,Object>> listMap = new ArrayList<>();
			List<List<Map<String,Object>>> list2Map = new ArrayList<>();
			if(StringUtils.equals(par.getType(),"4")){
				for(ZyJxdgPzxx par2 : list2){
					for(ZyJxdgTeacherCenter par3 : conlist){
						if(StringUtils.equals(par2.getId(),par3.getThreeId())){
							par2.setContent(par3.getContent());
						}
					}
				}
			}else if(StringUtils.equals(par.getType(),"6") || StringUtils.equals(par.getType(),"7") || StringUtils.equals(par.getType(),"8")){
				for(ZyJxdgTeacherCenter par3 : conlist){
					if(StringUtils.equals(par.getId(),par3.getTwoId())&&StringUtils.isEmpty(par3.getThreeId())){
						Map<String,Object> map = new HashMap<>();
						map.put("title", par3.getContent());
						listMap.add(map);
					}
				}
			}else if(StringUtils.equals(par.getType(),"5") || StringUtils.equals(par.getType(),"9")|| StringUtils.equals(par.getType(),"10")|| StringUtils.equals(par.getType(),"11")|| StringUtils.equals("14",par.getType())|| StringUtils.equals("15",par.getType())) {

				List<Map<String,Object>> listmap2 =  new ArrayList<>();
				for(int i=0;i< list2.size();i++){
					int j=0;
					ZyJxdgPzxx par2 = list2.get(i);
					for(ZyJxdgTeacherCenter par3 : conlist){
						if(StringUtils.equals(par2.getId(),par3.getThreeId())) {
							Map<String, Object> map3 = new HashMap<>();
							if(i==0){
								map3.put(par2.getId(), par3.getContent());
								listmap2.add(map3);
							}else{
								listmap2.get(j).put(par3.getThreeId(), par3.getContent());
							}
							j++;
						}
					}
				}
				listMap = listmap2;
			}else if(StringUtils.equals("12",par.getType())){
				List<List<Map<String,Object>>> listmap2 =  new ArrayList<>();
				for(int i=0;i< list2.size();i++){
					ZyJxdgPzxx par2 = list2.get(i);
					int j=0;
					for(ZyJxdgTeacherCenter par3 : conlist){
						if(StringUtils.equals(par2.getId(),par3.getThreeId())) {

							List<Map<String,Object>> map3 =  new ArrayList<>();
							Map<String, Object> map4 = new HashMap<>();
							map4.put("key", par3.getThreeId());
							map4.put("title", par3.getContent());
							if(i==0){
								map3.add(map4);
								listmap2.add(map3);
							}else{
								listmap2.get(j).add(map4);
							}
							j++;
						}
					}

				}
				list2Map = listmap2;
			}else if(StringUtils.equals("13",par.getType())){
				List<Map<String,Object>> listmap2 =  new ArrayList<>();

				for(int i=0;i< list2.size();i++){
					int j=0;
					ZyJxdgPzxx par2 = list2.get(i);
					for(ZyJxdgTeacherCenter par3 : conlist){
						if(StringUtils.equals(par2.getId(),par3.getThreeId())) {



							if(i==0){
								Map<String,Object> map = new HashMap<>();
								List<Map<String,Object>> listmap3333 =  new ArrayList<>();
								Map<String,Object> map3 = new HashMap<>();
								map3.put("title", par2.getTitle());
								map3.put("type", par3.getType());
								map3.put("content", par3.getContent());
								map3.put("key", par3.getThreeId());
								listmap3333.add(map3);
								map.put("list", listmap3333);
								listmap2.add(map);
							}else{
								Map<String,Object> map = new HashMap<>();
								List<Map<String,Object>> listmap3333 = (List<Map<String, Object>>) listmap2.get(j).get("list");
								Map<String,Object> map3 = new HashMap<>();
								map3.put("title", par2.getTitle());
								map3.put("type", par3.getType());
								map3.put("content", par3.getContent());
								map3.put("key", par3.getThreeId());
								listmap3333.add(map3);
								map.put("list", listmap3333);
//								listmap2.get(j) = map;
//								listmap2.get(j).put(par3.getThreeId(), par3.getContent());
							}

							j++;
						}
					}
				}





				listMap = listmap2;
			}
			else{
				for(ZyJxdgTeacherCenter par3 : conlist){
					if(StringUtils.equals(par.getId(),par3.getTwoId())&&StringUtils.isEmpty(par3.getThreeId())){
						par.setContent(par3.getContent());
					}
				}
			}
			par.setList(listMap);
			par.setList2Map(list2Map);
			par.setZyJxdgPzxxList(list2);
		}



		return list;
	}

}
