package org.jeecg.modules.kc.zyJxdgTeacherMain.vo;

import java.util.List;
import org.jeecg.modules.kc.zyJxdgTeacherMain.entity.ZyJxdgTeacherMain;
import org.jeecg.modules.kc.zyJxdgTeacherMain.entity.ZyJxdgTeacherCenter;
import lombok.Data;
import org.jeecgframework.poi.excel.annotation.Excel;
import org.jeecgframework.poi.excel.annotation.ExcelEntity;
import org.jeecgframework.poi.excel.annotation.ExcelCollection;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;
import java.util.Date;
import org.jeecg.common.aspect.annotation.Dict;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

/**
 * @Description: 教师填写教学大纲
 * @Author: jeecg-boot
 * @Date:   2024-08-20
 * @Version: V1.0
 */
@Data
@ApiModel(value="zy_jxdg_teacher_mainPage对象", description="教师填写教学大纲")
public class ZyJxdgTeacherMainPage {

	/**id*/
	@ApiModelProperty(value = "id")
    private java.lang.String id;
	/**createBy*/
	@ApiModelProperty(value = "createBy")
    private java.lang.String createBy;
	/**createTime*/
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd")
    @DateTimeFormat(pattern="yyyy-MM-dd")
	@ApiModelProperty(value = "createTime")
    private java.util.Date createTime;
	/**updateBy*/
	@ApiModelProperty(value = "updateBy")
    private java.lang.String updateBy;
	/**updateTime*/
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd")
    @DateTimeFormat(pattern="yyyy-MM-dd")
	@ApiModelProperty(value = "updateTime")
    private java.util.Date updateTime;
	/**版本id*/
	@Excel(name = "版本id", width = 15, dictTable = "zy_jxdg_banben", dicText = "title", dicCode = "id")
    @Dict(dictTable = "zy_jxdg_banben", dicText = "title", dicCode = "id")
	@ApiModelProperty(value = "版本id")
    private java.lang.String banbenId;
	/**是否发布（0未发布 1已发布）*/
	@Excel(name = "是否发布（0未发布 1已发布）", width = 15, dicCode = "yn")
    @Dict(dicCode = "yn")
	@ApiModelProperty(value = "是否发布（0未发布 1已发布）")
    private java.lang.String sffb;
	/**任务编号*/
	@Excel(name = "任务编号", width = 15)
	@ApiModelProperty(value = "任务编号")
    private java.lang.String rwbh;
	/**教师工号*/
	@Excel(name = "教师工号", width = 15)
	@ApiModelProperty(value = "教师工号")
    private java.lang.String teacherNo;
	/**教师姓名*/
	@Excel(name = "教师姓名", width = 15)
	@ApiModelProperty(value = "教师姓名")
    private java.lang.String teacherName;
	/**课程名称*/
	@Excel(name = "课程名称", width = 15)
	@ApiModelProperty(value = "课程名称")
    private java.lang.String kcmc;
	/**开课单位*/
	@Excel(name = "开课单位", width = 15)
	@ApiModelProperty(value = "开课单位")
    private java.lang.String kkdw;
	/**开课单位id*/
	@Excel(name = "开课单位id", width = 15)
	@ApiModelProperty(value = "开课单位id")
    private java.lang.String kkdwid;
	/**选课人数*/
	@Excel(name = "选课人数", width = 15)
	@ApiModelProperty(value = "选课人数")
    private java.lang.String xkrs;

	/**学期学年*/
	@Excel(name = "学期学年", width = 15)
	@ApiModelProperty(value = "学期学年")
	private java.lang.String xqxn;
	/**版本名称*/
	@Excel(name = "版本名称", width = 15)
	@ApiModelProperty(value = "版本名称")
	private java.lang.String banbenName;
	/**发布名称*/
	@Excel(name = "发布名称", width = 15)
	@ApiModelProperty(value = "发布名称")
	private java.lang.String fbName;

	@ExcelCollection(name="教师填写教学大纲内容")
	@ApiModelProperty(value = "教师填写教学大纲内容")
	private List<ZyJxdgTeacherCenter> zyJxdgTeacherCenterList;

}
