package org.jeecg.modules.kc.zyTlq.controller;

import java.util.Arrays;
import java.util.Date;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.lang.StringUtils;
import org.apache.shiro.SecurityUtils;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.system.vo.LoginUser;
import org.jeecg.common.util.DateUtils;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.kc.config.entity.KcExportConfigTpkwcqkjzglx;
import org.jeecg.modules.kc.config.service.IKcExportConfigTpkwcqkjzglxService;
import org.jeecg.modules.kc.grab.imports.entity.Xxhbbks;
import org.jeecg.modules.kc.grab.imports.service.IXxhbbksService;
import org.jeecg.modules.kc.kcSysConfig.entity.KcSysConfig;
import org.jeecg.modules.kc.kcSysConfig.service.IKcSysConfigService;
import org.jeecg.modules.kc.wjxDjxx.entity.StudentCyglSys;
import org.jeecg.modules.kc.wjxWjxx.entity.WjxWjxx;
import org.jeecg.modules.kc.zyDbtx.entity.ZyDbtx;
import org.jeecg.modules.kc.zyDbtx.service.IZyDbtxService;
import org.jeecg.modules.kc.zyTlq.entity.ZyTlq;
import org.jeecg.modules.kc.zyTlq.entity.ZyTlqSys;
import org.jeecg.modules.kc.zyTlq.service.IZyTlqService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecg.modules.system.service.impl.SysBaseApiImpl;
import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

 /**
 * @Description: 讨论区
 * @Author: jeecg-boot
 * @Date:   2024-05-20
 * @Version: V1.0
 */
@Api(tags="讨论区")
@RestController
@RequestMapping("/zyTlq/zyTlq")
@Slf4j
public class ZyTlqController extends JeecgController<ZyTlq, IZyTlqService> {
	@Autowired
	private IZyTlqService zyTlqService;

	 @Autowired
	 private IXxhbbksService xxhbbksService;

	 @Autowired
	 private IZyDbtxService zyDbtxService;

	 @Autowired
	 private SysBaseApiImpl sysBaseApi;
	 @Autowired
	 private IKcExportConfigTpkwcqkjzglxService kcExportConfigTpkwcqkjzglxService;
	 @Autowired
	 private IKcSysConfigService kcSysConfigService;
	
	/**
	 * 分页列表查询
	 *
	 * @param zyTlq
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "讨论区-分页列表查询")
	@ApiOperation(value="讨论区-分页列表查询", notes="讨论区-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<ZyTlq>> queryPageList(ZyTlq zyTlq,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<ZyTlq> queryWrapper = QueryGenerator.initQueryWrapper(zyTlq, req.getParameterMap());
		Page<ZyTlq> page = new Page<ZyTlq>(pageNo, pageSize);
		queryWrapper.eq(StringUtils.isNotBlank(zyTlq.getTeano()),"create_by",zyTlq.getTeano());
		IPage<ZyTlq> pageList = zyTlqService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param zyTlq
	 * @return
	 */
	@AutoLog(value = "讨论区-添加")
	@ApiOperation(value="讨论区-添加", notes="讨论区-添加")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody ZyTlq zyTlq) {
		zyTlqService.save(zyTlq);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param zyTlq
	 * @return
	 */
	@AutoLog(value = "讨论区-编辑")
	@ApiOperation(value="讨论区-编辑", notes="讨论区-编辑")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody ZyTlq zyTlq) {
		zyTlqService.updateById(zyTlq);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "讨论区-通过id删除")
	@ApiOperation(value="讨论区-通过id删除", notes="讨论区-通过id删除")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		zyTlqService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "讨论区-批量删除")
	@ApiOperation(value="讨论区-批量删除", notes="讨论区-批量删除")
	@RequiresPermissions("zyTlq:zy_tlq:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.zyTlqService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "讨论区-通过id查询")
	@ApiOperation(value="讨论区-通过id查询", notes="讨论区-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<ZyTlq> queryById(@RequestParam(name="id",required=true) String id) {
		ZyTlq zyTlq = zyTlqService.getById(id);
		if(zyTlq==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(zyTlq);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param zyTlq
    */
    @RequiresPermissions("zyTlq:zy_tlq:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, ZyTlq zyTlq) {
        return super.exportXls(request, zyTlq, ZyTlq.class, "讨论区");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("zyTlq:zy_tlq:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, ZyTlq.class);
    }


	 @AutoLog(value = "讨论区-发布")
	 @ApiOperation(value="讨论区-发布", notes="讨论区-发布")
	 @RequestMapping(value = "/editFbtl", method = {RequestMethod.PUT,RequestMethod.POST})
	 public Result<String> editFbtl(@RequestBody ZyTlq zyTlq) {
		 zyTlqService.updateById(zyTlq);



		 ZyTlq par=zyTlqService.getByKechengId(zyTlq.getId());
		 QueryWrapper<Xxhbbks> queryWrapper = new QueryWrapper<>();
		 queryWrapper.apply("a.xh = b.xh");
		 queryWrapper.eq("b.KCAPZBBH",par.getRwbh());
		 List<Xxhbbks> list = xxhbbksService.getXsxkbAllList(queryWrapper);
		 LoginUser user = (LoginUser) SecurityUtils.getSubject().getPrincipal();
		 for(Xxhbbks xxhbbks:list){

			 //作业代办提醒
			 ZyDbtx zyDbtx = new ZyDbtx();
			 zyDbtx.setCreateBy(xxhbbks.getXh());
			 zyDbtx.setType("4");//0发布作业 1评分 2测验 3问卷 4讨论
			 zyDbtx.setMainId(par.getId());
			 zyDbtx.setRwbh(par.getRwbh());
//			 zyDbtx.setContent(" ["+par.getKcmc()+"] "+par.getSkjs()+" 发布了一篇新的讨论，请及时参与！");
			 zyDbtx.setContent(user.getRealname()+"教师发起了["+par.getKcmc()+"]课程“"+par.getTitle()+"”的讨论，请及时参与讨论。发布时间："+DateUtils.formatDate(new Date(),"yyyy-MM-dd HH:mm:ss"));
			 zyDbtx.setFlag("0");
			 zyDbtx.setFbr(user.getUsername());
			 zyDbtxService.save(zyDbtx);

		 }

		 return Result.OK("编辑成功!");
	 }



	 @ApiOperation(value="教学大纲-分页列表查询", notes="教学大纲-分页列表查询")
	 @GetMapping(value = "/sysList")
	 public Result<IPage<ZyTlqSys>> sysList(ZyTlqSys zyTlqSys,
											@RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
											@RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
											HttpServletRequest req) {
		 LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
		 //-------------获取当前登陆人是否是管理员角色，如果不是都按照教务秘书处理---------------------------
		 List<String> roleList = sysBaseApi.getRolesByUsername(sysUser.getUsername());
		 String adminRole = "1";//0 admin  1教务秘书
		 for(String role :roleList){
			 if(org.apache.commons.lang.StringUtils.equals("admin",role)){
				 adminRole = "0";
				 break;
			 }
		 }
		 QueryWrapper<ZyTlqSys> queryWrapper = new QueryWrapper<ZyTlqSys>();
		 if(org.apache.commons.lang.StringUtils.equals("1",adminRole)){
			 QueryWrapper<KcExportConfigTpkwcqkjzglx> queryWrapperCon = new QueryWrapper<KcExportConfigTpkwcqkjzglx>();
			 queryWrapperCon.eq("gh",sysUser.getUsername());
			 queryWrapperCon.orderByDesc("create_time");
			 queryWrapperCon.last("limit 1");
			 KcExportConfigTpkwcqkjzglx kcExportConfigTpkwcqkjzglx = kcExportConfigTpkwcqkjzglxService.getOne(queryWrapperCon);
			 queryWrapper.eq("kkdw",kcExportConfigTpkwcqkjzglx.getDwmc());
		 }

		 if(com.baomidou.mybatisplus.core.toolkit.StringUtils.isEmpty(zyTlqSys.getXqxn())){
			 KcSysConfig kcSysConfig = kcSysConfigService.getById("1");
			 queryWrapper.eq("xqxn",kcSysConfig.getFlag1());
		 }else{
			 queryWrapper.eq("xqxn",zyTlqSys.getXqxn());
		 }
		 queryWrapper.like(com.baomidou.mybatisplus.core.toolkit.StringUtils.isNotEmpty(zyTlqSys.getKkdw()),"kkdw",zyTlqSys.getKkdw());
		 queryWrapper.like(com.baomidou.mybatisplus.core.toolkit.StringUtils.isNotEmpty(zyTlqSys.getKcmc()),"kcmc",zyTlqSys.getKcmc());
		 queryWrapper.like(com.baomidou.mybatisplus.core.toolkit.StringUtils.isNotEmpty(zyTlqSys.getKcbh()),"kcbh",zyTlqSys.getKcbh());
		 queryWrapper.like(com.baomidou.mybatisplus.core.toolkit.StringUtils.isNotEmpty(zyTlqSys.getSkjs()),"skjs",zyTlqSys.getSkjs());


		 Page<ZyTlqSys> page = new Page<ZyTlqSys>(pageNo, pageSize);
		 IPage<ZyTlqSys> pageList = service.sysList(page, queryWrapper,zyTlqSys);
		 return Result.OK(pageList);
	 }
}
