package org.jeecg.modules.tencent.utils;

import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.tencentcloudapi.wemeet.client.MeetingClient;
import com.tencentcloudapi.wemeet.client.UserClient;
import com.tencentcloudapi.wemeet.common.RequestSender;
import com.tencentcloudapi.wemeet.common.constants.InstanceEnum;
import com.tencentcloudapi.wemeet.common.exception.WemeetSdkException;
import com.tencentcloudapi.wemeet.common.profile.HttpProfile;
import com.tencentcloudapi.wemeet.models.MeetingSetting;
import com.tencentcloudapi.wemeet.models.User;
import com.tencentcloudapi.wemeet.models.meeting.CreateMeetingRequest;
import com.tencentcloudapi.wemeet.models.meeting.QueryMeetingDetailResponse;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.lang3.StringUtils;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.base.controller.JeecgController;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.DateUtils;
import org.jeecg.modules.kc.KcBdgxbcopy.entity.KcBdgxbcopy;
import org.jeecg.modules.kc.KcBdgxbcopy.service.IKcBdgxbcopyService;
import org.jeecg.modules.kc.ktgl.entity.KcKetangbiao;
import org.jeecg.modules.kc.ktgl.service.IKcKetangbiaoService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

@RestController
@RequestMapping("/tencentUtil")
public class TencentUtils   extends JeecgController<KcKetangbiao, IKcKetangbiaoService> {
    @Autowired
    private IKcKetangbiaoService kcKetangbiaoService;

    private static final Log log = LogFactory.getLog(TencentUtils.class);
    // 初始化全局client
    /**
     * 初始化全局会议client
     */
    private static final MeetingClient MEETING_CLIENT;
    /**
     * 初始化全局用户client
     */
    private static final UserClient USER_CLIENT;
    private static final Gson GSON = new GsonBuilder().excludeFieldsWithoutExposeAnnotation().create();

    @Autowired
    private IKcBdgxbcopyService kcBdgxbcopyService;

    private static final String AppId = "214887356";
//    private static final String AppId = "wxafdbb51ba3aa614d";
    private static final String AppSecret = "bdf346ae8b986e9fa5d33b2e4495b27e";
    private static final String SdkId = "21830121448";
    private static final String SecretId = "TolxEfbUvmipPU28J7fwXq40Bxpguv70";
    private static final String SecretKey = "Hr2RJSYHWAicJrHH4imSphIXnLZhgG3rYmE2UrI484qjuBwJ";



    static {
        HttpProfile profile = new HttpProfile();
        // 腾讯会议分配给三方开发应用的 App ID。企业管理员可以登录 腾讯会议官网，单击右上角【用户中心】
        // 在左侧菜单栏中的【企业管理】>【高级】>【restApi】中进行查看。
        profile.setAppId(AppId);
        // 用户子账号或开发的应用 ID，企业管理员可以登录 腾讯会议官网，单击右上角【用户中心】
        // 在左侧菜单栏中的【企业管理】>【高级】>【restApi】中进行查看（如存在 SdkId 则必须填写，早期申请 API 且未分配 SdkId 的客户可不填写）。
        profile.setSdkId(SdkId);
        // 请求域名
        profile.setHost("https://api.meeting.qq.com");
        // 申请的安全凭证密钥对中的 SecretId，传入请求header，对应X-TC-Key
        profile.setSecretId(SecretId);
        // 申请的安全凭证密钥对中的 Secretkey，用户签名计算
        profile.setSecretKey(SecretKey);
        // 是否开启请求日志，开启后会打印请求和返回的详细日志
        profile.setDebug(true);
        // 设置请求超时时间，单位s
        profile.setReadTimeout(3);
        // 设置获取连接超时时间，单位s
        profile.setConnTimeout(1);

        // 初始化全局sender，也可以方法级别实例化
        RequestSender sender = new RequestSender(profile);
        // 自定义拦截器，可以忽略
//        sender.addInterceptors(new Interceptor() {
//            @Override
//            public Response intercept(Chain chain) {
//                // TODO return null; 用户自定义实现
//            }
//        });
        // 实例化client
        MEETING_CLIENT = new MeetingClient(sender);
        USER_CLIENT = new UserClient(sender);
        // ...
    }

    public static void main(String[] args) throws WemeetSdkException {
        CreateMeetingRequest request = new CreateMeetingRequest();
        request.setInstanceId(InstanceEnum.INSTANCE_MAC.getInstanceID());
        request.setUserId("2016900057");
        request.setSubject("授课教师 - 课程名称");
        request.setType(0);
        request.setStartTime("1619733600");
        request.setEndTime("1619737200");
        MeetingSetting meetingSetting = new MeetingSetting();
        meetingSetting.setMuteEnableJoin(true);
        meetingSetting.setAllowUnmuteSelf(false);
        meetingSetting.setMuteAll(false);
        meetingSetting.setPlayIvrOnLeave(false);
        meetingSetting.setPlayIvrOnJoin(false);
        meetingSetting.setAllowInBeforeHost(true);
        meetingSetting.setAutoInWaitingRoom(false);
        meetingSetting.setAllowScreenSharedWatermark(false);
        meetingSetting.setOnlyEnterpriseUserAllowed(false);
        request.setSettings(meetingSetting);
        request.setMeetingType(0);
        List<User> userList = new ArrayList<>();
        User user = new User();
        user.setUserId("2016900057");
        userList.add(user);
        request.setHosts(userList);
        // 非注册用户设置
        // request.addHeader(ReqHeaderConstants.REGISTERED, "0");
        QueryMeetingDetailResponse response = MEETING_CLIENT.createMeeting(request);
        String mettingId = response.getMeetingInfoList().get(0).getMeetingId();
        String joinUrl = response.getMeetingInfoList().get(0).getJoinUrl();
        String mettingCode = response.getMeetingInfoList().get(0).getMeetingCode();
        log.info(mettingId);
        log.info(joinUrl);
        log.info(mettingCode);
        log.info(GSON.toJson(response));
    }


    @ApiOperation(value="生成腾讯会议", notes="生成腾讯会议")
    @PostMapping(value = "/addTencent")
    public Result<String> addTencent(@RequestBody KcKetangbiao kcKetangbiao,
                                                     HttpServletRequest req) {
        QueryWrapper<KcKetangbiao> queryWrapper = QueryGenerator.initQueryWrapper(kcKetangbiao, req.getParameterMap());
        queryWrapper.ge(StringUtils.isNotBlank(kcKetangbiao.getStartTime()),"skrq",kcKetangbiao.getStartTime());
        queryWrapper.le(StringUtils.isNotBlank(kcKetangbiao.getEndTime()),"skrq",kcKetangbiao.getEndTime());
//        queryWrapper.apply("limit 10");
//        queryWrapper.last("limit 1");
        List<KcKetangbiao> pageList = kcKetangbiaoService.list(queryWrapper);
        int successNum = 0;
        int errorNum = 0;
        String errorTitle = "";
        for(int i=0;i<pageList.size();i++){
            KcKetangbiao kcKetangbiaoPar = pageList.get(i);
            try {

                CreateMeetingRequest request = new CreateMeetingRequest();
                request.setInstanceId(InstanceEnum.INSTANCE_MAC.getInstanceID());
                request.setUserId(kcKetangbiaoPar.getJgh());
                request.setSubject(kcKetangbiaoPar.getSkjs()+" - "+kcKetangbiaoPar.getKcmc());
                request.setType(0);
                String skrq = kcKetangbiaoPar.getSkrq();
                String hhks = kcKetangbiaoPar.getHhks();
                String hhjs = kcKetangbiaoPar.getHhjs();
                String startTime = skrq+" "+hhks.substring(0,2)+":"+hhks.substring(2)+":00";
                String endTime = skrq+" "+hhjs.substring(0,2)+":"+hhjs.substring(2)+":00";
                Date ks = DateUtils.parseDate(startTime,"yyyy-MM-dd HH:mm:ss");
                Date js = DateUtils.parseDate(endTime,"yyyy-MM-dd HH:mm:ss");
                String kspar = (ks.getTime()+"").substring(0,10);
                String jspar = (js.getTime()+"").substring(0,10);
                request.setStartTime(kspar);
                request.setEndTime(jspar);
                MeetingSetting meetingSetting = new MeetingSetting();
                meetingSetting.setMuteEnableJoin(true);
                meetingSetting.setAllowUnmuteSelf(false);
                meetingSetting.setMuteAll(false);
                meetingSetting.setPlayIvrOnLeave(false);
                meetingSetting.setPlayIvrOnJoin(false);
                meetingSetting.setAllowInBeforeHost(true);
                meetingSetting.setAutoInWaitingRoom(false);
                meetingSetting.setAllowScreenSharedWatermark(false);
                meetingSetting.setOnlyEnterpriseUserAllowed(false);
                request.setSettings(meetingSetting);
                request.setMeetingType(0);
                List<User> userList = new ArrayList<>();
                User user = new User();
                user.setUserId(kcKetangbiaoPar.getJgh());
                userList.add(user);
                request.setHosts(userList);
                QueryMeetingDetailResponse response = MEETING_CLIENT.createMeeting(request);
                String mettingId = response.getMeetingInfoList().get(0).getMeetingId();
                String joinUrl = response.getMeetingInfoList().get(0).getJoinUrl();
                String mettingCode = response.getMeetingInfoList().get(0).getMeetingCode();
                log.info(mettingId);
                log.info(joinUrl);
                log.info(mettingCode);
                log.info(GSON.toJson(response));
                kcKetangbiaoPar.setKclj(joinUrl);
                kcKetangbiaoPar.setHyid(mettingId);
                kcKetangbiaoPar.setHyh(mettingCode);
                kcKetangbiaoService.updateById(kcKetangbiaoPar);

//                errorTitle += "会议id："+mettingId+"；链接地址："+joinUrl+"；开始时间："+kspar+";结束时间："+jspar+"<br/>";
                successNum++;
            }catch (Exception e){
                e.printStackTrace();
                errorTitle += kcKetangbiaoPar.getSkjs()+" - "+kcKetangbiaoPar.getKcmc()+";表id："+kcKetangbiaoPar.getId()+"<br/>";
                errorNum ++;
            }
        }
        if(StringUtils.isEmpty(errorTitle)){
            errorTitle = "无";
        }
        String resMessage = "成功："+successNum+"条，失败："+errorNum+"条；失败课程：<br/>"+errorTitle;
        return Result.OK(resMessage);
    }



    /**
     * 获取openid
     * @param
     * @param
     * @return
     */
    @ApiOperation(value="获取openId", notes="获取openId")
    @CrossOrigin
    @GetMapping("/getopenid")
    @ResponseBody
    public String getopenid(String code,HttpServletRequest request, HttpServletResponse response){
        String appid= AppId;
        String secret = SecretId;
        //dI7xDaaKI7IW38JoiyKP1IXIA    --- Token
        //v9HLhqR2zb0WTn4TEURoZFTJYALc3WXkk0ICSFL1Thl   ---EncodingAESKey
        response.setHeader("Access-Control-Allow-Origin", "*");
        /*星号表示所有的域都可以接受，*/
        response.setHeader("Access-Control-Allow-Methods", "GET,POST");
        String wxLoginUrl = "https://api.weixin.qq.com/sns/oauth2/access_token";
        String param = "appid="+appid+"&secret="+secret+"&code="+code+"&grant_type=authorization_code";
        String jsonString = GetPostUntil.sendGet(wxLoginUrl, param);
        JSONObject json = JSONObject.parseObject(jsonString);
        String openid = json.getString("openid");
        System.out.println("openid###############"+openid);


        QueryWrapper<KcBdgxbcopy> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("openid",openid);
        List<KcBdgxbcopy> list = kcBdgxbcopyService.list(queryWrapper);
        if(list == null || list.size() == 0){
            KcBdgxbcopy kcBdgxbcopy = new KcBdgxbcopy();
            kcBdgxbcopy.setOpenid(openid);
            kcBdgxbcopy.setUserid(code);
            kcBdgxbcopy.setBdtime(new Date());
            kcBdgxbcopyService.save(kcBdgxbcopy);
        }
        return openid;
    }
}
