package org.jeecg.modules.tools;

import org.apache.commons.lang3.StringUtils;
import org.apache.commons.lang3.StringEscapeUtils;
import org.jeecg.common.util.CommonUtils;

import java.util.Map;

public class CommonUtil extends CommonUtils {

    public static String getFileName(String fileName) {
        int unixSep = fileName.lastIndexOf(47);
        int winSep = fileName.lastIndexOf(92);
        int pos = winSep > unixSep ? winSep : unixSep;
        if (pos != -1) {
            fileName = fileName.substring(pos + 1);
        }

        fileName = fileName.replace("=", "").replace(",", "").replace("&", "").replace("#", "");
        //if (ifContainChinese(fileName)) {
            //fileName = PinyinUtil.getPinyin(fileName, "");
        //}

        fileName = fileName.replaceAll("\\s", "");
        return fileName;
    }



    /**
     * 替换一段文字里有多个{key1},{key2}
     * @param str           待替换的字符
     * @param replaceMap    替换的map
     * @param startKey      开始的键值
     * @param endKey        结束的键值
     * @return
     */
    public static String getReplaceMapValue(String str, Map<String,?> replaceMap, String startKey, String endKey){
        if(StringUtils.isNotBlank(str)){
            //之前判断过，现在不再判断是否存在两个{
            //判断是否存在第二个{，如“姓名：{name},{miniName}”,存在则替换其字符
            StringBuilder sb = new StringBuilder();
            //“姓名：{name},{miniName}xxxxx”拆分成“['姓名：','name},','miniName}','xxxxx']”
            String[] arr = StringUtils.split(str,startKey);
            for (String s:arr){
                int endIndex = StringUtils.indexOf(s,endKey);
                if(endIndex != -1){
                    //包含key和额外的，
                    String[] keyList = StringUtils.split(s,endKey);
                    for (int i=0;i<keyList.length;i++){
                        String s2 = keyList[i];
                        if(i == 0){
                            //这就是key，拿去去真正的值
                            String value = (String)replaceMap.get(s2);
                            if (StringUtils.isBlank(value)) {
                                value = "";
                            }
                            value = StringEscapeUtils.unescapeHtml4(value);
                            sb.append(value);
                        }else{
                            //这个是key后面的赠品，存上，别整丢了
                            sb.append(s2);
                        }
                    }
                    //String key = StringUtils.substring(s,0,endIndex);
                }else{
                    //不存在直接放行，添加到返回的内容里面
                    sb.append(s);
                }
            }
            //StringUtils.indexOf(str,LABEL_STR);
            //run.setText(sb.toString(),0);
            return sb.toString();
        }
        return "";
    }


}
