package org.jeecg.modules.tools;

//import org.apache.commons.lang.StringUtils;
//import org.joda.time.format.DateTimeFormat;
//import org.joda.time.format.DateTimeFormatter;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Locale;

/**
 * @ClassName DateUtils
 * @Description 日期工具类
 * @Author raymond
 * @Date 2024/4/7 10:24
 * @Version 1.0
 **/
public class DateUtils {

    /** 时间格式(yyyy-MM-dd) */
    public final static String DATE_PATTERN = "yyyy-MM-dd";
    public final static String DATE_PATTERN_CHINESE = "yyyy年MM月dd日";
    public final static String DATE_PATTERN_String = "yyyy-MM-dd"+" 00:00:00";
    public final static String DATE_PATTERN_END_TIME = "yyyy-MM-dd"+" 23:59:59";
    /** 时间格式(yyyy-MM-dd HH) */
    public final static String DATE_PATTERN_HOURS = "yyyy-MM-dd HH";
    /** 时间格式(yyyy-MM-dd HH:mm) */
    public final static String DATE_PATTERN_MINUTE = "yyyy-MM-dd HH:mm";
    /** 时间格式(yyyy-MM-dd HH:mm:ss) */
    public final static String DATE_TIME_PATTERN = "yyyy-MM-dd HH:mm:ss";

    public final static String DATE_PAY_TIME = "yyyyMMddHHmmss";

    /**
     * 日期格式化 日期格式为：yyyy-MM-dd
     * @param date  日期
     * @return  返回yyyy-MM-dd格式日期
     */
    public static String format(Date date) {
        return format(date, DATE_PATTERN);
    }

    /**
     * 日期格式化 日期格式为：yyyy-MM-dd
     * @param date  日期
     * @param pattern  格式，如：DateUtils.DATE_TIME_PATTERN
     * @return  返回yyyy-MM-dd格式日期
     */
    public static String format(Date date, String pattern) {
        if(date != null){
            SimpleDateFormat df = new SimpleDateFormat(pattern);
            return df.format(date);
        }
        return null;
    }

//    public static Date stringToDate(String strDate, String pattern) {
//        if (StringUtils.isBlank(strDate)){
//            return null;
//        }
//
//        DateTimeFormatter fmt = DateTimeFormat.forPattern(pattern);
//        return fmt.parseLocalDateTime(strDate).toDate();
//    }

    public static Date executeDate(String payTime){
        SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmmss");
        try {
            return sdf.parse(payTime);
        } catch (ParseException e) {
            return null;
        }
    }

    public static String getTradeNo(){
        SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmm");
        String str = sdf.format(new Date());
        str += DateUtils.getCaptcha().substring(0,6);
        return str.toLowerCase(Locale.ROOT);
    }

    public static String getCaptcha(){
        String str = "";
        for (int i = 0; i < 7; i++) {
            int num = (int) (Math.random() * 8);
            str = str +num;
        }
        return str;
    }

    public static void main(String[] args) {
    }
}
