package org.jeecg.modules.tools;

import cn.hutool.core.io.resource.ResourceUtil;
import org.apache.shiro.io.ResourceUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.core.env.Environment;
import org.springframework.core.io.ClassPathResource;
import org.springframework.stereotype.Component;

import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;

/**
 * 配置读取
 */
@Component
public class Global {

	/**
	 * 全部参数对象
	 */
	private Environment environment;
	@Autowired
	public void setEnvironment(Environment environment){this.environment = environment;}

	/**
	 * 本地：local minio：minio 阿里：alioss
	 */
	@Value(value="${jeecg.uploadType}")
	public String uploadType;

	/**
	 * 上传文件地址
	 */
	public String uploadPath;
	@Value("${jeecg.path.upload}")
	public void setUploadPath(String str){uploadPath = str;}

	/**
	 * 文档转换器url
	 */
	public String libreOfficeUrl;
	@Value("${libreOffice.url}")
	public void setLibreOfficeUrl(String str){libreOfficeUrl = str;}

	/**
	 * 文档转换器端口
	 */
	public int libreOfficePort;
	@Value("${libreOffice.port}")
	public void setLibreOfficePort(int port){libreOfficePort = port;}

	/**
	 * 机构Code
	 */
	/*public String departCode;
	@Value("${business.user.depart.code}")
	public void setDepartCode(String str){departCode = str;}*/

	/**
	 * 学校管理员角色code
	 */
	/*public String xxRole;
	@Value("${business.user.role.xx}")
	public void setXxRole(String str){xxRole = str;}*/

	/**
	 * 院校管理员角色code
	 */
	/*public String yxRole;
	@Value("${business.user.role.yx}")
	public void setYxRole(String str){yxRole = str;}*/

	/**
	 * 第一作者角色code
	 */
	/*public String zzRole;
	@Value("${business.user.role.zz}")
	public void setZzRole(String str){zzRole = str;}*/

	/**
	 * 获去配置文件的指定配置
	 * @param key
	 * @return
	 */
	public String getConfig(String key){
		return environment.getProperty(key);
	}

	/**
	 * 获取布尔型的配置（从application中获取）
	 * @param key
	 * @return
	 */
	public boolean getBooleanConfig(String key){
		return Boolean.valueOf(getConfig(key));
	}

	/**
	 * 临时文件存储盘符
	 */
	public static String TMP_DICK = "/pdfTemp/";

	public String getTmpDickPath(){
		return uploadPath + TMP_DICK;
	}

	/**
	 * 临时文件存储盘符
	 */
	public static String CONTRACT_DICK = "/contract/";

	public String getContractDickPath(){
		return uploadPath + CONTRACT_DICK;
	}

	/**
	 * 获取资源路径(可能读不出来)
	 * @param relativePath 相对路径
	 * @return
	 * @throws FileNotFoundException
	 */
	@Deprecated
	public static String getResourcePath(String relativePath) throws FileNotFoundException {
		return ResourceUtil.getResource(ResourceUtils.CLASSPATH_PREFIX + relativePath).getPath();
	}

	/**
	 * 从jar或是war中读取文件
	 * @param relativePath
	 * @return
	 * @throws IOException
	 */
	public InputStream getResourceInputStream(String relativePath) throws IOException {
		ClassPathResource classPathResource = new ClassPathResource(relativePath);
		return classPathResource.getInputStream();
	}

}
