package org.jeecg.modules.tools;


import com.alibaba.fastjson.JSONObject;
import org.jeecg.modules.tools.baidu.Base64Util;
import org.jeecg.modules.tools.baidu.FileUtil;
import org.jeecg.modules.tools.baidu.GsonUtils;
import org.jeecg.modules.tools.baidu.HttpUtil;
import org.jeewx.api.core.util.DateUtils;
import org.springframework.stereotype.Component;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLEncoder;
import java.time.Instant;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import static cn.hutool.crypto.SecureUtil.sha1;
import static org.apache.poi.poifs.crypt.HashAlgorithm.sha1;

/**
 * 获取token类
 */
@Component
public class WjxAuthService {

    /**
     * 获取权限token
     * @return 返回示例：
     * {
     * "access_token": "24.460da4889caad24cccdb1fea17221975.2592000.1491995545.282335-1234567",
     * "expires_in": 2592000
     * }
     */
    public static String getAuth() {
        String appid = "1321039";
        String appkey = "55328ebd11964fc8b40c10011bcb425d";
        String subuser = "jwctest";
        String mobile = "15844013241";
        String email = "";
        String roleId = "2";
        Long unixTimestamp = Instant.now().getEpochSecond();
        String ts = unixTimestamp.toString();
        String sign = sha1(appid+appkey+subuser+mobile+roleId+ts);
        return getAuth(appid, subuser,ts,sign);
    }

    /**
     * 获取API访问token
     * 该token有一定的有效期，需要自行管理，当失效时需重新获取.
     */
    public static String getAuth(String appid, String subuser,String ts,String sign) {
        // 获取token地址
        String authHost = "https://www.wjx.cn/openapi/default.aspx?";
        String getAccessTokenUrl = authHost
                + "appid="+appid
                + "&subuser=" + subuser
                + "&ts=" + ts
                + "&sign=" + sign;
        System.out.println("----------------------------------------------------");
        System.out.println(getAccessTokenUrl);
        System.out.println("----------------------------------------------------");
        try {
            URL realUrl = new URL(getAccessTokenUrl);
            // 打开和URL之间的连接
            HttpURLConnection connection = (HttpURLConnection) realUrl.openConnection();
            connection.setRequestMethod("GET");
            connection.connect();
            // 获取所有响应头字段
            Map<String, List<String>> map = connection.getHeaderFields();
            // 遍历所有的响应头字段
            for (String key : map.keySet()) {
                System.err.println(key + "--->" + map.get(key));
            }
            // 定义 BufferedReader输入流来读取URL的响应
            BufferedReader in = new BufferedReader(new InputStreamReader(connection.getInputStream()));
            String result = "";
            String line;
            while ((line = in.readLine()) != null) {
                result += line;
            }
            /**
             * 返回结果示例
             */
            System.err.println("result:" + result);
            JSONObject jsonObject = JSONObject.parseObject(result);
            String access_token = jsonObject.getString("access_token");
            return access_token;
        } catch (Exception e) {
            System.err.printf("获取token失败！");
            e.printStackTrace(System.err);
        }
        return null;
    }

}