package org.jeecg.modules.tools.dbsdkfzpt;

import com.alibaba.fastjson.JSONObject;
import org.apache.http.NameValuePair;
import org.apache.tomcat.util.codec.binary.Base64;
import org.springframework.http.*;
import org.springframework.web.client.RestTemplate;

import java.io.OutputStream;
import java.net.HttpURLConnection;
import java.net.URL;
import java.nio.charset.StandardCharsets;
import java.util.*;

public class InterfaceDemo {
    public static void main(String[] args) {

        // 获取令牌URL前缀
        String prefixOauthUrl = "https://intf.nenu.edu.cn/api/bd-api";

        // 调用接口URL
        String interfaceUrl = "http://192.168.36.25:8082/get/studentsInfoInterface";

        // 开发者帐号,以实际为准
        String userName = "zhjxfwzx";
        // 开发者密码,以实际为准
        String password = "A9BYf7TZDpxg";
        // 应用编号,以实际为准
        String appNum = "d8bde966cba24ec_uuid";
        // 认证码,以实际为准
        String oauthCode = "a18267f1190fe4cc72131449d22caa08";
        //第几页(page,pageSize都不填不分页)
         String pageNum="1";
        //每页大小(page,pageSize都不填不分页)
        String pageSize="10";

        // 接口如果定义有参数，则将参数列表添加到此处
        List<Map<String, String>> paramsList =new ArrayList<>();
        Map<String, String> paramMap = new HashMap<>();
        paramMap.put("aaa","bbb");
        paramsList.add(paramMap);

        //获取token
        String token=getAccessToken();

//        String token=getAccessToken(prefixOauthUrl,userName,password,appNum,oauthCode);
//        net.sf.json.JSONObject token=getAccessToken4();
        System.out.println("================response token====================");
        System.out.println(token);
        System.out.println("================response token====================");
        //获取数据
//        String data=getInterfaceData(interfaceUrl,token,pageNum,pageSize, paramsList);
//        System.out.println("================response interfaceData====================");
//        System.out.println(data);
//        System.out.println("================response interfaceData====================");

    }



    public  static  String getAccessToken(String prefixUrl,String userName,String password,String appNum,String oauthCode){
        String token="";
        try {
            //NO.1：通过client_id:client_secret 和开发者账号和密码获取授权令牌access_token
            RestTemplate restTemplate = new RestTemplate();

            //通过client_id:client_secret构建认证信息
            String plainClientCredentials=appNum+":"+oauthCode;
            String base64ClientCredentials = new String(Base64.encodeBase64String(plainClientCredentials.getBytes()));

            //构建请求头信息
            HttpHeaders headers = new HttpHeaders();
            headers.setAccept(Arrays.asList(MediaType.APPLICATION_JSON));
            headers.add("Authorization", "Basic " + base64ClientCredentials);

            //获取access_token
            HttpEntity<String> request = new HttpEntity<String>(headers);

            userName=DesUtil.encrypt(userName);
            password=DesUtil.encrypt(password);
            String url= prefixUrl+"/oauth/token?grant_type=password&scope=read&username="+userName+"&password="+password;

            ResponseEntity<Object> response = restTemplate.exchange(url, HttpMethod.POST, request, Object.class);;

            LinkedHashMap<String, Object> map = (LinkedHashMap<String, Object>)response.getBody();

            //从返回结果中获取 access_token
            token = (String)map.get("access_token");

        } catch (Exception e) {
            e.printStackTrace();
        }
        return token;
    }

    /**
     * 请求无参接口
     * @param interfaceUrl  请求URL前缀
     * @param access_token
     * @param pageNum  第几页(page,pageSize都不填不分页)
     * @param pageSize 每页大小(page,pageSize都不填不分页)
     * @return data
     */
    public static  String getInterfaceData(String interfaceUrl,String access_token,String pageNum,String pageSize){
        //NO.2：通过NO.1返回的access_token访问输出接口
        //构建调用具体接口访问地址
//        String url = prefixUrl+"/get/studentsInfoInterface";
        JSONObject jsonObject = new JSONObject();
        jsonObject.put("access_token", access_token);
        jsonObject.put("page", pageNum);   //第几页(page,pageSize都不填不分页)
        jsonObject.put("pageSize", pageSize);  //每页大小(page,pageSize都不填不分页)
        //调用restful请求工具类发送请求
        String reString = RestTemplateUtils.get(interfaceUrl, jsonObject);
        return reString;
    }

    /**
     * 请求含有参数的接口
     * @param interfaceUrl  请求URL前缀
     * @param access_token
     * @param pageNum  第几页(page,pageSize都不填不分页)
     * @param pageSize 每页大小(page,pageSize都不填不分页)
     * @param list 自定义参数
     * @return data
     */
    public static  String getInterfaceData(String interfaceUrl,String access_token,String pageNum,String pageSize,List<Map<String, String>> list){
        //NO.2：通过NO.1返回的access_token访问输出接口
        //构建接口访问地址
//        String url = prefixUrl+"/get/studentsInfoInterface";
        JSONObject jsonObject = new JSONObject();
        jsonObject.put("access_token", access_token);
        jsonObject.put("page", pageNum);   //第几页(page,pageSize都不填不分页)
        jsonObject.put("pageSize", pageSize);  //每页大小(page,pageSize都不填不分页)
        if(list.size()>0){
            for (Map<String,String> map:list){
                jsonObject.putAll(map);
            }
        }
//        System.out.println(jsonObject);
        //调用restful请求工具类发送请求
        return RestTemplateUtils.get(interfaceUrl, jsonObject);
    }


    /**
     * 获取access_token令牌
     * @return access_token
     */
    public  static  String getAccessToken(){
        String token="";
        try {
            // 获取令牌URL前缀
            String prefixUrl = "https://intf.nenu.edu.cn/api/bd-api";
            // 开发者帐号,以实际为准
            String userName = "D64A8E04B63AE18D1D796914279AEEE3";
            // 开发者密码,以实际为准
            String password = "6413C873CD49C96D301B0D7A0EBFA51D";
            // 应用编号,以实际为准
            String appNum = "d8bde966cba24ec_uuid";
            // 认证码,以实际为准
            String oauthCode = "a18267f1190fe4cc72131449d22caa08";
            //NO.1：通过client_id:client_secret 和开发者账号和密码获取授权令牌access_token
            RestTemplate restTemplate = new RestTemplate();

            //构建请求头信息
            HttpHeaders headers = new HttpHeaders();
            headers.setContentType(MediaType.APPLICATION_JSON);
//            headers.add("Content-Type", "application/json");
            headers.add("Authorization", "Basic ZDhiZGU5NjZjYmEyNGVjX3V1aWQ6YTE4MjY3ZjExOTBmZTRjYzcyMTMxNDQ5ZDIyY2FhMDg=");

            //获取access_token
            HttpEntity<String> request = new HttpEntity<String>(headers);

//            userName=DesUtil.encrypt(userName);
//            password=DesUtil.encrypt(password);
            String url= prefixUrl+"/oauth/token?grant_type=password&scope=read&username="+userName+"&password="+password;

            ResponseEntity<Object> response = restTemplate.exchange(url, HttpMethod.POST, request, Object.class);;

            LinkedHashMap<String, Object> map = (LinkedHashMap<String, Object>)response.getBody();

            //从返回结果中获取 access_token
            token = (String)map.get("access_token");

        } catch (Exception e) {
            e.printStackTrace();
        }
        return token;
    }


    public  static  String getAccessToken3(){
        try {
            URL url = new URL("https://intf.nenu.edu.cn/api/bd-api/oauth/token?grant_type=password&scope=read&username=D64A8E04B63AE18D1D796914279AEEE3&password=6413C873CD49C96D301B0D7A0EBFA51D");

            // 打开连接
            HttpURLConnection connection = (HttpURLConnection) url.openConnection();

            // 设置请求方法为POST
            connection.setRequestMethod("POST");
//            connection.setRequestProperty("Host","<calculated when request is sent>");
            connection.setRequestProperty("Authorization", "Basic ZDhiZGU5NjZjYmEyNGVjX3V1aWQ6YTE4MjY3ZjExOTBmZTRjYzcyMTMxNDQ5ZDIyY2FhMDg=");
            connection.setRequestProperty("Content-Type", "application/json");

            // 发送POST请求的数据
            String postData = "";
            byte[] outputInBytes = postData.getBytes(StandardCharsets.UTF_8);
            connection.setDoOutput(true);

            // 写入数据到请求体
            try (OutputStream out = connection.getOutputStream()) {
                out.write(outputInBytes);
            }

            // 获取响应码
            int responseCode = connection.getResponseCode();
            System.out.println("Response Code: " + responseCode);

            // 读取响应内容
            if (responseCode == HttpURLConnection.HTTP_OK) {
                // 处理响应内容
    //                String response = new String(connection.getInputStream(), StandardCharsets.UTF_8);
    //                System.out.println(response);
            } else {
                // 处理错误响应
    //                String errorResponse = new String(connection.getErrorStream().readAllBytes(), StandardCharsets.UTF_8);
    //                System.out.println("Error Response: " + errorResponse);
            }

            // 关闭连接
            connection.disconnect();

            return "";
        } catch (Exception e) {
            e.printStackTrace();

            return "";
        }
    }
    public static  String getAccessToken5() {
        try {
            String targetURL = "https://intf.nenu.edu.cn/api/bd-api/oauth/token";
            URL url = new URL(targetURL);
            HttpURLConnection connection = (HttpURLConnection) url.openConnection();

            // 设置请求方法为POST
            connection.setRequestMethod("POST");

            // 设置通用请求属性
            connection.setRequestProperty("Content-Type", "application/json");

            // 如果需要，添加认证
//        String authentication = "username:password";
//        String encodedAuthentication = new String(Base64.getEncoder().encode(authentication.getBytes()));
            connection.setRequestProperty ("Authorization", "Basic ZDhiZGU5NjZjYmEyNGVjX3V1aWQ6YTE4MjY3ZjExOTBmZTRjYzcyMTMxNDQ5ZDIyY2FhMDg=");

            // 发送POST请求必须设置如下两行
            connection.setDoOutput(true);
            connection.setDoInput(true);

            // 发送请求参数
            String jsonInputString = "{\"grant_type\":\"password\",\"scope\":\"read\",\"username\":\"D64A8E04B63AE18D1D796914279AEEE3\",\"password\":\"6413C873CD49C96D301B0D7A0EBFA51D\"}";
            try(OutputStream os = connection.getOutputStream()) {
                byte[] input = jsonInputString.getBytes();
                os.write(input, 0, input.length);
            }

            // 获取响应码
            int responseCode = connection.getResponseCode();
            System.out.println("POST Response Code :: " + responseCode);

            // 根据需要处理响应内容
            if (responseCode == HttpURLConnection.HTTP_OK) {
                // 处理响应
            }

            // 关闭连接
            connection.disconnect();
            return "";
        } catch (Exception e) {
            throw new RuntimeException(e);
        }

    }

    public  static net.sf.json.JSONObject getAccessToken4(){
        try {
            List<NameValuePair> params=null;
            try {
                params = new ArrayList<>();
            } catch (Exception e) {
                e.printStackTrace();
            }
            String httpUrl = "https://intf.nenu.edu.cn/api/bd-api/oauth/token?grant_type=password&scope=read&username=D64A8E04B63AE18D1D796914279AEEE3&password=6413C873CD49C96D301B0D7A0EBFA51D";
            //String httpUrl = url+course+"?action=addClassStudentMultiple";
            return HttpUtil.SendPostRequest(httpUrl, params);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }

    }


}
