package org.jeecg.modules.tools.excel;

import org.apache.commons.io.IOUtils;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.ss.usermodel.Workbook;

import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.*;
import java.net.URLEncoder;

/**
 * 下载表格工具
 */
public class DownloadtExcelUtils {

	public static String genFileExtension(Workbook workbook,String codedFileName){
		if (workbook instanceof HSSFWorkbook) {
			codedFileName = codedFileName + ".xls";
		} else {
			codedFileName = codedFileName + ".xlsx";
		}
		return codedFileName;
	}

	/**
	 * 下载表格，
	 * @param codedFileName
	 * @param workbook
	 * @param request
	 * @param response
	 * @throws IOException
	 */
	public static void download(String codedFileName, Workbook workbook, HttpServletRequest request, HttpServletResponse response) throws IOException {
		codedFileName = genFileExtension(workbook,codedFileName);

		if (request.getHeader("USER-AGENT").toLowerCase().indexOf("msie") > 0 || request.getHeader("USER-AGENT").toLowerCase().indexOf("rv:11.0") > 0) {
			codedFileName = URLEncoder.encode(codedFileName, "UTF8");
		} else {
			codedFileName = new String(codedFileName.getBytes("UTF-8"), "ISO-8859-1");
		}
		response.setHeader("content-disposition", "attachment;filename=" + codedFileName);
		ServletOutputStream out = response.getOutputStream();
		workbook.write(out);
		out.flush();
	}

	/**
	 * 生成文件
	 * @param workbook excel对象
	 * @param codedFileName 文件名称，不带扩展名
	 * @param toFilePath 生成完整路径
	 * @throws IOException
	 */
	public static void toFile(Workbook workbook,String codedFileName,String toFilePath) throws IOException {
		codedFileName = genFileExtension(workbook,codedFileName);
		OutputStream out = new FileOutputStream(new File(toFilePath + codedFileName));
		workbook.write(out);
		IOUtils.closeQuietly(out);
//		FileUtils.createFile(toFilePath + codedFileName);
		//FileUtils.copyFile(new File(toFilePath + codedFileName),out);
		//out转in
//		FileInputStream in = new FileInputStream(out);
//		FileUtil.writeFromStream(in,"toFilePath + codedFileName");
	}

	/**
	 * 生成字节输入流
	 * @param workbook excel对象
	 * @throws IOException
	 */
	public static InputStream toByteFile(Workbook workbook) throws IOException {
		ByteArrayOutputStream out = new ByteArrayOutputStream();
		workbook.write(out);
		InputStream input = new ByteArrayInputStream(out.toByteArray());
		IOUtils.closeQuietly(out);
		//创建in输入流
		//根据内存输出流创建内存输入流

		return input;
	}


}
