package org.jeecg.modules.tools.office.convert;

import org.jodconverter.core.document.DefaultDocumentFormatRegistry;
import org.jodconverter.core.document.DocumentFormat;
import org.jodconverter.core.office.OfficeException;

import java.io.File;
import java.io.IOException;
import java.io.OutputStream;

public class OfficeOutputBox {

	private final OfficeInputBox officeInputBox;

	private File outFile;

	private OutputStream outp;

	private boolean closeStream = true;

	private DocumentFormat outDocumentFormat;

	OfficeOutputBox(OfficeInputBox officeInputBox, File outFile) {
		this.officeInputBox = officeInputBox;
		this.outFile = outFile;
	}

	OfficeOutputBox(OfficeOutputStreamBox officeOutputStreamBox) {
		this.officeInputBox = officeOutputStreamBox.getOfficeInputBox();
		this.outp = officeOutputStreamBox.getOutp();
		this.closeStream = officeOutputStreamBox.isCloseStream();
	}

	/**
	 *
	 * @param documentFormat @see {org.jodconverter.core.document.DefaultDocumentFormatRegistry}
	 * @return this
	 */
	public OfficeOutputBox as(DocumentFormat documentFormat) {
		this.outDocumentFormat = documentFormat;
		return this;
	}

	/**
	 *
	 * @param extension @see {org.jodconverter.core.document.DefaultDocumentFormatRegistry}
	 * @return this
	 */
	public OfficeOutputBox asExtension(String extension) {
		this.outDocumentFormat = DefaultDocumentFormatRegistry.getFormatByExtension(extension);
		return this;
	}

	/**
	 *
	 * @param mediaType @see {org.jodconverter.core.document.DefaultDocumentFormatRegistry}
	 * @return this
	 */
	public OfficeOutputBox asMediaType(String mediaType) {
		this.outDocumentFormat = DefaultDocumentFormatRegistry.getFormatByMediaType(mediaType);
		return this;
	}

	public void execute() throws IOException, OfficeException {
		OfficeConvertHelper.execute(this);
	}

	public OfficeInputBox getOfficeInputBox() {
		return officeInputBox;
	}

	public File getOutFile() {
		return outFile;
	}

	public OutputStream getOutp() {
		return outp;
	}

	public boolean isCloseStream() {
		return closeStream;
	}

	public DocumentFormat getOutDocumentFormat() {
		return outDocumentFormat;
	}

}
