package org.jeecg.modules.tools.office.convert;

import org.jodconverter.core.document.DocumentFormat;

import java.io.OutputStream;

public class OfficeOutputStreamBox {

	private final OfficeInputBox officeInputBox;

	private final OutputStream outp;

	private final boolean closeStream;

	OfficeOutputStreamBox(OfficeInputBox officeInputBox, OutputStream outp, boolean closeStream) {
		this.officeInputBox = officeInputBox;
		this.outp = outp;
		this.closeStream = closeStream;
	}


	/**
	 *
	 * @param documentFormat @see {org.jodconverter.core.document.DefaultDocumentFormatRegistry}
	 * @return 文档输出类
	 */
	public OfficeOutputBox as(DocumentFormat documentFormat) {
		OfficeOutputBox officeOutputBox = new OfficeOutputBox(this);
		officeOutputBox.as(documentFormat);
		return officeOutputBox;
	}

	/**
	 *
	 * @param extension @see {org.jodconverter.core.document.DefaultDocumentFormatRegistry}
	 * @return 文档输出类
	 */
	public OfficeOutputBox asExtension(String extension) {
		OfficeOutputBox officeOutputBox = new OfficeOutputBox(this);
		officeOutputBox.asExtension(extension);
		return officeOutputBox;
	}

	/**
	 *
	 * @param mediaType @see {org.jodconverter.core.document.DefaultDocumentFormatRegistry}
	 * @return 文档输出类
	 */
	public OfficeOutputBox asMediaType(String mediaType) {
		OfficeOutputBox officeOutputBox = new OfficeOutputBox(this);
		officeOutputBox.asMediaType(mediaType);
		return officeOutputBox;
	}


	OfficeInputBox getOfficeInputBox() {
		return officeInputBox;
	}


	OutputStream getOutp() {
		return outp;
	}


	boolean isCloseStream() {
		return closeStream;
	}
}
