package org.jeecg.modules.tools.office.pdf;

import lombok.SneakyThrows;
import org.jeecg.common.util.SpringContextUtils;
import org.jeecg.modules.tools.office.convert.OfficeConvertHelper;
import org.jodconverter.core.DocumentConverter;

import java.io.File;

/**
 * PFD工具类
 */
public class PDFUtil {

//	private static Global global = SpringContextUtils.getBean(Global.class);
//
//	public void setGlobal(Global g){
//		global = g;
//	}

	private static DocumentConverter documentConverter = SpringContextUtils.getBean(DocumentConverter.class);

	public void setDocumentConverter(DocumentConverter g){
		documentConverter = g;
	}


	/**
	 * WORD转PDF方法
	 * @param sourceFile	要被转化的word文档路径（如E:\\1.docx）
	 * @param destFile		转成之后pdf文档存放路径（如E:\\1.pdf）
	 */
	@SneakyThrows
	public static void office2PDF(String sourceFile, String destFile) {

		OfficeConvertHelper.converter(documentConverter).from(new File(sourceFile)).to(new File(destFile)).execute();
//		try {
//			File inputFile = new File(sourceFile);
//			File outputFile = new File(destFile);
//			// 获得文件格式(2018年9月25日16:12:35添加，不增加格式，多个文档拼接后转换会报错)
//			DefaultDocumentFormatRegistry formatReg = new DefaultDocumentFormatRegistry();
//			DocumentFormat pdfFormat = formatReg.getFormatByFileExtension("pdf");
//			DocumentFormat docFormat = formatReg.getFormatByFileExtension("doc");
//
//			if (!outputFile.getParentFile().exists()) {
//				outputFile.getParentFile().mkdirs();
//			}
//			OpenOfficeConnection connection = new SocketOpenOfficeConnection(global.libreOfficeUrl, global.libreOfficePort);
////			OpenOfficeConnection connection = new SocketOpenOfficeConnection("192.168.1.227", 8100);
//			connection.connect();
//			// 2018年7月19日修改， 原方法生成pdf会报错   wy
////			DocumentConverter converter = new OpenOfficeDocumentConverter(connection);
//			DocumentConverter converter = new StreamOpenOfficeDocumentConverter(connection);
//			converter.convert(inputFile,docFormat, outputFile,pdfFormat);
//			connection.disconnect();
//		} catch (ConnectException e) {
//			e.printStackTrace();
//		}
	}

	public static void main(String[] args) {
		PDFUtil.office2PDF("F:\\temp\\test\\a.docx","F:\\temp\\test\\a.pdf");
	}

}
