package org.jeecg.modules.tools.word;

import com.google.common.collect.Lists;
import com.google.common.collect.Maps;
import org.apache.commons.lang3.StringUtils;
import org.jeecg.common.system.vo.DictModel;
import org.jeecg.common.util.DateUtils;

import java.util.Date;
import java.util.List;
import java.util.Map;

public class BaseExport {

	public static String formatDate(Date date){
		if(date != null){
			return DateUtils.formatDate(date);
		}
		return "";
	}

	public static String formatDate(Date date,String pattern){
		if(date != null){
			return DateUtils.formatDate(date,pattern);
		}
		return "";
	}

	public List<DictModel> getDictList(String dictCode){
		return null;
	}

	public Map<String,String> getTxtList(String txt){
		if(StringUtils.isBlank(txt)){
			txt = "";
		}
		//转换，拼接的字典
		Map<String,String> txtMap = Maps.newHashMap();
		List<String> txtList = Lists.newArrayList(txt.split(","));
		txtList.forEach(x -> txtMap.put(x,x));
		return txtMap;
	}


	/**
	 * 翻译字典
	 * @param txt
	 * @param dictCode
	 * @return
	 */
	public String formatDictTxt(String txt, String dictCode){
		if(StringUtils.isBlank(dictCode)){
			return null;
		}
		//获取字典列表
		List<DictModel> list = getDictList(dictCode);

		//转换，拼接的字典
		Map<String,String> txtMap = getTxtList(txt);
		//组装字典
		StringBuffer sb = new StringBuffer();
		for(int i=0;i<list.size();i++){
			DictModel x = list.get(i);
			if(!StringUtils.isBlank(txtMap.get(x.getValue()))){
				sb.append(x.getText());
				sb.append(" ");
			}
		}
		return sb.toString();
	}


	/**
	 * 翻译字典， 在内容前面自动拼接□和√
	 * @param txt
	 * @param dictCode
	 * @param goBack
	 * @return
	 */
	public String formatDictTxtByIcon(String txt, String dictCode, int goBack){
		if(StringUtils.isBlank(dictCode)){
			return "";
		}
		//获取字典列表
		List<DictModel> list = getDictList(dictCode);

		//转换，拼接的字典
		Map<String,String> txtMap = getTxtList(txt);

		//组装字典
		StringBuffer sb = new StringBuffer();
		for(int i=0;i<list.size();i++){
			DictModel x = list.get(i);

			if(StringUtils.isBlank(txtMap.get(x.getText()))){
				sb.append(" □ ");
			}else{
				sb.append(" ☑ ");
			}
			sb.append(x.getText());
			sb.append(" ");
			if(goBack != -1 && i%goBack == 1){
				sb.append(" \r\n ");
			}
		}
		return sb.toString();
	}

	/**
	 * 翻译字典， 在内容前面自动拼接□和√
	 * @param txt
	 * @param dictCode
	 * @param goBack
	 * @return
	 */
	public String formatDictValueByIcon(String txt, String dictCode, int goBack){
		if(StringUtils.isBlank(dictCode)){
			return "";
		}
		//获取字典列表
		List<DictModel> list = getDictList(dictCode);

		//转换，拼接的字典
		Map<String,String> txtMap = getTxtList(txt);

		//组装字典
		StringBuffer sb = new StringBuffer();
		for(int i=0;i<list.size();i++){
			DictModel x = list.get(i);

			if(StringUtils.isBlank(txtMap.get(x.getValue()))){
				sb.append(" □ ");
			}else{
				sb.append(" ☑ ");
			}
			sb.append(x.getText());
			sb.append(" ");
			if(goBack != -1 && i%goBack == 1){
				sb.append(" \r\n ");
			}
		}
		return sb.toString();
	}
	public List<WordOperator> export(Object project) throws Exception{
		return Lists.newArrayList();
	}

	/**
	 *
	 * 功能说明    : 文档转换为数组类型
	 * 创建者        : byx
	 * 修改日期    : 2018年9月26日
	 * @param project
	 * @return	数组类型的文档片段
	 * @throws Exception
	 */
	public WordOperator[] exportToArray(Object project) throws Exception{
		List<WordOperator> allList = export(project);
		return allList.toArray(new WordOperator[0]);
	}

}
