/**********************************************************************
* $Id: WordImageLabel.java WordImageLabel ,v0.1 2018年9月19日 下午8:50:48 byx Exp $
* Copyright ©2018 sida . All rights reserved
***********************************************************************/

package org.jeecg.modules.tools.word;


import org.apache.commons.lang3.StringUtils;

/**
* 功能说明：从标签中读取键值，宽高和后缀内容
* 创建者：byx
* 创建时间：2018年9月19日
* <pre>
* 修改时间:       修改者:            
* 修改内容：
* </pre>
*/
public class WordImageLabel {
	
	public static final String SPLIT_STR = ",";
	
	private String key = "";	//键值

	private int width = 0;	//宽

	private int height = 0;	//高

	private String picAttch = "";	//后缀值
	
	public WordImageLabel(Object obj){
		if(obj instanceof String){
			this.wordImageLabel((String)obj);
		}
	}

	/**
	 * 
	 * 功能说明    : 如：‘image,10,10,后缀’
	 * 创建者        : byx
	 * 修改日期    : 2018年9月19日
	 * @param value
	 */
	public WordImageLabel(String value){
		super();
		this.wordImageLabel(value);
	}

	/**
	 * 
	 * 功能说明    : 如：‘image,10,10,后缀’
	 * 创建者        : byx
	 * 修改日期    : 2018年9月19日
	 * @param value
	 */
	public void wordImageLabel(String value) {
		if(StringUtils.isNotBlank(value)){
			String[] strList = StringUtils.split(value, SPLIT_STR);
			if(strList.length == 0){
				key = value;
			}else if(strList.length == 1){
				key = strList[0];
			}else if(strList.length == 2){
				key = strList[0];
				width = Integer.valueOf(strList[1]);
			}else if(strList.length == 3){
				key = strList[0];
				width = Integer.valueOf(strList[1]);
				height = Integer.valueOf(strList[2]);
			}else if(strList.length == 4){
				key = strList[0];
				width = Integer.valueOf(strList[1]);
				height = Integer.valueOf(strList[2]);
				picAttch = strList[3];
			}
		}
	}

	public String getKey() {
		return key;
	}

	public void setKey(String key) {
		this.key = key;
	}

	public int getWidth() {
		return width;
	}

	public void setWidth(int width) {
		this.width = width;
	}

	public int getHeight() {
		return height;
	}

	public void setHeight(int height) {
		this.height = height;
	}

	public String getPicAttch() {
		return picAttch;
	}

	public void setPicAttch(String picAttch) {
		this.picAttch = picAttch;
	}


	
	
}
