package org.jeecg.modules.wps.controller;

import java.io.OutputStream;
import java.net.HttpURLConnection;
import java.net.URL;
import java.nio.charset.StandardCharsets;
import java.util.Map;

public class HttpClientPOSTExample {

    public static void main(String[] args) {
        try {
        String drive_id = "test1111";
        String parent_id = "test1112";
        URL url = new URL("https://openapi.wps.cn/v7/drives/"+drive_id+"/files/"+parent_id+"/create");

        // 打开连接
        HttpURLConnection connection = (HttpURLConnection) url.openConnection();

        // 设置请求方法为POST
        connection.setRequestMethod("POST");

        // 设置请求头，例如内容类型和认证信息
        Map<String,String> map = KsoSign.getAuthorization();
//            String credentials = apiKey + ":" + secretKey;
//            String basicAuth = "Basic " + new String(Base64.getEncoder().encode(credentials.getBytes()));
        connection.setRequestProperty("Authorization", map.get("authorization"));
        connection.setRequestProperty("Content-Type", "application/json");

        // 发送POST请求的数据
        String postData = "{\"key1\":\"value1\",\"key2\":\"value2\"}";
        byte[] outputInBytes = postData.getBytes(StandardCharsets.UTF_8);
        connection.setDoOutput(true);

        // 写入数据到请求体
        try (OutputStream out = connection.getOutputStream()) {
            out.write(outputInBytes);
        }

        // 获取响应码
        int responseCode = connection.getResponseCode();
        System.out.println("Response Code: " + responseCode);

        // 读取响应内容
        if (responseCode == HttpURLConnection.HTTP_OK) {
            // 处理响应内容
//                String response = new String(connection.getInputStream(), StandardCharsets.UTF_8);
//                System.out.println(response);
        } else {
            // 处理错误响应
//                String errorResponse = new String(connection.getErrorStream().readAllBytes(), StandardCharsets.UTF_8);
//                System.out.println("Error Response: " + errorResponse);
        }

        // 关闭连接
        connection.disconnect();

        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
