package org.jeecg.modules.wxgzh;

import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.xkcoding.http.HttpUtil;
import org.jeecg.common.api.vo.Result;
import org.jeecg.modules.kc.KcBdgxbcopy.entity.KcBdgxbcopy;
import org.jeecg.modules.kc.KcBdgxbcopy.service.IKcBdgxbcopyService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.client.RestTemplate;

import java.io.UnsupportedEncodingException;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;


@Controller
public class WxgzhController {
    private static final Logger log = LoggerFactory.getLogger(WxgzhController.class);

    // appId
    private static final String appId = "wx59920eb69d611d7f";//东师

    // appIdSecret
    private static final String appIdSecret = "bf0c19af0e956f447ede4dd902ea63b7";//东师

    // 公众号的模板id(也有相应的接口可以查询到)
    private static final String templateId = "KtWw0lwQ8FOgJdKgrmya0eoafGkMfMN8ECdZs8oSJys";//东师

    // 微信申请的域名(提前准备)
    private static final String domain = "https://smartedu.nenu.edu.cn/wxpay";
    // 自定义跳转方法
    private static final String redirectMethod = "/weixinoauth";

    //微信通知点击后跳转的页面
    private static final String domainTo = "https://smartedu.nenu.edu.cn";

    @Autowired
    private IKcBdgxbcopyService kcBdgxbcopyService;

    //1.先查询code
    @RequestMapping("/wxpay/getCode")
    public String getCode() {
        // 官方地址
        String urlFir = "redirect:https://open.weixin.qq.com/connect/oauth2/authorize?appid=";
        // 地址进行encode转译 (未转译的地址是：http://pay.xxx.cn/wxpay/weixinoauth)
        // 转译后的地址是: http%3A%2F%2Fpay.xxx.cn%2Fwxpay%2Fweixinoauth
        String encoderUrl = getURLEncoderString(domain + redirectMethod);
        log.info(urlFir +appId + "&redirect_uri=" + encoderUrl +"&response_type=code&scope=snsapi_base" + "&state=STATE" + "#wechat_redirect");
        return urlFir + appId + "&redirect_uri=" + encoderUrl +"&response_type=code&scope=snsapi_base" + "&state=STATE" + "#wechat_redirect";
    }

    /**
     * 编码
     * @param str
     * @return
     */
    public static String getURLEncoderString(String str) {
        String result = "";
        if (null == str) {
            return "";
        }
        try {
            result = java.net.URLEncoder.encode(str, "GBK");
        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        }
        return result;
    }

    //2.根据code获取openId
    @GetMapping("/wxpay/weixinoauth")
    public String weixinOauth(@RequestParam String code, @RequestParam String state) throws Exception {
        log.info("获取code:{}",code);
        log.info("获取state:{}",state);
        String url = "https://api.weixin.qq.com/sns/oauth2/access_token?appid="
                + appId + "&secret=" + appIdSecret + "&code=" + code + "&grant_type=authorization_code";
        String res = HttpUtil.get(url);
        String openid = JSONObject.parseObject(res).getString("openid");
        JSONObject obj = JSONObject.parseObject(res);
        log.info("根据code查询得到openId:{}",openid);
        log.info("obj:{}",obj);
//        KcBdgxbcopy kcBdgxbcopy =
        QueryWrapper<KcBdgxbcopy> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("openid",openid);
        queryWrapper.eq("userid",state);
        List<KcBdgxbcopy> list = kcBdgxbcopyService.list(queryWrapper);
        if(list==null||list.size()>0){
            KcBdgxbcopy KcBdgxbcopy = new KcBdgxbcopy();
            KcBdgxbcopy.setUserid(state);
            KcBdgxbcopy.setOpenid(openid);
            KcBdgxbcopy.setBdtime(new Date());
            kcBdgxbcopyService.save(KcBdgxbcopy);
        }
        return domainTo;
    }

    @GetMapping("/wxpay/getToken")
    public String getAccessToken() throws Exception{
        String url = "https://api.weixin.qq.com/cgi-bin/token?grant_type=client_credential&appid="+ appId +"&secret=" + appIdSecret;
        String res = HttpUtil.get(url);
        JSONObject jsonObject = JSONObject.parseObject(res);
        String accessToken = jsonObject.getString("access_token");
        log.info("accessToken：{}", accessToken);
        return accessToken;
    }

    @RequestMapping("/wxpay/checkToken")
    @ResponseBody
    public String checkToken(@RequestParam("echostr") String echostr) {
        return echostr;
    }


    @GetMapping("/wxpay/sendMessage")
    public  Result<String> sendMessage() throws Exception {
        // 模板参数
        Map<String, WeChatTemplateMsg> sendMag = new HashMap<String, WeChatTemplateMsg>();

        // openId代表一个唯一微信用户，即微信消息的接收人
        String userid = "2016900057";

        QueryWrapper<KcBdgxbcopy> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("userid",userid);
        List<KcBdgxbcopy> list = kcBdgxbcopyService.list(queryWrapper);
        for(KcBdgxbcopy kcBdgxbcopyPar:list){
            String openId = kcBdgxbcopyPar.getOpenid();
            // 微信的基础accessToken
            String accessToken = getAccessToken();
            String url = "https://api.weixin.qq.com/cgi-bin/message/template/send?access_token=" + accessToken;

            /**
             *  其他模板可以从模板库中自己添加
             * 模板ID
             * KtWw0lwQ8FOgJdKgrmya0eoafGkMfMN8ECdZs8oSJys
             * 开发者调用模板消息接口时需提供模板ID
             * 标题      上课提醒
             * 行业      教育 - 院校
             * 详细内容
             * {{first.DATA}}
             * 课程：{{keyword1.DATA}}
             * 时间：{{keyword2.DATA}}
             * 地点：{{keyword3.DATA}}
             * {{remark.DATA}}
             */
            sendMag.put("first", new WeChatTemplateMsg("有课程即将开始"));
            sendMag.put("keyword1", new WeChatTemplateMsg("线性代数"));
            sendMag.put("keyword2", new WeChatTemplateMsg("[1,2节] 08:30-10:00"));
            sendMag.put("keyword3", new WeChatTemplateMsg("上课地点N304"));
            sendMag.put("remark", new WeChatTemplateMsg("请开发者为用户提供定制提醒的选项，以免打扰。"));
            RestTemplate restTemplate = new RestTemplate();
            //拼接base参数
            Map<String, Object> sendBody = new HashMap<>();
            sendBody.put("touser", openId);               // openId
            sendBody.put("url", domainTo);         // 点击模板信息跳转地址
            sendBody.put("topcolor", "#FF0000");          // 顶色
            sendBody.put("data", sendMag);                   // 模板参数
            sendBody.put("template_id", templateId);      // 模板Id
            ResponseEntity<String> forEntity = restTemplate.postForEntity(url, sendBody, String.class);
            log.info("结果是: {}",forEntity.getBody());
            JSONObject jsonObject = JSONObject.parseObject(forEntity.getBody());
            // 0
            String messageCode = jsonObject.getString("errcode");
            // 2431260672639467520
            String msgId = jsonObject.getString("msgid");
            System.out.println("messageCode : " + messageCode + ", msgId: " +msgId);
        }

        return Result.OK("推送成功！");
    }

    public static void main(String[] args) {
        String urlToken = "https://api.weixin.qq.com/cgi-bin/token?grant_type=client_credential&appid="+ appId +"&secret=" + appIdSecret;
        System.out.println("urlToken：  "+ urlToken);
        String res = HttpUtil.get(urlToken);
        JSONObject jsonObjectToken = JSONObject.parseObject(res);
        System.out.println("jsonObjectToken：{}"+ jsonObjectToken);
        String accessToken = jsonObjectToken.getString("access_token");
        System.out.println("accessToken：{}"+ accessToken);

        // 模板参数
        Map<String, WeChatTemplateMsg> sendMag = new HashMap<String, WeChatTemplateMsg>();

        String openId = "oak6lwKGlGQQwt83nuynZnP4HUR4";//曹老师账号
        // 微信的基础accessToken
//            String accessToken = getAccessToken();
        String url = "https://api.weixin.qq.com/cgi-bin/message/template/send?access_token=" + accessToken;

        /**
         *  其他模板可以从模板库中自己添加
         * 模板ID
         * KtWw0lwQ8FOgJdKgrmya0eoafGkMfMN8ECdZs8oSJys
         * 开发者调用模板消息接口时需提供模板ID
         * 标题      上课提醒
         * 行业      教育 - 院校
         * 详细内容
         * {{first.DATA}}
         * 课程：{{keyword1.DATA}}
         * 时间：{{keyword2.DATA}}
         * 地点：{{keyword3.DATA}}
         * {{remark.DATA}}
         */
        sendMag.put("first", new WeChatTemplateMsg("有课程即将开始"));
        sendMag.put("keyword1", new WeChatTemplateMsg("线性代数"));
        sendMag.put("keyword2", new WeChatTemplateMsg("[1,2节] 08:30-10:00"));
        sendMag.put("keyword3", new WeChatTemplateMsg("上课地点N304"));
        sendMag.put("remark", new WeChatTemplateMsg("请开发者为用户提供定制提醒的选项，以免打扰。"));
        RestTemplate restTemplate = new RestTemplate();
        //拼接base参数
        Map<String, Object> sendBody = new HashMap<>();
        sendBody.put("touser", openId);               // openId
        sendBody.put("url", domainTo);         // 点击模板信息跳转地址
        sendBody.put("topcolor", "#FF0000");          // 顶色
        sendBody.put("data", sendMag);                   // 模板参数
        sendBody.put("template_id", templateId);      // 模板Id
        ResponseEntity<String> forEntity = restTemplate.postForEntity(url, sendBody, String.class);
        log.info("结果是: {}",forEntity.getBody());
        JSONObject jsonObject2 = JSONObject.parseObject(forEntity.getBody());
        // 0
        String messageCode = jsonObject2.getString("errcode");
        // 2431260672639467520
        String msgId = jsonObject2.getString("msgid");
        System.out.println("messageCode : " + messageCode + ", msgId: " +msgId);
    }

}
