package org.jeecg.modules.zyk.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.jeecg.modules.kc.wjxWjxxTmlb.entity.WjxWjxxTmxx;
import org.springframework.format.annotation.DateTimeFormat;
import java.io.Serializable;
import java.util.Date;
import java.util.List;

@Data
@ApiModel(value="zyk_info对象", description="资源库信息")
public class ZykInfo implements Serializable {
    private static final long serialVersionUID = 1L;

    @TableId(type = IdType.ASSIGN_ID)
    @ApiModelProperty(value = "id")
    private String id;
    @ApiModelProperty(value = "创建人")
    private String createBy;
    @JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "创建时间")
    private Date createTime;
    @ApiModelProperty(value = "修改人")
    private String updateBy;
    @JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "修改时间")
    private Date updateTime;
    /**业务ID*/
    @ApiModelProperty(value = "业务ID")
    private String bizId;
    /**业务表*/
    @ApiModelProperty(value = "业务表")
    private String bizTable;
    /**学期学年*/
    @ApiModelProperty(value = "学期学年")
    private String xqxn;
    /**开课单位*/
    @ApiModelProperty(value = "开课单位")
    private String kkdw;
    /**课程名称*/
    @ApiModelProperty(value = "课程名称")
    private String kcmc;
    /**授课教师*/
    @ApiModelProperty(value = "授课教师")
    private String skjs;
    /**文件类型*/
    @ApiModelProperty(value = "文件类型")
    private String wjlx;
    /**文件名称*/
    @ApiModelProperty(value = "文件名称")
    private String fileName;
    /**PDF文件名称*/
    @ApiModelProperty(value = "PDF文件名称")
    private String pdfName;

    private String rwbh;




    /**学号*/
    @TableField(exist = false)
    private String xh;
    /**次*/
    @TableField(exist = false)
    private String seq;
    /**章*/
    @TableField(exist = false)
    private String chapter;
    /**节*/
    @TableField(exist = false)
    private String section;


    @TableField(exist = false)
    private List<ZykInfo> xqxnList;

    @TableField(exist = false)
    private List<ZykInfo> kkdwList;

    @TableField(exist = false)
    private List<ZykInfo> kcmcList;

    @TableField(exist = false)
    private List<ZykInfo> skjsList;

    @TableField(exist = false)
    private List<ZykInfo> wjlxList;

}
