package org.jeecg.modules.zyk.service;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;
import org.jeecg.modules.zyk.entity.ZykInfo;

import javax.servlet.http.HttpServletResponse;
import java.util.List;
import java.util.Map;

/**
 * @Description: 资源库信息
 * @Author: jeecg-boot
 * @Date:   2024-05-16
 * @Version: V1.0
 */
public interface IZykService extends IService<ZykInfo> {

    Page<ZykInfo> findPage(ZykInfo zykInfo, Page<ZykInfo> page);

    String saveInfo(ZykInfo zykInfo);

    String modifyInfo(ZykInfo zykInfo);

    String removeById(String id);

    String removeByIds(List<String> list);

    /**
     * 下载远端文件（预留）
     * @param filePath
     * @return 下载结果
     */
    Map<String,String> downloadRemoteFile(String filePath);

    /**
     * 下载远端文件流（含接口）
     * @param filePath
     */
    void downloadRes(String filePath, HttpServletResponse response) throws Exception;

    /**
     * 更新到资源库（接口）
     * @param zykInfo
     * @return 上传结果
     */
    Map<String,String> saveToZyk(ZykInfo zykInfo);
    Map<String,String> saveToZykJxdg(ZykInfo zykInfo);
    Map<String,String> uploadFileToSftp(String filePath);

    /**
     * 删除资源库（接口）
     * @param zykInfo
     * @return 上传结果
     */
    Map<String,String> deleteZyk(ZykInfo zykInfo);


    void disConnect();

    void saveLocal(ZykInfo zykInfo);

    Map<String, String> saveToStufile(ZykInfo zykInfo);
}
