package org.jeecg.modules.kc.blLoginLog.entity;

import java.io.Serializable;
import java.io.UnsupportedEncodingException;
import java.util.Date;
import java.math.BigDecimal;

import com.baomidou.mybatisplus.annotation.*;
import lombok.Data;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;
import org.jeecgframework.poi.excel.annotation.Excel;
import org.jeecg.common.aspect.annotation.Dict;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * @Description: 登录日志
 * @Author: jeecg-boot
 * @Date:   2024-06-17
 * @Version: V1.0
 */
@Data
@TableName("bl_login_log")
@Accessors(chain = true)
@EqualsAndHashCode(callSuper = false)
@ApiModel(value="bl_login_log对象", description="登录日志")
public class BlLoginLog implements Serializable {
    private static final long serialVersionUID = 1L;

	/**id*/
	@TableId(type = IdType.ASSIGN_ID)
    @ApiModelProperty(value = "id")
    private java.lang.String id;
	/**日志类型（1登录日志，2操作日志, 3.租户操作日志）*/
    @ApiModelProperty(value = "日志类型（1登录日志，2操作日志, 3.租户操作日志）")
    private java.lang.Integer logType;
	/**日志内容*/
	@Excel(name = "日志内容", width = 35)
    @ApiModelProperty(value = "日志内容")
    private java.lang.String logContent;
	/**操作类型*/
    @ApiModelProperty(value = "操作类型")
    private java.lang.Integer operateType;
	/**操作用户账号*/
	@Excel(name = "操作用户账号", width = 15)
    @ApiModelProperty(value = "操作用户账号")
    private java.lang.String userid;
	/**操作用户名称*/
	@Excel(name = "操作用户名称", width = 15)
    @ApiModelProperty(value = "操作用户名称")
    private java.lang.String username;
	/**IP*/
	@Excel(name = "IP", width = 15)
    @ApiModelProperty(value = "IP")
    private java.lang.String ip;
	/**请求java方法*/
    @ApiModelProperty(value = "请求java方法")
    private java.lang.String method;
	/**请求路径*/
    @ApiModelProperty(value = "请求路径")
    private java.lang.String requestUrl;
	/**请求参数*/
    @ApiModelProperty(value = "请求参数")
    private java.lang.String requestParam;
	/**请求类型*/
    @ApiModelProperty(value = "请求类型")
    private java.lang.String requestType;
	/**耗时*/
    @ApiModelProperty(value = "耗时")
    private java.lang.Integer costTime;
	/**创建人*/
    @ApiModelProperty(value = "创建人")
    private java.lang.String createBy;
	/**创建时间*/
    @Excel(name = "登录时间", width = 30 ,format = "yyyy-MM-dd HH:mm:ss")
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "创建时间")
    private java.util.Date createTime;
	/**更新人*/
    @ApiModelProperty(value = "更新人")
    private java.lang.String updateBy;
	/**更新时间*/
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd")
    @DateTimeFormat(pattern="yyyy-MM-dd")
    @ApiModelProperty(value = "更新时间")
    private java.util.Date updateTime;
	/**租户ID*/
    @ApiModelProperty(value = "租户ID")
    private java.lang.Integer tenantId;
    @TableField(exist = false)
    private String startTime;
    @TableField(exist = false)
    private String endTime;
}
