package org.jeecg.modules.kc.blLoginLog.service.impl;

import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import org.apache.shiro.SecurityUtils;
import org.jeecg.common.api.dto.LogDTO;
import org.jeecg.common.system.vo.LoginUser;
import org.jeecg.common.util.IpUtils;
import org.jeecg.common.util.SpringContextUtils;
import org.jeecg.modules.kc.blLoginLog.entity.BlLoginLog;
import org.jeecg.modules.kc.blLoginLog.mapper.BlLoginLogMapper;
import org.jeecg.modules.kc.blLoginLog.service.IBlLoginLogService;
import org.jeecg.modules.system.entity.SysUser;
import org.springframework.stereotype.Service;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;

import javax.servlet.http.HttpServletRequest;
import java.util.Date;

/**
 * @Description: 登录日志
 * @Author: jeecg-boot
 * @Date:   2024-06-17
 * @Version: V1.0
 */
@Service
public class BlLoginLogServiceImpl extends ServiceImpl<BlLoginLogMapper, BlLoginLog> implements IBlLoginLogService {


    @Override
    public void addLog(String logContent, Integer logType, Integer operatetype, SysUser user) {
        BlLoginLog sysLog = new BlLoginLog();
        sysLog.setId(String.valueOf(IdWorker.getId()));
        //注解上的描述,操作日志内容
        sysLog.setLogContent(logContent);
        sysLog.setLogType(logType);
        sysLog.setOperateType(operatetype);
        try {
            //获取request
            HttpServletRequest request = SpringContextUtils.getHttpServletRequest();
            //设置IP地址
            sysLog.setIp(IpUtils.getIpAddr(request));
        } catch (Exception e) {
            sysLog.setIp("127.0.0.1");
        }
        //获取登录用户信息
//        if(user==null){
//            try {
//                user = (LoginUser) SecurityUtils.getSubject().getPrincipal();
//            } catch (Exception e) {
//                //e.printStackTrace();
//            }
//        }
        if(user!=null){
            sysLog.setUserid(user.getUsername());
            sysLog.setUsername(user.getRealname());
            sysLog.setCreateBy(user.getUsername());
        }
        sysLog.setCreateTime(new Date());
        //保存日志（异常捕获处理，防止数据太大存储失败，导致业务失败）JT-238
        try {
            baseMapper.insert(sysLog);
        } catch (Exception e) {
            log.warn(" LogContent length : "+sysLog.getLogContent().length());
            log.warn(e.getMessage());
        }
    }
}
